!-----------------------------------------------------------------------
!                                                                       
!      Sammlung SUBROUTINES fuer Benson-Ansteuerung mit ALLPLO etc.     
!                    25-SEP-1989                                        
!                                                                       
!       Sie enthaelt folgende Subroutines:                              
!       SCALE,VELO,NUMERO,NAXFOR,NFRAME                                 
!       TRANS, ZEICH, TXTPLO, saemtliche Zeichensatze, sowie aus        
!       der Benson-Library  die Subroutines:                            
!       FIN, PNUMA, IBENA, TRAA, PLUMA, BENES, DPACK, POSA, BECENA,     
!       BCERCA, DELTA, PART, NUMBER, LINE.                              
!                                                                       
!       pluma modifiziert fuer Rueckgabe der Federposition              
!       M. Alflen  23-aug-1989                                          
!                                                                       
!       txtplo modifiziert fuer Wahl der Feder                          
!       M. Alflen  25-aug-1989                                          
!                                                                       
!       line modifiziert fuer Wahl der Feder                            
!       M. Alflen  29-aug-1989                                          
!                                                                       
!	txtplo modifiziert fuer Umlaute                                       
!	M. Alflen                                                             
!                                                                       
!       zeich um 19 Zeichen erweitert                                   
!       A.Vef      09-aug-1994                                          
!-----------------------------------------------------------------------
      SUBROUTINE TXTPLO (X0,Y0,ISTEU,ITEXT,NTEXT,                       &
     &                   BREITE,HOEHE,COSA,SINA,X2,Y2,Z2)               
                                                                        
!-----------------------------------------------------------------------
!      PLOTTET EINEN TEXTSTRING  ITEXT  MIT  NTEXT  ZEICHEN IN VERSCHIED
!      SCHRIFTTYPEN  ( ROMAN, ITALIC, SCRIPT, GREEK )  MIT GROSSEN UND  
!      KLEINEN BUCHSTABEN SOWIE SONDERZEICHEN                           
!      DIE VERWENDUNG ALS OBERER ODER UNTERER INDEX IST MOEGLICH        
!      AUSSERDEM VERSCHIEDENE SYMBOLE ( SCHRIFTART 'ZEICHEN' ),         
!      DIE AUCH ZENTRIERT GEZEICHNET WERDEN KOENNEN                     
!                                                                       
!                                 EBERHARD MEISSNER  17.05.83           
!                                                                       
!      modifiziert fuer federwahl                                       
!                                                                       
!                                 M. Alflen  25.8.89                    
!	modifiziert fuer Umlaute                                              
!				  M. Alflen 28.2.1990                                              
!       modifications             h.spiering 27.5.2008                  
!                  \y\Y   symbols included to the text                  
!                  $_,$^  according to Latex                            
!                  + 22 Zeichen called by name $\name                   
!                         according to Latex                            
!                  9 colors called by @n                                
!                  extra changes of charracter size                     
!                                   shift of upper and lower index      
!       further in routines like addtxt.f:                              
!                                                                       
!                  box rotates, colored area                            
!                  colored frame areas                                  
!                  colored background                                   
!-----------------------------------------------------------------------
!      FUER DEN BENUTZER:                                               
!      -UMSCHALTUNG DER SCHRIFTTYPEN:                                   
!       \R  ODER  \r   :  ROMAN  (VOREINSTELLUNG)                       
!       \I  ODER  \i   :  ITALIC                                        
!       \S  ODER  \s   :  SCRIPT                                        
!       \G  ODER  \g   :  GREEK                                         
!       \Z  ODER  \z   :  ZEICHEN (signs)                               
!       \y             :  Symbol 01-33                                  
!       \Y             :  gefuelltes Symbol 01-33                       
                                                                        
!        \,        2/5 : Leerzeichen                                    
!        \!       -1/5 : Leerzeichen                                    
                                                                        
!       \"a \"o \"u    : Umlaute                                        
!                                                                       
                                                                        
                                                                        
!       $              :  Zurueck zum NORMALBUCHSTABEN  (VOREINSTELLUNG)
!       $^             :  OBERER INDEX                                  
!       $_             :  UNTERER INDEX                                 
!       $P  ODER  $p   :  POSITION FUER SPAETEREN RUECKSPRUNG           
!       $B  ODER  $b   :  RUECKSPRUNG ZUR GEMERKTEN POSITION            
!       $F  ODER  $f   :  SPRUNG VORWAERTS ZUM BISHERIGEN TEXTENDE      
!       $H       *1.2  :  Buchstabengroesse                             
!       $h       /1.2  :  Buchstabengroesse                             
!       $U   (14+...)  :  > shift oberer Index                          
!       $u   (14-...)  :  < shift oberer Index                          
!       $D   (-7-...)  :  > shift unterer Index                         
!       $d   (-7+...)  :  < shift unterer Index                         
!       $m       m     :  multiple Zeichnung  (bold-m fach)             
!       $\name         :  name of Zeichen up to 16 characters           
                                                                        
!      -UMSCHALTUNG Gross/Kleinschreibung und der Feder                 
!       @u oder @U     :  Grosschreibung                                
!       @l oder @L     :  Kleinschreibung                               
!       @c oder @C     :  case Standard                                 
                                                                        
!       @n   n = 0...N :  Wahl der Feder (x11_ps_colors.txt legt N fest)
!                                                                       
!                                                                       
!-----------------------------------------------------------------------
!      FUER DEN PROGRAMMIERER :                                         
!      -DIE ELEMENTE VON  CTEXT sind IM FORMAT  A1  BESCHRIEBEN         
!      -X0,Y0  SIND DIE KOORDINATEN DER LINKEN UNTEREN ECKE DES STRINGS,
!       BEI  ISTEU=2  DIE DES ZENTRUMS DES ERSTEN ZEICHEN DES STRINGS   
!      -BREITE  UND  HOEHE  GELTEN FUER EINEN GROSSBUCHSTABEN WIE       
!       ETWA "A"  ( UNTERLAENGEN UND SCHMALERE BUCHSTABEN KOMMEN VOR )  
!      -COSA, SINA  SIND DER COSINUS UND DER SINUS DES WINKELS, DEN     
!       DER TEXTSTRING MIT DER X-RICHTUNG DES PLOTTERS EINSCHLIESST     
!      -X2,Y2  SIND DIE KOORDINATEN DER RECHTEN UNTEREN ECKE DES STRINGS
!       BEIM RUECKSPRUNG IN DAS RUFENDE PROGRAMM                        
!      -ISTEU >= 0   PLOTTEN VON  ITEXT :                               
!             = 1   STARTKOORDINATE LINKE UNTERE ECKE                   
!             = 2   STARTKOORDINATE ZENTRUM DES ERSTEN ZEICHENS         
!             = 3   WIE  = 2  MIT VERBINDEN DER MITTEN DER ZEICHEN      
!             < 0   BERECHNUNG VON  X2,Y2  OHNE PLOT                    
!-----------------------------------------------------------------------
      implicit none 
      integer     NTEXT,ISTEU 
      real        X0,Y0,BREITE,HOEHE,COSA,SINA,X2,Y2,Z2 
                                                                        
      character*1 ITEXT,IIC,ch1,fsym*16                                
      DIMENSION   ITEXT(NTEXT) 
      integer    KOORD 
      DIMENSION  KOORD(75) 
                                                                        
                                                                        
      integer ITYPE,INDEX,I6BIT,JTYPE,JNDEX,J6BIT,jumlaut,MARK,         &
     &        iold_pen,IC,i,j,jpm,IZEICH,IB,IX,IY,jumsiz,KC,IPEN,       &
     &        mult,nmult,iloop,isymbol,k                             
      logical isymfill 
      real    XB,YB,ZB,XF,YF,ZF,X1,Y1,Z1,H,B,                           &
     &        HX,HY,X,Y,DX,DY,XSHIFT,YSHIFT,WID,HEI,YOFF,XOFF,          &
     &        XHALF,YHALF,XX1,XX2,YY1,YY2,XS,YS,bsize,usize,dsize,      &
     &        penfill,g6,g5                                             
      integer MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,                     &
     &        N2MAX,ICAR,NMMAX,NCMAX                                    
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,              &
     &               N2MAX,ICAR,NMMAX,NCMAX,penfill                     
      integer        iIX,iIY,IBLOC 
      real                XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY 
      COMMON /BENXY/iIX,iIY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 

      character(len=1),parameter:: IBSL='\\',IAFFE='@',IDACH='^',      &
                                       IUMLAUT='"', IBLANK=' '
      integer,parameter::i0=48  
!     GROSSE BUCHSTABEN                                                 
character(len=1),parameter,dimension(1:26):: &
        ICHAR1=(/'A','B','C','D','E','F','G','H','I','J','K','L','M', &
                 'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/) 
!      KLEINE BUCHSTABEN                                                
character(len=1),parameter,dimension(1:26):: &
      ICHAR2=(/'a','b','c','d','e','f','g','h','i','j','k','l','m', &
               'n','o','p','q','r','s','t','u','v','w','x','y','z'/) 
!      NUMERISCHE- UND SONDERZEICHEN                                    
character(len=1),parameter,dimension(1:37):: & 
      ICHAR3=(/'0','1','2','3','4','5','6','7','8','9','.',',',':', &
               ';','!','?','<','>','&','$','/','(',')','*','-','+', &
               '=',IBSL,'"','#','[',']','%','_','{','}','|'/)         
character(len=16),parameter,dimension(1:45):: &
    sonderz=(/'Int             ','Aring           ','underscore      ',&
              'hat             ','rightarrow      ','leftarrow       ',&
              'leftrightarrow  ','Rightarrow      ','Leftarrow       ',&
              'Leftrightarrow  ','vert            ','uparrow         ',&
              'downarrow       ','updownarrow     ','cdot            ',&
              'parallel        ','neq             ','sim             ',&
              'perp            ','approx          ','hbar            ',&
              'at              ','backslash       ','number          ',&
              'section         ','infty           ','int             ',&
              'oint            ','sqrt            ','overscore       ',&
              'frac            ','nabla           ','partial         ',&
              'cap             ','supset          ','subset          ',&
              'cup             ','tilde           ','propto          ',&
              'geqq            ','leqq            ','pm              ',&
              'mp              ','langle          ','rangle          '/)
                                                                        
!                  27           30           33                         
!      UMGEORDNETE STARTWERTE FUER GROSSE UND KLEINE GRIECH. BUCHSTABEN 
integer,dimension(1:26),parameter:: &
      ICHARG=(/1,2,7,4,5,21,3,22,9,0,10,11,12,                      &
              13,15,16,8,17,18,19,20,0,24,14,23,6/)                
!      UMGEORDNETE STARTWERTE FUER ROMAN NUMERISCHE/SONDERZEICHEN       
integer,dimension(1:37),parameter:: &
     ICHARN=(/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,27,28,        &
             29,30,21,22,23,20,24,25,26,17,18,37,31,32,33,34,      &
             35,36,38/)                                             
                                                                        
!       write(6,'(a,i2,2x,80a1)')' TEXTPLO NTEXT ITEXT=',               
!     &                     NTEXT,(ITEXT(i),i=1,NTEXT)                  
!       write(6,'(a)')'X0,Y0,ISTEU,ITEXT,NTEXT,BREITE,HOEHE,COSA,SINA'  
!       write(6,'(2f10.2,i3,4g12.3)')X0,Y0,ISTEU,BREITE,HOEHE,COSA,SINA 
                                                                        
!      VORBESETZEN VON SCHRIFTART (ROMAN) , INDEX (NORMAL), 6-BIT-ASCII 
      ITYPE = 1 
      INDEX = 1 
      I6BIT = 0 
!      VORBESETZEN DER UMSCHALTINDIKATOREN                              
      JTYPE = 0 
      JNDEX = 0 
      J6BIT = 0 
      jumlaut=0 
!      VORBESETZUNG DER BUCHHALTER VON  @M, @B, @F                      
      MARK = 0 
      XB = X0 
      YB = Y0 
      XF = X0 
      YF = Y0 
!                                                                       
      X1 = X0 
      Y1 = Y0 
      Z1=HOEHE 
      H = HOEHE/21. 
      B = BREITE/20. 
      bsize=1. 
      usize=0. 
      dsize=0. 
      nmult=1 
                                                                        
!     erfragen der gewaehlten Feder                                     
!      write(6,'(a,10a3)')' ITEXT(I)=',(ITEXT(I),I=1,NTEXT)             
      iold_pen=-1 
      call PLUMA(iold_pen) 
!      write(6,'(a,i4)')'b TXTPLO  iold_pen=',iold_pen                  
!      SCHLEIFE UEBER ALLE  NTEXT  ZEICHEN                              
      IC=0 
    DO while(  IC.lt.NTEXT) 
                                                                        
       IC=IC+1 
!      WAR DAS LETZTE ZEICHEN EIN UMSCHALTZEICHEN, SO DUERFEN NUR       
!      BESTIMMTE ZEICHEN AUFTRETEN :   VERZWEIGUNG                      
      IF ( JTYPE.NE.0 ) GO TO 500 
      IF ( JNDEX.NE.0 ) GO TO 600 
      IF ( J6BIT.NE.0 ) GO TO 700 
!      ES WURDE KEIN SCHALTZEICHEN ERWARTET                             
!                                                                       
!      BLANK ODER UMSCHALTZEICHEN ?                                     
   50 IF ( ITEXT(IC).EQ.IBLANK ) GO TO 800 
      IF ( ITEXT(IC).EQ.IBSL )   GO TO 810 
      IF ( ITEXT(IC).EQ.'$' )  GO TO 820 
      IF ( ITEXT(IC).EQ.IAFFE )  GO TO 830 
!      ES HANDELT SICH WEDER UM EIN BLANK NOCH UM EIN UMSCHALTZEICHEN   
!                                                                       
!      GROSSBUCHSTABE ?                                                 
  100 DO I=1,26 
       J = I 
       IF ( ITEXT(IC).EQ.ICHAR1(I))GO TO 120 
      END DO 
!      KEIN GROSSBUCHSTABE, WEITERSUCHEN                                
      GO TO 200 
!      GROSSBUCHSTABE ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP              
!      FALLS JEDOCH  I6BIT  GESETZT IST, SOLL EIN KLEINER               
!      BUCHSTABE GEZEICHNET WERDEN                                      
  120 IF ( I6BIT.eq.2 ) GO TO 220 
      GO TO (130,140,150,160,170), ITYPE 
  130 CALL GROMAN (J,KOORD) 
      GO TO 400 
  140 CALL GITALI (J,KOORD) 
      GO TO 400 
  150 CALL GSCRIP (J,KOORD) 
      GO TO 400 
!      GRIECHISCHE BUCHSTABEN : ANDERE REIHENFOLGE DES ALPHABETS : UMORD
  160 J = ICHARG(J) 
!      "J" UND "V" GIBT ES NICHT : WIE BLANK BEHANDELN                  
      IF ( J.EQ.0 ) GO TO 800 
      CALL GGREEK (J,KOORD) 
      GO TO 400 
!      SCHRIFTART  ZEICHEN :  BUCHSTABE ALS ZIFFER "0" INTERPRETIERT    
  170 J = 0 
      GO TO 360 
!                                                                       
!      KLEINBUCHSTABE ?                                                 
  200 DO I=1,26 
       J = I 
       IF ( ITEXT(IC).EQ.ICHAR2(I) ) GO TO 215 
      END DO 
!      KEIN KLEINBUCHSTABE, WEITERSUCHEN                                
      GO TO 300 
!      KLEINBUCHSTABE ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP              
  215 IF ( I6BIT.eq.1 ) GO TO 120 
                                                                        
  220 GO TO (230,240,250,260,270), ITYPE 
  230 continue 
      CALL KROMAN (J,KOORD) 
      GO TO 400 
  240 CALL KITALI (J,KOORD) 
      GO TO 400 
  250 CALL KSCRIP (J,KOORD) 
      GO TO 400 
!      GRIECHISCHE BUCHSTABEN : ANDERE REIHENFOLGE DES ALPHABETS : UMORD
  260 J = ICHARG(J) 
!      "J" UND "V" GIBT ES NICHT : WIE BLANK BEHANDELN                  
      IF ( J.EQ.0 ) GO TO 800 
      CALL KGREEK (J,KOORD) 
      GO TO 400 
!      SCHRIFTART  ZEICHEN :  BUCHSTABE ALS ZIFFER "0" INTERPRETIERT    
  270 J = 0 
      GO TO 360 
                                                                        
!      NUMERISCHES- ODER SONDERZEICHEN ?                                
  300 continue 
!     write(6,'(a,i2,a2,a1)')'3 ITEXT(',IC,')=',ITEXT(IC)               
      DO I=1,37 
       J = I 
       IF ( ITEXT(IC).EQ.ICHAR3(I) ) GO TO 320 
      END DO 
!      KEIN NUMERISCHES- ODER SONDERZEICHEN                             
!      KANN NICHT IDENTIFIZIERT WERDEN : WIE BLANK BEHANDELN            
      GO TO 800 
!      NUM./SONDERZEICHEN ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP          
  320 GO TO (330,340,340,330,350,350), ITYPE 
!      ROMAN  NUM./SONDERZEICHEN : ANDERE REIHENFOLGE : UMORDNEN        
  330 J = ICHARN(J) 
      CALL NROMAN (J,KOORD) 
      GO TO 400 
  340 if(J.eq.37)J=38 
      if(J.eq.30)J=37 
      CALL NSCRIP (J,KOORD) 
      GO TO 400 
!      ZEICHEN: J=1,..,10  ENTSPRICHT ZIFFERN  0,..,9                   
  350 IF ( J.LE.10 ) J = J-1 
!      J > 10 :  KEINE ZIFFER, WIE "0" BEHANDELN                        
      IF ( J.GT.10 ) J = 0 
!                                                                       
!      AUSWERTUNG FUER ZEICHEN (ITYPE=5)                                
!      HINTER \Z WURDE EINE ZIFFER (J=0,..,9) ODER EIN ANDERES ZEICHEN  
!      GEFUNDEN (INTERPRETIERT ALS J=0). JE ZWEI SOLCHER ZEICHEN WERDEN 
!      PAARWEISE ALS ZWEISTELLIGE INTEGERZAHL INTERPRETIERT.            
  360 continue 
      IZEICH =J 
      if(IC+1.le.NTEXT)then 
       J=ichar(ITEXT(IC+1))-i0 
       if(J.ge.0.and.J.le.9)then 
        IC=IC+1 
        IZEICH=10*IZEICH+J 
       end if 
      end if 
      J=IZEICH 
      IF ( J.ge.1) GO TO 380 
!      J = 0  ODER J > 32 :  FALSCHE EINGABE                            
!      MIT GEHOBENER FEDER NACH (X1,Y1), BEI  ISTEU = 3  GESENKTE FEDER 
  370 IPEN = 0 
      IF ( ISTEU.EQ.3 ) IPEN  = 1 
      CALL TRAA (X1,Y1,IPEN) 
      GO TO 1000 
!     VORHANDENES ZEICHEN                                               
  380 if(ITYPE.eq.5)then 
        CALL ZEICH (J,KOORD) 
        if(j.lt.0)goto 370 
      else if(ITYPE.eq.6)then 
       isymbol=J 
       if(J.lt.1.or.J.gt.33) goto 370 
       goto 490 
      end if 
      GO TO 400 
!                                                                       
!      DIE ZIELKOORDINATEN  KOORD  SIND VON DER RICHTIGEN SUBROUTINE UEB
  400 if(J.lt.0)goto 491 
                                                                        
      IPEN = 0 
!      BREITE DES BUCHSTABENS  = IB                                     
      IB = KOORD(1) 
!      FALLS  ISTEU < 0 , SOLL NUR  X2,Y2  BERECHNET WERDEN             
!      DAHER WERDEN DIE FAHRBEFEHLE UEBERSPRUNGEN                       
      IF ( ISTEU.LT.0 ) GO TO 900 
!      FALLS  ISTEU = 3 :  VERBINDEN DER (X1,Y1)                        
      IF ( ISTEU.EQ.3 ) CALL TRAA (X1,Y1,1) 
!      SCHLEIFE UEBER DIE FAHRBEFEHLE EINES BUCHSTABENS                 
                                                                        
      jpm=1 
      do mult=1,nmult 
       jpm=-jpm 
       XS=X1+float(mult-1)*0.0125 
       YS=Y1+float(mult-1)*0.0125 
                                                                        
       DO J=2,75 
        if(KOORD(J).lt.0) then 
         IY = ( KOORD(J) - 30 ) / 100 
        else 
         IY = ( KOORD(J) + 30 ) / 100 
        end if 
        IX = KOORD(J) - 100*IY 
!       IX = 50, IY = 50 :  BUCHSTABE ZU ENDE                            
!       IX = 50, IY =  0 :  PENUP (SONST STETS PENDOWN)                  
        IF ( IX.NE.50 ) GO TO 420 
        IF ( IY.EQ.50 ) GO TO 480 
        IF ( IY.NE. 0 ) GO TO 420 
!       50, 0  GEFUNDEN :  PENUP   UND DANN NEUEN KOORDINATENPUNKT ANSTEU
        IPEN = 0 
        GO TO 470 
!       NORMALER KOORDINATENPUNKT                                        
  420   CONTINUE 
!       FALLS  ISTEU=2 : ZENTRIEREN DER ZEICHEN/BUCHSTABEN               
        IF ( ISTEU.NE.2 ) GO TO 421 
        IX = IX - IB/2 
        IY = IY - 10 
!       VERZWEIGUNG JE NACH INDEX                                        
  421   GO TO (430,440,450), INDEX 
!       NORMALES TEXTFORMAT                                              
  430   HX = IX 
        HY = IY 
        GO TO 460 
!       OBERER INDEX                                                     
  440   HX =  0.6*IX 
        HY = (14.+usize)/bsize + 0.6*IY 
        GO TO 460 
!       UNTERER INDEX                                                    
  450   HX =  0.6*IX 
        HY = -(7.+dsize)/bsize + 0.6*IY 
!       BERECHNUNG DER ABSOLUTEN KOORDINATEN                             
  460   continue 
        X = XS + ( HX*B*COSA - HY*H*SINA ) 
        Y = YS + ( HY*H*COSA + HX*B*SINA ) 
        CALL TRAA (X,Y,IPEN) 
        IPEN = 1 
  470   CONTINUE
       END DO 
  480  CONTINUE 
!                                                                       
!      Umlaute zeichnen                                                  
!                                                                       
       IF (JUMLAUT .EQ. 1) THEN 
        DX = 6.66 * ( B*SINA ) 
        DY = 6.66 * ( B*COSA ) 
        XSHIFT = 19.95 * (H*COSA ) 
        YSHIFT =-19.95 * (H*SINA ) 
        IF (ITYPE .EQ. 3 .AND. JUMSIZ .EQ. 0) THEN 
         XSHIFT=XSHIFT*.8 
         YSHIFT=YSHIFT*.8 
        END IF 
        IF (JUMSIZ .EQ. 1) THEN 
          YSHIFT=YSHIFT*1.25 
          XSHIFT=XSHIFT*1.25 
        END IF 
        WID=1.60*B 
        HEI=1.68*H 
        IF (INDEX .GT. 1) THEN 
         IF (INDEX .EQ. 2) THEN 
          YOFF=yshift*.33 
          XOFF=xshift*.33 
         END IF 
         IF (INDEX .EQ. 3) THEN 
          YOFF=-yshift*.8 
          XOFF=-xshift*.8 
         END IF 
         DX=DX*.66 
         DY=DY*.66 
         WID=WID*.66 
         HEI=HEI*.66 
        ELSE 
         YOFF=0. 
         XOFF=0. 
        END IF 
        XHALF= DX/.33*IB/40 
        YHALF= DY/.33*IB/40 
        XX1 = YS + (XHALF-DX/2.) + (XOFF+XSHIFT) 
        XX2 = YS + (XHALF+DX/2.) + (XOFF+XSHIFT) 
        YY1 = XS + (YOFF+YSHIFT) + (YHALF-DY/2.) 
        YY2 = XS + (YOFF+YSHIFT) + (YHALF+DY/2.) 
 !       write(6,'(a,6f10.3)')'YS,XS,YY1,XX1=',YS,XS,YY1,XX1             
        CALL BECENA(YY1,XX1,0,14,WID,HEI,COSA,SINA) 
        CALL BECENA(YY2,XX2,0,14,WID,HEI,COSA,SINA) 
        CALL TRAA(XS,YS,0) 
!       JUMLAUT=0                                                       
       END IF 
       IPEN = 0 
      end do  ! mult  
      JUMLAUT=0 
                                                                        
      goto 491 
  490 continue 
!      write(6,'(a,2i4)')' aplsub  isymfill,isymbol=',isymfill,isymbol  
      YS=Y1+H*11*SINA+B*10*COSA 
      XS=X1-B*10*SINA+H*11*COSA 
!      write(6,'(a,i3,6f10.3)')'ISTEU,YS,XS,Y1,X1=',ISTEU,YS,XS,Y1,X1   
      if(ISTEU.gt.0) then 
      if(isymfill) then 
         iloop=ifix(amin1(B*14,H*16)/penfill)+1 
                                         ! fill up symbol               
         do k=1,iloop 
          g5=B*14-(k-1)*penfill 
          if ( g5 .gt. 0 ) then 
           g6=H*16-(k-1)*penfill 
           if ( g6 .gt. 0 ) then 
            if ( isymbol .ne. 33 ) then 
                                                          ! plot symbol 
             call becena(XS,YS,0,isymbol,g5,g6,COSA,SINA) 
            else 
             g5=(g5+g6)/4. 
                                                       ! plot circle    
             CALL BCERCA (XS,YS,0,g5,90.,360.) 
            end if 
           end if 
          end if 
         end do 
      else 
       if ( isymbol .ne. 33 ) then 
        g5=B*14 
        g6=H*16 
        call becena(XS,YS,0,isymbol,g5,g6,COSA,SINA) 
       else 
        g5=(g5+g6)/4. 
                                                  ! plot circle         
        CALL BCERCA (XS,YS,0,g5,90.,360.) 
       end if 
      end if 
      end if 
  491 continue 
                                                                        
!      BUCHST./ZIFFER/ZEICHEN ABGEARBEITET                              
!      FALLS  ISTEU = 2,3 :  MIT GEHOBENER FEDER NACH (X1,Y1)           
      IF ( ISTEU.EQ.2 .OR. ISTEU.EQ.3 ) CALL TRAA (X1,Y1,0) 
      GO TO 900 
!                                                                       
!      ES WIRD EINE STEUERUNG DES SCHRIFTTYPES ERWARTET                 
!      ZULAESSIGE ZEICHEN SIND :                                        
!          \R,r       ROMAN         ITYPE = 1                           
!          \I,i       ITALIC        ITYPE = 2                           
!          \S,s       SCRIPT        ITYPE = 3                           
!          \G,g       GREEK         ITYPE = 4                           
!          \Z,z       ZEICHEN       ITYPE = 5                           
!          \,        2/5   Leerzeichen                                  
!          \!       -1/5   Leerzeichen                                  
                                                                        
!          \"a \"o \"u      Umlaute                                     
                                                                        
  500 JTYPE = 0 
      ch1=ITEXT(IC) 
      if( ch1.eq.'r'.or.ch1.eq.'R')then 
!      SCHRIFTTYP  ROMAN  GEWUENSCHT                                    
       ITYPE = 1 
      else if( ch1.eq.'i'.or.ch1.eq.'I')then 
!      SCHRIFTTYP  ITALIC  GEWUENSCHT                                   
       ITYPE = 2 
      else if( ch1.eq.'s'.or.ch1.eq.'S')then 
!      SCHRIFTTYP  SCRIPT  GEWUENSCHT                                   
       ITYPE = 3 
      else if( ch1.eq.'g'.or.ch1.eq.'G')then 
!      SCHRIFTTYP  GREEK  GEWUENSCHT                                    
       ITYPE = 4 
      else if( ch1.eq.'z'.or.ch1.eq.'Z')then 
!      SCHRIFTART  ZEICHEN  GEWUENSCHT                                  
       ITYPE = 5 
      else if( ch1.eq.'y')then 
!      SCHRIFTART  Symbol  GEWUENSCHT                                   
       ITYPE = 6 
       isymfill=.false. 
      else if( ch1.eq.'Y')then 
!      SCHRIFTART gefuelltes Symbol  GEWUENSCHT                         
       ITYPE = 6 
       isymfill=.true. 
      else if( ch1.eq.',')then 
!      Blank der Groesse \, gefunden                                    
       GO TO 801 
      else if( ch1.eq.'!')then 
!      Blank der Groesse \! gefunden (Ruecksetzung)                     
       GO TO 802 
      else if( ch1.eq.'"')then 
!      \" gefunden (UMLAUT)                                             
       GO TO 840 
      else if( ch1.eq.'$')then 
!      \$  gefunden Steuerzeichen $ wird gezeichnet                     
       GO TO 300 
      else if( ch1.eq.IBSL)then 
!      \\  gefunden Steuerzeichen $ wird gezeichnet                     
       J=23 
       CALL ZEICH (J,KOORD) 
       GO TO 400 
      else if( ch1.eq.IAFFE)then 
!      \@  gefunden Steuerzeichen $ wird gezeichnet                     
       J=22 
       CALL ZEICH (J,KOORD) 
       GO TO 400 
      end if 
      GO TO 1000 
!                                                                       
!      ES WIRD EINE STEUERUNG DES INDEX ERWARTET                        
!      ZULAESSIGE ZEICHEN SIND :                                        
!          $                                                            
!          $^         OBERER INDEX     INDEX = 2                        
!          $_         UNTERER INDEX    INDEX = 3                        
!          $P,p       POSITION X1,Y1 MERKEN                             
!          $B,b       ZURUECK ZUR GEMERKTEN POSITION                    
!          $F,f       VORWAERTS ZUR BISHER WEITESTEN POSITION           
!          $H         *1.2   Buchstabengroesse                          
!          $h         /1.2   Buchstabengroesse                          
!       $U   (14+...)  :  > shift oberer Index                          
!       $u   (14-...)  :  < shift oberer Index                          
!       $D   (-7-...)  :  > shift unterer Index                         
!       $d   (-7+...)  :  < shift unterer Index                         
!          $m         m     multiple Zeichnung  (bold)                  
                                                                        
  600 ch1=ITEXT(IC) 
      JNDEX = 0 
       i=ichar(ch1)-i0 
       if(i.gt.0.and.i.lt.10) ch1='m' 
!      NORMALBUCHSTABE GEWUENSCHT                                       
      if(ch1.eq.'^')then 
!      OBERER INDEX GEWUENSCHT                                          
       INDEX = 2 
      else if(ch1.eq.'_')then 
!      UNTERER INDEX GEWUENSCHT                                         
       INDEX = 3 
      else if( ch1.eq.'H')then 
!      $H  gefunden Buchstabengroesse *1.2                              
       bsize=bsize*1.2 
       H=H*1.2 
       B=B*1.2 
      else if( ch1.eq.'h')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       bsize=bsize/1.2 
       H=H/1.2 
       B=B/1.2 
      else if( ch1.eq.'U')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       usize=usize+3 
      else if( ch1.eq.'u')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       usize=usize-3 
      else if( ch1.eq.'D')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       dsize=dsize+3 
      else if( ch1.eq.'d')then 
!      $h  gefunden Buchstabengroesse /1.2                              
       dsize=dsize-3 
      else if( ch1.eq.'m')then 
!      $m  gefunden Buchstabengroesse                                   
       nmult=i 
      else if(ch1.eq.'p'.or.ch1.eq.'P')then 
!      MERKEN DER AKTUELLEN X1,Y1 AUF XB,YB                             
       MARK = 1 
       XB = X1 
       YB = Y1 
       ZB = Z1 
      else if(ch1.eq.'b'.or.ch1.eq.'B')then 
!      RUECKSPRUNG AUF (XB,YB),                                         
!      MERKEN DER AKTUELLEN X1,Y1 AUF XF,YF                             
       IF ( MARK.EQ.0 ) GO TO 1000 
!      RUECKSPRUNGSTELLE BEKANNT                                        
       XF = X1 
       YF = Y1 
       ZF = Z1 
       X1 = XB 
       Y1 = YB 
       Z1 = ZB 
      else if(ch1.eq.'f'.or.ch1.eq.'F')then 
!      SPRUNG AUF (XF,YF), FALLS DIESER WEITER RECHTS STEHT             
!      ALS DAS AKTUELLE (X1,Y1)                                         
       MARK = 0 
       IF ( (X1-XF)*COSA.lt.0) X1 = XF 
       IF ( (Y1-YF)*SINA.lt.0) Y1 = YF 
       IF ( (Z1-ZF)*SINA.lt.0) Z1 = ZF 
      else if(ch1.eq.' ')then 
       H=H/bsize 
       B=B/bsize 
       nmult=1 
       INDEX=1 
      else if(ch1.eq.IBSL)then 
       IC=IC+1 
       ch1=ITEXT(IC) 
       i=1 
       do while(ch1.ne.' '.and.ch1.ne.'$'.and.ch1.ne.'@'                &
                        .and.ch1.ne.IBSL.and.IC.le.NTEXT)                      
        fsym(i:i)=ch1 
!        write(6,'(i4,2a)')IC,'   fsym=',fsym(:i)                       
        i=i+1 
        IC=IC+1 
        if(IC.gt.NTEXT)then 
         ch1='$' 
        else 
         ch1=ITEXT(IC) 
        end if 
       end do 
       IC=IC-1 
       i=i-1 
!        write(6,'(2i4,2a)')NTEXT,IC,'  # fsym=',fsym(:i)               
       J=1 
       do while(fsym(:i).ne.sonderz(J)(:i).and.J.le.44) 
        J=J+1 
       end do 
       if(J.gt.0.and.J.le.45)then 
        CALL ZEICH (J,KOORD) 
        GO TO 400 
       end if 
      end if 
      GO TO 1000 
                                                                        
!      ES WIRD EINE UMSTEUERUNG GROSS-/KLEINBUCHSTABE ERWARTET          
!      ZULAESSIGE ZEICHEN SIND :                                        
!           @                                                           
!           @U,u       Grossbuchstaben               I6BIT = 1          
!           @L,l       KLEINBUCHSTABEN MIT 6-BIT     I6BIT = 2          
!           @C,c       Buchstaben gross(shift)/klein I6BIT = 0          
!           @n         0<=n<=9     Farbe der Feder                      
  700 ch1=ITEXT(IC) 
      J6BIT = 0 
      I6BIT = 0 
      i=ichar(ch1)-i0 
      if(i.ge.0.and.i.le.9)then 
       k=ichar(ITEXT(IC+1))-i0 
       if(k.ge.0.and.k.le.9)then 
!       second number                                                   
        i=10*i+k 
        IC=IC+1 
       end if 
      else 
       i=-1 
      end if 
      if( ch1.eq.'u'.or.ch1.eq.'U')then 
!      7-BIT-ASCII (UMSCHALTUNG MIT 'SHIFT') GEWUENSCHT                 
       I6BIT = 1 
      else if( ch1.eq.'l'.or.ch1.eq.'L')then 
!      KLEINBUCHSTABEN BEI 6-BIT-ASCII GEWUENSCHT                       
       I6BIT = 2 
      else if( ch1.eq.'c'.or.ch1.eq.'C')then 
!      gross(shift)/klein GEWUENSCHT                                    
       I6BIT = 0 
      else if(i.ge.0)then 
!      federwahl                                                        
       call PLUMA(i) 
      else 
       i=iold_pen 
       call PLUMA(i) 
       goto 50 
      end if 
      GO TO 1000 
                                                                        
!     BLANK GEFUNDEN                                                    
  800 IB = 20 
      goto 803 
  801 IB=8 
      goto 803 
  802 IB=-4 
                                                                        
  803  GO TO 900 
!      BACKSLASH  "\"  GEFUNDEN                                         
  810 JTYPE = 1 
      GO TO 1000 
!     Dollar  "$"  GEFUNDEN                                             
  820 JNDEX = 1 
      GO TO 1000 
!      KLAMMERAFFE "@"  GEFUNDEN                                        
  830 J6BIT = 1 
      GO TO 1000 
                                                                        
  840 IF (JUMLAUT .NE. 1) THEN 
       KC=IC 
       IF (KC .LE. NTEXT .AND. ITYPE .LE. 3) THEN 
        IIC=ITEXT(KC) 
        IF (IIC .EQ. ICHAR1(1) .OR. IIC .EQ. ICHAR1(15) .OR.            &
            IIC .EQ. ICHAR1(21) ) THEN                                  
         JUMLAUT=1 
         JUMSIZ=1 
        ELSE IF(  IIC .EQ. IUMLAUT .OR.                                 &
                  IIC .EQ. ICHAR2(1) .OR. IIC .EQ. ICHAR2(15) .OR.      &
                  IIC .EQ. ICHAR2(21) ) THEN                            
         JUMLAUT=1 
         JUMSIZ=0 
        else 
         jumlaut=0 
      END IF 
       END IF 
       GO TO 1000 
              ! doppeltes "                                             
      ELSE 
       JUMLAUT=0 
       GO TO 100 
      END IF 
!                                                                       
!      BUCHSTABE IST FERTIG, X1,Y1 WERDEN UM DIE BUCHSTABENBREITE ERHOEH
!      DIESE IST   =IB        ,  FALLS  INDEX = 1        (NORMALBUCHSTAB
!                  =0.6*IB    ,  FALLS  INDEX = 2, 3     (OBERER, UNTERE
  900 CONTINUE 
      IF ( INDEX.GT.1 ) GO TO 910 
!      INDEX = 1                                                        
      X1 = X1 + IB*B*COSA 
      Y1 = Y1 + IB*B*SINA 
      if(Z1.lt.H*21) Z1=H*21 
!      BUCHSTABE FERTIG                                                 
      GO TO 1000 
!      INDEX = 2, 3                                                     
  910 X1 = X1 + 0.6*IB*B*COSA 
      Y1 = Y1 + 0.6*IB*B*SINA 
      if(Z1.lt.H*21) Z1=H*21 
!      BUCHSTABE FERTIG                                                 
 1000 CONTINUE 
      end do 
!      ITEXT  IST ABGEARBEITET                                          
!      DIE LAGE DER RECHTEN UNTEREN ECKE DER TEXTZEICHNUNG              
!      WIRD AN DAS RUFENDE PROGRAMM ZURUECKUEBERGEBEN                   
      X2 = X1 
      Y2 = Y1 
      Z2 = Z1 
!     wahl der startfeder                                               
                                                                       
      call PLUMA(iold_pen) 
!                                                                       
      RETURN 
      END                                           
!-----------------------------------------------------------------------
!***********************************************************************
!                                                                       
!     BENSON-LIBRARY                                                    
!                                                                       
!***********************************************************************
!                                                                       
      SUBROUTINE FIN(NTAPE)
      implicit none
      integer NTAPE 
      CLOSE (UNIT=NTAPE) 
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE PNUMA(X1,Y1,NBLC,X2,Y2) 
      implicit none 
      integer NBLC,IX,IY,IBLOC,               &
              MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,N2MAX,ICAR,   &
              NMMAX,NCMAX,LB  
      real    X1,X2,Y1,Y2,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,dum,D
      COMMON /BENXY/ IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,              &
                     N2MAX,ICAR,NMMAX,NCMAX,dum                         
      dimension LB(1) 

      LB(1)=0                      ! 4.1.2014
      CALL TRAA(X1,Y1,0) 
      CALL TRAA(X1,Y1,1) 
      XP=X2 
      YP=Y2 
      XV=XP 
      YV=YP 
      IF(XP.lt.0) then 
       D=-0.5 
       GO TO 4 
      else if(XP.eq.0) then 
       IX=0 
       GO TO 5 
      else if(XP.gt.0) then 
       D=0.5 
      end if 
    4 D=PASX*XP + D 
      IX=IFIX(D) 
                                                                        
    5 IF(YP.lt.0) then 
       D=-0.5 
       GO TO 9 
      else if(YP.eq.0) then 
       IY=0 
       GO TO 10 
      else if(YP.gt.0) then 
       D=0.5 
      end if 
    9 D=PASY*YP + D 
      IY=IFIX(D) 
   10 IF(NBLC.ge.0)then 
       IF(NBLC-IBLOC.lt.0)then 
        NBLC=IBLOC 
        GO TO 14 
       else IF(NBLC-IBLOC.eq.0)then 
        goto 14 
       else IF(NBLC-IBLOC.gt.0)then 
        IBLOC=NBLC 
       end if 
      ELSE 
       goto 100 
      end if 
!      Write(6,'(a,i8)')'NBLC=',NBLC                                    
      LB(1)=NBLC 
   14 CALL BENES(NBLC,LB,1,2) 
!.....LEEREN DES BUFFERS                                                
!.....SCHREIBEN EINER BLOCKNUMMER                                       
      NBLC=NBLC+1 
  100 RETURN 
      END                                           
!                                                                       
      SUBROUTINE IBENA(JBUF,LBUF,NTAPE) 
      implicit none 
      integer JBUF,LBUF,NTAPE,IX,IY,IBLOC,LB 
      real    XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY 
      COMMON /BENXY/IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      dimension LB(1) 
                                                                        
      XP=0. 
      YP=0. 
      XV=0. 
      YV=0. 
      EX=1. 
      EY=1. 
      XO=0. 
      YO=0. 
      IX=0 
      IY=0 
      LB(1)=0
      CALL BENES(NTAPE,LB,1,1) 
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE TRAA(X,Y,J) 
      implicit none 
      integer J,IX,IY,IBLOC,N2MAX,ICAR,NMMAX,NCMAX,IPL,                 &
     &        MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,idum                 
      real    X,Y,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY 
                                                                        
      COMMON /BENXY/IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,              &
     &               N2MAX,ICAR,NMMAX,NCMAX,idum                        
      DIMENSION IPL(3) 
                                                                        
      integer JJ,IXN,NJX,NJY,INEND,NTX,NTY,IK,IYN 
      real    XX,YY,D 
!      write(6,'(i3,a,4f10.3)')J,'=j  TRAA x,y=',X,Y                    
!      write(6,'(a,2f10.2,i2)')' traa x,y,j=',X,Y,J                     
!                                                                       
! ... (XP,YP)  :  WIRKLICHE FEDERPOSITION                               
!                                                                       
! ... (XV,YV)  :  VIRTUELLE FEDERPOSITION                               
!                                                                       
! ... (XX,YY)  :  VIRTUELLE FEDERPOSITION NACH DER ZUWEISUNG            
!                                                                       
      JJ=J 
      IF(JJ-2.ge.0)then 
       XX=XV+X 
       YY=YV+Y 
       JJ=JJ-2 
       GO TO 3 
      end if 
      XX=X 
      YY=Y 
    3 IF(JJ.eq.0)then 
       XV=XX 
       YV=YY 
       JUP=1 
       GO TO 100 
      end if 
    5 IF(JUP.eq.0)then 
       IPL(3)=1 
       XP=XX 
       YP=YY 
       XV=XP 
       YV=YP 
       GO TO 10 
      end if 
      IPL(3)=0 
      XP=XV 
      YP=YV 
   10 IF(XP.lt.0)then 
       D=-0.5 
       GO TO 14 
      else IF(XP.eq.0)then 
       IXN=0 
       GO TO 15 
      else IF(XP.gt.0)then 
       D=0.5 
      end if 
   14 D=PASX*XP + D 
      IXN=IFIX(D) 
   15 NJX=IXN - IX 
      IX=IXN 
      IF(NJX.lt.0)then 
       IXN=-1 
       NJX=-NJX 
       GO TO 20 
      end if 
      IXN=1 
   20 IF(YP.lt.0)then 
       D=-0.5 
       GO TO 24 
      else IF(YP.eq.0)then 
       IYN=0 
       GO TO 25 
      else IF(YP.gt.0)then 
       D=0.5 
      end if 
                                                                        
   24 D=PASY*YP + D 
      IYN=IFIX(D) 
   25 NJY=IYN - IY 
      IY=IYN 
                                                                        
      IF(NJY.lt.0)then 
       IYN=-1 
       NJY=-NJY 
       GO TO 30 
      end if 
      IYN=1 
   30 INEND=1 
      JJ=1 
                                                                        
      IF(NJX-NJY.lt.0)then 
       JJ=NJX 
       NJX=NJY 
       NJY=JJ 
       JJ=-1 
      end if 
      IF(NJX.le.0) goto 60 
      IF(NJX-N2MAX.le.0)goto 50 
      NTX=NJX 
      NTY=NJY 
      NJX=N2MAX 
                                                                        
   35 IF(NTX-NTY.eq.0)then 
       NJY=N2MAX 
       GO TO 42 
      end if 
      IF(NTY.le.0)then 
       NJY=0 
       GO TO 42 
      end if 
      IK=NTX/N2MAX 
      INEND=NTX - IK*N2MAX 
                                                                        
      IF(INEND.gt.0)IK=IK+1 
      NJX=NTX/IK 
      NJY=NTY/IK 
   42 INEND=0 
      NTX=NTX-NJX 
      NTY=NTY-NJY 
                                                                        
   50 IF(JJ.lt.0)then 
       IK=NJY 
       NJY=NJX 
       NJX=IK 
      end if 
   52 IPL(1)=NJX*IXN 
      IPL(2)=NJY*IYN 
      CALL BENES(18,IPL,3,3) 
                                                                        
      IF(INEND.eq.0)then 
       IF(NTX-N2MAX.gt.0)then 
        NJX=N2MAX 
        GO TO 35 
       else 
        goto 56 
       end if 
      else 
       goto 60 
      end if 
                                                                        
   56 NJX=NTX 
      NJY=NTY 
      INEND=1 
      IF(JJ.lt.0)then 
       IK=NJY 
       NJY=NJX 
       NJX=IK 
      end if 
      goto 52 
                                                                        
   60 IF(JUP.eq.0) goto 100 
      JUP=0 
      IPL(3)=1 
      XP=XX 
      YP=YY 
      XV=XP 
      YV=YP 
      GO TO 10 
  100 RETURN 
      END                                           
!                                                                       
      SUBROUTINE PLUMA(LPL)
      implicit none
 
!     modifiziert fuer Rueckgabe der gewaehlten Feder                   
!     und Feder 0...7                                                   
!                                                                       
!     M. Alflen  23.8.89
      real dum 
   integer LPL,IPN,&
           MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,N2MAX,ICAR,NMMAX,NCMAX                                               
   COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,              &
     &               N2MAX,ICAR,NMMAX,NCMAX,dum                         
                                                                        
      DIMENSION IPN(1) 
!     IF (LPL-IP.eq.0.or.LPL.lt.0.or.LPL-9.gt.0)goto 100                
      IF (LPL-IP.eq.0.or.LPL.lt.0.)goto 100 
      IPN(1)=LPL 
      CALL BENES(5,IPN,1,4) 
      IP=LPL 
      RETURN 
  100 LPL=IP 
      RETURN 
      END                                           
                                                                        
      SUBROUTINE PFUMA(LPL) 
      implicit none
      integer LPL,IP,IPN 
!     modifiziert fuer Rueckgabe der gewaehlten Feder                   
      DIMENSION IPN(1) 

      IPN(1)=LPL 
      CALL BENES(5,IPN,1,8) 
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE BENES(LA,LB,lbd,IPEN) 
      implicit none 
      integer LA,LB,lbd,IPEN,IX,IY,IBLOC,N2MAX,ICAR,NMMAX,NCMAX,        &
              MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,idum                 
                                                                        
      real                 XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY 
      COMMON /BENXY/ IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      COMMON /BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,              &
                     N2MAX,ICAR,NMMAX,NCMAX,idum                        
      integer     ICH,ICOD,ICS,IMN,INOP,I7,I6,IES 
      DIMENSION   IES(128) 
      integer     NA 
      DIMENSION   ICH(64),ICOD(12),LB(lbd),ICS(10),NA(10) 
      EQUIVALENCE (ICH(17),ICS(1)),(ICH(14),IMN),(ICH(1),INOP) 
                                                                        
      integer IC,IBIT,IDI,I,I2N,MBIT,K,IR,IDV,IM,IQ,                   &
              IK,JC,LT,J,IXV,IZS,LPAD,IFI,junit                        
                                                                        
      SAVE IDI,MBIT,IES 
integer,parameter :: INBUF=1,MOT=16
integer,parameter,dimension(1:6) :: NPAR=(/3,1,4,2,1,1/) 
!      DATA ICOD/'P','L','N','P','S','Z','N','T','T','X'/               
!.....I7 UND I6 DIE BINAERE DARSTELLUNG DER WERTE 7 UND 6 IN DEN        
!     NIEDERWERTIGSTEN 3 BITS                                           
!      DATA I7/'7'/,I6/'6'/                                             
!      DATA ICH/' ','!','"','#','$','%','&','\'','(',')','*','+',',',   
!     1 '-','.','/','0','1','2','3','4','5','6','7','8','9',            
!     2 ':',';','<','=','>','?','@','A','B','C','D','E','F','G','H','I',
!     3 'J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y',
!     4 'Z',' ',' ',' ',' ',' '/                                        
      ICOD(1)=ichar('P') 
      ICOD(2)=ichar('L') 
      ICOD(3)=ichar('P') 
      ICOD(4)=ichar('N') 
      ICOD(5)=ichar('S') 
      ICOD(6)=ichar('Z') 
      ICOD(7)=ichar('N') 
      ICOD(8)=ichar('T') 
      ICOD(9)=ichar('T') 
      ICOD(10)=ichar('X') 
      ICOD(11)=ichar('P') 
      ICOD(12)=ichar('F') 
                                                                       
      I6=ichar('6') 
      I7=ichar('7')

      do I=1,59 
       ICH(I)=I+31 
      end do 
      do I=60,64 
       ICH(I)=32 
      end do 
                                                                        
      junit=9 
!      if(MBUF.eq.107) then                                             
!       write(6,'(a,5i6)')'BENES(LA,LB,IPEN):',LA,LB,IPEN,MBUF          
!      end if                                                           
      IC=IPEN 
      IF(IC-2.lt.0)then 
!..... INITIALISIERUNG                                                  
       IBUF=126 
       LGMIN=16 
       ICAR=2 
       ICR=13 
       ILF=10 
       IBIT=MOT/ICAR 
       N2MAX=16383 
       PASX=200. 
       PASY=200. 
       IBLOC=1 
       NTAPE=LA 
       IDI=1 
       DO I=5,8 
        IES(I)=0 
       end do 
       I2N=(ICAR-1)*IBIT 
       I2N=2**I2N 
       MBIT=MOT-IBIT 
       ICR=ICR*I2N 
       ILF=ILF*I2N 
!                                                                       
!..... K - MAX. LAENGE DER CHARACTERKETTE                               
!      K <= MIN(255,IBUF-6)                                             
       K=255 
       IF (IBUF .LT. 249) K=IBUF-6 
       NMMAX=K/ICAR 
       NCMAX=NMMAX*ICAR 
       GO TO 45 
      else IF(IC-2.eq.0)then 
       IDI=0 
      else IF(IC-2.gt.0)then 
       goto 200 
      end if 
                                                                        
!.....LEEREN DES BUFFERS                                                
      IF(MBUF-INBUF.le.0)goto 30 
                                                                        
      IF(MBUF-LGMIN.le.0)then 
       DO I=MBUF,LGMIN 
        IES(I)=INOP 
       end do 
       MBUF=LGMIN+1 
      end if 
      IR=MBUF+1 
      IES(MBUF)=ICR 
      IES(MBUF+1)=ILF 
!      write(junit,'(a,5i6)')'1BENES   NTAPE=',NTAPE,MBUF               
      WRITE(NTAPE,1000)(char(IES(I)),I=1,IR) 
!     WRITE(6,1000)(char(IES(I)),I=1,IR)
 1000 FORMAT(1H ,4(250A1)) 
                                                                        
   30 IDV=1000 
      IM=LA 
      DO I=5,8 
       IQ=IM/IDV 
       IES(I)=IQ 
       IM=IM-IQ*IDV 
       IDV=IDV/10 
      end do 
                                                                        
   45 CONTINUE 
      IF(IDI.eq.0)goto 100 
      IDI=0 
!.....DEFINITION DES 1. DATENSATZES                                     
      IES(1)=I7 
      IES(2)=I6 
      DO I=1,64 
       IES(I+2)=ICH(I) 
      end do 
      IES(67)=ICR 
      IES(68)=ILF 
!      write(junit,'(a,5i6)')'2BENES   NTAPE=',NTAPE ,MBUF              
      WRITE(NTAPE,1000)(char(IES(I)),I=1,68) 
!.....DEFINITION DES 2. DATENSATZES                                     
      IES(1)=I7 
      IES(2)=I6 
      DO I=1,64 
       IES(I+2)=ICH(1) 
      end do 
      IES(67)=ICR 
      IES(68)=ILF 
!      write(junit,'(a,5i6)')'3BENES   NTAPE=',NTAPE,MBUF               
      WRITE(NTAPE,1000)(char(IES(I)),I=1,68) 
  100 MBUF=INBUF 
      IK=LB(1) 
      IF(IK-9999.lt.0)goto 150 
!     write(junit,'(a,5i6)')'4BENES   NTAPE=',NTAPE,MBUF                
      write(ntape,111) 
  111 format(1H ) 
!      CALL FIN(NTAPE)                                                  
  150 RETURN 
                                                                        
  200 IF(IC-50.eq.0)then 
       goto 400 
      else IF(IC-50.gt.0)then 
       goto 500 
      end if 
      IC=IC-2 
      JC=IC+IC-1 
      LT=MBUF+LA-1 
      IF(LT-IBUF.le.0)goto 220 
      IR=MBUF+1 
      IES(MBUF)=ICR 
      IES(MBUF+1)=ILF 
!      write(junit,'(a,5i6)')'5BENES   NTAPE=',NTAPE,MBUF               
      WRITE(NTAPE,1000)(char(IES(I)),I=1,IR)
      MBUF=INBUF 
  220 IES(MBUF)=ICOD(JC) 
      IES(MBUF+1)=ICOD(JC+1) 
      MBUF=MBUF+2 
      IK=NPAR(IC) 
      DO J=1,IK 
       IXV=LB(J) 
       IZS=0 
       IF(IXV.eq.0) then 
        IES(MBUF)=ICS(1) 
        MBUF=MBUF+1 
        GO TO 300 
       else IF(IXV.gt.0) then 
        goto 240 
       end if 
       IXV=-IXV 
       IES(MBUF)=IMN 
       MBUF=MBUF+1 
  240  IDV=10000 
       DO I=1,5 
        IQ=IXV/IDV 
        IF(IQ.ne.0)goto 260 
        IF(IZS.gt.0)then 
         goto 270 
        else 
         goto 280 
        end if 
  260   IZS=1 
        IXV=IXV-IDV*IQ 
  270   IES(MBUF)=ICS(IQ+1) 
        MBUF=MBUF+1 
  280   IDV=IDV/10 
       end do 
  300  IES(MBUF)=INOP 
       MBUF=MBUF+1 
      end do 
      RETURN 
  400 LPAD=LA-(LA/ICAR)*ICAR 
      RETURN 
  500 IF(IC-1000.ge.0)goto 800 
      IFI=IC-100 
      DO I=LA,IFI 
       IM=LB(I) 
!..... ISOLIEREN DER ZEICHEN DES WORTES IM LINKSBUENDIG IN DIE          
!      WORTE DER TABELLE NA ( FORMAT A1 )                               
       CALL DPACK(IM,NA,MBIT) 
       IF(I-IFI.lt.0.or.LPAD.eq.0)goto 540 
       LPAD=LPAD+1 
       DO  J=LPAD,ICAR 
        NA(J)=INOP 
       end do 
  540  DO J=1,ICAR 
        IES(MBUF)=NA(J) 
        MBUF=MBUF+1 
       end do 
      end do 
      RETURN 
  800 IFI=IC-1000 
      DO I=1,IFI 
       IES(MBUF)=LB(I) 
       MBUF=MBUF+1 
      end do 
      RETURN 
      END                                           
!                                                                       
      SUBROUTINE DPACK (LAD,NA,IBIT) 
      DIMENSION NA(2),NB(2) 
      LOGICAL*1 M1(4),M2(2) 
      EQUIVALENCE (NB(1),M1(1)),(LBD,M2(1)) 
!                                                                       
      SAVE 
!      write(6,'(a,8i4)')'DPACK:',LAD,NA,IBIT                           
      LBD=LAD 
      M1(1)=M2(1) 
      M1(2)=M2(1) 
      M1(3)=M2(2) 
      M1(4)=M2(2) 
      NA(1)=NB(1) 
      NA(2)=NB(2) 
!      write(6,'(a,8i4)')'DPACK:',LAD,NA,IBIT,M1,M2                     
      RETURN 
      END                                           
                                                                        
      SUBROUTINE POSA(X,Y)
      implicit none
      integer IX,IY,IBLOC
      real    X,Y,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY 
      COMMON /BENXY/ IX,IY,XP,YP,XV,YV,EX,EY,XO,YO,PASX,PASY,IBLOC 
      save 
      X=XV 
      Y=YV 
      RETURN 
      END                                           
                                                                        
      SUBROUTINE  BECENA(X,Y,J,ICA,HX,HY,COSA,SINA)
      implicit none 
! X Y COORDONNEES DU CENTRE DU SYMBOLE DEFINI DANS UN CARRE             
!         4 * 4                                                         
!     J   MEME DEFINITION QUE DANS TRAA                                 
!     ICA RANG DU CARACTERE DANS LA TABLE                               
!    HX,HY  DIMENSIONS DU CARACTERE EN CENTIMETRES                      
       integer J,ICA,&
               ID,IFIN,IND,JP,KX,KY                                                                
        real   X,Y,HX,HY,COSA,SINA,&
               DX,DY,TX,TY,XA,YA                                                                        
real,   dimension(1:5), parameter:: AT=(/0.0,0.25,0.50,0.75,1.0/)
integer,dimension(1:32),parameter:: &
      IOC=(/11,15,7,3,1,5,9,13,17,22,66,71,27,28,34,35,42,43,48,49,&
            54,55,60,61,76,81,86,92,98,104,110,111/)
integer,dimension(1:121),parameter:: &
   IDC=(/ 124, 122, 142,-122, 142, 122, 120,-122, 102, 122, 124,-122,&
          120, 122, 102,-122, 124, 120,   2, 142,-122, 104, 140,   0,&
          144,-122, 124,  24, 102, 120, 142, 124, -22, 124,  24, 104,&
          100, 140, 144, 124, -22, 124,  24, 100, 140, 124, -22, 120,&
           20, 104, 144, 120, -22, 102,   2, 140, 144, 102, -22, 142,&
           42, 104, 100, 142, -22,   4, 122, 120,  44,-122,   0, 122,&
          124,  40,-122, 104, 144, 100, 140,-122, 104, 100, 144, 140,&
         -122, 112, 124, 132, 122, 120,-122, 123, 102, 121, 122, 142,&
         -122, 112, 120, 132, 122, 124,-122, 123, 142, 121, 122, 102,&
         -122, 124,  24, 114, 103, 101, 110, 130, 141, 143, 134, 124,&
          -22/)
         
      CALL TRAA(X,Y,J) 
      IF(ICA.le.0.or.ICA-32.gt.0)goto 10 
      IFIN=1 
      CALL POSA(XA,YA) 
      XA=XA-(HX*COSA-HY*SINA)*0.5 
      YA=YA-(HX*SINA+HY*COSA)*0.5 
      IND=IOC(ICA) 
    3 ID=IDC(IND) 
      IF(ID.ge.0)goto 5 
      IFIN=2 
      ID=-ID 
    5 JP=ID/100 
      KX=(ID-JP*100)/10 
      KY=ID-JP*100-KX*10+1 
      KX=KX+1 
      TX=HX*AT(KX) 
      TY=HY*AT(KY) 
      DX=XA+TX*COSA-TY*SINA 
      DY=YA+TX*SINA+TY*COSA 
      CALL TRAA(DX,DY,JP) 
      GO TO (6,10),IFIN 
    6 IND=IND+1 
      GO TO 3 
   10 RETURN 
      END                                           
                                                                        
      SUBROUTINE BCERCA(X,Y,J,R,ANG,DANG) 
      SAVE 
      A=0.5 
      EPS=0.02 
      RAD=0.01745329 
      I=J-2 
      IF(I.ge.0)goto 2 
      JJ=J 
      XP=X 
      YP=Y 
      GO TO 3 
    2 JJ=I 
      CALL POSA(XP,YP) 
      XP=XP+X 
      YP=YP+Y 
    3 IF(R.gt.0) goto 5 
      CALL TRAA(XP,YP,JJ) 
      GO TO 100 
    5 ALF=ANG*RAD 
      XX=XP + R*COS(ALF) 
      YY=YP + R*SIN(ALF) 
      CALL TRAA(XX,YY,JJ) 
      PHI=SQRT(EPS/(A+R)) 
      IF(DANG.eq.0)goto 100 
      IF(DANG.lt.0)PHI=-PHI 
      DELTA=RAD*DANG 
      JJ=DELTA/PHI 
      DELTA=ALF+DELTA 
      IF(JJ.le.0) goto 11 
      DO I=1,JJ 
       ALF=ALF+PHI 
       XX=XP + R*COS(ALF) 
       YY=YP + R*SIN(ALF) 
       CALL TRAA(XX,YY,1) 
      end do 
   11 XX=XP + R*COS(DELTA) 
      YY=YP + R*SIN(DELTA) 
      CALL TRAA(XX,YY,1) 
  100 RETURN 
      END                                           
                                                                        
                                                                        
!****************************************************                   
      FUNCTION NA(ANF,END,STEP) 
      NA=-2 
      G1=ABS(ANF) 
      G2=ABS(END) 
      G3=AMAX1 (G1,G2) 
      G1=ALOG10(ABS(STEP)) 
      G2=ALOG10(G3) 
      G1=ABS(G1)+1. 
      G2=ABS(G2)+1. 
      K1=IFIX(G1) 
      K2=IFIX(G2) 
      NA=K1 
      IF (NA.GT.6) NA=-2 
      IF (ABS(STEP).GE.1.) NA=-1 
      IF (ABS(STEP).LT.1.) K2=K2+K1 
      IF (K2.GT.7) NA=-2 
      RETURN 
      END                                           
!*********************************                                      
                                                                        
                                                                        
      SUBROUTINE PART (E,AANF,AEND,ASTEP,IAF) 
      implicit none
      integer   IAF, &
                I,K,K1,K2,L,ISTEP,ISCAL
      real      E,AANF,AEND,ASTEP, &
                AMG,BMG,GMB,G1,G2,G3,G4,G5                                                                        
real,dimension(1:4),parameter :: SCALE=(/20.,50.,100.,200./)
      SAVE 

      ASTEP=0. 
      IAF=1 
      ISCAL=0 
      ISTEP=0 
      AMG=1.E-6 
      BMG=1.E+9 
      DO I=1,15 
       BMG=BMG/10. 
       IF ((E-BMG).LT.0.) AMG=10.*AMG 
      END DO 
      E=E*AMG 
      G3=1000. 
      DO K=3,10 
       DO L=1,4 
        G2=K*SCALE(L) 
        IF (G2.GT.E) GOTO 20 
        G1=E-G2 
        IF (G1.GT.G3) GOTO 10 
        G3=G1 
        ISCAL=L 
        ISTEP=K+1 
   10   continue
       END DO 
   20  continue
      END DO 
      ASTEP=SCALE(ISCAL)/AMG 
      IAF=IFIX(SCALE(ISCAL)/10.) 
!                                                                       
      G1=-11. 
      IF (AEND.NE.0.) G1=ALOG10 (ABS(AEND)) 
      IF (G1.LT.0.) G1=G1-1. 
      K1=IFIX(G1) 
      G2=10.**K1 
      K2=IFIX(AEND/G2) 
      G3=FLOAT(K2)*G2 
      IF (AANF.LT.0..AND.AEND.GT.0.) G3=0. 
      G4=ASTEP 
      G5=G3 
   30 G5=G5+G4 
      IF (G5.LT.AEND) GOTO 30 
      AEND=G5 
      G5=G3 
   40 G5=G5-G4 
      IF (G5.GT.AANF) GOTO 40 
      AANF=G5 
      RETURN 
      END                                           
!*******                                                                
      SUBROUTINE NUMBER (X0,Y0,J,FNP,NC,HX,HY,COSA,SINA,X1,Y1) 
      implicit none 
      real X0,Y0,FNP,HX,HY,COSA,SINA,X1,Y1,Z1 
      integer J,NC,ISL,IPEN,N,MAX,I,ILP,K,L 
                                                                        
      real A10,FPV,Z,U,V,W 
                                                                        
      character*1 ICR 
character(len=1),DIMENSION(1:80) :: ILIS
character(len=1),parameter :: NBL=' ', NSR='R', NSZ='Z', MOINS='-', &
                              POINT='.', EA='E',NBS=char(92) 
character(len=1),dimension(1:10),parameter:: &
         IDA=(/'0','1','2','3','4','5','6','7','8','9'/) 
!                                                                       
!     X0,Y0 KOORDINATEN DES STARTPUNKTES (J < 2)                        
!           KOORDINATEN DES ZENTRUMS (J = 2,3)                          
!     J=2,3 ZEICHNEN EINES ZENTRIERTEN SYMBOLS                          
!     J=0,1 PLOTTEN DER ZAHL FNP IM FORMAT NC                           
!     J < 0 BERECHNEN DES ENDPUNKTES X1,Y1 OHNE PLOT                    
!     FNP   MASCHINENINTERNE GLEITKOMMADARSTELLUNG DER SYMBOLNUMMER (J =
!           BZW. DER ZU ZEICHNENDEN ZAHL (J < 2)                        
!     NC    FORMAT                                                      
!     NC>-1 FESTKOMMADARSTELLUNG                                        
!     NC=-1 INTEGERDARSTELLUNG (IMMER BEI J=2,3 UNABHAENGIG VON EINGABE)
!     NC<-1 GLEITKOMMADARSTELLUNG                                       
!     HX,HY BREITE UND HOEHE DER ZAHL BZW. DES SYMBOLS                  
!     COSA  COSINUS DES WINKELS ZWISCHEN ZAHL BZW. SYMBOL UND           
!           POSITIVER PLOTTER-X-ACHSE                                   
!     SINA  SINUS DES WINKELS ZWISCHEN ZAHL BZW. SYMBOL UND             
!           POSITIVER PLOTTER-X-ACHSE                                   
!     X1,Y1 KOORDINATEN DES ENDPUNKTES (AUSGABEGROESSEN)                
                                                                        
                                                                        
                                                                        
      ILIS(1)=NBS 
!     ROMAN NUMBERS (FOR SCRIPT NUMBERS  SET ILIS(2)=NSS)               
      ILIS(2)=NSR 
      ISL=2 
      IF (J.LT.2) GOTO 5 
      NC=-1 
      ILIS(2)=NSZ 
      IF (FNP.GE.10.) GOTO 5 
      ILIS(3)=NBL 
      ISL=3 
    5 A10=1./ALOG(10.) 
                                                                        
      IPEN=J 
      FPV=ABS(FNP) 
      N=NC 
      MAX=9 
      IF(N-MAX.gt.0)N=MAX 
      IF(N+MAX.lt.0)N=-MAX 
      IF(FNP.eq.0)then 
       ICR=IDA(1) 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
       goto 101 
      else IF(FNP.lt.0)then 
       ICR=MOINS 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
      end if 
      GOTO 6 
                                                                        
  101 IF(N+1.ne.0)then 
       ICR=POINT 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
      end if 
      GO TO 900 
                                                                        
    6 IF(N+1.eq.0)then 
       Z=0.5 
       GO TO 53 
      else IF(N+1.lt.0)then 
       ICR=IDA(1) 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
       goto 104 
      else IF(N+1.gt.0)then 
       Z=0.5*10.**(-N) 
      end if 
                                                                        
   53 FPV=FPV+Z 
      Z=ALOG(FPV)*A10 
      I=Z+1. 
                                                                        
      IF(I.le.0)I=1 
      ILP=I+N 
      if(N.lt.0)ILP=ILP+1 
      DO  K=1,ILP 
       U=10.**(I-K) 
       L=FPV/U 
       IF(L-9.gt.0) L=9 
       ICR=IDA(L+1) 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
                                                                        
       FPV=FPV-FLOAT(L)*U 
                                                                        
       IF(K-I.ne.0.or.N.lt.0)goto 10 
       ICR=POINT 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
   10  CONTINUE 
      end do 
  900 CALL TXTPLO(X0,Y0,IPEN,ILIS,ISL,HX,HY,COSA,SINA,X1,Y1,Z1) 
      RETURN 
                                                                        
  104 ICR=POINT 
      ISL=ISL+1 
      ILIS(ISL)=ICR 
      N=-N 
      V=ALOG(FPV)*A10 
      L=V+1. 
      IF(V+1.0.lt.0.0)L=L-1 
      W=FPV+0.5*10.**(L-N) 
      Z=ALOG(W)*A10 
      I=L 
      L=Z+1. 
      IF(Z+1.0.lt.0.)L=L-1 
      IF(I-L.eq.0)FPV=W 
                                                                        
      DO K=1,N 
       U=10.**(I-K) 
       L=FPV/U 
       IF(L-9.gt.0) L=9 
       ICR=IDA(L+1) 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
       FPV=FPV-FLOAT(L)*U 
      end do 
      ICR=EA 
      ISL=ISL+1 
      ILIS(ISL)=ICR 
      IF(I.lt.0)then 
       ICR=MOINS 
       ISL=ISL+1 
       ILIS(ISL)=ICR 
      end if 
      L=IABS(I)/10 
      ICR=IDA(L+1) 
      ISL=ISL+1 
      ILIS(ISL)=ICR 
      L=IABS(I)-L*10 
                                                                        
      ICR=IDA(L+1) 
      ISL=ISL+1 
      ILIS(ISL)=ICR 
      GO TO 900 
      END                                           
!*******************************************************************    
                                                                        
!-----------------------------------------------------------------------
!     call numero(ystep,ny,iystep,nystep,0)                             
      SUBROUTINE NUMERO(FNP_T,NC,INUM,NCHA,MODE,iscfactor) 
      implicit none                                                                  
!     konvertiert Zahl zu ASCII-String                                  
!                                                                       
!     M. Alflen  13.9.89                                                
!                                                                       
!     fnp  Eingabezahl                                                  
!     nc   > 0  : f-Format mit nc Nachkommastellen  ( nc <= 5 )         
!          =0   : i-Format                                              
!          <0   : e-Format mit nc  Nachkommastellen    ( nc<=2 )        
!     mode =  0  : e-Format = x.yzE+nn                                  
!             1  : e-Formay = x.yz*10-n                                 
!                                                                       
!     num  =   Ausgabestring  ( Integer )                               
!     ncha =   Zahl der signifikanten Character                         
      integer     NC,NCHA,MODE,iscfactor, &
                  i,k,l
      real        FNP_T,dum,fnp                                                                     
      character*1 ie1,ie2,inum(24),form*7 
                                                                        
      do i=1,24 
       inum(i)=' ' 
      end do 
      ie2=' ' 
      fnp=FNP_T/10**iscfactor 
!     write(6,'(a,f15.5,a,i2,a,i2)')                                    
!     &            ' fnp=',fnp,' MODE=',MODE,'  NC=',NC                 
                                     ! f - oder i-Format                
      if ( nc .ge. 0) then 
       if ( nc .gt. 5 ) nc=5 
       form='f15.5'
      inum=' ' 
       call xencode(fnp,form,inum) 
!      write(6,'(a8,a,f15.5,a,24a1)') form,' fnp=',fnp,'    inum=',inum         
       if (nc .eq. 0) then 
        ncha=10-1 
       else 
        ncha=10+nc 
       end if 
                                    ! ueberfluessige Nachkommastellen en
       if ( nc .lt. 5 ) then 
        k=ncha+1 
        do while ( k .le. 15 ) 
         inum(k)=' ' 
         k=k+1 
        end do 
       end if 
                                    ! e-Format                          
      else if ( nc .le. -1 ) then 
       dum=fnp 
       if(nc.eq.-1) form='e10.1' 
       if(nc.eq.-2) form='e10.2' 
       if(nc.eq.-3) form='e10.3' 
       if(nc.le.-4) form='e10.4' 
       call xencode(dum,form,inum) 
!      write(6,'(a,15a1,a,15a1,/)') ' a inum=',inum                     
                                                                        
                                    ! normales e-Format                 
       if ( mode .eq. 0 ) then 
                                    ! Divison/10. ausgleichen           
        inum(2)=inum(4) 
        do i=4,9 
         inum(i)=inum(i+1) 
        end do 
                                                                        
                                     ! Blanks einfuegen                 
        do i=10,24 
         inum(i)=' ' 
        end do 
        ncha=10 
                                     ! spezielles e-Format              
       else 
        i=4 
        do while(i.lt.24.and.inum(i).ne.'e') 
         i=i+1 
        end do 
         ie1=inum(i+1) 
         ie2=inum(i+2) 
!        write(6,'(i2,2x,2a1,a,24a1,/)') i,ie1,ie2,'- inum=',inum       
!                              inum=   -1.0e-4                          
!                              inum= -1.050e-4                          
!                              inum=-1.0500e-4                          
          inum(i  )=char(92) 
          inum(i+1)='Z' 
          inum(i+2)='1' 
          inum(i+3)='5' 
          inum(i+4)=char(92) 
          inum(i+5)='r' 
          inum(i+6)='1' 
          inum(i+7)='0' 
          inum(i+8)='$' 
          inum(i+9)='^' 
          inum(i+10)=ie1 
          inum(i+11)=ie2 
          inum(i+12)='$' 
          inum(i+13)=' ' 
          ncha=i+13 
       end if 
      end if 
!      write(6,'(i2,a,24a1,/)') i,'- inum=',inum                        
                                                                        
                                     ! fuehrende Blanks beseitigen      
      i=1 
      do while ( i.le. 24 .and. inum(i) .eq. ' ') 
       i=i+1 
      end do 
      i=i-1 
      ncha=ncha-i 
      if ( i .gt. 0) then 
       do k=1,ncha 
        l=k+i 
        inum(k)=inum(l) 
        inum(l)=' ' 
       end do 
      end if 
                                                                        
!     write(6,'(i2,a,24a1,/)') i,'- inum=',inum                         
      return 
      END                                           
                                                                        
!-----------------------------------------------------------------------
                                                                        
      subroutine xencode(rn,form,inum) 
       implicit none
       integer k,nr,nl
       real    rn
       character*1 inum(24),form*7,chr*24,chl*24 
       call trlnu(form,rn,chr,nr,chl,nl) 
       do k=1,nr 
        inum(k)=chr(k:k) 
       end do 
      return 
      END                                           
                                                                        
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
      function naxfor(anf,end,step) 
!                                                                       
!     naxfor analysiert Eingabegroessen und                             
!     bestimmt Skalierungs-Format fuer BATPLO                           
!                                                                       
!     nform <0  : e-Format                                              
!           =0  : i-Format                                              
!           >0  : f-Format ( nform Nachkommastellen )                   
!                                                                       
!     anf       : Anfangswert Skala                                     
!     end       : Endwert Skala                                         
!     step      : Abschnitt                                             
!                                                                       
!                                                                       
!     M. Alflen   15.9.89                                               
!                                                                       
!                                                                       
      implicit none 
!                                                                       
      real anf,end,step,aanf,aend,astep,delta 
      integer naxfor,k,mult 
!                                                                       
      aanf=abs(anf) 
      aend=abs(end) 
      astep=abs(step) 
!                                                                       
      if (astep .ge. 1.e6 .or. astep .le. 1.e-4) then 
       mult=ifix( amax1(aend,aanf)/astep ) 
       if ( mult .ge. 10) then 
                                                      ! e-Format        
        naxfor=-2 
       else 
        naxfor=-1 
       end if 
      else 
       delta=abs( astep-float( ifix( astep ) ) ) 
       if ( delta .le. 1.e-4 ) then 
                                                      ! i-Format        
        naxfor=0 
       else 
        k=0 
        do while (delta .gt. 1.e-4 .and. k .le. 5) 
         k=k+1 
         delta=delta*10. 
         delta=abs( delta-float( ifix( delta ) ) ) 
        end do 
        naxfor=min(k,5) 
       end if 
      end if 
!                                                                       
      return 
!                                                                       
      END                                           
