
/* This headerfile should ONLY be used by the device-dependent modules */
/* "u_pl_xxx.c", NEVER by a user program                               */

#define PLOT_STAT_OK             0
#define PLOT_STAT_NOMOREHANDLES  1
#define PLOT_STAT_NOMEMORY       2
#define PLOT_STAT_NOSUCHHANDLE   3
#define PLOT_STAT_NOMOREDEV      4
#define PLOT_STAT_NODISPLAY      5
#define PLOT_STAT_NOSUCHDEV      6
#define PLOT_STAT_OPENERROR      7
#define PLOT_STAT_NOSYMBOLS      8
#define PLOT_STAT_NODRIVER       9
#define PLOT_STAT_NOFONTS        10

#define MAXHANDLES 20

typedef signed char symbolcoordtyp;

typedef struct symboltyp{
   unsigned char vec;
   symbolcoordtyp *x1,*x2,*y1,*y2;
}symboltyp;

/* Forward declarationof handletyp, we need handleptr to be declared */
/* to use it in the declaration of handletyp. Gnu C complains about  */
/* "useless keyword in empty declaration", don't care about...       */

/* handletyp contains all information about a plot device handle, and */
/* pointers to the functions you need for working with  the device    */

typedef struct handletyp {
   int xvmin, xvmax, yvmin, yvmax, clip;     
   double xwmin, xwmax, ywmin, ywmax, xfact, xoffs, yfact, yoffs;
   double akt_x, akt_y, symbol_factor, cm_per_unit;
   char name[80];
   int devtype;
   unsigned long capabilities;
   int (* ploth_modify)();
   int (* ploth_getdevice)();
   void (* ploth_line)();
   void (* ploth_point)();
   void (* ploth_fillpolygon)();
   void (* ploth_polyline)();
   int (* ploth_setfg)();
   int (* ploth_getfg)();
   int (* ploth_setbg)();
   int (* ploth_getbg)();
   void (* ploth_settextalign)();
   void (* ploth_writetext)();
   void (* ploth_erasetext)();
   void (* ploth_graphmode)();
   void (* ploth_clear)();
   void (* ploth_textmode)();
   void (* ploth_close)();
   int  (* ploth_setmode)();
   int  (* ploth_getmode)();
   int (* ploth_getpointer)();
   int (* ploth_checkevent)();
   int (* ploth_get_any_event)();
   int (* ploth_check_any_event)();
   void (* ploth_rectangle)();
   void (* ploth_polysymbol)();
   void (* ploth_do_special)();
} handletyp;

/*typedef struct handletyp;*/    
typedef struct handletyp *handleptr;

int plotd_init_ps(int nh, handletyp *h, int sizex, int sizey,
		  int posx, int posy, char name[], void *special);

int plotd_init_x11(int nh, handletyp *h, int sizex, int sizey,
		   int posx, int posy, char name[]);
