
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#include "v_inp.h"

#ifdef MOTIF

#define get_filename MOTIF_get_filename
void MOTIF_get_filename(char filnam[], char frage[], char wildcard[]);
/* ask for filename, by entering a "?", you get the directory   */
/* The filename is returned in "filename"                       */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR"  */

#define lesefile_oeffnen MOTIF_lesefile_oeffnen
FILE *MOTIF_lesefile_oeffnen(char frage[], char wildcard[]);
/* Open textfile for reading                                    */
/* If successfull, ok is true, else ok is false                 */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR"  */

#define schreibfile_oeffnen MOTIF_schreibfile_oeffnen
FILE *MOTIF_schreibfile_oeffnen(char frage[], char wildcard[]);
/* open textfile for writing                                    */
/* If successfull, ok is true, else ok is false                 */
/* "frage" passes a question to be displayed, "wildcard" passes */
/* the mask for the files to be displayed by "?", e.g. "*.PAR", */
/* and the Default-Extension.                                   */
/* Check if file already exists (only if it's not the terminal) */

#define entscheidung MOTIF_entscheidung
int MOTIF_entscheidung(char frage[], char def);
/* Question with two possible answers: yes or no         */
/* The question is passed in "frage", the default answer */
/* "y" or "n" in "d". The Function returns "true" if the */
/* answer is "Yes".                                      */

#define entscheidung_a MOTIF_entscheidung_a
int MOTIF_entscheidung_a(char frage[], int def, int anz);
/* Question with two (yes/no) or three (yes/no/exit) possible answers    */
/* the question is passed in "frage", the default in "def" and the       */
/* number of possible answers in "anz". The result returned is           */
/* Res = 1 : "Yes",     Res = 2 : "No",     Res = 3 : "Exit"             */
/* The name comes from ATARI-GEM, where this Procedure used an Alert-Box */

void MOTIF_message(char mess[]);
/* print message and wait for keypress */

#define selection_menu MOTIF_selection_menu
int MOTIF_selection_menu(char *title, char *shorts,
                   char **items, int n_items, int def);
/* Displays a selector box and returns the selection.  */

void MOTIF_interface_switch(int onoff);

int MOTIF_interface_enabled();

#endif
