#include <stdio.h>
#include "xben.h"

#define XB_ITEM_END      0
#define XB_ITEM_POLYLINE 1
#define XB_ITEM_MOVE_ABS 2
#define XB_ITEM_MOVE_REL 3
#define XB_ITEM_PEN      4
#define XB_ITEM_FILL     10
#define XB_ITEM_DRAW_REL 5
#define XB_ITEM_DRAW_ABS 6
#define XB_ITEM_CONT     7
#define XB_ITEM_START    8
#define XB_ITEM_NONE     9

int add_item(plotinfo *plot, int item, double arguments[]);
/* Add one item to buffer */

int get_item(plotinfo *plot, int *item, int *nargs, datatype **arguments);
/* get one item from buffer */

int create_buffer(plotinfo *plot);
/* Create buffer for one plot, returns buffernumber, 0 if no more buffers */


int start_buffer(plotinfo *plot);
/* Makes buffer ready for output, returns status */

void delete_buffer(plotinfo *plot);
/* Delete one Buffer */

int get_minmax(plotinfo *plot, datatype *xmin, datatype *xmax, 
                               datatype *ymin, datatype *ymax);

void xb_buff_init();

int move_origin(plotinfo *plot, datatype move_x, datatype move_y);

int scale_buffer(plotinfo *plot, double factor_x, double factor_y);

int rotate_buffer(plotinfo *plot, double angle);

void reset_scaling(plotinfo *plot);

int transform_buffer(FILE *,plotinfo *plot);
