
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "xben.h"
#include "xb_menu.h"
#include "xb_read.h"
#include "xb_buff.h"
#include "v_inp.h"


#define BEN_FACTOR 50        /* Micrometers per Step */
#define HPGL_FACTOR 25       /* Micrometers per Step */
#define apl_factor 10000.0 

static long int BEN_OFFSET=300000.0;   /*(2*xrand+2*xd+xw)*10000 */
static char typename[4][10] = {"Unknown","Allplo","XPL","HPGL"};

static void besetzen(beninfo *fromapl,double out[],int i){
                  fromapl->xanf=out[0]*apl_factor; 
		  fromapl->xend=out[1]*apl_factor; 
                  fromapl->yanf=out[2]*apl_factor;
                  fromapl->yend=out[3]*apl_factor;
}
static void besetzen_a(beninfo *fromapl,double out[],int i){
                  fromapl->a_xanf=out[4]*apl_factor;
                  fromapl->a_xend=out[5]*apl_factor;
                  fromapl->a_yanf=out[6]*apl_factor;
                  fromapl->a_yend=out[7]*apl_factor;
                  fromapl->r_xanf=fromapl->a_xanf;
                  fromapl->r_xend=fromapl->a_xend;
                  fromapl->r_yanf=fromapl->a_yanf;
                  fromapl->r_yend=fromapl->a_yend;
                  fromapl->iplot=i;
		  /*printf("# i=%d   a_xanf=%8.1f a_xend=%8.1f apl_factor=%12.3f\n",
		    i,out[4]*apl_factor,out[5]*apl_factor,apl_factor);*/ 
}

static int read_benson(beninfo *fromapl,plotinfo *plot, FILE *infile, int invert){
   char ch[255], dummy;
   double out[16], tmp;
   int cnt, stat, item, i_run;

   fgets(ch,250,infile);/*printf("%s\n",ch);*/
   fgets(ch,250,infile);
   while ((cnt=fscanf(infile,"%[^P]",ch)) != EOF){
     dummy = getc(infile);
   } 
   cnt = trans(ch,out);
   BEN_OFFSET=(long int)(out[0]*apl_factor); 
   rewind(infile);

   fgets(ch,250,infile);
   fgets(ch,250,infile);
   /* Read Commands from file: Commands are "PL x y p " or "NP p" */
   /* so we take N and P as record separators, ignore the second  */
   /* char and look how many numbers follow: 3 -> PL, 1 -> NP     */
   i_run=0;
   out[0] = BEN_OFFSET; out[1] = 0;
   stat = add_item(plot,XB_ITEM_MOVE_ABS,out);   
   while (((cnt=fscanf(infile,"%[^P]",ch)) != EOF)
          && (stat == XB_STAT_OK)){
       /*printf("%s\n",ch);*/
     dummy = getc(infile);
     if (cnt==0) continue;
     cnt = trans(ch,out);
     if ((cnt==1) && ((int)out[0] == 76)) continue;
     /*if (cnt==1) { out[0] = out[0]-1;}*/
     if (cnt==1) { /*out[0] = out[0]; spiering*/
         stat = add_item(plot,XB_ITEM_PEN,out);
	 if(ch[0] == 'F') stat = add_item(plot,XB_ITEM_FILL,out);}
     if (cnt==3) {
        switch ((int)out[2]){
           case 0 : item = XB_ITEM_MOVE_REL; break; 
           case 1 : item = XB_ITEM_DRAW_REL; break; 
           case 2 : item = XB_ITEM_MOVE_ABS; break;  
           case 3 : item = XB_ITEM_DRAW_ABS; break; }
        tmp = out[1]; out[1] = out[0]*BEN_FACTOR;
        out[0] = -tmp*BEN_FACTOR;
        stat = add_item(plot,item,out); 
    }
     if (cnt==8) {
         besetzen(&fromapl[i_run],&out[0],i_run);
	 if(fromapl[i_run].iplot==-1) besetzen_a(&fromapl[i_run],&out[0],i_run);
	 /*printf("irun=%d out[0]=%8.2f out[1]=%8.2f out[2]=%8.2f out[3]=%8.2f \n",
	   i_run,out[0],out[1],out[2],out[3]);*/
      i_run++;} 
   }
   stat = add_item(plot,XB_ITEM_END,out);
 
   return stat;
}


static int read_the_file(FILE *infile,beninfo *fromapl, plotinfo *plot){
   char outstr[80];
   int stat;
   if (plot->bufnum != XB_STAT_NOBUFF) delete_buffer(plot);
   if (create_buffer(plot) == XB_STAT_NOBUFF){
      fclose(infile);
      return XB_STAT_NOBUFF;}
       stat = read_benson(fromapl,plot,infile,FALSE); 
   
   fclose(infile);
   plot->visible = TRUE;
   return stat;
}

static int detect_filetype(char name[]){
   char *tmp;
   int type;
   tmp = malloc(strlen(name)+1);
   strcpy(tmp,name);
   upstring(tmp);
   if (strstr(tmp,".BEN")!=NULL) type = FILETYPE_ALLPLO;
   else type = FILETYPE_HPGL;
   free(tmp);
   return type;
}

int read_plotfile_by_name(beninfo *fromapl,plotinfo *plot){
   FILE *infile;
   if (plot->filetype==FILETYPE_DETECT) 
       plot->filetype = detect_filetype(plot->filename);
   infile = fopen(plot->filename,"r");
   if (! infile){/*XBEN_message("Error opening file for Input");*/ 
      return XB_STAT_NOFILE;}
   /* printf(" Reading File %s, Type %s ",
      plot->filename,typename[plot->filetype]);newline();*/
   return read_the_file(infile,fromapl,plot);
}

int read_plotfile(FILE *volterm,beninfo *fromapl,plotinfo *plot){
   FILE *infile;
   int filetype;
   char def_extension[10];
   filetype = plot->filetype;
   if (plot->filetype == FILETYPE_DETECT){
      printf(" Filetype (1=Allplo, 2=XPL, 3=HPGL) (D=%1d) : ",FILETYPE_ALLPLO);
      filetype = integer_default(volterm,FILETYPE_ALLPLO);
   }
   if ((filetype < FILETYPE_ALLPLO) || (filetype > FILETYPE_HPGL)) return FILETYPE_HPGL;
   plot->filetype = filetype;
   if (filetype==FILETYPE_HPGL) strcpy(def_extension,"*.hpl");
                           else strcpy(def_extension,"*.ben");
   infile = lesefile_oeffnen(volterm," Read Plotfile ",def_extension);
   if (! infile) return XB_STAT_NOFILE;
#ifdef VMS
   fgetname(infile,plot->filename,1);
#else
   strcpy(plot->filename, last_filename());
#endif
   return read_the_file(infile,fromapl,plot);
}
