#include <stdlib.h> 
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>

#define fr2fi fr2fi_
#define  mcarlocounts mcarlocounts_

#define frand() ((double)random()/((float)RAND_MAX+1.))

#define maxn 1024

extern struct fr2fi{
  float thfk[8*maxn],simul[8*maxn],geof[8*maxn];             
} fr2fi;


void mcarlocounts(int *icase, int *achannel, float *acountrate, float *adeadtime, 
	         float *sweepfr,int *counts,  float *mfrwindow, int *iseed) 
{ 
  float rf,lambda,deadtime,lastevent,eventtime,eventtimeB,bfraction,
    mfraction,cputime,timec,times, *theo,*geo;
  double carlonu,totaltime,printmct,bg_fraction,dwelltime,u; 
  int  nu_channel,ifr;
  long int ichannel,i,j,jch,isweep,icall,iloss,mloss,*isimul; 
  clock_t c0, c1; /* clock_t is defined on <time.h> and <sys/types.h> as int */

  /*  Donald Knuth describes a way to generate such values in §3.4.1 (D)
  of The Art of Computer Programming.
  NEXTTIME=-log(1.-frand())/rate 
  http://preshing.com/20111007/how-to-generate-random-timings-for-a-poisson-process*/
  
    srandom(*iseed);
    nu_channel=*achannel;
    dwelltime=0.0;
    if( *sweepfr >0.0) dwelltime=1./ *sweepfr/nu_channel;

    printf ("nu_channel=  %d\n ",nu_channel);       
    theo=   malloc(nu_channel * sizeof(float));
    geo=   malloc(nu_channel * sizeof(float));

    isimul= malloc(nu_channel * sizeof(long int));
    for(i=0;i<nu_channel; i++) isimul[i]=0;
    for(i=0;i<nu_channel; i++) theo[i]=fr2fi.thfk[i];
    for(i=0;i<nu_channel; i++) geo[i]=fr2fi.geof[i];

    //for(i=0;i<nu_channel; i=i+4){printf("n=%d  %f  %f   %f\n",i,theo[i],geo[i],theo[i]/geo[i]);};

    c0 = clock(); 
    cputime=0.;

    if(*mfrwindow >0.999999)*mfrwindow=0.999999;
    lambda=*acountrate;

    mfraction=*mfrwindow;
    deadtime=*adeadtime;
    
    iloss=0; mloss=0;  icall=0; lastevent=0.0; eventtime=0.0;

  if(*icase == 3){
     //non-paralyzable
     isweep=0; icall=0; times=*counts/lambda/5.0;
     if(dwelltime == 0.0){    //dwelltime= 5*lamda*s  each channel
     while(isimul[0] < *counts){
       isweep++;
       for(ichannel=0;ichannel<nu_channel;ichannel++){
       timec=0.0;
       while(timec< times){
        u=-log(1.-frand());
        eventtime=u/lambda/geo[ichannel];
        icall++;
       if(frand()<mfraction){
 	  eventtime=eventtime/theo[ichannel];   timec=timec+eventtime;
          lastevent=lastevent+eventtime;
         if(lastevent > deadtime){lastevent=0.0; isimul[ichannel]++;
         }else{mloss++;}	
        }else{
          lastevent=lastevent+eventtime;   timec=timec+eventtime;
	  if(lastevent > deadtime){lastevent=0.0;}else{iloss++;}
        };
       };
      };
     printf("sweep=%ld mloss=%ld iloss=%ld  MC-call=%ld\n",isweep,mloss,iloss,icall);
     };

     }else{  //dwelltime each channel
     icall=0;  totaltime=0.0;
     while(isimul[0] < *counts){
       icall++;
       totaltime=totaltime+eventtime;
       ichannel= totaltime/dwelltime;
       isweep=ichannel/nu_channel; ichannel=ichannel-isweep*nu_channel;

       u=-log(1.-frand());
       eventtime=u/lambda/geo[ichannel];

	if(frand()<mfraction){
 	  eventtime=eventtime/theo[ichannel]; 
          lastevent=lastevent+eventtime;
         if(lastevent > deadtime){lastevent=0.0; isimul[ichannel]++;
         }else{mloss++;}	
        }else{
          lastevent=lastevent+eventtime;  
	  if(lastevent > deadtime){lastevent=0.0; }else{iloss++;}
        };
        totaltime=totaltime+eventtime;
	
	ifr=5.0*(isimul[0]/ *counts);
	if(ifr ==1 || ifr ==2 ||ifr ==3 ||ifr ==4){
        printf (" total time units:%8.0f    MC-calls=%ld\n",totaltime,icall);}
     };
       printf (" total time units:%8.0f    MC-calls=%ld\n",totaltime,icall);	
     };
     
   }else if(*icase == 4){
     //paralyzable
     if(dwelltime == 0.0){    //dwelltime= 5*lamda*s  each channel
      isweep=0; icall=0;
     while(isimul[0] < *counts){
      isweep++;
      for(ichannel=0;ichannel<nu_channel;ichannel++){
       timec=0.0;
       while(timec< 5.0){
        u=-log(1.-frand());
        eventtime=u/lambda/geo[ichannel];
        icall++;
       if(frand()<mfraction){
 	  eventtime=eventtime/theo[ichannel]; 
          lastevent=lastevent+eventtime;
         if(lastevent > deadtime){lastevent=0.0; isimul[ichannel]++;
         }else{mloss++;  lastevent=0;}	
        }else{
          lastevent=lastevent+eventtime; 
	  if(lastevent > deadtime){lastevent=0.0; }else{iloss++; lastevent=0;}
        };
        timec=timec+eventtime;
       };   // timec
      };
     printf("sweep=%ld mloss=%ld iloss=%ld  MC-call=%ld\n",isweep,mloss,iloss,icall);
     };
     }else{ //dwelltime each channel
       icall=0;  totaltime=0;
     while(isimul[0] < *counts){
       icall++;
       totaltime=totaltime+eventtime;
       ichannel= totaltime/dwelltime;
       isweep=ichannel/nu_channel; ichannel=ichannel-isweep*nu_channel;

       u=-log(1.-frand());
       eventtime=u/lambda/geo[ichannel];

	if(frand()<mfraction){
 	  eventtime=eventtime/theo[ichannel]; 
          lastevent=lastevent+eventtime;
         if(lastevent > deadtime){lastevent=0.0; isimul[ichannel]++;
         }else{mloss++;  lastevent=0;}	
        }else{
          lastevent=lastevent+eventtime;  
	  if(lastevent > deadtime){lastevent=0.0; }else{iloss++; lastevent=0;}
        };
        totaltime=totaltime+eventtime;
	
	ifr=5.0*(isimul[0]/ *counts);
	if(ifr ==1 || ifr ==2 ||ifr ==3 ||ifr ==4){
        printf (" total time units:%8.0f    MC-calls=%ld\n",totaltime,icall);}
     };
       printf (" total time units:%8.0f    MC-calls=%ld\n",totaltime,icall);	
     };

   }
        
      c1 = clock();
      cputime=(float) (c1 - c0)/CLOCKS_PER_SEC;
      printf ("\n cputime=%f\n",cputime); 


    for(i=0;i<nu_channel; i++) fr2fi.simul[i]=isimul[i];
    free( isimul);
    free(theo);              
}
