#include "string.h"
#include "u_plot.h"

 typedef struct {
          short int x, y;
       } XPoint;
#include "u_pl_loc.h"

#include <stdio.h>
#include <stdlib.h>
#include "v_plotstr.h"

#define A4_X  19.
#define A4_Y  27.

static float FACTOR=40.;     /* ~625/19   */
static float shiftx=0.,shifty=0.;
static FILE *plotfile;
static int file_is_open= FALSE;
static int rotate, devsizex, devsizey, mirrory;
static char cmd[6];

static void write_point(char *cmd, int x, int y){
     int tmp;
     
     if(mirrory) y = devsizey - y;
     if (rotate) { tmp = x; x = devsizey-y; y = tmp; }
   fprintf(plotfile," %s %g %g \n",cmd,x/FACTOR+shiftx,y/FACTOR+shifty);
}

void plotd_line_dsp(int handle, int X0, int Y0, int X1, int Y1){
   write_point("34",X0,Y0);
   write_point(cmd,X1,Y1);
}
void plotd_point_dsp(int handle, int X, int Y){
   plotd_line_dsp(handle,X,Y,X,Y+1);
}

void plotd_polyline_dsp(int handle, int pts, int X[], int Y[]){
    int i;
  write_point("34",X[0],Y[0]);
  for (i=1; i<pts; i++) write_point(cmd,X[i],Y[i]);
}
void plotd_polylinevc_dsp(int handle, int pts, XPoint *itmp){
    int i;
    write_point("34",itmp[0].x,itmp[0].y);
    for (i=1; i<pts; i++) write_point(cmd,itmp[i].x,itmp[i].y);
}
int plotd_setfgbyname_dsp(int handle, char *color){
/* set foreground color */
    int j,k, fg;
    cmd[0]=' ';cmd[1]=' ';cmd[2]=' ';cmd[3]=' ';cmd[4]=' ';cmd[5]='0';cmd[6]='\0';
    /*printf("color=%s \n", color);*/
    fg=0;
    while(strcmp(color,win.tabcolor[fg]) !=0 && fg < 64)fg++;
    /*printf("fg=%d  win.tabcolor=%s \n", fg,win.tabcolor[fg]);*/
    if(fg>0){cmd[3]='0';cmd[4]='0';}else return fg;
    j=fg/10; 
    if(j>0){k=fg-10*j;cmd[0]='-';cmd[1]=j+48;cmd[2]=k+48;
    }else{cmd[1]='-';cmd[2]=fg+48;}
    return fg;
}
int plotd_setbgbyname_dsp(int handle, char *color){
/* set foreground color */
    int j,k,bg;
    cmd[0]='-';cmd[3]='0';cmd[4]='0';cmd[5]='\0';
    bg=0;
    while(strcmp(color,win.tabcolor[bg]) !=0 && bg < 64)bg++;
    j=bg/10; 
    if(j>0){k=bg-10*j;cmd[1]=j+48;cmd[2]=k+48;
    }else{cmd[1]=bg+48;cmd[2]=48;}
    return bg;
}
void plotd_polysymbol_dsp(int handle, int pts, symboltyp sym,int x[], int y[]){
   int a1,a2,b1,b2,i,k;
   for (i=0; i<pts; i++)
     for(k=0; k<sym.vec; k++){       
       a1= x[i]+sym.x1[k];			     
       a2= x[i]+sym.x2[k];			     
       b1= y[i]+sym.y1[k];	     
       b2= y[i]+sym.y2[k];
       plotd_line_dsp(handle, a1, b1, a2, b2);
     }
}

void plotd_fillpolygon_dsp(int handle,int pts,XPoint *itmp){
  int i; 
  cmd[0]='f';cmd[3]='3';cmd[4]='4';   
  write_point(cmd,itmp[0].x,itmp[0].y);
  for (i=1; i<pts; i++) write_point("0",itmp[i].x,itmp[i].y);  
}

static void filed_close_dsp(int handle){
   fclose(plotfile);
   file_is_open = FALSE;
}

void plotd_func_dsp(handletyp *h,int vector,int trm){
   int i;

   devsizex= win.sizex[win.ksphandle-1];
   devsizey= win.sizey[win.ksphandle-1];

   rotate=0;
   if((trm == 108 || trm == 76) && devsizex*0.9> devsizey) rotate=1;
   if(rotate)FACTOR=devsizex/A4_Y; else FACTOR=devsizex/A4_X;

   i=strlen(plot.datfile)-2;
   if(i > 0){
    plot.datfile[i]='\0'; 
    strcat(plot.datfile,"apl"); /* allplo format */
   }else{strcat(plot.datfile,"theo.apl");}

   plot.title[79]='\0';
   plotfile = fopen(plot.datfile,"w");
   fprintf(plotfile," %s \n",plot.title);
   fprintf(plotfile," %s \n","x");
   fprintf(plotfile," %s \n","y");

   h->ploth_line         =   plotd_line_dsp;
   h->ploth_polyline     =   plotd_polyline_dsp;
   h->ploth_point        =   plotd_point_dsp;
   h->ploth_linevc       =   plotd_line_dsp;
   h->ploth_polylinevc   =   plotd_polylinevc_dsp;
   h->ploth_pointvc      =   plotd_point_dsp;
   h->ploth_polysymbol   =   plotd_polysymbol_dsp;
   h->ploth_setfgbyname  =   plotd_setfgbyname_dsp;
   h->ploth_setbgbyname  =   plotd_setbgbyname_dsp;
   h->ploth_fillpolygon  =   plotd_fillpolygon_dsp;
   h->fileh_close        =  filed_close_dsp;   

   mirrory=vector;
   /*printf("sizex=%d \n", devsizex);
     printf("sizey=%d \n", devsizey);*/
    }

