
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>            /* string routines             */
#include <math.h>              /* mathematical routines       */
#include <errno.h>
#include <unistd.h>

#include "v_inp.h"
#include "v_inp1.h"
#include <curses.h>
#define PATHSEP '/'
#define DIRCMD "ls"

#define plus  1.0
#define minus  -1.0
#define NUL   0
#define ESC  27
#define LF   10
#define CR   13

extern void trlch16_(int* jnstr ,int *len, float out[], int *iout) ;

int trans(char instr[], float out[]){
 int iout,i,len;
 int  jnstr[132];
 
 len= strlen(instr);
 for(i=0;i<len; i++)jnstr[i]=(int)instr[i];
 trlch16_(jnstr , &len, out, &iout) ;
 return iout;
}


char *mystrerror(int code){
   char *ch;
   ch = strerror(code);
   if (ch == NULL) return " Unknown error ";
   else return ch;
}

static int v_inp_initialized = FALSE;
void init_v_inp(){
    v_inp_initialized = TRUE;
}

#define cuserid(x) "Unknown"
char *proc_username(){
   return (cuserid(NULL));
}


void taste_warten(int wait){
  if (!wait) return;
  printf("\n\t Press any key to continue \n\n");
  read_key();
}


char *readl(char *str, int max, FILE *inf){
/* this is a combination of fgets() and pascal's readln(): We read up to */
/* max characters into str[] and skip the rest of the line,              */
/* Trailing CR and/or LF are deleted                                     */
   char *p, dummy[80];
   p = fgets(str,max,inf);
   if (! p) return NULL;
   p = strchr(str,10);
   if (p) *p=0;
   else while (p==NULL){
      fgets(dummy,80,inf);
      if (feof(inf)) return NULL;
      p = strchr(dummy,10);}
   p = strchr(str,13); if (p) *p=0;
   p = str + strlen(str)-1; while(*p==32){ *p=0; p--; }
   return str;
}

void message(char msg[])
{
   printf("\n %s \n",msg);
   taste_warten(TRUE);
}


int insert(sou,tar,i)
  char sou[],tar[];
  int i;
  { char tmp[200];
    tmp[0] = 0;
    strcpy(tmp,tar);
    tmp[i]=0;
    strcat(tmp,sou);
    strcat(tmp,&tar[i]);
    strcpy(tar,tmp);
    return strlen(tmp);
  }


int strerase(char str[], int index, int count)
{
   str[index] = 0;
   strcat(str, str+index+count);
   return(strlen(str));
}

void directory(char wildcard[]){
   char cmd[80];
   sprintf(cmd,"%s %s",DIRCMD,wildcard);
   system(cmd);
   printf("\n\n");
}

void upstring(char s[]){
   while (s[0]){
      s[0]=toupper(s[0]);
      s++;
   }
}


int change_dir(char newdir[]){
   if (chdir(newdir)==0) return(TRUE);
   printf("\n\tError changing Directory to %s\n",newdir);
   printf("\t%s\n",mystrerror(errno));
   return(FALSE);
}


void get_dir(char path[]){
   getcwd(path,255);
}


void show_dir(){
   char path[255];
   get_dir(path);
   printf(" Actual directory is: %s\n",path);
}

char save_filename[80];

char *last_filename(){ return (save_filename); }
/* Returns a pointer to the last non-empty filename read by get_filename */


void add_extension(char filnam[], char wildcard[]){
/* adds the extension from "wildcard" to "filnam", only if "filnam" */
/* has no extension, e.g. "test" "*.par"  -----> "test.par"         */
   char *p2, *tmp;
   tmp = filnam;
   /* tmp = pointer to separator between path and name in filnam */
   if (strrchr(filnam,PATHSEP)) tmp = strrchr(filnam,PATHSEP);
   if (strrchr(tmp,'.')) return;  /* filnam has already extension */
   /* tmp = pointer to separator between path and name in wildcard */
   tmp = wildcard;
   if (strrchr(wildcard,PATHSEP)) tmp = strrchr(wildcard,PATHSEP);
   /* tmp = pointer to "." in filename part of wildcard */
   p2 = strrchr(tmp,'.');
   if (p2==NULL) return;  /* wildcard has no extension */
   strcat(filnam,p2);
}


int get_key()
{
   char c;
   c = getchar();   /*orig: c=getch();*/
   if (c == LF) return(CR);
   if (c != ESC) return(c);
   if ((getchar()) != '[') return(0);
   switch (
getchar()) {
      case  'A' : return(SMG_K_TRM_UP);
      case  'B' : return(SMG_K_TRM_DOWN);
      case  'C' : return(SMG_K_TRM_RIGHT);
      case  'D' : return(SMG_K_TRM_LEFT);
      default : return(0);
  }
}

int read_key(){
   int c;
/*noecho();
   cbreak();*/
   c = get_key();
/* nocbreak();
   echo();*/
   return(c);
}

void lib_wait(float t){
  int it;
  it = t;
  sleep(it);
}

void vaxdate(char datum[] ){
  time_t t;
  char *ct;
  t = time(NULL);
  ct = ctime(&t);
  strncpy(datum,ct,10);
  datum[10] = 0;
  }

void vaxtime(char zeit[] ){
  time_t t;
  char *ct;
  t = time(NULL);
  ct = ctime(&t);
  strncpy(zeit,ct+11,10);
}




/************************************************************************/
/* trans : get float values from a string                               */
/*         returns : number of values found                             */
/*         instr   : string to be evaluated                             */
/*         out     : array with values                                  */
/************************************************************************/

/* Return nearest integer to x */

int fround(float x)
  { return floor(x+0.5); } 

int transOO(instr, out)

/* This procedure looks how many numerical values are in "instr" */
/* It returns the number of values and the values in "out". 
   Since gcc 7.3.0 the routine does not work reproducable. 
   The line  x = (int)(strchr(ich,instr[k]) - ich + 1);
   has been replaced by while and if m runs up to 18 it is 
   set t0 5 ^ to a blank. The termination by NUL has been replaced by 'T'.
   This way it works fo the Strings from MODEL.SYM: No explanation!!    
   routine is replaced by encapsulated old fortran routine trlch16 
   reduced from 32 to 16 values.
  */
  char instr[];
  float out[];
  { char *ich = ".-+Ee 0123456789";
    char jch[] =".-+Ee 0123456789";
    int nnum,nex,x,k,f,l,m,j,iout;
    float pt,nsig;
    //  strcat(instr," "); /* terminating blank */
    j=strlen(instr); //printf("len=%i \n",j);
    instr[j]='T';  instr[j+1]=NUL;
    nsig = plus; pt = 1.0; nex = nnum = iout=0;
    for (k = 0; k < 16; k++) out[k] = 0.0;   /* initialize out       */
    for (k = 0; (instr[k] != 'T') ; k++)   /* scan instr until NUL */
    { if (iout > 15) break;                /* outarray full        */

      //x = (int)(strchr(ich,instr[k]) - ich + 1);
 m=0;
 while(jch[m] != instr[k] && m < 18) m=m+1;
 if(m==18)m=5;
 //printf("k=%i  instr[k]=%c      x=%i    m=%i\n",k,instr[k],x, m);
 x=m+1; if(x>16)x=16;   
 if (x >= 7)
       { nnum=1;
        if (pt > 0.9) out[iout] = out[iout]*10.0 + (x-7);
        else
        { out[iout] += ((x-7)*pt);
          pt /= 10;
	}}
 //          printf("iout=%i  out=%f  \n",iout,out[iout]);
      if (x == 1) pt=0.1;
      if (x == 2) nsig=minus;
      if ((x != 1) && (x < 7))
      { if (nnum)
          { out[iout] *= nsig;
            if (out[iout] >= 1.0) out[iout] += 1.0E-9;

            nsig=plus; nnum=0; pt=1.0;
            if (nex)
            { if (iout)
              { f = fround(out[iout]);

                if (f > 0){ for (l=1; l <= f; l++)
                  out[iout-1] *= 10.0;

                }else for (l= -1; l >= f; l--)
                  out[iout-1] /=  10.0;
              }
              nex=0; out[iout]=0; iout=iout-1;
            }

            iout++;

          }
          if (((x == 4) || (x == 5)) && (iout > 0) &&
	      (strchr(" .0123456789",instr[k-1]))) nex=1;
  }}
  return iout;
}


