      subroutine frame(chx,chbx,chlr,chy,chby,chbt,l_logx,l_logy,       &
                       chh,chw,syw,syh,                                 &
                      CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)
      use glbconst, only: maxsub,maxs,maxn,infplot,MDBPLFT
      implicit none 
                                                                        
!     plottet Rahmen fuer ALLPLO                                        
!     legt Zeichenhoehe etc. fest                                       
!     bestimmt Ursprung                                                 
!                                                                       
!     M. Alflen 12.9.89                                                 
!                                                                       
!     erweitert fuer durchbrochene Achsen  ( ab Version 1.1 )           
!     M. Alflen 14.12.89                                                
!     adaptiert fuer EFFI  2008                                         

      character(len=1), intent(in):: chx,chbx,chlr,chy,chby,chbt
      character(len=80),intent(in):: CTEXT,CXTEXT,CYTEXT
      character(len=24),intent(in):: frcolor,bgcolor
      real,             intent(in):: chh,chw,syw,syh 
      integer,          intent(in):: nformx,nformy

      integer,parameter ::idum1=5*infplot+maxsub+201,                  &
                          max16=maxn*16, max112=maxn*112,              &
                          idum2=MDBPLFT*2-176*maxn-8*39-idum1-14*33         
      character(len=132):: allbat 
      character(len=4)  :: cdum,chdum1,chdum2
      character(len=24) :: tabcolor
      real        parray,xyzdz,vtxt,vtxtp 
      integer     ifeder,int3d,npnt3d,ltext
      common/plot/parray(max112),xyzdz(8),vtxt(2,max16),vtxtp(8,32), &
                  int3d(maxn*16),npnt3d(16),ifeder(max16),ltext(32),   &
                  chdum1(idum1),allbat(14),chdum2(idum2)                
      common/win/ cdum(19*maxs+22),tabcolor(64) 
                                                                        
      real          xrand,yrand,gx,gy,hx,hy,sw,sh,pen,xorg,yorg,        &
                    xanfsc,xendsc,xstep,yanfsc,yendsc,ystep,            &
                    xoff_l,xoff_r,yoff_b,yoff_t                         
      integer       ixt,iyt,IX,IY,ixscp10,iyscp10 
      common/aplplt/xrand,yrand,gx,gy,hx,hy,sw,sh,pen,xorg,yorg,        &
                    xanfsc,xendsc,xstep,yanfsc,yendsc,ystep,            &
                    xoff_l,xoff_r,yoff_b,yoff_t,                        &
                    ixt,iyt,IX,IY,ixscp10,iyscp10                       
                                                                        
      real          xanf,xend,yanf,yend,a_xanf,a_xend,a_yanf,a_yend,    &
                    hlog10                                              
      common/scl/   xanf,xend,yanf,yend,a_xanf,a_xend,a_yanf,a_yend,    &
                    hlog10                                              
                                                                        
      logical       l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,    &
                    l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t
      real          b_wid,b_x,b_y,b_off,xd,yd,pos_x,pos_y,wid_x,heig_y 
      common/plfr/  l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,    &
                    l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t,    &
                    b_wid,b_x,b_y,b_off,xd,yd,pos_x,pos_y,wid_x,heig_y  

      character(len=1),dimension(24):: cnum 
      character(len=1)  :: ch0,chlogx,chlogy
      integer       npenfr,npendg,jcw,i,j,k,nnum,nc                             
      logical       l_xaxb,l_xaxt,l_yaxl,l_yaxr,l_logx,l_logy 
      real          xbot,ybot,xtop,ytop,xscal,yscal,genau,xlow,yup,off
       
       call scaling(xyzdz(1),xyzdz(2),0,xanf,xend,xbot,i)  ! x-Skala   
       if(abs((xend-xyzdz(2))/xbot).gt.0.5)xend=xyzdz(2)+0.1*xbot 
       if(abs((xanf-xyzdz(1))/xbot).gt.0.5)xanf=xyzdz(1)-0.1*xbot 

       call scaling(xyzdz(3),xyzdz(4),0,yanf,yend,xbot,i)  ! y-Skala   
       if(abs((yend-xyzdz(4))/xbot).gt.0.5)yend=xyzdz(4)+0.1*xbot 
       if(abs((yanf-xyzdz(3))/xbot).gt.0.5)yanf=xyzdz(3)-0.1*xbot 
                                                                        
!------some strings for allplo.bat file stored in common/plot/-------   
!    color frame             [black]       color background  [yellow]   
!x-axis                              (none,Both,bottom,top)  [B]        
!    break(none,bottom,top)  [n]               (left,right)  [l]        
!y-axis                              (none,Both,left,right)  [B]        
!    break(none,left,right)  [n]               (bottom,top)  [b]        
      ch0=char(0) 
      i=index(frcolor,ch0)-1 
      j=index(bgcolor,ch0)-1 
      allbat(1)='    color frame             ['//frcolor(1:i)//         &
     & ']       color background   ['//bgcolor(1:j)//']'                 
      allbat(2)='x-axis                              (none,Both,'//     &
     & 'bottom,top)  ['//chx//']'                                       
      allbat(3)='    break(none,bottom,top)  ['//chbx//                 &
     & ']               (left,right)  ['//chlr//']'                     
      allbat(4)='y-axis                              (none,Both,'//     &
     & 'left,right)  ['//chy//']'                                       
      allbat(5)='    break(none,left,right)  ['//chby//                 &
     & ']               (bottom,top)  ['//chbt//']'                     
                                                                        
!    title (*...=no, #=fdf)  [title]                                    
!    name of x-axis (#=fdf)  [log(channel)]                             
      !    name of y-axis (#=fdf)  [counts]
      allbat(6)='    title (*...=no, #=fdf)  ['//TRIM(CTEXT)//']' 
      allbat(7)='    name of x-axis (#=fdf)  ['//TRIM(CXTEXT)//']' 
      allbat(8)='    name of y-axis (#=fdf)  ['//TRIM(CYTEXT)//']' 
                                                                        
!-------------------------8 strings allbat()----------------------------
                                                                        
!     origin  x,y                [0.00,0.00]    width xw,yw [16.00,10.00
       xorg=0.                  ! origin
       yorg=0. 
       gx=19.                   ! frame size  400x250 pixel 
       gy=10. 
!    pen number (0..)       [0]   color background (0...)   [0]          
!    borderwidth xd,yd      [0.40,0.40]  character cw,ch        [0.40,0.
      hy=chh                ! character height
      hx=chw                ! character width 
      xd=hx 
      yd=hy 
      sh=syh                ! symbol height
      sw=syw                ! symbol width
      pen=0.03              ! pen size  
      hlog10=alog(10.0)     !  basis 10 
!    x-axis (none,Both,bottom,top)                         [b]          

       if(chx.eq.'n') then ! none 
        l_xaxb=.false. 
        l_xaxt=.false. 
       else if(chx.eq.'B') then 
        l_xaxb=.true. 
        l_xaxt=.true. 
       else if(chx.eq.'b') then 
        l_xaxb=.true. 
        l_xaxt=.false. 
       else if(chx.eq.'t') then 
        l_xaxb=.false. 
        l_xaxt=.true. 
       end if 
                                                                        
!    break(none,bottom,top) [b]             (left,right) [l]            
       if(chbx.eq.'n') then 
        xoff_l=xd 
        xoff_r=xd 
        l_x_br_bo_l=.false. 
        l_x_br_bo_r=.false. 
        l_x_br_to_l=.false. 
        l_x_br_to_r=.false. 
       else if(chbx.eq.'b') then 
        if(chlr.eq.'l')then 
         xoff_l=2.*xd 
         xoff_r=xd 
         l_x_br_bo_l=.true. 
         l_x_br_bo_r=.false. 
        else if(chlr.eq.'r')then 
         xoff_l=xd 
         xoff_r=2.*xd 
         l_x_br_bo_l=.false. 
         l_x_br_bo_r=.true. 
        end if 
       else if(chbx.eq.'t') then 
        if(chlr.eq.'l')then 
         xoff_l=2.*xd 
         xoff_r=xd 
         l_x_br_to_l=.true. 
         l_x_br_to_r=.false. 
        else if(chlr.eq.'r')then 
         xoff_l=xd 
         xoff_r=2.*xd 
         l_x_br_to_l=.false. 
         l_x_br_to_r=.true. 
        end if 
       end if 
                                                                        
!     y-axis (none,Both,left,right)                         [B]         
       if(chy.eq.'n') then 
        l_yaxl=.false. 
        l_yaxr=.false. 
       else if(chy.eq.'B') then 
        l_yaxl=.true. 
        l_yaxr=.true. 
       else if(chy.eq.'l') then 
        l_yaxl=.true. 
        l_yaxr=.false. 
       else if(chy.eq.'r') then 
        l_yaxl=.false. 
        l_yaxr=.true. 
       end if 
                                                                        
!    break(none,left,right) [n]             (bottom,top) [b]            
                                                                        
      if(chby.eq.'n') then 
       yoff_t=yd 
       yoff_b=yd 
       l_y_br_le_b=.false. 
       l_y_br_le_t=.false. 
       l_y_br_ri_b=.false. 
       l_y_br_ri_t=.false. 
      else if(chby.eq.'l') then 
       if(chbt.eq.'b') then 
        yoff_t=yd 
        yoff_b=2.*yd 
        l_y_br_le_b=.true. 
        l_y_br_le_t=.false. 
       else if(chbt.eq.'t') then 
        yoff_t=2.*yd 
        yoff_b=yd 
        l_y_br_le_b=.false. 
        l_y_br_le_t=.true. 
       end if 
      else if(chby.eq.'r') then 
       if(chbt.eq.'b') then 
       yoff_t=yd 
       yoff_b=2.*yd 
       l_y_br_ri_b=.true. 
       l_y_br_ri_t=.false. 
       else if(chbt.eq.'t') then 
        yoff_t=2.*yd 
        yoff_b=yd 
        l_y_br_ri_b=.false. 
        l_y_br_ri_t=.true. 
       end if 
      end if 
                                                                        
                                ! none                                  
       if(chx.eq.'n') then 
        yrand=yd 
       else if(chx.eq.'B'.or.chx.eq.'b') then 
        yrand=yd+7.*hx 
       else if(chx.eq.'t') then 
        yrand=yd 
        off=yd+7.*hx+3*hy 
       end if 
                                                                        
       off=0. 
       xrand=xd 
       if(chy.eq.'B'.or.chy.eq.'l') then 
        xrand=yd 
        off=xd+4.*hx+3*hy 
       else if(chy.eq.'r') then 
        xrand=yd+7.*hx +3*hy 
       end if 
                                                                        
       a_xanf=-xorg+xrand+xd 
       a_xend=-xorg+xrand+xd+gx
       a_yanf= yorg+yrand+yd 
       a_yend= yorg+yrand+yd+gy 
       xtop=-1.e6 
       ytop=-1.e6 
       xbot=1.e6 
       ybot=1.e6 
                                                                        
       npenfr=0 
       i=1 
       do while(i.lt.64) 
        j=index(tabcolor(i),char(0)) 
!       write(6,'(a,i4)')tabcolor(i),j                                  
        if(frcolor(1:j-1).eq.tabcolor(i)(1:j-1))then 
         npenfr=i-1 
         i=64 
        end if 
        i=i+1 
       end do 
       npendg=npenfr 
!       write(6,'(2a,i4)')frcolor,' npenfr=',npenfr                     
                                                                        
      ltext=0 
                                                                        
!     start plot                                                        
      xbot=yrand 
      ybot=xrand 
      xtop=yrand+gy+yoff_b+yoff_t 
      ytop=xrand+gx+xoff_l+xoff_r 
                                                                        
                                                                        
      ytop=(ytop+off) 
      if(ytop/xtop.lt.1.6) ytop=xtop*1.6 
!      write(6,'(a,4f10.2)')'xbot,ybot,xtop,ytop=',xbot,ybot,xtop,ytop  
                                                                        
      jcw=0 
      do i=1,8 
       vtxtp(i,1)=0. 
      end do 
      vtxtp(4,1)=xorg 
      vtxtp(5,1)=yorg 

      call plotframe(l_xaxb,l_xaxt,l_yaxl,l_yaxr,npenfr,jcw) 
                                                                       
!      write(6,'(2f10.2,2x,i4)')(vtxt(1,i),vtxt(2,i),ifeder(i),i=1,jcw) 
      ifeder(jcw+1)=-1 
                                                                        
      xscal=gx/(xend-xanf)  ! x-scaling  
      yscal=gy/(yend-yanf)  ! y-scaling  
      genau=1.0e-4 
      xlow=gx+xrand+xoff_r+genau  ! x-plot range ( plot coo's )  
      yup=yrand+yoff_b-genau 
                                                                        
      xyzdz(5)=xanf+xlow/xscal 
      xyzdz(6)=-ytop/xscal 
      xyzdz(7)=yanf-yup/yscal 
      xyzdz(8)=+ytop/yscal 
                                                                        
                                                                        
      call axsclticks(l_xaxb,l_xaxt,l_yaxl,l_yaxr,l_logx,l_logy,        &
                                nformx,nformy,npenfr,jcw)              


      ltext(1)=jcw 
      do i=1,jcw 
       vtxt(1,i)=vtxt(1,i)/ytop 
       vtxt(2,i)=vtxt(2,i)/ytop 
      end do 
                                                                        
                                                                        
       call axscltext(l_xaxb,l_xaxt,l_yaxl,l_yaxr,l_logx,l_logy,         &
                       CTEXT,CXTEXT,CYTEXT,nformx,nformy,npendg)          
                                                                        
!      write(6,'(a,20i5)')' ltext=',ltext                               
       j=1 
       do while(ltext(j).ne.0.and.j.lt.32) 
        j=j+1 
       end do 
       jcw=ltext(j-1) 
      do i=ltext(1)+1,jcw 
       vtxt(1,i)=vtxt(1,i)/ytop 
       vtxt(2,i)=vtxt(2,i)/ytop 
      end do 
      do i=1,j-1 
       vtxtp(4,i)=vtxtp(4,i)/ytop 
       vtxtp(5,i)=vtxtp(5,i)/ytop 
      end do 
      ifeder(jcw+1)=-1 
!--------------------------allbat------------------------------         
                                                                        
!     allbat(9)                                                         
      chlogx='n' 
      if(l_logx)chlogx='y' 
                                                                        
      call numero(xyzdz(1),2,cnum,nnum,0,0) 
      allbat(9)='    x-range(' 
      k=12 
      do i=1,nnum 
       j=k+i 
       allbat(9)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(9)(k:k)=',' 
      call numero(xyzdz(2),2,cnum,nnum,0,0) 
      do i=1,nnum 
       j=k+i 
       allbat(9)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(9)(k:k)=')' 
      allbat(9)(k+1:28)=' ' 
      allbat(9)(29:29)='[' 
      call numero(xanf,2,cnum,nnum,0,0) 
      k=29 
      do i=1,nnum 
       j=k+i 
       allbat(9)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(9)(k:k)=',' 
      call numero(xend,2,cnum,nnum,0,0) 
      do i=1,nnum 
       j=k+i 
       allbat(9)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(9)(k:k)=']' 
      allbat(9)(k+1:44)=' ' 
      allbat(9)(45:)='(log scale y/n) ['//chlogx//']' 
      allbat(10)='    scale(l,r,step,tics,pw) [' 
      call numero(xanfsc,nformx,cnum,nnum,0,0) 
      k=29 
      do i=1,nnum+2 
       j=k+i 
       allbat(10)(j:j)=cnum(i) 
      end do 
      k=j 
      call numero(xendsc,nformx,cnum,nnum,0,0) 
      do i=1,nnum+2 
       j=k+i 
       allbat(10)(j:j)=cnum(i) 
      end do 
      k=j 
      call numero(xstep,nformx,cnum,nnum,0,0) 
      do i=1,nnum+2 
       j=k+i 
       allbat(10)(j:j)=cnum(i) 
      end do 
      call numero(float(ixt),0,cnum,nnum,0,0) 
      k=j 
      do i=1,nnum+2 
       j=k+i 
       allbat(10)(j:j)=cnum(i) 
      end do 
      call numero(float(ixscp10),0,cnum,nnum,0,0) 
      k=j 
      do i=1,nnum+2 
       j=k+i 
       allbat(10)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(10)(k:k)=']' 
                                                                        
!     allbat(11)                                                        
      chlogy='n' 
      if(l_logy)chlogy='y' 
      nc=2 
      call numero(xyzdz(3),nc,cnum,nnum,0,0) 
      if(nnum.ge.8)nc=-2 
      call numero(xyzdz(3),nc,cnum,nnum,0,0) 
      allbat(11)='    y-range(' 
      k=12 
      do i=1,nnum 
       j=k+i 
       allbat(11)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(11)(k:k)=',' 
      call numero(xyzdz(4),nc,cnum,nnum,0,0) 
      do i=1,nnum 
       j=k+i 
       allbat(11)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(11)(k:k)=')' 
      if(k+1.le.28)then 
       allbat(11)(k+1:28)=' ' 
       allbat(11)(29:29)='[' 
       k=29 
      else 
       k=k+1 
       allbat(11)(k:k)='[' 
      end if 
      call numero(yanf,nc,cnum,nnum,0,0) 
                                                                        
      do i=1,nnum 
       j=k+i 
       allbat(11)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(11)(k:k)=',' 
      call numero(yend,nc,cnum,nnum,0,0) 
      do i=1,nnum 
       j=k+i 
       allbat(11)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(11)(k:k)=']' 
      if(k+1.le.45)then 
       allbat(11)(k+1:45)=' ' 
       allbat(11)(46:)='(log scale y/n)['//chlogx//']' 
      else 
       k=k+1 
       allbat(11)(k:)='(log scale y/n)['//chlogx//']' 
      end if 
                                                                        
      allbat(12)='    scale(l,u,step,tics,pw) [' 
      call numero(yanfsc,nformy,cnum,nnum,0,0) 
      k=29 
      do i=1,nnum+2 
       j=k+i 
       allbat(12)(j:j)=cnum(i) 
      end do 
      k=j 
      call numero(yendsc,nformy,cnum,nnum,0,0) 
      do i=1,nnum+2 
       j=k+i 
       allbat(12)(j:j)=cnum(i) 
      end do 
      k=j 
      call numero(ystep,nformy,cnum,nnum,0,0) 
      do i=1,nnum+2 
       j=k+i 
       allbat(12)(j:j)=cnum(i) 
      end do 
      k=j 
      call numero(float(iyt),0,cnum,nnum,0,0) 
      do i=1,nnum+2 
       j=k+i 
       allbat(12)(j:j)=cnum(i) 
      end do 
      k=j 
      call numero(float(iyscp10),0,cnum,nnum,0,0) 
      do i=1,nnum+2 
       j=k+i 
       allbat(12)(j:j)=cnum(i) 
      end do 
      k=j+1 
      allbat(12)(k:k)=']' 
      allbat(13)='    inscription               (normal,top,'//         &
           'bottom,inverted)  ['//chx//']'
      allbat(14)='    inscription               (normal,left,'//        &
                 'right,inverted)  ['//chy//']'
       return 
!                                                                       
      END                                           
                                                                        
!c A.Vef, 8.8.94 : Modifikationen im ganzen Modul:                      
!c es waren einige Abfragen der Form "if (undefinierte variable)...     
!c vorhanden. Diese wurden rauskommentiert und mit >> markiert.         
!c Wenn sonst mal ein Betriebssystem lokale Variablen nicht initialisier
!c geht alles schief...                                                 
!c                                                                      
                                                                        
     subroutine plotframe(l_xaxb,l_xaxt,l_yaxl,l_yaxr,npenfr,jcw) 
     implicit none 
     logical       l_xaxb,l_xaxt,l_yaxl,l_yaxr 
     integer       npenfr,jcw 
                                                                       
     logical       l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,    &
                   l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t     
     real          b_wid,b_x,b_y,b_off,xd,yd,pos_x,pos_y,wid_x,heig_y 
     common/plfr/  l_x_br_bo_l,l_x_br_bo_r,l_x_br_to_l,l_x_br_to_r,    &
                   l_y_br_le_b,l_y_br_le_t,l_y_br_ri_b,l_y_br_ri_t,    &
                   b_wid,b_x,b_y,b_off,xd,yd,pos_x,pos_y,wid_x,heig_y  
                                                                       
     real          xrand,yrand,gx,gy,hx,hy,sw,sh,pen,xorg,yorg,        &
                   xanfsc,xendsc,xstep,yanfsc,yendsc,ystep,            &
                   xoff_l,xoff_r,yoff_b,yoff_t                         
     integer       ixt,iyt,IX,IY,ixscp10,iyscp10,npenup 
     common/aplplt/xrand,yrand,gx,gy,hx,hy,sw,sh,pen,xorg,yorg,        &
                   xanfsc,xendsc,xstep,yanfsc,yendsc,ystep,            &
                   xoff_l,xoff_r,yoff_b,yoff_t,                        &
                   ixt,iyt,IX,IY,ixscp10,iyscp10                       
                                                                       
      npenup=-1 
      if (l_xaxb .or. l_xaxt .or. l_yaxl .or. l_yaxr) then 
       if ( l_xaxb) then                          ! bottom x-axis   
        pos_x=xrand 
      pos_y=yrand 
      wid_x=gx+xoff_l+xoff_r 
      call traa(pos_y,pos_x,npenup,jcw) 
        if ( l_x_br_bo_l .or. l_x_br_bo_r) then    ! break bottom x-axis
         b_wid=xd/3. 
       b_x=xd*.15 
         b_y=yd*.7 
       if ( l_x_br_bo_r ) b_off=xd      ! break right side  
         if ( l_x_br_bo_l ) b_off=wid_x-(1.+1/3.)*xd ! break left side  
         call traa(pos_y,pos_x+b_off,npenfr,jcw) 
         call traa(pos_y-b_y,pos_x+b_off+b_x,npenup,jcw) 
         call traa(pos_y+b_y,pos_x+b_off-b_x,npenfr,jcw) 
       b_off=b_off+b_wid 
         call traa(pos_y-b_y,pos_x+b_off+b_x,npenup,jcw) 
         call traa(pos_y+b_y,pos_x+b_off-b_x,npenfr,jcw) 
         call traa(pos_y,pos_x+b_off,npenup,jcw) 
         call traa(pos_y,pos_x+wid_x,npenfr,jcw) 
      else 
         call traa(pos_y,pos_x+wid_x,npenfr,jcw) 
      end if 
       end if 
       if ( l_yaxl ) then                 ! plot left y-axis  
        pos_x=xrand+gx+xoff_r+xoff_l 
        pos_y=yrand 
!       write(6,'(a,2f10.2)')'left-axis px,py=',pos_x,pos_y             
        heig_y=gy+yoff_t+yoff_b 
        call traa(pos_y,pos_x,npenup,jcw) 
        if ( l_y_br_le_b .or. l_y_br_le_t) then  ! break left y-axis 
         b_wid=yd/3. 
       b_x=xd*.7 
         b_y=yd*.15 
       if ( l_y_br_le_b ) b_off=yoff_b/2. 
         if ( l_y_br_le_t ) b_off=heig_y-yoff_t/2.-b_wid 
         call traa(pos_y+b_off,pos_x,npenfr,jcw) 
         call traa(pos_y+b_off-b_y,pos_x+b_x,npenup,jcw) 
         call traa(pos_y+b_off+b_y,pos_x-b_x,npenfr,jcw) 
       b_off=b_off+b_wid 
         call traa(pos_y+b_off-b_y,pos_x+b_x,npenup,jcw) 
         call traa(pos_y+b_off+b_y,pos_x-b_x,npenfr,jcw) 
         call traa(pos_y+b_off,pos_x,npenup,jcw) 
         call traa(pos_y+heig_y,pos_x,npenfr,jcw) 
      else 
         call traa(pos_y+heig_y,pos_x,npenfr,jcw) 
      end if 
       end if 
       if ( l_xaxt) then     ! top x-axis 
        pos_x=xrand+gx+xoff_l+xoff_r 
        pos_y=yrand+gy+yoff_b+yoff_t 
        wid_x=-(gx+xoff_l+xoff_r) 
        call traa(pos_y,pos_x,npenup,jcw) 
        if ( l_x_br_to_r .or. l_x_br_to_l) then    ! break top x-axis 
!         write(6,'(a,2f10.2)')' break top x-axis ',pos_x,pos_y         
         b_wid=-xd/3. 
       b_x=xd*.15 
         b_y=yd*.7 
       if ( l_x_br_to_l ) b_off=-xoff_l/2.    ! break left side 
         if ( l_x_br_to_r ) b_off=wid_x+0.5*xoff_r-b_wid ! break right s
         call traa(pos_y,pos_x+b_off,npenfr,jcw) 
         call traa(pos_y-b_y,pos_x+b_off+b_x,npenup,jcw) 
         call traa(pos_y+b_y,pos_x+b_off-b_x,npenfr,jcw) 
       b_off=b_off+b_wid 
         call traa(pos_y-b_y,pos_x+b_off+b_x,npenup,jcw) 
         call traa(pos_y+b_y,pos_x+b_off-b_x,npenfr,jcw) 
         call traa(pos_y,pos_x+b_off,npenup,jcw) 
         call traa(pos_y,pos_x+wid_x,npenfr,jcw) 
      else 
         call traa(pos_y,pos_x+wid_x,npenfr,jcw) 
      end if 
       end if 
       if ( l_yaxr ) then  ! plot right y-axis  
        pos_x=xrand 
        pos_y=yrand+gy+yoff_t+yoff_b 
        heig_y=-(gy+yoff_t+yoff_b) 
      call traa(pos_y,pos_x,npenup,jcw) 
        if ( l_y_br_ri_b .or. l_y_br_ri_t) then    ! break right y-axis 
         b_wid=-yd/3. 
       b_x=xd*.7 
         b_y=yd*.15 
       if ( l_y_br_ri_t ) b_off=-yoff_t/2   ! top break 
         if ( l_y_br_ri_b ) b_off=heig_y+yoff_b/2.-b_wid ! bottom break 
         call traa(pos_y+b_off,pos_x,npenfr,jcw) 
         call traa(pos_y+b_off-b_y,pos_x+b_x,npenup,jcw) 
         call traa(pos_y+b_off+b_y,pos_x-b_x,npenfr,jcw) 
       b_off=b_off+b_wid 
         call traa(pos_y+b_off-b_y,pos_x+b_x,npenup,jcw) 
         call traa(pos_y+b_off+b_y,pos_x-b_x,npenfr,jcw) 
         call traa(pos_y+b_off,pos_x,npenup,jcw) 
         call traa(pos_y+heig_y,pos_x,npenfr,jcw) 
                                ! no break                              
      else 
         call traa(pos_y+heig_y,pos_x,npenfr,jcw) 
      end if 
       end if 
      end if  ! l_frame 
      return 
      END                                           
                                                                        
                                                                        
     subroutine axsclticks(l_xaxb,l_xaxt,l_yaxl,l_yaxr,l_logx,l_logy,  &
                                            nformx,nformy,npenfr,jcw) 
     implicit none 
!    plottet Achsen-Beschriftung und Textzeile                         
!    M. Alflen 15.12.89                                                
!      erweitert um variablen offset zwischen Rahmen und Plot                
!    Modifiziert: A.Vef, 12.11.90                                      
!    adaptiert fuer EFFI  2008   spi                                   

     logical       l_xaxb,l_xaxt,l_yaxl,l_yaxr,l_logx,l_logy 
     integer       nformx,nformy,npenfr,jcw 
                                                                       
     real          xrand,yrand,gx,gy,hx,hy,sw,sh,pen,xorg,yorg,        &
                   xanfsc,xendsc,xstep,yanfsc,yendsc,ystep,            &
                   xoff_l,xoff_r,yoff_b,yoff_t                         
     integer       ixt,iyt,IX,IY,ixscp10,iyscp10 
     common/aplplt/xrand,yrand,gx,gy,hx,hy,sw,sh,pen,xorg,yorg,        &
                   xanfsc,xendsc,xstep,yanfsc,yendsc,ystep,            &
                   xoff_l,xoff_r,yoff_b,yoff_t,                        &
                   ixt,iyt,IX,IY,ixscp10,iyscp10                       
                                                                       
     real          xanf,xend,yanf,yend,a_xanf,a_xend,a_yanf,a_yend,    &
                   hlog10                                              
     common/scl/  xanf,xend,yanf,yend,a_xanf,a_xend,a_yanf,a_yend,     &
                   hlog10                                              
                                                                       
     logical       l_xtck,l_xtckb,l_xtckt,l_ytck,l_ytckl,l_ytckr 
     integer       ixtck,iytck,i,j,npenup 
     real          old,h,xbeg,absx,xscal,xoffset,xbck,x,               &
                         ybeg,absy,yscal,yoffset,ybck,y                     
     real,dimension(20):: xtick,ytick 
                                                                       
       npenup=-1 
       ixtck=1                      ! Achsen-Ticks an 
       iytck=1 
       l_xtck=.true. 
       l_ytck=.true. 
       if (l_xaxb .and. l_xaxt) then 
!       normale x-Achsen-Skalierung                                     
        l_xtckb=.true. 
        l_xtckt=.true. 
       else if (l_xaxb) then 
!       untere x-Achsen-Skalierung                                      
        l_xtckb=.true. 
        l_xtckt=.false. 
       else if (l_xaxt) then 
!       obere x-Achsen-Skalierung                                       
        l_xtckb=.false. 
        l_xtckt=.true. 
       else                         ! no ticks on x-axis 
        l_xtckt=.false. 
        l_xtckb=.false. 
        l_xtck=.false. 
        ixtck=0 
       end if 
                                                                        
       if (l_yaxl .and. l_yaxr) then 
!       normale y-Achsen-Skalierung                                     
        l_ytckl=.true. 
        l_ytckr=.true. 
       else if (l_yaxl) then 
!       linke y-Achsen-Skalierung                                       
        l_ytckl=.true. 
        l_ytckr=.false. 
       else if (l_yaxr) then 
!       rechte y-Achsen-Skalierung                                      
        l_ytckl=.false. 
        l_ytckr=.true. 
       else 
        l_ytckl=.false.              ! no ticks on y-axis 
        l_ytckr=.false. 
        l_ytck=.false. 
        iytck=0 
       end if 
                                                                        
                                                          ! x-Skala     
       call scaling(xanf,xend,1,xanfsc,xendsc,xstep,ixt) 
       if(abs(xstep).lt.1.)then 
        h=-alog(abs(xstep))/2.3025851 
        if(h.gt.int(h))h=h+1 
        nformx=int(h) 
       end if 
                                                                        
                                                                        
       if(l_logx)then 
        ixt=10 
        i=int(ABS(XENDSC)) 
        xendsc=sign(i,int(XENDSC)) 
        i=int(ABS(XANFSC)) 
        xanfsc=sign(i,int(XANFSC)) 
        xstep=sign(1.,xstep) 
       end if 
       if(abs((xanf-xanfsc)/xstep).gt.0.95)xanfsc=xanfsc-xstep 
       ABSX= ABS((XENDSC-XANFSC)/XSTEP) 
       IX = IFIX(ABSX+.5) + 1 
                                                                        
       call scaling(yanf,yend,1,yanfsc,yendsc,ystep,iyt)  ! y-Skala
       if(abs(ystep).lt.1.)then 
        h=-alog(abs(ystep))/2.3025851 
        if(h.gt.int(h))h=h+1 
        nformy=int(h) 
       end if 
                                                                        
       if(l_logy)then 
        IYT=10 
        i=int(ABS(YENDSC)) 
        yendsc=sign(i,int(YENDSC)) 
        i=int(ABS(YANFSC)) 
        yanfsc=sign(i,int(YANFSC)) 
        ystep=sign(1.,ystep) 
       end if 
       if(abs((yanf-yanfsc)/ystep).gt.0.95)yanfsc=yanfsc-ystep 
       ABSY= ABS((YENDSC-YANFSC)/YSTEP) 
       IY = IFIX(ABSY+.5) + 1 
                                                                        
       OLD=0. 
       XBCK=0. 
       YBCK=0. 
       if(IX.gt.20)IX=20 
       if(IY.gt.20)IY=20 
                                                                        
!      write(6,'(a,6f12.2)')'XEND,XENDSC,YANF,YANFSC,xscal,yscal=',     
!     &       XEND,XENDSC,YANF,YANFSC,xscal,yscal                       
                                                                        
!************************plot ticks of x-axis***************************
      XOFFSET=XEND-XENDSC 
      xscal=gx/(xend-xanf) 
      xbeg=XRAND+xoff_r 
!**************************** top x-axis********************************
                                                                        
      IF (l_xtckt) then 
       Y=YRAND+yoff_b+yoff_t+gy 
       DO  I=IX,1,-1 
        if(l_logx)then 
         h= (I-1)*XSTEP 
         X=xbeg+XSCAL*(h+XOFFSET) 
         do j=1,IXT-1 
          h=(I-1)*XSTEP-alog(float(j)/IXT)/hlog10*XSTEP 
          xtick(j)=xbeg+XSCAL*(h+XOFFSET) 
         end do 
        else 
         X=xbeg+XSCAL*((I-1)*XSTEP+XOFFSET) 
        end if 
        if(X.gt.xbeg)then 
         CALL TRAA (Y,X,npenup,jcw) 
         CALL TRAA (Y-HY/2.,X,npenfr,jcw) 
        end if 
                                                                        
        IF (I.ne.IX) then 
         DO  j=1,IXT-1 
          X=X+XSTEP*XSCAL/IXT 
          if(l_logx)then 
           X=xtick(J) 
           if(xtick(J).gt.xbeg)then 
            CALL TRAA (Y,X,npenup,jcw) 
            CALL TRAA (Y-HY/4.,X,npenfr,jcw) 
           end if 
          else 
            CALL TRAA (Y,X,npenup,jcw) 
            CALL TRAA (Y-HY/4.,X,npenfr,jcw) 
          end if 
         END DO 
        END IF 
       END DO 
      END IF 
!*************************** bottom x-axis******************************
      IF (l_xtckb) then 
       Y=YRAND 
       DO  I=IX,1,-1 
        if(l_logx)then 
         h= (I-1)*XSTEP 
         X=xbeg+XSCAL*(h+XOFFSET) 
         do j=1,IXT-1 
          h=(I-1)*XSTEP-alog(float(j)/IXT)/hlog10*XSTEP 
          xtick(j)=xbeg+XSCAL*(h+XOFFSET) 
         end do 
        else 
         X=xbeg+XSCAL*((I-1)*XSTEP+XOFFSET) 
        end if 
        if(X.gt.xbeg)then 
         CALL TRAA (Y,X,npenup,jcw) 
         CALL TRAA (Y+HY/2.,X,npenfr,jcw) 
        end if 
                                                                        
        IF (I.ne.IX) then 
         DO  j=1,IXT-1 
          X=X+XSTEP*XSCAL/IXT 
          if(l_logx)then 
           X=xtick(J) 
           if(xtick(J).gt.xbeg)then 
            CALL TRAA (Y,X,npenup,jcw) 
            CALL TRAA (Y+HY/4.,X,npenfr,jcw) 
           end if 
          else 
            CALL TRAA (Y,X,npenup,jcw) 
            CALL TRAA (Y+HY/4.,X,npenfr,jcw) 
          end if 
         END DO 
        END IF 
       END DO 
      END IF 
                                                                        
!*************************plot ticks of y-axis**************************
      YOFFSET=-(YANF-YANFSC) 
      ybeg=YRAND+yoff_b 
      yscal=gy/(yend-yanf) 
                                                                        
!************************ left y-axis***********************************
      IF (l_ytckl) then 
       X=XRAND+xoff_l+xoff_r+GX 
       DO  I=1,IY 
        if(l_logy)then 
          h= (I-1)*YSTEP 
          Y=ybeg+YSCAL*(h+YOFFSET) 
         do j=1,IYT-1 
           h=I*YSTEP+alog(float(j)/IYT)/hlog10*YSTEP 
          ytick(j)=ybeg+YSCAL*(h+YOFFSET) 
         end do 
        else 
         Y=ybeg+YSCAL*((I-1)*YSTEP+YOFFSET) 
        end if 
        if(Y.gt.ybeg)then 
         CALL TRAA (Y,X,npenup,jcw) 
         CALL TRAA (Y,X-HX/2.,npenfr,jcw) 
        end if 
                                                                        
        IF (I.ne.IY) then 
         DO  J=1,IYT-1 
          Y=Y+YSTEP*YSCAL/IYT 
          if(l_logy)then 
           Y=ytick(J) 
           if(ytick(J).gt.ybeg)then 
            call traa(y,x,npenup,jcw) 
            CALL TRAA (Y,X-HX/4.,npenfr,jcw) 
           end if 
          else 
            call traa(y,x,npenup,jcw) 
            CALL TRAA (Y,X-HX/4.,npenfr,jcw) 
          end if 
         END DO 
        END IF 
                                                                        
       END DO 
      END IF 
                                                                        
!**************************right y-axis*********************************
                                                                        
      IF (l_ytckr ) then 
       X=XRAND 
       DO  I=1,IY 
        if(l_logy)then 
           h= (I-1)*YSTEP 
          Y=ybeg+YSCAL*(h+YOFFSET) 
         do j=1,IYT-1 
           h=I*YSTEP+alog(float(j)/IYT)/hlog10*YSTEP 
          ytick(j)=ybeg+YSCAL*(h+YOFFSET) 
         end do 
        else 
         Y=ybeg+YSCAL*((I-1)*YSTEP+YOFFSET) 
        end if 
        if(Y.gt.ybeg)then 
         CALL TRAA (Y,X,npenup,jcw) 
         CALL TRAA (Y,X+HX/2.,npenfr,jcw) 
        end if 
                                                                        
        IF (I.ne.IY) then 
         DO J=1,IYT-1 
          Y=Y+YSTEP*YSCAL/IYT 
          if(l_logy)then 
           Y=ytick(J) 
           if(ytick(J).gt.ybeg)then 
            call traa(y,x,npenup,jcw) 
            CALL TRAA (Y,X+HX/4.,npenfr,jcw) 
           end if 
          else 
           call traa(y,x,npenup,jcw) 
           CALL TRAA (Y,X+HX/4.,npenfr,jcw) 
          end if 
         END DO 
        END IF 
                                                                        
       END DO 
      END IF 
!                                                                       
!***********************************************************************
      return 
      END                                           
                                                                        
                                                                        
     subroutine axscltext(l_xaxb,l_xaxt,l_yaxl,l_yaxr,l_logx,l_logy,   &
                     CTEXT,CXTEXT,CYTEXT,nformx,nformy,npendg)         
     implicit none 
     logical       l_xaxb,l_xaxt,l_yaxl,l_yaxr,l_logx,l_logy 
     character(len=80)::  CTEXT,CXTEXT,CYTEXT 
     integer       nformx,nformy,npendg 
                                                                       
!    plottet Achsen-Beschriftung und Textzeile                         
!    M. Alflen 15.12.89                                                
!      erweitert um variablen offset zwischen Rahmen und Plot                
!    Modifiziert: A.Vef, 12.11.90                                      
!    adaptiert fuer EFFI  2008   spi                                   
                                                                       
                                                                       
     real          xrand,yrand,gx,gy,hx,hy,sw,sh,pen,xorg,yorg,        &
                   xanfsc,xendsc,xstep,yanfsc,yendsc,ystep,            &
                   xoff_l,xoff_r,yoff_b,yoff_t                         
     integer       IX,IY,ixt,iyt,ixscp10,iyscp10 
     common/aplplt/xrand,yrand,gx,gy,hx,hy,sw,sh,pen,xorg,yorg,        &
                   xanfsc,xendsc,xstep,yanfsc,yendsc,ystep,            &
                   xoff_l,xoff_r,yoff_b,yoff_t,                        &
                   ixt,iyt,IX,IY,ixscp10,iyscp10                       
                                                                       
     real          xanf,xend,yanf,yend,a_xanf,a_xend,a_yanf,a_yend,    &
                   hlog10                                              
     common/scl/  xanf,xend,yanf,yend,a_xanf,a_xend,a_yanf,a_yend,     &
                   hlog10                                              
                                                                       
     logical       l_semi,                                             &
                   l_xtext,l_xtextb,l_xtextt,l_ytext,l_ytextl,l_ytextr,&
                   l_xscal,l_xscalb,l_xscalt,l_yscal,l_yscall,l_yscalr
                                                                       
     character(len=1),dimension(24):: conum,cnum,pcnum
     character(len=1) :: bsl
     character(len=4) :: ch4
     character(len=80):: ch80
                                                                       
     integer       ixscal,iyscal,ixmode,iymode,nnum,nny,icon,&
                   i,i0,ii,it,j,jj     
     real          G1,G2,G5,G6,old,h,wi1,wi2,wi,zxtext,                &
                   xscal,xoffset,xbck,hhx,x,xp,xxww,                   &
                   xwi,xpos,xbeg,ybeg,zytext,                          &
                   yscal,yoffset,ybck,hhy,y,yp,yyww,ywi,zh,alpha                                     
     real,dimension(0:8):: OP 

       do i=1,8 
        OP(i)=0. 
       end do 
       OP(0)=1. 
       i0=ichar('0') 
       conum(1)='@' 
       i=npendg/10 
       j=npendg-10*i 
       if(i.gt.0)then 
        conum(2)=char(i+i0) 
        conum(3)=char(j+i0) 
        conum(4)=' ' 
        icon=4 
       else 
        conum(2)=char(npendg+i0) 
        conum(3)=' ' 
        icon=3 
       end if 
       do j=1,icon 
        ch4(j:j)=conum(j) 
       end do 
!       write(6,'(a,i4,2x,a4)')' allplosub npendg,ch4=',npendg,ch4      
       ixscp10=0 
       iyscp10=0 
                                                                        
!      x-axis text size*          [1.0]   values, scale  (y,n) [y,y]    
!      y-axis text size*          [1.0]   values, scale  (y,n) [y,y]    
                                                                        
       zxtext=1.2                   ! Faktor fuer Text  def effi  
       zytext=1.2 
       l_xtext=.true. 
       l_ytext=.true. 

       ixscal=1                     ! Skalierung an   
       iyscal=1 
       l_xscal=.true. 
       l_yscal=.true. 
                                                                        
       if (l_xaxb .and. l_xaxt) then 
        ixmode=0                   ! normale x-Achsen-Skalierung    
        l_xtextb=.true.            !                  inscription   
        l_xtextt=.false.                                            
        l_xscalb=.true.                                             
        l_xscalt=.false.                                            
       else if (l_xaxb) then                                        
        ixmode=-1                   ! untere x-Achsen-Skalierung    
        l_xtextb=.true.            !                  inscription   
        l_xtextt=.false.                                            
        l_xscalb=.true.                                             
        l_xscalt=.false.                                            
       else if (l_xaxt) then                                        
        ixmode=-2                   ! obere x-Achsen-Skalierung     
        l_xtextb=.false.            !                  inscription  
        l_xtextt=.true.                                             
        l_xscalb=.false.                                            
        l_xscalt=.true.                                             
       else                                                         
                                                                        
        l_xtextb=.false.            ! keine x-Achsen-Skalierung     
        l_xtextt=.false.            !                inscription    
        l_xtext=.false. 
        zxtext=0. 
        l_xscalb=.false. 
        l_xscalt=.false. 
        l_xscal=.false. 
        ixscal=0 
       end if 
                                                                        
       if (l_yaxl .and. l_yaxr) then 
                                     
        iymode=0                   ! normale y-Achsen-Skalierung    
        l_ytextl=.true.            !                  inscription   
        l_ytextr=.false.                                            
        l_yscall=.true.                                             
        l_yscalr=.false.                                            
       else if (l_yaxl) then                                        
                                                                        
        iymode=-1                   ! linke y-Achsen-Skalierung     
        l_ytextl=.true.             !                  inscription  
        l_ytextr=.false.                                            
        l_yscall=.true.                                             
        l_yscalr=.false.                                            
       else if (l_yaxr) then                                        
                                                                        
        iymode=-2                   ! rechte y-Achsen-Skalierung    
        l_ytextl=.false.            !                  inscription  
        l_ytextr=.true.                                             
        l_yscall=.false.                                            
        l_yscalr=.true.                                             
       else                                                         
                                                                        
        l_ytextl=.false.            ! keine y-Achsen-Skalierung     
        l_ytextr=.false.            !                  inscription  
        l_ytext=.false. 
        zytext=0. 
        l_yscall=.false. 
        l_yscalr=.false. 
        l_yscal=.false. 
        iyscal=0 
       end if 
                                                                        
!       write(6,'(a,2(i4,2x,f12.2),6f12.2)')                            
!     &    'IX,XSTEP,IY,YSTEP,yanf,yanfsc,yend,yendsc=',                
!     &     IX,XSTEP,IY,YSTEP,yanf,yanfsc,yend,yendsc                   
                                                                        
       OLD=0. 
       XBCK=0. 
       YBCK=0. 
! ********************plot inscription of x-axis************************
                                                                        
                                                                        
      XOFFSET=XEND-XENDSC 
      xbeg=XRAND+xoff_r 
      xscal=gx/(xend-xanf) 
!      write(6,'(a,6f12.2)')'XEND,XENDSC,XRAND,xoff_r=',XEND,XENDSC,XRAND,xoff_r                 
                                                                        
!*************plot inscription of bottom/top x-axis*********************
                                                                        
       IF (l_xscalt.or.l_xscalb) then 
        if (l_xscalt)then 
         Y=YRAND+yoff_b+yoff_t+gy 
        else 
         Y=YRAND 
        end if 
                                                                        
       ixscp10=0 
       ch80=CXTEXT 
       if(XSTEP.gt.1000.and.nformx.eq.0) then 
        jj=20 
        DO  I=1,IX 
         XP=XANFSC+(I-1)*XSTEP 
         G1=abs(XP/(XENDSC-XANFSC)) 
         if(G1.gt.0.) then 
          call numero(XP,nformx,cnum,nnum,1,ixscp10) 
          j=nnum 
          ii=0 
          do while(cnum(j).eq.'0'.and.j.gt.1) 
           j=j-1 
           ii=ii+1 
          end do 
          if(jj.gt.ii)jj=ii 
         end if 
        END DO 
!        write(6,'(i4,a,24a1)')jj,' cnum=',cnum                         
        ixscp10=jj 
        i=jj/10 
        ii=jj-10*i 
        bsl=char(92) 
        j=80 
        do while(CXTEXT(j:j).eq.' ') 
         j=j-1 
        end do 
        j=j+1 
        if(i.eq.0) then 
        ch80=CXTEXT(:j)//' ['//bsl//',10$^'//char(jj+i0)//'$ '//bsl//',]' 
        else 
         ch80=CXTEXT(:j)                                                &
         //' ['//bsl//',10$^'//char(i+i0)//char(ii+i0)//'$ '//bsl//',]'
        end if 
       end if 
       CXTEXT=ch4(:icon)//ch80 
                                                                        
       I=IX+1 
   10  I=I-1 
        if(l_logx)then 
         h=XENDSC-(I-1)*XSTEP 
         XP=exp(h*hlog10) 
         if(XP.lt.1000.and.h.gt.0) then 
          call numero(XP,0,cnum,nnum,1,0) 
         else 
          call numexp(h,cnum,nnum) 
         end if 
        else 
         XP=XENDSC-(I-1)*XSTEP 
         G1=abs(XP/(XENDSC-XANFSC)) 
         if(G1.lt.1.E-4) XP=0.0 
         call numero(xp,nformx,cnum,nnum,1,ixscp10) 
        end if 
        if(I.lt.IX) then 
         j=1 
         do while(pcnum(j).eq.cnum(j).and.j.lt.nnum) 
          j=j+1 
         end do 
                                                                        
!         write(6,'(a,2(24a1),2x,3i3)')'p,cnum=',pcnum,cnum,j,nnum,nform
         if(j-1.eq.nnum.and.nformx.lt.5)then 
          nformx=nformx+1 
          I=IX+1 
          goto 10 
         end if 
        end if 
        do j=1,24 
         pcnum(j)=cnum(j) 
        end do 
       if(I.gt.1) goto 10 
                                                                        
       DO  I=IX,1,-1 
        if(l_logx)then 
         h=(I-1)*XSTEP 
         X=xbeg+XSCAL*(h+XOFFSET) 
         h=XENDSC-(I-1)*XSTEP 
         XP=exp(h*hlog10) 
         if(XP.lt.1000.and.h.gt.0) then 
          call numero(XP,0,cnum,nnum,1,0) 
         else 
          call numexp(h,cnum,nnum) 
         end if 
        else 
         X=xbeg+XSCAL*((I-1)*XSTEP+XOFFSET) 
         XP=XENDSC-(I-1)*XSTEP 
         G1=abs(XP/(XENDSC-XANFSC)) 
         if(G1.lt.1.E-4) XP=0.0 
         call numero(xp,nformx,cnum,nnum,1,ixscp10) 
        end if 
                                                                        
         do ii=1,nnum 
          conum(ii+icon)=cnum(ii) 
         end do 
         nnum=nnum+icon 
         alpha=-90 
         OP(4)=0.     ! x  
         OP(5)=0.     ! y  
         CALL TXTPLO(OP,-1,conum,nnum,hx,hy,alpha,ybck,xwi,zh) 
         xwi=abs(xwi) 
         xpos=x+xwi/2. 
!                                                                       
                                                      ! plot x-name     
         IF (OLD.ge.xpos+xwi.or.I.eq.IX) then 
          OP(4)=xpos        ! x   
          OP(5)=y-2.*hy 
          if (l_xscalt) OP(5)=y+.5*hy     ! y    
          CALL TXTPLO(OP,1,conum,nnum,hx,hy,alpha,ybck,xwi,zh) 
          OLD=XPOS-HX 
         end if 
       END DO 
      END IF 
                                                                        
!*********************plot name of x-axis*******************************
                                                                        
      IF (l_xtextb .or. l_xtextt ) then 
       hhx=hx*zxtext 
       hhy=hy*zxtext 
       if (l_xtextb) then 
        if (l_xscalb ) then 
         G1=YRAND-3.8*hhy 
        else 
         G1=yrand-1.5*hhy 
        end if 
       end if 
       if (l_xtextt) then 
        if (l_xscalt) then 
         G1=YRAND+GY+yoff_t+yoff_b+2.2*hhy 
        else 
         G1=yrand+gy+yoff_t+yoff_b+.2*hhy 
        end if 
       end if 
       it=LEN_TRIM(CXTEXT)
       if ( it.gt.0 ) then 
        if(CXTEXT(it:it).eq.';') then 
         CXTEXT(it:it)=' ' 
         l_semi=.true. 
        else 
         l_semi=.false. 
        end if 
        G2=XRAND+xoff_l+FLOAT(it)*hhx 
        alpha=-90                                           
         OP(4)=G2          ! x                                          
         OP(5)=G1          ! y 
        CALL TXTPLO(OP,-1,CXTEXT,it,hhx,hhy,alpha,G5,G6,zh) 
        if (.not. l_semi) OP(4)=XRAND+xoff_l-G6
        CALL TXTPLO(OP,1,CXTEXT,it,hhx,hhy,alpha,G5,G6,zh) 
       end if 
      end if 
                                                                        
!******************plot inscription of y-axis***************************
      YOFFSET=-(YANF-YANFSC) 
      ybeg=YRAND+yoff_b 
      yscal=gy/(yend-yanf) 
      iyscp10=0 
                                                                        
       ch80=CYTEXT 
       if(YSTEP.ge.1000.and.nformy.eq.0) then 
        jj=20 
        DO  I=1,IY 
         YP=YENDSC-(I-1)*YSTEP 
         G1=abs(YP/(YENDSC-YANFSC)) 
         if(G1.gt.0.) then 
          call numero(yp,nformy,cnum,nnum,1,iyscp10) 
!          write(6,'(a,24a1)')' cnum=',cnum                             
          j=nnum 
          ii=0 
          do while(cnum(j).eq.'0'.and.j.gt.1) 
           j=j-1 
           ii=ii+1 
          end do 
          if(jj.gt.ii)jj=ii 
         end if 
        END DO 
!        write(6,'(i4,a,24a1)')jj,' cnum=',cnum                         
        iyscp10=jj 
        i=jj/10 
        ii=jj-10*i 
        bsl=char(92) 
        j=80 
        do while(CYTEXT(j:j).eq.' ') 
         j=j-1 
        end do 
        j=j+1 
        if(i.eq.0) then 
         ch80=CYTEXT(:j)//' ['//bsl//',10$^'//char(jj+i0)//'$ '//bsl//',]'
        else 
         ch80=CYTEXT(:j)                                                &
         //' ['//bsl//',10$^'//char(i+i0)//char(ii+i0)//'$ '//bsl//',]' 
        end if 
       end if 
       CYTEXT=ch4(:icon)//ch80 
                                                                        
       I=IY+1 
   20  I=I-1 
        if(l_logy)then 
         h=YENDSC-(I-1)*YSTEP 
         YP=exp(h*hlog10) 
         if(YP.lt.1000.and.h.gt.0) then 
          call numero(YP,0,cnum,nnum,1,0) 
         else 
          call numexp(h,cnum,nnum) 
         end if 
        else 
         YP=YENDSC-(I-1)*YSTEP 
         G1=abs(YP/(YENDSC-YANFSC)) 
         if(G1.lt.1.E-4) YP=0. 
         call numero(YP,nformy,cnum,nnum,1,iyscp10) 
        end if 
        if(I.lt.IY) then 
         j=1 
         do while(pcnum(j).eq.cnum(j).and.j.lt.nnum) 
          j=j+1 
         end do 
         if(j-1.eq.nnum.and.nformy.lt.5)then 
          nformy=nformy+1 
          I=IY+1 
          goto 20 
         end if 
        end if 
        do j=1,24 
         pcnum(j)=cnum(j) 
        end do 
       if(I.gt.1) goto 20 
                                                                        
!*************************left y-axis***********************************
                                                                        
      IF (l_yscall) then   ! normal yaxis     
                                                                        
       DO  I=1,IY 
        X=XRAND+xoff_l+xoff_r+GX 
        if(l_logy)then 
         h= (I-1)*YSTEP 
         Y=ybeg+YSCAL*(h+YOFFSET) 
         h=YANFSC+(I-1)*YSTEP 
         YP=exp(h*hlog10) 
!         write(6,'(a,i3,6f10.3)')'IY,YANFSC,YSTEP,YP=',                
!     &                            IY,YANFSC,YSTEP,YP                   
         if(YP.lt.1000.and.h.gt.0) then 
          call numero(YP,0,cnum,nnum,1,0) 
         else 
          call numexp(h,cnum,nnum) 
         end if 
        else 
         Y=ybeg+YSCAL*((I-1)*YSTEP+YOFFSET) 
         YP=YANFSC+(I-1)*YSTEP 
         G1=abs(YP/(YENDSC-YANFSC)) 
         if(G1.lt.1.E-4) YP=0.0 
         call numero(yp,nformy,cnum,nnum,1,iyscp10) 
        end if 
                                                                        
        if(Y.gt.ybeg)then 
         do ii=1,nnum 
          conum(ii+icon)=cnum(ii) 
         end do 
         nnum=nnum+icon 
         alpha=-90 
         OP(4)=0.       ! x    
         OP(5)=0.       ! y   
         CALL TXTPLO(OP,-1,conum,nnum,hx,hy,alpha,ybck,ywi,zh) 
         ywi=abs(ywi)+hx 
                                              ! e-Format korrigieren    
         if (nny .lt. 0) ywi=ywi-.5*hx 
!                                                                       
         IF ( I.EQ.1 .or. OLD.le.Y-HY/2.) then 
          OP(4)=X+ywi        ! x   
          OP(5)=Y-HY/2.      ! y  
          CALL TXTPLO(OP,1,conum,nnum,HX,HY,alpha,YBCK,XBCK,zh) 
          OLD=Y+HY/2.+HY 
         end if 
        end if 
       END DO 
      END IF 
                                                                        
!************************ right y-axis**********************************
                                                                        
      IF (l_yscalr ) then        !  values at right y-axis  
                                                                        
       DO  I=1,IY 
        X=XRAND 
        if(l_logy)then 
         h=(I-1)*YSTEP 
         Y=ybeg+YSCAL*(h+YOFFSET) 
         h=YANFSC+(I-1)*YSTEP 
         YP=exp(h*hlog10) 
         if(YP.lt.1000.and.h.gt.0) then 
          call numero(YP,0,cnum,nnum,1,0) 
         else 
          call numexp(h,cnum,nnum) 
         end if 
        else 
         Y=ybeg+YSCAL*((I-1)*YSTEP+YOFFSET) 
         YP=YANFSC+(I-1)*YSTEP 
         G1=abs(YP/(YENDSC-YANFSC)) 
         if(G1.lt.1.E-4) YP=0.0
         call numero(yp,nformy,cnum,nnum,1,iyscp10) 
        end if 
                                                                        
        if(Y.gt.ybeg)then 
         do ii=1,nnum 
          conum(ii+icon)=cnum(ii) 
         end do 
         nnum=nnum+icon 
!        write(6,'(a,5f8.2)')' OLD.le.Y-HY/2=',OLD,Y-HY/2.,YP           
         alpha=-90 
         IF ( I.EQ.1 .or. OLD.le.Y-HY*0.6) then 
          OP(4)=X-0.1*hx   ! x  
          OP(5)=Y-HY/2.    ! y  
          CALL TXTPLO(OP,1,conum,nnum,HX,HY,alpha,YBCK,XBCK,zh) 
          OLD=Y+HY*0.6 
         else IF ( I.EQ.1 .or. OLD.ge.Y-HY/2.) then 
          OP(4)=X-0.1*hx      ! x     
          OP(5)=Y-HY/2.       ! y  
          CALL TXTPLO(OP,1,conum,nnum,HX,HY,alpha,YBCK,XBCK,zh) 
          OLD=Y-HY/2.-HY 
         end if 
        end if 
       END DO 
      END IF 
!                                                                       
!********************plot name of y-axis********************************
                                                                        
      if ( l_ytextl .or. l_ytextr ) then 
       hhx=hx*zytext 
       hhy=hy*zytext 
       alpha=-90 
       if (l_yscalr .or. l_yscall) then 
                                                                        
        call numero(yanfsc,nformy,cnum,nnum,1,iyscp10) 
        OP(4)=0.       ! x  
        OP(5)=0.       ! y   
        CALL TXTPLO(OP,-1,cnum,nnum,HX,HY,alpha,YBCK,wi1,zh) 
        wi1=abs(wi1) 
        call numero(yendsc,nformy,cnum,nnum,1,iyscp10) 
        CALL TXTPLO(OP,-1,cnum,nnum,HX,HY,alpha,YBCK,wi2,zh) 
        wi2=abs(wi2) 
        wi=amax1(wi1,wi2) 
       else 
        wi=0. 
       end if 
       it=LEN_TRIM(CYTEXT)
       if ( it .gt. 0) then 
        if (CYTEXT(it:it).eq.';') then 
         CYTEXT(it:it)=' ' 
         l_semi=.true. 
        else 
         l_semi=.false. 
        end if 
        if (l_ytextl) then 
         G1=YRAND+GY+yoff_b-FLOAT(it+1)*hhx 
         G2=XRAND+GX+xoff_l+xoff_r+1.5*HX+.5*HHY+WI 
!         if(l_logy)G2=G2+1.5**HX                                       
         alpha=0 
        else if (l_ytextr) then 
         G1=YRAND+GY+yoff_b-FLOAT(it)*hhx 
         G2=XRAND-HX-2.5*HHY-WI 
         if(l_logy)G2=G2+HX 
         alpha=0 
        end if 
        OP(4)=0.       ! x   
        OP(5)=0.       ! y    
        CALL TXTPLO(OP,-1,CYTEXT,it,hhx,hhy,alpha,yyww,xxww,zh) 
        if (.not. l_semi) g1=yrand+gy+yoff_b-yyww      ! correct for st
        OP(4)=G2        ! x  
        OP(5)=G1        ! y  
        CALL TXTPLO(OP,1,CYTEXT,it,hhx,hhy,alpha,G5,G6,zh) 
       end if 
      end if 
!                                                                       
!***********************************************************************
!                                                                       
!     plot wordcard                                                     
!                                                                       
!***********************************************************************
!                                                                       
       g2= xrand+gx+xoff_r 
                                                                        
       if (l_xtextb) then 
        if (l_xscalb ) then 
         G1=YRAND-3.5*hhy-2.*hy 
!         G1=YRAND-3.5*hhy-3.*hy                                        
        else 
         G1=yrand-1.5*hhy-3.*hy 
        end if 
       else 
        if (l_xscalb ) g1=g1-2.*hy 
       end if 
                                                                        
       if (l_xtextt) then 
        if (l_xscalt) then 
         G1=YRAND+GY+yoff_b+yoff_t+2.2*hhy+2.*hy 
        else 
         G1=yrand+gy+yoff_b+yoff_t+.2*hhy+2.*hy 
        end if 
       else 
        if (l_xscalt) g1=g1+2.*hy 
       end if 
                                                                        
       alpha=-90 
       it=LEN_TRIM(CTEXT) 
        OP(4)=G2        ! x    
        OP(5)=G1        ! y   
       CALL TXTPLO(OP,1,CTEXT,it,zxtext*hx,zytext*hy,alpha,G5,G6,zh) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      SUBROUTINE NUMERO(FNP_T,NC,INUM,NCHA,MODE,iscfactor) 
!     konvertiert Zahl zu ASCII-String                                  
!     M. Alflen  13.9.89                                                
!     fnp  Eingabezahl                                                  
!     nc   > 0  : f-Format mit nc Nachkommastellen  ( nc <= 5 )         
!          =0   : i-Format                                              
!          <0   : e-Format mit nc  Nachkommastellen    ( nc<=2 )        
!     mode =  0  : e-Format = x.yzE+nn                                  
!             1  : e-Formay = x.yz*10-n                                 
!     inum  =   Ausgabestring  ( Integer )                               
!     ncha =   Zahl der signifikanten Character                         
                                                                        
      character(len=1):: ie1,ie2
      character(len=7):: form
      character(len=1),dimension(24)::inum
      i0=ichar('0') 
                                                                        
      do i=1,24 
       inum(i)=' ' 
      end do 
      ie2=' ' 
      fnp=FNP_T/10**iscfactor 
!     write(6,'(a,f15.5,a,i2,a,i2)')                                    
!     &            ' fnp=',fnp,' MODE=',MODE,'  NC=',NC                 
                                     ! f - oder i-Format                
      if ( nc .ge. 0) then 
       if ( nc .gt. 5 ) nc=5 
       form='f15.5' 
       call xencode(fnp,form,inum) 
!      write(6,'(a,f15.5,a,15a1)') ' fnp=',fnp,'    inum=',inum         
       if (nc .eq. 0) then 
        ncha=10-1 
       else 
        ncha=10+nc 
       end if 
                                    ! ueberfluessige Nachkommastellen en
       if ( nc .lt. 5 ) then 
        k=ncha+1 
        do while ( k .le. 15 ) 
         inum(k)=' ' 
         k=k+1 
        end do 
       end if 
                                    ! e-Format                          
      else if ( nc .le. -1 ) then 
       dum=fnp 
       form='e10.'//char(-nc+i0) 
       call xencode(dum,form,inum) 
!      write(6,'(a,15a1,a,15a1,/)') ' a inum=',inum                     
                                                                        
                                    ! normales e-Format                 
       if ( mode .eq. 0 ) then 
                                    ! Divison/10. ausgleichen           
        inum(2)=inum(4) 
        do i=4,9 
         inum(i)=inum(i+1) 
        end do 
                                                                        
                                     ! Blanks einfuegen                 
        do i=10,24 
         inum(i)=' ' 
        end do 
        ncha=10 
                                     ! spezielles e-Format              
       else 
        i=4 
        do while(i.lt.24.and.inum(i).ne.'e') 
         i=i+1 
        end do 
         ie1=inum(i+1) 
         ie2=inum(i+2) 
!        write(6,'(i2,2x,2a1,a,24a1,/)') i,ie1,ie2,'- inum=',inum       
!                              inum=   -1.0e-4                          
!                              inum= -1.050e-4                          
!                              inum=-1.0500e-4                          
          inum(i  )=char(92) 
          inum(i+1)='Z' 
          inum(i+2)='1' 
          inum(i+3)='5' 
          inum(i+4)=char(92) 
          inum(i+5)='r' 
          inum(i+6)='1' 
          inum(i+7)='0' 
          inum(i+8)='$' 
          inum(i+9)='^' 
          inum(i+10)=ie1 
          inum(i+11)=ie2 
          inum(i+12)='$' 
          inum(i+13)=' ' 
          ncha=i+13 
       end if 
      end if 
!      write(6,'(i2,a,24a1,/)') i,'- inum=',inum                        
                                                                        
                                     ! fuehrende Blanks beseitigen      
      i=1 
      do while ( i.le. 24 .and. inum(i) .eq. ' ') 
       i=i+1 
      end do 
      i=i-1 
      ncha=ncha-i 
      if ( i .gt. 0) then 
       do k=1,ncha 
        l=k+i 
        inum(k)=inum(l) 
        inum(l)=' ' 
       end do 
      end if 
                                                                        
!     write(6,'(i2,a,24a1,/)') i,'- inum=',inum                         
      return 
      END                                           
                                                                        
!-----------------------------------------------------------------------
                                                                        
      subroutine xencode(rn,form,inum)
      implicit none
      real      rn 
      character(len=7) :: form
      character(len=1),dimension(24)::inum
      character(len=24):: chr,chl
      integer   k,nl,nr
       call trlnu(form,rn,chr,nr,chl,nl) 
       do k=1,nr 
        inum(k)=chr(k:k) 
       end do 
      return 
      END                                           
                                                                        
      subroutine scaling(xanf,xend,ityp,XFIRST,XLAST,DELTA,itck) 
      implicit none
!     scale berechnet Werte fuer Plotbereich und Achsenbeschriftung     
!     M. Alflen   8.9.89                                                
!     ityp = 0 : Plotbereich ( d.h. xfirst<xanf , xlast>xend )          
!            1 : Achsen      ( d.h. xfirst>xanf , xlast<xend )          
!     xanf , xend : Eingabewerte Bereich                                
!     xfirst,xlast : geglaettete Ausgabewerte                           
!     delta        : Achsen-Unterteilung                                
!     itck         : Anzahl der Ticks zwischen zwei Unterteilungen      
!                                                                       
      real,dimension(4),parameter :: xmant=(/1.,2.,5.,10./) 
      real xanf,xend,XFIRST,XLAST,DELTA,deltap2,                          & 
           TENPOW,ROUND,xf,xl,bb,xd
      integer ityp,itck,I,IS
      logical b_power2

      XFIRST = AMIN1(xanf,xend) 
      XLAST = AMAX1(xanf,xend)
      b_power2=.false.
      if(XLAST.gt.64) then
        I=XLAST/64
        XLAST =I*64 
        b_power2=.true.
        deltap2 = (XLAST-XFIRST+1)/4.         
        itck=5
      end if
      xf=xfirst 
      xl=xlast 
      IF(XLAST-XFIRST .LT. 0.001) GOTO 999 
!                                                                       
      DELTA = (XLAST-XFIRST)/8. 

      TENPOW = 10.**(INT(ALOG10(DELTA)+1000.)-1000) 
      DELTA = DELTA/TENPOW - 0.01 
!                                                                       
!     NOW DELTA CONTAINS MANTISSA, TENPOW THE TENPOWER OF DELTA         
!                                                                       
      DO I=1,4 
       IS = I 
       IF(XMANT(I).GE.DELTA) GOTO 302 
      END DO 
!     SMOOTH MANTISSA                                                   
  302 CONTINUE 

 
      if(b_power2) then
        DELTA=deltap2  
        
      else                                                                  

!      SMOOTH XFIRST,XLAST                                               
       DELTA = XMANT(IS)*TENPOW 

       ROUND = 0.001 
       IF(XFIRST.LT.0.) ROUND = ROUND - 1. 
       bb=AINT(XFIRST/DELTA + ROUND) 
       XFIRST = DELTA *bb 
       XLAST = AINT((XLAST-XFIRST)/DELTA + 0.99999)*DELTA + XFIRST 
       itck=min(ifix(xmant(is)),5) 
      end if                                                                      

      if ( ityp .eq. 1) then 
       if ( xfirst .lt. xf*(1.-1.e-4) )                                 &
            xfirst=xfirst+delta                                          
       if ( xlast .gt. xl*(1.+1.e-4) )                                  &
            xlast=xlast-delta                                            
      end if 
      if ( xanf .gt. xend ) then 
       xd=xfirst 
       xfirst=xlast 
       xlast=xd 
       delta=-delta 
      end if 
!                                                                       
      return 
!                                                                       
                   ! keine sinnvolle Skalierung moeglich                
  999 continue 
      if (xanf .eq. xend) then 
       xanf=0 
       xend=1 
       delta=1 
      else 
       xfirst=xanf 
       xlast=xend 
       delta=xend-xanf 
      end if 
      itck=1 
      RETURN 
      END                                           
!                                                                       
      function naxfor(anf,end,step) 
!     naxfor analysiert Eingabegroessen und                             
!     bestimmt Skalierungs-Format fuer BATPLO                           
!     naxfor<0  : e-Format                                              
!           =0  : i-Format                                              
!           >0  : f-Format ( nform Nachkommastellen )                   
!     anf       : Anfangswert Skala                                     
!     end       : Endwert Skala                                         
!     step      : Abschnitt                                             
!     M. Alflen   15.9.89                                               
!                                                                       
      implicit none 
      real anf,end,step,aanf,aend,astep,delta 
      integer naxfor,k,mult 
!                                                                       
      aanf=abs(anf) 
      aend=abs(end) 
      astep=abs(step) 
!                                                                       
      if (astep .ge. 1.e6 .or. astep .le. 1.e-4) then 
       mult=ifix( amax1(aend,aanf)/astep ) 
       if ( mult .ge. 10) then 
                                                      ! e-Format        
        naxfor=-2 
       else 
        naxfor=-1 
       end if 
      else 
       delta=abs( astep-float( ifix( astep ) ) ) 
       if ( delta .le. 1.e-4 ) then 
                                                      ! i-Format        
        naxfor=0 
       else 
        k=0 
        do while (delta .gt. 1.e-4 .and. k .le. 5) 
         k=k+1 
         delta=delta*10. 
         delta=abs( delta-float( ifix( delta ) ) ) 
        end do 
                                                       ! f-Format       
        naxfor=min(k,5) 
       end if 
      end if 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine numexp(X,inum,nnum) 
      implicit none
      real X 
      integer in,i10,i1,nnum,k,i,i0 
      character(len=1),dimension(24)::inum

      i0=ichar('0') 
      do i=1,24 
       inum(i)=' ' 
      end do 
      in=X 
                                                                        
      inum(1)='1' 
      if(in.eq.0) then 
        nnum=1 
        return 
      end if 
      inum(2)='0' 
      inum(3)='$' 
      inum(4)='^' 
      k=4 
      if(in.lt.0)then 
       in=-in 
       inum(k+1)='-' 
       k=k+1 
      end if 
      i10=in/10 
      if(i10.gt.0)then 
       i1=in-i10*10 
       if(i10.ge.10)i10=ichar('x')-i0 
       inum(k+1)=char(i10+i0) 
       inum(k+2)=char(i1+i0) 
       nnum=k+2 
      else 
       inum(k+1)=char(in+i0) 
       nnum=k+1 
      end if 
      if(in.eq.0)nnum=1 
      return 
      END                                           
