      subroutine th_22index(isubthe,icase,iput,iget,info) 
!     called by i.e. stroboscopy and synchrotron                        
      use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,               &
                          icstrf,ivstrf,ivfr1trf,nwr

      use comthe, only: array_fr,theoryname
      implicit none 
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info   
                                                                        
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      integer       dstr,ipt,iposLG,iaddr                                          
      common/struct/dstr(istr),         &
                    ipt,iposLG,iaddr(6)

      integer       ibe,idum,nAS,ifrth,iflag_basis,lfwscat,nLG,nsampling,ak8,idum2,ien
      real          srw8 
      common/strLOC/ibe(8),ifrth(4),iflag_basis,lfwscat,  &
                    nLG,nAS,idum,nsampling,ak8,idum2,srw8,ien(11)      
                                                                        
      logical       b_vsp,b_v_max,b_dumvsp 
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                        
      logical        b_vfr1trf 
      common/bvfr1trf/b_vfr1trf(ivfr1trf) 

!     storage use nst2_8 for 4 complex numbers of r_ik                  
      real          c1,gamnat,e_xsi,flag_SAMP,offset,dumc 
!      common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumc(icstrf-5) 
      common/acmaps/c1,gamnat,e_xsi,flag_SAMP,offset,dumc(icstrf-5) 
      real          avm,sftr,aisom,w_Gauss,wLorentz,dumv 
      logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz,b_dumv 
      common/avmaps/avm,sftr,aisom,w_Gauss,wLorentz(8),dumv(ivstrf-5) 
      common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz(8),           &
                    b_dumv(ivstrf-12)                                    
                                                                        
      logical   b_fwscat,b_pc,bxx 
      integer   iflag_SAMP,iflag_Voigt,ioffset,nd,nE,jge,ige,lge, &
                i,ip,jn,n,ni,nget,n_all,nall                      
                                                                        
      real      Eagd,hti,srw,azz,d_x2,aszz,dsx2,fd,w_Lorentz 
      complex   hc,hci,ctr,cpm,cmp,hrtr,hrpm

      complex, dimension(:), allocatable:: cLG
                                                                         
                                                                
      if(isubthe.lt.0) then 
       c1=8*(nAS+1) 
       theoryname='2x2_refraction_index_static     v=101' 
       return 
      end if 
 
      hci=cmplx(0.,1.) 
      iflag_SAMP=flag_SAMP 
      if(icase.eq.0)iflag_SAMP=0 
      iflag_Voigt=0  ! flag_Voigt instead ioffset is defined 
      ioffset=offset
      b_fwscat=lfwscat.eq.1 
                                                                        
!      write(6,'(a,4i6)') '22index ....isubthe,nLG=',isubthe,nLG        

!     i.e  th_hdeq                                                      
      call get_theory(isubthe,info) 
      if(info.gt.0) return
      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.isubthe.gt.0 
      do i=1,8
       b_pc=b_pc.or.b_wLorentz(i)
      end do
      if(.not.b_pc.or.info.gt.0) then 
       isubthe=-abs(isubthe) 
       return 
      else
       isubthe=abs(isubthe)
      end if
                                                                        
      nget=real(array_fr(iget+1)) 
      n_all=real(array_fr(nget+1)) 
      jge=aimag(array_fr(nget+1)) 
      bxx=real(array_fr(nget+2)).gt.0.01 

                                                                        
!      write(6,'(a,L5,5i8)') 'b_fwscat,iflag_basis,iflag_SAMP,iput=',&    
!                             b_fwscat,iflag_basis,iflag_SAMP,iput,icase      
!-----------------------------------------------------------------------
!      if (iflag_basis.eq.0) transformation with TrhoT+
!       t=1/2( 1 -1)
!            (-i -i)   (see iflag_basis.eq.0)
      i=8 
      do n=iput+1,iput+(nAS+1)*i 
       array_fr(n)=(0.,0.) 
      end do 
!      write(6,'(a,4i8)')'iput,nAS,(nAS*1)*8=',iput,nAS,(nAS*1)*8
                                                                  
      if(iflag_SAMP.eq.1) then 
       allocate(cLG(0:nLG))

       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        do jn=ip+1,ip+jge*3-2,3 
         Eagd=real(array_fr(jn))+aisom 
                                         ! nE <= sk8                    
         nE=ifix(Eagd/srw8+0.5) 
         if (abs(nE).gt.ak8) write(nwr,'(2(a,f10.2),a)')                &
           '**** E(sample)=',Eagd,' out of range ',ak8*srw8,'[mm/s]'    
        end do 
       end do   ! nall=1,n_all 

        w_Lorentz=wLorentz(1) 
        if(icase.eq.1) call cLORGAU(gamnat,e_xsi,                        &
                          srw8,w_Lorentz,w_Gauss,nLG,cLG)
                                                                        
!        write(6,'(a,3i6,/,4f12.5)')'icase,iposLG,nLG,array_fr(iposLG,+1)=', & 
!        icase,nLG,iposLG,array_fr(iposLG),array_fr(iposLG+1)                
                                                                        
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
                                                                        
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 

        ige=0
        lge=0   
        do jn=ip,ip+jge*3-3,3
         ige=ige+1
         if(icase.eq.2) then
          if(ige.ge.ioffset)then
           lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
           else 
            w_Lorentz=wLorentz(1)
           end if
          end if
          call cLORGAU(gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,nLG,cLG)
         end if   
         if (iflag_basis.eq.1) then
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd 
         else
          hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
          hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
         end if
         Eagd=real(array_fr(jn+1))+aisom 
         nE=ifix(Eagd/srw8+0.5) 
                                                                        
         if(b_fwscat) then 
           hti = aimag(hrtr)/2.0 
           ctr= real(hrtr)*hci/2.0 
           cpm= hrpm*hci/2.0 
           cmp= conjg(hrpm)*hci/2.0 
         else 
!         shape of rho-hatrix                                           
           hti = aimag(hrtr)+real(hrtr) 
           ctr= cmplx(aimag(hrtr)-real(hrtr),0.) 
           cpm= hrpm 
           cmp= conjg(hrpm) 
!         write(6,'(l5,2x,8f12.4)').not.b_fwscat,Eagd,hti,ctr,cpm     
         end if 
!        write(6,'(a,4i6,f15.6)')'nsampling,nLG,nAS,iposLG,srw8=',      
!     &                           nsampling,nLG,nAS,iposLG,srw8         
                                                                        
         do n=0,nAS 
          ni=iput+8*n 
          nd=nsampling*n-nE 
          if(abs(nd).le.nLG) then 
                                                                        
!          nkz=kz*I-Sum;ab rpq(ab)/2*(-i+(E-Eab)/hga)*LG(E-Eab)         
!          nkz=kz*I-Sum;ab rpq(ab)/2*(-i*LGi(E-Eab)+LGr(E-Eab))         
!          b1=1/2 kz*(npm+nmp)                                          
!          b2=1/2 kz*(npm-nmp)*i                                        
!          b3=1/2 kz*(npp-nmm)                                          
!                                                                       
!          the factor 1/4 is the factor in 1/2 kz*(...) and in npq ( 1/2
!          fLG=(4*n-nE)*srw8/(hga/2.) is written as                     
                                                                        
           if(nd.gt.0) then  
            hc=cLG(nd)                        
           else 
            hc=-conjg(cLG(-nd)) 
           end if 
           array_fr(ni+1)=array_fr(ni+1)-hc*hti 
           array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
           array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
           array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
          end if 
                                                                        
           nd=-nsampling*n-nE 
           if(abs(nd).le.nLG) then 
            if(nd.gt.0) then 
             hc=cLG(nd) 
            else 
             hc=-conjg(cLG(-nd)) 
            end if 
            array_fr(ni+5)=array_fr(ni+5)-hc*hti 
            array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
            array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
            array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
           end if 
         end do  ! nAS     
        end do   ! jn=  
       end do    ! n_all
       deallocate(cLG)

      else
!      iflag_SAMP=0  

       allocate(cLG(-nAS:nAS))

       srw=srw8*nsampling 
       w_Lorentz=wLorentz(1)

       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
                                                                        
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
                                                                        
        ige=0
        lge=0    
        do jn=ip,ip+jge*3-3,3 
         ige=ige+1
         if(icase.eq.2) then
          if(ige.ge.ioffset)then
           lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
           else 
            w_Lorentz=wLorentz(1)
           end if
          end if
         end if
         if (iflag_basis.eq.1) then
          hrtr=array_fr(jn+2)*fd  
          hrpm=array_fr(jn+3)*fd 
         else
          hrtr=cmplx(-real(array_fr(jn+3)),aimag(array_fr(jn+2)))*fd 
          hrpm=cmplx(-aimag(array_fr(jn+3)),real(array_fr(jn+2)))*fd 
         end if
         
         if(b_fwscat)then 
          hti=aimag(hrtr)/2.0 
          ctr=real(hrtr)*hci/2.0 
          cpm=hrpm*hci/2.0 
          cmp=conjg(hrpm)*hci/2.0 
         else 
          hti=aimag(hrtr)+real(hrtr) 
          ctr=cmplx(aimag(hrtr)-real(hrtr),0.) 
          cpm=hrpm 
          cmp=conjg(cpm) 
         end if 
                                                                        
          Eagd=real(array_fr(jn+1))+aisom
!         write(6,'(i8,8f12.4)')jn,Eagd,array_fr(jn+2),array_fr(jn+3)
!         write(11,'(8f12.4)')Eagd,hti,ctr,cpm
                                                                       
         call aLORGAU(Eagd,gamnat,e_xsi,                                &
                      srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)
         do n=0,nAS 
          ni=iput+8*n 
          hc=cLG(n)                             
          array_fr(ni+1)=array_fr(ni+1)-hc*hti 
          array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
          array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
          array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
          hc=cLG(-n) 
          array_fr(ni+5)=array_fr(ni+5)-hc*hti 
          array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
          array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
          array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
!        if(n.lt.3) write(6,'(a,2i6,8e15.6)') &                       
!          ' nAS, n,i,hc*100.=',nAS,-n,hc*100., Eagd,array_fr(ni+1)

         end do    ! n loop
        end do     !   jn=
       end do      ! nall=1,n_all 
       deallocate(cLG)
!      write(6,'(a1,2i8,2f10.4)')                                       
!     & ('m',i,iput+i,array_fr(iput+i+1),i=0,8*nAS,nAS)                 
      end if      ! iflag_SAMP 
                                                                        
      return 
      END                                           
