      subroutine th_rhoSingleLine(isubthe,icase,iput,iget,info) 
      use glbconst, only: icstrf,ivstrf,enwr
      use comthe, only: array_fr,theoryname
      implicit none 

      integer       isubthe,icase,iput,iget,info 

      integer       ifrth,iflag_basis,iend
      common/strLOC/ifrth(12),iflag_basis,iend(19)

      real           avm,Pxsi,Peta,Pzeta,dumvm 
      common/avmaps/ avm,Pxsi,Peta,Pzeta,dumvm(ivstrf-4) 
      logical        b_vm,b_dumvm 
      common/bvmaps/ b_vm,b_dumvm(ivstrf-1) 
      real           c1,dumcm 
      common/acmaps/ c1,dumcm(icstrf-1) 
      integer        jge
      complex,dimension(4)     :: rho
      complex hrtr,hrpm

      info=0
      if(isubthe.lt.0) then 
       theoryname='Single_polarized_Line       v=000' 
       jge=1 
       c1=2*jge+14 
       return 
      end if 
      if(iget.eq.0) print'(a)','iget not defined'      
                                                                        
      if(.not.b_vm) then 
       isubthe=-abs(isubthe) 
       return 
      end if                                                                    
!      write(6,'(a,3f10.2)') ' Poincare =', Pxsi,Peta, Pzeta             
!      (11 12))     fortran  ( 1 3 )                                    
!      (21 22)               ( 2 4 )                                    
!                       effi ( 1 3 )                                    
!                            ( 4 2 )                                    
!     !!!!! 2x2 matrices on array_fr use always effi notation !!!!      
!     Fortran notation                                                  
!     if(iflag_basis.eq.1) then
      rho(1)=cmplx(1.+Pzeta,0.)/2. 
      rho(3)=cmplx(Pxsi,-Peta)/2. 
      rho(2)=cmplx(Pxsi,Peta)/2. 
      rho(4)=cmplx(1.-Pzeta,0.)/2.

!     else if(iflag_basis.eq.0) then 
!     if (iflag_basis.eq.0) transformation with TrhoT+
!     T=1/sqrt(2)( 1 -1)
!                (-i -i)   (see iflag_basis.eq.0)
!     Ts_0T+=s_0,Ts_1T+=-s_3, Ts_2T+=s_1, Ts_3T+=-s_2 
!      rho(1)= cmplx(1.-Pxsi,0.)/2. 
!      rho(3)= cmplx(Peta,Pzeta)/2.  
!      rho(2)= cmplx(Peta,-Pzeta)/2.   
!      rho(4)= cmplx(1.+Pxsi,0.)/2.  
!     end if

      if(enwr(7).eq.'3rho')then 
       print'(a,4f8.2)', 'SL  rho=', rho(1),rho(3)                     
       print'(a,4f8.2)', '        ', rho(2),rho(4) 
      end if

      array_fr(iput+1)=cmplx(float(iput)+1,0.0) 
      jge=1
      ! nall=1
      array_fr(iput+2)=cmplx(1.0,float(jge)) 
      ! bxx=.false.
      array_fr(iput+3)=(0.,2.)
      ! Eagd=0
      array_fr(iput+4)=cmplx(0.0,0.0) 
      array_fr(iput+5)=cmplx(real(rho(1)-rho(4)),real(rho(1)+rho(4)))/2.
      array_fr(iput+6)=rho(3)
          hrtr=cmplx(real(rho(1)-rho(4)),real(rho(1)+rho(4)))/2.
          hrpm=rho(3) 
!          write(6,'(a)')' Esource='
!          write(6,'(8f10.2)')hrtr*100,hrpm*100
          ! fd=1 
      array_fr(iput+16)=cmplx(1.1,0.0)
 
                                                                        
      return 
      END                                           
                                                                        

     subroutine th_hdeqf(isubthe,icase,iput,iget,info) 
       use glbconst, only: maxscrd,icstrf,icfr2trf,ivstrf,ivfr2trf, &
                           ipostxtu,infotext,enwr
     use comthe, only: array_fr,real_fr,nproc,theoryname,thetaz,phiz
     implicit none 
                                                                        
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info

!    transmission: fr2 defines external magnetic field, the orientation    
!    of the sample by phi,theta,psi is calculated by the routine "sample
!    orientation" and tansferred by  array_fr to main and passed to fr2
                                                                        
     real            acfr2,rep_grp,aset,asymmetry,a_psi,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,               &
                     dumcfr2(icfr2trf-5)                               
     logical         bcfr2,bumcfr2 
     common/bcfr2trf/bcfr2,bumcfr2(icfr2trf-1) 
     real            avfr2,dum5,Hext,thetaHe,phiHe,                    &
                     phi_ls,theta_ls,psi_ls,                           &
                     d_x2,eta_xx,phi_xx,theta_xx,psi_xx,               &
                     t00,t100,t11s,t11c,t200,t21s,t21c,t22s,t22c,t300,t400,&
                     dumvfr2             
     common/avfr2trf/avfr2,dum5(5),Hext,thetaHe,phiHe,                 &
                     phi_ls,theta_ls,psi_ls,                           &
                     d_x2,eta_xx,phi_xx,theta_xx,psi_xx,               &
                     t00,t100,t11s,t11c,t200,t21s,t21c,t22s,t22c,t300,t400,&
                     dumvfr2(ivfr2trf-28)                    
!    b_phi is named b_laba (laboratory angles of the sample)           
!    b_laba has got the value of b_phi.or.b_theta.or.b_psi             
!    in the routine th_sampleorient                                    
!    b_dum5(5) is reserved place for the parameters thicklay,re_chilay,
!    ai_chilay,roughness,xxx  which are used in scattering theories,   
     logical         b_vfr2,b_dum5,b_Hext,b_thetaHe,b_phiHe,           &
                     b_laba,b_thetals,b_psils,b_dx2,b_etaxx,           &
                     b_phixx,b_thetaxx,b_psixx,b_dumvfr2 
     common/bvfr2trf/b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe,        &
                     b_laba,b_thetals,b_psils,b_dx2,b_etaxx,           &
                     b_phixx,b_thetaxx,b_psixx,b_dumvfr2(ivfr2trf-17)    
                                                                       
     real          ac1,symcase,timeinvers,cTms,                         &
                   ajg,aje,amueg,amuee,QgdQe,r_QUDI,e1m1,dumc          
     common/acmaps/ac1,cTms,ajg,aje,amueg,amuee,QgdQe,r_QUDI,e1m1,      &
                   symcase,timeinvers,dumc(icstrf-11)                  
     logical       b_ac1,b_dum 
     common/bcmaps/b_ac1,b_dum(icstrf-1) 
!    arrays derived from constants are calculated only once (transforma
!    matrices for equivalent orientations, clebsch Gordan coefficients 
!    in the routine  hamJgJe, ...)                                     
                                                                       
     real          avss,                                               &
                   dsx2,eta_sx,phi_sx,theta_sx,psi_sx,                 &
                   aH,thetaH,phiH,DEq,eta,phi_CE,theta_CE,psi_CE,dumvss
     common/avmaps/avss,                                               &
                   dsx2,eta_sx,phi_sx,theta_sx,psi_sx,                 &
                   aH,thetaH,phiH,DEq,eta,phi_CE,theta_CE,psi_CE,      &
                   dumvss(ivstrf-14)                                   
     logical       b_vss,                                              &
                   b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,           &
                   b_aH,b_thetaH,b_phiH,                               &
                   b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvss         
     common/bvmaps/b_vss,                                              &
                   b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,           &
                   b_aH,b_thetaH,b_phiH,                               &
                   b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,                 &
                   b_dumvss(ivstrf-14)                                 
                                                                       
!    logical avssfr,avari,dumvssfr                                     
!    common/avsstrf/avssfr,avari(17),dumvssfr(ivsstrf-18)              
!    logical b_vssfr,b_vari,b_dumvssfr                                 
!    common/bvsstrf/b_vssfr,b_vari(17),b_dumvssfr(ivsstrf-18)          
                                                                       
                                                                       
!    parameter(maxloop=5,..) has also to be changed in sym_equiv(...)  
      integer,parameter::maxloop=11,ivv=90,iec=ivv+25,icl=iec+25,       &
                        iecv=icl+9,id1=iecv+9,id2=id1+1+10*maxloop,     &
                        istore=id2+25*maxloop  

     real,dimension(maxloop)  :: timeinv   
     complex,dimension(-2:2):: efg,efgPAS,efgC,efgC0,efgL,xxPAS,sx2C,sx2C0,  &
                               x2C,x2C0,x2Clab
     complex,dimension(-1:1)     :: hv,hvL,hvC,hvC0,hve
     complex,dimension(-2:2,-2:2):: Dcct,Dect,Dsxct,Dxxct,Dslt,Dclt,Dcpt    
     complex,dimension(-1:1,-1:1):: Dccv,Decv,Dslv,Dclv,DclvI,Dcpv
     complex,dimension(-2:2,-2:2,maxloop):: d2
     complex,dimension(-1:1,-1:1,maxloop):: d1
     complex,dimension(maxloop)  :: ctimeinv
                                                                       
     complex,dimension(istore):: store
     complex      caseloop
     equivalence (store(1),efgPAS(-2)),(store(6),efgC(-2)),            &
                 (store(11),efgL(-2)),(store(16),xxPAS(-2)),           &
                 (store(21),sx2C(-2)),(store(26),x2C(-2)),             &
                 (store(31),hve(-1)),(store(34),hvC(-1)),              &
                 (store(37),hvL(-1)),(store(40),Dect(-2,-2)),          &
                 (store(65),Dsxct(-2,-2)),(store(ivv),Dxxct(-2,-2)),   &
                 (store(iec),Dslt(-2,-2)),                             &
                 (store(icl),Decv(-1,-1)),(store(iecv),Dslv(-1,-1)),   &
                 (store(id1),caseloop),(store(id1+1),ctimeinv(1)),     &
            (store(id1+1+maxloop),d1(-1,-1,1)),(store(id2),d2(-2,-2,1))
                                                                       

     integer,parameter:: idumscrd=maxscrd-6144*2-128*3-9*24 
     real        thetaOM,phiOM,eh,mat,dumscrd 
     common/scrd/phiOM(6144),thetaOM(6144),                            &
                 eh(3,128),mat(3,3,24),dumscrd(idumscrd)               
     real,parameter :: sqrt2=1.4142136,q62=1.224745,sqrt23=0.816497,   &
                       sqrt6=2.44950,rad=0.0174533,pi=3.14159           

     integer i,j,k,m,n,ip,ii,iset,isymmetry,n_psi,jpsi,iOM,jOM,        &
             je,jg,jge,ncase,                                          &
             nloop,nloop_b,nloop_e,jloop,nput,jljpjO,n_all,jtxtu
     logical b_He,b_Hi,b_Hea,b_Hegt0,b_Higt0,b_Hgt0,                   &
             b_eq,b_eqa,b_eqgt0,b_sx2,b_sx2a,b_sx2gt0,                 &
             b_x2,b_x2a,b_x2gt0,b_xx,b_hf,b_laba0,b_integer
     real    a_mueg,a_muee,c_Tms,efg0,efg2,x22,sx22,aszz,azz,          &
             texture,Stexture,cost,cost2,sint,cosp,sinp,cos2p,sin2p,   &
             pp,hmm,r_delta2,h,hx,hy,hz,psi_OM

     real    phiH_r,thetaH_r,phi_r,theta_r,psi_r,phiE_r,thetaE_r,      &
             psiE_r,phiHe_r,thetaHe_r    
     real, save :: start,finish, wstart,wfinish
     complex pm,hc1,ap,aq
     character(len=2)  :: w6
     character(len=4)  :: ext          
     
     real,    dimension(:),   allocatable :: Eagd,eagd_zz,txtuGT0
     complex, dimension(:),   allocatable :: eagdzz
     complex, dimension(:,:), allocatable :: V1m
     complex, dimension(:,:), allocatable :: V2m
     integer, dimension(:,:,:),allocatable ::jOLP
     
     complex, parameter:: C0=cmplx(0.,0.), Ci=cmplx(0.,1.), C1=cmplx(1.,0.)


!      write(6,'(a)')' th_hdeqf avmaps ::'                              
!      write(6,'(6f12.3)')avss,   &                                         
!                   dsx2,eta_sx,phi_sx,theta_sx,psi_sx,  &              
!                   aH,thetaH,phiH,DEq,eta,phi_CE,theta_CE,psi_CE            
!      write(6,'(a,10f10.2)') ' acmaps:',&
!            ac1,cTms,ajg,aje,amueg,amuee,QgdQe,r_QUDI,e1m1
      jge=(2.*ajg+1)*(2.*aje+1)+0.01 

      if(acfr2.lt.3.)aset=0.0 
!     this way iset,... have not to be defined in frstr_..              
      if(isubthe.lt.0) then 
       theoryname='H_DEQ_f_equivalent_sites      v=200' 
       if(isubthe.eq.-16) then 
!       reading .par file ncase,symcase are not mapped (-> 8888.88)     
!       asking name with isubthe=-1 the routine sym_equiv (later        
!       calculating storage space) leads to an error exit               
        symcase=0.0 
        ncase=0 
        return 
       end if 
!      routines only asking for the name (not values for storage space) 
!      put isubthe to -16 (far away from -ntheory)                      
                                                                        
       ncase=symcase 
       call sym_equiv(-ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
       iset=aset 
       if(nloop.eq.-1)nloop=0          ! only 1 rotation 
       if(iset.gt.0) then 
        isymmetry=asymmetry 
        n_psi=a_psi 
        call sphere(-iset,isymmetry,.false.,iOM,phiOM,thetaOM)
        if(iOM.eq.0) then 
         print'(a,i3,ai2)','iset=',iset,'  isymmetry=',isymmetry
         info=1 
         infotext(1)=' ' 
         infotext(2)(1:17)='*** error ***' 
         infotext(3)='meaningless values of constants iset/isymmetry' 
         infotext(4)=                                                   &
              'help available: {co a}, {he cn} (n=number of constant)'    
         infotext(5)=' ' 
         return 
        end if 
        i=1+istore+2+3*jge*(nloop+1)*iOM*(n_psi+1)+iOM 
        if(iOM.eq.1)i=i+2 
        ac1=i 
       else 
        ac1=1+istore+2+3*jge*(nloop+1)+2
        n_psi=0  
       end if 
       return 
      end if 
      if(.not.(b_vss.or.b_vfr2).and.thetaz.eq.0.0) then 
       isubthe=-abs(isubthe)             ! 24.10.07 theory not changed  
!       write(6,'(a)') ' no change'                                     
       return 
      end if 

      if(iget.eq.0) print'(a)','iget not defined'      
! ----------------------------------------------------------------------
  if(e1m1.eq.0.0)e1m1=-1.0   ! see comment  subroutine th_hdeq()
  allocate(Eagd(jge),eagd_zz(2*jge),V1m(-1:1,jge),V2m(-2:2,jge),eagdzz(jge))
  ! the odd numbers i of eagd_zz(i) are used for jge eigenvalues
  ! the even numbers 2,4,6,8,10 are used for MSD-values
  ! jge>5 is fulfilled for all implemented nuclei

      j=iput+1 
      nput=j+istore 
      do i=1,istore 
       store(i)=array_fr(j+i) 
      end do 
      array_fr(j)=cmplx(float(nput),float(istore)) 

!     bvfr2trf                                                           
!     external magnetic field                                           
      b_Hea=b_thetaHe.or.b_phiHe 
      b_He=b_Hext.or.b_Hea 
!     orientation of the crystal/sample in the la. system               
      b_laba=b_laba.or.b_thetals.or.b_psils
!    write(6,'(a,3f10.2)')'Hext,thetaHe,phiHe=',Hext,thetaHe,phiHe     
!    write(6,'(a,6f10.2)')'d_x2,eta_xx,phi_xx,theta_xx,psi_xx=',&
!         d_x2,eta_xx,phi_xx,theta_xx,psi_xx
!    write(6,'(a,3f10.2)')'22nuc phils,thetals,psils=',phi_ls,theta_ls,psi_ls
!    write(6,'(a,10f10.2)')'t=',t00,t100,t11s,t11c,t200,t21s,t21c,t22s,t22c,t400
!    write(6,'(15f10.2)')avss,dsx2,eta_sx,phi_sx,theta_sx,psi_sx,&
!                   aH,thetaH,phiH,DEq,eta,phi_CE,theta_CE,psi_CE
!     <x2> of the crystal                                               
      b_x2a =b_phixx.or.b_thetaxx.or.b_psixx 
      b_x2  =b_dx2.or.b_etaxx.or.b_x2a 
      
!    avmap                                                              
!    <sx2> of the called site of the crystal                            
      b_sx2a=b_phisx.or.b_thetasx.or.b_psisx 
      b_sx2 =b_dsx2.or.b_etasx.or.b_sx2a 
!     internal magnetic field at the called site of the crystal         
      b_Hi=b_aH.or.b_thetaH.or.b_phiH 
!     electric field gradient at the called site of the crystal         
      b_eqa=b_phiE.or.b_thetaE.or.b_psiE 
      b_eq=b_DEq.or.b_eta.or.b_eqa 
                                                                        
!     hyperfine parameter (He depends on angles phi,theta,psi)          
      b_hf=b_He.or.b_Hi.or.b_eq.or.b_laba 
!     <x2>+<sx2> (<x2> depends on angles phi,theta,psi)                 
      b_xx  =b_dsx2.or.b_sx2.or.b_dx2.or.b_x2.or.b_laba 

      ii=jge/2 
      if(2*ii.eq.jge) then 
       b_integer=.false. 
       je=2*aje+0.01 
       jg=2*ajg+0.01 
      else 
       b_integer=.true. 
       je=aje+0.01 
       jg=ajg+0.01 
      end if 

      a_mueg=amueg 
      a_muee=amuee 
      c_Tms=cTms 
                                                                        
      n_psi=a_psi 
      iset=aset; if(iset.eq.0) n_psi=0
      jtxtu=10*(0.001+aset-iset)
      if(iset.eq.0)then
         n_psi=0; jtxtu=0
      end if  
      ncase=symcase 
      isymmetry=asymmetry 
                                                                        
      nloop_b=0 
      if(b_ac1) then 
       call sym_equiv(ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
       nloop_e=nloop
!       write(6,'(a,i6)')'th_22nuclear nloop_e=',nloop        
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      else 
       nloop=real(caseloop) 
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      end if 
      do k=1,nloop_e 
         timeinv(k)=real(ctimeinv(k))
      end do 
                                                                        
      if(bcfr2) then 
       call sphere(iset,isymmetry,.false.,iOM,phiOM,thetaOM)
       caseloop=cmplx(float(nloop),float(iOM)) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if
       j=(nput+2+3*jge*n_all)*2 
       do i=1,iOM 
        k=(i-1)*2+j 
        real_fr(k+1)=phiOM(i) 
        real_fr(k+2)=thetaOM(i) 
       end do 
      else 
       iOM=aimag(caseloop) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if 
       j=(nput+2+3*jge*n_all)*2 
       do i=1,iOM 
        k=(i-1)*2+j 
        phiOM(i)=real_fr(k+1) 
        thetaOM(i)=real_fr(k+2) 
       end do 
      end if 
      caseloop=cmplx(float(nloop),float(iOM)) 
                                                                        
                                                                        
!     <sx2> tensor                                                      
      b_sx2gt0=abs(dsx2).gt.0.
      if(b_sx2) then 
       if(b_sx2a)then 
!       The Euler angles rotate the crystal system S_C to the PAS S_sx2 
!       of <sx2> tensor.The Euler angles are obtained with the          
!       program called by  {eu} [1 Euler angles from unit vectors]      
!       ->[unit vectors eb(n) in system Sa].                            
!       nput are the unit vectors eb(x,y,z)=e_sx2 of S_sx2 with respect
!       to the crystal system S_C.                                      
!       The transformation Dsxct(-gamma,-theta,-alpha) transforms       
!       the tensor components to the crystal system.                    
!       Symbolic:  e_sx2 in S_C  -> t_C=t_sx2*d^(-1)                    
        call dimj(-psi_sx*rad,-theta_sx*rad,-phi_sx*rad,2,Dsxct)
       end if 
                       
!      xxPAS (-2..2) are the spherical tensor components of <sx2> in the
!      S_sx2 system. The tensor is attached to site 1 (of nloop+1       
!      equivalent sites) of the crystal.                                
       sx22=eta_sx/sqrt(6.) 
                                                                        
       xxPAS(0)=cmplx(1.,0.0) 
       xxPAS(-1)=C0 
       xxPAS(1) =C0 
       xxPAS(-2)=cmplx(sx22,0.) 
       xxPAS(2)=cmplx(sx22,0.) 
       
       call vecxmat(2,xxPAS,Dsxct,sx2C)
!      sx2C(n) are the components of the tensor in the crystal system.  
!      Taking these components (the Cathesian one) to the program called
!      by  {eu} [9 Euler angles of PAS of 2. rank tensor]               
!      the PAS-values and Euler angles are obtained back.               
      end if   ! b_sx2   
                                                                        
!     <x2> tensor                                                       
!     see comment on the <sx2> tensor                                   
      b_x2gt0=abs(d_x2).gt.0. 
      if(b_x2) then 
       if(b_x2a) call dimj(-psi_xx*rad,-theta_xx*rad,-phi_xx*rad,2,Dxxct)
                                                                        
       x22=eta_xx/sqrt(6.) 
       xxPAS(0)=cmplx(1.,0.0) 
       xxPAS(-1)=C0 
       xxPAS(1) =C0 
       xxPAS(-2)=cmplx(x22,0.) 
       xxPAS(2)=cmplx(x22,0.) 
                                                                      
       call vecxmat(2,xxPAS,Dxxct,x2C)   
      end if ! b_x2 
                                                                        
      phiE_r  =phi_CE*rad 
      thetaE_r=theta_CE*rad 
      psiE_r  =psi_CE*rad 
                                                                        
      b_eqgt0=abs(DEq).gt.0. 
      if(b_eq)then 
!      efg (-2..2) are the spherical tensor components of the EFG in the PAS
       efg0=1.0/sqrt(1.+eta**2/3.) 
       efg2=eta*efg0/sqrt(6.) 
                                                                        
       efgPAS(0)=cmplx(efg0,0.0) 
       efgPAS(-1)=C0 
       efgPAS(1) =C0 
       efgPAS(-2)=cmplx(efg2,0.) 
       efgPAS(2)=cmplx(efg2,0.) 
                                                                        
       if(b_eqa) call dimj(-psiE_r,-thetaE_r,-phiE_r,2,Dect) 
       call vecxmat(2,efgPAS,Dect,efgC)
      end if  ! b_eq
                                                                        
!-----enable write----- tensors (site 1) in the crystal system --------------
       if(enwr(6)(1:2).eq.'s1') then   !  'cx', 'sx', 'ef'
        w6=enwr(6)(3:4)
        call writetensors1(w6,d_x2,x2C,dsx2,sx2C,phiE_r,thetaE_r,psiE_r,efgC)
       end if 
!------end enable write---------------------------------------------    
                                                                        
!     Transformation of the tensors sx2,x2 tensor given in the crystal  
!     system  to the lab-system.                                        
!     The gamma-direction is parallel to +z of the lab-system.          
!     The orientation of the crystal in the laboratory is decribed by   
!     the Euler angles (phi,theta,psi). e_z(S_C) in the la. system S_L  
!     determines phi,theta, which are the polar angle of e_z(S_C).      
!     The Euler angles are obtained with the                            
!     program euler in the directory effi/helproutines/euler:           
!      [1 Euler angles from unit vectors]->[unit vectors eb(n) in system
!      nput are the unit vectors e_C=eb(x,y,z) of the crystal system S_C
!      with respect to the lab. system S_L.                             
!     The tensor components known in the system S_C are tranformed to th
!     Lab. system by the invers transformation Dsl(-psi,-theta,-phi).   
!     Symbolic:  e_C in S_L  -> t_L=t_C*dlc^(-1)                        
!     (see comment for sx2 above)                                       
      b_laba0=abs(phi_ls)+abs(theta_ls)+abs(psi_ls).lt.0.001
!      if(b_laba)then 
       phi_r=phi_ls*rad 
       theta_r=theta_ls*rad 
       psi_r=psi_ls*rad
!      1. rank tensor transformation matrix: crystal/sample to Lab      
       call dimj(-psi_r,-theta_r,-phi_r,1,Dslv) 

       if(enwr(6).eq.'gdir')then
         call matrixinvers(1,Dslv,DclvI)
         hve(-1)=C0; hve(1)=C0; hve(0)=(1.,0.)
         call vecxmat(1,hve,DclvI,hvL)
         w6='hf'; j=-1
         call writetensorsi(w6,d_x2,x2C,dsx2,sx2C,efgC,hvL,j)        
        end if
      
!      2. rank tensor transformation matrix: crystal/sample to Lab       
       call dimj(-psi_r,-theta_r,-phi_r,2,Dslt)
!      end if ! b_laba (lab angle) 
                                                                        
!     write(6,'(10f8.4)')Dslt                                           
!     electric field gradient tensor  transformed to the crystal system 
!     (see comment for sx2 above)                                       

!     magnetic field                                                    
      b_Hegt0=abs(Hext).gt.0.0 
      b_Higt0=abs(aH).gt.0.0 
      b_Hgt0=b_Higt0.or.b_Hegt0 
      if(b_hf) then 
       phiH_r=phiH*rad 
       thetaH_r=thetaH*rad 
       hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*                          &
                     sin(thetaH_r)/sqrt2                              
       hv(0) = cmplx(cos(thetaH_r),0.0) 
       hv(-1)=-conjg(hv(1)) 
!      write(6,'(a,f10.1,a2,6f10.4)') 'hv  = ',aH,'*(',hv               
                                                                        
       if(icase.eq.1) then 
!       internal field with respect to the EFG system                   
!       transformation of the magnetic field H from the  S_E to the     
!       crystal system S_C. hvC(n) in the crystal system  S_C.          
        if(b_eqa) call dimj(-psiE_r,-thetaE_r,-phiE_r,1,Decv) 
        call vecxmat(1,hv,Decv,hvC)   
       else 
!       magnetic field given in the crystal system Sc                   
        hvC= hv 
       end if ! case 1
      end if  ! b_Hi
                                                                        
!-----enable write---H-field in the crystal system -----------------    
      if(enwr(6).eq.'s1hf') then 
       hx=-real(hvC(1)-hvC(-1))/sqrt2*aH
       hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2*aH 
       hz= real(hvC(0))*ah 
       print '(/,a,3f8.3,a1)','        h_C =   (', hx,hy,hz,')' 
      end if 
!--------------------------------------------------------------------   
                                                                        
!      external field defined in the LAB system S_L                     
       if(b_Hea)then 
        phiHe_r=phiHe*rad 
        thetaHe_r=thetaHe*rad 
        hve(1) =-cmplx(cos(phiHe_r),sin(phiHe_r))*                      &
                       sin(thetaHe_r)/sqrt2                            
        hve(0) = cmplx(cos(thetaHe_r),0.0) 
        hve(-1)=-conjg(hve(1))
       end if 
                                                                        
!      storing the tensors of the 1. site if there are nloop+1          
!      equivalent sites (nloop >0)                                      
       efgC0=efgC 
       sx2C0=sx2C 
       x2C0=x2C 
       hvC0 =hvC 
                                                                        
!      ----------------------------------------------------             
!       thetaOM(1)=54.7*rad                                             
!       phiOM(1)=pi/4.                                                  
!       thetaOM(1)=0.                                                   
!      Omega loop in case of an average over different crystal          
!      orientations: powder, texture                                    
!      ----------------------- loops-----------------------             
      if(enwr(15).eq.'time') then
          call cpu_time(start);  call wall_time(wstart)
      end if
      allocate(txtuGT0(iOM))     
      Stexture=0.0;  txtuGT0=0.0
!      write(6,'(i4,9f10.1)')iOM,t00,t100,t11s,t11c,t200,t21s,t21c,t22s,t22c
      do jOM=1,iOM
!      texture functions, parameters
!      (t00,t100,t11s,t11c,t200,t200,t21s,t21c,t22s,t22c,t300,t400) describe 
!      the theta,phi- dependence of texture seen by a dipole transition  
!      t00,t100,t200,t300,t400 describe axial texture
!      for mixed M1/E2 transition 
!      write(6,'(i4,3f10.1)')jOM,thetaOM(jOM)/rad,phiOM(jOM)/rad
        select case(jtxtu)
        case(0)         ! ideal powder
         texture=1.     
        case(1)         ! M1,E1: axial symmetry of texture
         cost=cos(thetaOM(jOM)); cost2=cost**2
         texture=t00+t100*cost+t200*(3.0*cost2-1.)
        case(2)         ! dipole: Theta,phi distribution 
         cost=cos(thetaOM(jOM));  sint=sin(thetaOM(jOM));
         cosp=cos(phiOM(jOM));    sinp=sin(phiOM(jOM))
         cos2p=cos(2.*phiOM(jOM));sin2p=sin(2.*phiOM(jOM))
         cost2=cost**2
         texture=t00+t100*cost+(t11s*sinp+t11c*cosp)*sint            &
                  +t200*(3.0*cost2-1.)+((t21s*sinp+t21c*cosp)*cost  &
                  +(t22s*sin2p+t22c*cos2p)*sint)*sint

        case(3)    ! E2: axial symmetry of texture
         cost=cos(thetaOM(jOM)); cost2=cost**2
         texture=t00+t100*cost+t200*(3.0*cost2-1.)                   &
              +t300*cost*(5.0*cost2-3.)+t400*((35*cost2-30)*cost2+3.)
        case(4)    ! E2: Theta,phi distribution (t3mn, t4mn terms are missing!!)
         cost=cos(thetaOM(jOM));  sint=sin(thetaOM(jOM));
         cosp=cos(phiOM(jOM));    sinp=sin(phiOM(jOM))
         cos2p=cos(2.*phiOM(jOM));sin2p=sin(2.*phiOM(jOM))
         cost2=cost**2
         texture=t00+t100*cost+(t11s*sinp+t11c*cosp)*sint            &
                  +t200*(3.0*cost2-1.)+((t21s*sinp+t21c*cosp)*cost  &
                  +(t22s*sin2p+t22c*cos2p)*sint)*sint               &
                  +t300*cost*(5.0*cost2-3.)+t400*((35*cost2-30)*cost2+3.)      
        case(5)    ! model: ellipsoidal distribution (always >0!)
         cost2=cos(thetaOM(jOM))**2
         texture=1./sqrt(1.+(t200**2-1.)*cost2)
      end select
        txtuGT0(jOM)=texture
        Stexture= Stexture+ texture 
      end do
      if(enwr(6).eq.'txtu')then
         m= ipostxtu/10
         if(m.eq.1)then
            ext(1:2)='ds'
         else
            ext(1:2)='da'
         end if   
       m=ipostxtu-10*m 
        ext(3:4)='L'//char(m+48)    
       open(unit=2,file='direction.'//ext,       &
         status='unknown',access='sequential',form='formatted')
       write(2,'(a,/,a)') '# Orientations: z-axes',          &       
                          '(f10.3,f10.3,f10.3)   x y z '
       write(2,'(a,i4)')'nu_channels  =',iOM
       do jOM=1,iOM
        write(2,'(3f10.3)') &
           cos(phiOM(jOM))*sin(thetaOM(jOM)),  &
           sin(phiOM(jOM))*sin(thetaOM(jOM)),cos(thetaOM(jOM))
       end do
       write(2,'(3f10.3)') float(iOM),0.000,-1.000
       write(2,'(3f10.3)') -1.000,-1.000, -1.000
       write(2,'(a1)')'x','y','z'
       close(unit=2)

       open(unit=3,file='texture.'//ext,          &
            status='unknown',access='sequential',form='formatted')
       if(abs(t100).lt.0.01) then
        write(3,'(a,2(a,f5.2))')' weighted directions of layer '// ext,  &
            ':  t00=',t00,' t100=0.0  t200=',t200
       else
        write(3,'(a,3(a,f5.2))')' weighted directions of layer '// ext,  &
             ':  t00=',t00,' t100=',t100,' t200=',t200
       end if
       write(3,'(a,/,a,i4)')  '(4f10.3)   x y z dz','nu_channels  =',iOM     
      end if
      allocate(jOLP(iOM,0:nloop_e,0:n_psi))
      jljpjO=0 
      do jOM=1,iOM
         do jloop=nloop_b,nloop_e
         do jpsi=0,n_psi
          jljpjO=jljpjO+1  
          jOLP(jOM,jloop,jpsi)=jljpjO
         end do
       end do
      end do

      h=float(iOM)/float(jljpjO)
      txtuGT0=txtuGT0/Stexture*h
      if(enwr(6).eq.'txtu')then
         h=0.
         do jOM=1,iOM
          if(h.lt.abs(txtuGT0(jOM))) h=abs(txtuGT0(jOM))
        end do
       do jOM=1,iOM
        texture=txtuGT0(jOM)/h
          
        hv(1)=C0; hv(-1)=C0; hv(0)=C1*texture
        call dimj(0.0,-thetaOM(jOM),-phiOM(jOM),1,Dcpv)
        Dclv=matmul(Dcpv,Dslv)
        call vecxmat(1,hv,Dclv,hvL)
        hx=-real(hvL(1)-hvL(-1))/sqrt2 
        hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2  
        hz= real(hvL(0))
        write(3,'(4f10.3)')hx,hy,hz,texture
       end do
       write(3,'(3f10.3)') float(iOM),0.000,-1.000
       write(3,'(3f10.3)') -1.000,-1.000, -1.000
       write(3,'(a1)')'x','y','z'
       close(unit=3)
!       print'(a,i4,f12.2)','iOM,Stexture=',iOM,Stexture
      end if

      psi_OM=2.*pi/(n_psi+1) 
     

      CALL OMP_SET_NUM_THREADS(nproc)
!!$OMP PARALLEL DEFAULT(PRIVATE) &
!!$OMP SHARED(enwr,phiOM,thetaOM,iOM,txtuGT0,d1,d2)&
!!$OMP SHARED(nloop_b,nloop_e,efgC0,hvC0,x2C0,sx2C0,timeinv)&
!!$OMP SHARED(b_Higt0,b_eqgt0,b_x2gt0,b_sx2gt0,b_Hgt0,b_laba0,b_integer) &  
!!$OMP SHARED(n_psi,psi_OM,Dslv,Dslt,d_x2,dsx2,DEq,hve,aH,Hext,r_QUDI,e1m1)&
!!$OMP SHARED(icase,amueg,amuee,QgdQe,cTms,je,jg,jge,nput,jOLP,array_fr,thetaz,phiz)
!!$OMP DO      
      
     do jOM=1,iOM
      texture=txtuGT0(jOM)
!     loop over equivalent sites. In the routine sym_equiv(...,d1,d2)  
!     the transformations d1 and d2 and timeinv() are defined          
!     write(6,'(a,2i4)')' nloop_b,nloop_e=',nloop_b,nloop_e            

      do jloop=nloop_b,nloop_e 
       if(jloop.gt.0) then 
        if(b_Higt0) then 
         do n=-1,1 
          hc1=C0 
          do m=-1,1 
           hc1=hc1+hvC0(m)*d1(m,n,jloop) 
          end do 
          hvC(n)=hc1*timeinv(jloop) 
         end do 
        end if 
                                                                       
        if(b_eqgt0)then 
         do n=-2,2 
          hc1=C0 
          do m=-2,2 
           hc1=hc1+efgC0(m)*d2(m,n,jloop) 
          end do 
          efgC(n)=hc1 
         end do 
        end if 

        if(b_x2gt0)then 
         do n=-2,2 
          hc1=C0 
          do m=-2,2 
           hc1=hc1+x2C0(m)*d2(m,n,jloop) 
          end do 
          x2C(n)=hc1 
         end do
        end if
      
        if(b_sx2gt0)then 
         do n=-2,2 
          hc1=C0 
          do m=-2,2 
           hc1=hc1+sx2C0(m)*d2(m,n,jloop) 
          end do 
          sx2C(n)=hc1 
         end do
        end if 

       else 
        efgC=efgC0 
        x2C =x2C0 
        sx2C=sx2C0 
        hvC=hvC0 
       end if   ! jloop > 0   
                                                                        
!------enable write--- of site i ------------------------------------   
       if(enwr(6)(1:2).eq.'si') then  ! 'sx', 'cx', 'ef', 'hf' 
        w6=enwr(6)(3:4)
        call writetensorsi(w6,d_x2,x2C,dsx2,sx2C,efgC,hvC*aH,jloop)
       end if 
!------enable write--- of site i ------------------------------------   
                                                                        
       do jpsi=0,n_psi 
!       averaging over psiOM with n_psi+1 steps                         
!       write(6,'(a,i4,f10.3)')' jpsi,texture=',jpsi,texture            

        if(b_Hgt0) then 
!        The grid point p(thetaOM,phiOM) defines z-axis of the system   
!        S_S of the sample. (If the sample is not rotated S_S coincides 
!        with the lab. system S_L, and the z_axis is the direction of   
!        observation).                                                  
!        The rotation around the z-axis starts with angle psiOM=0         
!        and has n_psi steps for averaging. The components in the       
!        S_OM system are                                                
!        Symbolic:  e_OM in S_C  -> t_C*dcs=t_OM   (t_S=t_OM)           
!        If the sample system S_S  is rotated with respect to the Lab. s
!        -Dsl (=djsl)- the tensor components are                        
!        transformations are:                                           
!         Symbolic:  e_S in S_L  -> t_L=t_S*dls^(-1)                    
!                                   t_L= t_C*dcs*dls^(-1)               
         call dimj(jpsi*psi_OM,-thetaOM(jOM),-phiOM(jOM),1,Dcpv)
!        call dimj(-phiOM(jOM),-thetaOM(jOM),jpsi*psi_OM,1,Dcpv) 
         if(b_laba0)then 
!         1. rank tensor transformation                                 
          Dclv=Dcpv 
         else
          Dclv=matmul(Dcpv,Dslv)
         end if
         call vecxmat(1,hvC,Dclv,hvL)
         hvL=hvL*aH+hve*Hext 
        else 
         hvL=C0
        end if    ! b_Hgt0 
        call dimj(jpsi*psi_OM,-thetaOM(jOM),-phiOM(jOM),2,Dcpt) 
!        call dimj(-phiOM(jOM),-thetaOM(jOM),jpsi*psi_OM,2,Dcpt) 
!       2. rank tensor transformation                                  
        if(b_laba0)then 
         Dclt=Dcpt 
        else 
         Dclt=matmul(Dcpt,Dslt) 
        end if 

        if(b_eqgt0)then
         call vecxmat(2,efgC,Dclt,efgL)   
         efgL=efgL*DEq
        else 
          efgL=C0 
        end if   ! b_eqgt0
                                                                        
        if(b_sx2gt0)then 
         hc1=C0 
         do m=-2,2 
          hc1=hc1+sx2C(m)*Dclt(m,0) 
         end do 
         aszz=real(hc1) 
        else 
         aszz=0. 
        end if  ! b_sx2gt0   
                                                                        
        if(b_x2gt0)then 
         call vecxmat(2,x2C,Dclt,x2Clab)   
         azz=real(x2Clab(0)) 
        else 
         azz=0. 
        end if   ! b_x2gt0  
!-------------------------------------------------------------------
        ! transformation of hvL and efgL
        if(thetaz.ne.0) then
!        print'(5f10.1)',phiz/rad,thetaz/rad  
         hv=hvL; efg=efgL  
         call dimj(phiz,thetaz,0.0,1,Dccv) 
         call vecxmat(1,hv,Dccv,hvL)   
         call dimj(phiz,thetaz,0.0,2,Dcct) 
         call vecxmat(2,efg,Dcct,efgL)   
        end if
!-------enable write-------- EFG in the Lab system -------------------  
        if(enwr(6)(1:2).eq.'lb') then   ! 'cx', 'sx', 'ef', 'hf'
           w6=enwr(6)(3:4)
         call writetensorlb(w6,d_x2,aszz,dsx2,x2Clab,efgL,hvL,jloop)
        end if 
!-------enable write-------- in the Lab system -------------------      
        call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,         &
                                                 je,jg,jge,Eagd,V1m,V2m)
        call flush_8zero(jge,V1m)

        if(enwr(6).eq.'Eagd')print'(4f12.5)',Eagd 
        eagd_zz(2)=aszz 
        eagd_zz(4)=dsx2 
        eagd_zz(6)=azz 
        eagd_zz(8)=d_x2 
        eagd_zz(10)=aszz*dsx2+azz*d_x2 
!        write(6,'(a,6f12.4)')'aszz*dsx2+azz*d_x2=',&
!             aszz,dsx2,azz,d_x2,aszz*dsx2+azz*d_x2   
        do i=1,jge 
         eagd_zz(2*i-1)=Eagd(i) 
        end do 
        do i=1,jge 
         eagdzz(i)=cmplx(eagd_zz(2*i-1),eagd_zz(2*i)) 
        end do 
!       write(6,'(8f10.3)')(eagdzz(j),j=1,jge)   ! trick with equivalenz
        jljpjO=jOLP(jOM,jloop,jpsi)

        ip=nput+2+3*jge*(jljpjO-1)   
        if(r_QUDI.eq.0.)then
!        M1 transition             
         do i=1,jge
          pp =real(conjg(V1m(1,i))*V1m(1,i))
          hmm=real(conjg(V1m(-1,i))*V1m(-1,i))
          ii=ip+3*(i-1) 
          array_fr(ii+1)=eagdzz(i) 
          array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture 
          array_fr(ii+3)=-e1m1*conjg(V1m(1,i))*V1m(-1,i)*texture
       end do
        else 
         if(abs(r_QUDI).lt.9999.)then 
!         mixed M1/E2 transition    
          r_delta2=1./(1.+r_QUDI**2) 
          do i=1,jge 
           ap=(-V1m(1,i)+r_QUDI*V2m(1,i))*e1m1   ! Rose/Blume
           aq=V1m(-1,i)+r_QUDI*V2m(-1,i)

!           ap=(-V1m( 1,i)-r_QUDI*V2m(1,i))*e1m1   !*Ci  Brink & satchler   
!           aq=-V1m(-1,i)+r_QUDI*V2m(-1,i)         !*Ci

           pp =real(conjg(ap)*ap)*r_delta2 
           hmm=real(conjg(aq)*aq)*r_delta2 
           pm =conjg(ap)*aq*r_delta2 
!          write(6,'(8f10.3)')eagdzz(i),pp,hmm,pm   
             
           ii=ip+3*(i-1) 
           array_fr(ii+1)=eagdzz(i) 
           array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture 
           array_fr(ii+3)=pm*texture 
          end do 

         else 
!         E2 transition   ; no M2 transition                                              
          do i=1,jge 
           pp =real(conjg(V2m(1,i))*V2m(1,i)) 
           hmm=real(conjg(V2m(-1,i))*V2m(-1,i)) 
           ii=ip+3*(i-1) 
           array_fr(ii+1)=eagdzz(i) 
           array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*texture 
           array_fr(ii+3)=-conjg(V2m(1,i))*V2m(-1,i)*texture 
          end do 
         end if 
        end if 

       end do    ! n_psi  
      end do    ! nloop 
     end do ! iOM
!!$OMP END PARALLEL
     deallocate(jOLP,txtuGT0)
   if(enwr(15).eq.'time') then
    call cpu_time(finish); call wall_time(wfinish)
    print '(" cpu/wall time = ",2f15.4," seconds ")',finish-start,wfinish-wstart
   end if

!     array_fr(nput+i):                                                 
!     (nput+1)=(n_all,jge)    (nput+2) = (b_xx,0)                       
!     (nput+3)=(Eagd(1),aszz) (nput+4) = (pp-hmm,hr+hmm)/2   (nput+5) =p
!     (nput+6)=(Eagd(2),dsx2) (nput+7) = (pp-hmm,hr+hmm)/2   (nput+8) =p
!     (nput+9)=(Eagd(3),dsx2) (nput+10)= (pp-hmm,hr+hmm)/2   (nput+11)=p
!                                                                       
!      ................................................................ 
!                                                                       
!     (nput+j1)=(Eagd(2),dsx2) (nput+j2)= (pp-hmm,hr+hmm)/2   (nput+j3)=
!      j=2+3*(jge-1) j1=j+1,...,j3=j+3                                  
!                                                                       
!     for the case: b_xx=.false. the f-factor fd=exp(-azz*d_x2-aszz*dsx2
!     itself is stored                                                  

      array_fr(nput+1)=cmplx(float(jljpjO),float(jge)) 
      if(b_xx) then 
       array_fr(nput+2)=cmplx(1.0,0.) 
      else 
       array_fr(nput+2)=C0 
      end if 
!     aimag of array_fr(nput+2) for further use                         
                                                                        
      if(nloop_e.gt.0) then 
!      to be stored in array store() => array_fr()                      
       efgC=efgC0 
       sx2C=sx2C0 
       hvC=hvC0 
      end if 
      j=iput+1 
      do i=1,istore 
       array_fr(j+i)=store(i) 
      end do 

      return 
     END subroutine th_hdeqf
                                                                        
     subroutine flush_8zero(n,c)
       real, dimension(1:2*n):: x
       complex, dimension(-1:1,n)::c
       do l=-1,1
        do i=1,n
          x(2*i-1)=real(c(l,i)); x(2*i)=aimag(c(l,i))
        end do
        do i=1,2*n
          if(abs(x(i)).lt.1.e-8) x(i)=0.0
        end do
        do i=1,n
         j=2*i 
         c(l,i)=cmplx(x(j-1),x(j))
        end do
       end do
       return
      end subroutine flush_8zero
     
                                                                             
                                                                             
                                                                             
      subroutine th_hdeq(isubthe,icase,iput,iget,info) 
      use glbconst, only: maxscrd,icstrf,icfr2trf,ivstrf,ivfr2trf,infotext,enwr
      use comthe, only: array_fr,real_fr,theoryname
      implicit none 
                                                                        
                                                                        
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info 
     
      real            acfr2,rep_grp,aset,asymmetry,apsi,dumcfr2 
      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,apsi,dumcfr2(icfr2trf-5) 
      logical         bcfr2,bumcfr2 
      common/bcfr2trf/bcfr2,bumcfr2(icfr2trf-1) 
                                                                        
      real           avfr2,pvfr2,Hext,thetaHe,phiHe,                   &
                     phi_ls,theta_ls,psi_ls,dum,dumvfr2                
     common/avfr2trf/avfr2,pvfr2,dum(4),Hext,thetaHe,phiHe,            &
                     phi_ls,theta_ls,psi_ls,dumvfr2(ivfr2trf-12)       
     logical         b_vfr2,b_Hext,b_thetaHe,b_phiHe,                  &
                     b_phils,b_thetals,b_psils,b_dum,b_dumvfr2         
     common/bvfr2trf/b_vfr2,b_dum(5),b_Hext,b_thetaHe,b_phiHe,         &
                     b_phils,b_thetals,b_psils,b_dumvfr2(ivfr2trf-12)  
                                                                       
     real          ac1,cTms,ajg,aje,amueg,amuee,QgdQe,r_QUDI,e1m1,      &
                   symcase,timeinvers,dumc                             
     common/acmaps/ac1,cTms,ajg,aje,amueg,amuee,QgdQe,r_QUDI,e1m1,      &
                   symcase,timeinvers,dumc(icstrf-11)                  
                                                                       
     real          avm,aH,thetaH,phiH,                                 &
                   DEq,eta,phi_CE,theta_CE,psi_CE,dumvm                
     common/avmaps/avm,aH,thetaH,phiH,                                 &
                   DEq,eta,phi_CE,theta_CE,psi_CE,dumvm(ivstrf-9)      
     logical       b_vm,b_aH,b_thetaH,b_phiH,                          &
                   b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvm          
     common/bvmaps/b_vm,b_aH,b_thetaH,b_phiH,                          &
                   b_DEq,b_eta,b_phiE,b_thetaE,b_psiE,b_dumvm(ivstrf-9)
     logical       b_ac1,b_dumcm 
     common/bcmaps/b_ac1,b_dumcm(icstrf-1) 
                                                                       
     integer,parameter:: maxloop=11,ivv=28,iec=ivv+25,icl=iec+25,     &
                         iecv=icl+9,id1=iecv+9,id2=id1+1+10*maxloop,  &
                         istore=id2+25*maxloop 
     logical,dimension(0:maxloop):: b_timeinv
  
     complex,dimension(-2:2):: efgPAS,efgC,efgC0,efgL,V2mi,V2hi,DDt
     complex,dimension(-1:1):: hv,hve,hvL,hvC,hvC0,V1mi,V1hi,DDv

     complex,dimension(-2:2,-2:2):: Dslt,Dect,Dcpt,DD2
     complex,dimension(-1:1,-1:1):: Decv,Dslv,Dcpv,DD1
     complex,dimension(-2:2,-2:2,maxloop):: d2
     complex,dimension(-1:1,-1:1,maxloop):: d1
     complex,dimension(maxloop) ::ctimeinv

 
     logical  b_He,b_Hi,b_efg,b_eqgt0,b_Hegt0,b_efgC,b_LS 
     real     phiH_r,thetaH_r,phiHe_r,thetaHe_r,phiE_r,thetaE_r, psiE_r 
                                                                       
     complex,dimension(istore):: store
     complex      caseloop
     equivalence (store(1),efgPAS(-2)),(store(6),efgC(-2)),            &
                 (store(11),efgL(-2)),                                 &
                 (store(16),hv(-1)),(store(19),hve(-1)),               &
                 (store(22),hvC(-1)),(store(25),hvL(-1)),              &
                 (store(ivv),Dect(-2,-2)),(store(iec),Dslt(-2,-2)),    &
                 (store(icl),Decv(-1,-1)),(store(iecv),Dslv(-1,-1)),   &
                 (store(id1),caseloop),(store(id1+1),ctimeinv(1)),     &
            (store(id1+1+maxloop),d1(-1,-1,1)),(store(id2),d2(-2,-2,1))
                                                                       
     integer,parameter :: idumscrd=maxscrd-6144*2
     real        phiOM,thetaOM,dumscrd          
     common/scrd/phiOM(6144),thetaOM(6144),dumscrd(idumscrd)

     logical b_integer
     integer je,jg,jge,i,ip,ii,k,j,m,n,nput,n_all,ncase,jpsi,n_psi,      &
             jloop,nloop,nloop_b,nloop_e,jOM,iOM,iset,isymmetry,jljO
     real    phils_r,thetals_r,psils_r,delta2,r_delta2,psi_OM,dpsiOM,    &
             a_mueg,a_muee,efg0,efg2,c_Tms,                              &
             pp,hmm,d_x2,aszz,dsx2
                                                                       
     complex  pm,hc1,hc2,ap,aq
     complex, dimension(-2:2):: x2C,sx2C  
     character(len=2):: w6
     real,    parameter :: sqrt2=1.4142136,q62=1.224745,              &
                           rad=0.0174533,pi=3.14159 
     complex, parameter:: C0=(0.,0.) 

     real,    dimension(:),   allocatable :: eagd_zz 
     real,    dimension(:),   allocatable :: Eagd
     complex, dimension(:),   allocatable :: eagdzz,rtr,rpm
     complex, dimension(:,:), allocatable :: V1m
     complex, dimension(:,:), allocatable :: V2m
                          
      info=0 
                                                                       
      jge=(2.*ajg+1)*(2.*aje+1)+0.01 
      
                                                                        
      if(acfr2.lt.3.)aset=0.0 
!     this way iset,... have not to be defined in frstr_..              
      if(isubthe.lt.0) then 
       theoryname='H_DEQ_equivalent_sites     v=200' 
       if(isubthe.eq.-16) then 
!       reading .par file ncase,symcase are not mapped (-> 8888.88)     
!       asking name with isubthe=-1 the routine sym_equiv (later        
!       calculating storage space) leads to an error exit               
        return 
       end if
       ncase=symcase
       call sym_equiv(-ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
       iset=aset 
       if(nloop.eq.-1)nloop=0          ! only 1 rotation 
       if(iset.gt.0) then 
        isymmetry=asymmetry 
        n_psi=apsi 
        call sphere(-iset,isymmetry,.false.,iOM,phiOM,thetaOM)
        i=1+istore+2+3*jge*(nloop+1)*iOM*(n_psi+1)+iOM 
        if(iOM.eq.1)i=i+2 
        ac1=i 
       else 
        iOM=1; n_psi=0
        ac1=1+istore+2+3*jge*(nloop+1)+2
        n_psi=0
       end if 
       return 
      end if 
                                                                        
      if(.not.(b_vm.or.b_vfr2)) then 
       isubthe=-abs(isubthe)             ! 24.10.07 theory not changed 
!      write(6,'(a)') ' no change in th_hdeq'                           
       return 
      end if
      if(iget.eq.0) print'(a)','iget is not defined'
! ----------------------------------------------------------------------
!      write(6,'(a,2i8)')'th_22nuclear avfr2...',iput,iget                             
!      write(6,'(6f10.2)')Hext,thetaHe,phiHe,phi_ls,theta_ls,psi_ls     
!      write(6,'(6L5)')b_Hext,b_thetaHe,b_phiHe,b_phils,b_thetals,b_psils

!      the introduction of the constant e1m1 : electric dipole/magnetic 
!      dipole transiotion or mixed transition E1-M2/M1-E2 need the constant
!      e1m1=-1 for magnetic and +1 for electric dipole transition + 
!      parity allowed quadrupole transition.
!      pure quadrupole transitions are not effected
!      if e1m1 is not defined in the .par file its value is zero.
!      in this case e1m1=-1 (E1 transition is not yet implemented and will 
!      be defined setting up the theory by the handbook nucleus.hdb
  if(e1m1.eq.0.0)e1m1=-1.0

  allocate(Eagd(jge),eagd_zz(2*jge),V1m(-1:1,jge),V2m(-2:2,jge),&
           eagdzz(jge),rtr(jge),rpm(jge))
  ! the odd numbers i of eagd_zz(i) are used for jge eigenvalues
  ! the even numbers 2,4,6,8,10 are used for MSD-values
  ! jge>5 is fulfilled for all implemented nuclei
      j=iput+1 
      nput=j+istore 
      do i=1,istore 
       store(i)=array_fr(j+i) 
      end do 
      array_fr(j)=cmplx(float(nput),float(istore)) 
!      write(6,'(8f10.1)')store                                         
!     logicals 
!     write(6,'(a,5f12.4)') 'DEq,eta,phi_CE,theta_CE,psi_CE=',    &
!            DEq,eta,phi_CE,theta_CE,psi_CE
!     write(6,'(a,5f12.4)') 'aH,thetaH,phiH=',aH,thetaH,phiH    
     
                                                         
      b_efg=b_DEq.or.b_eta 
      b_eqgt0=abs(DEq).gt.0. 
      b_Hegt0=abs(Hext).gt.0.0 

      b_He=b_Hext.or.b_thetaHe.or.b_phiHe 
      b_Hi=b_aH.or.b_thetaH.or.b_phiH 
      b_LS=b_phils.or.b_thetals.or.b_psils 
      b_efgC=b_phiE.or.b_thetaE.or.b_psiE 


!     write(6,'(a,4L5,5f12.4)') ' b_LS,phi_ls,theta_ls,psi_lsE=',    &
!            b_LS,b_phils,b_thetals,b_psils,phi_ls,theta_ls,psi_ls
                                                                        
                                                                     
      phils_r=phi_ls*rad 
      thetals_r=theta_ls*rad 
      psils_r=psi_ls*rad 

      phiE_r=phi_CE*rad 
      thetaE_r=theta_CE*rad 
      psiE_r=psi_CE*rad 
                                                                        
      a_mueg=amueg 
      a_muee=amuee 
      c_Tms=cTms 
      
      n_psi=apsi                                                                  
      iset=aset; if(iset.eq.0)n_psi=0
      ncase=symcase 
      isymmetry=asymmetry 
                                                                        
      ii=jge/2 
      if(2*ii.eq.jge) then 
       b_integer=.false. 
       je=2*aje+0.01 
       jg=2*ajg+0.01 
      else 
       b_integer=.true. 
       je=aje+0.01 
       jg=ajg+0.01 
      end if 
                                                                        
!     icase=1,2 magnetic field aH defined with respect to S_E, S_C      
      nloop_b=0 
      if(b_ac1) then 
       call sym_equiv(ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      else 
       nloop=real(caseloop) 
!      write(6,'(a,i6)')'th_22nuclear nloop=',nloop                     
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      end if 
      b_timeinv(0)=.false. 
      do k=1,nloop_e 
       b_timeinv(k)=real(ctimeinv(k)).lt.0. 
      end do 
                                                                        
      if(bcfr2) then 
       call sphere(iset,isymmetry,.false.,iOM,phiOM,thetaOM) 
       if(iOM.eq.0) then 
        print'(a,i3,ai2)','iset=',iset,'  isymmetry=',isymmetry
        info=1 
        infotext(1)=' ' 
        infotext(2)(1:17)='*** error ***' 
        infotext(3)='meaningless values of constants iset/isymmetry' 
        infotext(4)=                                                   &
             'help available: {co a}, {he cn} (n=number of constant)'    
        infotext(5)=' ' 
        return 
       end if 
         
       caseloop=cmplx(float(nloop),float(iOM)) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if
       j=(nput+2+3*jge*n_all)*2 
       do i=1,iOM 
        k=(i-1)*2+j 
        real_fr(k+1)=phiOM(i) 
        real_fr(k+2)=thetaOM(i) 
       end do 
      else
       iOM=aimag(caseloop) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if 
       j=(nput+2+3*jge*n_all)*2 
       do i=1,iOM 
        k=(i-1)*2+j 
        phiOM(i)=real_fr(k+1) 
        thetaOM(i)=real_fr(k+2) 
       end do 
      end if 
      caseloop=cmplx(float(nloop),float(iOM)) 
!     write(6,'(a,5f12.6)') '   efg=', eta,phi_CE,theta_CE,psi_CE       
!     write(6,'(a,5f12.6)') '    H=',aH,phiH,thetaH                     
!     write(6,'(a,5f12.6)') '    A=',phi_ls,theta_ls,psi_ls             
                                                                  
      if(b_efg)then 
       if(b_eqgt0)then 
!       efg (-2..2) are the spherical tensor components of the EFG in th
        efg0=1./sqrt(1.+eta**2/3.) 
        efg2=eta*efg0/sqrt(6.) 
                                                                        
        efgPAS(0)=cmplx(efg0,0.0) 
        efgPAS(-1)=C0 
        efgPAS(1)=C0 
        efgPAS(-2)=cmplx(efg2,0.) 
        efgPAS(2)=cmplx(efg2,0.) 
       else 
        efgPAS=C0
       end if 
      end if 
      if(b_He)then 
!       external field defined in the LAB system S_L                    
        phiHe_r=phiHe*rad 
        thetaHe_r=thetaHe*rad 
        hve(1) =-cmplx(cos(phiHe_r),sin(phiHe_r))*                      &
                       sin(thetaHe_r)/sqrt2*Hext                       
        hve(0) = cmplx(cos(thetaHe_r),0.0)*Hext 
        hve(-1)=-conjg(hve(1)) 
      end if 
      
!      write(6,*)'b_He,b_Hegt0,Hext,aH=',b_He,b_Hegt0,Hext,aH  
!      write(6,'(a,8f12.4)') 'hve    =',hve                
                                                                        
      if(b_Hi.or.b_LS) then 
!      internal field hv defined in the system S_E or S_C (case)        
       phiH_r=phiH*rad 
       thetaH_r=thetaH*rad 
       hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*                         &
                     sin(thetaH_r)/sqrt2*aH                           
       hv(0) = cmplx(cos(thetaH_r),0.0)*aH 
       hv(-1)=-conjg(hv(1)) 
      end if
!     write(6,'(a,8f12.4)') 'th_hdeq  hv    =',hv   
! --------------------------------------------------------------------  
    if(iset.eq.0) then 
!    single crystal case,  EFG(efgL) in the S_L sytem                 
!    transformation:                                                  
!    Sum;n T(n)*Dnm(phi_CE,teta_CE,psi_CE) = T(m)                     
                                                                     
     if(b_efgC) call dimj(-psiE_r,-thetaE_r,-phiE_r,2,Dect)
     if(b_efg.or.b_efgC) call vecxmat(2,efgPAS,Dect,efgC)       
     if(b_LS) call dimj(-psils_r,-thetals_r,-phils_r,2,Dslt)

     if(b_efg.or.b_efgC.or.b_LS)then 
      call vecxmat(2,efgC,Dslt,efgL)                        
      efgL=efgL*DEq
     end if 
                                                                      
     if(icase.eq.1)then 
!     transformation of the magnetic field H (hv) from the  S_E to    
!     the crystal system S_C  (hvC(n) in the crystal system  S_C)     
      if(b_efgC) call dimj(-psiE_r,-thetaE_r,-phiE_r,1,Decv)
      if(b_LS.or.b_Hi.or.b_efgC)call vecxmat(1,hv,Decv,hvC) 
     else 
!     magnetic field given in the crystal system Sc                   
      hvC=hv
     end if  ! case 1 

     if(enwr(6)(1:2).eq.'si') then   ! lbhf
      w6=enwr(6)(3:4)
      if(w6(2:2).ne.'x')then 
       call writetensorsi(w6,d_x2,x2C,dsx2,sx2C,efgC,hvC,-1)
      else
       print'(a)',' no msd tensor => no information for sisx and sicx'
      end if 
     end if
!------------------------------------------------------------------   
!     write(6,'(L5,a,8f9.1)')b_LS, ' psi... =',psils_r,thetals_r,phils_r
!     magnetic field transformed to the Lab system       
     if(b_LS) call dimj(-psils_r,-thetals_r,-phils_r,1,Dslv)
     if(b_LS.or.b_Hi.or.b_He.or.b_efgC)then 
      call vecxmat(1,hvC,Dslv,hvL) 
      hvL=hvL+hve
     end if 

!-------enable write-------- EFG in the Lab system -------------------
!    write(6,'(a,8f12.4)') 'hve   =',hve 
     if(enwr(6)(1:2).eq.'lb') then 
      w6=enwr(6)(3:4)
      if(w6(2:2).ne.'x')then 
       call writetensorlb(w6,d_x2,aszz,dsx2,x2C,efgL,hvL,-1)
      else
       print'(a)',' no msd tensor => no information for lbsx and lbcx'
      end if 
     end if
!-------enable write-------- EFG in the Lab system -------------------    

     call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,          &
                                               je,jg,jge,Eagd,V1m,V2m)
     if(enwr(6).eq.'Eagd')print'(4f12.5)',Eagd 
     do i=1,jge 
      eagd_zz(2*i-1)=Eagd(i) 
     end do

     n_all=nloop_e-nloop_b+1 
     do i=1,jge 
!     transformation (rotation and time inversion) of V1m,V2m         
!     calculation of r_pq and averaging                               
      pp=0. 
      hmm=0. 
      pm=C0 
                                                                      
      do jloop=nloop_b,nloop_e 
                                                                      
        if(b_timeinv(jloop))then 
         do m=-1,1 
          V1mi(m)=-(-1)**m*conjg(V1m(-m,i)) 
         end do 
         do m=-1,1 
          V2mi(m)=(-1)**m*conjg(V1m(-m,i)) 
         end do 
        else 
         do m=-1,1 
          V1mi(m)=V1m(m,i) 
         end do 
         do m=-2,2 
          V2mi(m)=V2m(m,i) 
         end do 
        end if 
                                                                      
       if(jloop.gt.0) then 
        do n=-1,1 
         hc1=C0 
         do m=-1,1 
          hc1=hc1+V1mi(m)*d1(m,n,jloop) 
         end do 
         V1hi(n)=hc1 
        end do 
        V1mi= V1hi 
         
        do n=-2,2 
         hc1=C0 
         do m=-2,2 
          hc1=hc1+V2mi(m)*d2(m,n,jloop) 
         end do 
         V2hi(n)=hc1 
        end do 
        V2mi=V2hi
       end if 

       if(r_QUDI.eq.0.)then 
        pp =pp+real(conjg(V1mi(1))*V1mi(1)) 
        hmm=hmm+real(conjg(V1mi(-1))*V1mi(-1)) 
        pm =pm-e1m1*conjg(V1mi(1))*V1mi(-1)        ! Rose/Blume
!       pm =pm+e1m1*conjg(V1mi(1))*V1mi(-1)        ! Brink-Satchler  
       else 
        if(abs(r_QUDI).lt.9999.)then 
!        mixed M1/E2 transition  
         r_delta2=1./(1.+r_QUDI**2) 

         ap=(-V1mi( 1)+r_QUDI*V2mi(1))*e1m1   ! Rose/Blume
         aq=V1mi(-1)+r_QUDI*V2mi(-1)

!         ap=(-V1mi( 1)-r_QUDI*V2mi(1))*e1m1    ! Brink-Satchler
!         aq=-V1mi(-1)+r_QUDI*V2mi(-1)
                                  
          pp=pp+real(conjg(ap)*ap)*r_delta2  
          hmm=hmm+real(conjg(aq)*aq)*r_delta2 
          pm=pm+conjg(ap)*aq*r_delta2 
        else 
!        E2 transition                                                
         pp =pp+real(conjg(V2mi(1))*V2mi(1))    ! Brink-Satchler
         hmm=hmm+real(conjg(V2mi(-1))*V2mi(-1))
         pm =pm+conjg(V2mi(1))*V2mi(-1)
         ! as long only Mossbauer is considered Brink-Satchler/Rose
         ! bases give the same results
        end if
       end if 
!      write(6,'(2i3,a,2f10.3,3x,2f10.3)')  &                            
!          i,jloop,' pp,hmm,pm=',real(conjg(V1mi(1))*V1mi(1)),&       
!      real(conjg(V1mi(-1))*V1mi(-1)),conjg(V1mi(1))*V1mi(-1)         
      end do   ! nloop   
                                                                      
      rtr(i)=cmplx(pp-hmm,pp+hmm)/2.0/float(n_all) 
      rpm(i)=pm/float(n_all) 
     end do   ! i=1-jge 
                                                                      
    else   
!     ----------------------powder case  iset>0 -----------------------
!     phi_ls,theta_ls,psi_ls would  rotate a powder (no effect)        
     if(b_Hegt0)then 
!      The polar angles  thetaOM,phiOM define the direction of        
!      the z-axis of one of the crystals of the powder with system S_C
!      rotated with respect to the sample system S_S. (If the sample  
!      is not rotated S_S coincides with the lab. system S_L).        
!      The Euler angles of the rotation are alpha=phiOM and beta=thetaOM
!      and the angle psiOM which is averaged analytically (off diagonal
!      elements of r_pq vanish). The components in the S_OM system are
!      (symbolic):  e_OM in S_C  -> t_OM=t_C*d   (t_S=t_OM)           
                                                                      
      array_fr(nput+1)=cmplx(float(n_all),float(jge)) 
      array_fr(nput+2)=C0

      call dimj(phiHe_r,thetaHe_r,0.0,1,DD1) 
      call dimj(phiHe_r,thetaHe_r,0.0,2,DD2)
                                                                      

      hve(0)=cmplx(Hext,0.) 
      hve(1)=C0
      hve(-1)=C0

      efgC=efgPAS 
  
      eagd_zz(2)=0. 
      eagd_zz(4)=0. 
      eagd_zz(6)=0. 
      eagd_zz(8)=0. 
      eagd_zz(10)=0. 
                                                                      
      if(icase.eq.2) then 
!      H internal defined with respect to the crystal system          
       if(b_efgC)then 
        call dimj(phiE_r,thetaE_r,psiE_r,1,Decv)
        call vecxmat(1,hv,Decv,hvC)                                 
       end if 
      else 
       hvC=hv 
      end if 
      hvC0=hvC 
      efgC0=efgC 
      jljO=0 
      dpsiOM=2.*pi/(n_psi+1)
      do jOM=1,iOM 
       if(enwr(6).eq.'vecp')print'(a3,i3,a4,3(f6.2,a1))',' v(',jOM,')= (',&
                 cos(phiOM(jOM))*sin(thetaOM(jOM)),',',         &
                 sin(phiOM(jOM))*sin(thetaOM(jOM)),',',cos(thetaOM(jOM)),')'
       do jpsi=0,n_psi 
        psi_OM=jpsi*dpsiOM

       call dimj(-phiOM(jOM),-thetaOM(jOM),psi_OM,1,Dcpv)
       call dimj(-phiOM(jOM),-thetaOM(jOM),psi_OM,2,Dcpt)
!      loop for isymmetry and timeinvers could be inserted here       
!      hvC(n)=hvC0(m)*d1(m,n,jloop)   efgC(n)=efgC0(m)*d2(m,n,jloop)  
!      if(b_timeinv(jloop)) hvC(n)=-hvC(n)  

       do jloop=nloop_b,nloop_e 
        jljO=jljO+1 
        if(jloop.gt.0) then 
         do n=-1,1 
          hc1=C0 
          do m=-1,1 
           hc1=hc1+hvC0(m)*d1(m,n,jloop) 
          end do 
          hvC(n)=hc1 
         end do 
   
         if(b_timeinv(jloop))then 
          do n=-1,1 
          hvC(n)=-hvC(n) 
          end do 
         end if 
         do n=-2,2 
          hc1=C0 
          do m=-2,2 
           hc1=hc1+efgC0(m)*d2(m,n,jloop) 
          end do 
          efgC(n)=hc1 
         end do 
        else 
         hvC=hvC0 
         efgC=efgC0 
        end if 

!       1. rank tensor transformation                                 
        call vecxmat(1,hvC,Dcpv,hvL)                       
        hvL=hvL+hve

        if(b_eqgt0)then 
         call vecxmat(2,efgC0,Dcpt,efgL)  
         efgL=efgL*DEq 
        else
         efgL=(0.,0.)
        end if ! b_eqgt0   
 
        if(enwr(6)(1:2).eq.'lb') then 
         ! no msd tensor => dummy arguments d_x2,aszz,dsx2,x2C    
         w6=enwr(6)(3:4)
         if(w6(2:2).ne.'x')then 
          call writetensorlb(w6,d_x2,aszz,dsx2,x2C,efgL,hvL,jloop)
         else
          print'(a)',' no msd tensor => no information for lbsx and lbcx'
         end if 
        end if                                                        
!       write(6,'(a,10f9.1)') 'efgC=',efgL                             
!       write(6,'(a,8f9.1)') 'b hvL =',hvL                               
!       write(6,'(a,L5,8f9.3)')'... =',b_integer,amueg,amuee,QgdQe,cTms 


        call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,        &
                                               je,jg,jge,Eagd,V1m,V2m)
        if(enwr(6).eq.'Eagd')print'(4f12.5)',Eagd 
        do i=1,jge 
         eagd_zz(2*i-1)=Eagd(i) 
        end do 
        do i=1,jge 
         eagdzz(i)=cmplx(eagd_zz(2*i-1),eagd_zz(2*i)) 
        end do 
                                                                      
!       write(6,'(10f10.3)') (eagdzz(j),j=1,10)   ! trick with equivale
!       if(jOM.eq.1)write(6,'(a,i4,f12.3)')' iOM,thetaHe=',iOM,thetaHe_r/rad

        ip=nput+2+3*jge*(jljO-1) 
        do i=1,jge 
         do m=-1,1         
          DDv(m)=V1m(m,i)
         end do
         call vecxmat(1,DDv,DD1,V1mi) 

        if(r_QUDI.eq.0.)then 
!        dipole transition  --------------------------------
         ap=-V1mi(1)*e1m1                    ! Rose/Blume
         aq=V1mi(-1)
         pp=conjg(ap)*ap
         hmm=conjg(aq)*aq
         pm =conjg(ap)*aq
        else 
         do m=-2,2        
          DDt(m)=V2m(n,i)
         end do
         call vecxmat(2,DDt,DD2,V2mi) 

         if(abs(r_QUDI).lt.1000.)then 
!          mixed M1/E2 transition  ----------------------------
          ap=(-V1mi( 1)+r_QUDI*V2mi(1))*e1m1 ! Rose/Blume
          aq=V1mi(-1)+r_QUDI*V2mi(-1)
          pp=conjg(ap)*ap
          hmm=conjg(aq)*aq
          pm =conjg(ap)*aq
         else 
!         E2 transition  --------------------------------
          ap=V2mi(1)
          aq=V2mi(-1)
          pp=conjg(ap)*ap
          hmm=conjg(aq)*aq
          pm =conjg(ap)*aq 
         end if 
        end if 
        ii=ip+3*(i-1) 
        array_fr(ii+1)=eagdzz(i) 
        array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0/float(n_all) 
        array_fr(ii+3)=pm/float(n_all) 
       end do ! jge
       end do ! nloop
      end do  ! jpsi
      end do ! iOM
      goto 100 
!     end of powder average (Collins etc)                             
     else   !  b_Hegt0 = .false. 
!     ------------------------------------------------------------
!       average intensities of efg with only Hi (no external H)         
        if(icase.eq.2) then 
!        H internal defined with respect to the crystal system          
         if(b_efgC) call dimj(-psiE_r,-thetaE_r,-phiE_r,2,Dect)
 
         if(b_efg.or.b_efgC)then 
          call vecxmat(2,efgPAS,Dect,efgC)
         end if 
        else 
         efgC=efgPAS 
        end if 
        efgC=efgC*DEq 
        hvC=hv 

!       write(6,'(a,10f9.1)') 'efgC=',efgC                             
!       write(6,'(a,8f9.1)') 'hv =',hvC                                
!       write(6,'(a,L5,8f9.3)')'... =',b_integer,amueg,amuee,QgdQe,cTms 
      
        call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvC,efgC,         &
                                                je,jg,jge,Eagd,V1m,V2m)

        if(enwr(6).eq.'Eagd')print'(4f12.5)',Eagd 
        if(r_QUDI.eq.0.)then 
         do i=1,jge 
          hc1=V1m(1,i)*conjg(V1m(1,i))+V1m(0,i)*conjg(V1m(0,i))+        &
              V1m(-1,i)*conjg(V1m(-1,i))                                  
          rtr(i)=cmplx(0.,real(hc1)/3.) 
          rpm(i)=C0 
         end do 
        else 
         if(abs(r_QUDI).lt.1000.)then 
!         mixed M1/E2 transition                                        
          delta2=r_QUDI**2 
          r_delta2=1./(1.+delta2) 
          do i=1,jge 
           hc1=V1m(1,i)*conjg(V1m(1,i))+V1m(0,i)*conjg(V1m(0,i))+       &
               V1m(-1,i)*conjg(V1m(-1,i))                               
           hc2=V2m(2,i)*conjg(V2m(2,i))+V2m(1,i)*conjg(V2m(1,i))+       &
               V2m(0,i)*conjg(V2m(0,i))+V2m(-1,i)*conjg(V2m(-1,i))+     &
               V2m(-2,i)*conjg(V2m(-2,i))                               
           rtr(i)=cmplx(0.,(real(hc1)/3.+delta2*real(hc2)/5.)*r_delta2) 
           rpm(i)=C0
          end do 
         else 
!         E2 transition                                                 
          do i=1,jge 
           hc2=V2m(2,i)*conjg(V2m(2,i))+V2m(1,i)*conjg(V2m(1,i))+       &
               V2m(0,i)*conjg(V2m(0,i))+V2m(-1,i)*conjg(V2m(-1,i))+     &
               V2m(-2,i)*conjg(V2m(-2,i))                               
           rtr(i)=cmplx(0.,real(hc2)/5.) 
           rpm(i)=C0 
          end do 
         end if 
        end if 
      end if 
    end if 
                                                                        
      ip=nput+2 
      do i=1,jge 
       ii=ip+3*(i-1) 
!      write(6,'(i8,a,8g12.4)')ii,' E=',Eagd(i),rtr(i),rpm(i) 


       array_fr(ii+1)=cmplx(Eagd(i),0.0) 
       array_fr(ii+2)=rtr(i) 
       array_fr(ii+3)=rpm(i) 

      end do 
      n_all=1 
      array_fr(nput+1)=cmplx(float(n_all),float(jge)) 
      array_fr(nput+2)=C0 
                                                                        
  100 if(nloop_e.gt.0) then 
!      to be stored in array store() => array_fr()                      
       efgC=efgC0 
       hvC=hvC0 
      end if 
      j=iput+1 
      do i=1,istore 
       array_fr(j+i)=store(i) 
      end do 

      return 
      END                                           


     subroutine writetensors1(w6,d_x2,x2C,dsx2,sx2C,phiE_r,thetaE_r,psiE_r,efgC)
     implicit none
     character(len=2), intent(inout):: w6
     real,    intent(in):: d_x2,dsx2,phiE_r,thetaE_r,psiE_r
     complex, intent(in), dimension(-2:2)::x2C,sx2C,efgC
     complex,dimension(-1:1,-1:1):: d21
     real, dimension(3,3):: uveca,vik,vdd
     real txx,txy,txz,tyy,tyz,tzz,h,h1,hx,hy,hz,thetaC,phiC,sintC
     real, parameter::  sqrt2=1.4142136,rad=0.0174533
     integer  i,j,k,l
     logical b_read

      b_read=.false.
      if(w6.eq.'Cx')then
       w6='cx'; b_read=.true.
      end if
      if(w6.eq.'Sx')then
       w6='sx'; b_read=.true.
      end if

!-------enable write----- xx(msd) all sites in the crystal system ---------- 
        if(w6.eq.'cx') then 
         h=0.5*d_x2 
         call sph2carth(x2C,h,txx,txy,txz,tyy,tyz,tzz)
         print '(2x,a,2(f7.3,1x),f7.3,a1)',                         &
         '            x ( ',txx,txy,txz,')'                            
         print '(2x,a,8x,f7.3,1x,f7.3,a1)',                         &
         '<i|T_C|k> = y ( ',tyy,tyz,')'                                
         print '(2x,a,16x,f7.3,a1)',                                &
         '            z ( ',tzz,')'

       if(b_read)then
        print '(a)',' type direction of observation (theta,phi) for f(theta,phi)'
        read(5,*)thetaC,phiC
        print '(2f10.2)',thetaC,phiC
        h=thetaC*rad
        hx=sin(h)*cos(phiC*rad); hy=sin(h)*sin(phiC*rad);hz=cos(h)
        thetaC=(hx*txx+hy*txy+hz*txz)*hx
        phiC  =(hx*txy+hy*tyy+hz*tyz)*hy
        sintC =(hx*txz+hy*tyz+hz*tzz)*hz
        print '(a,f10.3,/)',' exp(-<zz>)=',exp(-(thetaC+phiC+sintC))
       end if
                                    
!-------enable write----- sxx(msd) site 1 in the crystal system ---------- 
        else if(w6.eq.'sx') then 
         h=0.5*dsx2 
         call sph2carth(sx2C,h,txx,txy,txz,tyy,tyz,tzz)
         print '(a,/)', '-- local <sx> in the S_C -- site 1' 
         print '(2x,a,2(f7.3,1x),f7.3,a1)',                         &
         '            x ( ',txx,txy,txz,')'                            
         print '(2x,a,8x,f7.3,1x,f7.3,a1)',                         &
         '<i|T_C|k> = y ( ',tyy,tyz,')'                                
         print '(2x,a,16x,f7.3,a1)',                                &
         '            z ( ',tzz,')'                                    
!-------enable write------EFG (site 1) in the crystal system -------------- 
        else if(w6.eq.'ef') then 
         call sph2carth(efgC,0.5,txx,txy,txz,tyy,tyz,tzz)
         print '(a,/)', '-- EFG in the crystal system DEQ=1 -- site 1' 
                                                                        
         call dimj(phiE_r,thetaE_r,psiE_r,1,d21) 
                                                                        
         uveca(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1)) 
         uveca(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1)) 
         uveca(1,3)=-1./sqrt2*real(d21(0,1)-d21(0,-1)) 
                                                                        
         uveca(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1)) 
         uveca(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1)) 
         uveca(2,3)=-1./sqrt2*aimag(d21(0,1)+d21(0,-1)) 
                                                                        
         uveca(3,1)=-1./sqrt2*real(d21(1,0)-d21(-1,0)) 
         uveca(3,2)=1./sqrt2*aimag(d21(1,0)+d21(-1,0)) 
         uveca(3,3)=real(d21(0,0)) 
                                                                        
         vik(1,1)=txx; vik(1,2)=txy; vik(1,3)=txz 
         vik(2,1)=txy; vik(2,2)=tyy; vik(2,3)=tyz 
         vik(3,1)=txz; vik(3,2)=tyz; vik(3,3)=tzz 
                                                                        
         do i=1,3 
         do l=1,3 
          h1=0.0 
          do j=1,3 
          do k=1,3 
           h1=h1+uveca(i,k)*vik(k,j)*uveca(l,j) 
          end do 
          end do 
          vdd(i,l)=h1 
         end do 
         end do 
         print '(10x,a,3(f7.3,a1))',                                &
         '      ( ',vdd(1,1),',',vdd(1,2),',',vdd(1,3),')'             
         print '(a10,a,3(f7.3,a1))','          ',                   &
         'tik = ( ',vdd(2,1),',',vdd(2,2),',',vdd(2,3),')'             
         print '(10x,a,3(f7.3,a1),/)',                              &
         '      ( ',vdd(3,1),',',vdd(3,2),',',vdd(3,3),')'             
                                                                        
!         print '(2(6x,a,3(f8.3,a1)))',                       &
!           'eQx=(',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')'         
!         print '(2(6x,a,3(f8.3,a1)))',                        & 
!           'eQy=(',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'         
!         print '(2(6x,a,3(f8.3,a1)))',                        &
!           'eQz=(',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'         
                                                                        
         print '(2x,a,2(f7.3,1x),f7.3,a1,2(4x,a,3(f7.3,a1)))',         &
          '            x ( ',txx,txy,txz,')',                          &
          ' u = x (',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')'       
                                                                        
         print '(2x,a,8x,f7.3,1x,f7.3,a1,2(4x,a,3(f7.3,a1)))',         &
          '<i|T_C|k> = y ( ',tyy,tyz,')',                              &
          '   = y (',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'       
         print '(2x,a,16x,f7.3,a1,2(4x,a,3(f7.3,a1)))',                &
          '            z ( ',tzz,')',                                  &
          '   = z (',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'       
        end if 
      return
      end

     subroutine writetensorsi(w6,d_x2,x2C,dsx2,sx2C,efgC,hvC,jloop)
     implicit none
     character(len=2), intent(inout):: w6
     integer, intent(in):: jloop
     real,    intent(in):: d_x2,dsx2
     complex, intent(in), dimension(-2:2):: x2C,sx2C,efgC
     complex, intent(in), dimension(-1:1):: hvC
     real txx,txy,txz,tyy,tyz,tzz,h,hx,hy,hz,thetaC,phiC,sintC,arcos
     real, parameter::  sqrt2=1.4142136,rad=0.0174533,pi=3.14159                             
     logical b_wrtensor,b_read

     b_read=.false.; b_wrtensor=.false. 
     if(w6.eq.'Cx')then
      w6='cx'; b_read=.true.
     end if
     if(w6.eq.'Sx')then
      w6='sx'; b_read=.true.
     end if

     if(w6.eq.'cx') then 
      h=0.5*d_x2 
      call sph2carth(x2C,h,txx,txy,txz,tyy,tyz,tzz)
      if(jloop.ge.0)print '(/,a,i2,/)', '--- equivalent <xx> ---- site',jloop+1 
      b_wrtensor=.true.
      if(b_read)then
       print '(a)',' type direction of observation (theta,phi) for f(theta,phi)'
       read(5,*)thetaC,phiC
       print '(2f10.2)',thetaC,phiC
       h=thetaC*rad
       hx=sin(h)*cos(phiC*rad); hy=sin(h)*sin(phiC*rad);hz=cos(h)
       thetaC=(hx*txx+hy*txy+hz*txz)*hx
       phiC  =(hx*txy+hy*tyy+hz*tyz)*hy
       sintC =(hx*txz+hy*tyz+hz*tzz)*hz
       print '(a,f10.3,/)',' exp(-<zz>)=',exp(-(thetaC+phiC+sintC))
      end if
     else if(w6.eq.'sx') then 
      h=0.5*dsx2 
      call sph2carth(sx2C,h,txx,txy,txz,tyy,tyz,tzz)
      print '(/,a,i2,/)','--- equivalent <sx> ---- site',jloop+1 
      b_wrtensor=.true.
      if(b_read)then
       print '(a)',' type direction of observation (theta,phi) for f(theta,phi)'
       read(5,*)thetaC,phiC
       print '(2f10.2)',thetaC,phiC
       h=thetaC*rad
       hx=sin(h)*cos(phiC*rad); hy=sin(h)*sin(phiC*rad);hz=cos(h)
       thetaC=(hx*txx+hy*txy+hz*txz)*hx
       phiC  =(hx*txy+hy*tyy+hz*tyz)*hy
       sintC =(hx*txz+hy*tyz+hz*tzz)*hz
       print '(a,f10.3,/)','   exp(-<zz>)=',exp(-(thetaC+phiC+sintC))
      end if
!----enable write------ EFG in the crystal system -------------- 
     else if(w6.eq.'ef') then 
      call sph2carth(efgC,0.5,txx,txy,txz,tyy,tyz,tzz)
      if(jloop.ge.0)print '(/,a,i2,/)', '--- equivalent EFGs DEQ=1 ---- site',jloop+1 
      b_wrtensor=.true. 
!----enable write------H-field in the crystal system --------------  
     else if(w6.eq.'hf') then 
      hx=-real(hvC(1)-hvC(-1))/sqrt2 
      hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2 
      hz= real(hvC(0)) 
      thetaC=arcos(hz) 
      sintC=sin(thetaC) 
      if(sintC.lt.0.001) then 
       phiC=0.0 
      else 
       phic=arcos(hx/sintC) 
       if(hy.lt.0.)phiC=2.*pi-phiC 
      end if 
      if(jloop.ge.0) then                                                               
       print'(/,a,i2,a,3f8.3,a4,2f8.3,a1)',' site',jloop+1,      &
           ' ------  h_C = (',hx,hy,hz,'):=(',thetaC/rad,phiC/rad,')' 
      else if(jloop.eq.-1)then
       print'(a,3f8.4,a4,2f9.4,a1)',                           &
       ' z-axis = (',hx,hy,hz,'):=(',thetaC/rad,phiC/rad,')' 
      end if
     end if 
     if(b_wrtensor)then 
      print '(2x,a,2(f7.4,1x),f7.4,a1,2(4x,a,3(f7.4,a1)))',      &
      '            x ( ',txx,txy,txz,')'
      print '(2x,a,8x,f7.4,1x,f7.4,a1,2(4x,a,3(f7.4,a1)))',      &
      '<i|t_c|k> = y ( ',tyy,tyz,')'
      print '(2x,a,16x,f7.4,a1,2(4x,a,3(f7.4,a1)))',             &
      '            z ( ',tzz,')'
     end if 
    return
    end

     subroutine writetensorlb(w6,d_x2,aszz,dsx2,x2Clab,efgL,hvL,jloop)
     implicit none
     character(len=2), intent(in):: w6
     integer, intent(in):: jloop
     real,    intent(in):: d_x2,aszz,dsx2
     complex, intent(in), dimension(-2:2):: x2Clab,efgL
     complex, intent(in), dimension(-1:1):: hvL
     real     txx,txy,txz,tyy,tyz,tzz,h,hx,hy,hz,thetaC,sintC,phiC,arcos, &
              phi,theta,sinp,cosp,sint,cost
     real, dimension(3,3) :: akm,Tnm,Tik
     integer i,k,n,m
     real, parameter::  sqrt2=1.4142136, rad=0.0174533, pi=3.14159

     if(w6.eq.'cx') then 
      h=0.5*d_x2 
      call sph2carth(x2Clab,h,txx,txy,txz,tyy,tyz,tzz)
      print '(2x,a,6f8.3,a1,3f10.3)',' (',txx,txy,txz,tyy,tyz,tzz,')'
     else if(w6.eq.'sx') then 
      print '(a,3f10.3)',' ez(lab)*<x**2(i)>*ez(lab)=', aszz*dsx2
!----enable write---EFG  in the Lab system ---------------------    
     else if(w6.eq.'ef') then 
      call sph2carth(efgL,0.5,txx,txy,txz,tyy,tyz,tzz)
!      print '(2x,a,6f8.3,a1,3f10.3)',' (',txx,txy,txz,tyy,tyz,tzz,')'
     print '(a)'                                              
     print '(2x,a,3f8.3,a1)',   '            x (',txx,txy,txz,')'
     print '(2x,a,8x,2f8.3,a1)','<i|V_L|k> = y (',tyy,tyz,')'  
     print '(2x,a,16x,f8.3,a1)','            z (',tzz,')'      
      Tnm(1,1)=txx;  Tnm(1,2)=txy;  Tnm(1,3)=txz;
      Tnm(2,1)=txy;  Tnm(2,2)=tyy;  Tnm(2,3)=tyz;
      Tnm(3,1)=txz;  Tnm(3,2)=tyz;  Tnm(3,3)=tzz;
goto 1      
      write(6,*)'  phi'; read(5,*)phi
      sinp=sin(phi*rad); cosp=cos(phi*rad)
      write(6,*)'theta'; read(5,*)theta
      sint=sin(theta*rad); cost=cos(theta*rad)
      akm(1,1)=cost*cosp; akm(1,2)=cost*sinp; akm(1,3)=-sint
      akm(2,1)=-sinp; akm(2,2)=cosp;   akm(2,3)=0.0      
      akm(3,1)=sint*cosp; akm(3,2)=sint*sinp; akm(3,3)=cost
      do i=1,3
      do k=1,3     
       h=0
       do n=1,3
       do m=1,3         
         h=h+akm(i,n)*akm(k,m)*Tnm(n,m)
       end do
       end do
       Tik(i,k)=h
      end do
      end do
     print '(a)'                                              
     print '(2x,a,3f8.3,a1)',   '            x (',Tik(1,1),Tik(1,2),Tik(1,3),')'
     print '(2x,a,8x,2f8.3,a1)','<i|V_L|k> = y (',Tik(2,2),Tik(2,3),')'  
     print '(2x,a,16x,f8.3,a1)','            z (',Tik(3,3),')' 
1 continue
     !----enable write---H-field in the Lab system ---------------------  
     else if(w6.eq.'hf') then 
      hx=-real(hvL(1)-hvL(-1))/sqrt2 
      hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2 
      hz= real(hvL(0))
      h=sqrt(hx**2+hy**2+hz**2); hx=hx/h; hy=hy/h;hz=hz/h
      thetaC=arcos(hz) 
      sintC=sin(thetaC) 
      if(sintC.lt.0.001) then 
       phiC=0.0 
      else 
       phiC=arcos(hx/sintC) 
       if(hy.lt.0.)phiC=2.*pi-phiC 
      end if 
      if(jloop.ge.0) then                                                               
       print'(a,3f6.2,a4,2f8.2,a1)',&
           ' ------  h_L = (',hx,hy,hz,'):=(',thetaC/rad,phiC/rad,')' 
!       print '(a,i2,a,3f8.3,a1)',' site',jloop+1,' ------  h_L = (',hx,hy,hz,')'
      else
       print '(a,3f8.3,a1)',' -----------  h_L = (',hx,hy,hz,')'
      end if
     end if 
    return
    end
 
    subroutine sph2carth(sph,dd,txx,txy,txz,tyy,tyz,tzz)
    implicit none
    complex, intent(in), dimension(-2:2):: sph
    real,    intent(in) :: dd       
    real,    intent(out):: txx,txy,txz,tyy,tyz,tzz
    real, parameter:: q62=1.224745
    
    txx=real(-sph(0)+q62*(sph(2)+sph(-2)))*dd
    tyy=real(-sph(0)-q62*(sph(2)+sph(-2)))*dd
    tzz=2*real(sph(0))*dd 
    txy=-real(q62*(sph(2)-sph(-2))*cmplx(0.,1.))*dd 
    txz=-real(q62*(sph(1)-sph(-1)))*dd
    tyz=real(q62*(sph(1)+sph(-1))*cmplx(0.,1.))*dd
    return
    end
 
    subroutine matrixinvers(j,DD,DDI)
    integer,intent(in)::j
    complex, dimension(-j:j,-j:j), intent(in) ::DD
    complex, dimension(-j:j,-j:j), intent(out)::DDI
    integer i,k
    
    do i=-j,j
       do k=-j,j
          DDI(i,k)=conjg(DD(k,i))
       end do
    end do

    return
    end

