     subroutine th_hdeqfRELAX(isubthe,icase,iput,iget,info) 
       use glbconst, only: maxscrd,icstrf,icfr2trf,ivstrf,ivfr2trf,  &
                           ipostxtu,infotext,enwr
     use comthe, only: array_fr,real_fr,nproc,theoryname
     implicit none 
                                                                        
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info                                                                 

!    transmission: fr2 defines external magnetic field, the orientation    
!    of the sample by phi,theta,psi is calculated by the routine "sample
!    orientation" and tansferred by  array_fr to main and passed to fr2
                                                                        
     real            acfr2,rep_grp,aset,asymmetry,a_psi,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,               &
                     dumcfr2(icfr2trf-5)                               
     logical         bcfr2,bumcfr2 
     common/bcfr2trf/bcfr2,bumcfr2(icfr2trf-1) 
     real            avfr2,dum5,Hext,thetaHe,phiHe,                    &
                     phi_LS,theta_LS,psi_LS,                           &
                     d_xx,eta_xx,phi_xx,theta_xx,psi_xx,               &
                     t00,t100,t11s,t11c,t200,t21s,t21c,t22s,t22c,t300,t400,&
                     dumvfr2                               
     common/avfr2trf/avfr2,dum5(5),Hext,thetaHe,phiHe,                 &
                     phi_LS,theta_LS,psi_LS,                           &
                     d_xx,eta_xx,phi_xx,theta_xx,psi_xx,               &
                     t00,t100,t11s,t11c,t200,t21s,t21c,t22s,t22c,t300,t400,&
                     dumvfr2(ivfr2trf-28)
!    b_phi is named b_laba (laboratory angles of the sample)           
!    b_laba has got the value of b_phi.or.b_theta.or.b_psi             
!    in the routine th_sampleorient                                    
!    b_dum5(5) is reserved place for the parameters thicklay,re_chilay,
!    ai_chilay,roughness,xxx  which are used in scattering theories,   
     logical         b_vfr2,b_dum5,b_Hext,b_thetaHe,b_phiHe,           &
                     b_laba,b_thetals,b_psils,b_dxx,b_etaxx,           &
                     b_phixx,b_thetaxx,b_psixx,b_dumvfr2 
     common/bvfr2trf/b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe,        &
                     b_laba,b_thetals,b_psils,b_dxx,b_etaxx,           &
                     b_phixx,b_thetaxx,b_psixx,b_dumvfr2(ivfr2trf-17)                            
                                                                       
     real          ac1,symcase,timeinvers,cTms,                         &
                   ajg,aje,amueg,amuee,QgdQe,r_QUDI,e1m1,dumc          
     common/acmaps/ac1,cTms,ajg,aje,amueg,amuee,QgdQe,r_QUDI,e1m1,      &
                   symcase,timeinvers,dumc(icstrf-11)                  
     logical       b_ac1,b_dum 
     common/bcmaps/b_ac1,b_dum(icstrf-1) 
!    arrays derived from constants are calculated only once (transforma
!    matrices for equivalent orientations, clebsch Gordan coefficients 
!    in the routine  hamJgJe, ...)                                     
                                                                       
     real          avss,shift12,pop,wab,varnuc1,varnuc2,dumvss
     common/avmaps/avss,shift12,pop,wab,varnuc1(13),varnuc2(13),      &
                   dumvss(ivstrf-30)
     logical       b_vss,b_shift12,b_pop1,b_w12,b_varnuc1,b_varnuc2,b_dumvss         
     common/bvmaps/b_vss,b_shift12,b_pop1,b_w12,b_varnuc1(13),b_varnuc2(13),&
                   b_dumvss(ivstrf-30)                                  
                                                                       
!    parameter(maxloop=5,..) has also to be changed in sym_equiv(...)  
     integer,parameter::maxloop=11,islt=10,ixxct=islt+25,ixxC=ixxct+25,  &
                        isxct1=ixxC+5,isxC1=isxct1+25,isxct2=isxC1+5,    &
                        isxC2=isxct2+25,iect1=isxC2+5,iefgC1=iect1+25,   &
                        iect2=iefgC1+5,iefgC2=iect2+25,iecv1=iefgC2+5,   &
                        ihvC1=iecv1 +9,iecv2 =ihvC1+ 3,ihvC2=iecv2 +9,   &
                        id1=ihvC2+3,id2=id1+1+maxloop,id3=id2+9*maxloop, &
                        istore=id3+25*maxloop  

     real,dimension(maxloop)  :: timeinv   
     complex,dimension(-2:2):: efgPAS,efgC,efgC0,efgC1,efgC2,efgL,efgL1,  &
                               xxPAS,sxC,sxC0,sxCL,sxCL1,  &
                               sxC1,sxC2,xxC,xxC0,xxClab
     complex,dimension(-1:1)     :: hv,hvL,hvL1,hvC,hvC1,hvC2,hvC0,hve
     complex,dimension(-2:2,-2:2):: Dect1,Dect2,Dsxct1,Dsxct2,Dxxct,Dslt,Dclt,Dcpt    
     complex,dimension(-1:1,-1:1):: Decv1,Decv2,Dslv,Dclv,Dcpv
     complex,dimension(-2:2,-2:2,maxloop):: d2
     complex,dimension(-1:1,-1:1,maxloop):: d1
     complex,dimension(maxloop)  :: ctimeinv
                                                                       
     complex,dimension(istore):: store
     complex      caseloop
     equivalence (store(1),Dslv(-1,-1)),(store(islt),Dslt(-2,-2)),     & 
                 (store(ixxct),Dxxct(-2,-2)),(store(ixxC),xxC(-2)),    &
                 (store(isxct1),Dsxct1(-2,-2)),(store(isxC1),sxC1(-2)),&
                 (store(isxct2),Dsxct2(-2,-2)),(store(isxC2),sxC2(-2)),&
                 (store(iect1),Dect1(-2,-2)),(store(iefgC1),efgC1(-2)),&
                 (store(iect2),Dect2(-2,-2)),(store(iefgC2),efgC2(-2)),&
                 (store(iecv1),Decv1(-1,-1)),(store(ihvC1),hvC1(-1)),  &
                 (store(iecv2),Decv2(-1,-1)),(store(ihvC2),hvC2(-1)),  &
                 (store(id1),caseloop),(store(id1+1),ctimeinv(1)),     &
                 (store(id2),d1(-1,-1,1)),(store(id3),d2(-2,-2,1))
                                                                       

     integer,parameter:: idumscrd=maxscrd-6144*2-128*3-9*24 
     real        thetaOM,phiOM,eh,mat,dumscrd 
     common/scrd/phiOM(6144),thetaOM(6144),                           &
                 eh(3,128),mat(3,3,24),dumscrd(idumscrd)               
     real,parameter :: sqrt2=1.4142136,q62=1.224745,sqrt23=0.816497,   &
                       sqrt6=2.44950,rad=0.0174533,pi=3.14159

     integer i,j,k,m,n,ip,ii,iset,isymmetry,n_psi,jpsi,iOM,jOM,    &
             je,jg,jge,jges,ncase,nstate,itr,jtxtu,                    &
             nloop,nloop_b,nloop_e,jloop,nput,jljpjO,n_all    
     logical b_Hia,b_Hea,b_Hegt0,b_Higt0,b_Hgt0,                       &
             b_eq,b_eqa,b_eqgt0,b_sx,b_sxa,b_sxgt0,                    &
             b_xx,b_xxa,b_xxgt0,b_laba0,b_integer
     real    a_mueg,a_muee,c_Tms,efg0,efg2,x22,sx22,aH1,aH2,DEq1,DEq2, &
             dsx1,dsx2,azz,texture,Stexture,psi_OM,               &
             h,hx,hy,hz,cost,cost2,sint,cosp,sinp,cos2p,sin2p,         &
             fsx1,fsx2,w12,pop1 
     real    aH,phiH,thetaH,phiHe_r,thetaHe_r,phiLS_r,thetaLS_r,psiLS_r,  &
             DEq,eta,phi_CE,theta_CE,psi_CE,eta_sx,phi_sx,theta_sx,psi_sx,tf

     character(len=2)  :: w6
     complex  hc1 !,hc2,hc3,hc4 
     complex, parameter:: C0=cmplx(0.,0.),Ci=cmplx(0.,1.), C1=cmplx(1.,0.)
     integer, parameter:: ks=2
     complex, dimension(:),   allocatable :: vhefg1 
     complex, dimension(:),   allocatable :: Eagd
     complex, dimension(:,:,:), allocatable :: VV
     integer, dimension(:,:,:), allocatable :: jOLP
     real,    dimension(:),    allocatable :: txtuGT0

     real, save    :: start,finish, wstart,wfinish
     jge=(2.*ajg+1)*(2.*aje+1)+0.01 
      jges=jge*ks

     if(acfr2.lt.3.)aset=0.0 
!     this way iset,... have not to be defined in frstr_..              

     if(isubthe.lt.0) then 
      theoryname='H_DEQ_f_RELAX_equivalent_sites      v=100' 
      if(isubthe.eq.-16) then 
!     reading .par file ncase,symcase are not mapped (-> 8888.88)     
!     asking name with isubthe=-1 the routine sym_equiv (later        
!     calculating storage space) leads to an error exit               
      symcase=0.0 
      ncase=0 
      return 
     end if 

!    routines only asking for the name (not values for storage space) 
!    put isubthe to -16 (far away from -ntheory)                      
     if(enwr(15).eq.'time') then
      call cpu_time(start) ; call wall_time(wstart)                               
     end if
   
      ncase=symcase 
       call sym_equiv(-ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
       iset=aset 
       if(nloop.eq.-1)nloop=0          ! only 1 rotation 
       if(iset.gt.0) then 
        isymmetry=asymmetry 
        n_psi=a_psi 
        call sphere(-iset,isymmetry,.false.,iOM,phiOM,thetaOM)
        if(iOM.eq.0) then 
         info=1 
         infotext(1)=' ' 
         infotext(2)(1:17)='*** error ***' 
         infotext(3)='meaningless values of constants iset/isymmetry' 
         infotext(4)=                                                   &
              'help available: {co a}, {he cn} (n=number of constant)'    
         infotext(5)=' ' 
         return 
        end if 
        i=1+istore+2+5*jges*(nloop+1)*iOM*(n_psi+1)+iOM*2  
        if(iOM.eq.1)i=i+2 
        ac1=i 
       else 
        ac1=1+istore+2+(2+5*jges)*(nloop+1)+2 
       end if 
       return 
      end if 
                                                                        
!        write(6,'(a,f15.2)')'th_22nuclear avfr2...',r_QUDI                          
!        write(6,'(8f10.2)')avfr2,dum5(5),Hext,thetaHe,phiHe,           &
!                     phi_ls,theta_ls,psi_ls,                           &
!                     d_xx,eta_xx,phi_xx,theta_xx,psi_xx,               &
!                     t200,t400          
!      write(6,'(20L3)')b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe,      &
!                     b_laba,b_thetals,b_psils,b_dx2,b_etaxx,b_phixx,   &
!                     b_thetaxx,b_psixx,b_t200,b_t400                  

      if(.not.(b_vss.or.b_vfr2)) then 
       isubthe=-abs(isubthe)       ! 24.10.07 theory parameter not changed  
       return 
      end if 

      if(iget.eq.0) print'(a)','iget not defined'      
! ----------------------------------------------------------------------
  if(e1m1.eq.0.0)e1m1=-1.0   ! see comment  subroutine th_hdeq()

  allocate(Eagd(jges),VV(-1:1,-1:1,jges))

      j=iput+1 
      nput=j+istore 
      do i=1,istore 
       store(i)=array_fr(j+i) 
      end do 
      array_fr(j)=cmplx(float(nput),float(istore)) 

      ii=jge/2 
      if(2*ii.eq.jge) then 
       b_integer=.false. 
       je=2*aje+0.01 
       jg=2*ajg+0.01 
      else 
       b_integer=.true. 
       je=aje+0.01 
       jg=ajg+0.01 
      end if 

      a_mueg=amueg 
      a_muee=amuee 
      c_Tms=cTms 
                                                                        
      n_psi=a_psi 
      iset=aset; if(iset.eq.0) n_psi=0
      jtxtu=10*(0.001+aset-iset)
      if(iset.eq.0)then
         n_psi=0; jtxtu=0
      end if   
      ncase=symcase 
      isymmetry=asymmetry 
                                                                        
      nloop_b=0 
      if(b_ac1) then 
       call sym_equiv(ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      else 
       nloop=real(caseloop) 
!      write(6,'(a,i6)')'th_22nuclear nloop=',nloop                     
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      end if 
      do k=1,nloop_e 
       timeinv(k)=real(ctimeinv(k)) 
      end do 

      if(bcfr2) then 
       call sphere(iset,isymmetry,.false.,iOM,phiOM,thetaOM)          
       caseloop=cmplx(float(nloop),float(iOM)) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if
       j=(nput+2+3*jges*n_all)*2 
       do i=1,iOM 
        k=(i-1)*2+j 
        real_fr(k+1)=phiOM(i) 
        real_fr(k+2)=thetaOM(i) 
       end do 
      else 
       iOM=aimag(caseloop) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if 
       j=(nput+2+3*jges*n_all)*2 
       do i=1,iOM 
        k=(i-1)*2+j 
        phiOM(i)=real_fr(k+1) 
        thetaOM(i)=real_fr(k+2) 
       end do 
      end if 
      caseloop=cmplx(float(nloop),float(iOM)) 

!    external field defined in the LAB system S_L  (store hve)
      b_Hegt0=abs(Hext).gt.0.0
      if(icase.eq.2.and.b_Hegt0)then
       info=2  
       infotext(1)=' ' 
       infotext(2)(1:17)='*** warning ***' 
       infotext(3)='external field > 0: intensity average for the ideal powder' 
       infotext(4)='is not valid '    
       infotext(5)=' ' 
       return 
      end if         

      if(b_Hegt0) then
       b_Hea=b_phiHe.or.b_thetaHe
       if(b_Hea)then 
        phiHe_r=phiHe*rad; thetaHe_r=thetaHe*rad 
        hve(1) =-cmplx(cos(phiHe_r),sin(phiHe_r))*sin(thetaHe_r)/sqrt2
        hve(0) = cmplx(cos(thetaHe_r),0.0) 
        hve(-1)=-conjg(hve(1)) 
       end if 
      else
       hve=(.0,.0)
      end if

!     The orientation of the crystal in the laboratory is decribed by   
!     the Euler angles (phi,theta,psi). e_z(S_C) in the la. system S_L  
!     determines phi,theta, which are the polar angle of e_z(S_C).      
!     The Euler angles are obtained with the                            
!     program euler in the directory effi/helproutines/euler:           
!      [1 Euler angles from unit vectors]->[unit vectors eb(n) in system
!     Input are the unit vectors e_C=eb(x,y,z) of the crystal system S_C
!      with respect to the lab. system S_L.                             
!     The tensor components known in the system S_C are tranformed to th
!     Lab. system by the invers transformation Dsl(-psi,-theta,-phi).   
!     Symbolic:  e_C in S_L  -> t_L=t_C*dlc^(-1)                        
!     (see comment for sx2 above)                                       
      b_laba0=abs(phi_ls)+abs(theta_ls)+abs(psi_ls).lt.0.001 
!     b_laba=b_phils.or.b_thetals.or.b_psils provided by common/bvfr2trf/
!     (store Dslv,Dslt)
      if(b_laba)then 
       phiLS_r=phi_LS*rad 
       thetaLS_r=theta_LS*rad 
       psiLS_r=psi_LS*rad 
       
!      1. rank tensor transformation matrix: crystal/sample to Lab      
       call dimj(-psiLS_r,-thetaLS_r,-phiLS_r,1,Dslv) 
!      2. rank tensor transformation matrix: crstal/sample to Lab       
       call dimj(-psiLS_r,-thetaLS_r,-phiLS_r,2,Dslt)
      end if ! b_laba (lab angle) 

!     <xx> tensor (d_xx,eta_xx,phi_xx,theta_xx,psi_xx)  (store Dxxct,xxC)
!     see comment on the <sx2> tensor                                   
      b_xxa =b_phixx.or.b_thetaxx.or.b_psixx 
      b_xx  =b_dxx.or.b_etaxx.or.b_xxa 
      b_xxgt0=abs(d_xx).gt.0. 

      if(b_xxa) call dimj(-psi_xx*rad,-theta_xx*rad,-phi_xx*rad,2,Dxxct)
      x22=eta_xx/sqrt(6.) 
      xxPAS(0)=cmplx(1.,0.0) 
      xxPAS(-1)=(0.,0.) 
      xxPAS(1)=(0.,0.) 
      xxPAS(-2)=cmplx(x22,0.) 
      xxPAS(2)=cmplx(x22,0.) 
      call vecxmat(2,xxPAS,Dxxct,xxC0)
                                                                        
!     <sx>-tensor of the called site (dsx,eta_sx,phi_sx,theta_sx,psi_s)
!     (store Dsxct1,sxC1,Dsxct2,sxC2)
!     state 1   
      b_sxa=b_varnuc1(3).or.b_varnuc1(4).or.b_varnuc1(5) 
      b_sx =b_varnuc1(1).or.b_varnuc1(2).or.b_sxa 
      dsx1=varnuc1(1); eta_sx=varnuc1(2) 
      phi_sx=varnuc1(3)*rad; theta_sx=varnuc1(4)*rad; psi_sx=varnuc1(5)*rad  
      b_sxgt0=abs(dsx1).gt.0.

      if(b_sx) then 
       if(b_sxa)then 
!       The Euler angles rotate the crystal system S_C to the PAS S_sx2 
!       of <sx2> tensor.The Euler angles are obtained with the          
!       program called by  {eu} [1 Euler angles from unit vectors]      
!       ->[unit vectors eb(n) in system Sa].                            
!       Input are the unit vectors eb(x,y,z)=e_sx2 of S_sx2 with respect
!       to the crystal system S_C.                                      
!       The transformation Dsxct(-gamma,-theta,-alpha) transforms       
!       the tensor components to the crystal system.                    
!       Symbolic:  e_sx2 in S_C  -> t_C=t_sx2*d^(-1)                    
        call dimj(-psi_sx,-theta_sx,-phi_sx,2,Dsxct1)
       end if 
                                                                        
!      xxPAS (-2..2) are the spherical tensor components of <sx2> in the
!      S_sx2 system. The tensor is attached to site 1 (of nloop+1       
!      equivalent sites) of the crystal.                                
       sx22=eta_sx/sqrt(6.) 
       xxPAS(0)=cmplx(1.,0.0) 
       xxPAS(-1)=(0.,0.) 
       xxPAS(1)=(0.,0.) 
       xxPAS(-2)=cmplx(sx22,0.) 
       xxPAS(2)=cmplx(sx22,0.) 
       call vecxmat(2,xxPAS,Dsxct1,sxC1)
!      sxC(n) are the components of the tensor in the crystal system.  
!      Taking these components (the Cathesian one) to the program called
!      by  {eu} [9 Euler angles of PAS of 2. rank tensor]               
!      the PAS-values and Euler angles are obtained back.               
      end if  ! b_sx

!     state 2
      b_sxa=b_varnuc2(3).or.b_varnuc2(4).or.b_varnuc2(5) 
      b_sx =b_varnuc2(1).or.b_varnuc2(2).or.b_sxa 
      dsx2=varnuc2(1); eta_sx=varnuc2(2); 
      phi_sx=varnuc2(3)*rad; theta_sx=varnuc2(4)*rad; psi_sx=varnuc2(5)*rad  
      b_sxgt0=b_sxgt0.or.abs(dsx2).gt.0.

      if(b_sx) then 
       if(b_sxa)call dimj(-psi_sx,-theta_sx,-phi_sx,2,Dsxct2)
       sx22=eta_sx/sqrt(6.) 
       xxPAS(0)=cmplx(1.,0.0) 
       xxPAS(-1)=(0.,0.) 
       xxPAS(1)=(0.,0.) 
       xxPAS(-2)=cmplx(sx22,0.) 
       xxPAS(2)=cmplx(sx22,0.) 
       call vecxmat(2,xxPAS,Dsxct2,sxC2)
      end if  ! b_sx2  
!     <sx2>-tensor of the called site --------------------------------------

!                                             ###############################
!     electric field gradient/internal magnetic field
!     (store Dect1,efgC1,Decv1,hvC1,Dect2,efgC2,Decv2,hvC2)
!     state 1
      b_eqa=b_varnuc1(11).or.b_varnuc1(12).or.b_varnuc1(13) 
      b_eq=b_varnuc1(9).or.b_varnuc1(10).or.b_eqa 
      DEq1=varnuc1(9); eta=varnuc1(10); 
      phi_CE=varnuc1(11)*rad; theta_CE=varnuc1(12)*rad; psi_CE=varnuc1(13)*rad
      b_eqgt0=abs(DEq1).gt.0. 

      if(b_eq)then 
!      efg (-2..2) are the spherical tensor components of the EFG in the PAS
       if(b_eqa) call dimj(-psi_CE,-theta_CE,-phi_CE,2,Dect1) 
       efg0=1.0/sqrt(1.+eta**2/3.) 
       efg2=eta*efg0/sqrt(6.) 
       efgPAS(0)=cmplx(efg0,0.0) 
       efgPAS(-1)=(0.,0.) 
       efgPAS(1)=(0.,0.) 
       efgPAS(-2)=cmplx(efg2,0.) 
       efgPAS(2)=cmplx(efg2,0.) 
       call vecxmat(2,efgPAS,Dect1,efgC1)
      end if  ! b_eq

!-----enable write----- tensors (site 1) in the crystal system --------------
       if(enwr(6)(1:2).eq.'s1') then   !  'cx', 'sx', 'ef'
        w6=enwr(6)(3:4)
        call writetensors1(w6,d_xx,xxC0,dsx2,sxC2,phi_CE,theta_CE,psi_CE,efgC)
       end if 
!------end enable write---------------------------------------------   

!     internal magnetic field defined with respect to the PAS of the EFG 
      b_Hia=b_varnuc1(7).or.b_varnuc1(8)
      aH1 =varnuc1(6)
      b_Higt0=abs(aH1).gt.0.0 
      if(b_eqa.or.b_Hia)then
       thetaH=varnuc1(7)*rad; phiH=varnuc1(8)*rad
       hv(1) =-cmplx(cos(phiH),sin(phiH))*sin(thetaH)/sqrt2
       hv(0) = cmplx(cos(thetaH),0.0)
       hv(-1)=-conjg(hv(1)) 
       call dimj(-psi_CE,-theta_CE,-phi_CE,1,Decv1) 
       call vecxmat(1,hv,Decv1,hvC1)   
!      write(6,'(a,f10.1,a2,6f10.4,a1)') 'hvC1  = ',aH1,'*(',hvC1,')'
      end if
!     transformation of the magnetic field H from the  S_E to the     
!     crystal system S_C. hvC(n) in the crystal system  S_C.          

!     state 2
      b_eqa=b_varnuc2(11).or.b_varnuc2(12).or.b_varnuc2(13) 
      b_eq=b_varnuc2(9).or.b_varnuc2(10).or.b_eqa 
      DEq2=varnuc2(9); eta=varnuc2(10); 
      b_eqgt0=b_eqgt0.or.abs(DEq2).gt.0. 
      if(b_eq)then 
!      efg (-2..2) are the spherical tensor components of the EFG in the PAS
       if(b_eqa)then
        phi_CE=varnuc2(11)*rad; theta_CE=varnuc2(12)*rad; psi_CE=varnuc2(13)*rad
        call dimj(-psi_CE,-theta_CE,-phi_CE,2,Dect2) 
       end if
       efg0=1.0/sqrt(1.+eta**2/3.) 
       efg2=eta*efg0/sqrt(6.) 
       efgPAS(0)=cmplx(efg0,0.0) 
       efgPAS(-1)=(0.,0.) 
       efgPAS(1)=(0.,0.) 
       efgPAS(-2)=cmplx(efg2,0.) 
       efgPAS(2)=cmplx(efg2,0.) 
       call vecxmat(2,efgPAS,Dect2,efgC2)
      end if  ! b_eq

!     internal magnetic field defined with respect to the PAS of the EFG 
      b_Hia=b_varnuc2(7).or.b_varnuc2(8)
      aH2 =varnuc2(6)
      b_Higt0=b_Higt0.or.abs(aH2).gt.0.0 
      if(b_eqa.or.b_Hia)then
       thetaH=varnuc2(7)*rad; phiH=varnuc2(8)*rad
       hv(1) =-cmplx(cos(phiH),sin(phiH))*sin(thetaH)/sqrt2
       hv(0) = cmplx(cos(thetaH),0.0)
       hv(-1)=-conjg(hv(1))
       call dimj(-psi_CE,-theta_CE,-phi_CE,1,Decv2) 
       call vecxmat(1,hv,Decv2,hvC2)        
      end if
!     electric field gradient/internal magnetic field  -----------------------

!     DEq1,efgC1, DEq2,efgC2, aH1,hvC1, aH2,hvC2;  b_eqgt0,b_Higt0,b_Hegt0
                                                                        
      b_Hgt0=b_Higt0.or.b_Hegt0 
                                                                        
!     Transformation of the tensors sx2,x2 tensor given in the crystal  
!     system  to the lab-system.                                        
!     The gamma-direction is parallel to +z of the lab-system.          
                                                                        
!     write(6,'(10f8.4)')Dslt                                           
!     electric field gradient tensor  transformed to the crystal system 
!     (see comment for sx2 above)                                       
                                                                        
!      storing the tensors of the 1. site if there are nloop+1          
!      equivalent sites (nloop >0)                                      

!      ----------------------------------------------------             
!       thetaOM(1)=54.7*rad                                             
!       phiOM(1)=pi/4.                                                  
!       thetaOM(1)=0.                                                   
!      Omega loop in case of an average over different crystal          
!      orientations: powder, texture                                    
!      ----------------------- loops-----------------------  
      if(enwr(15).eq.'time') then
          call cpu_time(start);  call wall_time(wstart)
       end if
      allocate(txtuGT0(iOM))     

      Stexture=0.0; txtuGT0=0.0
      do jOM=1,iOM
!      texture functions, parameters
!      (t00,t100,t11s,t11c,t200,t1s0,t1c0,t2s0,t2c0,t300,t400) describe 
!      the theta,phi- dependence of texture seen by a dipole transition  
!      t100,t200,t300,t400 describe axial texture for mixed M1/E2 transition 
        select case(jtxtu)
        case(0)         ! ideal powder
         texture=1.     
        case(1)         ! M1,E1: axial symmetry of texture
         cost=cos(thetaOM(jOM)); cost2=cost**2
         texture=1.0+t100*cost+t200*(3.0*cost2-1.)/2
        case(2)         ! dipole: Theta,phi distribution 
         cost=cos(thetaOM(jOM));  sint=sin(thetaOM(jOM));
         cosp=cos(phiOM(jOM));    sinp=sin(phiOM(jOM))
         cos2p=cos(2.*phiOM(jOM));sin2p=sin(2.*phiOM(jOM))
         cost2=cost**2
         texture=t00+t100*cost+(t11s*sinp+t11c*cosp)*sint            &
                  +t200*(3.0*cost2-1.)+((t21s*sinp+t21c*cosp)*cost  &
                  +(t22s*sin2p+t22c*cos2p)*sint)*sint

        case(3)    ! E2: axial symmetry of texture
         cost=cos(thetaOM(jOM)); cost2=cost**2
         texture=t00+t100*cost+t200*(3.0*cost2-1.)                   &
              +t300*cost*(5.0*cost2-3.)+t400*((35*cost2-30)*cost2+3.)
        case(4)    ! E2: Theta,phi distribution (t3mn, t4mn terms are missing!!)
         cost=cos(thetaOM(jOM));  sint=sin(thetaOM(jOM));
         cosp=cos(phiOM(jOM));    sinp=sin(phiOM(jOM))
         cos2p=cos(2.*phiOM(jOM));sin2p=sin(2.*phiOM(jOM))
         cost2=cost**2
         texture=t00+t100*cost+(t11s*sinp+t11c*cosp)*sint            &
                  +t200*(3.0*cost2-1.)+((t21s*sinp+t21c*cosp)*cost  &
                  +(t22s*sin2p+t22c*cos2p)*sint)*sint               &
                  +t300*cost*(5.0*cost2-3.)+t400*((35*cost2-30)*cost2+3.)      
        case(5)    ! model: ellipsoidal distribution (always >0!)
         cost2=cos(thetaOM(jOM))**2
         texture=1./sqrt(1.+(t200**2-1.)*cost2)
      end select
        Stexture= Stexture+ texture 
        txtuGT0(jOM)=texture
       end do

      if(enwr(6).eq.'txtu')then
       open(unit=2,file='direction.lay'//char(ipostxtu+48),       &
         status='unknown',access='sequential',form='formatted')
       write(2,'(a,/,a)') '# Orientations: z-axes',          &       
                          '(f10.3,f10.3,f10.3)   x y z'
       write(2,'(a,i4)')'nu_channels  =',iOM  
       do jOM=1,iOM
        write(2,'(3f10.3)') &
           cos(phiOM(jOM))*sin(thetaOM(jOM)),  &
           sin(phiOM(jOM))*sin(thetaOM(jOM)),cos(thetaOM(jOM))
       end do
       write(2,'(3f10.3)') float(iOM),0.000,-1.000
       write(2,'(3f10.3)') -1.000,-1.000, -1.000
       write(2,'(a1)')'x','y','z'
       close(unit=2)

       open(unit=3,file='texture.lay'//char(ipostxtu+48),          &
         status='unknown',access='sequential',form='formatted')
       write(3,'(2(a,/),a,i4)')'# weighted directions of layer '   &
                          //char(ipostxtu+48),&
          '(f10.3,f10.3,f10.3)   x y z','nu_channels  =',iOM     
      end if

      allocate(jOLP(iOM,0:nloop_e,0:n_psi))
      
      jljpjO=iOM*(nloop_e-nloop_b+1)*(n_psi+1)*13     
      allocate(vhefg1(jljpjO)) 
       

      jljpjO=0 
      do jOM=1,iOM
         do jloop=nloop_b,nloop_e
          nstate=0  
 11       continue
          nstate=nstate+1
         do jpsi=0,n_psi
          if(nstate.eq.1) jljpjO=jljpjO+1  
          jOLP(jOM,jloop,jpsi)=jljpjO
         end do
         if(nstate.eq.1) goto 11 
       end do
      end do
  
      h=float(iOM)/float(jljpjO)
      txtuGT0=txtuGT0/Stexture*h
      Stexture=Stexture/h

      if(enwr(6).eq.'txtu')then
       Stexture=Stexture/h
       do jOM=1,iOM 
        texture=txtuGT0(jOM)
        h=texture/Stexture
        hv(1)=C0; hv(-1)=C0; hv(0)=C1*h
        call dimj(0.0,-thetaOM(jOM),-phiOM(jOM),1,Dcpv)
        Dclv=matmul(Dcpv,Dslv)
        call vecxmat(1,hv,Dclv,hvL)
        hx=-real(hvL(1)-hvL(-1))/sqrt2 
        hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2  
        hz= real(hvL(0))
        write(3,'(3f10.3)')hx,hy,hz
       end do
       write(3,'(3f10.3)') float(iOM),0.000,-1.000
       write(3,'(3f10.3)') -1.000,-1.000, -1.000
       write(3,'(a1)')'x','y','z'
       close(unit=3)
!       print'(a,i4,f12.2)','iOM,Stexture=',iOM,Stexture
      end if

      psi_OM=2.*pi/(n_psi+1) 

   CALL OMP_SET_NUM_THREADS(nproc)
!$OMP PARALLEL DEFAULT(PRIVATE) &
!$OMP SHARED(enwr,phiOM,thetaOM,iOM,txtuGT0,d1,d2,nloop_b,nloop_e)&
!$OMP SHARED(efgC1,hvC1,aH1,DEq1,sxC1,efgC2,hvC2,aH2,DEq2,sxC2,d_xx,xxC0)&
!$OMP SHARED(sxCL,sxCL1,dsx1,dsx2,fsx1,fsx2) &
!$OMP SHARED(b_Higt0,b_eqgt0,b_sxgt0,b_Hgt0,b_laba0,b_xxgt0,b_integer)&
!$OMP SHARED(n_psi,psi_OM,Dslv,Dslt,hve,Hext,r_QUDI,e1m1,pop,wab)&
!$OMP SHARED(icase,amueg,amuee,QgdQe,cTms,je,jg,jge,shift12)&
!$OMP SHARED(jOLP,nput,jges,timeinv,array_fr)      
!$OMP DO
     do jOM=1,iOM 
      texture=txtuGT0(jOM)
!    loop over equivalent sites. In the routine sym_equiv(...,d1,d2)  
!    the transformations d1 and d2 and timeinv() are defined          
!    write(6,'(a,2i4)')' nloop_b,nloop_e=',nloop_b,nloop_e            


     do jloop=nloop_b,nloop_e 
     
     nstate=0                                                                 
1111 continue
     nstate=nstate+1
     if(nstate.eq.1) then
       efgC0=efgC1;  hvC0 =hvC1; ah=aH1; DEq=DEq1;  sxC0=sxC1 
     else if(nstate.eq.2) then
       efgC0=efgC2;  hvC0 =hvC2; ah=aH2; DEq=DEq2;  sxC0=sxC2
     end if

      if(jloop.gt.0) then 
       if(b_Higt0) then 
        do n=-1,1 
         hc1=C0 
         do m=-1,1 
          hc1=hc1+hvC0(m)*d1(m,n,jloop) 
         end do 
         hvC(n)=hc1*timeinv(jloop) 
        end do 
       else
        hvC=C0
       end if 
                                                                      
       if(b_eqgt0)then 
        do n=-2,2 
         hc1=C0
         do m=-2,2 
          hc1=hc1+efgC0(m)*d2(m,n,jloop) 
         end do 
         efgC(n)=hc1 
        end do 
       else
        efgC=C0
       end if 

       if(b_sxgt0)then 
        do n=-2,2 
         hc1=C0
         do m=-2,2 
          hc1=hc1+sxC0(m)*d2(m,n,jloop) 
         end do 
         sxC(n)=hc1 
        end do
       else
        sxC=C0
       end if 
      else 
       efgC=efgC0 
       hvC =hvC0 
       xxC =xxC0 
       sxC=sxC0 
      end if   ! jloop > 0   

       do jpsi=0,n_psi 
!      averaging over psiOM with n_psi+1 steps                         
!      write(6,'(a,i4,3f10.3)')' jpsi,texture=',jpsi,texture,t200,t400           
       jljpjO=jOLP(jOM,jloop,jpsi)

       if(b_Hgt0) then 
!       The grid point p(thetaOM,phiOM) defines z-axis of the system   
!       S_S of the sample. (If the sample is not rotated S_S coincides 
!       with the lab. system S_L, and the z_axis is the direction of   
!       observation).                                                  
!       The rotation around the z-axis starts with angle psiOM         
!       and has n_psi steps for averaging. The components in the       
!       S_OM system are                                                
!       Symbolic:  e_OM in S_C  -> t_C*dcs=t_OM   (t_S=t_OM)           
!       If the sample system S_S  is rotated with respect to the Lab. s
!       -Dsl (=djsl)- the tensor components are                        
!       transformations are:                                           
!        Symbolic:  e_S in S_L  -> t_L=t_S*dls^(-1)                    
!                                  t_L= t_C*dcs*dls^(-1)               
                                                                       
        call dimj(phiOM(jOM),thetaOM(jOM),jpsi*psi_OM,1,Dcpv) 
        if(b_laba0)then 
!        1. rank tensor transformation                                 
         Dclv=Dcpv 
        else
         Dclv=matmul(Dcpv,Dslv)
        end if 
                                                                       
        call vecxmat(1,hvC,Dclv,hvL)   
        hvL=hvL*aH+hve*Hext 
       else 
        hvL=C0
       end if    ! b_Hgt0 

       call dimj(phiOM(jOM),thetaOM(jOM),jpsi*psi_OM,2,Dcpt) 

!      2. rank tensor transformation                                  
       if(b_laba0)then 
        Dclt=Dcpt 
       else 
        Dclt=matmul(Dcpt,Dslt) 
       end if
     
        call vecxmat(2,efgC,Dclt,efgL)   
        efgL=efgL*DEq
        call vecxmat(2,sxC,Dclt,sxCL)
        call vecxmat(2,xxC,Dclt,xxClab)
        azz=real(xxClab(0))*d_xx
       if(nstate.eq.1) then
        do i=1,3
         ii=13*(jljpjO-1)+i 
         vhefg1(ii)=hvL(i-2)
        end do
        do i=4,8
         ii=13*(jljpjO-1)+i 
         vhefg1(ii)=efgL(i-6)
        end do                                                                
        do i=9,13
         ii=13*(jljpjO-1)+i 
         vhefg1(ii)=sxCL(i-11)
        end do                                                                

       else if(nstate.eq.2) then
        ! hvl,efgL,sxL belong to nstate 2 
        do i=1,3
         ii=13*(jljpjO-1)+i 
         hvL1(i-2)=vhefg1(ii)
        end do
        do i=4,8
         ii=13*(jljpjO-1)+i 
         efgL1(i-6)=vhefg1(ii)
        end do
        do i=9,13
         ii=13*(jljpjO-1)+i 
         sxCL1(i-11)=vhefg1(ii)
        end do

         fsx1=exp(-real(sxCL1(0))*dsx1)
         fsx2=exp(-real(sxCL(0))*dsx2)
        if(r_QUDI.eq.0.)then 
!        dipole transition  --------------------------------
         itr=1
        else  
         if(abs(r_QUDI).lt.1000.)then 
!         mixed M1/E2 transition  ----------------------------
          itr=2 
         else 
!         E2 transition  --------------------------------
          itr=3
         end if 
       end if

       if(enwr(7).eq.'ln12') then
          pop1=pop   ! pop1 is fitparameter
          w12=exp(wab)       ! ln(w12) is fitparameter
          ! ln(w12)= ln[K0*exp(-delta/kT)] =: a - b/T
          ! a,b become fit parameters of  ln(w12)
          !
          ! matrix:
          !            pop1 ln(w12)   a    b
          !  ln(w12)    0       0     1    -1/T
          !  pop1       1       0     0    0
          !  for n spectra  n+2 parameters instead of 2*n
       else if(enwr(7).eq.'ln21') then
          pop1=pop                      ! pop1 is fitparameter
          w12=(1.-pop1)*exp(wab)/pop1   ! ln(w21)  is fitparameter
          ! w21=pop1*w12/pop2
          ! ln(w21)= ln[K0*exp(-delta/kT)] =: a - b/T
          ! a,b become fit parameters of the product ln(w21)
          !
          ! matrix:
          !            pop1     ln(w21)   a    b
          !  ln(w21)    0           0     1    -1/T
          !  pop1       1           0     0    0
          !  for n spectra  n+2 parameters instead of 2*n
       else if(enwr(7).eq.'lnpw') then
          pop1=exp(pop)      ! ln(pop1) is fitparameter
          w12=exp(wab)       ! ln(w12)  is fitparameter
          ! ln(pop1*w12)= ln[K0*exp(-delta/kT)] =: a - b/T
          ! a,b become fit parameters of the product ln(pop1*w12)
          !
          ! matrix:
          !            ln(pop1) ln(w12)   a    b
          !  ln(w12)   -1           0     1    -1/T
          !  ln(pop1)   1           0     0    0
          !  for n spectra  n+2 parameters instead of 2*n
       else
        w12=wab; pop1=pop  
       end if
       if(enwr(8).eq.'lnPR')print'(6f12.4)',pop1,w12,pop1/(1.-pop1),&
            pop1/(1.-pop1)*w12,pop1*w12    
        if(b_integer) then
         call intJgJeRELAX2(itr,icase,r_QUDI,amueg,amuee,QgdQe,cTms,je,jg,jge,  &
                     shift12,pop1,fsx1,fsx2,w12,hvL1,efgL1,hvL,efgL,Eagd,VV)        
        else
         call hintJgJeRELAX2(itr,icase,r_QUDI,amueg,amuee,QgdQe,cTms,je,jg,jge,  &
                     shift12,pop1,fsx1,fsx2,w12,hvL1,efgL1,hvL,efgL,Eagd,VV)
        end if

        ip=nput+2+5*jges*(jljpjO-1)
!        hc1=C0; hc2=C0; hc3=C0; hc4=C0
!        do i=1,jges
!         hc1=hc1+VV(1,1,i); hc2=hc2+VV(-1,-1,i);
!         hc3=hc3+VV(-1,1,i);   hc4=hc4+VV(1,-1,i);
!         write(6,'(2f8.2,10f9.4)')                              &
!         Eagd(i),VV(1,1,i),VV(-1,-1,i),VV(-1,1,i),VV(1,-1,i),VV(0,0,i)
!        end do
!        write(6,'(a,8f9.4)')'                ',hc1,hc2,hc3,hc4
        tf=texture/2.*exp(-azz) ! since the loop goes 2 times for state 1 and 2
        if(icase.eq.1)then
         do i=1,jges 
          ii=ip+5*(i-1) 
          array_fr(ii+1)=Eagd(i) 
          array_fr(ii+2)=VV(1,1,i)*tf
          array_fr(ii+3)=VV(-1,-1,i)*tf
          array_fr(ii+4)=-e1m1*VV(-1,1,i)*tf
          array_fr(ii+5)=-e1m1*VV(1,-1,i)*tf 
         end do
        else if(icase.eq.2)then
         do i=1,jges
            ii=ip+5*(i-1)
          array_fr(ii+1)=Eagd(i) 
          array_fr(ii+2)=VV(0,0,i)
          array_fr(ii+3)=C0
          array_fr(ii+4)=C0
          array_fr(ii+5)=C0
         end do 
        end if
       end if   ! nstate.eq.2
      end do    ! n_psi
     if(nstate.eq.1) goto 1111 
     end do    ! nloop 
    end do ! iOM
!$OMP END PARALLEL
   deallocate(jOLP,txtuGT0) 
!   array_fr(nput+i):                                                 
!   (nput+1)=(n_all,jges)    (nput+2) = (b_xx,0)                       
!   (nput+3)=(Eagd(1),aszz) (nput+4) = (pp-hmm,hr+hmm)/2   (nput+5) =p
!   (nput+6)=(Eagd(2),dsx2) (nput+7) = (pp-hmm,hr+hmm)/2   (nput+8) =p
!   (nput+9)=(Eagd(3),dsx2) (nput+10)= (pp-hmm,hr+hmm)/2   (nput+11)=p
!                                                                     
!    ................................................................ 
!                                                                     
!   (nput+j1)=(Eagd(2),dsx2) (nput+j2)= (pp-hmm,hr+hmm)/2   (nput+j3)=
!    j=2+3*(jge-1) j1=j+1,...,j3=j+3                                  

   if(enwr(15).eq.'time') then
    call cpu_time(finish); call wall_time(wfinish)
    print '(" cpu/wall time = ",2f15.4," seconds.")',finish-start,wfinish-wstart
   end if
 
    array_fr(nput+1)=cmplx(float(iOM),float(jges)) 
    array_fr(nput+2)=cmplx(0.,0.) 
!   aimag of array_fr(nput+2) for further use                         
                                                                      
    j=iput+1 
    do i=1,istore 
     array_fr(j+i)=store(i) 
    end do 
                                                                      
    return  
    END                                           
                                                                        
                                                                        
