      subroutine th_hyperfineft(isubthe,icase,iput,iget,info) 
     use glbconst, only: maxscrd,icstrf,icfr2trf,ivstrf,ivfr2trf,      &
                         infotext,enwr,nwr
     use comthe, only: array_fr,real_fr,theoryname
     implicit none 
                                                                       
     integer isubthe,icase,iput,iget,info 
                                                                       
                                                                       
!    transmission: fr2 defines external magnetic field, orientation    
!    of the sample by phi,theta,psi is calculated by the routine sample
!    orientation tansferred by  array_fr to main and than passed to fr2
                                                                       
     real            acfr2,rep_grp,aset,asymmetry,a_psi,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,               &
                     dumcfr2(icfr2trf-5)                               
     logical         bcfr2,bumcfr2 
     common/bcfr2trf/bcfr2,bumcfr2(icfr2trf-1) 
     real            avfr2,dum5,Hext,thetaHe,phiHe,                    &
                     phi_ls,theta_ls,psi_ls,                           &
                     d_x2,eta_xx,phi_xx,theta_xx,psi_xx,               &
                     t200,t400,dumvfr2                                 
     common/avfr2trf/avfr2,dum5(5),Hext,thetaHe,phiHe,                 &
                     phi_ls,theta_ls,psi_ls,                           &
                     d_x2,eta_xx,phi_xx,theta_xx,psi_xx,               &
                     t200,t400,dumvfr2(ivfr2trf-19)                    
!    b_phi is named b_laba (laboratory angles of the sample)           
!    b_laba has got the value of b_phi.or.b_theta.or.b_psi             
!    in the routine th_sampleorient                                    
!    b_dum5(5) is reserved place for the parameters thicklay,re_chilay,
!    ai_chilay,roughness,xxx  which are used in scattering theories,   
     logical         b_vfr2,b_dum5,b_Hext,b_thetaHe,b_phiHe,           &
                     b_laba,b_thetals,b_psils,b_dx2,b_etaxx,           &
                     b_phixx,b_thetaxx,b_psixx,b_t200,b_t400,b_dumvfr2 
     common/bvfr2trf/b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe,        &
                     b_laba,b_thetals,b_psils,b_dx2,b_etaxx,b_phixx,   &
                     b_thetaxx,b_psixx,b_t200,b_t400,                  &
                     b_dumvfr2(ivfr2trf-19)                            
                                                                       
     real          c1,symcase,timeinvers,cTms,                         &
                   ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,dumc          
     common/acmaps/c1,cTms,ajg,aje,amueg,amuee,QgdQe,r_E2M1,e1m1,      &
                   symcase,dumc(icstrf-10)                             
     logical       b_c1,b_dum 
     common/bcmaps/b_c1,b_dum(icstrf-1) 
!    arrays derived from constants are calculated only once (transforma
!    matrices for equivalent orientations, clebsch Gordan coefficients 
!    in the routine  hamJgJe, ...)                                     
                                                                       
     real          avss,dsx2,eta_sx,phi_sx,theta_sx,psi_sx,dumvss 
     common/avmaps/avss,dsx2,eta_sx,phi_sx,theta_sx,psi_sx,            &
                   dumvss(ivstrf-6)                                    
     logical       b_vss,b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,     &
                   b_dumvss                                            
     common/bvmaps/b_vss,b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx,     &
                   b_dumvss(ivstrf-6)                                  
                                                                       

     integer,parameter::maxloop=11,ixx=14,islt=ixx+25,islv=islt+25,    &
                        icl=islv+9,id1=icl+1,id2=id1+9*maxloop,        &
                        istore=id2+25*maxloop      
     real,dimension(maxloop)  :: timeinv   
     real,dimension(3,3)      :: uveca,vik,vdd


     complex,dimension(-2:2):: efg,efgC,efgC0,efgL,xxPAS,sx2C,sx2C0,x2C
     complex,dimension(-1:1):: hv,hvL,hvC,hvC0,hve
     complex,dimension(-2:2,-2:2):: Dsxct,Dxxct,Dslt,Dclt,Dcpt 
     complex,dimension(-1:1,-1:1):: Dslv,d21,Dclv,Dcpv   
     complex,dimension(-2:2,-2:2,maxloop):: d2
     complex,dimension(-1:1,-1:1,maxloop):: d1
     complex,dimension(maxloop)  :: ctimeinv
                                                                       
!    parameter(maxloop=5,..) has also to be changed in sym_equiv(...)  
     complex,dimension(istore):: store
     complex      caseloop
     equivalence (store(1),sx2C0(-2)),(store(6),x2C(-2)),              &
                 (store(11),hve(-1)),                                  &
                 (store(14),Dsxct(-2,-2)),(store(ixx),Dxxct(-2,-2)),   &
                 (store(islt),Dslt(-2,-2)),(store(islv),Dslv(-1,-1)),  &
                 (store(icl),caseloop),                                &
                 (store(id1),d1(-1,-1,1)),(store(id2),d2(-2,-2,1))     
                                                                       
     integer,parameter::idumscrd=maxscrd-6144*3
     real        thetaOM,phiOM,psiOM,dumscrd 
     common/scrd/phiOM(6144),thetaOM(6144),psiOM(6144),dumscrd(idumscrd)

     logical b_Hea,b_Hegt0,b_powder,b_integer,                         &
             b_efgt0,b_sx2,b_sx2a,b_sx2gt0,                            &
             b_x2,b_x2a,b_x2gt0,b_xx,b_laba0                           

     integer i,j,k,l,m,n,ip,ii,iset,isymmetry,n_psi,jpsi,iOM,jOM,      &
             je,jg,jge,ncase,jfield,ifields,                   &
             nloop,nloop_b,nloop_e,jloop,nput,jljpjO,n_all   
     real    a_mueg,a_muee,c_Tms,                                      &
             aszz,azz,texture,cost2,Stexture,                          &
             txx,tyy,tzz,txy,txz,tyz,                                  &
             pp,hmm,pp1,hmm1,pp2,hmm2,pp12,hmm12,rEM2,qEM2,            &
             h,hx,hy,hz,thetaC,phiC,sintC,                             &
             psiOMa,arcos,population,                                  &                    
             phi_r,theta_r,psi_r,phiE_r,thetaE_r,psiE_r,h1
     complex pm,pm1,pm2,pm12,hc1 
     real,parameter::sqrt2=1.4142136,q62=1.224745,                     &
                     rad=0.0174533,pi=3.14159                             
     real,    dimension(:),   allocatable :: eagd_zz 
     real,    dimension(:),   allocatable :: Eagd
     complex, dimension(:),   allocatable :: eagdzz
     complex, dimension(:,:), allocatable :: V1m
     complex, dimension(:,:), allocatable :: V2m

                                                                        
      jge=(2.*ajg+1)*(2.*aje+1)+0.01 
                                                                        
      ifields=icase 
!     icase of the subroutine called below is choosen to discriminate   
!     the theories and at the same time the number of hyperfine fields  
!     ifields=1 :         thermal average                               
!     ifields=2 :         spin 1/2 slow relaxation                      
!     ifields=5 :         spin 2   slow relaxation                      
!     the population (weight) of the electronic levels (producing       
!     the hyperfine field) is stored together with the field components 
!     array_fr(iget+...)                                                
                                                                        
      if(acfr2.lt.3.)aset=0.0 
!     this way iset,... have not to be defined in frstr_..              
                                                                        
      if(isubthe.lt.0) then 
       theoryname='DEQ_H_spinham_equiv_sites   v=100' 
       if(isubthe.eq.-16) return 
!      routines only asking for the name (not values for storage space) 
!      put isubthe to -16 (far away from -ntheory)                      
       ncase=symcase 
       call sym_equiv(-ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
       iset=aset 
                                       ! only 1 rotation                
       if(nloop.eq.-1)nloop=0 
       if(iset.gt.0) then 
        isymmetry=asymmetry 
        n_psi=a_psi 
        call sphere(-iset,isymmetry,.false.,iOM,phiOM,thetaOM,psiOM)
        if(iOM.eq.0) then 
         info=1 
         infotext(1)=' ' 
         infotext(2)(1:17)='*** error ***' 
         infotext(3)='meaningless values of constants iset/isymmetry' 
         infotext(4)=                                                   &
     &      'help available: {co a}, {he cn} (n=number of constant)'    
         infotext(5)=' ' 
         return 
        end if 
        i=1+istore+2+3*jge*(nloop+1)*iOM*(n_psi+1)*ifields+(iOM/2)*3 
        if(iOM.eq.1)i=i+2 
        c1=i 
       else 
        c1=1+istore+2+3*jge*(nloop+1)*ifields+2 
       end if 
       return 
      end if 
                                                                        
!      write(6,'(a)')'th_22nuclear avfr2...'                            
!      write(6,'(8f10.2)')avfr2,dum5(5),Hext,thetaHe,phiHe              
!      write(6,'(20L3)')b_vfr2,b_dum5(5),b_Hext,b_thetaHe,b_phiHe       
!     &                phi,theta,psi,d_x2,eta_xx,phi_xx,theta_xx,psi_xx,
!     &                axtexture                                        
!      write(6,'(a)')'th_22nuclear avss...'                             
!      write(6,'(8f10.2)')avss,                                         
!     &              dsx2,eta_sx,phi_sx,theta_sx,psi_sx                 
!       write(6,'(20L3)')b_vss,                                         
!     &              b_dsx2,b_etasx,b_phisx,b_thetasx,b_psisx           
                                                                        
                                                                        
      if(.not.(b_vss.or.b_vfr2)) then 
                                         ! 24.10.07 theory not changed  
       isubthe=-abs(isubthe) 
!       write(6,'(a)') ' no change'                                     
       return 
      end if 
      if(iget.eq.0) print'(a)','iget not defined'
! print*,'iput,iget=',iput,iget
! ----------------------------------------------------------------------
  allocate(Eagd(jge),eagd_zz(2*jge),V1m(-1:1,jge),V2m(-2:2,jge),eagdzz(jge))
      j=iput+1 
      nput=j+istore 
      do i=1,istore 
       store(i)=array_fr(j+i) 
      end do 
      array_fr(j)=cmplx(float(nput),float(istore)) 
                                                                        
                                                                        
!    bvfr2trf                                                           
!     external magnetic field                                           
      b_Hea=b_thetaHe.or.b_phiHe 
!     orientation of the crystal/sample in the la. system               
                                                                        
!     b_laba=b_phils.or.b_thetals.or.b_psils                            
                                                                        
!     <x2> of the crystal                                               
      b_x2a =b_phixx.or.b_thetaxx.or.b_psixx 
      b_x2  =b_dx2.or.b_etaxx.or.b_x2a 
                                                                        
!    avmap                                                              
!    <sx2> of the called site of the crystal                            
      b_sx2a=b_phisx.or.b_thetasx.or.b_psisx 
      b_sx2 =b_dsx2.or.b_etasx.or.b_sx2a 
!     hyperfine parameter (He depends on angles phi,theta,psi)          
!     <x2>+<sx2> (<x2> depends on angles phi,theta,psi)                 
      b_xx  =b_sx2.or.b_x2.or.b_laba 
                                                                        
      ii=jge/2 
      if(2*ii.eq.jge) then 
       b_integer=.false. 
       je=2*aje+0.01 
       jg=2*ajg+0.01 
      else 
       b_integer=.true. 
       je=aje+0.01 
       jg=ajg+0.01 
      end if 
                                                                        
      a_mueg=amueg 
      a_muee=amuee 
      c_Tms=cTms 
      rEM2=r_E2M1**2 
      qEM2=1./(1.+rEM2) 
                                                                        
      n_psi=a_psi 
      iset=aset 
      ncase=symcase 
      isymmetry=asymmetry 
                                                                        
      nloop_b=0 
      if(b_c1) then 
       call sym_equiv(ncase,maxloop,nloop,timeinvers,ctimeinv,d1,d2) 
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      else 
       nloop=real(caseloop) 
!      write(6,'(a,i6)')'th_22nuclear nloop=',nloop                     
       nloop_e=nloop 
       if(nloop.eq.-1)then 
        nloop_b=1 
        nloop_e=1 
       end if 
      end if 
      do k=1,nloop_e 
       timeinv(k)=real(ctimeinv(k)) 
      end do 
                                                                        
      if(bcfr2) then 
       call sphere(iset,isymmetry,.false.,iOM,phiOM,thetaOM,psiOM)          
       caseloop=cmplx(float(nloop),float(iOM)) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if 
       j=(nput+2+3*jge*n_all*ifields)*2 
       do i=1,iOM 
        k=(i-1)*3+j 
        real_fr(k+1)=phiOM(i) 
        real_fr(k+2)=thetaOM(i) 
        real_fr(k+3)=psiOM(i) 
       end do 
      else 
       iOM=aimag(caseloop) 
       if(nloop.eq.-1)then 
        n_all=(n_psi+1)*iOM 
       else 
        n_all=(n_psi+1)*iOM*(nloop+1) 
       end if 
       j=(nput+2+3*jge*n_all*ifields)*2 
       do i=1,iOM 
        k=(i-1)*3+j 
        phiOM(i)=real_fr(k+1) 
        thetaOM(i)=real_fr(k+2) 
        psiOM(i)=real_fr(k+3) 
       end do 
      end if 
      caseloop=cmplx(float(nloop),float(iOM)) 
                                                                        
      b_powder=n_psi+iOM.gt.1 
                                                                        
!     <sx2> tensor                                                      
      b_sx2gt0=abs(dsx2).gt.0. 
      if(b_sx2) then 
       if(b_sx2a) call dimj(-psi_sx*rad,-theta_sx*rad,-phi_sx*rad,2,Dsxct)
!       The Euler angles rotate the crystal system S_C to the PAS S_sx2 
!       of <sx2> tensor.The Euler angles are obtained with the          
!       program called by  {eu} [1 Euler angles from unit vectors]      
!       ->[unit vectors eb(n) in system Sa].                            
!       Input are the unit vectors eb(x,y,z)=e_sx2 of S_sx2 with respect
!       to the crystal system S_C.                                      
!       The transformation Dsxct(-gamma,-theta,-alpha) transforms       
!       the tensor components to the crystal system.                    
!       Symbolic:  e_sx2 in S_C  -> t_C=t_sx2*d^(-1)                    
!      xxPAS (-2..2) are the spherical tensor components of <sx2> in the
!      S_sx2 system. The tensor is attached to site 1 (of nloop+1       
!      equivalent sites) of the crystal.                                
       xxPAS(0)=cmplx(q62,0.0) 
       xxPAS(-1)=(0.,0.) 
       xxPAS(1)=(0.,0.) 
       xxPAS(-2)=cmplx(eta_sx/2.,0.) 
       xxPAS(2)=cmplx(eta_sx/2.,0.) 
                                                                        
       call vecxmat(2,xxPAS,Dsxct,sx2C0)    
!      storing the tensors of the 1. site if there are nloop+1          
!      equivalent sites (nloop >0)                                      
!      sx2C0(n) are the components of the tensor in the crystal system. 
!      Taking these components (the Carthesian one) to the program calle
!      by  {eu} [9 Euler angles of PAS of 2. rank tensor]               
!      the PAS-values and Euler angles are obtained back.               
              ! b_sx2                                                   
      end if 
                                                                        
!     <x2> tensor                                                       
!     see comment on the <sx2> tensor                                   
      b_x2gt0=abs(d_x2).gt.0. 
      if(b_x2) then 
       if(b_x2a)then
       call dimj(-psi_xx*rad,-theta_xx*rad,-phi_xx*rad,2,Dxxct)
 
       end if 
       xxPAS(0)=cmplx(q62,0.0) 
       xxPAS(-1)=(0.,0.) 
       xxPAS(1)=(0.,0.) 
       xxPAS(-2)=cmplx(eta_xx/2.,0.) 
       xxPAS(2)=cmplx(eta_xx/2.,0.) 
                                                                        
       call vecxmat(2,xxPAS,Dxxct,x2C)    
      end if   ! b_x2 
                                                                        
!-----enable write-----xx (site 1) in the crystal system -------------- 
        if(enwr(6)(1:2).eq.'t1') then 
        if(enwr(6)(3:4).eq.'x2') then 
         h=d_x2/2./q62 
         txx=real(-x2C(0)+q62*(x2C(2)+x2C(-2)))*h 
         tyy=real(-x2C(0)-q62*(x2C(2)+x2C(-2)))*h 
         tzz=2*real(x2C(0))*h 
         txy=-real(q62*(x2C(2)-x2C(-2))*cmplx(0.,1.))*h 
         txz=-real(q62*(x2C(1)-x2C(-1)))*h 
         tyz=real(q62*(x2C(1)+x2C(-1))*cmplx(0.,1.))*h 
         write(nwr,'(a,/)') '-- crystal <xx> in the crystal system ' 
        else if(enwr(6)(3:4).eq.'sx') then 
         h=dsx2/2./q62 
         txx=real(-sx2C0(0)+q62*(sx2C0(2)+sx2C0(-2)))*h 
         tyy=real(-sx2C0(0)-q62*(sx2C0(2)+sx2C0(-2)))*h 
         tzz=2*real(sx2C0(0))*h 
         txy=-real(q62*(sx2C0(2)-sx2C0(-2))*cmplx(0.,1.))*h 
         txz=-real(q62*(sx2C0(1)-sx2C0(-1)))*h 
         tyz=real(q62*(sx2C0(1)+sx2C0(-1))*cmplx(0.,1.))*h 
         write(nwr,'(a,/)') '-- local <sx> in the S_C -- site 1' 
        end if 
                                                                        
         call dimj(phiE_r,thetaE_r,psiE_r,1,d21)
                                                                        
         uveca(1,1)=0.5*real(d21(1,1)-d21(-1,1)-d21(1,-1)+d21(-1,-1)) 
         uveca(1,2)=-0.5*aimag(d21(1,1)+d21(-1,1)-d21(1,-1)-d21(-1,-1)) 
         uveca(1,3)=-1./sqrt2*real(d21(0,1)-d21(0,-1)) 
                                                                        
         uveca(2,1)=0.5*aimag(d21(1,1)-d21(-1,1)+d21(1,-1)-d21(-1,-1)) 
         uveca(2,2)=0.5*real(d21(1,1)+d21(-1,1)+d21(1,-1)+d21(-1,-1)) 
         uveca(2,3)=-1./sqrt2*aimag(d21(0,1)+d21(0,-1)) 
                                                                        
         uveca(3,1)=-1./sqrt2*real(d21(1,0)-d21(-1,0)) 
         uveca(3,2)=1./sqrt2*aimag(d21(1,0)+d21(-1,0)) 
         uveca(3,3)=real(d21(0,0)) 
                                                                        
                                                                        
         vik(1,1)=txx 
         vik(1,2)=txy 
         vik(1,3)=txz 
         vik(2,1)=txy 
         vik(2,2)=tyy 
         vik(2,3)=tyz 
         vik(3,1)=txz 
         vik(3,2)=tyz 
         vik(3,3)=tzz 
                                                                        
         do i=1,3 
         do l=1,3 
          h1=0.0 
          do j=1,3 
          do k=1,3 
           h1=h1+uveca(i,k)*vik(k,j)*uveca(l,j) 
          end do 
          end do 
          vdd(i,l)=h1 
         end do 
         end do 
         write(nwr,'(10x,a,3(f7.3,a1))')                                &
          '      ( ',vdd(1,1),',',vdd(1,2),',',vdd(1,3),')'             
         write(nwr,'(a10,a,3(f7.3,a1))')'          ',                   &
          'tik = ( ',vdd(2,1),',',vdd(2,2),',',vdd(2,3),')'             
         write(nwr,'(10x,a,3(f7.3,a1),/)')                              &
          '      ( ',vdd(3,1),',',vdd(3,2),',',vdd(3,3),')'             
                                                                        
         write(nwr,'(2x,a,2(f7.3,1x),f7.3,a1,2(4x,a,3(f7.3,a1)))')      &
          '            x ( ',txx,txy,txz,')',                           &
          ' u = x (',uveca(1,1),',',uveca(1,2),',',uveca(1,3),')'       
                                                                        
         write(nwr,'(2x,a,8x,f7.3,1x,f7.3,a1,2(4x,a,3(f7.3,a1)))')      &
          '<i|T_C|k> = y ( ',tyy,tyz,')',                               &
          '   = y (',uveca(2,1),',',uveca(2,2),',',uveca(2,3),')'       
         write(nwr,'(2x,a,16x,f7.3,a1,2(4x,a,3(f7.3,a1)))')             &
          '            z ( ',tzz,')',                                   &
          '   = z (',uveca(3,1),',',uveca(3,2),',',uveca(3,3),')'       
                                                                         
        end if 
!------end enable write---------------------------------------------    
                                                                        
!     Transformation of the tensors given in the crystal/sample system t
!     the lab-system.                                                   
!     The gamma-direction is parallel to +z of the lab-system.          
!     The orientation of the crystal in the laboratory is decribed by   
!     the Euler angles (phi,theta,psi). e_z(S_C) in the la. system S_L  
!     determines phi,theta, which are the polar angle of e_z(S_C).      
!     The Euler angles are obtained with the                            
!     program euler in the directory effi/helproutines/euler:           
!      [1 Euler angles from unit vectors]->[unit vectors eb(n) in system
!     Input are the unit vectors e_C=eb(x,y,z) of the crystal system S_C
!      with respect to the lab. system S_L.                             
!     The tensor components known in the system S_C are tranformed to th
!     Lab. system by the invers transformation Dsl(-psi,-theta,-phi).   
!     Symbolic:  e_C in S_L  -> t_L=t_C*dlc^(-1)                        
!     (see comment for sx2 above)                                       
                                                                        
      b_laba0=abs(phi_ls)+abs(theta_ls)+abs(psi_ls).lt.0.001 
      if(b_laba)then 
!      write(6,'(a,3f10.2)')' phi,theta,psi_ls=',phi_ls,theta_ls,psi_ls 
                                                                        
       phi_r=phi_ls*rad 
       theta_r=theta_ls*rad 
       psi_r=psi_ls*rad 
!      1. rank tensor transformation matrix: crystal/sample to Lab      
       call dimj(-psi_r,-theta_r,-phi_r,1,Dslv)
!      2. rank tensor transformation matrix: crstal/sample to Lab       
       call dimj(-psi_r,-theta_r,-phi_r,2,Dslt)
      end if  ! b_laba (lab angle) 
                                                                        
                                                                        
                                                                        
                                                                        
!     external field defined in the LAB system S_L                      
      b_Hegt0=abs(Hext).gt.0 
      if(b_Hea)then 
       hve(1) =-cmplx(cos(phiHe*rad),sin(phiHe*rad))*sin(thetaHe*rad)/sqrt2
       hve(0) = cmplx(cos(thetaHe*rad),0.0) 
       hve(-1)=-conjg(hve(1)) 
      end if 
                                                                        
!     ----------------------------------------------------              
!      thetaOM(1)=54.7*rad                                              
!      phiOM(1)=pi/4.                                                   
!      thetaOM(1)=0.                                                    
!     Omega loop in case of an average over different crystal           
!     orientations: powder, texture                                     
!     ----------------------- loops-----------------------              
      psiOMa=2.*pi/(n_psi+1) 
      jljpjO=0 
      Stexture=0.0 
      do jOM=1,iOM 
       cost2=cos(thetaOM(jOM))**2 
       texture=1.+t200*(3.0*cost2-1.)/2.+t400*((35*cost2-30)*cost2+3.)/8.        
       Stexture= Stexture+ texture 
      end do
      if(enwr(6).eq.'tetu')print '(a,f10.3)', 'Sum texture=',Stexture 

      do jOM=1,iOM 
       cost2=cos(thetaOM(jOM))**2 
       texture=(1.+t200*(3.0*cost2-1.)/2.                               &
                +t400*((35*cost2-30)*cost2+3.)/8.)/float(n_all)/Stexture        
                                                                        
       do jpsi=0,n_psi 
!       averaging over psiOM with n_psi+1 steps                         
                                                                        
!       The grid point p(thetaOM,phiOM) defines z-axis of the system    
!       S_S of the sample. (If the sample is not rotated S_S coincides  
!       with the lab. system S_L, and the z_axis is the direction of    
!       observation).                                                   
!       The rotation around the z-axis starts with angle psiOM          
!       and has n_psi steps for averaging. The components in the        
!       S_OM system are                                                 
!       Symbolic:  e_OM in S_C  -> t_C*dcs=t_OM   (t_S=t_OM)            
!       If the sample system S_S  is rotated with respect to the Lab. sy
!       -Dsl (=djsl)- the tensor components are                         
!       transformations are:                                            
!        Symbolic:  e_S in S_L  -> t_L=t_S*dls^(-1)                     
!                                  t_L= t_C*dcs*dls^(-1)                
                                                                        
!          write(6,'(i3,a,3f10.3,3x,3f9.3)')jOM,' phi,theta,psi=',      
!     &               phiOM(jOM),thetaOM(jOM),psiOM(jOM)                
        if(b_powder) then 
         call dimj(phiOM(jOM),thetaOM(jOM),psiOM(jOM)+jpsi*psiOMa,1,Dcpv)
         if(b_laba0)then 
!         1. rank tensor transformation                                 
          Dclv=Dcpv 
         else 
          Dclv=matmul(Dcpv,Dslv)
         end if 
         call dimj(phiOM(jOM),thetaOM(jOM),psiOM(jOM)+jpsi*psiOMa,1,Dcpt) 
         if(b_laba0)then 
!         2. rank tensor transformation                                 
          Dclt=Dcpt 
         else 
          Dclt=matmul(Dcpt,Dslt)
         end if 
        else 
         Dclv=Dslv 
         Dclt=Dslt 
        end if 
                                                                        
!       hve has to be transformed to the crystal/sample system => hvC   
        do n=-1,1 
         hc1=(0.,0.) 
         do m=-1,1 
          hc1=hc1+hve(m)*conjg(Dclv(n,m)) 
         end do 
         hvC0(n)=hc1 
        end do 
!       storing the tensors of the 1. site if there are nloop+1         
!       equivalent sites (nloop >0)                                     
                                                                        
        if(b_x2gt0)then 
         hc1=(0.,0.) 
         do m=-2,2 
          hc1=hc1+x2C(m)*Dclt(m,0) 
         end do 
         azz=real(hc1)/q62 
        else 
         azz=0. 
        end if    ! b_x2gt0 
                                                                        
!       loop over equivalent sites. In the routine sym_equiv(...,d1,d2) 
!       the transformations d1 and d2 are defined                       
        do jloop=nloop_b,nloop_e 
                                                                        
         if(jloop.gt.0) then 
          if(b_Hegt0) then 
           do n=-1,1 
            hc1=(0.,0.) 
            do m=-1,1 
             hc1=hc1+hvC0(m)*conjg(d1(n,m,jloop)) 
            end do 
            hvC(n)=hc1*Hext 
           end do 
          else 
           do i=-1,1 
            hvC(i)=cmplx(0.,0.) 
           end do 
          end if 
          if(b_sx2gt0)then 
           do n=-2,2 
            hc1=(0.,0.) 
            do m=-2,2 
             hc1=hc1+sx2C0(m)*d2(m,n,jloop) 
            end do 
            sx2C(n)=hc1 
           end do 
          end if 
!         if =0 aszz put to 0                                           
         else 
          do m=-2,2 
           sx2C(m)=sx2C0(m) 
          end do 
          do i=-1,1 
           hvC(i)=hvC0(i)*Hext 
          end do 
                 ! jloop > 0                                            
         end if 
                                                                        
!        hvC is                                                         
         i=iget 
         if(array_fr(i+1).eq.hvC(-1).and.                               &
            array_fr(i+2).eq.hvC(0) .and.                               &
            array_fr(i+3).eq.hvC(1) )then                              
            array_fr(i+4)=cmplx(0.,0.) 
         else 
          array_fr(i+1)=hvC(-1) 
          array_fr(i+2)=hvC(0) 
          array_fr(i+3)=hvC(1) 
          array_fr(i+4)=cmplx(1.,0.) 
         end if 
                                                                        
         call get_theory(isubthe,info) 
         if(info.gt.0) return 
         isubthe=isubthe-1 
                                                                        
!         hyperfine fields from the theory called by  get_theory        
         do jfield=1,ifields 
          jljpjO=jljpjO+1 
                                                                        
          i=iget+4+(jfield-1)*9 
          b_efgt0=abs(aimag(array_fr(i))).gt.0 
          population=real(array_fr(i+9)) 
          hv(-1)=array_fr(i+1) 
          hv(0) =array_fr(i+2) 
          hv(1) =array_fr(i+3) 
          i=i+6 
          do j=-2,2 
           efg(j)=array_fr(i+j) 
          end do 
                                                                        
!         transformation of hv and efg to the lab system                
!         first step: transformation of hv (spezial case hve) back      
!         to the crystal system.                                        
          if(jloop.gt.0) then 
           do n=-1,1 
            hc1=(0.,0.) 
            do m=-1,1 
             hc1=hc1+hv(m)*d1(m,n,jloop) 
            end do 
            hvC(n)=hc1 
           end do 
          else 
           do m=-1,1 
            hvC(m)=hv(m) 
           end do 
          end if 
!-------- enable write------H-field in the crystal system --------------
          if(enwr(6).eq.'hfsi') then 
          hx=-real(hvC(1)-hvC(-1))/sqrt2 
          hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2 
          hz= real(hvC(0)) 
          thetaC=arcos(hz) 
          sintC=sin(thetaC) 
          if(sintC.lt.0.001) then 
           phiC=0.0 
          else 
           phic=arcos(hx/sintC) 
           if(hy.lt.0.)phiC=2.*pi-phiC 
          end if 
                                                                        
          write(nwr,'(/,a,i2,a,f6.2,a,3f8.3,a4,2f8.3,a1)')              &
           ' site',(jloop+1)*jfield,'  population=',population,         &
           '  h_C = (',hx,hy,hz,'):=(',thetaC/rad,phiC/rad,')'          
          end if 
!---------------------------------------------------------------------  
!         This transformation has also to be applied to the efg obtained
!         from get_theory                                               
          if(jloop.gt.0) then 
           if(b_efgt0)then 
            do n=-2,2 
             hc1=(0.,0.) 
             do m=-2,2 
              hc1=hc1+efg(m)*d2(m,n,jloop) 
             end do 
             efgC(n)=hc1 
            end do 
           end if 
          else 
           do m=-2,2 
            efgC(m)=efg(m) 
           end do 
          end if 
!         transformation of hvC and efgC,sx2C,x2C to the lab system     
                                                                        
          do n=-1,1 
           hc1=(0.,0.) 
           do m=-1,1 
            hc1=hc1+hvC(m)*Dclv(m,n) 
           end do 
           hvL(n)=hc1 
          end do 
                                                                        
          if(b_efgt0)then 
           do n=-2,2 
            hc1=(0.,0.) 
            do m=-2,2 
             hc1=hc1+efgC(m)*Dclt(m,n) 
            end do 
            efgL(n)=hc1 
           end do 
          else 
           hc1=(0.,0.) 
           do m=-2,2 
            efgL(m)=hc1 
           end do 
                   ! b_efgt0                                            
          end if 
                                                                        
          if(b_sx2gt0)then 
           hc1=(0.,0.) 
           do m=-2,2 
            hc1=hc1+sx2C(m)*Dclt(m,0) 
           end do 
           aszz=real(hc1)/q62 
          else 
           aszz=0. 
                   ! b_sx2gt0                                           
          end if 
                                                                        
                                                                        
!-------  enable write-------- EFG in the Lab system -------------------
          if(enwr(6).eq.'eflb') then 
           txx=real(-efgL(0)+q62*(efgL(2)+efgL(-2))) 
           tyy=real(-efgL(0)-q62*(efgL(2)+efgL(-2))) 
           tzz=2*real(efgL(0)) 
           txy=-real(q62*(efgL(2)-efgL(-2))*cmplx(0.,1.)) 
           txz=-real(q62*(efgL(1)-efgL(-1))) 
           tyz=real(q62*(efgL(1)+efgL(-1))*cmplx(0.,1.)) 
                                                                        
           write(nwr,'(2x,a,6f8.3,a1,3f10.3)')' (',txx,txy,txz,tyy,tyz,tzz,')'
!     &    sin(thetaOM(jOM))*cos(phiOM(jOM)),                           
!     &    sin(thetaOM(jOM))*sin(phiOM(jOM)),cos(thetaOM(jOM))          
!          write(nwr,'(a)')                                             
!          write(nwr,'(2x,a,3f8.3,a1)')  '            x (',txx,txy,txz,'
!          write(nwr,'(2x,a,8x,2f8.3,a1)')'<i|V_L|k> = y (',tyy,tyz,')' 
!          write(nwr,'(2x,a,16x,f8.3,a1)')'            z (',tzz,')'     
          end if 
!-------- enable write---H-field in the Lab system ---------------------
          if(enwr(6).eq.'hflb') then 
           hx=-real(hvL(1)-hvL(-1))/sqrt2 
           hy= real((hvL(1)+hvL(-1))*cmplx(0.,1.))/sqrt2 
           hz= real(hvL(0)) 
           write(nwr,'(a,i2,a,3f8.3,a1)')' site',jloop+1,               &
             ' ------  h_L = (',hx,hy,hz,')'                            
          end if 
!--------------------------------------------------------------------   
          call hamJgJe(b_integer,amueg,amuee,QgdQe,cTms,hvL,efgL,       &
                                                 je,jg,jge,Eagd,V1m,V2m)
          eagd_zz(2)=aszz 
          eagd_zz(4)=dsx2 
          eagd_zz(6)=azz 
          eagd_zz(8)=d_x2 
          eagd_zz(10)=aszz*dsx2+azz*d_x2 
!          write(6,'(a,f12.4)')'aszz*dsx2+azz*d_x2=',aszz*dsx2+azz*d_x2 
          do i=1,jge 
           eagd_zz(2*i-1)=Eagd(i) 
          end do 
          do i=1,jge 
           eagdzz(i)=cmplx(eagd_zz(2*i-1),eagd_zz(2*i)) 
          end do 

!         write(6,'(10f10.3)') (eagdzz(j),j=1,10)   ! trick with equival
                                                                        
          ip=nput+2+3*jge*(jljpjO-1) 
                                                                        
          population=population*texture 
          if(r_E2M1.eq.0.)then 
           do i=1,jge 
            pp =real(conjg(V1m(1,i))*V1m(1,i)) 
            hmm=real(conjg(V1m(-1,i))*V1m(-1,i)) 
            ii=ip+3*(i-1) 
            array_fr(ii+1)=eagdzz(i) 
            array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*population 
            array_fr(ii+3)=conjg(V1m(1,i))*V1m(-1,i)*population 
           end do 
          else 
           if(abs(r_E2M1).lt.9999.)then 
!           mixed M1/E2 transition                                      
            do i=1,jge 
              pp1 =real(conjg(V1m(1,i))*V1m(1,i)) 
             hmm1=real(conjg(V1m(-1,i))*V1m(-1,i)) 
              pm1=conjg(V1m(1,i))*V1m(-1,i) 
                                                                        
              pp2=real(conjg(V2m(1,i))*V2m(1,i)) 
             hmm2=real(conjg(V2m(-1,i))*V2m(-1,i)) 
              pm2=conjg(V2m(1,i))*V2m(-1,i) 
                                                                        
              pp12= 2.*real(conjg(V2m(1,i))*V1m(1,i)) 
             hmm12=-2.*real(conjg(V2m(-1,i))*V1m(-1,i)) 
              pm12= conjg(V2m(1,i))*V1m(-1,i)-conjg(V1m(1,i))*V2m(-1,i) 
                                                                        
               pp=(pp1 +rEM2*pp2  -r_E2M1*pp12)*qEM2 
              hmm=(hmm1+rEM2*hmm2-r_E2M1*hmm12)*qEM2 
               pm=(pm1 -rEM2*pm2  -r_E2M1*pm12)*qEM2 
                                                                        
!             write(6,'(8f10.3)')eagdzz(i),pp,hmm,pm                    
                                                                        
             ii=ip+3*(i-1) 
             array_fr(ii+1)=eagdzz(i) 
             array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*population 
             array_fr(ii+3)=pm*population 
            end do 
!           write(6,'(a)')                                              
           else 
!           E2 transition                                               
            do i=1,jge 
             pp =real(conjg(V2m(1,i))*V2m(1,i)) 
             hmm=real(conjg(V2m(-1,i))*V2m(-1,i)) 
             ii=ip+3*(i-1) 
             array_fr(ii+1)=eagdzz(i) 
             array_fr(ii+2)=cmplx(pp-hmm,pp+hmm)/2.0*population 
             array_fr(ii+3)=-conjg(V2m(1,i))*V2m(-1,i)*population 
            end do 
           end if 
          end if 
         end do    ! ifields
         isubthe=isubthe+1 
        end do ! nloop
       end do   ! n_psi 
      end do  ! iOM 

!     array_fr(nput+i):                                                 
!     (nput+1)=(n_all,jge)    (nput+2) = (b_xx,0)                       
!     (nput+3)=(Eagd(1),aszz) (nput+4) = (pp-hmm,hr+hmm)/2   (nput+5) =p
!     (nput+6)=(Eagd(2),dsx2) (nput+7) = (pp-hmm,hr+hmm)/2   (nput+8) =p
!     (nput+9)=(Eagd(3),dsx2) (nput+10)= (pp-hmm,hr+hmm)/2   (nput+11)=p
!                                                                       
!      ................................................................ 
!                                                                       
!     (nput+j1)=(Eagd(2),dsx2) (nput+j2)= (pp-hmm,hr+hmm)/2   (nput+j3)=
!      j=2+3*(jge-1) j1=j+1,...,j3=j+3                                  
!                                                                       
!     for the case: b_xx=.false. the f-factor fd=exp(-azz*d_x2-aszz*dsx2
!     itself is stored                                                  
                                                                        
      array_fr(nput+1)=cmplx(float(n_all*ifields),float(jge)) 
      if(b_xx) then 
       array_fr(nput+2)=cmplx(1.0,0.) 
      else 
       array_fr(nput+2)=cmplx(0.,0.) 
      end if 
!     aimag of array_fr(nput+2) for further use                         
                                                                        
                                                                        
      if(nloop_e.gt.0) then 
!      to be stored in array store() => array_fr()                      
       do m=-2,2 
        efgC(m)=efgC0(m) 
       end do 
       do m=-2,2 
        sx2C(m)=sx2C0(m) 
       end do 
       do i=-1,1 
        hvC(i)=hvC0(i) 
       end do 
      end if 
      j=iput+1 
      do i=1,istore 
       array_fr(j+i)=store(i) 
      end do 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
     subroutine th_spinham05(isubthe,icase,iput,iget,info) 
     use glbconst, only: icstrf,icfr2trf,ivstrf,ivfr2trf,      &
                         infotext
     use comthe, only: array_fr,theoryname
     implicit none 
                                                                       
     integer isubthe,icase,iput,iget,info 
!    transmission: fr2 defines external magnetic field, orientation    
!    of the sample by phi,theta,psi is calculated by the routine sample
!    orientation tansferred by  array_fr to main and than passed to fr2
                                                                       
     real          c1,temperature,dumc 
     common/acmaps/c1,temperature,dumc(icstrf-2) 
     logical       b_c1,b_temperature,b_dum 
     common/bcmaps/b_c1,b_temperature,b_dum(icstrf-2) 
                                                                       
     real          avss,DEq,va2,va3,va4,va5,va6,va7,va8,               &
                   phi_g,theta_g,psi_g,Aav,A_a,A_eta,                  &
                   phi_A,theta_A,psi_A,dumvss                          
     common/avmaps/avss,DEq,va2,va3,va4,va5,va6,va7,va8,               &
                                 phi_g,theta_g,psi_g,                  &
                   Aav,A_a,A_eta,phi_A,theta_A,psi_A,dumvss(ivstrf-18) 
!    case 1             DEq,eta,phiE,thetaE,psiE,Ha,phiH,thetaH        
!    case 2             DEq,eta,phiE,thetaE,psiE,gav,g_a,g_eta,        
!    case 3             Deq,Aav,Hc_kappa,cov_k,phi_t2g,theta_t2g       
!    case 3                      phi_t,theta_t,psi_t,                  
     logical       b_vss,b_dumvss 
     common/bvmaps/b_vss,b_dumvss(ivstrf-1) 

     logical     b_integer,b_He 
     real        hmag,phiH_r,thetaH_r,phiE_r,thetaE_r,psiE_r,          &
                 efg0,efg2,eta,gav,g_a,g_eta,akT,                      &
                 Hc_kappa,cov_k,phi_t2g,theta_t2g,qxx,qyy,qzz,         &
                 at,at2,bt,bt2,ct,ct2,gxx,gyy,gzz,Axx,Ayy,Azz,h,cf,    &
                 DD(2),h1,h2,                                          &
                 txx,tyy,tzz,txy,txz,tyz                               
     real,parameter::sqrt2=1.4142136,sqrt3=1.732051,q62=1.224745,      &
                     sqrt6=2.44948,rad=0.0174533,pi=3.14159,           &
                     meubohr=0.04668,ak=0.6950   
     integer     i,j,jm,m,n
     complex     he(-1:1), hv(-1:1),hvC(-1:1),heP(-1:1),               &
                 VV(2,2),Hm(-1:1,-1:1),                                &
                 Dcpv(-1:1,-1:1),D2ct(-2:2,-2:2),                      &
                 t2PAS(-2:2),efgC(-2:2),g2(-2:2),A2(-2:2),             &
                 St(-1:1),hc1,H10,H1m1
      if(isubthe.lt.0) then 
       theoryname='spin_Hamiltonian_H(T)_Deq      v=100' 
       if(isubthe.eq.-16) return 
!      routines only asking for the name (not values for storage space) 
!      put isubthe to -16 (far away from -ntheory)                      
        c1=4+9 
!       Hext,phi,theta external field taken from array_fr(iput+1)...    
!       2 logical, H,EFG written on array_fr(iput+..),...               
       return 
      end if 
      b_He=real(array_fr(iput+4)).gt.0 
      if(.not.(b_vss.or.b_He)) then 
       isubthe=-abs(isubthe)             ! 24.10.07 theory not changed 
!       write(6,'(a)') ' no change'                                     
       return 
      end if 
      if(iget.eq.0) print'(a)','iget not defined'
!print*,'iput,iget=',iput,iget
!      
! ----------------------------------------------------------------------
      j=iput+2 
      do i=-1,1 
       he(i)=array_fr(j+i) 
      end do 
!     logicals (.., Deq>0)                                              
      array_fr(j+3)=(0.,0.) 
!     g*he                                                              
                                           ! -------------------------- 
      if(icase.eq.1.or.icase.eq.2) then 
!      case 1             DEq,eta,phiE,thetaE,psiE,Ha,phiH,thetaH       
!      case 2             DEq,eta,phiE,thetaE,psiE,gav,g_a,g_eta,       
       eta=va2 
       phiE_r=va3*rad 
       thetaE_r=va4*rad 
       psiE_r=va5*rad 
                                                                        
       if (abs(DEq).gt.0.)then 
        array_fr(iput+4)=(0.,1.) 
        call dimj(-psiE_r,-thetaE_r,-phiE_r,2,D2ct)
!       efg (-2..2) are the spherical tensor components of the EFG in th
        efg0=1.0/sqrt(1.+eta**2/3.) 
        efg2=eta*efg0/sqrt(6.) 
                                                                        
        t2PAS(0)=cmplx(efg0,0.0) 
        t2PAS(-1)=(0.,0.) 
        t2PAS(1)=(0.,0.) 
        t2PAS(-2)=cmplx(efg2,0.) 
        t2PAS(2)=cmplx(efg2,0.) 
                                                                        
        call vecxmat(2,t2PAS,D2ct,efgC)    
        efgC=efgC*Deq
       end if  ! b_eq 

       j=iput+10 
       do i=-2,2 
        array_fr(j+i)=efgC(i) 
       end do 
      end if 
                                                                        
      if(icase.eq.1) then 
!      case 1             DEq,eta,phiE,thetaE,psiE,Ha,phiH,thetaH       
       phiH_r=va8*rad 
       thetaH_r=va7*rad 
       hv(1) =-cmplx(cos(phiH_r),sin(phiH_r))*                          &
                       sin(thetaH_r)/sqrt2                              
       hv(0) = cmplx(cos(thetaH_r),0.0) 
       hv(-1)=-conjg(hv(1)) 
       j=iput+6 
       do i=-1,1 
        array_fr(j+i)=he(i)+hv(i)*va6 
       end do 
       return 
      else if(icase.eq.2) then 
!      case 2             DEq,eta,phiE,thetaE,psiE,gav,g_a,g_eta,       
!      gav=va6                                                          
!      g_a=va7             ! Azz-gav                                    
!      g_eta=va8                                                        
!      he*g                                                             
       t2PAS(2)=va8/2.*va7 
       t2PAS(-2)=va8/2.*va7 
       t2PAS(1)=0. 
       t2PAS(-1)=0. 
       t2PAS(0)=q62*va7 
       call dimj(-psi_g*rad,-theta_g*rad,-phi_g*rad ,2,D2ct)
!      g-tensor in the crystal system                                   
       call vecxmat(2,t2PAS,D2ct,g2)    
!         txx=real(-t2PAS(0)+q62*(t2PAS(2)+t2PAS(-2)))/sqrt6        
!         tyy=real(-t2PAS(0)-q62*(t2PAS(2)+t2PAS(-2)))/sqrt6        
!         tzz=2*real(t2PAS(0))/sqrt6                                    
!         txy=-real(q62*(t2PAS(2)-t2PAS(-2))*cmplx(0.,1.))/sqrt6    
!         txz=-real(q62*(t2PAS(1)-t2PAS(-1)))/sqrt6                 
!         tyz=real(q62*(t2PAS(1)+t2PAS(-1))*cmplx(0.,1.))/sqrt6     
         txx=real(-g2(0)+q62*(g2(2)+g2(-2)))/sqrt6 
         tyy=real(-g2(0)-q62*(g2(2)+g2(-2)))/sqrt6 
         tzz=2*real(g2(0))/sqrt6 
         txy=-real(q62*(g2(2)-g2(-2))*cmplx(0.,1.))/sqrt6 
         txz=-real(q62*(g2(1)-g2(-1)))/sqrt6 
         tyz=real(q62*(g2(1)+g2(-1))*cmplx(0.,1.))/sqrt6 
!         write(nwr,'(2x,a,6f8.3,a1,3f10.3)')                           
!     &   ' (',txx,txy,txz,tyy,tyz,tzz,')'                              
!       write(6,'(a,6f10.2)')'va6,va7,va8=',va6,va7,va8                 
!       write(6,'(a,6f10.2)')'he=',real(he(-1)-he(1))/sqrt2,            
!     &          aimag(he(-1)+he(1))/sqrt2,real(he(0))                  
!      hv=gC*he magnetic field acting on the electronic spin S          
       hv(-1)=va6*he(-1)-g2(-2)*he(1)+g2(-1)/sqrt2*he(0)                &
     &                                 -g2(0)/sqrt6*he(-1)              
       hv( 0)=va6*he(0)-g2(-1)/sqrt2*he(1)+g2(0)/q62*he(0)          &
     &                                       -g2(1)/sqrt2*he(-1)        
       hv( 1)=-conjg(hv(-1)) 
!       write(6,'(a,6f10.2)')'g*h=',real(hv(-1)-hv(1))/sqrt2,           
!     &          -aimag(hv(-1)+hv(1))/sqrt2,real(hv(0))                 
!         hx=-real(hvC(1)-hvC(-1))/sqrt2                                
!         hy= real((hvC(1)+hvC(-1))*cmplx(0.,1.))/sqrt2                 
!         hz= real(hvC(0))                                              
!      A-tensor Aav,A_a,A_eta,phi_A,theta_A,psi_A                       
       t2PAS(2)=A_eta/2.*A_a 
       t2PAS(-2)=A_eta/2.*A_a 
       t2PAS(1)=0. 
       t2PAS(-1)=0. 
       t2PAS(0)=q62*A_a 
       call dimj(-psi_A*rad,-theta_A*rad,-phi_A*rad,2,D2ct)
!      A-tensor in the crystal system                                   
       call vecxmat(2,t2PAS,D2ct,A2)    
      else if(icase.eq.3) then 
!     case 3             Deq,Aav,Hc_kappa,cov_k,phi_t2g,theta_t2g       
!     solution in the PAS - transformation of h,efg to crystal system   
                                                                        
       Aav=va2 
       Hc_kappa=va3 
       cov_k=va4 
       phi_t2g=va5*rad 
       theta_t2g=va6*rad 
                                                                        
       at=sin(theta_t2g) 
       bt=at*sin(phi_t2g) 
       at=at*cos(phi_t2g) 
       ct=cos(theta_t2g) 
!       write(6,'(a,6f10.3)') ' va5,va6,at,bt,ct=',va5,va6,at,bt,ct     
                                                                        
       at2=at*at 
       bt2=bt*bt 
       ct2=1.-at2-bt2 
                                                                        
                                                                        
!      g-tensor in the PAS , he transformed (heP) to the PAS,           
!      hv acting on the spin magnetic moment                            
       gxx=2.*(at2-bt2+ct2+2.*cov_k*at*ct) 
       gyy=2.*(at2+bt2-ct2+2.*cov_k*at*bt) 
       gzz=2.*(at2-bt2-ct2-2.*cov_k*bt*ct) 
       gav=(gxx+gyy+gzz)/3. 
       g_a=gzz-gav 
       g_eta=(gxx-gyy)/g_a 
                                                                        
!       write(6,'(a,4f10.3)') ' gav,g_a,g_eta=',gav,g_a,g_eta           
!      gav=va6                                                          
!      g_a=va7             ! Azz-gav                                    
!      g_eta=va8                                                        
!      he*g                                                             
       t2PAS(2)=g_eta/2.*g_a 
       t2PAS(-2)=t2PAS(2) 
       t2PAS(1)=0. 
       t2PAS(-1)=0. 
       t2PAS(0)=q62*g_a 
!       case=3: phi_t=psi_g, theta_t=theta_g, and psi_t=psi_g           
       call dimj(phi_g*rad,theta_g*rad,psi_g*rad,1,Dcpv)
       call vecxmat(1,he,Dcpv,heP)    
                                                                        
       hv(-1)=gav*heP(-1)-t2PAS(-2)*heP(1)-t2PAS(0)/sqrt6*heP(-1) 
       hv( 0)=(gav+g_a)*heP(0) 
       hv( 1)=-conjg(hv(-1)) 
!      A-tensor (crystal field) from Aav                                
       Axx=(4.*at*ct-(Hc_kappa+1./7.)*(1.-2.*bt2)+                      &
                                         3.*(1.-2.*bt*(at+ct))/7.)     
       Ayy=(4.*at*bt-(Hc_kappa+1./7.)*(1.-2.*ct2)+                      &
                                          3.*(1.-2.*ct*(at+bt))/7.)     
       Azz=-(4.*bt*ct-(Hc_kappa+1./7.)*(1.-2.*at2)+                     &
                                          3.*(1.-2.*at*(bt+ct))/7.)     
       h=(Axx+Ayy+Azz)/3. 
       cf=Aav/h 
                                                                        
       A_a=cf*Azz-Aav 
       A_eta=cf*(Axx-Ayy)/A_a 
!       write(6,'(a,4f10.3)') ' Aav,A_a,A_eta=',Aav,A_a,A_eta           
       A2(2)=A_eta/2.*A_a 
       A2(-2)=A2(2) 
       A2(1)=0. 
       A2(-1)=0. 
       A2(0)=q62*A_a 
                                                                        
!      Quadrupole tensor                                                
       array_fr(iput+4)=(0.,1.) 
                                                                        
       qxx=at2-2.*bt2+ct2 
       qyy=at2+bt2-2.*ct2 
       qzz=-qxx-qyy 
       eta=(qxx-qyy)/qzz 
                                                                        
       efg0=1.0/sqrt(1.+eta**2/3.) 
       efg2=eta*efg0/sqrt(6.) 
                                                                        
       t2PAS(0)=cmplx(efg0,0.0) 
       t2PAS(-1)=(0.,0.) 
       t2PAS(1)=(0.,0.) 
       t2PAS(-2)=cmplx(efg2,0.) 
       t2PAS(2)=cmplx(efg2,0.) 
       call dimj(-psi_g*rad,-theta_g*rad,-phi_g*rad,2,D2ct)
!       efg (-2..2) are the spherical tensor components of the EFG in th
       call vecxmat(2,t2PAS,D2ct,efgC)   
       efgC=efgC*Deq 
      end if 
!                    -------------------------------------------------- 
       if(temperature.eq.0)then 
        info=1 
        infotext(1)='messages/spinham05/temperature' 
        infotext(2)='T=0 , temperature is not declared' 
        infotext(3)='missing  in the list of constants ' 
        infotext(4)=' ' 
        return 
       end if 
       akT=ak*temperature 
       b_integer=.false. 
       j=1 
       jm=j 
                                                                        
       do m=-j,j,2 
       do n=-j,j,2 
        Hm(n,m)=(0.,0.) 
       end do 
       end do 
!       write(6,'(a,6f10.4)')' hv=',hv                                  
!       write(6,'(a,6f10.2)')' hv=',real(hv(-1)-hv(1))/sqrt2,           
!     &          aimag(hv(-1)+hv(1))/sqrt2,real(hv(0))                  
       hmag=-meubohr/float(j) 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                        
       Hm(1,1)= H10 
       Hm(-1,-1)= -H10 
       Hm(1,-1)=H1m1*sqrt2 
       Hm(-1,1)=conjg(H1m1)*sqrt2 
                                                                        
!      do n=j,-j,-2                                                     
!       write(6,'(8f10.6)') (Hm(n,m),m=j,-j,-2)                         
!      end do                                                           
!      write(6,'(a)')                                                   
                                                                        
      call jacobihyf(b_integer,jm,Hm,j,j+1,DD,VV) 
!                                                                       
      h1=exp(-DD(1)/akT) 
      h2=exp(-DD(2)/akT) 
      h=h1+h2 
      h1=h1/h 
      h2=h2/h 
!                                                                       
!      write(6,'(a,5f10.2)')'T,DD1,2,h1,h2=',                           
!     &                      temperature,DD(1),DD(2),h1,h2              
!     spin expectation  <V S_i V+>_T                                    
                                                                        
      St(-1)=(h1*VV(1,2)*conjg(VV(1,1))                                 &
     &        +h2*conjg(VV(2,1))*VV(2,2))/sqrt2                         
      St( 0)=(conjg(VV(1,1))*VV(1,1)-conjg(VV(1,2))*VV(1,2))*(h1-h2)/2. 
      St( 1)=-conjg(St(-1)) 
!      write(6,'(a,6f10.4)')'  S=',real(St(-1)-St(1))/sqrt2,            
!     &          aimag(St(-1)+St(1))/sqrt2,real(St(0))                  
                                                                        
!     field at the nucleus hv = A*S                                     
      hv(-1)=Aav*St(-1)-A2(-2)*St(1)+A2(-1)/sqrt2*St(0)                 &
     &                              -A2(0)/sqrt6*St(-1)                 
      hv( 0)=Aav*St(0)-A2(-1)/sqrt2*St(1)+A2(0)/q62*St(0)           &
     &                                   -A2(1)/sqrt2*St(-1)            
      hv( 1)=-conjg(hv(-1)) 
!      write(6,'(a,6f10.2)')' hv=',real(hv(-1)-hv(1))/sqrt2,            
!     &          aimag(hv(-1)+hv(1))/sqrt2,real(hv(0))                  
      if(icase.eq.3) then 
!      transformation to the crystal system                             
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+hv(m)*conjg(Dcpv(n,m)) 
        end do 
        hvC(n)=hc1 
       end do 
      else if(icase.eq.2) then 
       do m=-1,1 
        hvC(m)=hv(m) 
       end do 
      end if 
!      write(6,'(a,6f10.2)')'hvC=',real(hvC(-1)-hvC(1))/sqrt2,          
!     &          aimag(hvC(-1)+hvC(1))/sqrt2,real(hvC(0))               
      j=iput+6 
      do i=-1,1 
       array_fr(j+i)=he(i)+hvC(i) 
      end do 
      j=iput+10 
      do i=-2,2 
       array_fr(j+i)=efgC(i) 
      end do 
      j=iput+13 
      array_fr(j)=(1.,0.) 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine th_sH05slowrelax(isubthe,icase,iput,iget,info) 
      use glbconst, only: icstrf,icfr2trf,ivstrf,ivfr2trf,infotext
      use comthe, only: array_fr,theoryname
      implicit none 
                                                                        
      integer isubthe,icase,iput,iget,info 
                                                                        
                                                                        
!     transmission: fr2 defines external magnetic field, orientation    
!     of the sample by phi,theta,psi is calculated by the routine sample
!     orientation tansferred by  array_fr to main and than passed to fr2
                                                                        
      real          c1,temperature,dumc 
      common/acmaps/c1,temperature,dumc(icstrf-2) 
      logical       b_c1,b_temperature,b_dum 
      common/bcmaps/b_c1,b_temperature,b_dum(icstrf-2) 
                                                                        
      real          avss,DEq,va2,va3,va4,va5,va6,va7,va8,               &
                    phi_g,theta_g,psi_g,Aav,A_a,A_eta,                  &
                    phi_A,theta_A,psi_A,dumvss                          
      common/avmaps/avss,DEq,va2,va3,va4,va5,va6,va7,va8,phi_g,theta_g,psi_g,&
                    Aav,A_a,A_eta,phi_A,theta_A,psi_A,dumvss(ivstrf-18) 
!     case 1             DEq,eta,phiE,thetaE,psiE,Ha,phiH,thetaH        
!     case 2             DEq,eta,phiE,thetaE,psiE,gav,g_a,g_eta,        
!     case 3             Deq,Aav,Hc_kappa,cov_k,phi_t2g,theta_t2g       
!                                              phi_t,theta_t,psi_t
      logical       b_vss,b_dumvss 
      common/bvmaps/b_vss,b_dumvss(ivstrf-1) 
                                                                        

     real,   dimension(2)        :: DD     

     complex,dimension(-1:1)     :: he,hv,hvC,heP,St
     complex,dimension(2,2)      :: VV
     complex,dimension(-1:1,-1:1):: Hm,Dcpv
     complex,dimension(-2:2,-2:2):: D2ct
     complex,dimension(-2:2)     :: t2PAS,efgC,g2,A2

      logical     b_integer,b_He 
      real        hmag,phiE_r,thetaE_r,psiE_r,                          &
                  efg0,efg2,eta,gav,g_a,g_eta,akT,                      &
                  Hc_kappa,cov_k,phi_t2g,theta_t2g,qxx,qyy,qzz,         &
                  at,at2,bt,bt2,ct,ct2,gxx,gyy,gzz,Axx,Ayy,Azz,h,cf,    &
                  h1,h2
      integer     i,j,m,n,jm 
      complex     hc1,H10,H1m1

      real,parameter::sqrt2=1.4142136,sqrt3=1.732051,q62=1.224745,      &
                      sqrt6=2.44948,rad=0.0174533,pi=3.14159,           &
                       meubohr=0.04668,ak=0.6950   
      complex,parameter:: C0=(0.,0.)



      if(isubthe.lt.0) then 
       theoryname='spin_Ham_Deq_slowrelax      v=100' 
       if(isubthe.eq.-16) return 
!      routines only asking for the name (not values for storage space) 
!      put isubthe to -16 (far away from -ntheory)                      
        c1=4+18 
!       Hext,phi,theta external field taken from array_fr(iput+1)...    
!       2 logical, H,EFG written on array_fr(iput+..),...               
       return 
      end if 
      b_He=real(array_fr(iput+4)).gt.0 
      if(.not.(b_vss.or.b_He)) then 
                                         ! 24.10.07 theory not changed  
       isubthe=-abs(isubthe) 
!       write(6,'(a)') ' no change'                                     
       return 
      end if 
      if(iget.eq.0) print'(a)','iget not defined'      
! ----------------------------------------------------------------------
      j=iput+2 
      do i=-1,1 
       he(i)=array_fr(j+i) 
      end do 
!     logicals (.., Deq>0)                                              
      array_fr(j+3)=(0.,0.) 
!     g*he                                                              
                             ! --------------------------               
      if(icase.eq.1) then 
!      case 1             DEq,eta,phiE,thetaE,psiE,gav,g_a,g_eta,       
       eta=va2 
       phiE_r=va3*rad 
       thetaE_r=va4*rad 
       psiE_r=va5*rad 
                                                                        
       if (abs(DEq).gt.0.)then 
        array_fr(iput+4)=(0.,1.) 
        call dimj(-psiE_r,-thetaE_r,-phiE_r,2,D2ct)
!       efg (-2..2) are the spherical tensor components of the EFG in th
        efg0=1.0/sqrt(1.+eta**2/3.) 
        efg2=eta*efg0/sqrt(6.) 
                                                                        
        t2PAS(0)=cmplx(efg0,0.0) 
        t2PAS(-1)=(0.,0.) 
        t2PAS(1)=(0.,0.) 
        t2PAS(-2)=cmplx(efg2,0.) 
        t2PAS(2)=cmplx(efg2,0.) 
                                                                        
        call vecxmat(2,t2PAS,D2ct,efgC)
        efgC=efgC*Deq   
       else 
         efgC=C0
       end if ! b_eq 
       j=iput+10 
       do i=-2,2 
        array_fr(j+i)=efgC(i) 
       end do 
      end if 
                                                                        
!      case 1             DEq,eta,phiE,thetaE,psiE,gav,g_a,g_eta,       
!      gav=va6                                                          
!      g_a=va7             ! Azz-gav                                    
!      g_eta=va8                                                        
!      he*g                                                             
       t2PAS(2)=va8/2.*va7 
       t2PAS(-2)=va8/2.*va7 
       t2PAS(1)=0. 
       t2PAS(-1)=0. 
       t2PAS(0)=q62*va7 
       call dimj(-psi_g*rad,-theta_g*rad,-phi_g*rad,2,D2ct)
!      g-tensor in the crystal system                                   
       call vecxmat(2,t2PAS,D2ct,g2)    
                                                                        
       hv(-1)=va6*he(-1)-g2(-2)*he(1)+g2(-1)/sqrt2*he(0)                &
     &                                 -g2(0)/sqrt6*he(-1)              
       hv( 0)=va6*he(0)-g2(-1)/sqrt2*he(1)+g2(0)/q62*he(0)          &
     &                                       -g2(1)/sqrt2*he(-1)        
       hv( 1)=-conjg(hv(-1)) 
                                                                        
!      A-tensor Aav,A_a,A_eta,phi_A,theta_A,psi_A                       
       t2PAS(2)=A_eta/2.*A_a 
       t2PAS(-2)=A_eta/2.*A_a 
       t2PAS(1)=0. 
       t2PAS(-1)=0. 
       t2PAS(0)=q62*A_a 
       call dimj(-psi_A*rad,-theta_A*rad,-phi_A*rad,2,D2ct)
!      A-tensor in the crystal system                                   
       call vecxmat(2,t2PAS,D2ct,A2)    
                                ! -------------------------------       
      if(icase.eq.2) then 
!     case 2             Deq,Aav,Hc_kappa,cov_k,phi_t2g,theta_t2g       
!     solution in the PAS - transformation of h,efg to crystal system   
                                                                        
       Aav=va2 
       Hc_kappa=va3 
       cov_k=va4 
       phi_t2g=va5*rad 
       theta_t2g=va6*rad 
                                                                        
       at=sin(theta_t2g) 
       bt=at*sin(phi_t2g) 
       at=at*cos(phi_t2g) 
       ct=cos(theta_t2g) 
!       write(6,'(a,6f10.3)') ' va5,va6,at,bt,ct=',va5,va6,at,bt,ct     
                                                                        
       at2=at*at 
       bt2=bt*bt 
       ct2=1.-at2-bt2 
                                                                        
                                                                        
!      g-tensor in the PAS , he transformed (heP) to the PAS,           
!      hv acting on the spin magnetic moment                            
       gxx=2.*(at2-bt2+ct2+2.*cov_k*at*ct) 
       gyy=2.*(at2+bt2-ct2+2.*cov_k*at*bt) 
       gzz=2.*(at2-bt2-ct2-2.*cov_k*bt*ct) 
       gav=(gxx+gyy+gzz)/3. 
       g_a=gzz-gav 
       g_eta=(gxx-gyy)/g_a 
                                                                        
!       write(6,'(a,4f10.3)') ' gav,g_a,g_eta=',gav,g_a,g_eta           
!      gav=va6                                                          
!      g_a=va7             ! Azz-gav                                    
!      g_eta=va8                                                        
!      he*g                                                             
       t2PAS(2)=g_eta/2.*g_a 
       t2PAS(-2)=t2PAS(2) 
       t2PAS(1)=0. 
       t2PAS(-1)=0. 
       t2PAS(0)=q62*g_a 
!       case=3: phi_t=psi_g, theta_t=theta_g, and psi_t=psi_g           
       call dimj(phi_g*rad,theta_g*rad,psi_g*rad,1,Dcpv)
       call vecxmat(1,he,Dcpv,heP)    
                                                                        
       hv(-1)=gav*heP(-1)-t2PAS(-2)*heP(1)-t2PAS(0)/sqrt6*heP(-1) 
       hv( 0)=(gav+g_a)*heP(0) 
       hv( 1)=-conjg(hv(-1)) 
!      A-tensor (crystal field) from Aav                                
       Axx=(4.*at*ct-(Hc_kappa+1./7.)*(1.-2.*bt2)+                      &
     &                                    3.*(1.-2.*bt*(at+ct))/7.)     
       Ayy=(4.*at*bt-(Hc_kappa+1./7.)*(1.-2.*ct2)+                      &
     &                                    3.*(1.-2.*ct*(at+bt))/7.)     
       Azz=-(4.*bt*ct-(Hc_kappa+1./7.)*(1.-2.*at2)+                     &
     &                                    3.*(1.-2.*at*(bt+ct))/7.)     
       h=(Axx+Ayy+Azz)/3. 
       cf=Aav/h 
                                                                        
       A_a=cf*Azz-Aav 
       A_eta=cf*(Axx-Ayy)/A_a 
!       write(6,'(a,4f10.3)') ' Aav,A_a,A_eta=',Aav,A_a,A_eta           
       A2(2)=A_eta/2.*A_a 
       A2(-2)=A2(2) 
       A2(1)=0. 
       A2(-1)=0. 
       A2(0)=q62*A_a 
                                                                        
!      Quadrupole tensor                                                
       array_fr(iput+4)=(0.,1.) 
                                                                        
       qxx=at2-2.*bt2+ct2 
       qyy=at2+bt2-2.*ct2 
       qzz=-qxx-qyy 
       eta=(qxx-qyy)/qzz 
                                                                        
       efg0=1.0/sqrt(1.+eta**2/3.) 
       efg2=eta*efg0/sqrt(6.) 
                                                                        
       t2PAS(0)=cmplx(efg0,0.0) 
       t2PAS(-1)=(0.,0.) 
       t2PAS(1)=(0.,0.) 
       t2PAS(-2)=cmplx(efg2,0.) 
       t2PAS(2)=cmplx(efg2,0.) 
                                                                        
       call dimj(-psi_g*rad,-theta_g*rad,-phi_g*rad,2,D2ct)
!       efg (-2..2) are the spherical tensor components of the EFG in th
       call vecxmat(2,t2PAS,D2ct,efgC)    
       efgC=efgc*Deq
      end if 
!                    -------------------------------------------------- 
       if(temperature.eq.0)then 
        info=1 
        infotext(1)='messages/spinham05/temperature' 
        infotext(2)='T=0 , temperature is not declared' 
        infotext(3)='missing  in the list of constants ' 
        infotext(4)=' ' 
        return 
       end if 
       akT=ak*temperature 
       b_integer=.false. 
       j=1 
       jm=j 
                                                                        
       do m=-j,j,2 
       do n=-j,j,2 
        Hm(n,m)=(0.,0.) 
       end do 
       end do 
!       write(6,'(a,6f10.4)')' hv=',hv                                  
!       write(6,'(a,6f10.2)')' hv=',real(hv(-1)-hv(1))/sqrt2,           
!     &          aimag(hv(-1)+hv(1))/sqrt2,real(hv(0))                  
       hmag=-meubohr/float(j) 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                        
       Hm(1,1)= H10 
       Hm(-1,-1)= -H10 
       Hm(1,-1)=H1m1*sqrt2 
       Hm(-1,1)=conjg(H1m1)*sqrt2 
                                                                        
!      do n=j,-j,-2                                                     
!       write(6,'(8f10.6)') (Hm(n,m),m=j,-j,-2)                         
!      end do                                                           
!      write(6,'(a)')                                                   
                                                                        
      call jacobihyf(b_integer,jm,Hm,j,j+1,DD,VV) 
                                                                        
      h1=exp(-DD(1)/akT) 
      h2=exp(-DD(2)/akT) 
      h=h1+h2 
      h1=h1/h 
      h2=h2/h 
!     spin expectation  <V+ S_i V>                                      
                                                                        
      St(-1)=conjg(VV(2,1))*VV(1,1)/sqrt2 
      St( 0)=(conjg(VV(1,1))*VV(1,1)-conjg(VV(2,1))*VV(2,1))/2. 
      St( 1)=-conjg(St(-1)) 
                                                                        
                                                                        
!     field at the nucleus hv = A*S                                     
      hv(-1)=Aav*St(-1)-A2(-2)*St(1)+A2(-1)/sqrt2*St(0)                 &
     &                              -A2(0)/sqrt6*St(-1)                 
      hv( 0)=Aav*St(0)-A2(-1)/sqrt2*St(1)+A2(0)/q62*St(0)           &
     &                                   -A2(1)/sqrt2*St(-1)            
      hv( 1)=-conjg(hv(-1)) 
!      write(6,'(a,6f10.2)')' hv=',real(hv(-1)-hv(1))/sqrt2,            
!     &          aimag(hv(-1)+hv(1))/sqrt2,real(hv(0))                  
      if(icase.eq.2) then 
!      transformation to the crystal system                             
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+hv(m)*conjg(Dcpv(n,m)) 
        end do 
        hvC(n)=hc1 
       end do 
      else if(icase.eq.1) then 
       hvC=hv 
      end if 
!      write(6,'(f10.2,a,6f10.2)')h1,'  hvC=',real(hvC(-1)-hvC(1))/sqrt2
!     &          aimag(hvC(-1)+hvC(1))/sqrt2,real(hvC(0))               
      j=iput+6 
      do i=-1,1 
       array_fr(j+i)=he(i)+hvC(i) 
      end do 
      j=iput+10 
      do i=-2,2 
       array_fr(j+i)=efgC(i) 
      end do 
      j=iput+13 
      array_fr(j)=cmplx(h1,0.) 
                                                                        
                                                                        
                                                                        
      St(-1)=conjg(VV(2,2))*VV(1,2)/sqrt2 
      St( 0)=-(conjg(VV(1,1))*VV(1,1)-conjg(VV(2,1))*VV(2,1))/2. 
      St( 1)=-conjg(St(-1)) 
                                                                        
                                                                        
!     field at the nucleus hv = A*S                                     
      hv(-1)=Aav*St(-1)-A2(-2)*St(1)+A2(-1)/sqrt2*St(0)                 &
     &                              -A2(0)/sqrt6*St(-1)                 
      hv( 0)=Aav*St(0)-A2(-1)/sqrt2*St(1)+A2(0)/q62*St(0)           &
     &                                   -A2(1)/sqrt2*St(-1)            
      hv( 1)=-conjg(hv(-1)) 
!      write(6,'(a,6f10.2)')' hv=',real(hv(-1)-hv(1))/sqrt2,            
!     &          aimag(hv(-1)+hv(1))/sqrt2,real(hv(0))                  
      if(icase.eq.2) then 
!      transformation to the crystal system                             
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+hv(m)*conjg(Dcpv(n,m)) 
        end do 
        hvC(n)=hc1 
       end do 
      else if(icase.eq.1) then 
       hvC=hv
      end if 
!      write(6,'(f10.2,a,6f10.2)')h2,'  hvC=',real(hvC(-1)-hvC(1))/sqrt2
!     &          aimag(hvC(-1)+hvC(1))/sqrt2,real(hvC(0))               
      j=iput+15 
      do i=-1,1 
       array_fr(j+i)=he(i)+hvC(i) 
      end do 
      j=iput+19 
      do i=-2,2 
       array_fr(j+i)=efgC(i) 
      end do 
      j=iput+22 
      array_fr(j)=cmplx(h2,.0) 
                                                                        
      return 
      END                                           


      subroutine jacobihyf(b_integer,jm,Hm,j,NN,D,V) 
      implicit none 
      logical, intent(in) :: b_integer 
      integer, intent(in) :: j,jm,NN 
      complex, intent(in) :: Hm(-jm:jm,-jm:jm)
      complex, intent(out):: V(NN,NN)
      real,    intent(out):: D(NN)

      complex,dimension(NN,NN):: A

      integer        :: i,k,m,n,nrot 
      real,parameter :: OUTJ=10000. 
                                                                        
                                                                        
      if(.not.b_integer)then 
!      ---------------half integral spin ------------------------       
       m=0 
       do i=j,-j,-2 
        m=m+1 
        A(m,m)=Hm(i,i) 
       end do 
!      write(6,'(10f8.3)')(A(n,n),n=1,NN)                               
       n=0 
       do k=j,-j+2,-2 
        n=n+1 
        m=n 
        do i=k-2,-j,-2 
        m=m+1 
         A(n,m)=Hm(k,i) 
!        write(6,'(2i4,2f10.3)')n,m,A(n,m)                              
        end do 
       end do 
                                                                        
       call jacHermite(NN,OUTJ,A,D,V,nrot) 
                                                                        
      else 
!       --------------- integral spin ------------------------          
        m=0 
        do i=j,-j,-1 
         m=m+1 
         A(m,m)=Hm(i,i) 
        end do 
                                                                        
        n=0 
        do k=j,-j+1,-1 
         n=n+1 
         m=n 
         do i=k-1,-j,-1 
         m=m+1 
          A(n,m)=Hm(k,i) 
!         write(6,'(2i4,2f10.3)')n,m,A(n,m)                             
         end do 
        end do 
                                                                        
        call jacHermite(NN,OUTJ,A,D,V,nrot) 
                                                                        
       end if 
!     U+HU is diagonal                                                  
!     <I|H|J> = Sum; i,k conjg(U(kI))*U(iJ)*<k|H|i>                     
!     <I|H|J> = Sum; i,k U(Ik)*<k|H|i>*U(iJ)                            
                                                                        
                                                                        
!      write(6,'(a,i6)')' nrot=',nrot                                   
!      m=0                                                              
!      do i=j,-j,-2                                                     
!       m=m+1                                                           
!       A(m,m)=Hm(i,i)                                                  
!      end do                                                           
                                                                        
!      n=0                                                              
!      do k=j,-j+2,-2                                                   
!       n=n+1                                                           
!       m=n                                                             
!       do i=k-2,-j,-2                                                  
!       m=m+1                                                           
!        A(n,m)=Hm(k,i)                                                 
!        A(m,n)=conjg(A(n,m))                                           
!       write(6,'(2i4,2f10.3)')n,m,A(n,m)                               
!       end do                                                          
!      end do                                                           
                                                                        
!      do i=1,NN                                                        
!       do j=1,NN                                                       
!        hc=(0.,0.)                                                     
!        do n=1,NN                                                      
!         do m=1,NN                                                     
!          hc=hc+ conjg(V(n,i))*A(n,m)*V(m,j)                           
!         end do                                                        
!        end do                                                         
!        write(6,'(a,2i3,a,2f12.3)')' h(',i,j,')=',hc                   
!       end do                                                          
!      end do                                                           
                                                                        
      return 
      END                                           
