      subroutine th_timewindows(isubthe,icase,iput,iget,info) 
     use glbconst, only: icstrf,ivstrf
     use comthe, only: array_fr,theoryname
     implicit none 
     integer, intent(inout):: isubthe
     integer, intent(in):: icase,iput,iget       
     integer, intent(out),optional :: info
     
     real          Tbunch
     integer       ibn,ien
     common/strLOC/ibn(18),Tbunch,ien(13)  
     real          c1,an_strob_order,                                  &
                   t1_window,t2_window,am_window,dumc
     common/acmaps/c1,an_strob_order,am_window,                        &
                   t1_window,t2_window,dumc(icstrf-5)
     logical       b_c1,b_strob_order,b_amwindow,                      &
                   b_t1_window,b_t2_window,b_dumc      
     common/bcmaps/b_c1,b_strob_order,b_amwindow,                      &
                   b_t1_window,b_t2_window,b_dumc(icstrf-5)

     real          v1,va12,vb12,dumv 
     common/avmaps/v1,va12,vb12,dumv(ivstrf-3) 
     logical       b_v1,b_va12,b_vb12,b_dumv 
     common/bvmaps/b_v1,b_va12,b_vb12,b_dumv(ivstrf-3) 

     integer iStrobo,jStrobo,jjStrobo,nStrobo,mStrobo,mWin 
     real    T2pT1,T2mT1,T2pT12,T2mT12,eta
     complex swin,swinp,swinm,swin1,swin10,swin2,swin2p,swin2m,swin20 

     real,    parameter:: pi=atan(1.0)*4.0 
     complex, parameter:: hci=cmplx(0.,1.)                           
                                                                        
                                                                        
!      write(6,'(a,4i6,a)')'th_timewindows isubthe,icase,iput,iget=',   
!     &                isubthe,icase,iput,iget                          
                                                                        
      if(isubthe.lt.0) then 
       if(icase.eq.1)c1=an_strob_order*2+1 
       if(icase.eq.2)then
        c1=an_strob_order*am_window*3+4 
        if(am_window.eq.0.)c1=an_strob_order*3+4 
       end if
!      storage for this routine                                         
       theoryname='rectangular_time_windows      v=200' 
       return 
      end if 
!      write(6,'(a,4i6,l5)')'th_timewindows isubthe,icase,iput,iget,b_c1=', &  
!                                          isubthe,icase,iput,iget,b_c1

       if(.not.b_c1) then 
        isubthe=-abs(isubthe) 
        return 
       end if 
       info=0                                                                 
                                                                          
      if(iget.eq.0) print'(a)','iget not defined'      

      if(icase.eq.1) then 
!      array_sp(iput+1)=s1                                              
!      Calculation of the diskret frequencies                           
!      Omega = 2.D0*PI/Tbunch                                           
!      VOmega= Omega*h/E0*C/2.D0/PI          ! Omega in mm/s            

       T2pT1 = (t2_window+t1_window)*pi 
       T2mT1 = (t2_window-t1_window)*pi 
                                                                        
       swin=cmplx(T2mT1,0.0)/pi 
       array_fr(iput+1)=swin 

       nStrobo=an_strob_order 
       do iStrobo=1,nStrobo 
         swin  = exp(hci*float(iStrobo)*T2pT1)/pi                  &
                 *sin(float(iStrobo)*T2mT1)/float(iStrobo)
!        write(6,'(I4,2F10.3)')iStrobo,swin                                    
        array_fr(iput+1+iStrobo)=swin 
       end do
       array_fr(iput+1)=array_fr(iput+1)/2.

      else if (icase.eq.2) then                                        
       t1_window=t1_window/Tbunch
       t2_window=t2_window/Tbunch 

!     number of boxcar funtions inside Tbunch:
      mWin    = am_window
      if(mWin.eq.0) then
       mStrobo=0; mWin=1; nStrobo=an_strob_order 

      else
       mStrobo =an_strob_order    ! max Fourier component considered in case 
                                  ! of the second window
      nStrobo=an_strob_order*mWin       
      end if
      eta     = 1./float(6*mWin) !shift for real and imaginay parts

      swin20  = (0.5,0.0)  !zeroth Fourier component of the 2nd window
                           ! for the first timewindow t1-t2 (defined by veto)
       T2pT1 = (t2_window+t1_window)*pi 
       T2mT1 = (t2_window-t1_window)*pi 
            ! for the second timewindow repeted mWin times duaring [0,Tbunch]
       T2pT12 = (0.75+0.25)*pi/mWin ! =(t2_window2+t1_window2)*pi/mWin 
       T2mT12 = (0.75-0.25)*pi/mWin ! =(t2_window2-t1_window2)*pi/mWin 
                                                                        
       swin10=cmplx(T2mT1,0.0)/pi 
                                                                       
       do iStrobo=0,nStrobo 
        swin =(0.0,0.0) 
        swinp=(0.0,0.0) 
        swinm=(0.0,0.0) 
!        swin1 = (1.0,0.0)
        do jStrobo = -mStrobo,mStrobo
         jjStrobo = mWin*jStrobo
         if(iStrobo-jjStrobo.eq.0)then
          swin1 = swin10
!         swin1 = (1.0,0.0)
         else
          swin1 = exp(-hci*float(iStrobo-jjStrobo)*T2pT1)/pi    &
                  *sin(float(iStrobo-jjStrobo)*T2mT1)/float(iStrobo-jjStrobo)
         endif                         

         if(jjStrobo.eq.0)then
          swin2 = swin20
         else
          swin2 = mWin*exp(-hci*float(jjStrobo)*T2pT12)/pi    &
                  *sin(float(jjStrobo)*T2mT12)/float(jjStrobo)        
         endif
         swin2p= swin2*exp(-hci*2.*pi*float(jjStrobo)*eta)
         swin2m= swin2*exp( hci*2.*pi*float(jjStrobo)*eta)
         swin  = swin+swin1*swin2
         swinp = swinp+swin1*swin2p
         swinm = swinm+swin1*swin2m
        end do
!        write(6,'(I4,6F10.3)')iStrobo,swin,swinp,swinm
!        write(6,'(I4,4F10.3)')iStrobo,swin,swinp   
        array_fr(iput+1+iStrobo)=swin 
        array_fr(iput+2+nStrobo+iStrobo)=swinp 
        array_fr(iput+3+2*nStrobo+iStrobo)=swinm 
!         array_fr(iput+1+nStrobo-i)=conjg(swin)                          
       end do 
       array_fr(iput+1)          =array_fr(iput+1)/2. 
       array_fr(iput+2+nStrobo)  =array_fr(iput+2+nStrobo)/2.
       array_fr(iput+3+2*nStrobo)=array_fr(iput+3+2*nStrobo)/2.
      end if 
                                                                        
      return 
!    End of calculation of the diskret frequencies                      
    END subroutine th_timewindows


    subroutine th_debye(isubthe,icase,iput,iget,info) 
     use glbconst, only: icstrf,ivstrf
     use comthe, only: array_fr,theoryname
     implicit none 
                                                                       
     integer, intent(inout):: isubthe
     integer, intent(in):: icase,iput,iget       
     integer, intent(out),optional :: info

     real          c1,dumc 
     common/acmaps/c1,dumc(icstrf-1) 
                                                                       
     real          v1,phi,theta,psi,ax_theta,ax_phi,omega,             &
                   x_theta,x_phi,z_theta,z_phi,dumv                    
     common/avmaps/v1,phi,theta,psi,ax_theta,ax_phi,omega,             &
                   x_theta,x_phi,z_theta,z_phi,dumv(ivstrf-11)         
     logical       b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega, &
                   b_xtheta,b_xphi,b_ztheta,b_zphi,b_dumv              
     common/bvmaps/b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega, &
                   b_xtheta,b_xphi,b_ztheta,b_zphi,b_dumv(ivstrf-11)   
                                                                       
     real,   parameter::pi=3.141592654,rad=0.017453293
     complex,parameter::hc0=(0.0,0.0) 
                                                                        
!     planed              
                                                                        
     if(isubthe.lt.0) then
       theoryname='f_is_debye      v=001' 
       if(isubthe.eq.-16) return        
       c1=4 
!      storage for this routine                                         
       return 
      end if 
!     write(6,'(a,i2)')' enter debye icase=',icase        

      if(iget.eq.0) print'(a)','iget not defined'      
                                                                        
!      write(6,'(a,i2,i8,10f8.2)')'icase,iput,var debey,const tem=',  &    
!           icase,iput,omega,dumc(6)
      array_fr(iput+1)=omega*2;array_fr(iput+2)=dumc(6)*2 
      return 
    END subroutine th_debye
                                                                        
                                                                        
     subroutine th_sampleorient(isubthe,icase,iput,iget,info) 
     use glbconst, only: icstrf,ivstrf,infotext,enwr
     use comthe, only: array_fr,theoryname
     implicit none 
                                                                       
     integer, intent(inout):: isubthe
     integer, intent(in):: icase,iput,iget       
     integer, intent(out),optional :: info

     real          c1, phip,thetap,psip,dumc 
     common/acmaps/c1, phip,thetap,psip,dumc(icstrf-4) 
     logical       b_c1,b_phip,b_thetap,b_psip,b_dumc 
     common/bcmaps/b_c1,b_phip,b_thetap,b_psip,b_dumc(icstrf-4)                         
     real          v1,phi,theta,psi,ax_theta,ax_phi,omega,dumv                    
     common/avmaps/v1,phi,theta,psi,ax_theta,ax_phi,omega,dumv(ivstrf-7)         
     logical       b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega,b_dumv              
     common/bvmaps/b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega, &
                   b_dumv(ivstrf-7)   
                                                                       
     real,   parameter::pi=3.141592654,rad=0.017453293
     complex,parameter::hc0=(0.0,0.0) 
     real    alpha,beta,gamma,thickness,phiz,thetaz,phig
!             cphi,ctheta,cpsi,cosb,zx,zy,zz
     logical b_change 
                                                                        
                                                                        
      if(isubthe.lt.0) then 
       c1=6
!      storage for this routine                                         
       theoryname='sample_orientation' 
       return 
      end if 
      if(enwr(15).eq.'ipig')print'(2(a,i7))','iput=',iput,'  iget=',iget
!     write(6,'(a,i2,2i7)')'gpg_spezial sample_orientation icase=', &
!         icase,iput,iget
      info=0                                                  
      if(icase.eq.1) then 
        array_fr(iput+2)=hc0                  !  alpha,     false       
        array_fr(iput+3)=hc0                  !  beta,      not used    
        array_fr(iput+4)=hc0                  !  gamma,     not used    
        array_fr(iput+1)=cmplx(1.0,1.0)       !  thickness, not used    
        isubthe=-abs(isubthe)                 !  no change of input      
        return 
       end if 
!  construction of phi,theta,psi,ax_theta,ax_phi,omega & phiz,thetaz  
!  alpha,beta,gamma & thickness
      
      if(iget.eq.0) print'(a)','iget not defined'      

!      write(6,'(a,2f5.1,/5x,3f6.1,/5x,3f6.1)') &
!                 'phiz,thetaz,phi,theta,psi,cphi,ctheta,cpsi=',&
!                  phiz,thetaz,phi,theta,psi,cphi,ctheta,cpsi
!       write(6,'(a,i2,i8,10f8.2)')                          &         
!        'icase,iput,phi,theta,psi,ax_theta,ax_phi,omega=',  &          
!         icase,iput,phi,theta,psi,ax_theta,ax_phi,omega               
!      write(6,'(10f12.2)')d_x2 ,x2_eta,x2_phi,x2_theta,x2_psi          
        b_change=b_phi.or.b_theta.or.b_psi.or.                           &
                     b_axtheta.or.b_axphi.or.b_omega                   

        if(aimag(array_fr(iput+6)).lt.0) then
         !  case om_samp<0 : single cristal case of cos-smearing
         phiz=real(array_fr(iput+5)); thetaz=aimag(array_fr(iput+5))
         phig=real(array_fr(iput+6))
        else
         phiz=0.0; thetaz=0.0; phig=0.0
        end if
!        write(6,*)'  phiz'; read(5,*)phiz
!       write(6,*)'thetaz'; read(5,*)thetaz
!        write(6,'(a,3f10.3)')'gpg_spezial  phiz,thetaz,phig=',phiz,thetaz 

        if(b_change) then
!          print*,'###',ax_theta,ax_phi,omega,phi,theta,psi
         call euler_omega(icase,enwr,ax_theta,ax_phi,omega,phi,theta,psi, &
              alpha,beta,gamma,thickness,infotext,info)
         if(enwr(15).eq.'ipig')print'(i3,i7,a,4f10.3)',icase,iput,' ###',  &
                                                alpha,beta,gamma,thickness
         if(info.gt.0) return          
         if(icase.eq.2) then 
          array_fr(iput+1)=cmplx(1.0,2.0) 
         else 
          array_fr(iput+1)=cmplx(thickness,3.0) 
         end if 
!        write(6,'(a,i2,i8,/,10f12.2)')  &                                
!        'icase,iput,ax_theta,ax_phi,omega,alpha,beta,gamma=',&         
!         icase,iput,ax_theta,ax_phi,omega,alpha,beta,gamma            
!       write(6,'(a,2f8.4,3x,3f8.2)')'   omega,thickness,alpha,beta,gamma=',&
!                                        omega,thickness,alpha,beta,gamma      
         array_fr(iput+2)=cmplx(alpha,1.0) 
         array_fr(iput+3)=cmplx(beta,1.0) 
         array_fr(iput+4)=cmplx(gamma,1.0) 
        else
         ! no change : aimag(array_fr(iput+2)) put to 0 => signalling no change
         alpha=real(array_fr(iput+2)) 
         array_fr(iput+2)=cmplx(alpha,0.0) 
         ! isubthe < 0 : => signalling no change  
         isubthe=-abs(isubthe) 
        end if 
      return 
    END subroutine th_sampleorient



  subroutine seq2rotations(alpha1,beta1,gamma1,alpha2,beta2,gamma2,&
                                                    alpha,beta,gamma)
     implicit none
     real, intent(in)::alpha1,beta1,gamma1,alpha2,beta2,gamma2
     real, intent(out)::alpha,beta,gamma     
     real, parameter:: rad= 0.01745329
     integer m,n,k

     complex, dimension(-1:1,-1:1):: dj1,dj2,drt 
     complex hc
     real, dimension(-1:1,-1:1):: d1
     real, dimension(3,3)::uveca,uvecb
     real fm,fn
     
       call wigner(1,beta1*rad,d1)
        do m=-1,1 
         do n=-1,1 
          fm=float(m)*alpha1*rad 
          fn=float(n)*gamma1*rad 
          dj1(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
         end do 
        end do 

        call wigner(1,beta2*rad,d1) 
        do m=-1,1 
         do n=-1,1 
          fm=float(m)*alpha2*rad 
          fn=float(n)*gamma2*rad 
          dj2(m,n)=cmplx(cos(fm+fn),-sin(fm+fn))*d1(m,n) 
         end do 
        end do 
       
        do m=-1,1 
         do n=-1,1 
          hc=(0.,0.) 
          do k=-1,1 
           hc=hc+dj1(m,k)*dj2(k,n) 
          end do 
          drt(m,n)=hc 
         end do 
        end do 
       uveca=0.0; uveca(1,1)=1.; uveca(2,2)=1.; uveca(3,3)=1.
                                                                        
       uvecb(1,1)=0.5*real(drt(1,1)-drt(-1,1)-drt(1,-1)+drt(-1,-1)) 
       uvecb(1,2)=-0.5*aimag(drt(1,1)+drt(-1,1)-drt(1,-1)-drt(-1,-1)) 
       uvecb(1,3)=-1./sqrt(2.)*real(drt(0,1)-drt(0,-1)) 
                                                                        
       uvecb(2,1)=0.5*aimag(drt(1,1)-drt(-1,1)+drt(1,-1)-drt(-1,-1)) 
       uvecb(2,2)=0.5*real(drt(1,1)+drt(-1,1)+drt(1,-1)+drt(-1,-1)) 
       uvecb(2,3)=-1./sqrt(2.)*aimag(drt(0,1)+drt(0,-1)) 
                                                                        
       uvecb(3,1)=-1./sqrt(2.)*real(drt(1,0)-drt(-1,0)) 
       uvecb(3,2)=1./sqrt(2.)*aimag(drt(1,0)+drt(-1,0)) 
       uvecb(3,3)=real(drt(0,0)) 

       call angle_uvecab(uveca,uvecb,alpha,beta,gamma)

       return
     end subroutine seq2rotations
     
    subroutine angle_uvecab(uveca,uvecb,alpha,beta,gamma)
    implicit none
    real, intent(in):: uveca(3,3),uvecb(3,3)
    real, intent(out)::alpha,beta,gamma
    real h,st,arcos
    integer k
    real, parameter:: pi=3.14159265, rad=pi/180.0
!  for test       eax=(0.296198, 0.17101,0.939692) eaz=(-0.5,0.866025,0 )
!      vectors uveca and uvecb are known                                
!      calculation of Euler angle alpha,beta,gamma                      
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(3,k) 
       end do 
       beta=arcos(h) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=beta/rad 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(1,k) 
        end do 
        alpha=arcos(h) 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(2,k) 
        end do 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0           ! beta=0  
       else                 ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(1,k) 
         end do 
         gamma=0.0 
         alpha=arcos(-h) 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(2,k) 
         end do 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(3,k) 
         end do 
         alpha=arcos(h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(2,k)*uvecb(3,k) 
         end do 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
                                                                        
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(1,k) 
         end do 
         gamma=arcos(-h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(2,k) 
         end do 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
      end if
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
     return
   END subroutine angle_uvecab
   


  subroutine euler_omega(case,enwr,ax_theta,ax_phi,omega,oalpha,obeta,ogamma,&
                      alpha,beta,gamma,thickness,infotext,info)     
      implicit none
     integer, intent(in) :: case 
     real,    intent(in) :: ax_theta,ax_phi,omega,oalpha,obeta,ogamma
     real,    intent(out):: alpha,beta,gamma,thickness
     character(len=4), dimension(16), intent(in):: enwr
     character(len=132), dimension(8), intent(out):: infotext
     integer, intent(out):: info 

     character(len=6),dimension(3),parameter:: eai=  &
                                       (/'      x','e_C = y','      z'/) 
     character(len=6),dimension(3),parameter:: ebi=  &
                                       (/'      x','r_ax= y','      z'/)
     character(len=8),dimension(3),parameter::text= &
                                        (/' in the ',' Lab.   ',' system '/) 
     real, dimension(3,3):: uveca,uvecb,uvec 
     real, parameter:: pi=3.141592654,rad=atan(1.)/45., eps=0.001
     logical   b_error 
     integer   l,k 
     real      cosb,cosg,cosa,omcosg,sina,sinb,sing,xalpha,xbeta,xgamma, & 
               cos2b,sin2b,coshps,coshms,sinhps,sinhms,phi,dx,dy,dz,h,st,arcos  

!  write(6,'(5f12.4)')ax_theta,ax_phi,omega,oalpha,obeta,ogamma,&
!                            alpha,beta,gamma,thickness
!    write(6,'(a,3f10.1)')' alpha,beta,gamma=',oalpha,obeta,ogamma   
!    oalpha,obeta,ogamma is the transformation of the crystal system t
!    absorber system.                                                 
!    omega rotation around the axis ax_theta,ax_phi in the absorbersys
!    inverse matrix uvecz
!    inverse matrix uveca  
     cos2b=cos(obeta*rad/2.)**2; sin2b=sin(obeta*rad/2.)**2
     coshps=cos((oalpha+ogamma)*rad); sinhps=sin((oalpha+ogamma)*rad)
     coshms=cos((oalpha-ogamma)*rad); sinhms=sin((oalpha-ogamma)*rad)
 
     uveca(1,1)=cos2b*coshps-sin2b*coshms
     uveca(1,2)=cos2b*sinhps-sin2b*sinhms
     uveca(1,3)=-sin(obeta*rad)*cos(ogamma*rad)
                 
     uveca(2,1)=-(cos2b*sinhps+sin2b*sinhms)
     uveca(2,2)= (cos2b*coshps+sin2b*coshms)
     uveca(2,3)=sin(obeta*rad)*sin(ogamma*rad)
                 
     uveca(3,1)=sin(obeta*rad)*cos(oalpha*rad)
     uveca(3,2)=sin(obeta*rad)*sin(oalpha*rad)
     uveca(3,3)=cos(obeta*rad)

!     do k=1,3 
!     print'(a12,x,2(a6,a3,3(f7.3,a1),3x))', text(k),               &
!     eai(k),' ( ',uveca(k,1),',',uveca(k,2),',',uveca(k,3),')'      
!     end do 

     xalpha=ax_phi*rad 
     xbeta=ax_theta*rad 
     xgamma=omega*rad 
                                                                      
     cosa=cos(xalpha) 
     sina=sin(xalpha) 
     cosb=cos(xbeta) 
     sinb=sin(xbeta) 
                                                                      
     cosg=cos(xgamma) 
     sing=sin(xgamma) 
     omcosg=1.0-cosg 
                                                                      
     dx=sinb*cosa 
     dy=sinb*sina 
     dz=cosb 
                                                                      
                                                                      
     uvecb(1,1)=dx**2*omcosg +cosg 
     uvecb(1,2)=dx*dy*omcosg+dz*sing 
     uvecb(1,3)=dx*dz*omcosg-dy*sing 
                                                                      
     uvecb(2,1)=dx*dy*omcosg-dz*sing 
     uvecb(2,2)=dy**2*omcosg+cosg 
     uvecb(2,3)=dz*dy*omcosg+dx*sing 
                                                                      
     uvecb(3,1)=dx*dz*omcosg+dy*sing 
     uvecb(3,2)=dy*dz*omcosg-dx*sing 
     uvecb(3,3)=dz**2*omcosg+cosg  
                                                                      
     uvec=matmul(uveca,uvecb)
     uvecb=uvec        

     uveca=0.
     do l=1,3 
      uveca(l,l)=1. 
     end do 
                                                                      
     b_error=.false. 
     if(case.eq.3)then 
!     1. case: Rotation axis (defined with respect to the lab. system 
!             is the g-direction) is normal to the surface of the samp
!             The thickness of the sample increases by the factor 1/co
!     2. case: rotation axis lies in the sample plane (ax_theta=90°) 
!             The sample is rotated out of the position orthonormal to
!             g-direction by the rotation angle omega. The thickness o
!             sample increases by the factor 1/cos(omega)             
!     Which case is decided by theta<90°.                            
      b_error=.true. 
      if(abs(ax_theta-90).lt.0.01) then 
       if(cosg.gt.0.05)then 
        thickness=1./cosg 
        b_error=.false. 
       end if 
      else 
       if(cosb.gt.0.05)then
!        write(6,'(a,3f8.2)')'alpha,beta,gamma=',oalpha,obeta,ogamma
        ! ebz=  -0.741ex+0.672ey+0.0ez  rotation axes       
!         cosb=0.741*sin(obeta*rad)*cos(ogamma*rad)+   &
!               0.672*sin(obeta*rad)*sin(ogamma*rad)    
        thickness=1./cosb 
!       write(6,'(a,3f12.3,a,f12.4)')' vec=',-sin(obeta*rad)*cos(ogamma*rad), &
!       sin(obeta*rad)*sin(ogamma*rad),cos(obeta*rad),' thickness=', thickness
        b_error=.false. 
       end if 
      end if 

      if(b_error)then 
       info=1
       infotext(1)='<euler>/sample/rotation/axis' 
       infotext(2)(1:17)=' Rotation axis is ill defined' 
       infotext(3)=' ' 
       goto 10 
      end if 
     end if 
                                                                      
!    vectors uveca and uvecb are known                                
!    calculation of Euler angle alpha,beta,gamma                      
                                                                      
     h=0.0 
     do k=1,3 
      h=h+uveca(3,k)*uvecb(3,k) 
     end do 
     beta=arcos(h) 
     st=sin(beta)*(1.+eps/100.) 
     if(beta.lt.eps) then 
      beta=0.0 
      h=0.0 
      do k=1,3 
       h=h+uveca(1,k)*uvecb(1,k) 
      end do 
      alpha=arcos(h) 
      h=0.0 
      do k=1,3 
       h=h+uveca(1,k)*uvecb(2,k) 
      end do 
      if(h.gt.0.0) alpha=2.0*pi-alpha 
      gamma=0.0 
      ! beta=0                                                   
     else    ! sin(beta)=0  
      if(abs(st).lt.eps) then 
       h=0.0 
       do k=1,3 
        h=h+uveca(1,k)*uvecb(1,k) 
       end do 
       gamma=0.0 
       alpha=arcos(-h) 
       h=0.0 
       do k=1,3 
        h=h+uveca(1,k)*uvecb(2,k) 
       end do 
       if(h.gt.0.0) alpha=2.0*pi-alpha 
      else 
       h=0.0 
       do k=1,3 
        h=h+uveca(1,k)*uvecb(3,k) 
       end do 
       alpha=arcos(h/st) 
       h=0.0 
       do k=1,3 
        h=h+uveca(2,k)*uvecb(3,k) 
       end do 
       if(h.lt.0.0) alpha=2.0*pi-alpha 
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(1,k) 
       end do 
       gamma=arcos(-h/st) 
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(2,k) 
       end do 
      if(h.lt.0.0) gamma=2.0*pi-gamma
      end if  ! sin(beta)#0   
     end if   ! beta=0  


     if(enwr(7).eq.'thph')then
      phi=atan(-sin(gamma)/cos(gamma))                                      
      if(-sin(beta)*cos(gamma).lt.0.) phi=phi+pi      
      print'(a,2f12.2)','theta,phi=',beta/rad,phi/rad
     end if

     beta=beta/rad 
     alpha=alpha/rad 
     gamma=gamma/rad 
                                                                      
!    write(nwr,'(/,a)') 'unit vectors of system Sb in system S'      
!    caution! vector a is the transpose matrix in order to print the  
!    unit vectors of the rotatet system in the original system.       

 10 if(enwr(7).eq.'eulr'.or.b_error) then 
     print'(/,a,/,3(a,f10.2),/)',' unit vectors of system Sa and system Sb',&
                    ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega
     do k=1,3 
      print'(a12,x,2(a6,a3,3(f7.3,a1),3x))', text(k),               &
      eai(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'      
     end do 
     print'(/,20x,a,/,a,3(f6.1,a),/)','Euler angles alpha,beta,gamma',&
                                    ' eb(n)=Sum;m ea(m) D1,mn(alpha=',&
                              alpha,',beta=',beta,',gamma=',gamma,')'
     if(b_error) return 
    end if 

    return 

  END subroutine euler_omega
                                                                        
    subroutine  euler_dir(x_theta,x_phi,z_theta,z_phi,               &
                          alpha,beta,gamma,thickness,enwr,info)          
    implicit none
    integer, intent(out):: info
    real,    intent(in) :: x_theta,x_phi,z_theta,z_phi
    real,    intent(out):: alpha,beta,gamma,thickness 
     character(len=4), dimension(16), intent(in):: enwr
                                                    
    real, dimension(3,3):: uveca,uvecb
    real, dimension(3)  :: uvec1,uvec2,uvec3 
                                                                        
     character(len=6),dimension(3),parameter:: eai=(/'eax   ','eay   ','eaz   '/) 
     character(len=6),dimension(3),parameter:: ebi=(/'ebx   ','eby   ','ebz   '/) 
     logical     b_error 
     real        st,ax_phi,ax_theta,omega,h,arcos
     real, parameter:: pi=3.141592654,rad=0.017453293, eps=0.0001
     integer   k

     st=sin(x_theta*rad) 
     uvecb(1,1)=st*cos(x_phi*rad) 
     uvecb(1,2)=st*sin(x_phi*rad) 
     uvecb(1,3)=cos(x_theta*rad) 
                                                                    
                                                                    
     st=sin(z_theta*rad) 
     uvecb(3,1)=st*cos(z_phi*rad) 
     uvecb(3,2)=st*sin(z_phi*rad) 
     uvecb(3,3)=cos(z_theta*rad) 
                                                                      
!    zeta=arcos(uvecb(3,3)) is the angle between old and new z-axes  
!    1/ uvecb(3,3)> 1 is the increase of the thickness of the        
!    absorber with respect to the  g-direction parallel to the old z-
     b_error=.false. 
     thickness=1./abs(uvecb(3,3)) 
     if(thickness.gt.100) then 
      print'(a)',' orientation of the scatterer is such that',   &
                   ' the z-axis lies in the plan of the scatterer'                 
      b_error=.true.
      info=1 
     end if 
                                                                      
     do k=1,3 
      uvec1(k)=uvecb(3,k) 
      uvec2(k)=uvecb(1,k) 
     end do 
     call crospr(uvec1,uvec2,uvec3) 
     do k=1,3 
      uvecb(2,k)=uvec3(k) 
     end do 
                                                                      
!    calculation of Euler angle alpha,beta,gamma                      
                                                                      
     beta=arcos(uvecb(3,3)) 
     st=sin(beta) 
     if(beta.lt.eps) then 
      beta=0.0 
      beta=beta/rad 
      alpha=arcos(uvecb(1,1)) 
      h=uvecb(2,1) 
      if(h.gt.0.0) alpha=2.0*pi-alpha 
      gamma=0.0 
           ! beta=0                                                   
     else 
                                 ! sin(beta)=0                        
      if(abs(st).lt.eps) then 
       h=uvecb(1,1) 
       gamma=0.0 
       alpha=arcos(-h) 
       h=uvecb(2,1) 
       if(h.gt.0.0) alpha=2.0*pi-alpha 
      else 
       h=uvecb(3,1) 
       alpha=arcos(h/st) 
       h=uvecb(3,2) 
       if(h.lt.0.0) alpha=2.0*pi-alpha 
       h=uvecb(1,3) 
       gamma=arcos(-h/st) 
       h=uvecb(2,3) 
      if(h.lt.0.0) gamma=2.0*pi-gamma 
     end if  ! sin(beta)#0   
     end if  ! beta=0         
     beta=beta/rad 
     alpha=alpha/rad 
     gamma=gamma/rad 
                                                                      
    if(enwr(7).eq.'eulr') then 
     print'(/,a,/,3(a,f10.2))',' unit vectors of system Sb in system S',&
                 ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega          
     do k=1,3 
      print'(6x,a3,a2,3(f8.3,a1))',ebi(k),'=(',                  &
                uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'          
     end do 
     print'(/,a)', 'unit vectors of system Sa in system S' 
     do k=1,3 
      print'(6x,a3,a2,3(f8.3,a1))',eai(k),'=(',                  &
                uveca(k,1),',',uveca(k,2),',',uveca(k,3),')'          
     end do 
     print'(/,20x,a,/,a,3(f6.1,a),/)','Euler angles alpha,beta,gamma',&
                                     'eb(n)=Sum;m ea(m) D1,mn(alpha=',&
                              alpha,',beta=',beta,',gamma=',gamma,')'                       
     if(b_error) return 
    end if 
                                                                      
    return 
    END                                           
                                                                        
