!  the file hpg_neutron.f containes the following subroutines:          
!      subroutine plotneutron(cmch)                                     
!      subroutine n_diffuse(maxl,NL,b_Cm,MAXGRP,GEOSTR,Cmatrix,VKD,     
!      subroutine n_diffuse_base(maxl,NL,MAXGRP,GEOSTR,SFi_inc,SFi_fin, 
!      subroutine contribution (T1,C,T2,dI)                             
!      subroutine correlate(Qx,ksi,sigma,both_plus,C)                   
!      subroutine n_field(maxl,I_DMAX,NL,b_Cm,MAXGRP,GEOSTR,SQ,K1,      
!      subroutine trans(QD,KL,R,L,A,B)                                  
!      subroutine nanalytic_fourier(z1,z2,QD,K1,KL,A,B,T)               
!      subroutine n_diffuseRough(I_DMAX,maxl,Nl,b_Cm,MAXGRP,GEOSTR,     
!      subroutine contributionRough(Inc1,Dif1,dhi,Inc2,Dif2,dhi1,       
!      subroutine correlateRough(z1,z2,sigma1,sigma2,                   
!      subroutine field_in_z(I_DMAX,T_z,layer,DWBA,T_kz)                
!      subroutine ket_from_bra(matrix)                                  
!      subroutine n_depth(I_DMAX,maxll,NL,b_Cm,MAXGRP,GEOSTR,SQ,Cmatrix,
!      subroutine transRough(L,R,T)                                     
!      subroutine n_optics(maxl,NL,b_Cm,MAXGRP,GEOSTR,SQ,Hextz,Cmatrix, 
!      subroutine reflG(G,M,R)                                          
      subroutine plotneutron(cmch) 
      use glbconst, only: maxfr1,maxfr2,maxn,max8,maxsub,       &
                          maxthss,icstrf,ivstrf,MDBPLFT,infplot
      use comdat, only: ichanks,mfpt,mdfpt,file_data,name_data,formdata, &
                        b_theory,b_data,name_theory
      use complt, only: display_mode,icolor_sub,n_subset,ndisplay_mode
      use comthe, only: real_fr,thfk     
      implicit none 
      character(len=4),intent(in):: cmch 

      integer       istorTH,nexp,mxpt,idumloc,ien
      real          xb_the,dx_the
      common/strLOC/istorTH,nexp,mxpt,idumloc(23),xb_the,dx_the,ien(4)  

                                                                        
     integer      n_subspectra,logx,logy,logf,       &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         plotx,ploty,ploterry,plotres,plotxx,plotyy,plotsub,  &
                  xyzdz,vtxt,vtxtp                                     
     character(len=132):: plotstrpu,title
     character(len=24) :: axesname,abscissa,ordinata,bgcolor,fgcolor,   &  
                          datacolor,thcolor,rescolor,auxcolor1,         &      
                          auxcolor2,auxcolor3
     character(len=80) :: datfile,plotstrdef
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,ch4d,ch4de

     real              :: datx,errx,sym,subspectrum,daty,erry       
     integer,parameter:: max8subn=maxsub*max8,max4=4*maxn,max16=maxn*16,&
                 jdumpl=8*(max4+2)+4*(max4/2)+max4,                    &
                 idumpl=4*maxn-8*39-5*infplot-maxsub-201+jdumpl,       &
                 kdumpl=5*max4+max4*maxsub,                            &
                 ldumpl=MDBPLFT*2-144*maxn-jdumpl-kdumpl  
     common/plot/plotx(max8),ploty(max8),ploterry(max8),plotres(max8), &
                 plotxx(max8),plotyy(max8),plotsub(max8subn),          &
                 xyzdz(8),vtxt(2,max16),vtxtp(8,32),                  &
                 int3d(max16),npnt3d(16),ifeder(max16),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,ch4d(idumpl),   &
                 datx(max4),errx(max4),sym(max4),                      &
                 subspectrum(max4,maxsub),daty(max4),erry(max4),ch4de(ldumpl)
                                                                       
     real          acsp,dwba,dastr,channels,anglepair,                 &
                   unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,dumcsp  
     common/acstrf/acsp,dwba,dastr,channels,anglepair,                 &
                   unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,        &
                   dumcsp(icstrf-11)                                   
                                                                       
     real          avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,   &
                   Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvs                 
     common/avstrf/avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,   &
                   Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvs(ivstrf-10)      
                                                                       
                                                                       
     integer nthe,ii,i,k,j,ns,nyy,ny,nresidue 
     real    h,resmin,resmax,xmin,xmax,ymin,ymax,hd 
                                                                        
      logical         b_logx,b_logy,b_12,b_34 
      character(len=1) :: chx,chbx,chlr,chy,chby,chbt,ch0
      character(len=80):: CTEXT,CXTEXT,CYTEXT
      character(len=24):: frcolor
      integer         nformx,nformy,isd
      real            chh,chw,syw,syh 

      ch0=char(0)
      if(cmch.eq.'dstr') then 
!      format  reading data                                             
       formdata(1)='y'           ! dastr=1 
       formdata(2)='y,dy'        ! dastr=2 
       formdata(3)='y,x'         ! dastr=3 
       formdata(4)='y,dy,x'      ! dastr=4
       formdata(5)=' '
       return 
      end if 

      if(cmch.eq.'dmod') then 
       namechan(1)='x' 
       namechan(2)='y' 
       namechan(3)='dy' 
       namechan(4)='res' 
       namechan(5)='xt' 
       namechan(6)='yt' 
       namechan(7)='su' 
       namechan(8)=' ' 
       plotstrdef='(x,y,dy)' 
       if(b_theory) plotstrdef='(xt,yt)' 
!      if there is not the standard xd,yd,erry a d(...) identifies data 
       if(b_theory.and.b_data) plotstrdef='(x,y,dy) (xt,yt)' 
                                                                        
       display_mode(1)='q-scale ,log(count)' 
       display_mode(2)='q-scale, residual aintensity' 
       display_mode(3)='channel scale, aintensity' 
       display_mode(4)='channel scale,residual aintensity' 
       return 
      end if 
                                                                        
      b_logy=.false. 
      b_logx=.false. 
      b_12=.false. 
      b_34=.false. 
      if(ndisplay_mode.gt.4) ndisplay_mode=4 
      goto(1,2,3,4), ndisplay_mode 
!      display_mode(1)='q scale, log(count)'                            
    1 continue 
      b_12=.true. 
      abscissa='Q[10$^-2$ A$^-1$ ]' 
      axisformat(1)='%6.2f ' 
      ordinata='log(count) ' 
      axisformat(2)='%6.2f ' 
      b_logy=.true. 
      nformx=2 
      nformy=2 
      goto 5 
!     display_mode(2)='q-scale, residual aintensity'                    
    2 continue 
      b_12=.true. 
      abscissa='Q[10$^-2$ A$^-1$ ]'  
      axisformat(1)='%6.2f ' 
      ordinata='log(intensity) ' 
      axisformat(2)='%6.2f ' 
      b_logy=.true. 
      nformx=2 
      nformy=2 
      goto 5 
!     display_mode(3)='channel scale'                                   
    3 b_34=.true. 
      abscissa='channel ' 
      ordinata='intensity ' 
      axisformat(1)='%6.0f ' 
      axisformat(2)='%8.0f ' 
      nformx=0 
      nformy=0 
      goto 5 
!     display_mode(4)='-channel scale, residual aintensity'             
    4 b_34=.true. 
      abscissa='channel ' 
      ordinata='intensity ' 
      axisformat(1)='%6.0f ' 
      axisformat(2)='%8.0f ' 
      nformx=0 
      nformy=0 
    5 continue 
                                                                        
                                                                        
      if(b_12) then 
       kform(1)='f10.4' 
       kform(2)='f12.4' 
       kform(3)='f12.6' 
       kform(4)='f12.6' 
       kform(5)='f10.4' 
       kform(6)='f12.4' 
       kform(7)='f12.4' 
       nformy=2 
      end if 
      if(b_34) then 
       kform(1)='f6.0' 
       kform(2)='f10.0' 
       kform(3)='f8.1' 
       kform(4)='f8.1' 
       kform(5)='f6.0' 
       kform(6)='f10.0' 
       kform(7)='f10.0' 
       nformy=0 
      end if 
      kform(8)=' ' 
                                                                        
                                                                        
      bgcolor='LightYellow'//ch0 
      fgcolor='black'//ch0 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//ch0 
      do j=1,maxsub 
       ncolor(j)=icolor_sub(j) 
      end do 
                                                                        
      nthe=istorTH*2 
      n_subspectra=n_subset 
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=TRIM(name_data)//' \0'
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if        
      if(.not.b_data) title=name_theory 
                                                                        
      isd=nexp/1024 
      if(nexp-isd*1024.gt.0)isd=isd+1 
      if(isd.eq.0)isd=1 
      if(b_data) then 
       do i=1,nexp 
        daty(i)=real_fr(mfpt+i) 
       end do 
       do i=1,nexp 
        erry(i)=real_fr(mdfpt+i) 
       end do 
      end if 
                                                                        
      nresidue=0 
      do ii=1,infplot 
       nchanplot(ii)=0 
      end do 


!    write(6,*)'mfpt=',mfpt                                                                     
!     if(b_theory) then                                                 
!      write(6,'(6g12.3)') (thfk(j),j=1,nexp,16)                         
!     else                                                              
!      write(6,'(8g15.4)') (daty(j),j=1,16)                             
!     end if                                                            
      nyy=0 
      ny=0 
      if(b_12) then 
       if(b_data) then 
        if(ndisplay_mode.eq.1)then 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ny=ny+1 
           plotx(ny)=real_fr(mxpt+j)   !x_exp(j) 
           h=abs(daty(j)) 
           if(h.lt.0.1) then 
            ploty(ny)=0. 
            ploterry(ny)=1. 
            ny=ny-1 
           else 
            ploty(ny)=alog(h) 
            ploterry(ny)=1./erry(j) 
           end if 
          end do 
         end do 
        else 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ny=ny+1 
           plotx(ny)=real_fr(mxpt+j)   !x_exp(j)  
           ploty(ny)=daty(j) 
           ploterry(ny)=erry(j) 
          end do 
         end do 
         if(b_theory)then 
          nresidue=1 
          ns=0 
          do k=2,ichanks(0),2 
           do j=ichanks(k-1),ichanks(k),isd 
            ns=ns+1 
            plotres(ns)=daty(j)-thfk(j) 
           end do 
          end do 
         end if 
        end if 
       end if ! b_data
                                                                        
                                                                        
       if(b_theory) then 
        if(ndisplay_mode.eq.1)then 
         nyy=0 
         do j=ichanks(1)+1,ichanks(ichanks(0)),isd 
          nyy=nyy+1 
          plotxx(nyy)=real_fr(mxpt+j)
          plotyy(nyy)=alog(abs(thfk(j)+0.1)) 
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do ii=1,nyy 
            ns=ns+1 
            plotsub(ns)=alog(abs(subspectrum(ii,j)+0.1)) 
           end do 
          end do 
         end if 
        else 
         nyy=nexp 
         do ii=1,nyy 
          plotxx(ii)=real_fr(mxpt+ii) !  x_exp(ii)  
          plotyy(ii)=thfk(ii) 
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do ii=1,nyy 
            ns=ns+1 
            plotsub(ns)=subspectrum(ii,j) 
           end do 
          end do 
         end if 
        end if 
       end if ! b_theory 
      end if ! log scale  
                                                                        
      if(b_34) then 
       if(b_data) then 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
          ny=ny+1 
          plotx(ny)=j 
          ploty(ny)=daty(j) 
          ploterry(ny)=erry(j) 
          if(daty(j).lt.0.1) ny=ny-1 
         end do 
        end do 
        if(b_theory.and.ndisplay_mode.eq.4)then 
         nresidue=1 
         ns=0 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ns=ns+1 
           plotres(ns)=daty(j)-thfk(j) 
          end do 
         end do 
        end if 
       end if ! b_data
                                                                        
       if(b_theory) then 
        nyy=nexp 
        do ii=1,nyy 
         plotxx(ii)=ii 
         plotyy(ii)=thfk(ii) 
        end do 
        if(n_subspectra.gt.0) then 
         do j=1,n_subspectra 
          ns=(j-1)*max8 
          nchanplot(6+j)=nyy 
          do i=1,nyy 
            ns=ns+1 
            plotsub(ns)=subspectrum(ii,j) 
          end do 
         end do 
        end if 
       end if ! b_theory
      end if  ! counts  
                                                                        
                                                                        
      xmin=1.e30 
      xmax=-xmin 
      ymin=xmin
      ymax=-ymin   ! counts > 0

      if(b_data) then 
       do ii=1,3 
        nchanplot(ii)=ny 
       end do 
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny 
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i) 
       end do 
       do i=1,ny 
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i) 
       end do 
      end if 

      if(b_theory) then 
       nchanplot(5)=nyy 
       nchanplot(6)=nyy 
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy-2 
        if(ymin.gt.plotyy(i))ymin=plotyy(i) 
       end do 
       do i=1,nyy-2 
        if(ymax.lt.plotyy(i))ymax=plotyy(i) 
       end do 
      end if 
                                                                        
      if(nresidue.eq.1) then 
        nchanplot(4)=ny 
        resmin=0. 
        resmax=0. 
        do i=1,ny 
         hd= plotres(i)-ploterry(i) 
         if(resmin.gt.hd) resmin=hd 
        end do 
        do i=1,ny 
         hd= plotres(i)+ploterry(i) 
         if(resmax.lt.hd) resmax=hd 
        end do 
         hd= resmax-2.0*resmin 
        do i=1,ny 
         plotres(i)=plotres(i)+ymax-resmin 
        end do 
        ymax=ymax-resmin+resmax 
      end if 
       xyzdz(1)=xmin 
       xyzdz(2)=xmax 
       xyzdz(3)=ymin 
       xyzdz(4)=ymax 
!       write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax            
                                                                        
!      write(6,'(a,5i8)') 'nchanplot(ii)=',(nchanplot(ii),ii=1,6)       
!      write(6,'(a,3i8)') 'plotx  nyy=',nyy                             
!      write(6,'(8g12.4)') (plotxx(ii),ii=1,nyy,8)                      
!      write(6,'(a,3i8)') 'plotyy  nyy=',nyy                            
!      write(6,'(8g12.4)') (ploty(ii),ii=1,nyy,8)                       
!      write(6,'(a,3i8)') 'ploterry ny=',ny                             
!      write(6,'(8g12.4)') (ploterry(ii),ii=1,ny,8)                     
       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1                                                                        
                                                                        
                                                                        
!      definitions taken from allplo                                    
       chx='b'                 ! (none,Both,bottom,top)  [B]            
       chbx='n'                ! (none,bottom,top)  [n]                 
       chlr='l'                ! (left,right)  [r]                      
       chy='l'                 ! (none,Both,left,right)  [B]            
       chby='l'                ! (none,left,right)  [r]                 
       chbt='b'                ! (bottom,top)  [t]                      
       chh=0.3                 !                                        
       chw=0.25                ! character cw,ch  [0.40,0.40]           
       syw=0.1                 !                                        
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]           
                               ! color frame       [black]              
       frcolor=fgcolor 
       frcolor='blue'//ch0 
       CTEXT=title 
       CXTEXT=abscissa 
       CYTEXT=ordinata 
                                                                        
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
                  chh,chw,syw,syh,                                      &
                  CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)      
                                                                        
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
!  *****************************************************************    
!    Correlation function of susceptibilities in  layers                
!                                                                       
!   	C~+-I*sigma_magn*(ksi*ksi*pi2)/((1+(Qx*ksi)**2)**1.5)              
!  *****************************************************************    
      subroutine correlate(Qx,ksi,sigma,both_plus,C) 
      implicit none 
      logical, intent(in):: both_plus 
      real,    intent(in):: ksi,sigma 
      real(kind=8), intent(in):: Qx 
      real(kind=8):: ksiD,pr,sigmaD,C 
      real(kind=8), parameter:: pi2=atan(1.)*8.d0                                                                   
     
      ksiD=ksi 
      sigmaD=sigma 
      pr=(Qx*ksiD)*(Qx*ksiD) 
      IF (both_plus) then 
       C=sigmaD*(ksiD*ksiD*pi2)/((1.D0+pr)**1.5) 
      ELSE 
       C=-sigmaD*(ksiD*ksiD*pi2)/((1.D0+pr)**1.5) 
      END IF 
!     print *, C                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine n_field(maxl,I_DMAX,NL,b_Cm,MAXGRP,GEOSTR,SQ,K1,       &
     &        Cmatrix,VKD,roughlay,Rmatrix,domain,Tmatrix)              
!***********************************************************************
! This Subroutine calculates Fourier transform (2.12) for each layer when
! domains exists.                                                       
!                                                                       
! Field of incident wave is calculated using Rmatrix for SQ=2k(sin(theta
! K1=k(sin(theta_out)                                                   
!                                                                       
!                                 Budapest 2004,                        
!                                                                       
!                                 Khaidukov Yu                          
!C**********************************************************************
       implicit none 
       integer, intent(in):: maxl,I_DMAX,NL,MAXGRP 
!     NL: number of layers  (in period)                                 
       logical, intent(in),dimension(maxl)    :: b_Cm,domain
       integer, intent(in),dimension(0:2*maxl):: GEOSTR
       real,        intent(in):: SQ
       real(kind=8),intent(in):: K1 
       complex,intent(in),dimension(2,2,maxl):: Cmatrix
       real,   intent(in),dimension(maxl)    :: VKD,roughlay
       complex,intent(in),dimension(2,2)     :: Rmatrix
                                                                        
       complex, intent(out),dimension(2,2,I_DMAX):: Tmatrix

!**************************************                                 
       integer    I,J,L,n_rep,GRP,LMIN,LMAX,POINTER,I_D 
       complex(kind=8),dimension(2,2):: T 
       complex(kind=8),dimension(4,4):: M,ML
       complex(kind=8),dimension(2,2):: A,B,KLprev,KL,R
       real   (kind=8):: QD, DL 
       real    absCmatr
       logical b_odz,b_first,b_grp 
!********* Variables added by Khaidukov for neutron case                
      integer Lprev,Lnext,n 
      logical prev_dgnl,both_dgnl,both_NONdgnl 
      real(kind=8):: DabsMatr,z1,z2 
                                                                        
      complex(kind=8),parameter:: C0=(0.D0,0.D0), C1=(1.D0,0.D0), &
                                  CI=(0.D0,1.D0) 
      complex,parameter:: cz=(0.0,0.0)
      real,   parameter:: VKDMAX=7.30416e4 
       
                                                                        
       QD=dble(SQ)*0.5D0 
       R= Rmatrix                                                               
       b_first=.true. 
                                                                        
!       To set the characteristic matrix to unit matrix                 
       ML=C0
       do I=1,4
        ML(I,I)=C1 
       end do 
                                                                        
      I_D=0 
                                                                        
      POINTER=0 
      z1=0.0D0  !First 
      z2=0.0D0  !and the second coordinate for each layer  
                                                                        
       do GRP=1,MAXGRP      ! loop for the groups 
        b_grp=.false. 
        LMIN =POINTER+1 
        LMAX =POINTER+GEOSTR(2*GRP) 
        n_rep=GEOSTR(2*GRP-1) 
        n=1 
        DO WHILE (n.LE.n_rep) 
         n=n+1 
         do L=LMIN,LMAX 
         if(VKD(L).gt.0.and.VKD(L).lt.1.e30) then 
!         b_odz=.false.                                                
          b_odz=.not.b_Cm(L) 
          b_grp=.true. 
          DL=VKD(L) 
                                                                        
          z2=z1+DL 
          KL(1,1)=Cmatrix(1,1,L) 
          KL(1,2)=Cmatrix(1,2,L) 
          KL(2,1)=Cmatrix(2,1,L) 
          KL(2,2)=Cmatrix(2,2,L) 
          absCmatr=real(Cmatrix(1,2,L)*conjg(Cmatrix(1,2,L))+         &
                        Cmatrix(2,1,L)*conjg(Cmatrix(2,1,L)))         
          if(absCmatr.lt.1.e-15) b_odz=.true. 
                                                                        
          IF (domain(L)) THEN !If there are domains in this layer store
           call trans(QD,KL,R,ML,A,B)  ! A ne M li dolzno bit vmest ML?
           call nanalytic_fourier(z1,z2,QD,K1,KL,A,B,T) 
           I_D=I_D+1 
           Tmatrix(1,1,I_D)=T(1,1) 
           Tmatrix(1,2,I_D)=T(1,2) 
           Tmatrix(2,1,I_D)=T(2,1) 
           Tmatrix(2,2,I_D)=T(2,2) 
          END IF  ! Domains 
          call genM(b_odz,QD,DL,KL,M) 
                                                                        
!************* Roughness************                                    
          IF (roughlay(L).GT.0) THEN 
           if (n_rep.GT.1.and.L.eq.Lmin) then  ! In case of repeating layers
            ! we are more interested in the information about roughnesses
            ! in repeated ones. #Khaidukov
            Lprev=Lmax                         
           else                                
           Lprev=L-1 
          END IF 
          if(n_rep.GT.1.and.L.eq.LMAX) then
           ! For peiodical structure the rougness is also periodical!
           ! The next layer to the last element is the first layer
           Lnext=LMIN 
          else 
           Lnext=L+1 
           if(Lnext.gt.NL) Lnext=NL 
          end if 
          DO I=1,2 
           DO J=1,2 
            IF (Lprev.EQ.0) THEN 
             KLprev(I,J)=C0      ! In case of 1st layer KLprev is for vacuum
             prev_dgnl=.true. 
            END IF 
            IF (Lprev.GT.0) THEN 
             KLprev(I,J)=Cmatrix(I,J,Lprev) 
             prev_dgnl=.not.b_Cm(Lprev) 
            ENDIF 
           END DO 
          END DO 
                                                                        
          DabsMatr= dreal(KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+ &
                         (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1)))  
          IF(prev_dgnl.and.b_odz) then 
             both_dgnl=.true.                 ! Rohlsberger roughness1     
             both_NONdgnl=.false.                                      
            ELSEIF (DabsMatr.lt.1.e-15) then                         
           both_dgnl=.true.                   ! Rohlsberger roughness1       
           both_NONdgnl=.false.                                         
          ELSEIF (.not.prev_dgnl.and..not.b_odz) then 
           both_dgnl=.false.                                        
           both_NONdgnl=.true.               ! Deak's roughness               
          ELSE                    
           both_dgnl=.false.                 ! Rohlsberger roughness2   
           both_NONdgnl=.false. 
          ENDIF 
                                                                        
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      
!           both_dgnl=.false. 	  !DONT FORGET TO REMOVE!!!!!!!!!        
!           both_NONdgnl=.TRUE.	  !Deak's roughness                     
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      
                                                                        
            call roughness(both_dgnl,both_NONdgnl,                      &
                           roughlay(L),roughlay(Lnext),QD,KLprev,KL,M)     
           END IF !Roughness 
           call mat4(M,ML,ML)                                           
          end if  ! VKD(L) > 0.                                       
         z1=z2                                                          
         end do   ! L                                                      
       END DO     ! while                                                       
        POINTER=POINTER+GEOSTR(2*GRP)                                   
       end do     ! GRP                                                        
       return                                                           
      END                                           
                                                                        
! **********************************************************************
! Subroutines calculate integral (exp(ikz)*A+exp(-ikz)B)*exp(-ik'z)dz   
! in the interval from z1 to z2                                         
! **********************************************************************
                                                                        
      subroutine nanalytic_fourier(z1,z2,QD,K1,KL,A,B,T) 
      implicit none 
      real(kind=8),   intent(in)                :: z1,z2,QD,K1
      complex(kind=8),intent(in), dimension(2,2):: KL,A,B
      complex(kind=8),intent(out),dimension(2,2):: T 

      complex(kind=8):: iz1,iz2
      complex(kind=8),dimension(2,2):: DM1,K,DMA,DMB,                 &
                                       DMA1,DMB1,DMA2,DMB2,DMAS,DMBS,DMAA,DMBB 
      real(kind=8) :: Kz2                         
      complex(kind=8),parameter :: const=cmplx(0.d0,1.d0/2.50662827 )
                                !  const=1/i*sqrt(2*pi) 
      integer    I,J 
                                                                        
      iz1=cmplx(0.d0,z1) 
      iz2=cmplx(0.d0,z2) 
      Kz2=QD*QD 
                                                                        
      DM1(1,1)=KL(1,1)+Kz2 
      DM1(1,2)=KL(1,2)             !DM1=Ko**2+KL 
      DM1(2,1)=KL(2,1) 
      DM1(2,2)=KL(2,2)+Kz2 
                                                                        
      call sqrt2(DM1,K)   ! K=sqrt(Ko**2+KL)- z component of incoming wa
      DO I=1,2            ! in the given layer     
       DO J=1,2  
        DMA(I,J)=K(I,J) 
        DMB(I,J)=K(I,J) 
       END DO 
       DMA(I,I)=K(I,I)-K1 !DMA=K-K1
       DMB(I,I)=K(I,I)+K1 !DMB=K+K1 
      END DO 
      DO I=1,2 
       DO J=1,2 
        DMA1(I,J)= iz1*DMA(I,J)       ! DMA1= i*z1*(K-K1)               
        DMA2(I,J)= iz2*DMA(I,J)       ! DMA1= i*z2*(K-K1)               
        DMB1(I,J)=-iz1*DMB(I,J)       ! DMB1=-i*z1*(K+K1)               
        DMB2(I,J)=-iz2*DMB(I,J)       ! DMB2=-i*z2*(K+K1)               
       END DO 
      END DO 
                                                                        
      call exp2(DMA1)    ! DMA1=exp(i*z1*(K-K1))                        
      call exp2(DMA2)    ! DMA2=exp(i*z2*(K-K1))                        
      call exp2(DMB1)    ! DMB1=exp(-i*z1*(K+K1))                       
      call exp2(DMB2)    ! DMB2=exp(-i*z2*(K+K1))                        

                                                                        
      DO I=1,2 
       DO J=1,2 
        DMAS(I,J)=DMA2(I,J)-DMA1(I,J) ! DMAS=exp(i*z2*(K-K1))-exp(i*z1*)
        DMBS(I,J)=DMB1(I,J)-DMB2(I,J) ! DMBS=exp(-i*z1*(K+K1))-exp(-i*z2)
       END DO 
      END DO 
                                                                        
      call inv2(DMA,DMAA)   ! DMAA=[K-K1]**-1                             
      call inv2(DMB,DMBB)   !DMBB=[K+K1]**-1                             
      call mat2(DMAA,A,DMA) !DMA=([K-K1]**-1)*A                         
      call mat2(DMBB,B,DMB) !DMB=([K+K1]**-1)*B                         
      call mat2(DMAS,DMA,DMAA) 
!     DMAA=[exp(i*z2*(K-K1))-exp(i*z1*(K-K1))]*([K-K1]**-1)*A           
      call mat2(DMBS,DMB,DMBB) 
!     DMBB=[exp(-i*z1*(K+K1))-exp(-i*z2*(K+K1))]*([K+K1]**-1)*B         
                                                                        
      DO I=1,2 
       DO J=1,2 
        T(I,J)=(DMAA(I,J)+DMBB(I,J))*const 
       END DO 
      END DO 
      return 
      END                                           
                                                                        
                                                                        
!*******************************************************************    
       subroutine n_optics(mlay,MAXGRP,GEOSTR,b_Bfield,Hextz,Cmatrix,   &
                           thicklayer,roughlay,SSQ,b_up,b_down,Rmatrix)      
                                                                        
!                               OPTICS                                  
!                                                                       
!          Reflectivity calculation of anizotropic multilayers          
!          in the Neutron case.                                         
!                                                                       
!          (method of G. H. Borzbov et. al. - L. Deak et. al.)          
!                                                                       
!                         Laszlo Deak, Hartmut Spiering                 
!                                                                       
!                         Budapest, 2000. December                      
!				                                                                   
!		           Khaidukov Yuri                                            
!                                                                       
!                         Budapest, 2004, September                     
! *****************************************************************     
! Geometry:                                                             
!               incident        reflected                               
!                        \    /                                         
!                         \  /                                          
!                      FI (\/                                           
!      Z=0>           -------------                                     
!           covering  _____________         [D(1),K(1,I,J)]             
!                                  >Layer#1 [D(2),K(2,I,J)]             
!                 1.  .............                                     
!                           .                                           
!                           .                                           
!                     .............                                     
! Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]       
!       I                                                               
!          substrate  _____________         [D(NL),K(NL,I,J)]           
!                            `                 ^                        
!                              `            infinit or finit            
!                             refracted                                 
!                                                                       
!  Variables of system:                                                 
!  INPUT:                                                               
!                           covering   layer #L     substrate           
!                                                                       
!            thickneses:         D(1)     D(L)        D(NL)             
!        susceptibility:                                                
!        (nuclear+electronic)    K(1)     K(L)        K(NL)     
!
!         where  L=1..NL  I,J=1,2,3                                     
!                                                                       
!  OUTPUT:                                                              
!         The 2x2 complex reflectivity (or transmitivity) matrix:  R    
!       subroutine n_optics(mlay,MAXGRP,GEOSTR,b_Bfield,Hextz,Cmatrix,   &
!                           thicklayer,roughlay,SSQ,b_up,b_down,Rmatrix) 
! ******************************************************************    
       implicit none 
       integer, intent(in):: mlay,MAXGRP 
       integer, intent(in), dimension(0:2*mlay):: GEOSTR
       logical, intent(in), dimension(mlay)    :: b_Bfield
       real(kind=8),intent(in):: Hextz,SSQ 
       complex(kind=8), intent(in),dimension(2,2,mlay):: Cmatrix
       real(kind=8),    intent(in), dimension(mlay)   :: thicklayer,roughlay 
       logical,         intent(in)                    :: b_up,b_down 

       complex(kind=8), intent(out),dimension(2,2):: Rmatrix
                                                                        
       real(kind=8):: DL,Hext4,QP,QD,DabsMatr 
       logical    b_odz,b_first,b_grp,prev_dgnl,both_dgnl,both_NONdgnl 
       integer    I,J,L,GRP,LMIN,LMAX,Lprev,POINTER,Lnext,NLOG,n_rep,NL 
       real       absCmatr,absC1,absC2

       complex(kind=8):: Q                                                                 
       complex(kind=8),dimension(4,4):: M,ML,MS
       complex(kind=8),dimension(2,2):: KL,Gamma,KLprev,UnMAT                     
                                
       complex(kind=8),parameter :: C0=(0.D0,0.D0), C1=(1.D0,0.D0),&
                                    CI=(0.D0,1.D0)
       real,parameter:: level=1.E17                                          
!**************************************                                 
       NL=mlay 
       UnMat(1,1)=C1 !Unit matrix 
       UnMat(1,2)=C0 
       UnMat(2,1)=C0 
       UnMat(2,2)=C1 
                                                                        
       QD=dble(SSQ) 
       Q =dcmplx(QD,0.D0) 
                                                                        
       Gamma(1,1)=C1 
       Gamma(1,2)=C0 
       Gamma(2,1)=C0 
       Gamma(2,2)=C1 ! no analizator
                                                                        
       if(b_up)then 
        Hext4=4.D0*dble(Hextz) 
        QP=QD*QD-Hext4 
        if(QP.ge.0.D0)then 
          Q= dcmplx(sqrt(QP),0.D0) 
!          write(6,'(2E16.3)')Q                                         
        else 
          Q= dcmplx(0.D0,-sqrt(-QP)) 
!          write(6,'(2E16.3)')Q                                         
        end if 
        if(QP-Hext4.ge.0.D0)then 
          Gamma(1,1)=dcmplx(QD/dble(Q),0.D0) 
          Gamma(2,2)=dcmplx(sqrt(QP-Hext4)/dble(Q),0.D0) 
        else 
         if(QP.ge.0.D0)then 
           Gamma(1,1)=dcmplx(QD/dble(Q),0.D0) 
           Gamma(2,2)=dcmplx(0.D0,-sqrt(Hext4-QP)/dble(Q)) 
         else 
           Gamma(1,1)=dcmplx(0.D0,-QD/dimag(Q)) 
           Gamma(2,2)=dcmplx(-sqrt(Hext4-QP)/dimag(Q),0.D0) 
         end if 
        end if 
!       write(6,*)SSQ,Gamma(1,1)*Gamma(2,2)                             
        Gamma(1,2)=C0 
        Gamma(2,1)=C0 ! we measure the '+' beam 
       end if 
                                                                        
       if(b_down)then 
        Hext4=4.D0*dble(Hextz) 
        QP=Hext4/(QD*QD+Hext4) 
        Q=sqrt(dcmplx(QD*QD+Hext4,0.D0)) 
        Gamma(1,1)=sqrt(C1+dcmplx(QP,0.D0)) 
        Gamma(1,2)=C0 
        Gamma(2,1)=C0 
        Gamma(2,2)=sqrt(C1-dcmplx(QP,0.D0)) 
!       write(6,*)SSQ,Gamma(2,2),Q                                      
       end if         ! we measure the '-' beam     

       b_first     =.true. 
       POINTER=0 
       do GRP=1,MAXGRP      ! loop for the groups  
!       To set the characteristic matrix to unit matrix                 

        ML=C0
        do I=1,4 
         ML(I,I)=C1 
        end do 
        b_grp=.false. 
        LMIN =POINTER+1 
        LMAX =POINTER+GEOSTR(2*GRP) 
        n_rep=GEOSTR(2*GRP-1) 
        do L=LMIN,LMAX 
         if(thicklayer(L).gt.0.) then 
!         b_odz=.false.                                                 
          b_odz=.not.b_Bfield(L) 
          b_grp=.true. 
          DL=thicklayer(L) 
          KL(1,1)=Cmatrix(1,1,L) 
          KL(1,2)=Cmatrix(1,2,L) 
          KL(2,1)=Cmatrix(2,1,L) 
          KL(2,2)=Cmatrix(2,2,L) 
                                                                        
          absCmatr=real(dble(KL(1,2)*dconjg(KL(1,2))+                   &
                             KL(2,1)*dconjg(KL(2,1))))                     
          absC1=real(dble(KL(1,1)*dconjg(KL(1,1))+                      &
                          KL(2,2)*dconjg(KL(2,2))))                     
          absC2=absCmatr*level 
          if(absC1.gt.absC2) then 
           b_odz=.true. 
          end if 
          call genM(b_odz,QD*0.5D0,DL,KL,M) 
!************* Roughness************                                    
          IF (roughlay(L).GT.0) THEN           ! In case of repeating layers
            ! we are more interested in the information about roughnesses
            ! in repeated ones. #Khaidukov
           if (n_rep.GT.1.and.L.eq.Lmin) then   
             Lprev=LMAX                       
           else                               
            Lprev=L-1 
           END IF 
           if(n_rep.GT.1.and.L.eq.LMAX) then 
           ! For peiodical structure the rougness is also periodical!
           ! The next layer to the last element is the first layer
            Lnext=LMIN          
           else               
            Lnext=L+1         
            if(Lnext.gt.NL) Lnext=NL 
           end if 
           DO I=1,2 
            DO J=1,2 
             IF (Lprev.EQ.0) THEN 
              KLprev(I,J)=C0     ! In case of 1st layer KLprev is for va
              prev_dgnl=.true. 
             END IF 
             IF (Lprev.GT.0) THEN 
              KLprev(I,J)=Cmatrix(I,J,Lprev) 
              prev_dgnl=.not.b_Bfield(Lprev) 
             ENDIF 
            END DO 
           END DO 
                                                                        
           DabsMatr=dble((KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+   &
                         (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1))))   
                                                                        
                                                   !                    
           IF (prev_dgnl.and.b_odz) then 
            both_dgnl=.true.      ! Rohlsberger roughness1 
            both_NONdgnl=.false. 
           ELSEIF (DabsMatr.lt.1.e-15) then 
            both_dgnl=.true.      ! Rohlsberger roughness1 
            both_NONdgnl=.false. 
           ELSEIF (.not.prev_dgnl.and..not.b_odz) then 
            both_dgnl=.false. 
            both_NONdgnl=.true.     ! Deak's roughness 
           ELSE 
            both_dgnl=.false.       ! Rohlsberger roughness2 
            both_NONdgnl=.false. 
           ENDIF 
!-----------------------------------------------------------------------
!          both_dgnl=.false. 		!DONT FORGET TO REMOVE!!!!!!!!!          
!          both_NONdgnl=.TRUE.		!Deak's roughness                       
!-----------------------------------------------------------------------
           call OSroughness(both_dgnl,both_NONdgnl,                     &
                 roughlay(L),roughlay(Lnext),QD*0.5D0,KLprev,KL,M)     
          END IF !Roughness
                                                                        
          call mat4(M,ML,ML)                                            
         endif                                                          
        end do                                                          
                                                                        
!       For periodic multilayers the int. propagation matrix is (ML)**n_
!       where n_rep is the number of periods.                           
                                                                        
        if(n_rep.gt.1.and.b_grp)then                                    
         do I=1,4                                                       
          do J=1,4                                                      
           M(I,J)=ML(I,J)                                               
          end do                                                        
         end do                                                         
         NLOG=alog(float(n_rep))/alog(2.0)                              
         do I=1,NLOG                                                    
          call mat4(ML,ML,ML)                                           
         end do                                                         
         do I=1,n_rep-2**NLOG                                           
          call mat4(M,ML,ML)                                            
         end do                                                         
        end if                                                          
                                                                        
        if(b_first) then                                                
         b_first=.false.                                                
         do I=1,4                                                       
          do J=1,4                                                      
           MS(I,J)=ML(I,J)                                              
          end do                                                        
         end do                                                         
        else                                                            
         call mat4(ML,MS,MS)                                            
        end if                                                          
        POINTER=POINTER+GEOSTR(2*GRP)                                   
       end do                                                           
                                                                        
!      Now we have the integreted propagation matrix of the structure: M
!      Calculation of reflectivity matrix (2x2):                        
       call refl(MS,Rmatrix)                                            
       return                                                           
      END                                           
                                                                        
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
                                                                        
      subroutine OSroughness(both_dgnl,both_NONdgnl,                    &
                                          sigma1,sigma2,A0,A1,A2,M)    
! ******************************************************************    
                                                                        
!  This subroutine updates integrated matrix of distibution with roughne
!	 the top border of a given layer.                                     
!      M->Mupd, where Mupd=exp(sigma**2)*[W1,W2]*0.5*M. For the details 
!      R. Rohlsberger, Hyperfine Inreractions 123/124 (1999) 301-325    
!      ------------------------------------------------------------     
!	 Differential matrix of distribution is  represented like             
!		      0		  I*Ao+Ai/Ao                                    
!      Wi   =	                                                          
!                     I*Ao         0                                    
                                                                        
!      ---------------------------------------------------------------  
      implicit none 
!     Input variables	                                                  
      logical,      intent(in):: both_dgnl,both_NONdgnl 
      real(kind=8), intent(in):: sigma1,sigma2,A0 
      complex(kind=8),intent(in),dimension(2,2):: A1,A2                      
      complex(kind=8), intent(out),dimension(4,4):: M

      complex(kind=8), dimension(4,4):: Mupd                                    
      complex(kind=8), dimension(2)  :: exp_scalar,C_scal,dA_scal
      complex(kind=8), dimension(2,2):: exp_Dp,exp_Dm,C,dA,TMP,C2,AA,BB,CC,DD
      real   (kind=8)::  sigmaD1,sigmaD2,R2min,R2plu 
      integer I,J,K 

      complex(kind=8), parameter:: C1=(1.D0,0.D0), C0=(0.D0,0.D0) 
                                                                        
      sigmaD1=sigma1 !RMS roughness at the upper border of the layer 
      sigmaD2=sigma2 !RMS roughness at the down border of the layer
                                                                        
      IF (both_dgnl.and..not.both_NONdgnl)  then !Both layers are non re
         DO I=1,2 
          dA_scal(I)=A2(I,I)-A1(I,I) 
          C_scal(I) =2.D0*(2.D0*A0*A0+A2(I,I)+A1(I,I)) 
                     exp_scalar(I)=dA_scal(I)*(C1/C_scal(I))*           &
                     (-exp(-0.5D0*sigmaD1*sigmaD1*C_scal(I))+C1)        
          exp_scalar(I)=exp(exp_scalar(I)) 
!          exp_scalar(I)=exp(dA(I)*(C1/C_scal(I))* &                          
!          (exp(0.5D0*sigmaD*sigmaD*C_scal(I))-C1))                         
         END DO 
                                                                        
         DO J=1,4 
          Mupd(J,1) =  exp_scalar(1)*M(J,1) 
          Mupd(J,2) =  exp_scalar(2)*M(J,2) 
          Mupd(J,3) =  (C1/exp_scalar(1))*M(J,3) 
          Mupd(J,4) =  (C1/exp_scalar(2))*M(J,4) 
         END DO 

       ELSE IF(.not.both_dgnl.and..not.both_NONdgnl)then  !One of the layers
                                                          ! is resonant
         C(1,1)=2.D0*(2.D0*A0*A0+A1(1,1)+A2(1,1))         !C=2*(2A0+A1+A2)  
         C(2,2)=2.D0*(2.D0*A0*A0+A1(2,2)+A2(2,2)) 
         C(1,2)=2.D0*(A1(1,2)+A2(1,2)) 
         C(2,1)=2.D0*(A1(2,1)+A2(2,1)) 
                                                                        
         DO I=1,2 
          DO J=1,2 
           dA(I,J)=A2(I,J)-A1(I,J)                  !dA=A2-A1   
           TMP(I,J)=-0.5D0*sigmaD1*sigmaD1*C(I,J)   !TMP=-0.5*sigma**2*C
          END DO 
         END DO 
                                                                        
         call exp2(TMP)              !TMP=exp(-0.5*sigma**2
         call inv2(C,C2)             !C2=1/C                                 
         call mat2(dA,C2,C2)         !C2=dA*1/C                          
         TMP(1,1)=C1-TMP(1,1)                                           
         TMP(1,2)=-TMP(1,2)       
         TMP(2,1)=-TMP(2,1)          !TMP=I-exp(-0.5*sigma**
         TMP(2,2)=C1-TMP(2,2)     
         call mat2(C2,TMP,exp_Dp)    !expDp=dA*1/C*(I-exp(-0.5*sigma**2*
         call exp2(exp_Dp)           !expDp=exp(dA*1/C*(I-exp(-0.5*sigma**2*C)))
         call inv2(exp_Dp,exp_Dm) 
!        The 'roughness' matrix has form:	                              
!        	       	                     (   exp_Dp        0  )        
!        exp(W)=exp(sigma**2)*[W1,W2]*0.5 =  (   0        exp_Dm  )       
         DO I=1,2 
          DO J=1,2 
           Mupd(I,J)     = C0 
           Mupd(I,J+2)   = C0 
           Mupd(I+2,J)   = C0 
           Mupd(I+2,J+2) = C0 
           DO K=1,2 
            Mupd(I,J)     = Mupd(I,J)    +  M(I,K)*exp_Dp(K,J) 
            Mupd(I,J+2)   = Mupd(I,J+2)  +  M(I,K+2)*exp_Dm(K,J) 
            Mupd(I+2,J)   = Mupd(I+2,J)  +  M(I+2,K)*exp_Dp(K,J) 
            Mupd(I+2,J+2) = Mupd(I+2,J+2)+  M(I+2,K+2)*exp_Dm(K,J) 
           END DO 
          END DO 
         END DO 
       ELSE IF (.not.both_dgnl.and.both_NONdgnl)  then !Both layers are 
! print *, 'Deak'						 
        R2min=(sigmaD1**2-sigmaD2**2)/2.D0 
        R2plu=(sigmaD1**2+sigmaD2**2)/2.D0 
        do I=1,2 
         do J=1,2 
          AA(I,J)= M(I,J) 
          BB(I,J)= M(I,J+2) 
          CC(I,J)= M(I+2,J) 
          DD(I,J)= M(I+2,J+2) 
         end do 
        end do 
        call mat2(AA,A2,AA) 
        call mat2(BB,A2,BB) 
        call mat2(CC,A2,CC) 
        do I=1,2 
         do J=1,2 
          Mupd(I,J)    = M(I,J)+R2min*AA(I,J) 
          Mupd(I,J+2)  = M(I,J+2)-R2plu*BB(I,J) 
          Mupd(I+2,J)  = M(I+2,J)+R2plu*CC(I,J) 
          Mupd(I+2,J+2)= M(I+2,J+2)-R2min*AA(I,J) 
         end do 
        end do 
       END IF   !Both are resonant
   
       M=MUPD
       return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
! **********************************************************************
!	Subroutine calculates (3.8) expression.Output Gamma(E,l,i,j) for both 
!	kind of domains                                                       
! **********************************************************************
                                                                     
    subroutine energy_trndwba(DWBA,mlay,lay_domain,MAXGRP,GEOSTR,    &
                       b_Bfield,b_domain,eta_domain,K_mag_lay,       &
                       scatlength,thicklayer,rough,SQ,K1,G_mjv)                            
     implicit none 
                                                                     
     logical, intent(in):: DWBA 
     integer, intent(in):: mlay,lay_domain,MAXGRP
     integer, intent(in),dimension(0:2*mlay):: GEOSTR
     logical, intent(in),dimension(mlay)    :: b_Bfield,b_domain
     real(kind=8),intent(in)                :: eta_domain
     complex(kind=8),intent(in),dimension(2,2,mlay):: K_mag_lay
     complex(kind=8),intent(in),dimension(mlay)    :: scatlength
     real(kind=8),   intent(in),dimension(mlay)    :: thicklayer,rough
     real(kind=8),   intent(in)                    :: SQ,K1

     complex(kind=8),intent(out),dimension(2,2,2,lay_domain):: G_mjv


     complex(kind=8),dimension(2,2,mlay)      :: Fmatrix_cur,AFmatrix_cur
     complex(kind=8),dimension(lay_domain)    :: Fouphase
     complex(kind=8),dimension(2,2,lay_domain):: C_pls,C_mns
     complex(kind=8),dimension(2,2,lay_domain)::                     &
                              L1matrix,R1matrix,L2matrix,R2matrix,   &
                              L3matrix,R3matrix,L4matrix,R4matrix            
     complex(kind=8),dimension(2,2):: HI_plus,HI_minus,              &
                 L1,R1,L2,R2,L3,R3,L4,R4,C_p,C_M,INT1,INT2,INT3,INT4,&
                 Rmatrix,ARmat,ARmatrix 
                                                  
     integer     L,classPOINTER,GRP,LMIN,LMAX,N_rep,N,ll,ii,I,J,I1,J1 
     real(kind=8),dimension(2):: coef
     real(kind=8)             :: k,Fi_fin,Fi_inc,SQP 
     complex(kind=8)          :: hpm 
     complex(kind=8),parameter:: C0=(0.D0,0.D0) 
                                                                       
!---------------Body of program                                         
                                                                        
                   ! DWBA approximation                                 
      if(DWBA)then 
!       write(*,'(a)')'DWBA'                                            
       coef(1)=1.D0-eta_domain 
       coef(2)=eta_domain 
                                                                        
       DO ii=1,mlay 
         Fmatrix_cur(1,1,ii) =+scatlength(ii) 
         Fmatrix_cur(1,2,ii)=(0.d0,0.d0) 
         Fmatrix_cur(2,1,ii)=(0.d0,0.d0) 
         Fmatrix_cur(2,2,ii) =+scatlength(ii) 
        IF (b_domain(ii)) THEN ! =eta 
         coef(1)=1.D0-coef(1) 
         coef(2)=1.D0-coef(2)  ! =1-eta 
         DO I1=1,2 
          DO J1=1,2 
           Fmatrix_cur(I1,J1,ii) =Fmatrix_cur(I1,J1,ii)+                &
                         (coef(1)-coef(2))*K_mag_lay(I1,J1,ii)         
           hpm=2.d0*K_mag_lay(I1,J1,ii) 
           C_pls(I1,J1,ii)= coef(2)*hpm 
           C_mns(I1,J1,ii)=-coef(1)*hpm 
          END DO 
!          Fmatrix_cur(I1,I1,ii) = Fmatrix_cur(I1,I1,ii)+scatlength(ii) 
         END DO 
        END IF 
                                                                        
        DO I1=1,2 
         DO J1=1,2 
          AFmatrix_cur(J1,I1,ii)=Fmatrix_cur(I1,J1,ii) 
         END DO 
        END DO 
       END DO 
                                                                        
       call n_optics(mlay,MAXGRP,GEOSTR,b_Bfield,0.0d0, Fmatrix_cur,    &
                    thicklayer,rough, 2.D0*SQ,.false.,.false.,Rmatrix) 
                                                                        
       call n_optics(mlay,MAXGRP,GEOSTR,b_Bfield,0.0d0,AFmatrix_cur,    &
                    thicklayer,rough,-2.D0*K1,.false.,.false.,ARmatrix)
       call g_fndwba(mlay,lay_domain,MAXGRP,GEOSTR,                     &
                     b_Bfield,b_domain,thicklayer,rough,SQ,K1,          &
                     Fmatrix_cur, AFmatrix_cur,                         &
                     Rmatrix,ARmatrix,                                  &
                            L1matrix,R1matrix,                          &
                            L2matrix,R2matrix,                          &
                            L3matrix,R3matrix,                          &
                            L4matrix,R4matrix)                          
       ll=0 
!       G_mjv1 matrix filling (for plus domains                         
       classPOINTER=0 
       do GRP=1,MAXGRP 
        LMIN =classPOINTER+1 
        LMAX =classPOINTER+GEOSTR(2*GRP) 
        n_rep=GEOSTR(2*GRP-1) 

        n=1 
        DO WHILE (n.LE.n_rep) 
       n=n+1 
         do L=LMIN,LMAX 
          IF (b_domain(L)) THEN 
         ll=ll+1 
!----Calculation of the  G_mjv matrixes -----                           
           do I=1,2 
            do J=1,2 
             C_P(I,J)=C_pls(I,J,L) 
             C_M(I,J)=C_mns(I,J,L) 
             L1(I,J)= L1matrix(I,J,ll) 
             R1(I,J)= R1matrix(I,J,ll) 
             L2(I,J)= L2matrix(I,J,ll) 
             R2(I,J)= R2matrix(I,J,ll) 
             L3(I,J)= L3matrix(I,J,ll) 
             R3(I,J)= R3matrix(I,J,ll) 
             L4(I,J)= L4matrix(I,J,ll) 
             R4(I,J)= R4matrix(I,J,ll) 
            end do 
           end do 
! plus domains:                                                         
           call mat2x3(L1,C_P,R1,INT1) 
           call mat2x3(L2,C_P,R2,INT2) 
           call mat2x3(L3,C_P,R3,INT3) 
           call mat2x3(L4,C_P,R4,INT4) 
                                                                        
           do I=1,2 
            do J=1,2 
             G_mjv(I,J,1,ll)=INT1(I,J)+INT2(I,J)+INT3(I,J)+INT4(I,J) 
            end do 
           end do 
! minus domains:                                                        
           call mat2x3(L1,C_M,R1,INT1) 
           call mat2x3(L2,C_M,R2,INT2) 
           call mat2x3(L3,C_M,R3,INT3) 
           call mat2x3(L4,C_M,R4,INT4) 
                                                                        
           do I=1,2 
            do J=1,2 
             G_mjv(I,J,2,ll)=INT1(I,J)+INT2(I,J)+INT3(I,J)+INT4(I,J) 
            end do 
           end do 
                                                                        
!--------------------------------------------                           
          END IF ! L  
         end do  ! while
        END DO 
        classPOINTER=classPOINTER+GEOSTR(2*GRP) 
       end do !over GRP 
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
      else   ! Born approximation 
                                                                        
       SQP=-k*(sin(Fi_inc)+sin(Fi_fin)) 
       coef(1)=1.D0-eta_domain 
       coef(2)=eta_domain 
                                                                        
       DO ii=1,mlay 
        IF (b_domain(ii)) THEN 
         coef(1)=1.D0-coef(1) 
         coef(2)=1.D0-coef(2) 
         DO I1=1,2 
          DO J1=1,2 
           C_pls(I1,J1,ii)=coef(2)*(HI_plus(I1,J1)                      &
                                     -HI_minus(I1,J1))                 
           C_mns(I1,J1,ii)=coef(1)*(HI_minus(I1,J1)                     &
                                      -HI_plus(I1,J1))                 
          END DO 
         END DO 
        END IF 
       END DO 
       call g_phase(mlay,lay_domain,MAXGRP,GEOSTR,b_domain,             &
                           thicklayer,SQP,Fouphase)                     
                                                                        
!      Output Fourier of field inside the structure.See (2.12) expression    
       ll=0 
!      G_mjv1 matrix filling (for plus domains                         
       classPOINTER=0 
       do GRP=1,MAXGRP 
        LMIN =classPOINTER+1 
        LMAX =classPOINTER+GEOSTR(2*GRP) 
        n_rep=GEOSTR(2*GRP-1) 
!                                                                       
        n=1 
        DO WHILE (n.LE.n_rep) 
         n=n+1 
         do L=LMIN,LMAX 
          IF (b_domain(L)) THEN 
           ll=ll+1 
!-----------------Place where G_mjv matrixes are filling----------------
           do I=1,2 
            do J=1,2 
               ARmat(I,J)=C_pls(I,J,L) 
            end do 
           end do 
!          call mat2(sqrhoA,ARmat,ARmat)                               
!          call mat2(ARmat,sqrhoP,ARmat)                               
           do I=1,2 
            do J=1,2 
             G_mjv(I,J,1,ll)=ARmat(I,J)*Fouphase(ll) 
            end do 
           end do 
                                                                        
           do I=1,2 
            do J=1,2 
               ARmat(I,J)=C_mns(I,J,L) 
            end do 
           end do 
!          call mat2(sqrhoA,ARmat,ARmat)                               
!          call mat2(ARmat,sqrhoP,ARmat)                               
           do I=1,2 
            do J=1,2 
             G_mjv(I,J,2,ll)=ARmat(I,J)*Fouphase(ll) 
            end do 
           end do 
!-----------------END OF place where G_mjv matrixes are filling---------
          END IF ! L   
         end do  ! while
        END DO 
        classPOINTER=classPOINTER+GEOSTR(2*GRP) 
       end do !over GRP 
      end if 

      return 
      END                                           
                                                                        
                                                                        
     subroutine energy_diffuse(mlay,lay_domain,MAXGRP,GEOSTR,b_domain, &
                               eta,G_mjv,prho,arho,Idiff)              
                                                                        
!*******************************************************************    
!                               OPTICS                                  
!                                                                       
!          Calculation of intensity of diffuse scattering for           
!		 magnetic domain roughness. Black-n-white                            
!          non-correlated domains, x-ray case, energy domains           
!                                                                       
!          (method of G. H. Borzbov et. al. - L. Deak et. al.)          
!                                                                       
!						Khaidukov Yuri                                                   
!                                                                       
!                         Budapest, 2003. May                           
!	                    Budapest, 2003. November                          
! *****************************************************************     
!                                                                       
! Geometry:                                                             
!                                                                       
!                                                                       
!               incident        reflected                               
!                                                                       
!                        \    /                                         
!                         \  /                                          
!                  FI_inc (\/) FI_final                                 
!      Z=0>           -------------                                     
!           covering  _____________         [D(1),K(1,I,J)]             
!                                  >Layer#1 [D(2),K(2,I,J)]             
!                 1.  .............                                     
!                           .                                           
!                           .                                           
!                     .............                                     
! Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]       
!       I                                                               
!          substrate  _____________         [D(NL),K(NL,I,J)]           
!                            `                 ^                        
!                              `            infinit or finit            
!                             refracted                                 
!                                                                       
!                                                                       
!  Variables of system:                                                 
!                                                                       
!  INPUT:                                                               
!                                                                       
!                           covering   layer #L     substrate           
!                                                                       
!            thickneses:         D(1)     D(L)        D(NL)             
!                                                                       
!        susceptibility:                                                
!          (nuclear+magnetic)                                           
!                                K(1)     K(L)        K(NL)             
!                                                                       
!       	 effect_rough       sigma(1)   sigma(L)    sigma(NL)           
!  (struct+magnetic rough)                                              
! (rms of domain angle distrib)                                         
!	   mag_sigma(i)->0                                                    
! lateral length of correl-n	 ksi(1)     ksi(2)       ksi(NL)           
!   where  L=1..NL  I,J=1,2,3                                           
! --------                                                              
!      SFI_inc,SFI_final - incident angle and angle of scattered wave   
!      r                    sample-detector distance                    
!      A                    area of sample                              
!                                                                       
!                                                                       
!                                                                       
!  OUTPUT:                                                              
!                                                                       
!         Intensity of diffusely scattered wave from the above sample   
!		which goes under angle SFI-final                     
!                                                                       
!     subroutine energy_diffuse(mlay,lay_domain,MAXGRP,GEOSTR,b_domain, &
!                               eta,G_mjv,prho,arho,Idiff)              
! ******************************************************************    
      implicit none 
      integer, intent(in)::  mlay,lay_domain,MAXGRP
      integer, intent(in),dimension(0:2*mlay)::GEOSTR 
      logical, Intent(in),dimension(mlay)    :: b_domain 
      real(kind=8), intent(in)               :: eta 
      complex(kind=8),intent(in),dimension(2,2,2,lay_domain):: G_mjv 
      complex(kind=8), intent(in),dimension(2,2):: prho,arho       

      complex(kind=8), intent(out):: Idiff

! Other variables                                                       
      complex(kind=8):: dIdiff
      integer    POINTER,GRP,GRP1,LMIN,LMAX,n_rep,L,n,POINTER1,         &
                 LMIN1,LMAX1,n_rep1,n1,L1,I1,I2,mju1,mju2              
                                                                        
      Idiff=dcmplx(0.0D0,0.0D0) 
                                                                        
!***************** Sum over mju************                             
      DO mju1=1,2 
       DO mju2=1,2 
!***************** Sum over layers************                          
        I1=0 
        POINTER=0 
        do GRP=1,MAXGRP      ! loop for the groups 
         LMIN =POINTER+1 
         LMAX =POINTER+GEOSTR(2*GRP) 
         n_rep=GEOSTR(2*GRP-1) 
         n=1 
         DO WHILE (n.LE.n_rep) 
          n=n+1 
          do L=LMIN,LMAX 
!          write(6,'(3i4,2x,L4)')n,L,I1,b_domain(L)                     
           if(b_domain(L)) then 
           I1=I1+1 
!          Second sum over L1                                                    
           POINTER1=0 
           I2=0 
            do GRP1=1,MAXGRP      ! loop for the groups   
             LMIN1 =POINTER1+1 
             LMAX1 =POINTER1+GEOSTR(2*GRP1) 
             n_rep1=GEOSTR(2*GRP1-1) 
             n1=1 
             DO WHILE (n1.LE.n_rep1) 
              n1=n1+1 
              do L1=LMIN1,LMAX1 
               if(b_domain(L1))  then 
                I2=I2+1 
                call contribution(lay_domain,mju1,mju2,G_mjv,I1,I2,     &
                                                  prho,arho,dIdiff)    
!------------- All the model assumptions are in this IF-block-----------
                if (mod((I1+I2)*1.0,2.0).EQ.0.)then 
                 if(mju1.eq.mju2)then 
                  Idiff=Idiff+dIdiff*eta*(1.D0-eta) 
                 else 
                  Idiff=Idiff-dIdiff*eta*(1.D0-eta) 
                 end if 
                else 
                 if(mju1.eq.mju2)then 
                  Idiff=Idiff-dIdiff*eta*(1.D0-eta) 
                 else 
                  Idiff=Idiff+dIdiff*eta*(1.D0-eta) 
                 end if 
                end if 
!-----------------------------------------------------------------------
               endif    ! thicklayer(L1) > 0. and ksi(L1)>0  
              end do  ! L1  
             END DO  ! n1<=n1_rep 
             POINTER1=POINTER1+GEOSTR(2*GRP1) 
            end do  ! GRP1 
           endif ! thicklayer(L) > 0. and ksi>0  
!          print *, d1,d2                                                 
          end do ! L
         END DO    ! n<=n_rep     
         POINTER=POINTER+GEOSTR(2*GRP) 
        end do ! GRP   
       END DO ! over mju1
      END DO ! over mju2 
      return 
      END                                           


!  *****************************************************************    
!    Contribution to diffuse scattering of layers I1 and I2 for         
!    a given polarization.                                              
!   	                                                                   
!  *****************************************************************    
    subroutine contribution(lay_domain,mju1,mju2,G_mjv,I1,I2,prho,arho,dIdiff)  
    implicit none 
    integer, intent(in):: lay_domain,mju1,mju2,I1,I2
    complex(kind=8),intent(in),dimension(2,2,2,lay_domain):: G_mjv 
    complex(kind=8),intent(in),dimension(2,2):: prho,arho 
    complex(kind=8),intent(out):: dIdiff 

    complex(kind=8),dimension(2,2):: A,B 
    integer    ii,jj 
                                                                      
    DO ii=1,2 
     DO jj=1,2 
      A(ii,jj)=conjg(G_mjv(jj,ii,mju2,I2)) 
      B(ii,jj)=G_mjv(ii,jj,mju1,I1) 
     END DO 
    END DO 
!  observation with analizer of polarization arho                      
    call mat2(A,arho,A) 
    call mat2(A,B,A)     !A=conj[G(E+nh)]*G(E) 
    call mat2(A,prho,B)  !B=conj[G(E+nh)]*G(E) *rho   
    dIdiff=B(1,1)+B(2,2)   !dIdiff=Sp{conj[G(E+nh)]*G(E) *rho}  
    return 
   END                                           
                                                                        
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
     subroutine g_fndwba(mlay,lay_domain,MAXGRP,GEOSTR,                &
                         b_Bfield,b_domain,thicklayer,roughlay,SQ,K1,  &
                         Fmatrix_cur, AFmatrix_cur,                    &
                         Rmatrix,ARmatrix,                             &
                         L1matrix,R1matrix,                            &
                         L2matrix,R2matrix,                            &
                         L3matrix,R3matrix,                            &
                         L4matrix,R4matrix)                            
!                                                                       
!***********************************************************************
!      This subroutine calculates the multiplication factors from the le
!      The four 2x2 matrices are L1matrix...L4matrix from left and R1mat
!                   Gamma= L1matrix*khi*R1matrix+ ... + L4matrix*khi*R4m
!      L.Deak, 18.03.2011 (Budapest)                                    
!**********************************************************************
    implicit none 
    integer,        intent(in)                    :: mlay,lay_domain,MAXGRP
    integer,        intent(in),dimension(0:2*mlay):: GEOSTR
    logical,        intent(in),dimension(mlay)    :: b_Bfield,b_domain 
    real(kind=8),   intent(in),dimension(1:mlay)  :: thicklayer,roughlay
    real(kind=8),   intent(in)                    :: SQ,K1
    complex(kind=8),intent(in),dimension(2,2,mlay):: Fmatrix_cur,AFmatrix_cur
    complex(kind=8),intent(in),dimension(2,2)     :: Rmatrix,ARmatrix

    complex(kind=8),intent(out),dimension(2,2,lay_domain)::           &
                               L1matrix,R1matrix,L2matrix,R2matrix,   &
                               L3matrix,R3matrix,L4matrix,R4matrix                            

    real(kind=8)                  :: QD,DL
    complex(kind=8),dimension(2,2):: KL,AKL
    complex(kind=8),dimension(4,4):: M,AM,ML,AML,MGRP,AMGRP
    integer    I,J,L,n_rep,GRP,LMIN,LMAX,NLOG,POINTER,I_D,NL
                                                                        
!**************************************                                 
                                                                        
!  L.Deak:    change Rmatrix back to double complex to avoid twicefold c
     complex(kind=8),dimension(2,2):: A,B,C,D,                      &
                                      matL1,matR1,matL2,matR2,      &
                                      matL3,matR3,matL4,matR4

      complex(kind=8):: H12 
      real           :: absCmatr,absC1,absC2
      logical        :: b_odz,b_grp 
                                                                        
!********* Variables added by Khaidukov for neutron case                
      complex(kind=8),dimension(2,2):: KLprev,AKLprev 
      real(kind=8)                  :: DabsMatr,z1,z2 
                                                                        
      integer    Lprev,Lnext,n 
      logical    prev_dgnl,both_dgnl,both_NONdgnl 
      complex(kind=8),parameter :: C0=(0.D0,0.D0), C1=(1.D0,0.D0), &
                                   CI=(0.D0,1.D0)
      real,parameter:: alevel=1.e17                                         
                                                                        
!---------------------------------------------                          
      QD=SQ 
!     NL: number of layers  (in period)                                   
      NL=mlay 
                                                                        
!    Setting the characteristic matrix to unit matrix                     
      M=C0
      AM=C0
      do I=1,4 
       M(I,I)  =C1 
       AM(I,I) =C1 
      end do 
      I_D=0 
      POINTER=0 
      z1=0.0D0  !First  
      z2=0.0D0  !and the second coordinate for each layer 

      do GRP=1,MAXGRP   ! loop for the groups  
       MGRP=C0
       AMGRP=C0
       do I=1,4 
        MGRP(I,I)=C1 
        AMGRP(I,I)=C1 
       end do 
                                                                        
       b_grp=.false. 
       LMIN =POINTER+1 
       LMAX =POINTER+GEOSTR(2*GRP) 
       n_rep=GEOSTR(2*GRP-1) 
                                                                        
       DO n=1,n_rep ! loop for the period
        ML=C0
        AML=C0
        do I=1,4 
         ML(I,I)=C1 
         AML(I,I)=C1 
        end do 
        do L=LMIN,LMAX ! loop for the layers 
!	 if(real(thicklayer(L)).gt.0..and.real(thicklayer(L)).lt.1.e30) then  
         b_odz=.not.b_Bfield(L) 
         b_grp=.true. 
         DL=thicklayer(L) 
         z2=z1+DL 
                                                                        
         do I=1,2 
          do J=1,2 
           KL(I,J) = Fmatrix_cur(I,J,L) 
           AKL(I,J)=AFmatrix_cur(I,J,L) 
          end do 
         end do 
                                                                        
          absCmatr=dreal(KL(1,2)*dconjg(KL(1,2))+KL(2,1)*dconjg(KL(2,1))) 
          absC1=dreal(KL(1,1)*dconjg(KL(1,1))+KL(2,2)*dconjg(KL(2,2)))
          absC2=absCmatr*alevel 
          if(absC1.gt.absC2) then 
           b_odz=.true. 
          end if 
          IF (b_domain(L)) THEN 
           !If there are domains in this layer store information
           I_D=I_D+1   ! identification of the layer having domains
!          call trans(b_odz,QD,KL, Rmatrix, M, A,B)                    
!          call trans(b_odz,K1,AKL,ARmatrix,AM,C,D)                    
           call trans(QD,KL, Rmatrix, M, A,B) 
           call trans(K1,AKL,ARmatrix,AM,C,D) 
           H12=C(1,2) 
           C(1,2)=C(2,1) 
           C(2,1)=H12 
           H12=D(1,2) 
           D(1,2)=D(2,1) 
           D(2,1)=H12 
           if(b_odz)then 
            call com_integral(z1,z2,QD,K1,KL,AKL,A,B,C,D,               &
                   matL1,matR1,matL2,matR2,matL3,matR3,matL4,matR4)    
           else 
            call analytic_integral(z1,z2,QD,K1,KL,AKL,A,B,C,D,          &
                   matL1,matR1,matL2,matR2,matL3,matR3,matL4,matR4)    
           end if 
                                                                        
           do I=1,2 
            do J=1,2 
             L1matrix(I,J,I_D)=matL1(I,J) 
             R1matrix(I,J,I_D)=matR1(I,J) 
             L2matrix(I,J,I_D)=matL2(I,J) 
             R2matrix(I,J,I_D)=matR2(I,J) 
             L3matrix(I,J,I_D)=matL3(I,J) 
             R3matrix(I,J,I_D)=matR3(I,J) 
             L4matrix(I,J,I_D)=matL4(I,J) 
             R4matrix(I,J,I_D)=matR4(I,J) 
           end do 
          end do 
         END IF      ! Domains  
                                                                        
         call genM(b_odz,QD,DL,KL,M) 
         call genM(b_odz,-K1,DL,AKL,AM) 
!************* Roughness************                                    
        IF (roughlay(L).GT.1.d-3) THEN   ! In case of repeating layers
          ! we are more interested in the information about roughnesses
          ! in repeated ones. #Khaidukov
          if (n_rep.GT.1.and.L.eq.Lmin) then 
           Lprev=LMAX 
          else 
          Lprev=L-1 
         END IF 
         if(n_rep.GT.1.and.L.eq.LMAX) then 
          ! For peiodical structure the rougness is also periodical! 
          ! The next layer to the last element is the first layer
          Lnext=LMIN 
         else 
          Lnext=L+1 
          if(Lnext.gt.NL) Lnext=NL 
         end if 
                                                                        
         DO I=1,2 
          DO J=1,2 
           IF (Lprev.EQ.0) THEN 
            ! In case of 1st layer KLprev is for vacuum
            KLprev(I,J)=C0 
            AKLprev(I,J)=C0 
            prev_dgnl=.true. 
           END IF 
           IF (Lprev.GT.0) THEN 
            KLprev(I,J)=Fmatrix_cur(I,J,Lprev) 
            AKLprev(I,J)=AFmatrix_cur(I,J,Lprev) 
            prev_dgnl=.not.b_Bfield(Lprev) 
           ENDIF 
                                                                        
          END DO 
         END DO 
         DabsMatr=dble((KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+&
                       (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1))))
         IF (prev_dgnl.and.b_odz) then 
          both_dgnl   =.true.                            !  Rohlsberge
          both_NONdgnl=.false.                           !            
         ELSEIF (DabsMatr.lt.1.d-15) then                !            
          both_dgnl   =.true.                            !  Rohlsberger
          both_NONdgnl=.false.                           !            
         ELSEIF (.not.prev_dgnl.and..not.b_odz) then    
          both_dgnl   =.false.                           !            
          both_NONdgnl=.true.                            !  Deak
         ELSE                                           
          both_dgnl   =.false.                           !  Rohlsberger
          both_NONdgnl=.false.                           !            
         ENDIF 
                                                                        
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      
!	  both_dgnl=.false.                !DONT FORGET TO REMOVE            
!         both_NONdgnl=.true.              !Deak's roughness               
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      
                                                                        
          call OSroughness(both_dgnl,both_NONdgnl,roughlay(L),         &
                        roughlay(Lnext),QD,KLprev,KL,M)                
          call OSroughness(both_dgnl,both_NONdgnl,roughlay(L),         &
                        roughlay(Lnext),-K1,AKLprev,AKL,AM)            
          END IF !Roughness                                             
                                                                        
          call mat4(M,ML,ML)                                            
          call mat4(AM,AML,AML)                                         
                                                                        
          call mat4(ML,MGRP,M)                                          
          call mat4(AML,AMGRP,AM)                                       
          z1=z2                                                         
        end do                                                          
                                                                        
        if(n_rep.gt.1.and.b_grp)then                                    
         if(n.gt.1)then                                                 
          M=ML
          AM=AML
         end if                                                        
         NLOG=alog(float(n))/alog(2.0)                                  
         do I=1,NLOG                                                    
          call mat4(ML,ML,ML)                                           
          call mat4(AML,AML,AML)                                        
         end do                                                         

         do I=1,n-2**NLOG                                               
          call mat4(M,ML,ML)                                            
          call mat4(AM,AML,AML)                                         
         end do                                                         
         MGRP=ML
         AMGRP=AML
         M=ML
         AM=AML
        end if ! n_rep>1
       END DO  ! n=1,n_rep                                              
       POINTER=POINTER+GEOSTR(2*GRP)                                    
      end do   ! GRP                                                          
      return                                                            
      END                                           
                                                                        
                                                                        
     subroutine transb(b_odz,QD,KL,R,L,A,B) 
! *******************************************************************   
!                                                                       
!           Calculation of the 2x2 A and B matrixes - amplitudes of wave
!
!         QD: Kz- perpendicular komponent of wave vektor (Kz=Qz*0.5)     
! ******************************************************************    
      implicit none 
      logical,      intent(in):: b_odz 
      real(kind=8), intent(in):: QD 
      complex(kind=8),intent(in),dimension(2,2):: KL,R
      complex(kind=8),intent(in),dimension(4,4):: L
      complex(kind=8),intent(out),dimension(2,2):: A,B
                                                     
      complex(kind=8),dimension(2,2):: L11,L12,L21,L22,RM,RP,A1,A2,    &
                                       C1,C2,C1P,C2P,C1M,C2M
      real(kind=8):: QD2 
      integer    I,J 
      complex(kind=8),parameter:: C0=(0.D0,0.D0) 
                                                                        
!     ********************Body of the subroutine**************************
      QD2=QD*QD 
!     Definition of 2x2 block matrices L21, L22 and                      
!     the 2x2 I-R and I+R matrices                                       
      do I=1,2 
       do J=1,2 
        L11(I,J)= 0.5D0*L(I,J) 
        L12(I,J)= 0.5D0*L(I,J+2) 
        L21(I,J)= 0.5D0*L(I+2,J) 
        L22(I,J)= 0.5D0*L(I+2,J+2) 
        RM(I,J) = -R(I,J)            ! L.D 15.02.2011 (Garching) 
        RP(I,J) =  R(I,J) 
       end do 
       RM(I,I)  =  1.D0-R(I,I) 
       RP(I,I)  =  1.D0+R(I,I) 
      end do 
!     Now Lij are block matrixes already divided by 2, Rm=1-R, Rp=1+R        
      if(b_odz)then 
       A1(1,1)=(KL(1,1)/QD2)+1.D0     !A1=1+(K/Kz**2)
       A1(1,2)= C0 
       A1(2,1)= C0 
       A1(2,2)=(KL(2,2)/QD2)+1.D0 
                                                                        
       A2(1,1)= -sqrt(A1(1,1)) 
       A2(1,2)= C0 
       A2(2,1)= C0 
       A2(2,2)= -sqrt(A1(2,2)) 
                                                                        
       A1(1,1)= 1.D0/A2(1,1) 
       A1(1,2)= C0 
       A1(2,1)= C0 
       A1(2,2)= 1.D0/A2(2,2) 
                                                                        
      else 
       A1(1,1)=(KL(1,1)/QD2)+1.D0     !A1=1+(K/Kz**2) 
       A1(1,2)= KL(1,2)/QD2 
       A1(2,1)= KL(2,1)/QD2 
       A1(2,2)=(KL(2,2)/QD2)+1.D0 
       call sqrt2(A1,A2) 
       A2(1,1)=-A2(1,1) 
       A2(1,2)=-A2(1,2) 
       A2(2,1)=-A2(2,1) 
       A2(2,2)=-A2(2,2) 
       call inv2(A2,A1)             !A1=eta**-1 
      end if 
                                                                        
      call mat2(A1,L11,C1)         !C1=(eta**-1)*L11*0.5                
      call mat2(A1,L12,C2)         !C2=(eta**-1)*L12*0.5                
      do I=1,2                                                          
       do J=1,2                   
        C1P(I,J)=L21(I,J)+C1(I,J)  !C1P=(L21+(eta**-1)*L11)*0.5         
        C1M(I,J)=L21(I,J)-C1(I,J)  !C1M=(L21-(eta**-1)*L11)*0.5         
        C2P(I,J)=L22(I,J)+C2(I,J)  !C2P=(L22+(eta**-1)*L12)*0.5         
        C2M(I,J)=L22(I,J)-C2(I,J)  !C2M=(L22-(eta**-1)*L12)*0.5         
       end do                     
      end do                      
      call mat2(C1P,RM,C1)         !C1=(L21+(eta**-1)*L11)*(1-R)*0.5         
      call mat2(C2P,RP,C2)         !C2=(L22+(eta**-1)*L12)*(1+R)*0.5         
      call mat2(C1M,RM,A1)         !A1=(L21-(eta**-1)*L11)*(1-R)*0.5         
      call mat2(C2M,RP,A2)         !A2=(L22-(eta**-1)*L12)*(1+R)*0.5         
      do I=1,2 
       do J=1,2 
        A(I,J)=C1(I,J)+C2(I,J)    ! A=[ L21+(eta**-1)*L11)*(1-R)+
                                  !    (L22+(eta**-1)*L12)*(1+R)]*0.5            
        B(I,J)=A1(I,J)+A2(I,J)    ! B=[(L21-(eta**-1)*L11)*(1-R)+ 
                                  !    (L22-(eta**-1)*L12)*(1+R)]*0.5   
       end do 
      end do 
      return 
      END                                           
                                                                        
! **********************************************************************
! Subroutines calculate integral (exp(ikz)*A+exp(-ikz)B)*exp(-ik'z)dz   
! in the interval from z1 to z2                                         
! **********************************************************************
     subroutine analytic_integral(z1,z2,QINC,QOUT,KL,AKL,A,B,C,D,      &
                        matL1,matR1,matL2,matR2,matL3,matR3,matL4,matR4)    
     implicit none 
     real(kind=8),   intent(in):: z1,z2,QINC,QOUT 
     complex(kind=8),intent(in),dimension(2,2) :: KL,AKL,A,B,C,D
     complex(kind=8),intent(out),dimension(2,2):: matL1,matR1,matL2,matR2,&
                                                  matL3,matR3,matL4,matR4


     complex(kind=8),dimension(2,2)    :: F,AF,FF,F1,noTrF,noTrAF,comR,comL
     complex(kind=8),dimension(2,2,2,2):: S,dS
     complex(kind=8):: hTrF,hTrAF,sq_detF,sq_detAF
     complex(kind=8):: fact1,fact2,fact3,fact4,fact13,fact24,nu
     real(kind=8)   :: z21,QINC2,QOUT2 
     integer     I,J,M,N 
     real(kind=8),   parameter :: aLIMIT=2.D1
     real,           parameter :: sqdetcrit=1.E-7       
     complex(kind=8),parameter :: CI=(0.0D0,1.0D0),C1=(1.D0,0.D0),    &
                                  C0=(0.D0,0.D0)
!  L.Deak 23.02.2009                                                    
!  L.Deak 17.03.2011 (Budapest)                                         
!  L.Deak 29.03.2011 (Budapest)                                         
!********************Body of the subroutine                             
    z21=z2-z1 
!   matrices, variebles for the incoming wave:                            
    QINC2=QINC*QINC 
    QOUT2=QOUT*QOUT 
                                                                      
    FF(1,1)=-KL(1,1)-QINC2 
    FF(1,2)=-KL(1,2) 
    FF(2,1)=-KL(2,1) 
    FF(2,2)=-KL(2,2)-QINC2 
    call sqrt2(FF,F)                   !F=sqrt(-I*QINC**2-KL) 
    hTrF= 0.5D0*(F(1,1)+F(2,2)) 
    noTrF(1,1)= F(1,1)-hTrF 
    noTrF(1,2)= F(1,2)                 !noTrF=F-I*Tr(F)/2 
    noTrF(2,1)= F(2,1) 
    noTrF(2,2)= F(2,2)-hTrF 
    sq_detF   =sqrt(noTrF(1,1)*noTrF(1,1)+noTrF(1,2)*noTrF(2,1)) 
                                                                      
    comR(1,1) =  noTrF(1,1)/sq_detF 
    comR(1,2) =  noTrF(1,2)/sq_detF 
    comR(2,1) =  noTrF(2,1)/sq_detF 
    comR(2,2) = -comR(1,1) 
!   variables for the outgoing wave:                                
    FF(1,1)=-AKL(1,1)-QOUT2 
    FF(1,2)=-AKL(1,2) 
    FF(2,1)=-AKL(2,1) 
    FF(2,2)=-AKL(2,2)-QOUT2 
    call sqrt2(FF,AF)                  !AF=sqrt(-QOUT**2-AKL) 

    AF(1,1)= (AF(1,1)) 
    AF(2,2)= (AF(2,2)) 
    fact1  = (AF(1,2)) 
    fact2  = (AF(2,1)) 
    AF(1,2)= fact2 
    AF(2,1)= fact1                     !AF=transpose(AF) L.D, 2
    hTrAF      = 0.5D0*(AF(1,1)+AF(2,2)) 
    noTrAF(1,1)= AF(1,1)-hTrAF 
    noTrAF(1,2)= AF(1,2)               !noTrAF=AF-I*Tr(AF)/2 
    noTrAF(2,1)= AF(2,1) 
    noTrAF(2,2)= AF(2,2)-hTrAF 
                                                                      
    sq_detAF=sqrt(noTrAF(1,1)*noTrAF(1,1)+noTrAF(1,2)*noTrAF(2,1)) 
                                                                      
    comL(1,1) =  noTrAF(1,1)/sq_detAF 
    comL(1,2) =  noTrAF(1,2)/sq_detAF 
    comL(2,1) =  noTrAF(2,1)/sq_detAF 
    comL(2,2) = -comL(1,1) 
                                                                      
!   variables for in and out:                                             
                                                                      
    do I=1,2 
     fact1=(-1.D0)**(I-1)*hTrAF 
     do J=1,2 
      fact2=(-1.D0)**(J-1)*hTrF 
      do M=1,2 
       fact3=(-1.D0)**(M-1)*sq_detAF 
       do N=1,2 
        fact4=(-1.D0)**(N-1)*sq_detF 
        S(I,J,M,N)=fact1+fact2+fact3+fact4 
        fact13    =(fact1+fact3)*z21 
        fact24    =(fact2+fact4)*z21 
        dS(I,J,M,N)=fact13+fact24 
        if((dble(fact13).lt.aLIMIT).and.(dble(fact24).lt.aLIMIT))then 
         if(abs(S(I,J,M,N)).lt.sqdetcrit)then 
          dS(I,J,M,N)=0.25D0*z21 
         else 
          dS(I,J,M,N)=0.25D0*(exp(dS(I,J,M,N))-C1)/S(I,J,M,N) 
         endif 
        else 
         dS(I,J,M,N)=C0 
        endif 
       enddo 
      enddo 
     enddo 
    enddo 
                                                                      
!*****************   1st grp  right: (I+comR)A 
!   left side: 
                                                                      
    matL1(1,1)=C1+comL(1,1) 
    matL1(1,2)=comL(1,2) 
    matL1(2,1)=comL(2,1) 
    matL1(2,2)=C1+comL(2,2) 
                                                                      
    call mat2(C,matL1,F1) 
                                                                      
    nu=dS(1,1,1,1) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=F1(I,J)*nu 
     end do 
    end do 
                                                                      
    call mat2(D,matL1,F1) 
                                                                      
    nu=dS(2,1,2,1) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=FF(I,J)+F1(I,J)*nu 
     end do 
    end do 
                                                                      
    matL1(1,1)=C1-comL(1,1) 
    matL1(1,2)=-comL(1,2) 
    matL1(2,1)=-comL(2,1) 
    matL1(2,2)=C1-comL(2,2) 
                                                                      
    call mat2(C,matL1,F1) 
                                                                      
    nu=dS(1,1,2,1) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=FF(I,J)+F1(I,J)*nu 
     end do 
    end do 
                                                                      
    call mat2(D,matL1,F1) 
                                                                      
    nu=dS(2,1,1,1) 
    do I=1,2 
     do J=1,2 
      FF(I,J)   =FF(I,J)+F1(I,J)*nu 
      matL1(I,J)=FF(I,J) 
     end do 
    end do 
                                                                      
!right side:                                                          
                                                                      
    matR1(1,1)=C1+comR(1,1) 
    matR1(1,2)=comR(1,2) 
    matR1(2,1)=comR(2,1) 
    matR1(2,2)=C1+comR(2,2) 
                                                                      
    call mat2(matR1,A,matR1) 
                                                                      
!**********************************   2nd grp  right: (I-comR)A
!   left side:                                                           
                                                                      
    matL2(1,1)=C1+comL(1,1) 
    matL2(1,2)=comL(1,2) 
    matL2(2,1)=comL(2,1) 
    matL2(2,2)=C1+comL(2,2) 
                                                                      
    call mat2(C,matL2,F1) 
                                                                      
    nu=dS(1,1,1,2) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=F1(I,J)*nu 
     end do 
    end do 
                                                                      
    call mat2(D,matL2,F1) 
                                                                      
    nu=dS(2,1,2,2) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=FF(I,J)+F1(I,J)*nu 
     end do 
    end do 
                                                                      
    matL2(1,1)=C1-comL(1,1) 
    matL2(1,2)=-comL(1,2) 
    matL2(2,1)=-comL(2,1) 
    matL2(2,2)=C1-comL(2,2) 
                                                                      
    call mat2(C,matL2,F1) 
                                                                      
    nu=dS(1,1,2,2) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=FF(I,J)+F1(I,J)*nu 
     end do 
    end do 
                                                                      
    call mat2(D,matL2,F1) 
                                                                      
    nu=dS(2,1,1,2) 
    do I=1,2 
     do J=1,2 
      FF(I,J)   =FF(I,J)+F1(I,J)*nu 
      matL2(I,J)=FF(I,J) 
     end do 
    end do 
                                                                      
!   right side:                                                          
                                                                      
    matR2(1,1)=C1-comR(1,1) 
    matR2(1,2)=-comR(1,2) 
    matR2(2,1)=-comR(2,1) 
    matR2(2,2)=C1-comR(2,2) 
                                                                      
    call mat2(matR2,A,matR2) 
                                                                      
!**********************************    3rd grp  right: (I-comR)B
!   left side:                                                           
                                                                      
    matL3(1,1)=C1+comL(1,1) 
    matL3(1,2)=comL(1,2) 
    matL3(2,1)=comL(2,1) 
    matL3(2,2)=C1+comL(2,2) 
                                                                      
    call mat2(C,matL3,F1) 
                                                                      
    nu=dS(1,2,1,1) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=F1(I,J)*nu 
     end do 
    end do 
                                                                      
    call mat2(D,matL3,F1) 
                                                                      
    nu=dS(2,2,2,1) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=FF(I,J)+F1(I,J)*nu 
     end do 
    end do 
                                                                      
    matL3(1,1)=C1-comL(1,1) 
    matL3(1,2)=-comL(1,2) 
    matL3(2,1)=-comL(2,1) 
    matL3(2,2)=C1-comL(2,2) 
                                                                      
    call mat2(C,matL3,F1) 
                                                                      
    nu=dS(1,2,2,1) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=FF(I,J)+F1(I,J)*nu 
     end do 
    end do 
                                                                      
    call mat2(D,matL3,F1) 
                                                                      
    nu=dS(2,2,1,1) 
    do I=1,2 
     do J=1,2 
      FF(I,J)   =FF(I,J)+F1(I,J)*nu 
      matL3(I,J)=FF(I,J) 
     end do 
    end do 
                                                                      
!   right side:                                                          
                                                                      
    matR3(1,1)=C1-comR(1,1) 
    matR3(1,2)=-comR(1,2) 
    matR3(2,1)=-comR(2,1) 
    matR3(2,2)=C1-comR(2,2) 
                                                                      
    call mat2(matR3,B,matR3) 
                                                                      
!**********************************    4th grp                                
!   left side:  (I+comR)B                                                
                                                                      
    matL4(1,1)=C1+comL(1,1) 
    matL4(1,2)=comL(1,2) 
    matL4(2,1)=comL(2,1) 
    matL4(2,2)=C1+comL(2,2) 
                                                                      
    call mat2(C,matL4,F1) 
                                                                      
    nu=dS(1,2,1,2) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=F1(I,J)*nu 
     end do 
    end do 
                                                                      
    call mat2(D,matL4,F1) 
                                                                      
    nu=dS(2,2,2,2) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=FF(I,J)+F1(I,J)*nu 
     end do 
    end do 
                                                                      
    matL4(1,1)=C1-comL(1,1) 
    matL4(1,2)=-comL(1,2) 
    matL4(2,1)=-comL(2,1) 
    matL4(2,2)=C1-comL(2,2) 
                                                                      
    call mat2(C,matL4,F1) 
                                                                      
    nu=dS(1,2,2,2) 
    do I=1,2 
     do J=1,2 
      FF(I,J)=FF(I,J)+F1(I,J)*nu 
     end do 
    end do 
                                                                      
    call mat2(D,matL4,F1) 
                                                                      
    nu=dS(2,2,1,2) 
    do I=1,2 
     do J=1,2 
      FF(I,J)   =FF(I,J)+F1(I,J)*nu 
      matL4(I,J)=FF(I,J) 
     end do 
    end do 
                                                                      
!   right side:                                                          
                                                                      
    matR4(1,1)=C1+comR(1,1) 
    matR4(1,2)=comR(1,2) 
    matR4(2,1)=comR(2,1) 
    matR4(2,2)=C1+comR(2,2) 
                                                                      
    call mat2(matR4,B,matR4) 
                                                                      
    return 
    END                                           
                                                                        
! **********************************************************************
! Subroutines calculate integral (exp(ikz)*A+exp(-ikz)B)*exp(-ik'z)dz   
! in the interval from z1 to z2                                         
! **********************************************************************
     subroutine com_integral(z1,z2,QINC,QOUT,KL,AKL,A,B,C,D,           &
                  matL1,matR1,matL2,matR2,matL3,matR3,matL4,matR4)    
     implicit none 
     real(kind=8),   intent(in):: z1,z2,QINC,QOUT 
     complex(kind=8),intent(in),dimension(2,2) :: KL,AKL,A,B,C,D
     complex(kind=8),intent(out),dimension(2,2):: matL1,matR1,matL2,matR2,&
                                                  matL3,matR3,matL4,matR4
     integer     I
     real(kind=8)   :: z21,QINC2,QOUT2,Rez21AF,Rez21F
     complex(kind=8),dimension(2,2):: F,AF,FF,AMPL1,L1
     complex(kind=8),parameter :: CI=(0.0D0,1.0D0),C1=(1.D0,0.D0),    &
                                  C0=(0.D0,0.D0)
     real(kind=8),parameter    :: aLIMIT=2.D1
     real,parameter            :: sqdetcrit=1.E-7       

!  L.Deak 23.02.2009                                                    
!********************Body of the subroutine                             
     z21   =z2-z1 
!    matrices, variebles for the incoming wave:                            
                                                                      
     QINC2=QINC*QINC 
     QOUT2=QOUT*QOUT 
                                                                      
     FF(1,1)=-KL(1,1)-QINC2 
     FF(1,2)= C0 
     FF(2,1)= C0 
     FF(2,2)=-KL(2,2)-QINC2 
                                                                      
     F(1,1)= sqrt(FF(1,1)) 
     F(1,2)= C0 
     F(2,1)= C0 
     F(2,2)= sqrt(FF(2,2))                     !F=sqrt(-QINC**2-KL) 
!    variables for the outgoing wave:                                
     FF(1,1)=-AKL(1,1)-QOUT2 
     FF(1,2)= C0 
     FF(2,1)= C0 
     FF(2,2)=-AKL(2,2)-QOUT2 
                                                                      
     AF(1,1)= sqrt(FF(1,1)) 
     AF(1,2)= C0 
     AF(2,1)= C0 
     AF(2,2)= sqrt(FF(2,2))                    !AF=sqrt(-QOUT**2-AKL)
                                                                      
!   *******************           1st grp 
!    left side:                                                           
                                                                      
     do I=1,2 
                                                                      
      AMPL1(I,I)= AF(I,I)+F(I,I) 
      Rez21AF=    z21*dble(AF(I,I)) 
      Rez21F =    z21*dble(F(I,I)) 
                                                                      
      if((Rez21AF.lt.aLIMIT).and.(Rez21F.lt.aLIMIT))then 
       if(abs(AMPL1(I,I)).lt.sqdetcrit)then 
        matL1(I,I)=C(I,I)*z21 
       else 
        L1(I,I)=1.D0/AMPL1(I,I) 
        FF(I,I)=AMPL1(I,I)*z21 
        FF(I,I)=exp(FF(I,I)) 
        FF(I,I)=FF(I,I)-C1 
                                                                      
        AMPL1(I,I)=L1(I,I)*FF(I,I) 
        matL1(I,I)=C(I,I)*AMPL1(I,I) 
       endif 
      else 
        matL1(I,I)=C0 
      endif 
     end do 
                                                                      
     matL1(1,2)=C0 
     matL1(2,1)=C0 
                                                                      
!    right side:                                                          
                                                                      
     matR1(1,1)=A(1,1) 
     matR1(1,2)=A(1,2) 
     matR1(2,1)=A(2,1) 
     matR1(2,2)=A(2,2) 
                                                                      
!  *******************           2nd grp                                          
!    left side:                                                           
                                                                      
     do I=1,2 
                                                                      
      AMPL1(I,I)=AF(I,I)-F(I,I) 
      Rez21AF=    z21*dble(AF(I,I)) 
      Rez21F =   -z21*dble(F(I,I)) 
                                                                      
      if((Rez21AF.lt.aLIMIT).and.(Rez21F.lt.aLIMIT))then 
       if(abs(AMPL1(I,I)).lt.sqdetcrit)then 
        matL2(I,I)=C(I,I)*z21 
       else 
        L1(I,I)=1.D0/AMPL1(I,I) 
        FF(I,I)=AMPL1(I,I)*z21 
        FF(I,I)=exp(FF(I,I)) 
        FF(I,I)=FF(I,I)-C1 
                                                                      
        AMPL1(I,I)=L1(I,I)*FF(I,I) 
        matL2(I,I)=C(I,I)*AMPL1(I,I) 
       endif 
      else 
        matL2(I,I)=C0 
      endif 
     end do 
                                                                      
     matL2(1,2)=C0 
     matL2(2,1)=C0 
                                                                      
!    right side:                                                          
                                                                      
     matR2(1,1)=B(1,1) 
     matR2(1,2)=B(1,2) 
     matR2(2,1)=B(2,1) 
     matR2(2,2)=B(2,2) 
                                                                      
!****************************        3rd grp                                              
!    left side:                                                           
                                                                      
     do I=1,2 
                                                                      
      AMPL1(I,I)=-AF(I,I)+F(I,I) 
      Rez21AF=   -z21*dble(AF(I,I)) 
      Rez21F =    z21*dble(F(I,I)) 
                                                                      
      if((Rez21AF.lt.aLIMIT).and.(Rez21F.lt.aLIMIT))then 
       if(abs(AMPL1(I,I)).lt.sqdetcrit)then 
        matL3(I,I)=D(I,I)*z21 
       else 
        L1(I,I)=1.D0/AMPL1(I,I) 
        FF(I,I)=AMPL1(I,I)*z21 
        FF(I,I)=exp(FF(I,I)) 
        FF(I,I)=FF(I,I)-C1 
                                                                      
        AMPL1(I,I)=L1(I,I)*FF(I,I) 
        matL3(I,I)=D(I,I)*AMPL1(I,I) 
       endif 
      else 
        matL3(I,I)=C0 
      endif 
     end do 
                                                                      
     matL3(1,2)=C0 
     matL3(2,1)=C0 
                                                                      
!   right side:                                                          
                                                                      
     matR3(1,1)=A(1,1) 
     matR3(1,2)=A(1,2) 
     matR3(2,1)=A(2,1) 
     matR3(2,2)=A(2,2) 
                                                                      
!**********************************      4th grp                               
!    left side:                                                           
                                                                      
     do I=1,2 
                                                                      
      AMPL1(I,I)=-AF(I,I)-F(I,I) 
      Rez21AF=   -z21*dble(AF(I,I)) 
      Rez21F =   -z21*dble(F(I,I)) 
                                                                      
      if((Rez21AF.lt.aLIMIT).and.(Rez21F.lt.aLIMIT))then 
       if(abs(AMPL1(I,I)).lt.sqdetcrit)then 
        matL4(I,I)=D(I,I)*z21 
       else 
        L1(I,I)=1.D0/AMPL1(I,I) 
        FF(I,I)=AMPL1(I,I)*z21 
        FF(I,I)=exp(FF(I,I)) 
        FF(I,I)=FF(I,I)-C1 
                                                                      
        AMPL1(I,I)=L1(I,I)*FF(I,I) 
        matL4(I,I)=D(I,I)*AMPL1(I,I) 
       endif 
      else 
        matL4(I,I)=C0 
      endif 
     end do 
                                                                      
     matL4(1,2)=C0 
     matL4(2,1)=C0 
                                                                      
!   right side:                                                          
                                                                      
     matR4(1,1)=B(1,1) 
     matR4(1,2)=B(1,2) 
     matR4(2,1)=B(2,1) 
     matR4(2,2)=B(2,2) 
                                                                      
     return 
    END                                           
                                                                        
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
       subroutine g_phase(mlay,lay_domain,MAXGRP,GEOSTR,b_domain,       &
     &                      thicklayer,SQ,Fouphase)                     
!***********************************************************************
!      Subroutine calculates Fourier transformation of the field (expers
!      2.12 in the article). Result is stored in Tmatrix.               
!     Size of the Tmatrix is 2*2*i, where i - Number of the layer with d
!                                                                       
!C**********************************************************************
      implicit none 
      integer, intent(in):: mlay,lay_domain,MAXGRP
      integer, intent(in),dimension(0:2*mlay):: GEOSTR
      logical, intent(in),dimension(mlay)    :: b_domain 
      real(kind=8),intent(in),dimension(mlay):: thicklayer 
      real(kind=8), intent(in):: SQ 
      complex(kind=8),intent(out),dimension(lay_domain):: Fouphase 
                                                                        
!********* Variables added by Khaidukov for neutron case                
      integer    n ,L,n_rep,GRP,LMIN,LMAX,POINTER,I_D 
!---------------------------------------------                          
      real(kind=8):: QD,DL,z1,z2 
      complex(kind=8),parameter ::C0=(0.D0,0.D0), C1=(1.D0,0.D0),    &
                                  CI=(0.D0,1.D0) 
                                                                        
      QD=SQ 
!     To set the Fouphase vector to zero fisrt                             
      Fouphase=C0 
      I_D=0 
      POINTER=0 
      z1=0.0D0  !First
      z2=0.0D0  !and the second coordinate for each layer
                                                                        
      do GRP=1,MAXGRP      ! loop for the groups
       LMIN =POINTER+1 
       LMAX =POINTER+GEOSTR(2*GRP) 
       n_rep=GEOSTR(2*GRP-1) 
       DO n=1,n_rep 
        do L=LMIN,LMAX 
         if(thicklayer(L).gt.0.0.and.thicklayer(L).lt.1.e30) then 
          DL=thicklayer(L) 
          z2=z1+DL 
          IF (b_domain(L)) THEN 
           !If there are domains in this layer store information
           I_D=I_D+1 
           Fouphase(I_D)=-2.D0/QD*exp(CI*QD*(z1+DL/2.D0))               &
     &                     *sin(QD*DL/2.D0)                             
          END IF     ! Domains 
         endif  ! thicklayer(L) > 0. 
         z1=z2 
        end do  ! L   
       END DO   ! n=1,n_rep  
       POINTER=POINTER+GEOSTR(2*GRP) 
      end do    ! GRP 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
