    subroutine x_data(mdastr,b_data,mxpt,nexp,xb_exp,dx_exp) 
    use comthe, only: real_fr
    implicit none 
    integer, intent(inout):: mdastr
    logical, intent(in):: b_data
    integer, intent(in):: mxpt,nexp
    real,    intent(in):: xb_exp,dx_exp

    integer k
    real    x
    
                                                                 
    if(.not.b_data) then 
     if(mdastr.eq.3) then 
      print '(a)',' **data_structure** dastr=3 requires data; set to 1' 
      mdastr=1 
     end if 
    end if 

   select case(mdastr)  
     case(1,2)
!     dastr of experimental points calculated 
      x=xb_exp-dx_exp 
      do k=1,nexp 
       x=x+dx_exp 
       real_fr(mxpt+k)=x 
      end do 
   case(3)
!     dastr of experimental points 
!     data for time or angle array taken from data file
    end select 
    return 
    END                                           
 
                                                                       
      subroutine syn_selsubset(text) 
      use glbconst, only: maxfr1,maxfr2,maxthss,maxs,maxscr,nrd,nwr,  &
                          maxsub,maxss
      use complt, only: n_int,n_subset
      implicit none
      character(len=40),intent(in),dimension(3):: text

      integer, parameter:: illc=3*(maxfr1+1+maxfr2+maxthss)
                                                                        
      character(len=64):: frthname 
      integer       mstruct1,istruct1,istruct2,i_array,iaddr
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    i_array(illc),frthname(2),iaddr(8)
                                                                        
      real,dimension(32):: out 
      character(len=132):: ch132,cp132,chcom
      character(len=40) :: htext
      character(len=4)  :: chp,chs 
      character(len=1)  :: ch1
      character(len=2)  :: ch2
      logical b_inc 
      integer i,i0,i10,ia,ig1,ig2,ii,iout,ipos,is_e,is_a,iset,iset_a,iset_e,&
              i1,j,j_int,j_intp,ji,jj,jscatterer,lay,lstruct1,   &
              lstruct2,max,mlay,layb,laye,n_ssub,nn
      integer, parameter :: mmax=4*maxss
      integer, dimension(mmax):: npanum
                                                                  
                                                                        
      i0=ichar('0') 
!     mlay : number of layers                                           
      if(mstruct1.gt.1) then 
       htext=text(2) 
       i=24 
       do while(htext(i:i).eq.' ') 
        i=i-1 
       end do 
       i=i+2 
                                                                        
       do lstruct1=1,mstruct1 
        j=0 
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
         j=j+1 
         lay=lstruct2 
         is_a=istruct2(lay-1)+1 
         is_e=istruct2(lay) 
         ii=is_e-is_a 
         if(j.eq.1) then 
          if(ii.gt.0) then 
           write(nwr,'(5x,a,i2,a,i2,a2,a,i2,a,i2)')                     &
     &     htext(:i),lstruct1,'    layer(',lay,'):',                    &
     &    '    sites from ',is_a,' to ',is_e                            
          else 
           write(nwr,'(5x,a,i2,a,i2,a2,a,i2)')                          &
     &     htext(:i),lstruct1,'    layer(',lay,'):','  with site ',is_a 
          end if 
         else 
!         i+5+2                                                         
          i10=(i+7)/10 
          i1=i+7-10*i10 
          ch2=char(i10+i0)//char(i1+i0) 
          if(ii.gt.0) then 
           write(nwr,'('//ch2//'x,a,i2,a2,a,i2,a,i2)')                  &
     &     '    layer(',lay,'):','    sites from ',is_a,' to ',is_e     
          else 
           write(nwr,'('//ch2//'x,a,i2,a2,a,i2)')                       &
     &     '    layer(',lay,'):','  with site ',is_a                    
          end if 
                                                                        
         end if 
        end do 
       end do 
       b_inc=.true. 
      else 
       mlay=istruct1(mstruct1) 
       iset_e=0 
       iset_a=maxthss 
       do lay=1,mlay 
        is_a=istruct2(lay-1)+1 
        is_e=istruct2(lay) 
        htext=text(1) 
        if(is_a.lt.iset_a) iset_a=is_a 
        if(is_e.gt.iset_e) iset_e=is_e 
        if(is_e.ge.is_a)                                                &
     &      write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',       &
     &      htext(1:24),' sites from ',is_a,' to ',is_e                 
       end do 
       if(istruct2(mlay).lt.2) then 
        write(nwr,'(a)') '**  there are no sub-spectra ** ' 
        return 
       end if 
       b_inc=.false. 
      end if 
                                                                        
                                                                        
  809 continue 
      if(b_inc) then 
       write(nwr,'(/,a,a)') ' sub-spectrum_j',                          &
     & ' of incoherent parts(ji) of the scatterer sites(ki).',          &
     &    ' Number j (h-ide), p*art=j1...jn  s*ite=k1...kn'             
      else 
       write(nwr,'(/,a,a)') ' sub-spectrum_j',                          &
     & ' of the scatterer. Number j (h), site: k1...kn'                 
      end if 
                                                                        
  810  i=1 
       n_subset=0 
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0) 
        ch1=' ' 
        j_int=n_int(i,0) 
        if(j_int.lt.0) ch1='h' 
        j_int=abs(j_int) 
        if(b_inc) then 
         jj=1 
         do while(n_int(i,jj).gt.maxthss)             ! ?? 5.3  
          jj=jj+1 
         end do 
         j_intp=jj-1 
!         write(6,'(a,4i4)')'select j_intp,j_int=',j_intp,j_int         
         jj=j_int-j_intp 
         if(jj.gt.9) then 
          i10=jj/10 
          i1=jj-10*i10 
          chs=char(i10+i0)//char(i1+i0)//'i4' 
         else 
          chs=char(jj+i0)//'i4' 
         end if 
         chp=char(j_intp+i0)//'i4' 
         ch2='i1' 
         if(i.gt.9) ch2='i2' 
!         write(6,'(a,4(2x,a))')'select chs,chp,ch2=',chs,chp,ch2       
         write(nwr,'(a,'//ch2//'a1,a,'//chp//',a,'//chs//')')           &
         ' sub-spectrum_',i,ch1,                                        &
         ' part=',(n_int(i,jj)-2*maxthss,jj=1,j_intp),                  &
                       ' site=',(n_int(i,jj),jj=j_intp+1,j_int)        
        else                       ! ?? 5.3   
         jj=j_int 
         if(jj.gt.9) then 
          i10=jj/10 
          i1=jj-10*i10 
          chs=char(i10+i0)//char(i1+i0)//'i4' 
         else 
          chs=char(jj+i0)//'i4' 
         end if 
         ch2='i1' 
         if(i.gt.9) ch2='i2' 
!         write(6,'(a,4(2x,a))')'select chs,ch2=',chs,ch2               
         write(nwr,'(a,'//ch2//'a1,a1,'//chs//')')                      &
         ' sub-spectrum_',i,ch1,' ',(n_int(i,jj),jj=1,j_int)            
        end if 
        if(ch1.eq.' ') n_subset=i 
        i=i+1 
        if(i-1.eq.maxsub) goto 811 
       end do 
  811  n_ssub=i-1 
                                                                        
  820  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/input' 
        call help(chcom) 
        goto 809 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 810 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
                                                                        
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a,i3)') ' maximal number of sub-spectra ',maxsub 
          goto 810 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
     &    ' q*uit or * to leave command ss'                             
          goto 820 
        end if 
        if(iout.eq.1) then 
         if(ch132(1:1).eq.'h') then 
          if(n_int(iset,0).lt.0) then 
           n_int(iset,0)= abs(n_int(iset,0)) 
           do j=maxsub,2,-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub) then 
            do ji=0,maxss 
             n_int(1,ji)=n_int(iset+1,ji) 
             n_int(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_int(iset,0)=-abs(n_int(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(iset,ji) 
             n_int(iset,ji)=0 
            end do 
           end if 
           goto 840 
          end if 
         end if 
!        remove a sub-spectrum                                          
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_int(maxsub,ji)=0 
          end do 
!          write(6,'(8i3)')n_int                                        
         end if 
        end if 
                                                                        
!       write(6,'(a,10i4)') ' 1 out=',(int(out(j)),j=1,iout)            
                                                                        
!         write(6,'(2a)')'select ch132=',ch132(:60)                     
        ig1=index(ch132,'=') 
        ig2=index(ch132(ig1+1:),'=')+ig1 
        cp132=ch132(ig1+1:ig1+3) 
!         write(6,'(a,2i4)')'select ig1,ig2=',ig1,ig2                   
                                                                        
        if(b_inc.and.(ig1.eq.0.or.ig2.eq.0)) then 
         write(nwr,'(a)')                                               &
     &    '**** at least one part(=) and one scatterer site(=)'         
          goto 820 
        end if 
        if(.not.b_inc) then 
         max=iset_e-iset_a+1 
!         write(6,'(a,2i4,2x,a)')'select iset_e,iset_a,ch132=',         
!     &                  iset_e,iset_a,ch132(:40)                       
         i=1
         call seqnum(ch132,max,npanum,i)
         if(i.ne.1) goto 840  
         iout=npanum(2) 
         if(iout.ge.1) then 
!         write(6,'(a,10i4)') ' 2 out=',(int(out(j)),j=1,iout)          
          n_int(iset,0)=0 
          jscatterer=0 
          do j=1,iout 
           nn=npanum(j+2) 
           if(nn.gt.is_e) then 
            write(nwr,'(a,i5,a)') ' ***',nn,' is not a site' 
           else 
            if(jscatterer.lt.maxss) then 
             jscatterer=jscatterer+1 
             n_int(iset,jscatterer)=nn 
            else 
             write(nwr,'(a,i5,a)') ' *** qmaximum number',maxthss,       &
     &                            ' of sites reached'                   
            end if 
           end if 
          end do 
          n_int(iset,0)=jscatterer 
          if(jscatterer.eq.0) then 
           write(nwr,'(a)')                                             &
     &     '****  at least one site of the scatterer'                   
           goto 820 
          end if 
         end if 
        else 
!         write(6,'(2a)')'select ch132=',ch132(:60)                     
!         write(6,'(2a)')'select cp132=',cp132(:60)                     
         max=mstruct1 
         i=1
         call seqnum(cp132,max,npanum,i)
         if(i.ne.1) goto 840  
         iout=npanum(2) 
                                                                        
         if(iout.eq.0) then 
          write(nwr,'(a)')                                              &
     &    '****  at least one incoherent part of the scatterer'         
          goto 820 
         end if 
                                                                        
         n_int(iset,0)=0 
         j_intp=0 
         do j=1,iout 
          nn=npanum(2+j) 
          if(nn.gt.mstruct1) then 
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a part' 
          else 
           j_intp=j_intp+1 
           n_int(iset,j_intp)=nn+2*maxthss  ! ?? 5.
!           maxss -> mathss 7.5.2007                                    
          end if 
         end do 
                                                                        
                                                                        
         cp132=ch132(ig2+1:) 
         lay=istruct1(mstruct1) 
         is_e=istruct2(lay) 
         max=is_e 
         i=1
         call seqnum(cp132,max,npanum,i) 
         if(i.ne.1) goto 840 
         iout=npanum(2) 
         if(iout.eq.0) then 
          write(nwr,'(a)')                                              &
     &    '****  all sites of the incoherent parts are taken'           
          iout=0 
          do j=1,j_intp 
           jj=n_int(iset,j)-2*maxthss             ! ?? 5.3
!           maxss -> mathss 7.5.2007                                    
           layb=istruct1(jj-1)+1 
           laye=istruct1(jj) 
           iout=iout+2 
           npanum(2+2*j-1)=-istruct2(layb-1)-1 
           npanum(2+2*j)=-istruct2(laye) 
          end do 
         end if 
         j_int=0 
         do j=1,iout 
          nn=npanum(j+2) 
          if(nn.gt.is_e) then 
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a site' 
          else 
           if(j_int+j_intp.lt.maxss) then                   ! ?? 5.3  
            j_int=j_int+1 
            n_int(iset,j_intp+j_int)=nn 
           else 
           write(nwr,'(a,i5,a)') ' *** maximum number',maxss-j_intp,    &
     &                            ' of selected sites reached'                   
           end if 
          end if 
         end do 
         n_int(iset,0)=j_intp+j_int 
        end if 
!        write(6,'(a,10i4)')'n_int(1,0)=',(n_int(1,ji),ji=0,5)          
         jj=n_ssub 
         do i=1,maxsub-1 
          if(n_int(i,0).lt.0.and.n_int(i+1,0).gt.0) then 
           jj=jj+1 
           if(jj.le.maxsub) then 
            do ji=0,maxss 
             n_int(jj,ji)=n_int(i,ji) 
            end do 
           else 
            do ji=0,maxss 
             n_int(i,ji)=0 
            end do 
           end if 
          end if 
         end do 
         do i=1,maxsub 
          if(n_int(i,0).eq.0) then 
           do j=i,maxsub-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
         end do 
         goto 810 
       end if   ! * out      
                                                                        
  840 continue 
      return 
      END                                           
                                                                        
                                                                        
     subroutine syn_subset(m1,m3,cmch,isub,info) 
     use glbconst, only: max8,maxfr1,maxfr2,maxthss,maxsub,   &
                         icstrf,MDBPLFT
     use comdat, only: mfpt
     use complt, only: n_int,n_subset,n_sub,ndisplay_mode
     use comthe, only: real_fr,thfk    
     implicit none 

     character(len=4),intent(in):: cmch 
     integer ,intent(in):: m1,m3,isub
     integer,intent(out):: info

     integer,parameter ::istr=6+4*(maxfr1+maxfr2)+3*maxthss 
     character(len=64):: frthname 
     integer       dstr,iaddr
     common/struct/dstr(istr),frthname(2),iaddr(8)

     integer       nTH1,ifrth,ien   
     common/strLOC/nTH1,ifrth(11),ien(20)                    !13.9.05                  
                                                                       
     real             :: datx,errx,sym,subspectrum,daty,erry,parray,thfkd  
     integer,parameter:: max4=max8/2,                                    &
                         idumpl= max8*18+8*(max4+2)+4*(max4/2)+max4,     &
                         kdumpl=5*max4+max4*maxsub,                      &
                         ldumpl=MDBPLFT*2-idumpl-kdumpl
    common/plot/parray(idumpl),datx(max4),errx(max4),sym(max4),          &
                subspectrum(max4,maxsub),daty(max4),erry(max4),thfkd(ldumpl)

     real           dum,channels,dumcsp 
     common/acstrf/dum(9),channels,dumcsp(icstrf-10) 
                                                                       
     real      p0 
     real,dimension(maxthss):: plold,plold1,plold3 
                                                                       
     integer  i,ip,ia,ie,j,jj,k,k1,l,ll,llm,lj,n1,nexp,nthe 
                                                                       
       nexp=channels 
       nthe=nTH1*2 
                                                                        
      if(cmch.eq.'subs') then 
       call calpl('test') 
                                                                        
       do  i=1,m1 
        plold1(i)=0. 
       end do 
       do  i=1,m3 
        plold3(i)=0.0 
       end do 
                                                                        
       do  i=1,m1 
        j=-(2*maxthss+i) 
        call replace_wi(j,plold1(i),info)  ! - take out and write on plo
       end do 
       do  i=1,m3 
        call replace_wi(-i,plold3(i),info)  ! - take out and write on pl
       end do 
!       write(6,'(a,10f8.2)')'frame02 plold1()=',(plold1(i),i=1,m1)     
!       write(6,'(a,10f8.2)')'frame02 plold3()=',(plold3(i),i=1,m3)     
                                                                        
       do  l=1,n_subset 
        p0=0.0 
        do  i=1,m1 
         j=2*maxthss+i 
         call replace_wi(j,p0,info)  ! + write 0 to wi values        
        end do 
                                                                        
        llm=n_int(l,0) 
        ll=0 
        do while(ll.lt.llm.and.n_int(l,ll).gt.0) 
         ll=ll+1 
        end do 
                                                                        
!        write(6,'(a,2i4)')' frame02 ll,llm=',ll,llm                    
        if(ll.eq.llm.and.n_int(l,llm).gt.0) then 
         do  i=1,m3 
          call replace_wi(i,p0,info)  ! + write 0 to wi values      
         end do 
        end if 
!      write(6,'(a,i4,a,5i4)')' l_subsp=',l,                            
!     &         ' n_int(l,ll)=',(n_int(l,ll),ll=1,4)                    
        ll=1 
        do while(ll.le.llm.and.n_int(l,ll).gt.0 ) 
         ip=n_int(l,ll) 
         if(ip.gt.maxthss) then 
          i=ip-2*maxthss 
!          write(6,'(a,2i4,f10.3)')'frame02 ip,plold1(i)=',ip,i,plold1(i
                                              ! + write plold(ip) to wi 
          call replace_wi(ip,plold1(i),info) 
         else 
!          write(6,'(a,2i4,f10.3)')'frame02 ip,plold3(i)=',ip,i,plold3(i
                                               ! + write plold(ip) to wi
          call replace_wi(ip,plold3(ip),info) 
         end if 
         if(ll.eq.llm) goto 10 
         ll=ll+1 
        end do 
   10   continue 
!       ll le llm is now guaranteed      8.2.06                         
                                                                        
        if(ll.lt.llm) then 
         do lj=ll,llm,2 
          ia=-n_int(l,lj) 
          ie=-n_int(l,lj+1) 
          do ip=ia,ie 
!          write(6,'(a,i4,f10.3)')'frame02 ip,plold3(ip)=',ip,plold3(ip)
           call replace_wi(ip,plold3(ip),info) 
          end do 
         end do 
        end if 
                                                                        
        k1=3 
        call syn_the2exp(k1,info) 
                                                                        
        j=nexp 
        if(ndisplay_mode.eq.1)j=nthe 
         do  i=1,j 
          subspectrum(i,l)=thfk(i) 
         end do 
!        end if                                                         
       end do 
                                                                        
       do  i=1,m1 
        j=2*maxthss+i 
        call replace_wi(j,plold1(i),info)  ! + write plold(jj) to wi val
       end do 
       do  i=1,m3 
        call replace_wi(i,plold3(i),info)  ! + write plold(jj) to wi val
       end do 
      end if  !  cmch=subs,test   
                                                                        
                                                                        
                                                                        
      if(cmch.eq.'subt') then 
!     write(6,'(a,i4)') ' ********** m1=',m1                            
                                                                        
       call calpl('test') 
        do  i=1,m1 
        call replace_wi(-i,plold(i),info)  ! - take out and write on plo
       end do 
!      write(6,'(a,i2,a2,f15.5)') ' plold(',i,')=',plold(i)             
!      subtract y - yy                                                  
!      absorber complete , source and detector window subtracted        
                                                                        
                                                                        
       nexp=channels 
       do k=1,nexp 
        daty(k)=real_fr(mfpt+k) 
       end do 
                                                                        
       p0=0.0 
       do j=1,isub 
        do i=1,m1 
         call replace_wi(i,p0,info)          ! + write 0 to wi values  
        end do 
                                                                        
        do i=1,n_sub(j,0) 
         jj=abs(n_sub(j,i)) 
         call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi v
        end do 
                                                                        
        k1=3 
        call syn_the2exp(n1,info) 
                                                                        
!      write(6,'(a)') ' ------1----back in subtract----------------'    
        do i=1,nexp 
         daty(i)=daty(i)-thfk(i) 
        end do 
       end do  ! isub   
                                                                        
!      calculation of the theory of the stripped spectrum               
       p0=0.0 
       do i=1,m1 
        call replace_wi(i,p0,info)  ! + write 0.0 to wi values  
       end do 
                                                                        
       do i=1,n_sub(0,0) 
        jj=n_sub(0,i) 
        call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi va
       end do 
                                                                        
       k1=3 
         ! values are not reset by calpl, written on theory-array       
       call syn_the2exp(k1,info) 
                                                                        
!      write(6,'(a)') ' ------2----back in subtract----------------'    
!      restore parameters                                               
       call calpl('test') 
      end if  ! cmch='subt' 
                                                                        
      k1=3 
      call syn_the2exp(k1,info) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
      SUBROUTINE INDEXi(N,IRRIN,INDX)
      implicit none
      integer N,J,L,I,IR,INDXT
      integer,DIMENSION(N):: IRRIN,INDX 
      real    Q
      DO  J=1,N 
        INDX(J)=J 
      END DO 
      L=N/2+1 
      IR=N 
   10 CONTINUE 
        IF(L.GT.1)THEN 
          L=L-1 
          INDXT=INDX(L) 
          Q=IRRIN(INDXT) 
        ELSE 
          INDXT=INDX(IR) 
          Q=IRRIN(INDXT) 
          INDX(IR)=INDX(1) 
          IR=IR-1 
          IF(IR.EQ.1)THEN 
            INDX(1)=INDXT 
            RETURN 
          ENDIF 
        ENDIF 
        I=L 
        J=L+L 
   20   IF(J.LE.IR)THEN 
          IF(J.LT.IR)THEN 
            IF(IRRIN(INDX(J)).LT.IRRIN(INDX(J+1)))J=J+1 
          ENDIF 
          IF(Q.LT.IRRIN(INDX(J)))THEN 
            INDX(I)=INDX(J) 
            I=J 
            J=J+J 
          ELSE 
            J=IR+1 
          ENDIF 
        GO TO 20 
        ENDIF 
        INDX(I)=INDXT 
      GO TO 10 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
    subroutine channels_adjust(nvch,nhyperfine,nstrob_order,nomega,iall) 
    use glbconst, only: maxn,maxscrd
    implicit none

!      the routine calculates channels needed for a nonequidistant     
!      channel numbers for all later shifts +- nomega in the stoboscopi
!      integration                                                     
!      iall is limited by maxn -> -maxn:maxn are the size of arrays    
       integer,intent(in) :: nvch,nhyperfine,nstrob_order,nomega
       integer,intent(out):: iall


       integer ichall,idumscrd                                 
       common/scrd/ichall(0:maxn*2),idumscrd(maxscrd-1-maxn*2) 

       integer    i,j,k,kk,kom,mcht,n,nn

       integer,dimension(:), allocatable:: inp,ichh,IRRIN,INDX
 
      iall=0 
       DO n=0,nstrob_order 
        kom=n*nomega/2 
        mcht=kom+nhyperfine 
        j=3*mcht+nvch*2+2
        iall=iall+j+1
       END DO
       nn=iall

      allocate(inp(-nn:nn),ichh(0:nn),IRRIN(nn),INDX(nn))

      iall=0 
      DO n=0,nstrob_order 
!      +-m =2m eqidistant steps,                                       
       kom=n*nomega/2 
        mcht=kom+nhyperfine 
        do i=0,mcht 
         inp(i)=i 
        end do 
        do i=1,mcht 
         inp(mcht+i)=i+kom 
        end do 
        j=2*mcht+1 
        do i=kom,mcht 
         inp(j+i)=i-kom 
        end do 
        j=3*mcht-kom+1 
        do i=1,nvch 
         inp(j+i)=mcht+i*(i+1)/2+kom 
        end do 
        j=3*mcht-kom+1+nvch 
        do i=1,nvch 
         inp(j+i)=mcht+i*(i+1)/2-kom 
        end do 
                                                                       
        j=3*mcht-kom+1+nvch*2 
        if(iall+j.gt.nn) then 
         iall=-iall-j 
!         write(6,'(a,i6)')' nn zu klein iall+j=',-iall                
         return 
        end if 
        do i=0,j 
         IRRIN(i+1+iall)=inp(i) 
        end do 
        iall=iall+j+1
 
!        write(6,'(a,i7)')' before iall=',iall                         
        call INDEXi(iall,IRRIN,INDX) 
        do k=1,iall 
         ichh(k)=IRRIN(INDX(k)) 
        end do 
!        print '(a )', 'before             elimination'                
!        print '(20i5)',(ichh(i),i=1,iall)                             
!        print '(20i5)',(ichh(i),i=1,iall/2)                           
!        print '(20i5)',(ichh(i),i=iall/2+1,iall)                      
!        print '(20i5)',n,kj,m,nomega,nvch                             
!        read(5,'(a)')                                                 
                                                                       
        k=0 
!       elimination of multiple indices                                
  400   k=k+1 
        if(ichh(k).eq.ichh(k+1))then 
         iall=iall-1 
         do kk=k+1,iall 
          ichh(kk)=ichh(kk+1) 
         end do 
         k=k-1 
         ichh(iall+1)=0 
        end if 
        if(k.lt.iall-1) goto 400 
        do i=1,iall 
         IRRIN(i)=ichh(i) 
        end do 
!       print '(a )', 'after elimination'                              
!       print '(20i5)',(ichh(i),i=1,iall)                              
!       read(5,'(a)')                                                  
!       end do  ! +-nomega                                             
!       write(6,'(a,i7)')' after  iall=',iall                          
                                                                       
!       for all nStrobo                                         
      END DO 
!      print '(" order  ")'                                            
!      print '(" iall,nvch,nhyperfine= ",5i6)',iall,nvch,nhyperfine    
      ichall(0)=0 
      if(iall.le.2*maxn)then 
       do k=1,iall 
        ichall(k)=ichh(k) 
       end do 
      else 
       iall=-iall 
      end if 
      deallocate(inp,ichh,IRRIN,INDX)
                                                                       
      return 
     END                                           
                                                                        
                                                                        
      subroutine ot_theo(i_3d,ab_the,iaset,xb_the,dx_the,yb_the,dy_the) 
      use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd
      use comthe, only: array_fr      
      implicit none 

      integer,intent(out),dimension(128):: iaset
      real,intent(out)   ,dimension(128):: ab_the
      integer,intent(out):: i_3d
      real,intent(out)   :: xb_the,dx_the,yb_the,dy_the 

      integer,parameter ::istr=3*maxfr2+3*maxthss+2*(maxfr1+1)+32 
      integer       mstruct1,istruct1,istruct2,l1_get,idum,nstorTH,iaddr
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    l1_get(0:maxfr1),idum(istr+2),nstorTH,iaddr(5)

      integer       nTH1,ien
      common/strLOC/nTH1,ien(31)                      

      integer     icase,k_omega,n_omega,i_theta,n_theta,i_angle,j,ig 
      real        omega,omega_beg,domega,omega_end,grazinc,grazout,     &
                  theta,theta_beg,dtheta,theta_end                      

      integer,parameter ::iscrd=maxscrd-128*128 
      integer     jth,idscrd
      common/scrd/jth(-3:124,-3:124),idscrd(iscrd) 
                                                                        
!      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega                
       icase=int(real(array_fr(l1_get(0)+1))) 
       n_omega=int(real(array_fr(l1_get(0)+2))) 
       n_theta=int(aimag(array_fr(l1_get(0)+2))) 
       omega_beg=real(array_fr(l1_get(0)+3)) 
       domega=aimag(array_fr(l1_get(0)+3)) 
       theta_beg=real(array_fr(l1_get(0)+4)) 
       dtheta=aimag(array_fr(l1_get(0)+4)) 
       omega_end=real(array_fr(l1_get(0)+5)) 
       theta_end=aimag(array_fr(l1_get(0)+5)) 
                                                                        
!       write(6,'(6f10.1)')(array_fr(l1_get(0)+j),j=1,5)                
                                                                        
       nstorTH=l1_get(0)+6             ! see th_scanmode()  
       nTH1=real(array_fr(l1_get(0)+6)) 
!       write(6,'(a,i4,4x,3f10.4)')'n_theta,theta_beg,dtheta,theta_end=',&              
!       n_theta,theta_beg,dtheta,theta_end                            
      jth=0
      i_3d=0 

      if(icase.eq.3) i_3d=1 
      if(icase.eq.4) i_3d=-1 
      iaset=0
      iaset(1)=0 
      i_angle=0 
      do i_theta=1,n_theta 
       theta=theta_beg+dtheta*(i_theta-1) 
       ig=0 
       do k_omega=1,n_omega 
        omega=omega_beg+domega*(k_omega-1) 
                                                                        
        if(icase.eq.1.or.icase.eq.4) then 
          grazinc=omega 
          grazout=theta 
        else if(icase.eq.2.or.icase.eq.3) then 
           grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta 
           grazout=2*omega_beg+domega*(n_omega-1)+                      &
     &       (i_theta-1)*dtheta*2-grazinc                               
        else if(icase.eq.5) then 
!        PHI_s=omega N_s=n_omega                                        
         j=i_theta/2 
         if(2*j.eq.i_theta) then 
!         + dTheta_out                                                  
          grazinc=omega 
          grazout=(omega+dtheta*j) 
         else 
!         + dTheta_out                                                  
          grazinc=(omega+dtheta*j) 
          grazout=omega 
         end if 
         if(omega+dtheta*j.gt.omega_end)goto 77 
        end if 
        i_angle=i_angle+1 
        jth(k_omega-1,i_theta-1)=i_angle 
                                                                        
        ig=ig+1 
        if(ig.eq.1)then 
         ab_the(i_theta)=grazinc 
        end if 
                                                                        
   77   continue 
!       write(6,'(a,3i6)')'ot ',i_angle,k_omega-1,i_theta-1             
                  ! n_omega                                             
       end do 
       iaset(i_theta+1)=i_angle 
                  ! n_theta                                             
       end do 
!       write(6,'(10i5)')iaset
       xb_the=omega_beg 
       dx_the=domega 
       yb_the=theta_beg 
       dy_the=dtheta

!       write(6,'(a,4f12.2)')'xb_the,dx_the,yb_the,dy_the=',            
!     &      xb_the,dx_the,yb_the,dy_the                                
       return 
      END                                           
                                                                        
                                                                        
                                                                        
       subroutine opticN(mlay,b_Cm,MAXGRP,GEOSTR,SFI,                   &
                           Kmatrix,roughlay,VKD,Rmatrix)               
!                                                                       
! ******************************************************************    
!                                                                       
!                              OPTICS                                   
!                                                                       
!          Reflectivity calculation of anisotropic multilayers          
!          in the Mossbauer case. 1mrad<FI<10mrad, K~1.E-5.             
!                                                                       
!          (method of G. H. Borzbov et. al. - L. Deak et. al.)          
!                                                                       
!                         Laszlo Deak                                   
!                                                                       
!                         Budapest, 1995. July                          
!                         Mainz, 2002. October                          
!                                                                       
!                         Khaidukov Yuri                                
!	                  Budapest, 2003. April-May                           
!                                                                       
! *****************************************************************     
! Geometry:                                                             
!               incident        reflected                               
!                                                                       
!                        \    /                                         
!                         \  /                                          
!                      FI (\/                                           
!      Z=0>           -------------                                     
!           covering  _____________         [D(1),K(1,I,J)]             
!                                  >Layer#1 [D(2),K(2,I,J)]             
!                 1.  .............                                     
!                           .                                           
!                           .                                           
!                     .............                                     
! Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]       
!       I                                                               
!          substrate  _____________         [D(NL),K(NL,I,J)]           
!                            `                 ^                        
!                              `            infinit or finit            
!                             refracted                                 
!  Variables of system:                                                 
!                                                                       
!  INPUT:                                                               
!                           covering   layer #L     substrate           
!                                                                       
!            thickneses:         D(1)     D(L)        D(NL)             
!        susceptibility:                                                
!        (nuclear+electronic)    K(1)     K(L)        K(NL)          
!                                                                       
!         where  L=1..NL  I,J=1,2,3                                     
!                                                                       
!  OUTPUT:                                                              
!                                                                       
!         The 2x2 complex reflectivity (or transmitivity) matrix:  R    
! ******************************************************************    
!       subroutine opticN(mlay,b_Cm,MAXGRP,GEOSTR,SFI,Kmatrix,      
!                                        roughlay,VKD,Rmatrix)               
!                                                                       
       implicit none 
!   input:                                                              
       integer,intent(in):: mlay,MAXGRP 
       real (kind=8),intent(in):: SFI
       logical,intent(in),dimension(mlay):: b_Cm 
       integer,intent(in),dimension(0:2*MAXGRP)::GEOSTR
       real (kind=8),intent(in),dimension(mlay)::roughlay,VKD 
       complex(kind=8),intent(in),dimension(2,2,mlay) :: Kmatrix 

!      NL=mlay: number of layers  (in period)( not expicitly used)      
       complex(kind=8),intent(out),dimension(2,2):: Rmatrix

!      other variables: 
       complex(kind=8),dimension(2,2):: KL,KLprev 
       real(kind=8)    :: DL 
       complex(kind=8),dimension(4,4):: M,ML,MS
       complex(kind=8),parameter:: C0=(0.D0,0.D0), C1=(1.D0,0.D0),    &
                                    CI=(0.D0,1.D0) 
       logical    b_odz,b_first,b_grp,both_dgnl,prev_dgnl 
       integer    I,J,L,n_rep,GRP,LMIN,LMAX,Lprev,POINTER,NLOG 
       real       absCmatr,absMatr 
                                                                        
!      print *,b_Cm	                                                    
!      print *,SFI                                                      
!      print *,MAXGRP                                                   
!      print *,GEOSTR                                                   
!      print *,chilay                                                   
!      print *,VKD                                                      
                                                                        
       b_first     =.true. 
       POINTER=0 
       do GRP=1,MAXGRP       ! loop for the groups  
!       To set the characteristic matrix to unit matrix                 
        ML=C0
        do I=1,4 
         ML(I,I)=C1 
        end do 
                                                                        
        b_grp=.false. 
!                                                                       
        LMIN =POINTER+1 
        LMAX =POINTER+GEOSTR(2*GRP) 
        n_rep=GEOSTR(2*GRP-1) 
!                                                                       
        do L=LMIN,LMAX 
         DL=VKD(L) 
         if(DL.ne.0.) then 
          if(DL.lt.0)DL=1.0d30 
          b_odz=.false. 
          b_grp=.true. 
          if(b_Cm(L))then 
           KL(1,1)=Kmatrix(1,1,L) 
           KL(1,2)=Kmatrix(1,2,L) 
           KL(2,1)=Kmatrix(2,1,L) 
           KL(2,2)=Kmatrix(2,2,L) 
                                                                        
           absCmatr=dreal( KL(1,2)*conjg( KL(1,2))+                     &
     &                    KL(2,1)*conjg( KL(2,1)))                      
           if(absCmatr.lt.1.e-15) b_odz=.true. 
          else 
           KL(1,1)=Kmatrix(1,1,L) 
           KL(1,2)=Kmatrix(1,2,L) 
           KL(2,1)=Kmatrix(2,1,L) 
           KL(2,2)=Kmatrix(2,2,L) 
           b_odz=.true. 
          end if 
                                                                        
          call genM(b_odz,SFI,DL,KL,M) 
                                                                        
! --------------------Roughness calculation of Y. Khaidukov:------------
        if(roughlay(L).gt.0.d0) then 
           if(n_rep.gt.1.and.L.eq.Lmin) then  ! In case of repeating lay
          Lprev=Lmax                          ! we are more interested in the
         else                                 ! information about roughnes
                                              ! in repeated ones.               
          Lprev=L-1                           ! Khaidukov 
         endif                                ! n_rep.gt.1.and.L.eq.Lmin 
                                                                        
         do I=1,2 
          do J=1,2 
           if (Lprev.eq.0) then 
            KLprev(I,J)=C0         ! In case of 1st layer KLprev is for 
            prev_dgnl=.true.       ! This variable for check the diagona
           endif 
                                                                        
             if (Lprev.gt.0) then 
              prev_dgnl=.not.b_Cm(Lprev) 
              KLprev(I,J)=Kmatrix(I,J,Lprev) 
             end if
           end do  ! J   
         end do  ! I 
         absMatr=real(dble(                                           &
                   (KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+ &
                   (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1)))))
                                            
           if(prev_dgnl.and.b_odz) then        ! If susceptibility of bot 
            both_dgnl=.true.                   ! are diagonal we give tru 
           elseif (absMatr.lt.1.e-15) then     ! for roughness subroutine 
            both_dgnl=.true. 
           else 
            both_dgnl=.false. 
           endif 
           call roughness(both_dgnl,roughlay(L),SFI,KLprev,KL,M) 
          endif 
! --------------------end of Roughness calculation ---------------      
          call mat4(M,ML,ML) 
         endif  ! VKD(L)>0.   
        end do  ! L
                                                                        
!     For periodic multilayers the int. propagation matrix is (ML)**n_re
!     where n_rep is the number of periods.                             
!                                                                       
!                                                                       
        if(n_rep.gt.1.and.b_grp)then 
         do I=1,4 
          do J=1,4 
           M(I,J)=ML(I,J) 
          end do 
         end do 
!                                                                       
         NLOG=alog(float(n_rep))/alog(2.0) 
!                                                                       
         do I=1,NLOG 
          call mat4(ML,ML,ML) 
         end do 
                                                                        
         do I=1,n_rep-2**NLOG 
          call mat4(M,ML,ML) 
         end do 
        end if  ! n_rep>1 
                                                                        
        if(b_first) then 
         b_first=.false. 
         MS=ML 
        else 
         call mat4(ML,MS,MS) 
        end if 
!                                                                       
        POINTER=POINTER+GEOSTR(2*GRP) 
       end do   ! GRP     
!                                                                       
!     Now we have the integreted propagation matrix of the structure: ML
!     Calculation of reflectivity matrix (2x2):                         
!                                                                       
      call refl(MS,Rmatrix) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
       subroutine optic(mlay,b_Cm,MAXGRP,GEOSTR,SFI,Cmatrix,       &
                                     chilay,roughlay,VKD,Rmatrix)                
!                                                                       
! ******************************************************************    
!                              OPTICS                                   
!                                                                       
!          Reflectivity calculation of anizotropic multilayers          
!          in the Mossbauer case. 1mrad<FI<10mrad, K~1.E-5.             
!                                                                       
!          (method of G. H. Borzbov et. al. - L. Deak et. al.)          
!                                                                       
!                         Laszlo Deak                                   
!                                                                       
!                         Budapest, 1995. July                          
!                         Mainz, 2002. October                          
!                                                                       
!                         Khaidukov Yuri                                
!	                  Budapest, 2003. April-May                           
!                                                                       
! *****************************************************************     
! Geometry:                                                             
!               incident        reflected                               
!                                                                       
!                        \    /                                         
!                         \  /                                          
!                      FI (\/                                           
!      Z=0>           -------------                                     
!           covering  _____________         [D(1),K(1,I,J)]             
!                                  >Layer#1 [D(2),K(2,I,J)]             
!                 1.  .............                                     
!                           .                                           
!                           .                                           
!                     .............                                     
! Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]       
!       I                                                               
!          substrate  _____________         [D(NL),K(NL,I,J)]           
!                            `                 ^                        
!                              `            infinit or finit            
!                             refracted                                 
!                                                                       
!  Variables of system:                                                 
!                                                                       
!  INPUT:                                                               
!                           covering   layer #L     substrate           
!                                                                       
!            thickneses:         D(1)     D(L)        D(NL)             
!        susceptibility:                                                
!        (nuclear+electronic)    K(1)     K(L)        K(NL) 
!                                                                       
!         where  L=1..NL  I,J=1,2,3                                     
!                                                                       
!  OUTPUT:                                                              
!         The 2x2 complex reflectivity (or transmitivity) matrix:  R    
!                                                                       
! ******************************************************************    
!       subroutine optic(mlay,b_Cm,MAXGRP,GEOSTR,SFI,Cmatrix,      
!     &                      chilay,roughlay,VKD,Rmatrix)               
!                                                                       
!                                                                       
!                                                                       
       implicit none 
!   input:
       integer ,intent(in):: mlay,MAXGRP 
       real,    intent(in):: SFI                                                              
       logical,intent(in),dimension(mlay):: b_Cm
       integer,intent(in),dimension(0:2*MAXGRP):: GEOSTR
       real,intent(in),dimension(mlay):: roughlay,VKD

       complex(kind=4),intent(in),dimension(2,2,mlay) :: Cmatrix
       complex(kind=4),intent(in),dimension(mlay) :: chilay
       complex(kind=4),intent(out),dimension(2,2) :: Rmatrix 
!      NL=mlay: number of layers  (in period)( not expicitly used)      
!      other variables:                                                 
       integer    I,J,L,n_rep,GRP,LMIN,LMAX,Lprev,POINTER,NLOG 
       real       absCmatr,absMatr 
       real(kind=8) :: sinFI, DL,sigma 
       complex(kind=8),dimension(2,2) :: R,KL,KLprev,UnMat
       complex(kind=8),dimension(4,4) :: M,ML,MS
       logical    b_odz,b_first,b_grp,both_dgnl,prev_dgnl 
       complex(kind=8),parameter :: C0=(0.D0,0.D0), C1=(1.D0,0.D0),     &
                                    CI=(0.D0,1.D0) 
                                                                        
       UnMat(1,1)=C1 
                      !Unit matrix                                      
       UnMat(1,2)=C0 
       UnMat(2,1)=C0 
       UnMat(2,2)=C1 
                                                                        
!      print *,b_Cm	                                                    
!      print *,SFI                                                      
!      print *,MAXGRP                                                   
!      print *,GEOSTR                                                   
!      print *,chilay                                                   
!      print *,VKD                                                      
!      read(5,'(a)')                                                    
                                                                        
       sinFI=sin(dble(SFI)) ! the double precision grazing angle   
!                                                                       
       b_first     =.true. 
       POINTER=0 
       do GRP=1,MAXGRP      ! loop for the groups    
!       To set the characteristic matrix to unit matrix                 
        ML=C0
        do I=1,4 
         ML(I,I)=C1 
        end do 

        b_grp=.false. 
        LMIN =POINTER+1 
        LMAX =POINTER+GEOSTR(2*GRP) 
        n_rep=GEOSTR(2*GRP-1) 
!                                                                       
        do L=LMIN,LMAX 
         if(VKD(L).gt.0.) then 
          b_odz=.false. 
          b_grp=.true. 
          DL=VKD(L) 
          if(b_Cm(L))then 
           KL(1,1)=Cmatrix(1,1,L)+chilay(L) 
           KL(1,2)=Cmatrix(1,2,L) 
           KL(2,1)=Cmatrix(2,1,L) 
           KL(2,2)=Cmatrix(2,2,L)+chilay(L) 
           absCmatr=dreal( KL(1,2)*conjg( KL(1,2))+                     &
     &                    KL(2,1)*conjg( KL(2,1)))                      
           if(absCmatr.lt.1.e-15) b_odz=.true. 
          else 
           KL(1,1)=chilay(L) 
           KL(1,2)=C0 
           KL(2,1)=C0 
           KL(2,2)=chilay(L) 
           b_odz=.true. 
          end if 
                                                                        
          call genM(b_odz,sinFI,DL,KL,M) 

! --------------------Roughness calculation of Y. Khaidukov:------------
        if(roughlay(L).gt.0.) then 
           if(n_rep.gt.1.and.L.eq.Lmin) then  ! In case of repeating lay
          Lprev=Lmax                          ! we are more interested in the
         else                                 ! information about roughnes
                                              ! in repeated ones.               
          Lprev=L-1                           ! Khaidukov 
         endif                                ! n_rep.gt.1.and.L.eq.Lmin 
                                                                        
         do I=1,2 
          do J=1,2 
           if (Lprev.eq.0) then 
            KLprev(I,J)=C0         ! In case of 1st layer KLprev is for 
            prev_dgnl=.true.       ! This variable for check the diagona
           endif 
                                                                        
             if (Lprev.gt.0) then 
              prev_dgnl=.not.b_Cm(Lprev) 
            if(b_Cm(Lprev))then 
               KLprev(I,J)=Cmatrix(I,J,Lprev)+chilay(Lprev)*UnMat(I,J) 
              else 
               KLprev(I,J)=chilay(Lprev)*UnMat(I,J) 
              endif 
            endif 
           end do  ! J   
         end do  ! I 
         absMatr=real(dble(                                           &
                   (KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+ &
                   (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1)))))
                                            
           if(prev_dgnl.and.b_odz) then        ! If susceptibility of bot 
            both_dgnl=.true.                   ! are diagonal we give tru 
           elseif (absMatr.lt.1.e-15) then     ! for roughness subroutine 
          both_dgnl=.true. 
           else 
          both_dgnl=.false. 
           endif
           sigma=roughlay(L)       ! sigma of kind=8 is needed
           call roughness(both_dgnl,sigma,sinFI,KLprev,KL,M) 
          endif 
! --------------------end of Roughness calculation --------------- 
          call mat4(M,ML,ML) 
         endif   ! VKD(L)>0.   
        end do   ! L 
                                                                        
!     For periodic multilayers the int. propagation matrix is (ML)**n_re
!     where n_rep is the number of periods.                             
                                                                       
        if(n_rep.gt.1.and.b_grp)then 
         M=ML 
         NLOG=alog(float(n_rep))/alog(2.0) 
                                                                       
         do I=1,NLOG 
          call mat4(ML,ML,ML) 
         end do 
                                                                        
         do I=1,n_rep-2**NLOG 
          call mat4(M,ML,ML) 
         end do 
        end if  ! n_rep>1   
                                                                        
        if(b_first) then 
         b_first=.false. 
         MS=ML 
        else 
         call mat4(ML,MS,MS) 
        end if 
        POINTER=POINTER+GEOSTR(2*GRP) 
       end do  ! GRP  
!                                                                       
!     Now we have the integreted propagation matrix of the structure: ML
!     Calculation of reflectivity matrix (2x2):                         
      call refl(MS,R) 
      Rmatrix=R 

      return 
      END                                           
                                                                        
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
      subroutine refl(M,R) 
! *******************************************************************   
!                 Calculation of reflectivity matrix (2X2)              
! ******************************************************************    
      implicit none 
      complex(kind=8),intent(in),dimension(4,4) :: M
      complex(kind=8),intent(out),dimension(2,2):: R
      complex(kind=8):: AA,BB,CC,DD 
      complex(kind=8),dimension(2,2):: R1,R2,R11 
      integer    I,J 
                                                                       
!    Definition of 2x2 block matrices:                                  
                                                                       
      do I=1,2 
        do J=1,2 
          AA= M(I,J) 
          BB= M(I,J+2) 
          CC= M(I+2,J) 
          DD= M(I+2,J+2) 
          R1(I,J)= AA-BB-CC+DD 
          R2(I,J)= AA+BB-CC-DD 
        end do 
      end do 
                                                                       
      call inv2(R1,R11) 
      call mat2(R11,R2,R) 
                                                                       
      return 
      END      

! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	subroutine genM(b_odz,sinFI,DL,KL,M)

! ******************************************************************
!            Definition of the integral propagation matrix  
!                   (see  Eq. (3.20) in the paper)
! *****************************************************************

    implicit none
    logical,     intent(in):: b_odz 
    real(kind=8),intent(in):: DL,sinFI 
    complex(kind=8),intent(in), dimension(2,2) :: KL
    complex(kind=8),intent(out),dimension(4,4) :: M
                                                                        
    real(kind=8)    :: aimFFF,sin2FI,wave1,wave2,wa1,wa2
    complex(kind=8) :: sqdetFF,hTrFF,DLsq,DLhTr,Fpp,Fmm,Fmp,Fpm,    &
                       cwave1,cwave2,cwa1,cwa2,FFF,sinFFF,FF1
                            
    complex(kind=8),dimension(2,2):: exppF,FL,invF,M12,M21,FF,noTrFF,Im,Ip 
                                                                        
    complex(kind=8),parameter :: C0=(0.D0,0.D0),CI=(0.D0,1.D0),C1=(1.D0,0.D0)
    real(kind=8)   ,parameter :: aLIMIT=2.D1, sqdetcrit=1.D-7 
    integer    I,J 
                                                                        
!    New version: L.Deak, Budapest 15.04.2011 
!    Definition of F and X ( Eq. (3.20) L.Deak et al, Phys. Rev B 1996)

!    ( ch(vkd*FF)                  1/x*sh(vkd*FF) )
!    ( x*FF**(-1)*sh(vkd*FF)       ch(vkd*FF)     )

!    x= i*sin(FI)
!    FF=sqrt(-I*sin**2 FI-khi)


      sin2FI = sinFI*sinFI

      FF(1,1)=-sin2FI-KL(1,1)
      FF(1,2)=-KL(1,2)
      FF(2,1)=-KL(2,1)
      FF(2,2)=-sin2FI-KL(2,2)

!     b_odz==(FF(2,1).eq.C0).and.(FF(1,2).eq.C0)

      if(b_odz)then                   ! FF is diagonal matrix
       FF(1,1)=sqrt(FF(1,1))
       FF(1,2)=C0
       FF(2,1)=C0
       FF(2,2)=sqrt(FF(2,2))
       do I=1,2
        do J=1,2
         FL(I,J)    =DL*FF(I,J)
         exppF(I,J) =FL(I,J)
         M(I,J)     =C0
         M(I+2,J+2) =C0
         M(I,J+2)   =C0
         M(I+2,J)   =C0
        end do
       end do
       do J=1,2
        FF1   =FF(J,J)
        FFF   =FL(J,J)*CI        
        aimFFF=dimag(FFF)
        if(aimFFF.gt.aLIMIT)then
         M(J,J)    = C1
         M(J+2,J+2)= C1
         M(J,J+2)  =-CI*FF1/sinFI       
         M(J+2,J)  = CI/FF1*sinFI      ! aimFFF -> +infinit
!         write(*,*)'+inf'
        else
         if(aimFFF.lt.-aLIMIT)then
          M(J,J)    = C1
          M(J+2,J+2)= C1
          M(J,J+2)  = CI*FF1/sinFI
          M(J+2,J)  =-CI/FF1*sinFI     ! aimFFF -> -infinit
!          write(*,*)'-inf'
         else
          sinFFF    = sin(FFF)
          M(J,J)    = cos(FFF)
          M(J+2,J+2)= M(J,J)
          M(J,J+2)  =-sinFFF*FF1/sinFI
          M(J+2,J)  = sinFFF/FF1*sinFI ! general case
!          write(*,*)'general'
         end if
        end if
       end do      
      else

       FL=C0
       M=C0
       call sqrt2(FF,FF)          

       hTrFF= 0.5D0*(FF(1,1)+FF(2,2))

       noTrFF(1,1)= FF(1,1)-hTrFF             !   FF=sqrt[-I*sin**2(FI)-khi]
       noTrFF(1,2)= FF(1,2)                   !   noTrFF=FF-I*Tr(FF)/2
       noTrFF(2,1)= FF(2,1)                           
       noTrFF(2,2)= -noTrFF(1,1)

!      i*sqrt(det(noTrFF)=sqrt(-det(noTrFF))

       sqdetFF= sqrt(noTrFF(1,1)*noTrFF(1,1)+noTrFF(1,2)*noTrFF(2,1))
       DLsq   = DL*sqdetFF
       DLhTr  = DL*hTrFF
       
       if(abs(sqdetFF).gt.sqdetcrit)then
        do I=1,2
         do J=1,2
          Ip(I,J)= noTrFF(I,J)/sqdetFF
          Im(I,J)=-Ip(I,J)
         end do
         Ip(I,I)= Ip(I,I)+C1
         Im(I,I)= Im(I,I)+C1
        end do

        cwave1  =DLhTr+DLsq
        cwave2  =DLhTr-DLsq
         wave1  =dble(cwave1)
         wave2  =dble(cwave2)
        cwa1    =2.D0*DLsq
        cwa2    =2.D0*DLhTr
         wa1    =dble(cwa1)
         wa2    =dble(cwa2)

        if(abs(wave1).gt.abs(wave2))then
         if(wave1.ge.aLIMIT)then
          Fpp=0.25D0*C1
          Fmm=C0
          if(wa1.lt.aLIMIT)then
           Fpm=0.25*exp(-cwa1)
          else
           Fpm=C0
          endif
          if(wa2.lt.aLIMIT)then
           Fmp=0.25*exp(-cwa2)
          else
           Fmp=C0
          endif
         else if(-wave1.ge.aLIMIT)then            ! -wave1 gt aLIMIT
          Fpp=C0
          Fmm=0.25D0*C1
          if(-wa2.lt.aLIMIT)then
           Fpm=0.25*exp(cwa2)
          else
           Fpm=C0
          endif
          if(-wa1.lt.aLIMIT)then
           Fmp=0.25*exp(cwa1)
          else
           Fmp=C0
          endif
         else
          Fpp=0.25D0*exp(cwave1)
          Fmm=0.0625D0/Fpp
          Fpm=0.25D0*exp(cwave2)
          Fmp=0.0625D0/Fpm
         endif
        else 
         if(abs(wave2).gt.abs(wave1))then
          if(wave2.ge.aLIMIT)then
           Fpm=0.25D0*C1
           Fmp=C0
           if(-wa1.lt.aLIMIT)then
            Fpp=0.25*exp(cwa1)
           else
            Fpp=C0
           endif
           if(wa2.lt.aLIMIT)then
            Fmm=0.25*exp(-cwa2)
           else
            Fmm=C0
           endif
          else if(-wave2.ge.aLIMIT)then          ! -wave2 gt aLIMIT
           Fpm=C0
           Fmp=0.25D0*C1
           if(-wa2.lt.aLIMIT)then
            Fpp=0.25*exp(cwa2)
           else
            Fpp=C0
           endif
           if(wa1.lt.aLIMIT)then
            Fmm=0.25*exp(-cwa1)
           else
            Fmm=C0
           endif
          else
           Fpp=0.25D0*exp(cwave1)
           Fmm=0.0625D0/Fpp
           Fpm=0.25D0*exp(cwave2)
           Fmp=0.0625D0/Fpm
          endif
         endif
        endif
       else                              !determinat is small
        do I=1,2
         do J=1,2
          Ip(I,J)= DL*noTrFF(I,J)
          Im(I,J)=-Ip(I,J)
         end do
         Ip(I,I)= Ip(I,I)+C1
         Im(I,I)= Im(I,I)+C1
        end do

        cwave2  =DLhTr
        wave2   =dble(cwave2)
        
        if(wave2.gt.aLIMIT)then
         Fpp=0.5D0*C1
         Fmm=C0
         Fmp=C0
         Fpm=C0
        else if(-wave2.gt.aLIMIT)then
         Fpp=C0
         Fmm=C0
         Fmp=0.5D0*C1
         Fpm=C0
        else
         Fpp=0.5D0*exp(cwave2)
         Fmm=C0
         Fmp=0.5D0*exp(-cwave2)
         Fpm=C0
        endif
       endif

       if((Fpm.eq.C0).and.(Fmp.eq.C0))then
        do I=1,2
         M(I,I)    = (Fpp+Fmm)
         M(I+2,I+2)= M(I,I)
         FL(I,I)   = (Fpp-Fmm)
        enddo
       else if((Fpp.eq.C0).and.(Fmm.eq.C0))then 
        do I=1,2
          M(I,I)    = (Fpm+Fmp)
          M(I+2,I+2)= M(I,I)
          FL(I,I)   = (Fpm-Fmp)
        enddo
       else
        do I=1,2
         do J=1,2
          M(I,J)    = (Fpp+Fmm)*Ip(I,J)+(Fpm+Fmp)*Im(I,J)
          M(I+2,J+2)= M(I,J)
          FL(I,J)   = (Fpp-Fmm)*Ip(I,J)+(Fpm-Fmp)*Im(I,J)
         enddo
        enddo
       endif

       call mat2(FF,FL,M12)
       call inv2(FF,invF)
       call mat2(invF,FL,M21)

       do I=1,2
        do J=1,2
         M(I,J+2) = -M12(I,J)/sinFI*CI
         M(I+2,J) =  M21(I,J)*sinFI*CI
        enddo
       enddo

      endif

      return
      end

                                                                        
      subroutine roughness(both_dgnl,sigma,A0,A1,A2,M) 
! ******************************************************************    
                                                                        
!  This ysubroutine updates integrated matrix of distibution with roughne
!	 the top border of a given layer.                                     
!      M->Mupd, where Mupd=exp(sigma**2)*[W1,W2]*0.5*M. For the details 
!      R. Rohlsberger, Hyperfine Inreractions 123/124 (1999) 301-325    
!      ------------------------------------------------------------     
!	 Differential matrix of distribution is  represented like             
!		      0		  I*Ao+Ai/Ao   
!      Wi   =	                                                          
!                    I*Ao		0   
                                                                        
!      ---------------------------------------------------------------  
       implicit none 
                                                                        
!      Input variables	                                                 
       logical,intent(in):: both_dgnl 
       real(kind=8),intent(in):: sigma 
       real(kind=8),intent(in):: A0 
       complex(kind=8),intent(in), dimension(2,2):: A1,A2
       complex(kind=8),intent(out),dimension(4,4):: M

       complex(kind=8),dimension(4,4):: Mupd 
                                                                        
       real(kind=8)   :: sigma2 
       complex(kind=8),dimension(2,2):: exp_Dp,exp_Dm,C,dA,TMP,C2 
       complex(kind=8),dimension(4)  :: exp_scalar
       complex(kind=8),dimension(2)  :: dA_scal,C_scal

       complex(kind=8),parameter::  C1=(1.D0,0.D0),C0=(0.0,0.0) 
       integer    I,J,K 
                                                                        

       sigma2=sigma**2 
                                                                        
       Mupd=C0 
                                                                        
       if(both_dgnl) then 
        do I=1,2 
         dA_scal(I)      = A2(I,I)-A1(I,I) 
         C_scal(I)       = 2.D0*(2.D0*A0*A0+A2(I,I)+A1(I,I)) 
         exp_scalar(I)   = dA_scal(I)*(C1/C_scal(I))*                   &
                          (-exp(-0.5D0*sigma2*C_scal(I))+C1)           
         exp_scalar(I)   = exp(exp_scalar(I)) 
         exp_scalar(I+2) = C1/exp_scalar(I) 
        end do 
                                                                        
!        do I=1,4                                                       
!         do J=1,4                                                      
!          Mupd(I,J) =  exp_scalar(J)*M(I,J)                            
!         end do                                                        
!	end do                                                                
                                            
        Mupd(1,1) =  exp_scalar(1)*M(1,1)   ! instead of the above loo  
        Mupd(2,2) =  exp_scalar(2)*M(2,2)   ! the direct definitions,   
        Mupd(3,1) =  exp_scalar(1)*M(3,1)   ! 8 complex products inste  
        Mupd(4,2) =  exp_scalar(2)*M(4,2)   ! # L. Deak                 
        Mupd(1,3) =  exp_scalar(3)*M(1,3) 
        Mupd(2,4) =  exp_scalar(4)*M(2,4) 
        Mupd(3,3) =  exp_scalar(3)*M(3,3) 
        Mupd(4,4) =  exp_scalar(4)*M(4,4) 
                                                                        
       elseif(.not.both_dgnl)  then 
        C(1,1)=2.D0*(2.D0*A0*A0+A1(1,1)+A2(1,1)) 
        C(2,2)=2.D0*(2.D0*A0*A0+A1(2,2)+A2(2,2))   ! C=2*(2*A0
        C(1,2)=2.D0*(A1(1,2)+A2(1,2)) 
        C(2,1)=2.D0*(A1(2,1)+A2(2,1)) 
                                                                        
      do I=1,2 
       do J=1,2 
          dA(I,J)=A2(I,J)-A1(I,J)           ! A=A2-A1                 
          TMP(I,J)=-0.5D0*sigma2*C(I,J)     ! TMP=-0.5*sigma**2*C     
         end do                                                       
        end do                                                        
                                                                           
        call exp2(TMP)                      ! TMP=exp(-0.5*sigma**2   
        call inv2(C,C2)                     ! C2=1/C                  
        call mat2(dA,C2,C2)                 ! C2=dA*1/C               
                                                                           
        TMP(1,1)= C1-TMP(1,1)                                         
        TMP(1,2)=-TMP(1,2)                                            
        TMP(2,1)=-TMP(2,1)                  ! TMP=I-exp(-0.5*sigma*   
        TMP(2,2)= C1-TMP(2,2)                                         

        call mat2(C2,TMP,exp_Dp)            ! expDp=dA*1/C*(I-exp(-   
        call exp2(exp_Dp)                   ! expDp=exp(dA*1/C*(I-e   
        call inv2(exp_Dp,exp_Dm) 
                                                                        
        do I=1,2 
         do J=1,2 
        do K=1,2 
           Mupd(I,J)     = Mupd(I,J)    +  M(I,K)*exp_Dp(K,J) 
           Mupd(I,J+2)   = Mupd(I,J+2)  +  M(I,K+2)*exp_Dm(K,J) 
           Mupd(I+2,J)   = Mupd(I+2,J)  +  M(I+2,K)*exp_Dp(K,J) 
           Mupd(I+2,J+2) = Mupd(I+2,J+2)+  M(I+2,K+2)*exp_Dm(K,J) 
          end do 
         end do 
        end do 
       end if                                 ! both_dgnl  
                                                                        
       do I=1,4 
        do J=1,4 
         M(I,J)=Mupd(I,J) 
        end do 
       end do 
                                                                        
       return 
      END                                           


