!   3 synchrrotron plot routines
!   strobo_plot, syn_plot and offspec_plot


     subroutine strobo_plot(cmch) 
     use glbconst, only: maxn,max8,maxsub,infplot,MDBPLFT,    &
                         icstrf,ivstrf
     use comdat, only: file_data,name_data,formdata,b_data,b_theory,   &
                       name_theory,ichanks,mxpt,mfpt,mdfpt
     use complt, only: display_mode,ndisplay_mode,n_subset,icolor_sub
     use comthe, only: real_fr,thfk
     implicit none  
     character(len=4),intent(in)::  cmch 
                                                                       
     integer      n_subspectra,logx,logy,logf,         &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         xyzdz,vtxt,vtxtp,parray                              

     character(len=132):: plotstrdef,plotstrpu,title
     character(len=24) :: axesname,abscissa,bgcolor,fgcolor,   &  
                          datacolor,thcolor,rescolor,auxcolor1,         & 
                          auxcolor2,auxcolor3
     character(len=80) :: datfile,ordinata
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,ch4d, ch4de
     real              :: datx,errx,sym,subspectrum,varray,yarray,yyarray, &
                          v1array,v3array,vrarray,vdarray,resarray
     integer           :: irarray,i0array,i1array,i2array                  
     logical           :: b_datf
     integer,parameter :: max8subn=maxsub*max8,max4=4*maxn,max16=maxn*16,&
                          maxn0=4*maxn+2,maxnh=4*maxn/2,max112=maxn*112, &
                 idumpl=4*maxn-8*39-5*infplot-maxsub-201,           & 
                 jdumpl=8*maxn0+4*maxnh+max4,                       &
                 kdumpl=3*max4+max4*maxsub,                         &
                 ldumpl=MDBPLFT*2-180*maxn-jdumpl-kdumpl
     common/plot/parray(max112),xyzdz(8),vtxt(2,max16),vtxtp(8,32), &
                 int3d(max16),npnt3d(16),ifeder(max16),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,ch4d(idumpl),   &
                 varray(maxn0),yarray(maxn0),yyarray(maxn0),           &
                 v1array(maxn0),v3array(maxn0),vrarray(maxn0),         &
                 vdarray(maxn0),resarray(maxn0),irarray(maxnh),        &
                 i0array(maxnh),i1array(maxnh),i2array(maxnh),         &
                 b_datf(max4),datx(max4),errx(max4),sym(max4),         &
                 subspectrum(max4,maxsub),ch4de(ldumpl) 

!    common/plot/parray(maxn*180+jdumpl),datx(max4),errx(max4),sym(max4),
!                subspectrum(max4,maxsub),ch4de(ldumpl)
                                                                       
     real,dimension(max8):: plotx,ploty,ploterry,plotres,plotxx,plotyy
     real,dimension(max4):: plotdvcorr
     real,dimension(max8subn):: plotsub
     equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),       &
                 (parray(max8*2+1),ploterry(1)),                       &
                 (parray(max8*3+1),plotres(1)),                        &
                 (parray(max8*4+1),plotxx(1)),                         &
                 (parray(max8*5+1),plotyy(1)),                         &
                 (parray(max8*6+1),plotsub(1)),                        &
                 (parray(max8*13+max4+1),plotdvcorr(1))
                        
     real          dum1,channels,dum2,drive_mode,channels_vmax,dumcs
     common/acstrf/dum1(5),channels,dum2(3),drive_mode,channels_vmax,  &
                   dumcs(icstrf-11)

     real          avsp,f_factor,base,bg_fraction,v_max,channel_v0,dumvs
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,channel_v0,    &
                   dumvs(ivstrf-6)

                   
     integer       idum,mvpt,mgpt,ifrth
     common/strLOC/idum(3),mvpt,mgpt,ifrth(27)

     logical         b_logx,b_logy,b_vdarray,b_velocityscale
     character(len=1) :: chx,chbx,chlr,chy,chby,chbt,ch0 
     character(len=80):: CTEXT,CXTEXT,CYTEXT
     character(len=24):: frcolor
     character(len=9) :: chsub
     integer         nformx,nformy,i,ii,il,ir,irh,is1,is2,i0,il0,     &
                     il1,il2,ivd,l,k,nbegin,nchansp,nend,nh,nresidue, &
                     j,ns,nsinglev,ny,nyy,iofs
     real            chh,chw,syw,syh,aa,base2,basepl,bb,ff,det,glow,  &
                     fold_point,sqrt2,v1,v1mv3,v3,vil,vil1,vil2,vir,  &
                     vr,xmax,xmin,y1,y2,y3,ymin,ymax,hd,hmin,hmax,    &
                     resmin,resmax,ressum 
     real, dimension(:), allocatable :: velocity 


      ch0=char(0) 
      i0=ichar('0') 
      if(cmch.eq.'dstr') then 
!      the string formdata also defines the sequence of storage of 
!      the y-, dy- (error of y), and x-data on the array real_fr().
!      y,dy is always stored (if dy is not on the data file dy=sqrt(y)) 
       formdata(1)='y' 
       formdata(2)='y,x'
       formdata(3)='y,dy' 
       formdata(4)='y,dy,x' 
       formdata(5)=' '               ! defines end
       return 
      end if 
      if(cmch.eq.'dmod') then 
       display_mode(1)='channel scale, counts' 
       display_mode(2)='channel scale, counts, residual spectrum' 
       display_mode(3)='velocity scale' 
       display_mode(4)='velocity scale, residual spectrum' 
       display_mode(5)='velocity scale, counts' 
       display_mode(6)='velocity scale, counts, residual spectrum' 
       display_mode(7)='channel scale & correction function ' 
       display_mode(8)=' ' 
       namechan(1)='x' 
       namechan(2)='y' 
       namechan(3)='dy' 
       namechan(4)='res' 
       namechan(5)='xt' 
       namechan(6)='yt' 
       namechan(7)='su' 
       namechan(8)=' '               ! defines end
       plotstrdef='(x,y,dy)' 
       if(b_theory)then 
        plotstrdef='(x,y,dy) (xt,yt)' 
        j=21 
        if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4                     &
                             .or.ndisplay_mode.eq.6)then              
         plotstrdef='(x,y,dy) (xt,yt) (x,res)' 
         j=30 
        end if 
        if(n_subset.gt.0)then 
         do i=1,n_subset 
          chsub=' (xt,su'//char(i+i0)//')' 
          k=j+(i-1)*9 
          plotstrdef(k:)=chsub 
         end do 
        end if 
       end if 
       return 
      end if 
                                                                        
      if(ndisplay_mode.eq.3.or.ndisplay_mode.eq.4) then 
       kform(1)='f6.2' 
       kform(2)='f10.6' 
       kform(3)='f10.6' 
       kform(4)='f10.6' 
       kform(5)='f6.2' 
       kform(6)='f10.6' 
       kform(7)='f10.6' 
       nformy=2 
      else if(ndisplay_mode.le.2.or.ndisplay_mode.ge.5) then 
       kform(1)='f8.3,2x' 
       kform(2)='f12.2,2x' 
       kform(3)='f8.1,2x' 
       kform(4)='f12.1,2x' 
       kform(5)='f8.3,2x' 
       kform(6)='f12.0,2x' 
       kform(7)='f12.0,2x' 
       nformy=0 
      end if 
      kform(8)=' ' 
                                                                        
   select case(ndisplay_mode)     
     case(1)
!      display_mode(3)='channel scale'                                 
       abscissa='channel' 
       ordinata='counts' 
       axisformat(1)='%8.2f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
     case(2)
!      display_mode(4)='-channel scale, residual spectrum'             
       abscissa='channel' 
       ordinata='counts' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%8.0f ' 
       nformx=0 
     case(3)
!      display_mode(1)='velocity scale'                                
       abscissa='mm/s' 
       ordinata='relative transmission' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=1 
     case(4)
!      display_mode(2)='-velocity scale, residual spectrum'            
       abscissa='mm/s' 
       ordinata='relative transmission' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=1 
     case(5,6)
!      display_mode(5,6)='-velocity scale, counts, residual spectrum'   
       abscissa='mm/s' 
       ordinata='counts' 
       axisformat(1)='%8.2f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
     case(7)
!      display_mode(7)='channel scale & correction function'
       abscissa='channel' 
       ordinata= 'velocity correction dv' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=0 
   end select
       b_velocityscale=ndisplay_mode.ge.3.and.ndisplay_mode.le.6
       nresidue=1
       if(ndisplay_mode.eq.1.or.ndisplay_mode.eq.3.or.ndisplay_mode.eq.5) nresidue=0 
       if(.not.b_data) title=name_theory 
       if(base.eq.0.) base=1. 
       n_subspectra=0 
       if(b_theory) n_subspectra=n_subset 
       nchansp=channels 
       fold_point=channel_v0+channels_vmax 

      bgcolor='LightYellow'//ch0 
      fgcolor='black'//ch0 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//ch0 
      do j=1,maxsub 
       ncolor(j)=icolor_sub(j) 
      end do 
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=name_data
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if 
!     write(6,'(2a)')'datfile=',datfile(1:60)                          

!      write(6,'(a,i4)') ' *****strobo_plot*********'                     
!       write(6,'(2(a,l5),a,i5)') ' b_data=',b_data,                    
!     &  '  b_theory=',b_theory,' n_subspectra=',n_subspectra           
!       write(6,'(4(a,f10.3))') ' base=',base,'  fold=',fold_point, &
!                               '  fresonant=',fresonant           
!     if(b_theory) then                                                 
!      write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)                     
!     else                                                              
!      write(6,'(20L4)') (b_datf(j),j=1,nchansp,16)                     
!     end if                                                            
                                                                        
      do j=1,nchansp 
       b_datf(j)=.false. 
      end do 
      do k=2,ichanks(0),2 
       do j=ichanks(k-1),ichanks(k) 
        b_datf(j)=.true. 
       end do 
      end do 
                                                                        
      if (.not.allocated(velocity))allocate(velocity(nchansp))

      if(b_theory) then
       do i=1,nchansp
        velocity(i)=real_fr(mvpt+i)
        plotdvcorr(i)=real_fr(mxpt+i)        
       end do
      else
       do i=1,nchansp
        velocity(i)=real_fr(mvpt+i)
       end do
      end if
      ny=0 
      nyy=0 
      nchanplot=0     ! array

      basepl=base 
      if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6) basepl=1 
                                                                        
     if(b_data) then 
        nbegin=0 
        i=0 
        do while(nbegin.eq.0.and.i.lt.nchansp) 
         i=i+1 
         if(b_datf(i)) nbegin=i 
        end do 
        nend=0 
        i=nchansp+1 
        do while(nend.eq.0.and.i.gt.1) 
         i=i-1 
         if(b_datf(i)) nend=i 
        end do 
        do i=1,nchansp 
         varray(i)=velocity(i) 
        end do 
        varray(nchansp+1)=varray(1) 
        varray(nchansp+2)=varray(2) 

        iofs=1
        if(drive_mode.eq.2) iofs=10

        nsinglev=1                              ! double/full  spectrum 
        if(nend*0.9.lt.fold_point) nsinglev=-1  ! single/half  spectrum 

        basepl=base 
        if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6)then 
         basepl=1 
         if(nsinglev.eq.1)basepl=0.5 
        end if 
                                                                        
!        write(6,'(a,2i6)') ' ndisplay_mode=',ndisplay_mode,nchansp     
!        write(6,'(3(a,i7))')' mfpt=',mfpt,' mdfpt=',mdfpt,' sigle_v=',nsinglev

        b_vdarray=.false. 
        if(b_velocityscale) then 
                                                                        
         if(nsinglev.lt.0) then 
          do ii=nbegin,nend 
           if(b_datf(ii)) then 
            ny=ny+1 
            plotx(ny)=velocity(ii) 
            ploty(ny)=real_fr(mfpt+ii)/basepl 
            ploterry(ny)=real_fr(mdfpt+ii)/basepl 
           end if 
          end do 
                                                                        
          if(b_theory) then 
           do ii=nbegin,nend 
            nyy=nyy+1 
            plotxx(nyy)=velocity(ii) 
            plotyy(nyy)=thfk(ii)/basepl 
           end do 
                                                           
           if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6) then 
            ressum=0.0
            ns=0 
            do ii=nbegin,nend 
             if(b_datf(ii)) then 
              ns=ns+1 
              plotres(ns)=ploty(ii)-plotyy(ii)
              ressum=ressum+plotres(ns)
             end if 
            end do 
            ressum=ressum/float(ns)
           end if 

           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j)/basepl 
             end do 
            end do 
           end if 
          end if  ! b_theory  
          goto 200 
         end if  !  nsinglev < 0  
                                                                        
         sqrt2=sqrt(2.) 
         base2=2*basepl 
                                                                        
         l=3*int(log10(abs(v_max/nchansp*4.))*2.) 
         glow=10**l 
!        write(6,'(a,i4)') ' lower limit =',l                           
         if(b_theory) then 
          do i=1,nchansp 
           yyarray(i)=thfk(i)
          end do 
          yyarray(nchansp+1)=thfk(1) 
          yyarray(nchansp+2)=thfk(2) 
         end if 
                                                                        
         do i=1,nchansp 
          resarray(i)=real_fr(mfpt+i)-thfk(i) 
          yarray(i)=real_fr(mfpt+i) 
         end do 
         yarray(nchansp+1)=real_fr(mfpt+1)
         yarray(nchansp+2)=real_fr(mfpt+2)

         nh=nchansp/2. 
         irh=int(fold_point)+1 
         il=irh 
         do ii=irh,irh+nh-1 
          ir=ii 
          if(ir.gt.nchansp) ir=ir-nchansp 
          il=il+1 
          il1=il+1 
          vir=varray(ir) 
          vil=varray(il) 
          vil1=varray(il1) 
          ivd=1 
          do while(ivd.gt.0) 
           il2=il1 
           il1=il 
           vil2=vil1 
           vil1=vil 
           ivd=1 
           if(vil2-vir.le.0)  ivd=-1 
           if(vil2-vir.eq.0) goto 18 
           if(vil1-vir.lt.0) then 
            ivd=-ivd 
           else if(vil1-vir.eq.0) then 
            ivd=-1 
           end if 
  18       il=il-1 
           if(il.lt.1) il=il+nchansp 
           vil=varray(il) 
          end do 

          v1=vil-vil1 
          v3=vil2-vil1 
          vr=vir-vil1 
          if(b_theory) then 
           nyy=nyy+1 
           irarray(nyy)=ir 
           i0array(nyy)=il 
           i1array(nyy)=il1 
           i2array(nyy)=il2 
           v1array(nyy)=v1 
           v3array(nyy)=v3 
           vrarray(nyy)=vr 
           vdarray(nyy)=0. 
                                                                        
           v1mv3=v1-v3 
           det=v1*v3*v1mv3 
           if(abs(det).gt.glow) then 
            vdarray(nyy)=det 
            b_vdarray=.true. 
            y1=yyarray(il) 
            y2=yyarray(il1) 
            y3=yyarray(il2) 
            y1=y1-y2 
            y3=y3-y2 
            y1=y1*v3  
            y3=y3*v1 
            aa=y1-y3 
            bb=-y1*v3+y3*v1 
            ff=vr*(vr*aa+bb)/det+y2 
           else 
            ff=yyarray(il1) 
            b_vdarray=.false. 
           end if 
           plotxx(nyy)=vir 
           plotyy(nyy)=(yyarray(ir)+ff)/base2 
          else 
           b_vdarray=.false. 
          end if  ! b_theory   
                                                                        
          if(b_datf(ir)) then 
           y1=yarray(il) 
           y2=yarray(il1) 
           y3=yarray(il2) 
           if(y1.ne.0..and.y2.ne.0..and.y3.ne.0.) then 
            ny=ny+1 
            if(b_vdarray) then 
             ff=(y1+y2+y3)/3.
            else 
             ff=y2 
            end if 
            plotx(ny)=vir 
            ploty(ny)=(yarray(ir)+ff)/base2 
            ploterry(ny)=sqrt2*real_fr(mdfpt+ir)/base2 
            if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6)                &
                              plotres(ny)=resarray(ir)/base2           
           end if 
          end if 
         end do 
                                                                
!        ny plot points for the data                                    
!        nyy plot points for the theory                                 
         ns=0                                                               
         if(b_theory.and.n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           do i=1,nchansp 
            yyarray(i)=subspectrum(i,j) 
           end do 
           yyarray(nchansp+1)=yyarray(1) 
           yyarray(nchansp+2)=yyarray(2) 
                                                                        
           ns=(j-1)*max8 
           nchanplot(6+j)=nh 
           do ii=1,nh 
            v1=v1array(ii) 
            v3=v3array(ii) 
            vr=vrarray(ii) 
            det=vdarray(ii) 
            ir=irarray(ii) 
            il0=i0array(ii) 
            il1=i1array(ii) 
            il2=i2array(ii) 
            if(det.ne.0.) then 
             y1=yyarray(il0) 
             y2=yyarray(il1) 
             y3=yyarray(il2) 
             y1=y1-y2 
             y3=y3-y2 
             y1=y1*v3 
             y3=y3*v1 
             aa=y1-y3 
             bb=-y1*v3+y3*v1 
             ff=vr*(vr*aa+bb)/det+y2 
            else 
             ff=yyarray(il1) 
            end if 
            ns=ns+1 
            plotsub(ns)=(subspectrum(ir,j)+ff)/base2 
           end do 
          end do 
         end if 
        else      ! ndisplay_mode: b_velocityscale=true 
         if(ndisplay_mode.eq.7)then
          do i=nbegin,nend 
           if(b_datf(i)) then 
            ny=ny+1 
            plotx(ny)=i 
            ploty(ny)=real_fr(mfpt+i)/basepl 
            ploterry(ny)=real_fr(mdfpt+i)/basepl 
           end if 
          end do 
          if(b_theory) then 
!           do i=nbegin,nend                                             
           do i=1,nchansp 
            nyy=nyy+1 
            plotxx(nyy)=i 
            plotyy(nyy)=thfk(i)/basepl 
            plotdvcorr(nyy)=real_fr(mxpt+i)        
           end do 
           ressum=0.0
           ns=0 
           do ii=nbegin,nend 
            if(b_datf(ii)) then 
             ns=ns+1 
             plotres(ns)=(real_fr(mfpt+ii)-thfk(ii))/basepl 
             ressum=ressum+plotres(ns)
            end if 
           end do 
           ressum=ressum/float(ns)
           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j)/basepl  
             end do 
            end do 
           end if 
          end if  ! b_theory 
         else   ! ndisplay_mode.eq.7
          do i=nbegin,nend 
           if(b_datf(i)) then 
            ny=ny+1 
            plotx(ny)=i 
            ploty(ny)=real_fr(mfpt+i) 
            ploterry(ny)=real_fr(mdfpt+i) 
           end if 
          end do 
          if(b_theory) then 
!           do i=nbegin,nend                                             
           do i=1,nchansp 
            nyy=nyy+1 
            plotyy(nyy)=thfk(i) 
            plotxx(nyy)=i 
            plotdvcorr(nyy)=real_fr(mxpt+i)        
           end do 
           if(ndisplay_mode.eq.2) then 
            ressum=0.0
            ns=0 
            do ii=nbegin,nend 
             if(b_datf(ii)) then 
              ns=ns+1 
              plotres(ns)=real_fr(mfpt+ii)-thfk(ii) 
              ressum=ressum+plotres(ns)
             end if 
            end do 
            ressum=ressum/float(ns)
           end if 
           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j) 
             end do 
            end do 
           end if 
          end if  ! b_theory 
         end if
        end if   ! ndisplay_mode.ge.3  
     else      ! b_data   
                                                                        
        if(b_velocityscale) then
         is1=sign(1.,velocity(3)-velocity(1))
         do ii=1,nchansp-3
         is2=is1*sign(1.,velocity(ii+3)-velocity(ii)) 
          if(is2.lt.0) goto 19 
         end do
 19      continue

         nyy=nchansp/2
         if(ii.gt.nchansp-3) nyy=nchansp

         do i=1,nyy 
          plotxx(i)=velocity(i) 
          plotyy(i)=thfk(i)/basepl
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do i=1,nyy 
            plotsub(ns+i)=subspectrum(i,j)/basepl
           end do 
          end do 
         end if 
        else 
         nyy=nchansp 
         do i=1,nchansp 
          plotxx(i)=nyy-i+1 
          plotyy(i)=thfk(i) 
         end do 
         ns=0
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do i=1,nyy 
            plotsub(ns+i)=subspectrum(i,j) 
           end do 
          end do 
         end if 
        end if 
     end if  ! b_data  
                                                                        
  200 continue 
                                                                        
      xmin=1.e30 
      xmax=-xmin 
      ymin=xmin 
      ymax=0.      ! counts > 0  
      if(b_data) then 
       do ii=1,3 
        nchanplot(ii)=ny 
       end do 
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny 
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i) 
       end do 
       do i=1,ny 
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i) 
       end do 
      end if 
      if(b_theory) then 
       nchanplot(5)=nyy 
       nchanplot(6)=nyy 
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 

       do i=1,nyy 
        if(ymin.gt.plotyy(i))ymin=plotyy(i) 
       end do 
       do i=1,nyy 
        if(ymax.lt.plotyy(i))ymax=plotyy(i) 
       end do 
      end if 

      if(ndisplay_mode.eq.7) then
       hmax=-1.0e10
       hmin=-hmax
       do i=1,nyy 
        if(hmin.gt.plotdvcorr(i))hmin=plotdvcorr(i) 
       end do 
       do i=1,nyy 
        if(hmax.lt.plotdvcorr(i))hmax=plotdvcorr(i) 
       end do
       if(hmax.gt.0.3)hmax=0.3;  if(hmin.lt.-0.3)hmin=-0.3
       vr=ymin-2*hmax+hmin
       i=vr*10. +1
       ymin=float(i)/10.
       if(ymin.gt.0.7)ymin=0.7
       i=(ymin-hmin)*10 +1
       vr=float(i)/10.
       plotdvcorr(1)=vr

       nchanplot(infplot)=2
       do i=2,nyy 
        plotdvcorr(i)=plotdvcorr(i)+vr
       end do 
      end if

      if(nresidue.eq.1.and.b_theory) then 
        nchanplot(4)=ny 
        resmin=0. 
        resmax=0. 
        do i=1,ny 
         hd= plotres(i)-ploterry(i) 
         if(resmin.gt.hd) resmin=hd 
        end do 
        do i=1,ny 
         hd= plotres(i)+ploterry(i) 
         if(resmax.lt.hd) resmax=hd 
        end do 
         hd= resmax-2.0*resmin 
        do i=1,ny 
         plotres(i)=plotres(i)+ymax-resmin 
        end do 
        ymax=ymax-resmin+resmax 
!        print '(a,f10.1)',' average <exp-theo>=',ressum
      end if 

       xyzdz(1)=xmin 
       xyzdz(2)=xmax 
       xyzdz(3)=ymin 
       xyzdz(4)=ymax 

       b_logx=.false. 
       b_logy=.false. 
       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1 
                                                                        
!      definitions taken from allplo 
       chx='b'                 ! (none,Both,bottom,top)  [B]            
       chbx='n'                ! (none,bottom,top)  [n]                 
       chlr='l'                ! (left,right)  [r]                      
       chy='l'                 ! (none,Both,left,right)  [B]            
       chby='l'                ! (none,left,right)  [r]                 
       chbt='b'                ! (bottom,top)  [t]                      
       chh=0.3                 !                                        
       chw=0.25                ! character cw,ch  [0.40,0.40]           
       syw=0.1                 !                                        
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]           
       frcolor=fgcolor         ! color frame       [black]              
       frcolor='blue'//ch0 
       CTEXT=title 
       CXTEXT=abscissa 
       CYTEXT=ordinata 
                                                                  
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
                  chh,chw,syw,syh,                                      &
                  CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)      
                                                                        
!      write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax             
!      write(6,'(a,10i5)') ' nchanplot=',(nchanplot(ii),ii=1,8)         
!      write(6,'(2(a,i4))')  ' ny=',ny,'    nyy=',nyy                   
!      write(6,'(a)')  ' j,plotx(j),ploty(j)'                           
!      write(6,'(3(2x,i4,1x,2g12.4))') (j,plotx(j),ploty(j),j=1,ny,16)  
!      write(6,'(a)')  ' j,plotres(j),ploty(j)'                         
!      write(6,'(3(2x,i4,1x,2g10.2))') (j,plotres(j),ploty(j),j=1,ny,16)
                                                                        
      return 
      END                                           

     subroutine syn_plot(cmch) 
     use glbconst, only: maxfr1,maxfr2,maxn,max8,maxthss,maxsub,enwr,    &
                         ivstrf,MDBPLFT,infplot
     use comdat, only: ichanks,mxpt,mfpt,mdfpt,b_data,name_data,formdata,&
                       file_data,b_theory,name_theory
     use complt, only: display_mode,ndisplay_mode,n_subset,icolor_sub
     use comthe, only: ifrcase,real_fr,array_fr,thfk     
     implicit none 

     character(len=4),intent(in):: cmch 

     integer, parameter:: istr=38+4*(maxfr1+maxfr2)+3*maxthss
     integer       dstr,nstorTH1,idum3,iaddr
     common/struct/dstr(istr),idum3(3),nstorTH1,iaddr(4)

     integer       idum1,nTH1,nCP,nsrw,idum2,nexp,ifrth,idum5,ien
     real          srw8,xb_the,dx_the
     common/strLOC/nTH1,nCP,idum1,nsrw,idum2,nexp,ifrth(14),           &
                        srw8,idum5(5),xb_the,dx_the,ien(4)   

     integer      n_subspectra,logx,logy,logf,                         &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         plotx,ploty,ploterry,plotres,plotxx,plotyy,plotsub,  &
                  xyzdz,vtxt,vtxtp                                     

     character(len=132):: plotstrdef,plotstrpu,title
     character(len=24) :: axesname,abscissa,ordinata,bgcolor,fgcolor,   &  
                          datacolor,thcolor,rescolor,auxcolor1,         & 
                          auxcolor2,auxcolor3
     character(len=80) :: datfile  
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,ch4d,ch4de

     real              :: datx,errx,sym,subspectrum,daty,erry                   
     integer,parameter :: max8subn=maxsub*max8,max4=4*maxn,max16=maxn*16,&
                          maxn0=4*maxn+2,maxnh=4*maxn/2,max112=maxn*112, &
                 jdumpl=8*(max4+2)+4*(max4/2)+max4,                    &
                 idumpl=4*maxn-8*39-5*infplot-maxsub-201+jdumpl,       &
                 kdumpl=5*max4+max4*maxsub,                            &
                 ldumpl=MDBPLFT*2-180*maxn-jdumpl-kdumpl  
     common/plot/plotx(max8),ploty(max8),ploterry(max8),plotres(max8), &
                 plotxx(max8),plotyy(max8),plotsub(max8subn),          &
                 xyzdz(8),vtxt(2,max16),vtxtp(8,32),                  &
                 int3d(max16),npnt3d(16),ifeder(max16),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,ch4d(idumpl),   &
                 datx(max4),errx(max4),sym(max4),                      &
                 subspectrum(max4,maxsub),daty(max4),erry(max4),ch4de(ldumpl)
      
                                                                       
     real          avsp,counts,background,Pdum,                        &
                   t_shift,dumvsp                                      
     common/avstrf/avsp,counts,background,Pdum(6),                     &
                   t_shift,dumvsp(ivstrf-10)                           
                                                                       
     logical          :: b_logx,b_logy,b_12,b_34 
     character(len=1) :: chx,chbx,chlr,chy,chby,chbt,ch0 
     character(len=80):: CTEXT,CXTEXT,CYTEXT
     character(len=24):: frcolor
     character(len=9) :: chsub
     integer   nformx,nformy,i0,nthe,isd,                              & 
               n_plotsub,nresidue,ny,nyy,ns,i,ii,j,jj,k 
     real      h,hm,htr,schrw,resmin,resmax,xmin,xmax,ymin,ymax,hd,    &
               chh,chw,syw,syh 

      i0=ichar('0') 
      ch0=char(0) 
      nthe=2*nTH1
      if(cmch.eq.'dstr') then 
!      format  reading data                                             
       formdata(1)='y'          
       formdata(2)='y,dy'        
       formdata(3)='y,x'        
       formdata(4)='y,dy,x'     
       formdata(5)=' '             
       return 
      end if 
      if(cmch.eq.'dmod') then 
!      format  writing data and theory                                  
       namechan(1)='x' 
       namechan(2)='y' 
       namechan(3)='dy' 
       namechan(4)='res' 
       namechan(5)='xt' 
       namechan(6)='yt' 
       namechan(7)='su' 
       namechan(8)=' ' 
       plotstrdef='(x,y,dy)' 
       if(b_theory) plotstrdef='(xt,yt)' 
!      if there is not the standard xd,yd,erry a d(...) identifies data 
       if(b_theory.and.b_data)then 
        plotstrdef='(x,y,dy) (xt,yt)' 
        j=21 
       end if 
       if(ifrcase.ge.22) then 
        display_mode(1)='angle scale, log(counts)' 
        display_mode(2)='angle scale, residual counts' 
        display_mode(3)='channel scale, counts' 
        display_mode(4)='channel scale,residual counts' 
        if(b_theory)then 
         if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4)then 
          plotstrdef='(x,y,dy) (xt,yt) (x,res)' 
          j=30 
         end if 
         if(n_subset.gt.0)then 
          do i=1,n_subset 
           chsub=' (xt,su'//char(i+i0)//')' 
           k=j+(i-1)*9 
           plotstrdef(k:)=chsub 
          end do 
         end if 
        end if 
       else 
        display_mode(1)='time scale, log(counts)' 
        display_mode(2)='time scale, residual counts' 
        display_mode(3)='channel scale, counts' 
        display_mode(4)='channel scale,residual counts' 
        display_mode(5)='velocity scale, cross section' 
        display_mode(6)='channel scale, cross section' 
        if(b_theory)then 
         if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4)then 
          plotstrdef='(x,y,dy) (xt,yt) (x,res)' 
          j=30 
         end if 
         if(n_subset.gt.0)then 
          do i=1,n_subset 
           chsub=' (xt,su'//char(i+i0)//')' 
           k=j+(i-1)*9 
           plotstrdef(k:)=chsub 
          end do 
         end if 
        end if 
       end if 
                                                                        
       return 
      end if 
                                                                        
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if 
                                                                        
      b_logy=.false. 
      b_logx=.false. 
      b_12=.false. 
      b_34=.false. 
      if(ifrcase.ge.22.and.ndisplay_mode.gt.4) ndisplay_mode=4 
      goto(1,2,3,4,5,6), ndisplay_mode 
!       display_mode(1)='angle, time scale'                             
    1  b_12=.true. 
       if(ifrcase.ge.22) then 
        abscissa='theta[mrad] ' 
        axisformat(1)='%6.2f ' 
       else 
        abscissa='T[ns] ' 
        axisformat(1)='%6.1f ' 
       end if 
       ordinata='log count'//ch0 
       axisformat(2)='%6.2f ' 
       b_logy=.true. 
       nformx=0 
       nformy=2 
       goto 7 
!       display_mode(2)='angle, time scale, residual counts'            
    2   b_12=.true. 
        if(ifrcase.ge.22) then 
        abscissa='theta[mrad] ' 
        axisformat(1)='%6.2f ' 
       else 
        abscissa='T[ns] ' 
        axisformat(1)='%6.1f ' 
       end if 
       ordinata='log count'//ch0 
       axisformat(2)='%6.2f ' 
       b_logy=.true. 
       nformx=0 
       nformy=2 
       goto 7 
!       display_mode(3)='channel scale'                                 
    3  b_34=.true. 
       abscissa='channel ' 
       ordinata='counts ' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%8.0f ' 
       nformx=0 
       nformy=0 
       goto 7 
!       display_mode(4)='-channel scale, residual counts'               
    4   b_34=.true. 
        abscissa='channel ' 
       ordinata='counts ' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%8.0f ' 
       b_logy=.false. 
       nformx=0 
       nformy=0 
       goto 7 
!      display_mode(5)='velocity scale, cross section'                  
    5   abscissa='[mm/s] ' 
       ordinata='cross section ' 
       axisformat(1)='%6.1f ' 
       axisformat(2)='%10.2f ' 
       nformx=1 
       nformy=2 
       goto 7 
!      display_mode(6)='channel scale, cross section'                   
    6  abscissa='channels ' 
       ordinata='cross section ' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
       nformy=2 
    7  continue 
                                                                        
                                                                        
                                                                        
      if(b_12.or.ndisplay_mode.eq.5) then 
       kform(1)='f7.2' 
       kform(2)='f10.4' 
       kform(3)='f12.6' 
       kform(4)='f10.6' 
       kform(5)='f7.2' 
       kform(6)='f8.4' 
       kform(7)='f8.4' 
       nformy=2 
      else 
       kform(1)='f6.0' 
       kform(2)='f12.0' 
       kform(3)='f9.1' 
       kform(4)='f9.1' 
       kform(5)='f6.0' 
       kform(6)='f12.0' 
       kform(7)='f12.0' 
       nformy=0 
      end if 
      kform(8)=' ' 

      bgcolor='LightYellow'//char(0) 
      fgcolor='black'//char(0) 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//char(0) 
      do j=1,maxsub 
       ncolor(j)=icolor_sub(j) 
      end do 

      n_subspectra=n_subset 
                                                                        
      n_plotsub=n_subspectra 
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=name_data 
      if(.not.b_data) title=name_theory 
                                                                        
!      write(6,'(a,i4)')'hpg_synmoss plot nexp=',nexp                       
                                                                        
      isd=nexp/1024 
      if(nexp-isd*1024.gt.0)isd=isd+1 
      if(isd.eq.0)isd=1 
      if(enwr(15).eq.'fupl')isd=1
      if(b_data) then 
       do i=1,nexp 
        daty(i)=real_fr(mfpt+i) 
       end do 
       do i=1,nexp 
        erry(i)=real_fr(mdfpt+i) 
       end do 
      end if

      nresidue=0 
      do ii=1,infplot 
       nchanplot(ii)=0 
      end do 
                                                                        
!      write(6,'(4(a,f10.3))')'counts=',counts, &                        
!        ' T_bunch=',T_bunch, '  background=',background               
!       write(6,'(6g12.2)') (thfk(i),i=1,256)                           
!      do j=1,nexp                                                      
!       write(6,'(i4,4x,4f15.6)') j,daty(j),erry(j),real_fr(mxpt+j) 
!      end do                                                           
!      do j=1,250                                                     
!      write(6,'(i4,4x,f15.6)') j,thfk(j)                               
!      end do                                                           
!      write(6,'(a,6i5)')'ichanks=',(ichanks(i),i=0,5)
!      write(6,'(a,i8)')'real_fr(mfpt+i) mfpt=',mfpt
!      write(6,'(8f10.1)')(daty(i),i=1,nexp,16)     
      nyy=0 
      ny=0 
      if(b_12) then 
       if(b_data) then 
        if(ndisplay_mode.eq.1)then 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ny=ny+1 
           plotx(ny)=real_fr(mxpt+j) !   =x_exp(j) 
           h=abs(daty(j)) 
           if(h.lt.0.1) then 
            ploty(ny)=0. 
            ploterry(ny)=1. 
            ny=ny-1 
           else 
            ploty(ny)=LOG10(h) 
            ploterry(ny)=1./erry(j) 
           end if 
          end do 
         end do 
!         write(6,*)ny,'=ny  ichanks:',(ichanks(j),j=0,5) 
        else 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ny=ny+1 
           plotx(ny)=real_fr(mxpt+j) !  x_exp(j) 
           ploty(ny)=daty(j) 
           ploterry(ny)=erry(j) 
          end do 
         end do 

         if(b_theory)then 
          nresidue=1 
          ns=0 
          do k=2,ichanks(0),2 
           do j=ichanks(k-1),ichanks(k),isd 
            ns=ns+1 
            plotres(ns)=daty(j)-thfk(j) 
           end do 
          end do 
         end if 
        end if 
       end if  ! b_data
                                                                        
       if(b_theory) then 
        if(ndisplay_mode.eq.1)then 
!         do k=2,ichanks(0),2 
          do j=ichanks(1)+1,ichanks(ichanks(0)),isd 
           nyy=nyy+1 
           plotxx(nyy)=real_fr(mxpt+j)
           plotyy(nyy)=LOG10(abs(thfk(j)+0.1)) 
          end do
!         end do 
!         write(6,*)nyy,'=nyy ichanks:',(ichanks(j),j=0,5) 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do ii=1,nyy 
            ns=ns+1 
            plotsub(ns)=LOG10(abs(subspectrum(ii,j)+0.1)) 
           end do 
          end do 
         end if 
        else 
         nyy=nexp 
         do ii=1,nyy 
          plotxx(ii)=real_fr(mxpt+ii) !  x_exp(ii) 
          plotyy(ii)=thfk(ii) 
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do ii=1,nyy 
            ns=ns+1 
            plotsub(ns)=subspectrum(ii,j) 
           end do 
          end do 
         end if 
        end if 
       end if ! b_theory
      end if  ! log scale  
                                                                        
                                                                        
      if(b_34) then 
       if(b_data) then 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
          ny=ny+1 
          plotx(ny)=j 
          ploty(ny)=daty(j) 
          ploterry(ny)=erry(j) 
!          if(daty(j).lt.0.1) ny=ny-1                                   
         end do 
        end do 

        if(b_theory.and.ndisplay_mode.eq.4)then 
         nresidue=1 
         ns=0 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k),isd 
           ns=ns+1 
           plotres(ns)=daty(j)-thfk(j) 
          end do 
         end do 
        end if 
       end if ! b_data 
                                                                        
       if(b_theory) then 
        nyy=0 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
         nyy=nyy+1 
         plotxx(nyy)=j 
         plotyy(nyy)=thfk(j) 
        end do 
        end do 
        if(n_subspectra.gt.0) then 
         do j=1,n_subspectra 
          ns=(j-1)*max8 
          nchanplot(6+j)=nyy 
          do i=1,nyy 
            ns=ns+1 
            plotsub(ns)=subspectrum(ii,j) 
          end do 
         end do 
        end if 
       end if  ! b_theory 
      end if  ! counts  
                                                                        
!      display_mode(5)='velocity scale, cross section'                  
!      abscissa='[mm/s]'                                                
!      ordinata='cross section'                                         
                                                                        
!      display_mode(5)='channel scale, cross section'                   
!      abscissa='channels'                                              
!       ordinata='cross section'                                        
                                                                        
      if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6) then 
       schrw=1.0 
       nresidue=0 
!       cv_ET=100.*wavelength                                           
!       iT_max=aiT_max                                                  
!       iT_max2=2**iT_max                                               
                                                                        
      if(ndisplay_mode.eq.5) schrw=8*srw8 
!      if(ndisplay_mode.eq.9) schrw=cv_ET/abs(T_bunch*iT_max2)         
       schrw=schrw*nsrw 
!      write(6,'(a,2i8,f10.4)')'array_fr( nn+),nCP,nsrw,schrw=',nCP,nsrw,schrw
       nyy=0 
       hm=0. 
       do ii=-nCP,nCP-1 
        jj=nstorTH1+(nCP+ii)*4 
        nyy=nyy+1 
        plotxx(nyy)=schrw*ii 
        htr=real(array_fr(jj+1))+real(array_fr(jj+4)) 
        plotyy(nyy)=htr 
        if(hm.lt.htr) hm=htr 
       end do 
       plotyy(nyy-1)=0 !hm 
       plotyy(nyy)=0 !-hm/2. 
                                                                        
!      write(6,'(a,2i4,f10.4)') ' nyy,nCP,schrw=',nyy,nCP,schrw         
       n_plotsub=8 
       n_subspectra=n_plotsub 
       do j=1,n_plotsub/2 
        ns=2*(j-1)*max8 
        nchanplot(5+2*j)=nyy 
        do ii=-nCP,nCP-1 
         jj=nstorTH1+(nCP+ii)*4 
         ns=ns+1 
         plotsub(ns)=real(array_fr(jj+j)) 
        end do 
!       write(6,'(a,8i8)') 'hpg_synmoss idum3,nstorTH1=',idum3,nstorTH1       
        ns=(2*j-1)*max8 
        nchanplot(6+2*j)=nyy 
        do ii=-nCP,nCP-1 
         jj=nstorTH1+(nCP+ii)*4 
         ns=ns+1 
         plotsub(ns)=aimag(array_fr(jj+j)) 
        end do 
!       write(6,'(a,2i6)') ' aimag nstorTH1,j=',nstorTH1,j              
!       write(6,'(8f10.4)') (plotsub(ii),ii=(2*j-1)*nyy+1,2*j*nyy)      
       end do 
!       abscissa='Channels' 
!       ordinata='prop. amplitudes' 
       b_logy=.false.
      end if  ! 5,6 
                                                                        
      xmin=1.e30 
      xmax=-xmin 
      ymin=xmin 
                                    ! counts > 0                        
      ymax=0. 
      if(b_data.and.ndisplay_mode.lt.5) then 
       do ii=1,3 
        nchanplot(ii)=ny 
       end do 
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny 
        if(ymin.gt.ploty(i)-ploterry(i))then
!         write(6,*)ploty(i),ploterry(i) 
         ymin=ploty(i)-ploterry(i) 
        end if
       end do 

       do i=1,ny 
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i) 
       end do 
      else 
       do ii=1,4 
        nchanplot(ii)=0 
       end do 
      end if 
                                                                        
      if(b_theory) then 
       nchanplot(5)=nyy 
       nchanplot(6)=nyy 
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy-2 
        if(ymin.gt.plotyy(i))ymin=plotyy(i) 
       end do 
       do i=1,nyy-2 
        if(ymax.lt.plotyy(i))ymax=plotyy(i) 
       end do 
       if(n_subspectra.gt.0) then 
         do j=1,n_subspectra 
          ns=(j-1)*max8 
          do i=1,nyy 
           if(ymin.gt.plotsub(ns+i))ymin=plotsub(ns+i) 
          end do 
         end do 
       end if 
      end if 
!      write(6,'(a,2i5,2g12.2)')'nyy,ny,xmin,xmax=',nyy,ny,xmin,xmax 
      if(nresidue.eq.1) then 
        nchanplot(4)=ny 
        resmin=0. 
        resmax=0. 
        do i=1,ns 
         hd= plotres(i)-ploterry(i) 
         if(resmin.gt.hd) resmin=hd 
        end do 
        do i=1,ns 
         hd= plotres(i)+ploterry(i) 
         if(resmax.lt.hd) resmax=hd 
        end do 
         hd= resmax-2.0*resmin 
        do i=1,ns 
         plotres(i)=plotres(i)+ymax-resmin 
        end do 
        ymax=ymax-resmin+resmax 
      end if 
!      write(6,'(a,4g12.2)')'m=',xmin,xmax,ymin,ymax
       xyzdz(1)=xmin 
       xyzdz(2)=xmax 
       xyzdz(3)=ymin 
       xyzdz(4)=ymax 
                                                                        
       bgcolor='Ivory'//char(0)     ! color background  (0...) [0]  
       fgcolor='black'//char(0) 
       datacolor=fgcolor 
       thcolor=fgcolor 
       rescolor='blue'//char(0) 
       do j=1,maxsub 
        ncolor(j)=icolor_sub(j)
       end do 

       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1 
                                                                        
!      definitions taken from allplo                                    
!      x                                                                
       chx='b'                 ! (none,Both,bottom,top)  [B]            
       chbx='n'                ! (none,bottom,top)  [n]                 
       chlr='l'                ! (left,right)  [r]
       chy='B'                 ! (none,Both,left,right)  [B]            
       chby='r'                ! (none,left,right)  [r]                 
       chbt='t'                ! (bottom,top)  [t]                      
       chh=0.3                 !                                        
       chw=0.25                ! character cw,ch  [0.40,0.40]           
       syw=0.1                 !                                        
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]           
       frcolor=fgcolor         ! color frame       [black]          

       frcolor='blue'//char(0) 
       CTEXT=title 
       CXTEXT=abscissa 
       CYTEXT=ordinata 
                                                                       
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
                  chh,chw,syw,syh,                                      &
                  CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)      
                                                                        
!       write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax            
!      write(6,'(a,f15.5)') ' in frame in plotf plotyy(2)=',plotyy(2)   
!       write(6,'(8f10.4)') (plotx(ii),ii=1,ny,16)                      
!       write(6,'(8f10.4)') (ploty(ii),ii=1,ny,16)                      
!      write(6,'(a,3i8)') 'syn_plot xx nexp,nyy=',nexp,nyy              
!      write(6,'(8f10.4)') (plotxx(ii),ii=1,nyy,16)                     
!      write(6,'(a,3i8)') 'syn_plot yy nexp,nyy=',nexp,nyy              
!      write(6,'(8f10.4)') (plotyy(ii),ii=1,nyy)                        
                                                                        
      return 
    END subroutine syn_plot


    
     subroutine offspec_plot(cmch,n5_offspec,info) 
     use glbconst, only: maxn,max8,maxsub,MDBPLFT,infplot,   &
                         infotext
     use comdat, only: ichanks,mxpt,mypt,mfpt,mdfpt,name_data,       &
                       formdata,b_data,file_data,name_theory,b_theory
     use complt, only: display_mode,ndisplay_mode,icolor_sub
     use comthe, only: real_fr,array_fr,thfk     
     implicit none 
     character(len=4),intent(in):: cmch 
     integer,intent(in),dimension(5):: n5_offspec
     integer ,intent(out):: info 
                                                                       
     integer      n_subspectra,logx,logy,logf,                  &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         parray,xyzdz,vtxt,vtxtp 


     character(len=132):: plotstrdef,plotstrpu,title
     character(len=24) :: axesname,abscissa,ordinata,bgcolor,fgcolor,   &  
                         datacolor,thcolor,rescolor,auxcolor1,          & 
                         auxcolor2,auxcolor3
     character(len=80) :: datfile
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,ch4d,ch4de,ch4a,txtu
                 
     real              :: datx,errx,sym,subspectrum,daty,erry
     integer,parameter :: max8subn=maxsub*max8,max4=4*maxn,max16=maxn*16,&
                          maxn0=4*maxn+2,maxnh=4*maxn/2,max112=maxn*112, &
                 jdumpl=8*(max4+2)+4*(max4/2)+max4,                    &
                 idumpl=4*maxn-8*39-5*infplot-maxsub-201-14*33+jdumpl, &
                 kdumpl=5*max4+max4*maxsub,                            &
                 ldumpl=MDBPLFT*2-180*maxn-jdumpl-kdumpl  
     common/plot/parray(max112),xyzdz(8),vtxt(2,max16),vtxtp(8,32), &
                 int3d(max16),npnt3d(16),ifeder(max16),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,txtu,ch4a(461),     &
                 ch4d(idumpl),datx(max4),errx(max4),sym(max4),         &
                 subspectrum(max4,maxsub),daty(max4),erry(max4),ch4de(ldumpl)

     real            x_exp,x_the 
     common/dastr3d/ x_exp(maxn),x_the(maxn) 
     integer   i,i0,ii,j,jj,k,ISTEU,j6th,j9th,nchannel,ny,isd,         &
               icase,n_omega,n_theta,nstorTH,i_angle,i_angp1,k_omega,  &
               nn,im,i_theta,ntxt,l1_get0,n_anglepair                  
     real      h,h1,Xl,Yl,Zl,BREITE,HOEHE,alpha,rad,                   &
               thmax,damax,damin,scmin,                                &
               omega,omega_beg,domega,omega_end,omegaend,omegabeg,     &
               theta,dtheta,theta_beg,theta_end,thetaend,thetabeg,     &
               anglemax,grazinc,grazout,                               &
               xend,yend,xbeg,ybeg,vxend,vyend,vxbeg,vybeg,            &
               counts,background                                       
     logical   omgtheta,log_mode,b_showangles 
                                                                       
     real,dimension(max8)::plotx,ploty,ploterry,plotres,plotxx,plotyy
     real,dimension(0:8):: OP
     equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),       &
                  (parray(max8*2+1),ploterry(1)),                      &
                  (parray(max8*3+1),plotres(1)),                       &
                  (parray(max8*4+1),plotxx(1)),                        &
                  (parray(max8*5+1),plotyy(1))                         
                                                                       
     logical         b_logx,b_logy 
     character(len=1) :: chx,chbx,chlr,chy,chby,chbt,bsl
     character(len=80):: CTEXT,CXTEXT,CYTEXT,TEXT
     character(len=24):: frcolor,chl,chr
     character(len=7) :: form
     character(len=4) :: ch4
     character(len=2) :: dbsl
     integer         nformx,nformy 
     real            chh,chw,syw,syh 
                                                                        
     if(cmch.eq.'dstr') then 
!      format  reading data                                             
       formdata(1)='z,dz,x y' 
       formdata(2)=' '        
       return 
      end if 
      l1_get0 =n5_offspec(1) 
      icase=int(real(array_fr(l1_get0+1))) 
!      write(6,'(a,i4)')'offspec_plot icase=',icase

      if(cmch.eq.'dmod') then 
!      format  writing data and theory                                  
       namechan(1)='xd' 
       namechan(2)='yd' 
       namechan(3)='zd' 
       namechan(4)='dz' 
       namechan(5)='res' 
       namechan(6)='xt' 
       namechan(7)='yt' 
       namechan(8)='zt' 
       namechan(9)='  ' 
       display_mode(1)='angle scale (linear scale)' 
       display_mode(2)='angle scale-(log scale)' 
       if(icase.lt.3.or.icase.eq.5)then 
        display_mode(3)='channel scale (2d) (linear scale)' 
        display_mode(4)='channel scale (2d) (log scale)' 
       end if 
       return 
      end if 
       txtu='nnn'//char(0)
                                                                        
      nchannel    =n5_offspec(2) 
      n_anglepair=n5_offspec(3) 
      counts      =n5_offspec(4) 
      background  =n5_offspec(5) 
      
      isd=nchannel/1024 
      if(nchannel-isd*1024.gt.0)isd=isd+1 
      if(isd.eq.0)isd=1 
                                                                        
      b_showangles=n_anglepair.eq.1 
      i0=ichar('0') 
      j6th=max8*6 
      j9th=max8*9 
      do k=1,infplot 
       nchanplot(k)=0 
      end do 
                                                                        
      if(.not.b_theory) then 
       info=10 
       infotext(1)='effi/3dplot/notheory' 
       infotext(2)='*** no theory calculated -> no dimensions of the plot'
       infotext(3)='calculate dummy (z=0) to obtaine x,y grid ' 
       infotext(4)=' ' 
       return 
      end if 
                                                                        
      nformx=1 
      nformy=1 
      b_logx=.false. 
      b_logy=.false. 
      log_mode=ndisplay_mode.eq.2.or.ndisplay_mode.eq.4 
      if(log_mode) then 
       kform(1)='f7.2' 
       kform(2)='f8.4' 
       kform(3)='f8.6' 
       kform(4)='f10.6' 
       kform(5)='f7.2' 
       kform(6)='f8.4' 
       kform(7)='f8.4' 
       kform(8)='f8.4' 
       b_logy=.true. 
      else 
       kform(1)='f10.3' 
       kform(2)='f10.3' 
       kform(3)='f8.1' 
       kform(4)='f8.1' 
       kform(5)='f6.0' 
       kform(6)='f10.3' 
       kform(7)='f10.3' 
       kform(8)='f10.0' 
      end if 
      kform(9)=' ' 
      plotstrdef='(xd,yd,zd,dz) (xt,yt,zt)' 
                                                                        
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if                                                                       

      bgcolor='Ivory'//char(0) 
      fgcolor='black'//char(0) 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//char(0) 
      do j=1,maxsub 
       ncolor(j)=icolor_sub(j) 
      end do 

      rad=0.0174533 
      do i=1,16 
       ltext(i)=0 
      end do 
                                                                         
!      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega                
       n_omega=int(real(array_fr(l1_get0+2))) 
       n_theta=int(aimag(array_fr(l1_get0+2))) 
       omgtheta= n_omega.ge.n_theta 
       omega_beg=real(array_fr(l1_get0+3)) 
       domega=aimag(array_fr(l1_get0+3)) 
       theta_beg=real(array_fr(l1_get0+4)) 
       dtheta=aimag(array_fr(l1_get0+4)) 
       omega_end=real(array_fr(l1_get0+5)) 
       theta_end=aimag(array_fr(l1_get0+5)) 
       
       nstorTH=l1_get0+6               ! see th_scanmode() 
!       write(6,'(a,i4,4x,3f10.4)')                     &                
!       'n_theta,theta_beg,dtheta,theta_end=',          &              
!        n_theta,theta_beg,dtheta,theta_end                            
!       write(6,'(a,i4,4x,3f10.4)')                     &                
!       'n_omega,omega_beg,domega,omega_end=',          &               
!       n_omega,omega_beg,domega,omega_end                            
                                                                        
!        display_mode(1)='angle scale (linear scale)'                   
!        display_mode(2)='angle scale-(log scale)'                      
!        display_mode(3)='channel scale (2d) (linear scale)'            
!        display_mode(4)='channel scale (2d) (log scale)'               
        if(icase.eq.1.or.icase.eq.4)then 
         h=(omega_end-omega_beg) 
         h1=(theta_end-theta_beg) 
         if(h.lt.h1)h=h1 
         xyzdz(1)=omega_beg-1. 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1. 
         xyzdz(4)=xyzdz(2) 
         anglemax=theta_end 
         if(theta_end.lt.omega_end) anglemax=omega_end 
         thetabeg=theta_beg 
         omegabeg=omega_beg 
         thetaend=theta_end*1.01 
         omegaend=theta_end*1.01 
        else if(icase.eq.2.or.icase.eq.3)then 
         xyzdz(1)=omega_beg 
         xyzdz(2)=(theta_end-omega_beg)/2. 
         xyzdz(3)=omega_beg 
         xyzdz(4)=(theta_end-omega_beg)/2. 
         anglemax=theta_end 
         thetaend=theta_end*1.01 
         omegaend=theta_end*1.01 
         thetabeg=omega_beg 
         omegabeg=omega_beg 
        else if(icase.eq.5)then 
         h=omega_end 
         xyzdz(1)=omega_beg-1 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1 
         xyzdz(4)=xyzdz(2) 
         anglemax=theta_end 
         if(theta_end.lt.omega_end) anglemax=omega_end 
         thetabeg=theta_beg 
         omegabeg=omega_beg 
         thetaend=omega_end*1.01 
         omegaend=omega_end*1.01 
        end if 
                                                                        
       i_angle=0 
       i_angp1=0 
       j=0 
!      ------caculation of the specular angles (red line)-------        
       omega=omega_beg-domega 
       do while(omega.lt.anglemax) 
        omega=omega+domega 
        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=omega 
        parray(j+2)=omega 
!        write(6,'(i5,i8,a,6f8.2)')j,j6th,'omega, omega_beg/end Theta_beg/end=', &   
!             omega,omegabeg,omegaend,thetabeg,thetaend
!        read(5,*)
        if(omega.gt.thetaend.or.omega.lt.thetabeg .or.                  &
          omega.gt.omegaend.or.omega.lt.omegabeg)i_angp1=i_angp1-1     
        parray(j+3)=0.0 
        if(log_mode) parray(j+3)=1.0 
       end do   ! n_omega    
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=i_angle 
       parray(j+2)=0 
       parray(j+3)=-1. 
!      ------ end of caculation of the specular angles (red line)-------
                                                                        
      do i_theta=1,n_theta 
       theta=theta_beg+dtheta*(i_theta-1) 
                                                                        
       do k_omega=1,n_omega 
        omega=omega_beg+domega*(k_omega-1) 
                                                                        
        if(icase.eq.1.or.icase.eq.4) then 
          grazinc=omega 
          grazout=theta 
        else if(icase.eq.2.or.icase.eq.3) then 
         grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta 
         grazout=2*omega_beg+domega*(n_omega-1)+(i_theta-1)*dtheta*2-grazinc
        else if(icase.eq.5) then 
!        PHI_s=omega N_s=n_omega                                        
         j=i_theta/2 
         if(2*j.eq.i_theta) then 
!         + dTheta_out                                                  
          grazinc=omega 
          grazout=(omega+dtheta*j) 
         else 
!         + dTheta_out                                                  
          grazinc=(omega+dtheta*j) 
          grazout=omega 
         end if 
         if(omega+dtheta*j.gt.omega_end) goto 77 
        end if 
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=grazinc 
        parray(j+2)=grazout 
                                                                        
                                                                        
        if(b_showangles) then 
         parray(j+3)=0.01 
        else 
         h=real_fr(2*nstorTH+i_angle)*counts+background 
!         write(6,'(2i8,3g12.3)')2*nstorTH+i_angle,i_angle,  &           
!                       real_fr(2*nstorTH+i_angle)                     
         if(log_mode)then 
          parray(j+3)=alog10(h) 
!         write(6,'(i8,2g12.3)')j,h, parray(j+3)                        
         else 
          parray(j+3)=h 
         end if 
        end if 

   77   continue 
!       write(11,'(i8,2x,f12.3)')j,parray(j)                                                                       
!       write(6,'(i4,2f12.1)')i_angle,grazinc,grazout                   
       end do     ! n_omega  

        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=i_angle 
        parray(j+2)=0 
        parray(j+3)=-1. 
       end do    ! n_theta 
       
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=-1. 
       parray(j+2)=-1. 
       parray(j+3)=-1. 
                                                                        
       write(11,'(3f10.3)')(parray(j6th+i),i=1,3*i_angp1+3)      
       if(ndisplay_mode.ge.3) goto 1000 
                                                                        
       if(icase.eq.2.or.icase.eq.3) then 
        xbeg =0.02 
        vxbeg=omega_beg 
        xend=1.02 
        vxend=omega_end+dtheta*(n_theta-1)/1.4142 
        ybeg =0.02 
        vybeg=omega_beg 
        yend =xend 
        vyend=vxend 
       else   ! icase.eq.1 or 4 or 5            
        ybeg=0.02 
        vybeg=theta_beg 
        yend=1.02 
        xbeg=0.02 
        vxbeg=omega_beg 
        xend=1.02 
        if(theta_end-theta_beg.lt.omega_end-omega_beg) then 
         vyend=theta_beg+omega_end-omega_beg 
         vxend=omega_end 
        else 
         vyend=theta_end 
         vxend=omega_beg+theta_end-theta_beg 
        end if 
       end if 
                                                                        
!      decission for points or line                                     
       npnt3d(1)=1 
       if(b_showangles) npnt3d(1)=0 
!                                                                       
      if(log_mode)then 
       abscissa='omega[mrad]' 
       axisformat(1)='%5.1f ' 
       ordinata='log counts' 
       axisformat(2)='%12.2f ' 
      else 
       abscissa='omega [mrad]' 
       axisformat(1)='%5.1f ' 
       ordinata='counts' 
       axisformat(2)='%12.2f ' 
      end if 
                                                                        
      xyzdz(5)=1.e10 
      scmin=1.e10 
      xyzdz(6)=0. 
      if(b_showangles) then 
       xyzdz(5)=-0.1 
       xyzdz(6)=1.0 
      end if 
                                                                        
      if(b_theory)then 
       j=j6th 
       thmax=0. 
       do k=1,i_angp1 
        if(parray(j+3).gt.thmax)thmax=parray(j+3) 
        j=j+3 
       end do 
       nchanplot(6)=i_angp1 
       if(thmax.gt.xyzdz(6))xyzdz(6)=thmax 
       j=j6th 
       do k=1,i_angp1 
        if(parray(j+3).lt.thmax)thmax=parray(j+3) 
        j=j+3 
       end do 
       if(thmax.lt.xyzdz(5))xyzdz(5)=thmax 
       scmin=thmax 
      end if 
!       write(6,'(a,f12.5)') ' th_min=',scmin                           
                                                                        
      if(b_data)then 
       j=j9th 
       if(log_mode)then 
        ny=0 
        do k=2,ichanks(0),2 
         do jj=ichanks(k-1),ichanks(k),isd 
         ny=ny+1 
!        do k=1,nchannel                                                
         parray(j+1)=real_fr(mxpt+jj) 
         parray(j+2)=real_fr(mypt+jj) 
         if(real_fr(mfpt+jj).le.0)then 
!          ny=ny-1 
!          j=j-5 
          parray(j+3)=-0.01 
          parray(j+4)=real_fr(mdfpt+jj)/(real_fr(mfpt+jj)+2) 
         else 
          parray(j+3)=alog10(real_fr(mfpt+jj)) 
          parray(j+4)=real_fr(mdfpt+jj)/(real_fr(mfpt+jj)+2) 
!          write(6,'(a,5f10.3)') ' real_fr(mypt+jj)=',parray(j+1),&      
!           parray(j+2),real_fr(mfpt+jj),parray(j+3),parray(j+4)         
         end if 
                                                                        
         parray(j+5)=1. 
         j=j+5 
         end do 
        end do 
!       residual not yet implemented                                    
       else 
        ny=0 
        do k=2,ichanks(0),2 
         do jj=ichanks(k-1),ichanks(k),isd 
         ny=ny+1 
         parray(j+1)=real_fr(mxpt+jj) 
         parray(j+2)=real_fr(mypt+jj) 
         parray(j+3)=real_fr(mfpt+jj) 
         parray(j+4)=real_fr(mdfpt+jj) 
         parray(j+5)=thfk(jj)-parray(j+3) 
         j=j+5 
         end do 
        end do 
                                                                        
        if(n_anglepair.gt.1.) then 
         j=j9th 
         do k=2,ichanks(0),2 
          do jj=ichanks(k-1),ichanks(k),isd 
           parray(j+3)=0.01 
           j=j+5 
          end do 
         end do 
                                                                        
        end if 
       end if 
                                                                        
       j=j9th 
       damax=0. 
       do k=1,ny 
!       write(6,'(i8,2f12.2)')j,parray(j+3),parray(j+4)                
        if(parray(j+3)+parray(j+4).gt.damax)                            &
                 damax=parray(j+3)+parray(j+4)                         
        j=j+5 
       end do 
       j=j9th 
       damin=damax 
       do k=1,ny 
        if(parray(j+3)-parray(j+4).lt.damin)                            &
     &            damin=parray(j+3)-parray(j+4)                         
        j=j+5 
       end do 
       if(damax.gt.xyzdz(6)) xyzdz(6)=damax 
       if(damin.lt.xyzdz(5)) xyzdz(5)=damin 
       nchanplot(1)=ny 
                                                                        
       j=j9th 
       do k=1,ny 
        if(parray(j+3).lt.scmin) scmin=parray(j+3) 
         j=j+5 
       end do 
      end if    ! b_data  
                                                                        
      if(n_anglepair.gt.1) then 
        xyzdz(5)=0. 
        xyzdz(6)=1. 
      end if 
                                                                        
!      ------ begin of correction the specular angles (red line)------- 
!      the z-component of the first point (used for all z-values i xmosp
       if(log_mode)parray(j6th+3)=xyzdz(4) 
!      ------ end of correction of the specular angles (red line)-------
                                                                        
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=i_angle 
       parray(j+2)=0 
       parray(j+3)=-1. 
!      ------ end of caculation of the specular angles (red line)-------
                                                                        
       axesname(1)=abscissa 
       axesname(2)='theta [mrad]' 
       axesname(3)=ordinata 
       auxcolor1='red'//char(0) 
       auxcolor2='yellow'//char(0) 

                                                                        
       title=name_data 
!       if(.not.b_data) then 
        if(icase.eq.1) title=TRIM(name_theory)//': @4 detector scan@ ' 
        if(icase.eq.2) title=TRIM(name_theory)//': omega scan' 
        if(icase.eq.3) title=TRIM(name_theory)//': omega scan (3d)' 
        if(icase.eq.4) title=TRIM(name_theory)//': theta1/theta2 (3d)' 
        if(icase.eq.5) title=TRIM(name_theory)//': parallel scan' 
!       end if 
                                                                 
       ISTEU=1 
       BREITE=0.5 
       HOEHE=0.6 
       ntxt=LEN_TRIM(text) 
!       write(6,'(i4,a)')ntxt,title                                     
       TEXT=title 
       alpha=90. 
       OP(0)=0.            ! no rotation around z-axis of inscription   
       OP(1)=0.            ! phix                                       
       OP(2)=0.            ! phiz                                       
       OP(3)=0.            ! phiy                                       
       OP(4)=10.            ! Xb                                        
       OP(5)=10.            ! Yb                                        
       OP(6)=0.0           ! Zb                                         
       OP(7)=0.            ! strsx                                      
       OP(8)=0.            ! strsy                                      
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!       -------- omega axis -------------------------------             
       OP(0)=1 
       bsl=char(92) 
       dbsl='$'//bsl 
       form='f5.2' 
       alpha=0. 
       BREITE=0.4 
       HOEHE=0.4 
       TEXT=bsl//'gW' 
       ntxt=3 
       if(icase.eq.4)then 
          TEXT=bsl//'gq$_1$ ' 
          ntxt=8 
       end if 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=1.           ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-1.3*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.2 
       HOEHE=0.25 
       TEXT=bsl//'r   [mrad]' 
       ntxt=11 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=1.           ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-2.6*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.3 
       HOEHE=0.3 
       call trlnu(form,vxbeg,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=xbeg         ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=Xl           ! strsx                                       
       OP(8)=-0.4*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       call trlnu(form,vxend,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=xend         ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-0.4*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!      -------- theta axis -------------------------------              
                                                                        
       ISTEU=1 
       alpha=0. 
       BREITE=0.4 
       HOEHE=0.5 
       TEXT=bsl//'gQ' 
       ntxt=3 
       if(icase.eq.4)then 
         TEXT=bsl//'gq$_2$ ' 
         ntxt=8 
       end if 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=0.87           ! Yb                                        
       OP(6)=0.           ! Zb                                          
       OP(7)=-1.6*HOEHE     ! strsx                                     
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
                                                                        
       BREITE=0.2 
       HOEHE=0.25 
       TEXT=bsl//'r   [mrad]' 
       ntxt=11 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=1.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=-3.5*HOEHE     ! strsx                                     
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.3 
       HOEHE=0.3 
       call trlnu(form,vybeg,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=ybeg          ! Yb                                         
       OP(6)=0.           ! Zb                                          
       OP(7)=-0.4*HOEHE   ! strsx                                       
       OP(8)=0.0             ! strsy                                    
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
                                                                        
       call trlnu(form,vyend,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=yend         ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=-0.4*HOEHE   ! strsx                                       
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!      -------- z axis -------------------------------                  
       BREITE=0.21 
       HOEHE=0.25 
       if(log_mode)then 
        i=0.8*int(xyzdz(6)+1.) 
        ii=i/10 
        jj=i-10*ii 
        ch4=' '//char(jj+i0)//'.0' 
        if(ii.gt.0)ch4(1:1)=char(ii+i0) 
        TEXT='lg(counts)' 
        ntxt=10 
       else 
        i=int(alog(xyzdz(6)+1.)/alog(10.)) 
        TEXT='counts[10$^'//char(i+i0)//'$ ]' 
        ntxt=16 
        form='f4.1' 
        h=0.8*xyzdz(6)/10**i 
        call trlnu(form,h,chr,nn,chl,im) 
        ch4=chl 
       end if 
       alpha=90. 
       OP(0)=0.           ! no rotation around z-axis of inscription    
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=-0.05        ! Xb                                          
       OP(5)=-0.05        ! Yb                                          
       OP(6)=0.4         ! Zb                                           
       OP(7)=0.           ! strsx                                       
       OP(8)=0.           ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       TEXT=ch4 
       ntxt=4 
       alpha=0. 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(0)=0.             ! no rotation around z-axis of inscription   
       OP(1)=0.             ! phix                                       
       OP(2)=0.             ! phiz                                       
       OP(3)=0.             ! phiy                                       
       OP(4)=0.             ! Xb                                         
       OP(5)=0.             ! Yb                                         
       OP(6)=0.75           ! Zb                                        
       OP(7)=0.             ! strsx                                      
       OP(8)=-Xl-0.4*HOEHE  ! strsy                                      
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       if(log_mode)then 
        i=int(scmin) 
!        write(6,'(a,i4)')'  log mode i=',i                             
         jj=abs(i) 
         ch4='-'//char(jj+i0)//'.0' 
         ii=10*(abs(scmin)-jj) 
         ch4(4:4)=char(ii+i0) 
        if(i.lt.0) then 
         TEXT=ch4 
         ntxt=4 
        else 
         ch4(1:1)=' ' 
         TEXT=ch4(2:4) 
         ntxt=3 
        end if 
       alpha=0. 
       OP(0)=0.             ! no rotation around z-axis of inscription    
       OP(1)=0.             ! phix                                        
       OP(2)=0.             ! phiz                                        
       OP(3)=0.             ! phiy                                        
       OP(4)=0.             ! Xb                                          
       OP(5)=0.             ! Yb                                          
       OP(6)=0.02           ! Zb                                          
       OP(7)=0.             ! strsx                                       
       OP(8)=-XL-0.4*BREITE ! strsy                                     

       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       end if 
!       write(6,'(a,8g12.6)')' min-max=', &                              
!              xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)     
                                                                        
                                                                        
!     fill in test data                                                 
      return 

 1000 continue 
       i_angle=0 
       i_angp1=0 
       do i_theta=1,n_theta 
        theta=theta_beg+dtheta*(i_theta-1) 
        do k_omega=1,n_omega 
         omega=omega_beg+domega*(k_omega-1) 
         if(icase.eq.2.or.icase.eq.3) then 
            grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta 
            grazout=2*omega_beg+domega*(n_omega-1)+                     &
             (i_theta-1)*dtheta*2-grazinc                              
         else if(icase.eq.5) then 
!         PHI_s=omega N_s=n_omega                                       
          j=i_theta/2 
          if(2*j.eq.i_theta) then 
!          + dTheta_out                                                 
           grazinc=omega 
           grazout=(omega+dtheta*j) 
          else 
!          + dTheta_out                                                 
           grazinc=(omega+dtheta*j) 
           grazout=omega 
          end if 
          if(omega+dtheta*j.gt.omega_end)goto 777 
         end if 
         i_angle=i_angle+1 
         i_angp1=i_angp1+1 
                                                                        
         if(.not.b_showangles)then 
          h=real_fr(2*nstorTH+i_angle)*counts+background 
          if(log_mode)then 
            plotyy(i_angp1)=alog10(h) 
          else 
           plotyy(i_angp1)=h 
          end if 
          plotxx(i_angp1)=i_angp1 
         end if 
  777    continue 
!         write(6,'(i6,a,4g12.6)')i_angp1 ,' plotxx(i_angp1)=',plotxx(i_angp1),plotyy(i_angp1)      
        end do  ! n_omega     
        i_angp1=i_angp1+1 
        plotxx(i_angp1)=i_angp1 
        plotyy(i_angp1)=-1. 
        nchanplot(5)=i_angp1 
       end do   ! n_theta      
                                                                        
                                                                        
!     write(6,'(2f12.2)') (real_fr(mfpt+j),real_fr(2*nstorTH+j),j=1,12)
      if(log_mode)then 
       abscissa='channel' 
       axisformat(1)='%5.1f ' 
       ordinata='lg(counts)' 
       axisformat(2)='%12.2f ' 
      else 
       abscissa='channel' 
       axisformat(1)='%5.1f ' 
       ordinata='counts' 
       axisformat(2)='%12.2f ' 
      end if 
                                                                        
      xyzdz(1)=1 
      xyzdz(2)=0. 
      xyzdz(3)=1.e10 
      xyzdz(4)=0. 
                                                                        
      if(b_data) then 
       if(log_mode)then 
        ny=0 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
          ny=ny+1 
          plotx(ny)=j 
          if(real_fr(mfpt+j).lt.1.0) then 
            ny=ny-1
          else 
           ploty(ny)=alog10(real_fr(mfpt+j)) 
           ploterry(ny)=real_fr(mdfpt+j)/(real_fr(mfpt+j)+1) 
!          write(6,'(2i6,a,4g12.6)')ny,j,' ploty(ny)=',ploty(ny)        
          end if 
         end do 
        end do 
        nchanplot(1)=ny 
       else 
        ny=0 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k),isd 
          ny=ny+1 
          plotx(ny)=j 
          if(real_fr(mfpt+j).lt.0.0) then 
           ny=ny-1
          else 
           ploty(ny)=real_fr(mfpt+j) 
           ploterry(ny)=real_fr(mdfpt+j) 
!          write(6,'(2i6,a,4g12.6)')ny,j,' ploty(ny)=',ploty(ny)        
          end if 
         end do 
        end do 
        nchanplot(1)=ny 
       end if 
       xyzdz(1)=1 
       xyzdz(2)=ny 
       damax=0. 
       do i=1,ny 
        if(ploty(i)+ploterry(i).gt.damax)damax=ploty(i)+ploterry(i) 
       end do 
       if(damax.gt.xyzdz(4))xyzdz(4)=damax 
       do i=1,ny 
        if(ploty(i)-ploterry(i).lt.damax)damax=ploty(i)-ploterry(i) 
       end do 
       if(damax.lt.xyzdz(3))xyzdz(3)=damax 
      end if   ! b_data  
                                                                        
                                                                        
      if(b_showangles.and..not.b_data) then 
       xyzdz(3)=-0.1 
       xyzdz(4)=1.0 
      end if 
                                                                        
                                                                        
      thmax=-1.e10 
      if(.not.b_showangles)then 
       jj=nchanplot(5) 
       do i=1,jj 
        if(plotyy(i).gt.thmax)thmax=plotyy(i) 
       end do 
       if(thmax.gt.xyzdz(4))xyzdz(4)=thmax 
       xyzdz(2)=jj 
       do i=1,jj 
        if(plotyy(i).lt.thmax)thmax=plotyy(i) 
       end do 
       if(thmax.lt.xyzdz(3))xyzdz(3)=thmax 
      end if 
!       write(6,'(i6,a,8g12.6)')nchanplot(5),' min-max=',    &           
!            xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)     
                                                                        
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=name_data 
      if(.not.b_data) title=name_theory 
                                                                        
                                    ! color background  (0...) [0]      
       bgcolor='Ivory'//char(0) 
       fgcolor='black'//char(0) 
       datacolor=fgcolor 
       thcolor=fgcolor 
       rescolor='blue'//char(0) 
       do j=1,maxsub 
        ncolor(j)=icolor_sub(j) 
       end do 

       frcolor=fgcolor         ! color frame       [black]              
       CTEXT=title 
       CXTEXT=abscissa 
       CYTEXT=ordinata 


       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1 

!      definitions taken from allplo                                    
       chx='B'                 ! (none,Both,bottom,top)  [B]            
       chbx='n'                ! (none,bottom,top)  [n]                 
       chlr='l'                ! (left,right)  [r]                      
       chy='r'                 ! (none,Both,left,right)  [B]            
       chby='r'                ! (none,left,right)  [r]                 
       chbt='b'                ! (bottom,top)  [t]                      
       chh=0.3                 !                                        
       chw=0.25                ! character cw,ch  [0.40,0.40]           
       syw=0.1                 !                                        
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]           

                                                                        
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
                  chh,chw,syw,syh,                                      &
                  CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)    
                                                                       
!      write(6,'(a,i5)') ' rdplpu3d nchannel=',nchannel                 
!       write(6,'(a,4g12.6)')' b min-max=',     &                        
!                     xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4)                       
!      write(6,'(8f10.4)') (plotxx(ii),ii=1,nchannel)                   
!      write(6,'(8f10.4)') (plotyy(ii),ii=1,nchanplot(5))               
!      write(6,'(8f10.4)') (ploterry(ii),ii=1,nchannel,16)              
                                                                        
      return 
      END                                           


      subroutine offspecplot(cmch,n5_offspec,info) 
     use glbconst, only: maxn,max8,maxsub,MDBPLFT,infplot
     use comdat, only: ichanks,mxpt,mypt,mfpt,mdfpt,name_data,       &
                       formdata,b_data,file_data,name_theory,b_theory
     use comthe, only: real_fr     
     implicit none 
     character(len=4),intent(in):: cmch 
     integer,intent(in),dimension(5):: n5_offspec
     integer ,intent(out):: info 
                                                                       
     integer      n_subspectra,logx,logy,logf,                  &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         parray,xyzdz,vtxt,vtxtp 


     character(len=132):: plotstrdef,plotstrpu,title
     character(len=24) :: axesname,abscissa,ordinata,bgcolor,fgcolor,   &  
                         datacolor,thcolor,rescolor,auxcolor1,          & 
                         auxcolor2,auxcolor3
     character(len=80) :: datfile 
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,ch4d,ch4de,ch4a,txtu
                 
     real              :: datx,errx,sym,subspectrum,daty,erry
     integer,parameter :: max8subn=maxsub*max8,max4=4*maxn,max16=maxn*16,&
                          maxn0=4*maxn+2,maxnh=4*maxn/2,max112=maxn*112, &
                 jdumpl=8*(max4+2)+4*(max4/2)+max4,                    &
                 idumpl=4*maxn-8*39-5*infplot-maxsub-201-14*33+jdumpl, &
                 kdumpl=5*max4+max4*maxsub,                            &
                 ldumpl=MDBPLFT*2-180*maxn-jdumpl-kdumpl  
     common/plot/parray(max112),xyzdz(8),vtxt(2,max16),vtxtp(8,32), &
                 int3d(max16),npnt3d(16),ifeder(max16),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,txtu,ch4a(461), &
                 ch4d(idumpl),datx(max4),errx(max4),sym(max4),         &
                 subspectrum(max4,maxsub),daty(max4),erry(max4),ch4de(ldumpl)

     real            x_exp,x_the 
     common/dastr3d/ x_exp(maxn),x_the(maxn) 
     integer   i,i0,ii,j,jj,k,ISTEU,j6th,j9th,nchannel,ny,isd,         &
               icase,n_omega,n_theta,i_angle,i_angp1,k_omega,  &
               nn,im,i_theta,ntxt,n_anglepair                  
     real      h,h1,Xl,Yl,Zl,BREITE,HOEHE,alpha,rad,                   &
               thmax,damax,damin,scmin,                                &
               omega,omega_beg,domega,omega_end,omegaend,omegabeg,     &
               theta,dtheta,theta_beg,theta_end,thetaend,thetabeg,     &
               anglemax,                                               &
               xend,yend,xbeg,ybeg,vxend,vyend,vxbeg,vybeg,            &
               counts,background                                       
     logical   omgtheta,log_mode,b_showangles 
                                                                       
     real,dimension(max8)::plotx,ploty,ploterry,plotres,plotxx,plotyy
     real,dimension(0:8):: OP
     equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),       &
                  (parray(max8*2+1),ploterry(1)),                      &
                  (parray(max8*3+1),plotres(1)),                       &
                  (parray(max8*4+1),plotxx(1)),                        &
                  (parray(max8*5+1),plotyy(1))                         
                                                                       
     character(len=80):: TEXT
     character(len=24):: chl,chr
     character(len=7) :: form
     character(len=4) :: ch4
     character(len=2) :: dbsl
     character(len=1) :: bsl
     integer         nformx,nformy 
                                                                        
     if(cmch.eq.'dstr') then 
!      format  reading data                                             
       formdata(1)='z,dz,x y' 
       formdata(2)=' '        
       return 
    end if
    if(cmch.eq.'dmod') then
       !      format  writing data and theory                                  
       namechan(1)='xd' 
       namechan(2)='yd' 
       namechan(3)='zd' 
       namechan(4)='dz' 
       namechan(5)='res' 
       namechan(6)='xt' 
       namechan(7)='yt' 
       namechan(8)='zt' 
       namechan(9)='  ' 
       return
    end if
 
      nchannel    =n5_offspec(2) 
      n_anglepair=n5_offspec(3) 
      counts      =n5_offspec(4) 
      background  =n5_offspec(5) 
      
      isd=nchannel/1024 
      if(nchannel-isd*1024.gt.0)isd=isd+1 
      if(isd.eq.0)isd=1 
                                                                        
      b_showangles=n_anglepair.eq.1 
      i0=ichar('0') 
      j6th=max8*6 
      j9th=max8*9 
      do k=1,infplot 
       nchanplot(k)=0 
      end do 
                                                                        
      nformx=1 
      nformy=1 
       kform(1)='f10.3' 
       kform(2)='f10.3' 
       kform(3)='f8.1' 
       kform(4)='f8.1' 
       kform(5)='f6.0' 
       kform(6)='f10.3' 
       kform(7)='f10.3' 
       kform(8)='f10.0' 
       kform(9)=' ' 
       plotstrdef='(xd,yd,zd,dz) (xt,yt,zt)'//char(0) 
                                                                        
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if                                                                       

      bgcolor='Ivory'//char(0) 
      fgcolor='black'//char(0) 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//char(0) 

      rad=0.0174533 
      do i=1,16 
       ltext(i)=0 
      end do 
                                                                         
!      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega                
       n_omega=15 
       omega_beg=4.0
       omega_end=8.0

       n_theta=2
       theta_beg=4.0 
       theta_end=6.0 

       omgtheta= n_omega.ge.n_theta 
       domega= 0.285 
       dtheta= 2.0 


       
         h=(omega_end-omega_beg) 
         h1=(theta_end-theta_beg) 
         if(h.lt.h1)h=h1 
         xyzdz(1)=omega_beg-1. 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1. 
         xyzdz(4)=xyzdz(2) 
         anglemax=theta_end 
         if(theta_end.lt.omega_end) anglemax=omega_end 
         thetabeg=theta_beg 
         omegabeg=omega_beg 
         thetaend=theta_end*1.01 
         omegaend=theta_end*1.01 
                                                                        
       i_angle=0 
       i_angp1=0 
       j=0 
!      ------caculation of the specular angles (red line)-------        
       omega=omega_beg-domega 
       do while(omega.lt.anglemax) 
        omega=omega+domega 
        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=omega 
        parray(j+2)=omega 
!        write(6,'(a,6f12.2)')'omega, omega_beg/end Theta_beg/end=', &   
!                    omega,omegabeg,omegaend,thetabeg,thetaend         
        if(omega.gt.thetaend.or.omega.lt.thetabeg .or.                  &
          omega.gt.omegaend.or.omega.lt.omegabeg)i_angp1=i_angp1-1     
        parray(j+3)=0.0 
       end do   ! n_omega    
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=i_angle 
       parray(j+2)=0 
       parray(j+3)=-1. 
!      ------ end of caculation of the specular angles (red line)-------
                                                                        
      do i_theta=1,n_theta 
       theta=theta_beg+dtheta*(i_theta-1) 
                                                                        
       do k_omega=1,n_omega 
        omega=omega_beg+domega*(k_omega-1) 
                                                                        
        i_angle=i_angle+1 
        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=omega 
        parray(j+2)=theta 
                                                                        
                                                                        
        if(b_showangles) then 
         parray(j+3)=0.01 
        else 
           h=0.5+0.1*i_angle
         parray(j+3)=h 
        end if 
       end do 
        i_angp1=i_angp1+1 
        j=3*(i_angp1-1)+j6th 
        parray(j+1)=i_angle 
        parray(j+2)=0 
        parray(j+3)=-1. 
      end do    ! n_theta 
                                                                        
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=-1. 
       parray(j+2)=-1. 
       parray(j+3)=-1. 
                                                                        
                                                                        
        ybeg=0.02 
        vybeg=theta_beg 
        yend=1.02 
        xbeg=0.02 
        vxbeg=omega_beg 
        xend=1.02 
        if(theta_end-theta_beg.lt.omega_end-omega_beg) then 
         vyend=theta_beg+omega_end-omega_beg 
         vxend=omega_end 
        else 
         vyend=theta_end 
         vxend=omega_beg+theta_end-theta_beg 
        end if 
                                                                        
!      decission for points or line                                     
       npnt3d(1)=1 
       if(b_showangles) npnt3d(1)=0 
!                                                                       
       abscissa='omega [mrad]' 
       axisformat(1)='%5.1f ' 
       ordinata='counts' 
       axisformat(2)='%12.2f ' 
                                                                        
      xyzdz(5)=1.e10 
      scmin=1.e10 
      xyzdz(6)=0. 
      if(b_showangles) then 
       xyzdz(5)=-0.1 
       xyzdz(6)=1.0 
      end if 
                                                                        
       j=j6th 
       thmax=0. 
       do k=1,i_angp1 
        if(parray(j+3).gt.thmax)thmax=parray(j+3) 
        j=j+3 
       end do 
       nchanplot(6)=i_angp1 
       if(thmax.gt.xyzdz(6))xyzdz(6)=thmax 
       j=j6th 
       do k=1,i_angp1 
        if(parray(j+3).lt.thmax)thmax=parray(j+3) 
        j=j+3 
       end do 
       if(thmax.lt.xyzdz(5))xyzdz(5)=thmax 
       scmin=thmax 
!       write(6,'(a,f12.5)') ' th_min=',scmin                           

       if(b_data)then 
        j=j9th 
        ny=0 
        do k=2,ichanks(0),2 
         do jj=ichanks(k-1),ichanks(k),isd 
         ny=ny+1 
         parray(j+1)=real_fr(mxpt+jj) 
         parray(j+2)=real_fr(mypt+jj) 
         parray(j+3)=real_fr(mfpt+jj) 
         parray(j+4)=real_fr(mdfpt+jj) 
         parray(j+5)=0.01 
         j=j+5 
         end do 
        end do 
        
        if(n_anglepair.gt.1.) then 
         j=j9th 
         do k=2,ichanks(0),2 
          do jj=ichanks(k-1),ichanks(k),isd 
           parray(j+3)=0.01 
           j=j+5 
          end do 
         end do 
        end if 
                                                                        
       j=j9th 
       damax=0. 
       do k=1,ny 
!       write(6,'(i8,2f12.2)')j,parray(j+3),parray(j+4)                
        if(parray(j+3)+parray(j+4).gt.damax)                            &
                 damax=parray(j+3)+parray(j+4)                         
        j=j+5 
       end do 
       j=j9th 
       damin=damax 
       do k=1,ny 
        if(parray(j+3)-parray(j+4).lt.damin)                            &
     &            damin=parray(j+3)-parray(j+4)                         
        j=j+5 
       end do 
       if(damax.gt.xyzdz(6)) xyzdz(6)=damax 
       if(damin.lt.xyzdz(5)) xyzdz(5)=damin 
       nchanplot(1)=ny 
                                                                        
       j=j9th 
       do k=1,ny 
        if(parray(j+3).lt.scmin) scmin=parray(j+3) 
         j=j+5 
       end do 
      end if    ! b_data  
                                                                        
      if(n_anglepair.gt.1) then 
        xyzdz(5)=0. 
        xyzdz(6)=1. 
      end if 
                                                                        
       i_angp1=i_angp1+1 
       j=3*(i_angp1-1)+j6th 
       parray(j+1)=i_angle 
       parray(j+2)=0 
       parray(j+3)=-1. 
!      ------ end of caculation of the specular angles (red line)-------
                                                                        
       axesname(1)=abscissa 
       axesname(2)='theta [mrad]' 
       axesname(3)=ordinata 
       auxcolor1='red'//char(0) 
       auxcolor2='yellow'//char(0) 

        title=Trim(name_data)//char(0) 
!       if(.not.b_data) then 
        title=TRIM(name_theory)//': @4 detector scan@ '//char(0)  
                                                                 
       ISTEU=1 
       BREITE=0.5 
       HOEHE=0.6 
       ntxt=LEN_TRIM(text) 
!       write(6,'(i4,a)')ntxt,title                                     
       TEXT=title 
       alpha=90. 
       OP(0)=0.            ! no rotation around z-axis of inscription   
       OP(1)=0.            ! phix                                       
       OP(2)=0.            ! phiz                                       
       OP(3)=0.            ! phiy                                       
       OP(4)=10.            ! Xb                                        
       OP(5)=10.            ! Yb                                        
       OP(6)=0.0           ! Zb                                         
       OP(7)=0.            ! strsx                                      
       OP(8)=0.            ! strsy                                      
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!       -------- omega axis -------------------------------             
       OP(0)=1 
       bsl=char(92) 
       dbsl='$'//bsl 
       form='f5.2' 
       alpha=0. 
       BREITE=0.4 
       HOEHE=0.4 
       TEXT=bsl//'gW' 
       ntxt=3 
       if(icase.eq.4)then 
          TEXT=bsl//'gq$_1$ ' 
          ntxt=8 
       end if 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=1.           ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-1.3*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.2 
       HOEHE=0.25 
       TEXT=bsl//'r   [mrad]' 
       ntxt=11 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=1.           ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-2.6*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.3 
       HOEHE=0.3 
       call trlnu(form,vxbeg,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=xbeg         ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=Xl           ! strsx                                       
       OP(8)=-0.4*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       call trlnu(form,vxend,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       OP(1)=-90.*rad     ! phix                                        
       OP(2)=-90.*rad     ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=xend         ! Xb                                          
       OP(5)=0.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=0.           ! strsx                                       
       OP(8)=-0.4*HOEHE   ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!      -------- theta axis -------------------------------              
                                                                        
       ISTEU=1 
       alpha=0. 
       BREITE=0.4 
       HOEHE=0.5 
       TEXT=bsl//'gQ' 
       ntxt=3 
       if(icase.eq.4)then 
         TEXT=bsl//'gq$_2$ ' 
         ntxt=8 
       end if 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=0.87           ! Yb                                        
       OP(6)=0.           ! Zb                                          
       OP(7)=-1.6*HOEHE     ! strsx                                     
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
                                                                        
       BREITE=0.2 
       HOEHE=0.25 
       TEXT=bsl//'r   [mrad]' 
       ntxt=11 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=1.           ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=-3.5*HOEHE     ! strsx                                     
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       BREITE=0.3 
       HOEHE=0.3 
       call trlnu(form,vybeg,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=ybeg          ! Yb                                         
       OP(6)=0.           ! Zb                                          
       OP(7)=-0.4*HOEHE   ! strsx                                       
       OP(8)=0.0             ! strsy                                    
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
                                                                        
       call trlnu(form,vyend,chr,nn,chl,im) 
       if(chr(nn:nn).eq.'0')nn=nn-1 
       TEXT=chr(:nn) 
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=-90.*rad     ! phiy                                        
       OP(4)=0            ! Xb                                          
       OP(5)=yend         ! Yb                                          
       OP(6)=0.           ! Zb                                          
       OP(7)=-0.4*HOEHE   ! strsx                                       
       OP(8)=-Xl          ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
!      -------- z axis -------------------------------                  
       BREITE=0.21 
       HOEHE=0.25 
       if(log_mode)then 
        i=0.8*int(xyzdz(6)+1.) 
        ii=i/10 
        jj=i-10*ii 
        ch4=' '//char(jj+i0)//'.0' 
        if(ii.gt.0)ch4(1:1)=char(ii+i0) 
        TEXT='lg(counts)' 
        ntxt=10 
       else 
        i=int(alog(xyzdz(6)+1.)/alog(10.)) 
        TEXT='counts[10$^'//char(i+i0)//'$ ]' 
        ntxt=16 
        form='f4.1' 
        h=0.8*xyzdz(6)/10**i 
        call trlnu(form,h,chr,nn,chl,im) 
        ch4=chl 
       end if 
       alpha=90. 
       OP(0)=0.           ! no rotation around z-axis of inscription    
       OP(1)=0.           ! phix                                        
       OP(2)=0.           ! phiz                                        
       OP(3)=0.           ! phiy                                        
       OP(4)=-0.05        ! Xb                                          
       OP(5)=-0.05        ! Yb                                          
       OP(6)=0.4          ! Zb                                           
       OP(7)=0.           ! strsx                                       
       OP(8)=0.           ! strsy                                       
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       TEXT=ch4 
       ntxt=4 
       alpha=0. 
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       OP(0)=0.             ! no rotation around z-axis of inscription   
       OP(1)=0.             ! phix                                       
       OP(2)=0.             ! phiz                                       
       OP(3)=0.             ! phiy                                       
       OP(4)=0.             ! Xb                                         
       OP(5)=0.             ! Yb                                         
       OP(6)=0.75           ! Zb                                        
       OP(7)=0.             ! strsx                                      
       OP(8)=-Xl-0.4*HOEHE  ! strsy                                      
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
                                                                        
       if(log_mode)then 
        i=int(scmin) 
!        write(6,'(a,i4)')'  log mode i=',i                             
         jj=abs(i) 
         ch4='-'//char(jj+i0)//'.0' 
         ii=10*(abs(scmin)-jj) 
         ch4(4:4)=char(ii+i0) 
        if(i.lt.0) then 
         TEXT=ch4 
         ntxt=4 
        else 
         ch4(1:1)=' ' 
         TEXT=ch4(2:4) 
         ntxt=3 
        end if 
       alpha=0. 
       OP(0)=0.             ! no rotation around z-axis of inscription    
       OP(1)=0.             ! phix                                        
       OP(2)=0.             ! phiz                                        
       OP(3)=0.             ! phiy                                        
       OP(4)=0.             ! Xb                                          
       OP(5)=0.             ! Yb                                          
       OP(6)=0.02           ! Zb                                          
       OP(7)=0.             ! strsx                                       
       OP(8)=-XL-0.4*BREITE ! strsy                                     

       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl) 
       end if 
!       write(6,'(a,8g12.6)')' min-max=', &                              
!               xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)     
                                                                        
                                                                        
      return 
      END                                           
