!     author : h. spiering                                              
!              Am Damsberg 86                                           
!              D-55130 Mainz                                            
!              last version september 2004                              
     subroutine fr_neutron(cmch,iss,info) 
     use glbconst, only: maxfr1,maxfr2,icstrf,ivstrf,maxthss,infotext 
     use comdat, only: b_theory,data_str,mfpt,mdfpt,mlpt,formdata,nuofdatas,ichanks
     use comthe, only: ifrcase,ifrsto,array_fr,theoryname,   &
                       thfrcase
     use complt, only: ndisplay_mode
     implicit none 
     character(len=4), intent(inout):: cmch
     integer, intent(in) :: iss
     integer, intent(out):: info                                        
     integer       mstruct1,istruct1,istruct2,                &
                   l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,          &
                   nstorTH,nstorRM,nstorTHyy,mpt,ipLG,iaddr              
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   mpt,ipLG,nstorTH,nstorRM,nstorTHyy,iaddr(3)

     integer       istorTH,nexp,mxpt,ien
     common/strLOC/istorTH,nexp,mxpt,ien(29)                                   
                                                                       
     real          acsp,dwba,dastr,channels,anglepair,unit_sclB,       &
                   unit_sclN,lambda,q_ch,q_beg,q_end,an2theta,dumcsp  
     common/acstrf/acsp,dwba,dastr,channels,anglepair,                 &
                   unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,an2theta,&
                   dumcsp(icstrf-12)                                   
     real          avsp,counts,background,Pxsi_b,Peta_b,Pzeta_b,       &
                   Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp                
     common/avstrf/avsp,counts,background,Pxsi_b,Peta_b,Pzeta_b,       &
                   Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp(ivstrf-10)     
     logical       b_avsp,b_counts,b_background,                       &
                   b_Pxsi_b,b_Peta_b,b_Pzeta_b,                        &
                   b_Pxsi_a,b_Peta_a,b_Pzeta_a,b_v_shift,b_dumvsp      
     common/bvstrf/b_avsp,b_counts,b_background,                       &
                   b_Pxsi_b,b_Peta_b,b_Pzeta_b,                        &
                   b_Pxsi_a,b_Peta_a,b_Pzeta_a,                        &
                   b_v_shift,b_dumvsp(ivstrf-10)                       
                                                                       
                                                                       
     integer       nchansp,k1,k2,mdastr,icase
     integer,dimension(5):: n5_offspec 
!***********************************************************************
!                                                                       
      if(cmch.eq.'thna') then 
       theoryname= 'Neutron source          v=001'
       thfrcase(1)='Neutron rocking curve(11)    v=001' 
       thfrcase(2)='Neutron offspecular(21)    v=001' 
       return 
      end if 
!***********************************************************************
                                                                        
      info=0                  
      nchansp=channels  ! number of experimental data  
      nexp= nchansp   
      if(cmch.eq.'arr0') then 
       nstorTH=(nuofdatas+2)*(nchansp+1)/2 
       if(nuofdatas.eq.0) then
        ichanks(0)=2; ichanks(1)=1; ichanks(2)=nchansp
       end if
        mpt=0
!       nstorFR    is now added inside EFFI                             
!       the pointer information (nstorFR numbers, strings)              
!       about the theory ist stored in array_fr. The absolute address of
!       set is added by effi entering the set for the first time.       
!       The 8 interger numbers (here) nstorTH,nstorRM,nstorTHyy,idum(5) 
!       appear to be changed by effi calling commands like pl,te,ft,...  
!       (8 is the maximum number of pointers which can be precalculated 
!        setting up the theory)                                         

        if(ifrcase.eq.11) then 
         istorTH=int(q_ch/4.)*2 
                                                                        
!        2*istorTH is the number of theoretical values (real)           
!        to be stored in array_fr (complex) at nstorTH+1,nstorTH+2, ... 
!        8*istorTH is the number of Rmatrix values (complex)            
!        to be stored in array_fr (complex) at nstorRM+1, ...           
                                                                        
         nstorRM=nstorTH+istorTH 
         nstorTHyy=nstorRM+8*istorTH 
!        nchansp/2 is number of theoretical values (real) calculated at 
!        experimental channel points to be stored n array_fr (complex)  
!        at nstorTHyy+1, ...                                            
                                                                        
         ifrsto=istorTH+8*istorTH+nchansp/2 
        else 
         ifrsto=nstorTH+nchansp/2
!         write(6,*)'ifrsto=',ifrsto,nstorTH,nchansp
        end if 
!       ifrsto is the total number of complex values requested by the   
!       frame of the theory with the subroutines:                       
!       fr_neutronrock,neutronglobal,plotneutron,neutronrock            
                                                                        
!      write(6,'(a,4i5)')'nstorTH,nstorRM,nstorTHyy=',                  
!     &                   nstorTH,nstorRM,nstorTHyy                     
       return 
      else if(cmch.eq.'arri') then 
       ifrsto=0 
       return 
      else if(cmch.eq.'arre') then 
       ifrsto=0 
       return 
      end if 
 
       mdastr=int(dastr)
       
!      write(6,'(a,4i5)')'nstorTH,nstorRM,nstorTHyy=',                  
!     &                   nstorTH,nstorRM,nstorTHyy                     
                                                                        
!      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f)              
!      corresponds to the i= drive_mode (label 100)                     
       mfpt=2*mpt                  ! y data                             
       mdfpt=mfpt+nchansp          ! errors of y data (calculated by sqrt
       mxpt=mfpt+2*nchansp         ! x data (angle) drive_mode=3 
       mlpt=mfpt+3*nchansp
!***********************************************************************
      if(cmch.eq.'dstr') then 
       k1=1 
      else if(cmch.eq.'data') then 
       k1=2 
      else if(cmch.eq.'ecic') then 
       k1=3 
      else if(cmch.eq.'test') then 
       k1=4 
      else if(cmch.eq.'dfdp') then 
       k1=5 
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then 
       k1=6 
      else if(cmch(1:3).eq.'ple') then 
       k1=7 
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then 
       k1=8 
      else if(cmch.eq.'punc')then 
       k1=9 
      end if 
                                                                        
      goto (100,110,120,200,300,400,500,600,700),k1 
!********************************************************************** 
  100 continue 
      if(ifrcase.gt.20) then 
       call offspec_plot(cmch,n5_offspec,info) 
       data_str=formdata(1) 
       call data3dread(0,info) 
      else 
      call plotneutron(cmch) 
       data_str=formdata(mdastr) 
       call data2dread(0,info) 
      end if 
      return 
  110 continue 
      k1=iss 
      if(ifrcase.gt.20) then 
       call data3dread(k1,info) 
      else 
       call data2dread(k1,info) 
      end if 
      return 
  120 continue 
      if(ifrcase.gt.20) then 
       call excinc3d(info) 
      else 
       call excinc2d(info) 
      end if 
      return 
!***********************************************************************
!     'test': theory function is calculated ...                         
                                                                        
  200 continue 
      k1=1 
      if(ifrcase.eq.11) then 
       call neutronspec_the2exp(k1,info) 
      else 
       call neutronoffspec_the2exp(k1,info) 
      end if 
      return 
!***********************************************************************
!     derivatives df                                                    
  300 continue 
      k1=2 
      if(ifrcase.eq.11) then 
       call neutronspec_the2exp(k1,info) 
      else 
       call neutronoffspec_the2exp(k1,info) 
      end if 
      return 
!********************************************************************** 
!     subs, subt                                                        
  400 continue 
      info=1 
      infotext(1)='effi/structure/neutron/subspectra' 
      infotext(2)='subspectra command has no meaning' 
      infotext(3)=' ' 
      return 
!*************************************************************          
!  call of subtract                                                     
      print '(a)',' ' 
      print '(a)','          subtraction of subspectra' 
      print '(a)','      has no meaning in the time domain' 
!***********************************************************************
!     plot execute                                                      
!     different plot programs may be called due to a flag constant      
!     to be introduced as global constant                               
  500 continue 
       icase=int(real(array_fr(l1_get(0)+1))) 
       k1=0 
       if(b_theory) k1=1 
       if(cmch(4:4).eq.'2') k1=2   ! update test 
       if(cmch(4:4).eq.'3') k1=3   ! update fit  
!              0,1    2d standard plot, 2,3 3d-plot                     
!              0,2: plot and return;  1,3: interactive plot             
       k2=1 
       if(ifrcase.gt.20)then 
        k2=3 
        if(ndisplay_mode.ge.3) k2=1 
       end if 
       call xmosplo(k1,k2) 
       return 
!***********************************************************************
!     display mode , filling of plotarray                               
  600 continue 
      if(cmch.eq.'dmod') then 
       if(ifrcase.eq.11) then 
        call plotneutron(cmch) 
       else 
        n5_offspec(1)=l1_get(0) 
        call offspec_plot(cmch,n5_offspec,info) 
       end if 
      else  ! cmch='plot'   
       if(b_theory) then 
        if(ifrcase.eq.11) then 
         call neutronspec_the2exp(k1,info) 
        else 
         call neutronoffspec_the2exp(k1,info) 
        end if 
       end if 
       if(ifrcase.eq.11) then 
        k1=4
        call neutronspec_the2exp(k1,info) 
        call plotneutron(cmch) 
       else 
        n5_offspec(1)=l1_get(0) 
        n5_offspec(2)=channels 
        n5_offspec(3)=anglepair 
        n5_offspec(4)=counts 
        n5_offspec(5)=background 
        call offspec_plot(cmch,n5_offspec,info) 
       end if 
      end if 
      return 
!***********************************************************************
!     punch data and theory                                             
  700 continue 
      k1=iss 
      if(ifrcase.gt.20) then 
       call punch3d(k1,info) 
      else 
       call punch2d(k1,info) 
       cmch='dim2'
      end if 
      return 
                                                                        
      END                                           
                                                                        
                                                                        
                                                                        
     subroutine neutronspec_the2exp(n1,info) 
! ****************************************************************     
!    n1 = 1 call of theory                                             
!    n1 = 2 derivatives                                                
!    n1 = 3 call of theory , calpl is not called                       
! ****************************************************************     
     use glbconst, only: maxfr1,maxfr2,maxn,max8,maxthss,icstrf,ivstrf,infotext 
     use comdat, only: b_data,b_theory,mlpt
     use comthe, only: real_fr,array_fr,thfk,dfdp,ddpk,ib_df,kana,ibmisfit 

     implicit none 
     integer, intent(in) :: n1
     integer, intent(out):: info 
                                                                      
     integer       ndumst,nstorTH,nstorRM,nstorTHyy,mpt,ipLG,iaddr
     character(len=64):: frthname 
     integer,parameter:: idumst=6+4*(maxfr1+maxfr2)+3*maxthss 
     common/struct/ndumst(idumst),frthname(2),                         &
                   mpt,ipLG,nstorTH,nstorRM,nstorTHyy,iaddr(3)

      integer       istorTH,nexp,mxpt,idumloc,ien
      real          xb_the,dx_the
      common/strLOC/istorTH,nexp,mxpt,idumloc(23),xb_the,dx_the,ien(4)  
                                                                       
     real          acsp,dwba,dastr,channels,anglepair,                 &
                   unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,dumcsp  
     common/acstrf/acsp,dwba,dastr,channels,anglepair,                 &
                   unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,        &
                   dumcsp(icstrf-11)                                   
     real          avsp,counts,background,Pxsi_p,Peta_p,Pzeta_p,       &
                   Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp                
     common/avstrf/avsp,counts,background,Pxsi_p,Peta_p,Pzeta_p,       &
                   Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvsp(ivstrf-10)     
     logical       b_avsp,b_counts,b_background,                       &
                   b_Pxsi_p,b_Peta_p,b_Pzeta_p,                        &
                   b_Pxsi_a,b_Peta_a,b_Pzeta_a,b_v_shift,b_dumvsp      
     common/bvstrf/b_avsp,b_counts,b_background,                       &
                   b_Pxsi_p,b_Peta_p,b_Pzeta_p,                        &
                   b_Pxsi_a,b_Peta_a,b_Pzeta_a,                        &
                   b_v_shift,b_dumvsp(ivstrf-10)                       
                                                                       
                                                                       
     logical b_total,b_residual 
                                                                       
     real    dx_exp,xb_exp,ff,hi                                                        
     integer nexp2,nthe,nthe2,mdastr,invers,jshift,k1,j,k,i,ji,jk,   &
             nTHyy2,nstorTH2,ipnth                                           
     integer, save:: ipntho=0                                 
     real, dimension(:), allocatable, save:: x_exp                                                                       
     real, dimension(:), allocatable, save:: yth

      ibmisfit=0 
!      integral 0-inf is normalized to 1                                
      nexp=channels

      do i=1,nexp
         real_fr(mlpt+i)=0.0
      end do
      !penalty function required by subroutine fit.f90
      nexp2=nexp/2 
      nthe=istorTH*2 
      nthe2=istorTH 
      nTHyy2=2*nstorTHyy 
      nstorTH2=nstorTH*2 

       dx_the=abs(q_end-q_beg)/(q_ch-1.0) 
       dx_exp=abs(q_end-q_beg)/(channels-1.0) 
       xb_the=q_beg+v_shift 
       xb_exp=q_beg 
       invers=0 
       if(dx_the.lt.0) then 
        invers=nexp+1 
        dx_the=-dx_the 
       end if 

      mdastr=dastr 
      if(b_data)then
       if(mdastr.lt.3)then
        hi=xb_exp-dx_exp 
        do k=1,nexp 
         hi=hi+dx_exp 
         real_fr(mxpt+k)=hi 
        end do
       else
        
        if(real_fr(mxpt+1).lt.q_beg.or.real_fr(mxpt+nexp).gt.q_end)then
         info=1 
         infotext(1)='<Synchrotron_spectrum>/grazing_interval' 
         infotext(2)='wrong constants of graz_beg/graz_end ' 
         infotext(3)=' ' 
         return       
        end if 
       end if
      else
       mdastr=1
       hi=xb_exp-dx_exp 
       do k=1,nexp 
        hi=hi+dx_exp 
        real_fr(mxpt+k)=hi 
       end do 
      end if

      i=size(x_exp)
      if(allocated(x_exp).and.i.lt.nexp)deallocate(x_exp)
      if (.not.allocated(x_exp))allocate(x_exp(nexp))
      do i=1,nexp
       x_exp(i)=real_fr(mxpt+i)
      end do
      if(n1.eq.4)goto 310 

      jshift=abs(xb_the/dx_the)+1 
      ji=abs(invers-1) 
      i=int((x_exp(ji)-xb_the)/dx_the) 
      ipnth=jshift+abs(i)
!       write(6,*)'x_exp(1),x_exp(nexp),xb_the,dx_the =',x_exp(1),x_exp(nexp),xb_the,dx_the 
      ji=-1000
      do j=1,nexp 
       jk=abs(invers-j) 
       hi=(x_exp(jk)-xb_the)/dx_the 
       i=int(hi)
       if(i.gt.ji) ji=i 
      end do
!      write(6,*)'imax=',ji
      ji=1000
      do j=1,nexp 
       jk=abs(invers-j) 
       hi=(x_exp(jk)-xb_the)/dx_the 
       i=int(hi)
       if(i.lt.ji) ji=i 
      end do
!      write(6,*)'imin=',ji,ipnth,invers,x_exp(1)

      
      i=size(yth)
      if(allocated(yth).and.                                          &
       (ipnth.gt.ipntho.or.i-ipntho-1.lt.nthe+ipnth))deallocate(yth)
      if (.not.allocated(yth))allocate(yth(-ipnth:nthe+ipnth))
      ipntho=ipnth

!      xb_exp is not correct if x-data are read from file     
!      it is correct after calling x_data()                            
                                                                        
!     write(6,'(a,2g12.4)')' xb_the,dx_the=',xb_the,dx_the              
!      write(6,'(a,L5,4i6)') 'neutronrock b_total=', b_total            
      k1=n1 
      goto (100,200,300),k1 
                                                                        
                                                                        
  100 continue 
!     calculation of thfk                                               
      call neutronrock(b_total,info) 
                                                                       
      if(b_total.or.b_counts.or.b_background)then 
       do j =1,nthe2 
        yth(j)=real(array_fr(nstorTH+j)) 
        yth(j+nthe2)=aimag(array_fr(nstorTH+j)) 
       end do 
       do k=0,ipnth 
        yth(-k)=yth(1) 
        yth(nthe+k)=yth(nthe) 
       end do 
!      write(6,'(6g12.2)') (yth(k),k=1,nthe,16)
!      write(6,'(a)')'x_exp' 
!      write(6,'(6g12.2)') (x_exp(k),k=1,nexp,16)

       do j=1,nexp 
        ji=abs(invers-j) 
        hi=(x_exp(ji)-xb_the)/dx_the 
        i=int(hi) 
        if(i.le.0)i=i-1 
        hi=hi-float(i) 
        ff=yth(i+1)+hi*(yth(i+2)-yth(i+1)) 
        thfk(j)=ff*counts+background 
       end do 
       do j=1,nexp 
        real_fr(nTHyy2+j)=thfk(j) 
       end do 
      else 
       do j=1,nexp 
         thfk(j)=real_fr(nTHyy2+j) 
       end do 
      end if 
!      write(6,'(6g12.3)') (thfk(k),k=1,nexp,16)
      b_theory=.true. 
      return 
                                                                        
  200 continue 
      ib_df=0 
                                                                        
!     variable background                                               
      if(b_background) then 
       b_residual=b_total.or.b_counts 
       if(.not.b_residual) then 
!       write(6,'(a)')  '   derivative of background ------------'      
        do j=1,nexp 
         dfdp(j)=1.0 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
       end if 
      end if 
                                                                        
      do j=1,nexp 
       thfk(j)=real_fr(nTHyy2+j) 
      end do 
!     variable counts                                                   
      if(b_counts) then 
       b_residual=b_total.or.b_background 
       if(.not.b_residual) then 
!       write(6,'(a)')  '   derivative of counts ------------'          
        do j=1,nexp 
         dfdp(j)=(thfk(j)-background)/counts 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
       end if 
      end if 
                                                                        
                                                                        
!      call x_data(mdastr)                                             
      kana=0 
      b_residual=b_total.or.b_counts.or.b_background 
      if(.not.b_residual) then 
       do j =1,nthe 
        yth(j)=real_fr(nstorTH2+j) 
       end do 
       do k=0,jshift 
        yth(-k)=yth(1) 
        yth(nthe+k)=yth(nthe) 
       end do 
       do j=1,nexp 
        ji=abs(invers-j) 
        hi=(x_exp(ji)-xb_the)/dx_the 
        i=int(hi) 
        if(i.le.0)i=i-1 
        hi=hi-float(i) 
        ff=yth(i+1)+hi*(yth(i+2)-yth(i+1)) 
        dfdp(j)=(ff*counts+background-thfk(j))/ddpk 
       end do   ! j=1,nexp
       ib_df=1 
       goto 250 
      end if 
                                                                        
      kana=0 
      call neutronrock(b_total,info) 
                                                                        
      do j =1,nthe 
       yth(j)=real_fr(nstorTH2+j) 
      end do 
                                                                        
      do k=0,jshift 
       yth(-k)=yth(1) 
       yth(nthe+k)=yth(nthe) 
      end do 
                                                                        
      do j=1,nexp 
       ji=abs(invers-j) 
       hi=(x_exp(ji)-xb_the)/dx_the 
       i=int(hi) 
       if(i.le.0)i=i-1 
       hi=hi-float(i) 
       ff=yth(i+1)+hi*(yth(i+2)-yth(i+1)) 
       dfdp(j)=(ff*counts-thfk(j)+background)/ddpk 
      end do   ! j=1,nexp 
      ib_df=1 
  250 continue 
      return 
                                                                        
  300 continue 
!     calculation of thfk , not refreshing pl(j) by calpl               
      if(.not.b_theory) goto 310 
                                                                        
       do j =1,nthe 
        yth(j)=real_fr(nstorTH2+j) 
       end do 
       do k=0,jshift 
        yth(-k)=yth(1) 
        yth(nthe+k+1)=yth(nthe) 
       end do 
                                                                        
       do j=1,nexp 
        ji=abs(invers-j) 
        hi=(x_exp(ji)-xb_the)/dx_the 
        i=int(hi) 
        if(i.le.0)i=i-1 
        hi=hi-float(i) 
        ff=yth(i+1)+hi*(yth(i+2)-yth(i+1)) 
        thfk(j)=ff*counts+background 
       end do 
  310 return 
      END                                           
                                                                        
                                                                        
                                                                        
     subroutine neutronoffspec_the2exp(n1,info) 
!    author : h. spiering                                              
!             Am Damsberg 86                                           
!             D-55130 Mainz                                            
!             2006-2007                                                
! ****************************************************************     
!    n1 = 0 error return                                               
!    n1 = 1 call of theory                                             
!    n1 = 2 derivatives                                                
!    n1 = 3 call of theory , calpl is not called                       
! ****************************************************************     
     use glbconst, only: maxfr1,maxfr2,maxn,max8,maxthss,          &
                         icstrf,ivstrf,maxscrd 
     use comdat, only: ichanks,b_data,b_theory,mgrpt,mxpt,mypt
     use comthe, only: real_fr,thfk,dfdp,ddpk,ib_df,kana,ibmisfit 
     use complt, only: ndisplay_mode
     implicit none 
     integer, intent(in) :: n1
     integer, intent(out):: info                                                                        

     integer     dstr,nstorTH,nstorRM,nstorTHyy,iaddr
     integer,parameter ::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
     common/struct/dstr(istr+2),nstorTH,nstorRM,nstorTHyy,iaddr(3)

     integer       nTH1,ifrth,ien   
     common/strLOC/nTH1,ifrth(11),ien(20)                              
                                                                       
     real          acsp,dwba,dastr,channels,dumcsp 
     common/acstrf/acsp,dwba,dastr,channels,dumcsp(icstrf-4) 

                                                                        
     real          avsp,counts,background,dumvsp 
     common/avstrf/avsp,counts,background,dumvsp(ivstrf-3) 
     logical       b_avsp,b_counts,b_background,b_dumvsp 
     common/bvstrf/b_avsp,b_counts,b_background,b_dumvsp(ivstrf-3) 
                                                                       
     logical      b_total,b_residual,b_trot 
                                                                       
     real,   dimension(256):: ab_the
     integer,dimension(256):: iaset 

     integer,parameter ::iscrd=maxscrd-260*260-65*maxn-1
     integer     idscrd,jth 
     real        yth 
     common/scrd/jth(-3:256,-3:256),yth(-maxn:max8*8),idscrd(iscrd) 
                                                                       
     real    y1,y2,y3,y4,y5,y6,ff,aa,bb,cc,dd,ee,                      &
             h,hx,hy,dx_the,dy_the,xb_the,yb_the,Dx_exp,Dy_exp         
     integer nexp,nthe,k,k1,j,ig,jx,jy,j1,j2,j3,j4,j5,j6,i_3d 
                                                                        
                                                                        
                                                                        
!      integral 0-inf is normalized to 1                                
!      write(6,'(a,4f10.2)') ' frame02 counts,background,channels=',    
!     &    counts,background,channels                                   
                                                                        
      call neutronoffspecular(b_total,info) 
      call ot_theo(i_3d,ab_the,iaset,xb_the,dx_the,yb_the,dy_the) 

!     print*,'xb_the,dx_the,yb_the,dy_the=',xb_the,dx_the,yb_the,dy_the
      b_theory=.true. 
      if(.not.b_data) return 
                                                                        
      nexp=channels 
      nthe=nTH1 
      ibmisfit=0 
                                                                        
!      write(6,'(a,6L5)')',b_total,b_background,b_counts,b_t_shift =',  
!     &             b_total, b_background,b_counts,b_t_shift            
                                                                        
      k1=n1 
      goto (100,200,300),k1 
                                                                        
  100 continue 
!     calculation of thfk                                               
      do j =1,nthe 
       yth(j)=real_fr(2*nstorTH+j)*counts+background 
      end do 
      yth(0)=0. 
      yth(-1)=0. 
!        write(6,'(a,i5)')' ichanks=',ichanks(0)                        
!        write(6,'(10i5)')(ichanks(j),j=1,ichanks(0))                   
!        write(6,'(8f12.3)') (yth(j),j=1,nthe)                          
                                                                        
       if(i_3d.eq.0) then 
!       2d interpolation of the theory at experimental points           
        do k=2,ichanks(0),2 
!        n-theta group                                                  
         do j=ichanks(k-1),ichanks(k) 
          ig=real_fr(mgrpt+j) 
!         to each theta group ig  belong n-omega theoreticalangles      
          hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the 
          jx=int(hx) 
          hx=hx-float(jx) 
          jx=jx+iaset(ig) 
          y1=yth(jx) 
          y2=yth(jx+1) 
          y3=yth(jx+2) 
          aa= (y1+y3-2.*y2)/2. 
          bb= (y3-y1)/2. 
          thfk(j)=(aa*hx+bb)*hx+y2 
          if(thfk(j).lt.0.) thfk(j)=0. 
!          write(6,'(4i3,8f12.2)')j,ig,iaset(ig),io,                    
!     &               real_fr(mxpt+j),ab_the(ig),y1,y2,y3,thfk(j)       
         end do 
        end do 
       else 
!       3d interpolation of the theory at experimental points           
        b_trot=.false. 
        if(i_3d.eq.1)b_trot=.true. 
                                                                        
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
           Dx_exp=real_fr(mxpt+j)-xb_the 
           Dy_exp=real_fr(mypt+j)-yb_the 
           if(b_trot) then 
            h=Dx_exp 
            Dx_exp=(Dx_exp-Dy_exp)/2. 
            Dy_exp=(h+Dy_exp)/2. 
           end if 
           hx=Dx_exp/dx_the 
           jx=int(hx)                         ! theta() of theory  
           hx=hx-float(jx) 
           hy=Dy_exp/dy_the 
           jy=int(hy)                         ! omega() of theory 
           hy=hy-float(jy) 
           if(jth(jx,jy+2).gt.0)then 
            if(jth(jx+2,jy).gt.0)then 
!            standard case                                              
             j1=jth(jx,jy) 
             j2=jth(jx+1,jy) 
             j3=jth(jx+2,jy) 
             j4=jth(jx,jy+1) 
             j5=jth(jx+1,jy+1) 
             j6=jth(jx,jy+2) 
            else  ! jth(jx+2,jy)=0  
!            x_max boundary                                             
             j1=jth(jx+1,jy) 
             j2=jth(jx,jy) 
             j3=jth(jx-1,jy) 
             j4=jth(jx+1,jy+1) 
             j5=jth(jx,jy+1) 
             j6=jth(jx+1,jy+2) 
             hx=1.-hx 
            end if 
           else    !jth(jx,jy+2)=0  
            if(jth(jx+2,jy).gt.0)then 
!            y_max boundary                                             
             j1=jth(jx,jy+1) 
             j2=jth(jx+1,jy+1) 
             j3=jth(jx+2,jy+1) 
             j4=jth(jx,jy) 
             j5=jth(jx+1,jy) 
             j6=jth(jx,jy-1) 
             hy=1.-hy 
            else   ! jth(jx+2,jy)=0  
!            x-max,y_max corner                                         
             j1=jth(jx+1,jy+1) 
             j2=jth(jx,jy+1) 
             j3=jth(jx-1,jy+1) 
             j4=jth(jx+1,jy) 
             j5=jth(jx,jy) 
             j6=jth(jx+1,jy-1) 
             hx=1.-hx 
             hy=1.-hy 
            end if 
           end if 
!           write(6,'(6i3,2(2x,i3,2f10.3),2f10.3)')j1,j2,j3,j4,j5,j6, &  
!              jx,hx,real_fr(mxpt+j),jy,hy,real_fr(mypt+j),Dx_exp,Dy_ex
           ff=yth(j1) 
           y2=yth(j2)-ff 
           y3=yth(j3)-ff 
           y4=yth(j4)-ff 
           y5=yth(j5)-ff 
           y6=yth(j6)-ff 
                                                                        
           aa=-(2.*y2-y3) 
           bb=-(y3-4.*y2) 
           cc=-(2.*y4-y6) 
           dd=-(y6-4.*y4) 
           ee=(y5-y4-y2)*2. 
                                                                        
           thfk(j)=((aa*hx+bb)*hx+(cc*hy+dd+ee*hx)*hy)/2.+ff 
         end do 
        end do 
       end if 
                                                                        
      do j=1,nexp 
       real_fr(2*nstorTHyy+j)=thfk(j) 
      end do 
!      write(6,'(2f12.2)') (real_fr(mfpt+j),thfk(j),j=1,nexp)           
                                                                        
      return 
                                                                        
  200 continue 
      ib_df=0 
!     derivatives                                                       
!     ib_df=1: derivative calculated                                    
!     ib_df=0 happens if a parameter of a set, wich is not currently    
!     fitted, is free. It will be fixed in the routine fit.             
                                                                        
!     analytical and numerical derivatives are handled fdifferently     
!     integer kana (k analytical) = 1 indicates an analytical derivative
                                                                        
      b_total=b_total 
      b_residual=.not.(b_total.or.b_counts) 
!     all variables unchanged but background                            
                                                                        
      if(b_background.and.b_residual) then 
!       write(6,'(a)')  '   derivative of background ------------'      
        do j=1,nexp 
         dfdp(j)=1.0 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
      end if 
!     for background derivative the last theory values were not neccessa
                                                                        
      do j=1,nexp 
       thfk(j)=real_fr(2*nstorTHyy+j) 
      end do 
!     write(6,'(8f10.5)') (thfk(i),i=1,nexp,18)                         
                                                                        
      b_residual=.not.(b_total.or.b_background) 
!     all variables but counts                                          
      if(b_counts.and.b_residual) then 
!       write(6,'(a)')  '   derivative of counts ------------'          
        do j=1,nexp 
         dfdp(j)=(thfk(j)-background)/counts 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
      end if 
                                                                        
                                                                        
!     numerical derivatives                                             
      b_residual=.not.(b_total.or.b_background.or.b_counts) 
!     (b_residual=.true.: parameter is connected only to variables      
!     of other sets                                                     
      if(b_residual) goto 250 
                                                                        
      kana=0 
      do j =1,nthe 
       yth(j)=real_fr(2*nstorTH+j)*counts+background 
      end do 
      yth(-1)=0. 
!      write(6,'(8g12.3)') (real_fr(2*nstorTH+j),j=1,nthe)              
                                                                        
       if(ndisplay_mode.gt.0) then 
!       2d interpolation of the theory at experimental points           
        do k=2,ichanks(0),2 
!        n-theta sets                                                   
         do j=ichanks(k-1),ichanks(k) 
          ig=real_fr(mgrpt+j) 
!         to each theta group ig  belong n-omega theoreticalangles      
          hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the 
          jx=int(hx) 
          hx=hx-float(jx) 
          jx=jx+iaset(ig) 
          y1=yth(jx) 
          y2=yth(jx+1) 
          y3=yth(jx+2) 
          aa= (y1+y3-2.*y2)/2. 
          bb= (y3-y1)/2. 
          ff=(aa*hx+bb)*hx+y2 
          if(ff.lt.0.) ff=0. 
          dfdp(j)=(ff-thfk(j))/ddpk 
!          write(6,'(8f12.3)') ff,thfk(j)                               
         end do 
        end do 
!        write(6,'(8g12.3)') (dfdp(j),j=1,nthe)                         
       else 
!       3d interpolation of the theory at experimental points           
        b_trot=.false. 
        if(i_3d.eq.1)b_trot=.true. 
                                                                        
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
           Dx_exp=real_fr(mxpt+j)-xb_the 
           Dy_exp=real_fr(mypt+j)-yb_the 
           if(b_trot) then 
            h=Dx_exp 
            Dx_exp=(Dx_exp-Dy_exp)/2. 
            Dy_exp=(h+Dy_exp)/2. 
           end if 
           hx=Dx_exp/dx_the 
                                              ! theta() of theory       
           jx=int(hx) 
           hx=hx-float(jx) 
           hy=Dy_exp/dy_the 
                                              ! omega() of theory       
           jy=int(hy) 
           hy=hy-float(jy) 
                                                                        
           if(jth(jx,jy+2).gt.0)then 
            if(jth(jx+2,jy).gt.0)then 
!            standard case                                              
             j1=jth(jx,jy) 
             j2=jth(jx+1,jy) 
             j3=jth(jx+2,jy) 
             j4=jth(jx,jy+1) 
             j5=jth(jx+1,jy+1) 
             j6=jth(jx,jy+2) 
                   ! jth(jx+2,jy)=0                                     
            else 
!            x_max boundary                                             
             j1=jth(jx+1,jy) 
             j2=jth(jx,jy) 
             j3=jth(jx-1,jy) 
             j4=jth(jx+1,jy+1) 
             j5=jth(jx,jy+1) 
             j6=jth(jx+1,jy+2) 
             hx=1.-hx 
            end if 
                   !jth(jx,jy+2)=0                                      
           else 
            if(jth(jx+2,jy).gt.0)then 
!            y_max boundary                                             
             j1=jth(jx,jy+1) 
             j2=jth(jx+1,jy+1) 
             j3=jth(jx+2,jy+1) 
             j4=jth(jx,jy) 
             j5=jth(jx+1,jy) 
             j6=jth(jx,jy-1) 
             hy=1.-hy 
                   ! jth(jx+2,jy)=0                                     
            else 
!            x-max,y_max corner                                         
             j1=jth(jx+1,jy+1) 
             j2=jth(jx,jy+1) 
             j3=jth(jx-1,jy+1) 
             j4=jth(jx+1,jy) 
             j5=jth(jx,jy) 
             j6=jth(jx+1,jy-1) 
             hx=1.-hx 
             hy=1.-hy 
            end if 
           end if 
                                                                        
!           write(6,'(6i3,2(2x,i3,2f10.3),2f10.3)')j1,j2,j3,j4,j5,j6,   
!     &         jx,hx,real_fr(mxpt+j),jy,hy,real_fr(mypt+j),Dx_exp,Dy_ex
           ff=yth(j1) 
           y2=yth(j2)-ff 
           y3=yth(j3)-ff 
           y4=yth(j4)-ff 
           y5=yth(j5)-ff 
           y6=yth(j6)-ff 
                                                                        
           aa=-(2.*y2-y3) 
           bb=-(y3-4.*y2) 
           cc=-(2.*y4-y6) 
           dd=-(y6-4.*y4) 
           ee=(y5-y4-y2)*2. 
           ff=((aa*hx+bb)*hx+(cc*hy+dd+ee*hx)*hy)/2.+ff 
           dfdp(j)=(ff-thfk(j))/ddpk 
         end do 
        end do 
       end if 
                                                                        
      ib_df=1 
                                                                        
  250 continue 
      return 
                                                                        
  300 continue 
!     calculation of thfk                                               
                                                                        
      if(.not.b_theory.or..not.b_data) goto 310 
                                                                        
      call synoffspec(b_total,info) 
!     calculation of thfk                                               
      do j =1,nthe 
       yth(j)=real_fr(2*nstorTH+j)*counts+background 
      end do 
      yth(0)=0. 
      yth(-1)=0. 
                                                                        
      if(i_3d.eq.0) then 
!      2d interpolation of the theory at experimental points            
       do k=2,ichanks(0),2 
!       n-theta group                                                   
        do j=ichanks(k-1),ichanks(k) 
         ig=real_fr(mgrpt+j) 
!        to each theta group ig  belong n-omega theoreticalangles       
         hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the 
         jx=int(hx) 
         hx=hx-float(jx) 
         jx=jx+iaset(ig) 
         y1=yth(jx) 
         y2=yth(jx+1) 
         y3=yth(jx+2) 
         aa= (y1+y3-2.*y2)/2. 
         bb= (y3-y1)/2. 
         thfk(j)=(aa*hx+bb)*hx+y2 
         if(thfk(j).lt.0.) thfk(j)=0. 
!         write(6,'(4i3,8f12.2)')j,ig,iaset(ig),io,     &                   
!                   real_fr(mxpt+j),ab_the(ig),y1,y2,y3,thfk(j)        
        end do 
       end do 
      end if 
!     3d: the full theory is plotted (independent of the data)          
  310 return 
      END                                           
                                                                        
                                                                        
     subroutine neutronrock(b_total,info) 
!    H. Spiering september 2004 Mainz                                  
!    adapted to the beta version                                       
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,icstrf,ivstrf,    &
                         ivfr1trf,ivfr2trf,icfr2trf 
     use comthe, only: array_fr
     implicit none 
     logical, intent(out):: b_total
     integer, intent(out):: info  


     integer     mstruct1,istruct1,istruct2,                      &
                 l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,            &
                 nstorTH,nstorRM,nstorTHyy,mpt,ipLG,idum                
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),mpt,ipLG,nstorTH,nstorRM,nstorTHyy,idum(3)

     integer       istorTH,ien
     common/strLOC/istorTH,ien(31)                                   
                                                                       
                                                                       
     real          acsp,dwba,dastr,channels,anglepair,               &
                   unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,dumcsp  
     common/acstrf/acsp,dwba,dastr,channels,anglepair,               &
                   unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,        &
                   dumcsp(icstrf-11)                                   
                                                                       
     real          avs,counts,background,Pxsi_p,Peta_p,Pzeta_p,        &
                   Pxsi_a,Peta_a,Pzeta_a,q_shift,q_min,phi_z,dumvs     
     common/avstrf/avs,counts,background,Pxsi_p,Peta_p,Pzeta_p,        &
                   Pxsi_a,Peta_a,Pzeta_a,q_shift,q_min,phi_z,          &
                   dumvs(ivstrf-12)                                    
     logical       b_vs,b_counts,b_background,                         &
                   b_Pxsi_p,b_Peta_p,b_Pzeta_p,                        &
                   b_Pxsi_a,b_Peta_a,b_Pzeta_a,                        &
                   b_q_shift,b_q_min,b_phi_z,b_dumvs                   
     common/bvstrf/b_vs,b_counts,b_background,                         &
                   b_Pxsi_p,b_Peta_p,b_Pzeta_p,                        &
                   b_Pxsi_a,b_Peta_a,b_Pzeta_a,                        &
                   b_q_shift,b_q_min,b_phi_z,b_dumvs(ivstrf-12)        
                                                                       
!    common/vfr1trf/ inc_frac,Hext,theta_He,phi_He                     
     integer,parameter:: idumvfr1=ivfr1trf-5 
     real            avfr1,pvfr1,Hext,theta_He,phi_He,dumvfr1 
     common/avfr1trf/avfr1,pvfr1,Hext,theta_He,phi_He,dumvfr1(idumvfr1) 
     logical         b_vfr1,b_pvfr1,b_Hext,b_theta_He,b_phi_He,        &
                     b_dumvfr1                                         
     common/bvfr1trf/b_vfr1,b_pvfr1,b_Hext,b_theta_He,b_phi_He,        &
                     b_dumvfr1(idumvfr1)                               
                                                                       
     real            acfr2,rep_grp,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2) 
                                                                       
     real            avfr2,thicklay,B_eff,theta_B,phi_B,               &
                     ar_scatldens,ai_scatldens,roughness,eta_domain,   &
                     dumvfr2                                           
     common/avfr2trf/avfr2,thicklay,B_eff,theta_B,phi_B,               &
                     ar_scatldens,ai_scatldens,roughness,eta_domain,   &
                     dumvfr2(ivfr2trf-9)                               
     logical         b_vfr2,b_thicklay,b_B_eff,b_theta_B,b_phi_B,      &
                     b_ar_scatldens,b_ai_scatldens,b_roughness,        &
                     b_eta_domain,b_dumvfr2                            
     common/bvfr2trf/b_vfr2,b_thicklay,b_B_eff,b_theta_B,b_phi_B,      &
                     b_ar_scatldens,b_ai_scatldens,b_roughness,        &
                     b_eta_domain,b_dumvfr2(ivfr2trf-9)                
                                                                       
     logical  b_scatl_lay,b_analyser 
     integer i,nn,lstruct1,lstruct2,                                   &
             lay,nch_q,nchq,nyout                               
!************************************************************          
!                                                                      
! Varables defined by L. Deak (20.12.2000)                             
!                                                                      
     real      rd_q,h,h1,                                             & 
               sin_theta_B,cos_theta_B,sin_phi_B,cos_phi_B,           & 
               sin_theta_H,cos_theta_H,sin_phi_H,cos_phi_H,           & 
               sin_B_H,cos_B_H,B_a,B_b,B_c 
     logical   b_up,b_down 
!                                                                      
! ***********************************************************          
     complex(kind=8),dimension(2,2,maxfr2):: K_mag_lay
     complex(kind=8),dimension(2,2):: Rmatrix 
     real(kind=8),dimension(maxfr2):: thicklayer,roughlayer
     integer,dimension(2*maxfr2+2) :: laystr
     logical,dimension(maxfr2)     ::b_Beff
                                                                       
     complex,dimension(4):: aa,bb,dd,rho_a,rho_p(4)
     real,dimension(maxn):: chrock 
!     common/scrd/dumscrd(maxscrd/2)                                   
!     equivalence (dumscrd(1),chrock(1)),(dumscrd(maxn+1),chrock2(1))  
                                                                       
     real(kind=8):: Hext_z,q_scat 
     complex scatl_lay                                                 
     logical b_true,b_false,b_scatterer,b_first
                                                                        
! **** Definitions of structure variables                               
! Khaidukov 26.04.2003 & L. Deak 09.10.2002 ***                         
     integer POINTER,GRP,MAXGRP,Kh 
     integer,dimension(0:2*maxfr2):: GEOSTR
! ****                                       ***                        
     real,parameter:: pi=3.141592654, rad=pi/180  

!      write(6,'(a)')'synrock ksp_m(0:maxthssp/2)='                     
!      write(6,'(10i7)')(iarray_sp+ksp_m(i),i=0,maxthssp/4)             
       info=0
!-------------------------------------------------------------------    
       b_up  =.false.   ! initialization of '+' beam
       b_down=.false.   !                   '-' 
                                                                        
      call mapsub(0,0,0) 
      b_total=b_vs 
!-----------------------------------------------------------------------
!     transformation matrix from spherical basis to (sigma,pi)-basis    
                                                                        
!     orientation of the absorber with respect to the beam              
                                                                        
      b_analyser=abs(Pxsi_a)+abs(Peta_a)+abs(Pzeta_a).gt.0.001 
      if(b_analyser) then 
!                                                                       
!      if Pzeta_a > 0. we measure the '+' beam                               
!      if Pzeta_a < 0. we measure the '-' beam                               
       if(Pzeta_a.gt.0.) b_up  =.true. 
       if(Pzeta_a.lt.0.) b_down=.true. 
       rho_a(1)=cmplx(1.+Pzeta_a,0.)/2. 
       rho_a(3)=cmplx(Pxsi_a,-Peta_a)/2. 
       rho_a(2)=cmplx(Pxsi_a,Peta_a)/2. 
       rho_a(4)=cmplx(1.-Pzeta_a,0.)/2. 
      end if 
                                                                        
       rho_p(1)=cmplx(1.+Pzeta_p,0.)/2. 
       rho_p(3)=cmplx(Pxsi_p,-Peta_p)/2. 
       rho_p(2)=cmplx(Pxsi_p,Peta_p)/2. 
       rho_p(4)=cmplx(1.-Pzeta_p,0.)/2. 
                                                                        
       nch_q=2*istorTH 
       rd_q=(q_end-q_beg)/float(nch_q-1) 
                                                                        
!      write(6,'(a,g15.5)')'neutronrok rd_q=',rd_q                      
!      write(6,'(a)')'++++++++++++++++++++++++++++++++++++'             
                                                                        
      lstruct1=1 
                                                                        
       call mapsub(lstruct1,0,0) 
!      common/avfr1trf/avfr1,pvfr1,Hext                                 
       b_false=b_false.or.b_vfr1 
       b_true=b_true.and.b_vfr1 
       b_total=b_total.or.b_pvfr1 
                                                                        
       Hext_z=Hext*unit_sclB 
                                                                        
                                                                        
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
!      ------------------------------------------------------------     
!      layer lay1,2 ... mlay of scatterer                               
!      ---------------------------------------------------------------  
                                                                        
        lay=lstruct2 
        call mapsub(lstruct1,lstruct2,0) 
                                                                        
        thicklayer(lay)=thicklay 
                                                                        
        scatl_lay=cmplx(ar_scatldens,ai_scatldens)*unit_sclN 
                                                                        
        b_scatl_lay=b_vfr2.or.b_thicklay 
        b_scatterer=b_scatl_lay 
!       write(6,'(a,l5)') '1------b_scatterer=',b_scatterer             
        b_Beff(lay)=abs(B_eff*unit_sclB).gt.1.0e-6 
        i=rep_grp 
        laystr(2*lay-1)=i 
        laystr(2*lay)=10*(rep_grp-float(i)+.01) 
        roughlayer(lay)=roughness 
                                                                        
!       hs=h*sin(theta_B*rad)                                           
!***********************************************************************
!                                                                       
! transformation of B_eff from the sample system to the neutron system  
!                                                                       
!***********************************************************************
                                                                        
         h=B_eff*unit_sclB 
         sin_theta_B=sin(theta_B*rad) 
         cos_theta_B=cos(theta_B*rad) 
         sin_phi_B  =sin(phi_B*rad) 
         cos_phi_B  =cos(phi_B*rad) 
!                                                                       
        if(theta_He*rad.lt.1.e-8)then 
         B_a=sin_theta_B*cos_phi_B 
         B_b=sin_theta_B*sin_phi_B 
         B_c=cos_theta_B 
!        write(*,'(a)')'Mintarendszer ...'                              
!        write(*,*)B_a,B_b,B_c,B_a**2+B_b**2+B_c**2                     
        else 
!        write(*,'(a)')'Trafo ...'                                      
         sin_theta_H =sin(theta_He*rad) 
         cos_theta_H =cos(theta_He*rad) 
         sin_phi_H   =sin(phi_He*rad) 
         cos_phi_H   =cos(phi_He*rad) 
                                                                        
         sin_B_H =sin((phi_B-phi_He)*rad) 
         cos_B_H =cos((phi_B-phi_He)*rad) 
!        write(6,'(3f15.3)')phi_B,phi_He,cos_B_H                        
                                                                        
         B_a =-sin_theta_B*sin_theta_H*sin_B_H 
         B_b = sin_theta_H*(sin_theta_B*cos_theta_H*cos_B_H+            &
               cos_theta_B*sin_theta_H)                                 
         B_c = sin_theta_B*sin_theta_H*cos_B_H+                         &
               cos_theta_B*cos_theta_H                                  
!           write(*,'(3f15.3)')B_a,B_b,B_c                              
        endif 
         K_mag_lay(1,1,lay)=cmplx( h*B_c,0.0)-scatl_lay 
         K_mag_lay(2,2,lay)=cmplx(-h*B_c,0.0)-scatl_lay 
         K_mag_lay(1,2,lay)=cmplx(h*B_a,-h*B_b) 
         K_mag_lay(2,1,lay)=conjg(K_mag_lay(1,2,lay)) 
!        write(6,'(3e15.5)')h*cos(theta_B*rad),real(scatl_lay),     &
!                                   real(K_mag_lay(1,1,lay))                                    
                                                                        
                                                                        
!*****************************************************************      
                                                                        
       end do 
                                                                        
       laystr(2*lay+2)=-1 
       laystr(2*lay+1)=0 
                                                                        
!      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)      
       b_total=b_total.or.b_scatterer 
       if(.not.b_total) return 
                                                                        
!      write(6,'(a,l5)') ' ---------------b_scatterer,b_total=', b_total
!-----------------------------------------------------------------------
!     here the matrix R for the layers are given :                      
!     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))              
!                         (samplay(n,lay) -sapplay(n,lay))              
!                                                                       
!     calculation of the transmittivity matrix T for all channels n     
!     by   T = exp(iR)*rho*exp(-iR+)                                    
                                                                        
                                                                        
!      if(.not.b_total) goto 1000                                       
                                                                        
!----------------------------------------------------------------       
!      **************************************************************** 
!      We reconstarct the layer strucrure from the laystr variabale.    
!      GEOSTR(GRP) is the number of layers in group GRP.                
!     Khaidukov Yu. 26.04.2003 & L. Deak, 09.10.2002                *** 
       GRP         =0 
       GEOSTR(GRP) =0 
       MAXGRP      =0 
!                                                                       
       b_first     =.true. 
       POINTER=1 
       do Kh=2,2*lay,2 
        if(b_first)then 
         if(GRP.eq.laystr(Kh))then 
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1 
         else 
          POINTER         =POINTER+GEOSTR(2*GRP) 
          GRP             =GRP+1 
          MAXGRP          =GRP 
          GEOSTR(2*GRP)   =1 
          GEOSTR(2*GRP-1) =laystr(Kh-1) 
         end if 
!                                                                       
!                                                                       
          if(thicklayer(Kh/2).lt.0.) then 
           b_first         =.false. 
          thicklayer(Kh/2)      =1.e30 
          GEOSTR(2*GRP-1) =1 
                ! VKD < 0                                               
         end if 
                ! b_first                                               
        end if 
       end do 
!      *****************************************************************
!      if(b_scatterer) then                                             
       do nchq=1,nch_q 
        q_scat=q_beg+rd_q*(nchq-1) 
!       write(6,'(a,i3,a,f10.5)') 'neutronrock nchq=',nchq,q_scat       
                                                                        
        call n_optics(lay,MAXGRP,GEOSTR,b_Beff,Hext_z,                  &
           K_mag_lay,thicklayer,roughlayer,q_scat,b_up,b_down,Rmatrix) 
                                                                        
                                                                        
                                                                        
        nn=nstorRM+(nchq-1)*4 
        array_fr(nn+1)=Rmatrix(1,1) 
        array_fr(nn+3)=Rmatrix(1,2) 
        array_fr(nn+2)=Rmatrix(2,1) 
        array_fr(nn+4)=Rmatrix(2,2) 
!       write(11,'(8g15.5)') Rmatrix(1,1),Rmatrix(2,2)                  
               ! loop over q_values                                     
       end do 
!      end if                                                           
!      write(6,'(a)')' neutronrock do nchq=1,nch_q'                     
                                                                        
      do nchq=1,nch_q 
       nn=nstorRM+4*(nchq-1) 
       do i=1,4 
        dd(i)=array_fr(nn+i) 
       end do 
!       write(6,'(8g15.5)') (dd(i),i=1,4)                               
!      trace (dd+*dd*rho) is the intensity                              
!      bb=cc+                                                           
       bb(1)=conjg(dd(1)) 
       bb(4)=conjg(dd(4)) 
       bb(2)=conjg(dd(3)) 
       bb(3)=conjg(dd(2)) 
       call matprof(dd,rho_p,aa) 
       call matprof(aa,bb,dd) 
       if(b_analyser) then 
        call matprof(dd,rho_a,bb) 
        h1=real(bb(1)+bb(4)) 
       else 
        h1=real(dd(1)+dd(4)) 
       end if 
       chrock(nchq)=h1 
              ! loop over q_values                                      
      end do 
!      write(6,'(8g14.5)') (chrock(i),i=1,nch_q,4)                      
!--------------------------------------------------------               
                                                                        
      nyout=nch_q/2 
      do i=1,nyout 
       array_fr(nstorTH+i)=cmplx(chrock(i),chrock(nyout+i)) 
      end do 
!     end of calculation of absorber function                           
      return 
      END                                           
                                                                        
                                                                        
!    H. Spiering september 2004 Mainz                                  
!    adapted to the beta version                                       
!                                                                      
     subroutine neutronoffspecular(b_total,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxthss,icstrf,ivstrf, &
                         ivfr1trf,ivfr2trf,icfr2trf,infotext 
     use comthe, only: array_fr,real_fr
     implicit none 
     logical, intent(out):: b_total
     integer, intent(out):: info  

     integer     mstruct1,istruct1,istruct2,                           &
                 l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,            &
                 nstorTH,nstorRM,nstorTHyy,mpt,ipLG,idum                
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),mpt,ipLG,nstorTH,nstorRM,nstorTHyy,idum(3)

     integer       istorTH,ien
     common/strLOC/istorTH,ien(31)                                   
                                                                       
                                                                       
     real          acsp,aDWBA,dastr,channels,anglepair,                &
                   unit_sclB,unit_sclN,lambda,dumcsp                   
     common/acstrf/acsp,aDWBA,dastr,channels,anglepair,                &
                   unit_sclB,unit_sclN,lambda,dumcsp(icstrf-8)         
                                                                       
     real           avs,counts,background,Pxsi_p,Peta_p,Pzeta_p,       &
                    Pxsi_a,Peta_a,Pzeta_a,theta2_shift,fr_offspec,xi,  &
                    Ao,dumvsp                                          
     common/avstrf/ avs,counts,background,Pxsi_p,Peta_p,Pzeta_p,       &
                    Pxsi_a,Peta_a,Pzeta_a,theta2_shift,fr_offspec,xi,  &
                    Ao,dumvsp(ivstrf-13)                               
     logical        b_vs,b_counts,b_background,                        &
                    b_Pxsi_p,b_Peta_p,b_Pzeta_p,                       &
                    b_Pxsi_a,b_Peta_a,b_Pzeta_a,                       &
                    b_theta2_shift,b_fr_offspec,b_xi,b_Ao,b_dumvsp     
     common/bvstrf/b_vs,b_counts,b_background,                         &
                    b_Pxsi_p,b_Peta_p,b_Pzeta_p,                       &
                    b_Pxsi_a,b_Peta_a,b_Pzeta_a,                       &
                    b_theta2_shift,b_fr_offspec,b_xi,b_Ao,             &
                    b_dumvsp(ivstrf-13)                                
                                                                       
                                                                       
     real            avfr1,pvfr1,Hext,theta_He,phi_He,dumvfr1 
     common/avfr1trf/avfr1,pvfr1,Hext,theta_He,phi_He,                 &
                     dumvfr1(ivfr1trf-5)                               
     logical         b_vfr1,b_pvfr1,b_Hext,b_theta_He,b_phi_He,        &
                     b_dumvfr1                                         
     common/bvfr1trf/b_vfr1,b_pvfr1,b_Hext,b_theta_He,b_phi_He,        &
                     b_dumvfr1(ivfr1trf-5)                             
                                                                       
     real            acfr2,rep_grp,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2) 
                                                                       
     real            avfr2,thicklay,B_eff,theta_B,phi_B,               &
                     ar_scatldens,ai_scatldens,roughness,etadomain,    &
                     dumvfr2                                           
     common/avfr2trf/avfr2,thicklay,B_eff,theta_B,phi_B,               &
                     ar_scatldens,ai_scatldens,roughness,etadomain,    &
                     dumvfr2(ivfr2trf-9)                               
     logical         b_vfr2,b_thicklay,b_B_eff,b_theta_B,b_phi_B,      &
                     b_ar_scatldens,b_ai_scatldens,b_roughness,        &
                     b_etadomain,b_dumvfr2                             
     common/bvfr2trf/b_vfr2,b_thicklay,b_B_eff,b_theta_B,b_phi_B,      &
                     b_ar_scatldens,b_ai_scatldens,b_roughness,        &
                     b_etadomain,b_dumvfr2(ivfr2trf-9)                 
                                                                       
!************************************************************          
!                                                                      
! Variables defined by L. Deak (20.12.2000)                             
     real      h,Hext_z,k_wave,pi,rad,sum_off,                          & 
               sin_theta_B,cos_theta_B,sin_phi_B,cos_phi_B,             & 
               sin_theta_H,cos_theta_H,sin_phi_H,cos_phi_H,             & 
               sin_B_H,cos_B_H,B_a,B_b,B_c 
! **** Definitions of structure variables                               
! Khaidukov 26.04.2003 & L. Deak 09.10.2002 ***                         
     logical b_first,DWBA,b_scatl_lay,b_analyser,b_scatterer,b_up,b_down 
     logical,     dimension(maxfr2)::  b_Bfield,b_domain      

     integer POINTER,GRP,MGRP,Kh 
     integer,dimension(0:2*maxfr2):: GEOSTR
     integer,dimension(2*maxfr2+2):: laystr
     integer,parameter:: maxl=maxfr2, maxl4=4*maxl 
     integer icase,n_omega,k_omega,n_theta,isubthe,nstorTH2,           &
             i_angle,i_theta,ibg_angle,j,i,nn,lstruct1,lstruct2,lay,   &
             lay_domain,LMIN,LMAX,L,n,n_rep 

     real    theta,theta_beg,dtheta,omega,omega_beg,domega,            &
             theta_m,omega_end,theta_end,Qx,grazinc,grazout
     real,dimension(maxfr2):: eta                       
     real, dimension(:), allocatable:: choffspecular
                                                                       
     real(kind=8)   :: eta_domain,SQ,K1 
     real(kind=8),   dimension(maxfr2)    :: thicklayer,roughlayer      
     complex(kind=8):: Offspec                                                              
     complex(kind=8),dimension(maxfr2)    :: scatlength
     complex(kind=8),dimension(2,2,maxfr2):: K_mag_lay
     complex(kind=8),dimension(4)         :: rho_a,rho_p
     complex(kind=8),dimension(2*maxl4)   :: G_mjv
                                                                       

       DWBA=aDWBA.eq.1. 
       b_Bfield=.false. 
       b_domain=.false. 
       pi=atan(1.)*4. 
       rad=pi/180. 

!      write(6,'(a)')'synoffspecular ksp_m(0:maxthssp/2)='              
!      write(6,'(10i7)')(iarray_sp+ksp_m(i),i=0,maxthssp/4)             
!-------------------------------------------------------------------    
       b_up  =.false.   ! initialization of '+' beam   
       b_down=.false.   !                   '-' 

!     write(6,'(3(a,e8.2))')                     &                       
!        ' -- Pxsi_a=',Pxsi_a,' Peta_a=',Peta_a,' Pzeta_a=',Pzeta_a    
                                                                        
      call mapsub(0,0,0) 
      b_total=b_vs 
                                                                        
      isubthe=1 
      call get_theory(isubthe,info) 
      b_total= b_total.or.(isubthe.gt.0) 
                                                                        
!-----------------------------------------------------------------------
!     transformation matrix from spherical basis to (sigma,pi)-basis    
!     orientation of the absorber with respect to the beam              
                                                                        
      b_analyser=abs(Pxsi_a)+abs(Peta_a)+abs(Pzeta_a).gt.0.001 
      if(b_analyser) then 
!      if Pzeta_a > 0. we measure the '+' beam                               
!      if Pzeta_a < 0. we measure the '-' beam                               
       if(Pzeta_a.gt.0.)b_up  =.true. 
       if(Pzeta_a.lt.0.)b_down=.true. 
       rho_a(1)=cmplx(1.+Pzeta_a,0.)/2. 
       rho_a(3)=cmplx(Pxsi_a,-Peta_a)/2. 
       rho_a(2)=cmplx(Pxsi_a,Peta_a)/2. 
       rho_a(4)=cmplx(1.-Pzeta_a,0.)/2. 
      end if 
                                                                        
      rho_p(1)=cmplx(1.+Pzeta_p,0.)/2. 
      rho_p(3)=cmplx(Pxsi_p,-Peta_p)/2. 
      rho_p(2)=cmplx(Pxsi_p,Peta_p)/2. 
      rho_p(4)=cmplx(1.-Pzeta_p,0.)/2. 
                                                                        
      lstruct1=1 
                                                                        
       call mapsub(lstruct1,0,0) 
!      common/avfr1trf/avfr1,pvfr1,Hext                                 
       b_total=b_total.or.b_vfr1 
       Hext_z=Hext*unit_sclB 
                                                                        
       b_scatterer=b_vfr1 
                                                                        
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
!      ------------------------------------------------------------     
!      layer lay1,2 ... mlay of scatterer                               
!      ---------------------------------------------------------------  
                                                                        
        lay=lstruct2 
        call mapsub(lstruct1,lstruct2,0) 
                                                                        
        eta(lay)=etadomain 
        b_domain(lay)=rep_grp.lt.0 
!        write(6,'(a,f10.1,L5)')'th_neutronoffspecular domain,b_domain='
!                                b_domain(lay)                                                  
        thicklayer(lay)=thicklay 
                                                                        
        scatlength(lay)=cmplx(ar_scatldens,ai_scatldens)*unit_sclN 
        b_scatl_lay=b_vfr2.or.b_thicklay 
        b_scatterer=b_scatterer.or.b_scatl_lay 
!       write(6,'(a,l5)') '1------b_scatterer=',b_scatterer             
!        b_Bfield(lay)=abs(B_eff*unit_sclB).gt.1.0e-6                   
        i=abs(rep_grp) 
        laystr(2*lay-1)=i 
        laystr(2*lay)=10*(abs(rep_grp)-float(i)+.01) 
        roughlayer(lay)=roughness 
                                                                        
!        hs=h*sin(theta_B*rad)                                          
!***********************************************************************
!                                                                       
! transformation of B_eff from the sample system to the neutron system  
!                                                                       
!***********************************************************************
                                                                        
                                                                        
         sin_theta_B=sin(theta_B*rad) 
         cos_theta_B=cos(theta_B*rad) 
         sin_phi_B  =sin(phi_B*rad) 
         cos_phi_B  =cos(phi_B*rad) 
!                                                                       
        if(Hext.lt.0.001)then 
         B_a=sin_theta_B*cos_phi_B 
         B_b=sin_theta_B*sin_phi_B 
         B_c=cos_theta_B 
!        write(*,'(a)')'Mintarendszer ...'                              
!        write(*,*)B_a,B_b,B_c,B_a**2+B_b**2+B_c**2                     
        else 
!        write(*,'(a)')'Trafo ...'                                      
         sin_theta_H =sin(theta_He*rad) 
         cos_theta_H =cos(theta_He*rad) 
         sin_phi_H   =sin(phi_He*rad) 
         cos_phi_H   =cos(phi_He*rad) 
!                                                                       
         sin_B_H =sin((phi_B-phi_He)*rad) 
         cos_B_H =cos((phi_B-phi_He)*rad) 
!        write(6,'(3f15.3)')phi_B,phi_He,cos_B_H                        
         B_a =-sin_theta_B*sin_theta_H*sin_B_H 
         B_b = sin_theta_H*(sin_theta_B*cos_theta_H*cos_B_H+            &
               cos_theta_B*sin_theta_H)                                 
         B_c = sin_theta_B*sin_theta_H*cos_B_H+                         &
               cos_theta_B*cos_theta_H                                  
        endif 
         h=-B_eff*unit_sclB 
         K_mag_lay(1,1,lay)=dcmplx( h*B_c,0.0) 
         K_mag_lay(2,2,lay)=dcmplx(-h*B_c,0.0) 
         K_mag_lay(1,2,lay)=dcmplx(h*B_a,-h*B_b) 
         K_mag_lay(2,1,lay)=conjg(K_mag_lay(1,2,lay)) 
!       write(11,*)',K_mag_lay'                                        
!       write(11,*)eta(lay) ,K_mag_lay(1,1,lay),K_mag_lay(1,2,lay),    &    
!                       K_mag_lay(2,1,lay),K_mag_lay(2,2,lay)          
                                                                        
!        write(6,'(3e15.5)')h*cos(theta_B*rad),real(scatl_lay), &         
!          real(K_mag_lay(1,1,lay))                                    
         b_Bfield(lay)=abs(B_a*unit_sclB).gt.1.0e-6 
                                                                        
!*****************************************************************      
                                                                        
       end do 
                                                                        
       laystr(2*lay+2)=-1 
       laystr(2*lay+1)=0 
                                                                        
!      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)      
       b_total=b_total.or.b_scatterer 
                                                                        
       if(.not.b_total) return 
                                                                        
!      write(6,'(a,l5)') ' ---------------b_scatterer,b_total=', b_total
!-----------------------------------------------------------------------
!     here the matrix R for the layers are given :                      
!     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))              
!                         (samplay(n,lay) -sapplay(n,lay))              
!                                                                       
!     calculation of the transmittivity matrix T for all channels n     
!     by   T = exp(iR)*rho*exp(-iR+)                                    
                                                                        
                                                                        
!      if(.not.b_total) goto 1000                                       
                                                                        
!----------------------------------------------------------------       
!      **************************************************************** 
!      We reconstarct the layer strucrure from the laystr variabale.    
!      GEOSTR(GRP) is the number of layers in group GRP.                
!     Khaidukov Yu. 26.04.2003 & L. Deak, 09.10.2002                *** 
       i=1 
       do while(eta(i).ne.0.) 
        i=i+1 
       end do 
       if(i.le.1)then 
        info=33 
         infotext(1)='<Synchrotron_offspecular>/th_synoffspec/domain' 
         infotext(2)='two eta_domain values have to be defined ' 
         infotext(3)=' ' 
        return 
       end if 
       eta_domain=eta(i-1) 
                                                                        
       do i=0,2*maxfr2 
        GEOSTR(i)=0 
       end do 
                                                                        
       GRP         =0 
       GEOSTR(GRP) =0 
       MGRP        =0 
       b_first     =.true. 
       POINTER=1 
       do Kh=2,2*lay,2 
        if(b_first)then 
         if(GRP.eq.laystr(Kh))then 
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1 
         else 
          POINTER         =POINTER+GEOSTR(2*GRP) 
          GRP             =GRP+1 
          MGRP          =GRP 
          GEOSTR(2*GRP)   =1 
          GEOSTR(2*GRP-1) =laystr(Kh-1) 
         end if 
         if(thicklayer(Kh/2).lt.0.) then 
          b_first         =.false. 
          thicklayer(Kh/2)      =1.e30 
          GEOSTR(2*GRP-1) =1 
         end if ! VKD < 0  
        end if  ! b_first 
       end do 
                                                                        
       DO I=1,2 
       DO J=1,2 
        lay_domain=0 
        POINTER=0 
        do GRP=1,MGRP      ! loop for the groups
         LMIN =POINTER+1 
         LMAX =POINTER+GEOSTR(2*GRP) 
         n_rep=GEOSTR(2*GRP-1) 
         n=1 
         DO WHILE (n.LE.n_rep) 
          n=n+1 
          do L=LMIN,LMAX 
           if(b_domain(L)) lay_domain=lay_domain+1 
          end do ! L   
         END DO    ! n<=n_rep  
         POINTER=POINTER+GEOSTR(2*GRP) 
        end do ! GRP 
       END DO ! over mju1 
       END DO ! over mju2  
       if(lay_domain.eq.0)lay_domain=lay 
                                                                        
!      *****************************************************************
       icase=int(real(array_fr(l1_get(0)+1))) 
       n_omega=int(real(array_fr(l1_get(0)+2))) 
       n_theta=int(aimag(array_fr(l1_get(0)+2))) 
       omega_beg=real(array_fr(l1_get(0)+3)) 
       domega=aimag(array_fr(l1_get(0)+3)) 
       theta_beg=real(array_fr(l1_get(0)+4)) 
       dtheta=aimag(array_fr(l1_get(0)+4)) 
       omega_end=real(array_fr(l1_get(0)+5)) 
       theta_end=aimag(array_fr(l1_get(0)+5)) 
       theta_m=aimag(array_fr(l1_get(0)+6)) 
                                                                        
      i_angle=n_omega*n_theta
      i=size(choffspecular)
      if(allocated(choffspecular).and.i.ne.i_angle) deallocate(choffspecular) 
      if (.not.allocated(choffspecular)) allocate(choffspecular(i_angle))

!       write(6,'(a,/,4f15.6)')'omega_beg,domega,omega_end,theta_beg=', &
!             omega_beg,domega,omega_end,theta_beg                     
!       write(6,'(a,4f10.2)')'omega_end,theta_end,theta_m=',  &          
!             omega_end,theta_end,theta_m                              
      nstorTH=l1_get(0)+6    ! see th_yscanmode() 
      nstorTH2=nstorTH*2 
!     nTH1=real(array_fr(l1_get(0)+6)) 
      k_wave=2.0*pi/lambda 
      sum_off=0.0 
!#####################################################################  
      i_angle=0 
      nn=nstorTH2 
      do i_theta=1,n_theta 
       theta=theta_beg+dtheta*(i_theta-1) 
       ibg_angle=i_angle+1 
       do k_omega=1,n_omega 
        omega=omega_beg+domega*(k_omega-1) 
        if(omega.eq.0.) omega=domega/100. 
                                                                        
        if(icase.eq.1.or.icase.eq.4)then 
!        exchange of theta and omega in routine scanmode                
         grazinc=theta 
         grazout=omega 
        else if(icase.eq.2.or.icase.eq.3) then 
         grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta 
         grazout=2*omega_beg+domega*(n_omega-1)+                        &
             (i_theta-1)*dtheta*2-grazinc                               
         if(grazout.lt.0.) then 
          i_angle=i_angle+1 
          choffspecular(i_angle)=0.0 
          goto 777 
         end if 
        else if(icase.eq.5) then 
!        PHI_s=omega N_s=n_omega                                        
         j=i_theta/2 
         if(2*j.eq.i_theta) then 
!         + dTheta_out                                                  
          grazinc=omega 
          grazout=omega+dtheta*j 
         else 
!         + dTheta_out                                                  
          grazinc=omega+dtheta*j 
          grazout=omega 
         end if 
         if(omega+dtheta*j.gt.omega_end)goto 777 
        end if 
                                                                        
        i_angle=i_angle+1 
                                                                        
        SQ= k_wave*sin(grazinc*0.001) 
        K1=-k_wave*sin(grazout*0.001) 
!        write(11,*)'SQ,K1=',SQ,K1                                      
        call energy_trndwba(DWBA,lay,lay_domain,MGRP,GEOSTR,           &
                         b_Bfield,b_domain,eta_domain,K_mag_lay,       &
                         scatlength,thicklayer,roughlayer,SQ,K1,G_mjv)                            
        call energy_diffuse(lay,lay_domain,MGRP,GEOSTR,b_domain,       &
                           eta_domain,G_mjv,rho_p,rho_a,Offspec)       
                                                                        
                                                                        
         Qx=k_wave*(cos(grazout*0.001)-cos(grazinc*0.001)) 
!	 call correlate(Qx,xi,COR)                                            
         choffspecular(i_angle)=real(dble((Offspec))/                    &
                               ((1.+(Qx*xi)**2)**1.5))                 
                                                                        
         sum_off=sum_off+choffspecular(i_angle) 
  777   continue       ! omega 
       end do          ! omega 
      end do 
!      write(6,*)' real_fr(nn+i),nn=',nn                                                                  
      do i=1,i_angle 
       real_fr(nn+i)=choffspecular(i)/sum_off 
      end do 
      return 
      END                                           
