!     author : h. spiering                                              
!              Am Damsberg 86                                           
!              D-55130 Mainz                                            
!              2006-2007                                                
     subroutine synoffspec_the2exp(n1,info) 
! ****************************************************************     
!    n1 = 0 error return                                               
!    n1 = 1 call of theory                                             
!    n1 = 2 derivatives                                                
!    n1 = 3 call of theory , calpl is not called                       
! ****************************************************************     
      use glbconst, only: maxfr1,maxfr2,maxn,max8,maxthss,maxscrd,&
                         icstrf,ivstrf
     use comdat, only: b_data,b_theory,ichanks,mxpt,mypt
     use comthe, only: real_fr,thfk,dfdp,ddpk,ib_df,kana,ibmisfit 
     use complt, only: ndisplay_mode
     implicit none 
     integer, intent(in) :: n1
     integer, intent(out):: info


     integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss
     integer       dstr,nstorTH,idum1,nstorTHyy,iaddr                         
     common/struct/dstr(istr+2),nstorTH,idum1,nstorTHyy,iaddr(3)

     integer       nTH1,idum,nexp,mgrpt,ien
     common/strLOC/nTH1,idum(4),nexp,mgrpt,ien(25)                              

     real          acsp,wavelength,uthick_A,                           &
                   unitchi,aiT_max,v_max,                              &
                   ak_extension,T_bunch,dastr,channels,columns,        &
                   strob_order,m_window,t1_window,t2_window,flag_basis,&
                   th_channels,angpairs,DWBA,dumcsp                    
     common/acstrf/acsp,wavelength,uthick_A,                           &
                   unitchi,aiT_max,v_max,                              &
                   ak_extension,T_bunch,dastr,channels,columns,        &
                   strob_order,m_window,t1_window,t2_window,flag_basis,&
                   th_channels,angpairs,DWBA,dumcsp(icstrf-18)         
                                                                       
     real          avsp,counts,background,Pdum,                        &
                   ang_shift,dumvsp                                    
     common/avstrf/avsp,counts,background,Pdum(3),ang_shift,           &
                   dumvsp(ivstrf-7)                                    
                                                                       
     logical       b_vs,b_counts,b_background,b_dumvsp 
     common/bvstrf/b_vs,b_counts,b_background,b_dumvsp(ivstrf-3) 
                                                                       
     logical b_total,b_residual,b_trot 
                                                                       
     real,   dimension(128):: ab_the
     integer,dimension(128):: iaset

     integer   jth,idscrd 
     real      yth 
     integer,parameter:: iscrd=maxscrd-128*128-9*maxn-1 
     common/scrd/jth(-3:124,-3:124),yth(-maxn:max8),idscrd(iscrd) 
     real    countsy,y1,y2,y3,y4,y5,y6,ff,aa,bb,cc,dd,ee,              &
             h,hx,hy,dx_the,dy_the,xb_the,yb_the,Dx_exp,Dy_exp         
     integer nthe,k,k1,j,ig,jx,jy,j1,j2,j3,j4,j5,j6,i_3d,jcase
                                                                       
!     write(6,'(a,5i6)')'syngl n1,ifrcase,dastr=',n1,ifrcase
      countsy=counts-background*channels 
!     integral 0-inf is normalized to 1                                
!     write(6,'(a,4f10.2)') ' frame02 counts,background,channels=' &,    
!        counts,background,channels                                   

      call synoffspec(b_total,info) 
                                                                        
      call ot_theo(i_3d,ab_the,iaset,xb_the,dx_the,yb_the,dy_the) 
                                                                        
      b_theory=.true. 
      if(.not.b_data) return 
                                                                        
      nexp=channels 
      nthe=nTH1 
      ibmisfit=0 
                                                                        
!      write(6,'(a,2i6,3f10.3)')'fr_synmos nstorTH,nTH1=',nstorTH,nTH1
!      write(6,'(a,6L5)')',b_total,b_background,b_counts =',           &  
!                  b_total, b_background,b_counts           
      k1=n1 
      goto (100,200,300),k1 
                                                                        
  100 continue 
      !     calculation of thfk                                               
      do j =1,nthe 
       yth(j)=real_fr(2*nstorTH+j)*countsy+background 
      end do 
      yth(0)=0. 
      yth(-1)=0. 
!     write(6,'(a,4i6)')' ichanks,mgrpt=',ichanks(0),mgrpt 
!     write(6,'(10i5)')(ichanks(j),j=1,ichanks(0))                   
!     write(6,'(8f12.3)') (yth(j),j=1,nthe)                          

      if(i_3d.eq.0) then 
!       2d interpolation of the theory at experimental points           
        do k=2,ichanks(0),2 
!        n-theta group                                                  
         do j=ichanks(k-1),ichanks(k) 
          ig=real_fr(mgrpt+j) 
!         to each theta group ig  belong n-omega theoretical angles      
          hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the 
          jx=int(hx) 
          hx=hx-float(jx) 
          jx=jx+iaset(ig) 
          y1=yth(jx) 
          y2=yth(jx+1) 
          y3=yth(jx+2) 
          aa= (y1+y3-2.*y2)/2. 
          bb= (y3-y1)/2. 
          thfk(j)=(aa*hx+bb)*hx+y2 
          if(thfk(j).lt.0.) thfk(j)=0. 
!          write(6,'(4i3,8f12.2)')j,ig,iaset(ig),io,                    
!     &               real_fr(mxpt+j),ab_the(ig),y1,y2,y3,thfk(j)       
         end do 
        end do 
       else 
!       3d interpolation of the theory at experimental points           
        b_trot=.false. 
        if(i_3d.eq.1)b_trot=.true. 
!       write(6,*)'ichanks: ',(ichanks(k),k=0,ichanks(0))                                                                
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
           Dx_exp=real_fr(mxpt+j)-xb_the 
           Dy_exp=real_fr(mypt+j)-yb_the 
           if(b_trot) then 
            h=Dx_exp 
            Dx_exp=(Dx_exp-Dy_exp)/2. 
            Dy_exp=(h+Dy_exp)/2. 
           end if 
           hx=Dx_exp/dx_the 
           jx=int(hx)                         ! theta() of theory  
           hx=hx-float(jx) 

           hy=Dy_exp/dy_the 
           jy=int(hy)                         ! omega() of theory 
           hy=hy-float(jy) 
                                                                        
           if(jth(jx,jy+2).gt.0)then 
            if(jth(jx+2,jy).gt.0)then 
!            standard case                                              
             jcase=1 
             j1=jth(jx,jy) 
             j2=jth(jx+1,jy) 
             j3=jth(jx+2,jy) 
             j4=jth(jx,jy+1) 
             j5=jth(jx+1,jy+1) 
             j6=jth(jx,jy+2) 
            else   ! jth(jx+2,jy)=0
!            x_max boundary                                             
             jcase=2 
             j1=jth(jx+1,jy) 
             j2=jth(jx,jy) 
             j3=jth(jx-1,jy) 
             j4=jth(jx+1,jy+1) 
             j5=jth(jx,jy+1) 
             j6=jth(jx+1,jy+2) 
             hx=1.-hx 
            end if 
           else  !jth(jx,jy+2)=0 
            if(jth(jx+2,jy).gt.0)then 
!            y_max boundary                                             
             jcase=3 
             j1=jth(jx,jy+1) 
             j2=jth(jx+1,jy+1) 
             j3=jth(jx+2,jy+1) 
             j4=jth(jx,jy) 
             j5=jth(jx+1,jy) 
             j6=jth(jx,jy-1) 
             hy=1.-hy 
            else   ! jth(jx+2,jy)=0 
!            x-max,y_max corner                                         
             jcase=4 
             j1=jth(jx+1,jy+1) 
             j2=jth(jx,jy+1) 
             j3=jth(jx-1,jy+1) 
             j4=jth(jx+1,jy) 
             j5=jth(jx,jy) 
             j6=jth(jx+1,jy-1) 
             hx=1.-hx 
             hy=1.-hy 
            end if 
           end if 
!           write(6,'(6i3,2(2x,i3,2f10.3),2f10.3)')j1,j2,j3,j4,j5,j6,&   
!              jx,hx,real_fr(mxpt+j),jy,hy,real_fr(mypt+j),Dx_exp,Dy_exp
           ff=yth(j1) 
           y2=yth(j2)-ff 
           y3=yth(j3)-ff 
           y4=yth(j4)-ff 
           y5=yth(j5)-ff 
           y6=yth(j6)-ff 
!            write(6,'(6f12.3)')ff,y2,y3,y4,y5,y6
           aa=-(2.*y2-y3) 
           bb=-(y3-4.*y2) 
           cc=-(2.*y4-y6) 
           dd=-(y6-4.*y4) 
           ee=(y5-y4-y2)*2. 
                                                                        
           thfk(j)=((aa*hx+bb)*hx+(cc*hy+dd+ee*hx)*hy)/2.+ff 
         end do 
        end do 
       end if 
                                                                        
      do j=1,nexp 
       real_fr(2*nstorTHyy+j)=thfk(j) 
      end do 
!     write(6,'(2f12.2)') (real_fr(mfpt+j),thfk(j),j=1,nexp)           
                                                                        
      return 
                                                                        
  200 continue 
      ib_df=0 
!     derivatives                                                       
!     ib_df=1: derivative calculated                                    
!     ib_df=0 happens if a parameter of a set, wich is not currently    
!     fitted, is free. It will be fixed in the routine fit.             
                                                                        
!     analytical and numerical derivatives are handled fdifferently     
!     integer kana (k analytical) = 1 indicates an analytical derivative
                                                                        
      b_total=b_total 
      b_residual=.not.(b_total.or.b_counts) 
!     all variables unchanged but background                            
                                                                        
      if(b_background.and.b_residual) then 
!       write(6,'(a)')  '   derivative of background ------------'      
        do j=1,nexp 
         dfdp(j)=1.0 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
      end if 
!     for background derivative the last theory values were not neccessa
                                                                        
      do j=1,nexp 
       thfk(j)=real_fr(2*nstorTHyy+j) 
      end do 
!     write(6,'(8f10.5)') (thfk(i),i=1,nexp,18)                         
                                                                        
      b_residual=.not.(b_total.or.b_background) 
!     all variables but counts                                          
      if(b_counts.and.b_residual) then 
!       write(6,'(a)')  '   derivative of counts ------------'          
        do j=1,nexp 
         dfdp(j)=(thfk(j)-background)/countsy 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
      end if 
                                                                        
                                                                        
!     numerical derivatives                                             
      b_residual=.not.(b_total.or.b_background.or.b_counts) 
!     (b_residual=.true.: parameter is connected only to variables      
!     of other sets                                                     
      if(b_residual) goto 250 
                                                                        
      kana=0 
      do j =1,nthe 
       yth(j)=real_fr(2*nstorTH+j)*countsy+background 
      end do 
      yth(-1)=0. 
!      write(6,'(8g12.3)') (real_fr(2*nstorTH+j),j=1,nthe)              
                                                                        
       if(ndisplay_mode.gt.0) then 
!       2d interpolation of the theory at experimental points           
        do k=2,ichanks(0),2 
!        n-theta sets                                                   
         do j=ichanks(k-1),ichanks(k) 
          ig=real_fr(mgrpt+j) 
!         to each theta group ig  belong n-omega theoreticalangles      
          hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the 
          jx=int(hx) 
          hx=hx-float(jx) 
          jx=jx+iaset(ig) 
          y1=yth(jx) 
          y2=yth(jx+1) 
          y3=yth(jx+2) 
          aa= (y1+y3-2.*y2)/2. 
          bb= (y3-y1)/2. 
          ff=(aa*hx+bb)*hx+y2 
          if(ff.lt.0.) ff=0. 
          dfdp(j)=(ff-thfk(j))/ddpk 
!          write(6,'(8f12.3)') ff,thfk(j)                               
         end do 
        end do 
!        write(6,'(8g12.3)') (dfdp(j),j=1,nthe)                         
       else 
!       3d interpolation of the theory at experimental points           
        b_trot=.false. 
        if(i_3d.eq.1)b_trot=.true. 
                                                                        
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
           Dx_exp=real_fr(mxpt+j)-xb_the 
           Dy_exp=real_fr(mypt+j)-yb_the 
           if(b_trot) then 
            h=Dx_exp 
            Dx_exp=(Dx_exp-Dy_exp)/2. 
            Dy_exp=(h+Dy_exp)/2. 
           end if 
           hx=Dx_exp/dx_the 
                                              ! theta() of theory       
           jx=int(hx) 
           hx=hx-float(jx) 
           hy=Dy_exp/dy_the 
                                              ! omega() of theory       
           jy=int(hy) 
           hy=hy-float(jy) 
!          write(6,'(a,2i5)')' jx,jy=',jx,jy                            
           if(jth(jx,jy+2).gt.0)then 
            if(jth(jx+2,jy).gt.0)then 
!            standard case                                              
             j1=jth(jx,jy) 
             j2=jth(jx+1,jy) 
             j3=jth(jx+2,jy) 
             j4=jth(jx,jy+1) 
             j5=jth(jx+1,jy+1) 
             j6=jth(jx,jy+2) 
            else   ! jth(jx+2,jy)=0 
!            x_max boundary                                             
             j1=jth(jx+1,jy) 
             j2=jth(jx,jy) 
             j3=jth(jx-1,jy) 
             j4=jth(jx+1,jy+1) 
             j5=jth(jx,jy+1) 
             j6=jth(jx+1,jy+2) 
             hx=1.-hx 
            end if 
           else    !jth(jx,jy+2)=0  
            if(jth(jx+2,jy).gt.0)then 
!            y_max boundary                                             
             j1=jth(jx,jy+1) 
             j2=jth(jx+1,jy+1) 
             j3=jth(jx+2,jy+1) 
             j4=jth(jx,jy) 
             j5=jth(jx+1,jy) 
             j6=jth(jx,jy-1) 
             hy=1.-hy 
            else   ! jth(jx+2,jy)=0 
!            x-max,y_max corner                                         
             j1=jth(jx+1,jy+1) 
             j2=jth(jx,jy+1) 
             j3=jth(jx-1,jy+1) 
             j4=jth(jx+1,jy) 
             j5=jth(jx,jy) 
             j6=jth(jx+1,jy-1) 
             hx=1.-hx 
             hy=1.-hy 
            end if 
           end if 
                                                                        
!           write(6,'(6i3,2(2x,i3,2f10.3),2f10.3)')j1,j2,j3,j4,j5,j6,   
!     &         jx,hx,real_fr(mxpt+j),jy,hy,real_fr(mypt+j),Dx_exp,Dy_ex
           ff=yth(j1) 
           y2=yth(j2)-ff 
           y3=yth(j3)-ff 
           y4=yth(j4)-ff 
           y5=yth(j5)-ff 
           y6=yth(j6)-ff 
                                                                        
           aa=-(2.*y2-y3) 
           bb=-(y3-4.*y2) 
           cc=-(2.*y4-y6) 
           dd=-(y6-4.*y4) 
           ee=(y5-y4-y2)*2. 
           ff=((aa*hx+bb)*hx+(cc*hy+dd+ee*hx)*hy)/2.+ff 
           dfdp(j)=(ff-thfk(j))/ddpk 
         end do 
        end do 
       end if 
                                                                        
      ib_df=1 
                                                                        
  250 continue 
      return 
                                                                        
  300 continue 
      !     calculation of thfk                                               
                                                                        
      if(.not.b_theory.or..not.b_data) goto 310 

!     call synoffspec(b_total,info) 
!     calculation of thfk                                               
      do j =1,nthe 
       yth(j)=real_fr(2*nstorTH+j)*countsy+background 
      end do 
      yth(0)=0. 
      yth(-1)=0. 
                                                                        
      if(i_3d.eq.0) then 
!      2d interpolation of the theory at experimental points            
       do k=2,ichanks(0),2 
!       n-theta group                                                   
        do j=ichanks(k-1),ichanks(k) 
         ig=real_fr(mgrpt+j) 
!        to each theta group ig  belong n-omega theoreticalangles       
         hx=(real_fr(mxpt+j)-ab_the(ig))/dx_the 
         jx=int(hx) 
         hx=hx-float(jx) 
         jx=jx+iaset(ig) 
         y1=yth(jx) 
         y2=yth(jx+1) 
         y3=yth(jx+2) 
         aa= (y1+y3-2.*y2)/2. 
         bb= (y3-y1)/2. 
         thfk(j)=(aa*hx+bb)*hx+y2 
         if(thfk(j).lt.0.) thfk(j)=0. 
!         write(6,'(4i3,8f12.2)')j,ig,iaset(ig),io,                     
!    &               real_fr(mxpt+j),ab_the(ig),y1,y2,y3,thfk(j)        
        end do 
       end do 
      end if 
!     3d: the full theory is plotted (independent of the data)          
  310 return 
      END                                           
                                                                        
                                                                        
! Program for non-specular SMR spectra evaluation from correlated       
! +- domains.                                                           
!Vesrion 2.                                                             
!        Khaidukov & Deak                                               
!        October 2005                                                   
!       +Summer 2006                                                    
!        H. Spiering november 2006                                      
     subroutine synoffspec(b_total,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,max8,maxscrd,maxthss,&
                         ivstrf,ivfr1trf,ivfr2trf,ivsstrf, &
                         icstrf,icfr1trf,icfr2trf, &
                         infotext,enwr,nwr
     use comthe, only: array_fr,real_fr
     implicit none 
     logical, intent(out):: b_total 
     integer, intent(out):: info   

     integer     mstruct1,istruct1,istruct2,     &
                 l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,            &
                 nstorTH,nstorTH1,nstorTHyy,nstorSI,mpt,ipLG,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   mpt,ipLG,nstorTH,nstorTH1,nstorTHyy,nstorSI,iaddr(2)

     real          srw8 
     integer       nTH1,nCP,nTH2,nsrw,nstore,ifrth,                    &
                   iflag_basis,l_Poincare,nLG,nTH,ith_channels,        &
                   nsampling,ak8,nomega,nstrob_order,jt0_ch,           &
                   iT_max,nvch,nhyperfine,ien                                            
     common/strLOC/nTH1,nCP,nTH2,nsrw,nstore,ifrth(7),                 &
                   iflag_basis,l_Poincare,nLG,nTH,ith_channels,        &
                   nsampling,ak8,nomega,srw8,nstrob_order,jt0_ch,      &
                   iT_max,nvch,nhyperfine,ien(6)                      
                                                                       
     real          acsp,wavelength,uthick_A,                           &
                   unitchi,aiT_max,v_max,                              &
                   ak_extension,T_bunch,dastr,channels,columns,        &
                   strob_order,m_window,t1_window,t2_window,flag_basis,         &
                   th_channels,angpairs,Th_approx,dumcsp               
     common/acstrf/acsp,wavelength,uthick_A,                           &
                   unitchi,aiT_max,v_max,                              &
                   ak_extension,T_bunch,dastr,channels,columns,        &
                   strob_order,m_window,t1_window,t2_window,flag_basis,&
                   th_channels,angpairs,Th_approx,dumcsp(icstrf-18)    
                                                                       
     real          avs,counts,background,Pxsi,Peta,Pzeta,              &
                   PAdum,ang_shift,dumvsp                              
     common/avstrf/avs,counts,background,Pxsi,Peta,Pzeta,              &
                   PAdum(3),ang_shift,dumvsp(ivstrf-10)                
                                                                       
     logical       b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,   &
                   b_PAdum,b_ang_shift,b_dumvsp                        
     common/bvstrf/b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,   &
                   b_PAdum(3),b_ang_shift,b_dumvsp(ivstrf-10)          
                                                                       
     real            acfr1,dumcfr1 
     common/acfr1trf/acfr1,dumcfr1(icfr1trf-1) 
                                                                       
     real            avfr1,pvfr1,Hext,thetaHe,phiHe,phiA,thetaA,psiA,  &
                     lLcor_length,uUcor_length,dumvfr1                 
     common/avfr1trf/avfr1,pvfr1,Hext,thetaHe,phiHe,phiA,thetaA,psiA,  &
                     lLcor_length,uUcor_length,dumvfr1(ivfr1trf-10)    
     logical         b_vfr1,b_pvfr1,b_Hext,b_thetaHe,b_phiHe,b_phiA,   &
                     b_thetaA,b_psiA,b_lLcorlength,b_uUcorlength,      &
                     b_dumvfr1                                         
     common/bvfr1trf/b_vfr1,b_pvfr1,b_Hext,b_thetaHe,b_phiHe,b_phiA,   &
                     b_thetaA,b_psiA,b_lLcorlength,b_uUcorlength,      &
                     b_dumvfr1(ivfr1trf-10)                            
                                                                       
                                                                       
     real            acfr2,rep_grp,dumcfr2 
     common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2) 
                                                                       
     real            avfr2,thicklay,re_chilay,ai_chilay,roughness,     &
                     eta_domain,dumvfr2                                
     common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,     &
                     eta_domain,dumvfr2(ivfr2trf-6)                    
     logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,        &
                     b_roughness,b_etadomain,b_dumvfr2                 
     common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,        &
                     b_roughness,b_etadomain,b_dumvfr2(ivfr2trf-6)     
                                                                       
     real            vsstrf,sftr 
     common/avsstrf/ vsstrf(ivsstrf) 
     logical         b_vsstrf 
     common/bvsstrf/ b_vsstrf(ivsstrf) 
                                                                       
     logical,     dimension(maxfr2) :: b_sites,b_domain
     real(kind=4),dimension(maxfr1) :: winc
     real(kind=8),dimension(maxfr2) :: vkd,thicklayer,roughlay

     integer,     dimension(maxfr1) :: ipos_mstruct1
     integer,  dimension(2*maxfr2+2):: laystr
     integer,  dimension(0:2*maxfr2):: GEOSTR
     complex,     dimension(2,2)    :: rho,A
                                                                       
! *** Definitions of structure variables L. Deak 09.10.2002 ***        
     integer POINTER,GRP,MAXGRP 
     logical b_first,b_isgt1 
     integer,parameter:: iscrd=maxscrd-3-5*maxn-11*maxfr2              &
                         -maxfr2*maxfr2*2-66-24-8*maxfr2               &
                         -16-max8-256, maxn4=4*maxn                      
     integer   iposlayav,iposlay,ichstr,ichall,indmu,indll,indly,      &
               lmu1,lmu2                                  
     real      eta,wi,trace,Qz,ar_ratio,dscrd 
     complex   chilay,                                        &
               SQRO,Sexpa,cmat,sFourier,                               &
               Fourier,cmatav,cmat2                                    
     common/scrd/ichall(0:maxn*2),iposlay(maxfr2,2),ichstr(0:maxn),    &
               indmu(maxfr2),indll(maxfr2),indly(maxfr2),              &
               lmu1(maxfr2*maxfr2),lmu2(maxfr2*maxfr2),                &
               eta(maxfr2),wi(maxfr2,2),                               &
               trace(-maxn:maxn),                                      &
               iposlayav(maxfr2),chilay(maxfr2),                       &
               SQRO(4),Sexpa(0:32),cmat(4),sFourier(4),                &
               Fourier(2,2,maxfr2),                                    &
               cmatav(4),cmat2(4),Qz(max8),ar_ratio(0:255),dscrd(iscrd)

     integer lstruct1,lstruct2,lstruct3,isubthe,                       &
             icase,i_angle,k_omega,i_theta,n_omega,n_theta,            &
             iall,mlay,lay_domain,nn_ne0,nstorIN,nstorTH2,             &
             isite,inc_pos,i,k,ll,j,jj,n,nn,isgtp,lay,mal,             &
             n_approx,i_approx,kom1,kom2,ibg_angle,nfourier 
     real    theta,theta_beg,dtheta,omega,omega_beg,domega,            &
             theta_m,omega_end,theta_end,pi,rad,sing,Offspec,          &
             weight,h1,ratio,start,finish                              
     real    vector_k,grazinc,grazout,corroff,thmax 
     real,dimension(64):: hoffspec
     real(kind=8):: SQ,K1 
     complex hc1,hci,hc0 
     complex, dimension(:), allocatable:: aFourier  
     complex, dimension(:,:), allocatable::rg1,g2r
                                                                        
     real    c1,dumc 
     common/acmaps/c1,dumc(icstrf-1) 
!     complex forout, dimension forout(4,-maxn:maxn)                   
     logical b_lay,b_absorber,b_corr,b_angpairs 

      info=0                                                                  
      b_absorber=.false. 
      b_corr=.false. 
      b_angpairs=angpairs.gt.0. 
                                                                        
      n_approx=Th_approx 
!------------------------------------------------------------------     
      nstorIN=nstorTH-maxfr2**2       ! pointer of the storage for 
!                                       the integrals                   
!-------------------------------------------------------------------    
                                                                        
      call mapsub(0,0,0) 
      b_total=b_Pxsi.or.b_Peta.or.b_Pzeta.or.b_ang_shift 
!     calculation of non equidistant energy points                      
       call channels_adjust(nvch,nhyperfine,nstrob_order,nomega,iall)
                                                                        
!      the routine calculates channels needed for a nonequidistant      
!      channel numbers for all later shifts +- nomega in the stoboscopic
!      integration                                                      
!---------------------------------------------------------------------- 
!       nvch=0                                                          
!       iall=nTH                                                        
!       do i=0,iall                                                     
!        ichall(i)=i                                                    
!       end do                                                          
!       ichall(nTH+1)=-1                                                
!---------------------------------------------------------------------- 
                                                                        
      isubthe=1 
      call get_theory(isubthe,info) 
      b_total= b_total.or.(isubthe.gt.0) 
                                                                        
      hc1=cmplx(1.,0.) 
      hci=cmplx(0.,1.) 
      hc0=cmplx(0.,0.) 
                                                                        
!     this routine synoffspec is only called for ifrcase=31             
                                                                        
!     thfrcase(1)='time differential transmission spectrum(11)'         
!     thfrcase(2)='time differential reflection spectrum(21)'           
!     thfrcase(3)='time integral - rocking curve,Fourier(22)'           
!     thfrcase(4)='time integral - rocking curve(24)'                   
!     thfrcase(5)='prompt - rocking curve(23)'                          
!     thfrcase(5)='time integral - offspecular(31)'                     
                                                                        
!-------------------------------------------------------------------    
!     write(6,'(3(a,e8.2))')'synmos Pxsi=',Pxsi,' Peta=',Peta,' Pzeta=',Pzeta

       pi=atan(1.)*4. 
       rad=pi/180. 
!      transformation matrix from spherical basis to (sigma,pi)-basis   
                                     ! /Angstroem                       
       vector_k=2.0*pi/wavelength 
!-----------------------------------------------------------------------
!     transformation matrix from spherical basis to (sigma,pi)-basis    
!     orientation of the absorber with respect to the beam              
                                                                        
       rho(1,1)=cmplx(1.+Pzeta,0.)/2. 
       rho(1,2)=cmplx(Pxsi,-Peta)/2. 
       rho(2,1)=cmplx(Pxsi,Peta)/2. 
       rho(2,2)=cmplx(1.-Pzeta,0.)/2. 
                                                                        
!      rho=(1+P*sigma)/2                                                
!                (0  1)            (0  -i)              (1   0)         
!      sigma_xsi=(1  0), sigma_eta=(i   0),  sigma_zeta=(0  -1)         
                                                                        
      lstruct1=0 
 1000 continue 
                                                                        
      lstruct1=lstruct1+1 
      if(lstruct1.gt.mstruct1) goto 2000 
      inc_pos=l1_put(lstruct1) 
      ipos_mstruct1(lstruct1)=inc_pos 
!     inc_pos points to the data block on array_fr of the inc_oherent pa
!     running from 1 to mstruct1                                        
                                                                        
!      write(6,'(a,i1,a2,i8)')'synmos l1_put(',lstruct1,')=',l1_put(lstruct1)
                                                                        
       call mapsub(lstruct1,0,0) 
       winc(lstruct1)=pvfr1 
       b_total=b_total.or.b_pvfr1.or.b_lLcorlength
!      weigth of the incoherent part (first number on common/avfr1trm/ b
!      to the theory)                                                   
                                                                        
!      thetaA=(graz_end-graz_beg)/2.                                    
       sing=sin(0.001*thetaA) 
                                                                        
       b_lay=.false. 
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
!       carefull lstruct2 counts the number of layers over all devices l
!      ------------------------------------------------------------     
!      layer lay1,2 ... mlay of  absorber                               
!      ---------------------------------------------------------------  
!      The Lorentz curve of the absorber in npq is 1 at resonance so tha
!      for a singl line the exponent at resonance is just -teff (effecti
!      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw
!      normalizes ( to area 1) the Lorentz curve.                       
!                                                                       
!      Sums of absorber curves at the positions Eagd.                   
!                                                                       
!      ----0--------------------------naLG                              
!       naLG--------------------------0-------------        srw8        
!        nTH------------0------------nTH                    srw         
                                                                        
        lay=lstruct2 
                                                                        
        call mapsub(lstruct1,lstruct2,0) 
                                                                        
        thicklayer(lay)=thicklay 
        if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then 
         chilay(lay)=cmplx(re_chilay,ai_chilay)*unitchi 
        else 
         chilay(lay)=(0.,0.) 
        end if 
        b_lay=b_vfr2.or.b_thicklay 
        eta(lay)=eta_domain 
!       to each layer may belong another eta, but there is only one eta 
!       per layer independent of the number of sites.                   
!       The case of strong antiferromagnetic correlation between layers 
!       requires eta/1-eta for neigbouring layers!!                     
!       if rep_grp is negativ the logical b_domain(lay) is .True.       
                                                                        
        b_domain(lay)=rep_grp.lt.0 
        i=abs(rep_grp) 
        laystr(2*lay-1)=i 
        laystr(2*lay)=10*(abs(rep_grp)-float(i)+.01) 
        roughlay(lay)=roughness*vector_k 
                                                                        
        b_isgt1=.false. 
        if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then 
         b_isgt1=.true. 
         iposlayav(lay)=l2_put(lstruct2) 
         jj=iposlayav(lay) 
         do i=0,nTH 
           ll=jj+8*i 
          array_fr(ll+1)=chilay(lay) 
          array_fr(ll+2)=chilay(lay) 
          array_fr(ll+3)=(0.,0.) 
          array_fr(ll+4)=(0.,0.) 
          array_fr(ll+5)=chilay(lay) 
          array_fr(ll+6)=chilay(lay) 
          array_fr(ll+7)=(0.,0.) 
          array_fr(ll+8)=(0.,0.) 
         end do 
        end if 
!       subroutine th_hdeq and th_hdeqf expect the external field  in
!       common block:
!       common/avfr2trf/avfr2,pvfr2,dum(4),
!                     Hext,thetaHe,phiHe,phi_ls,theta_ls,psi_ls
!     common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,eta_domain,&
!                     dumvfr2(ivfr2trf-6) 
  
         dumvfr2(1)=Hext
         dumvfr2(2)=thetaHe
         dumvfr2(3)=phiHe
         dumvfr2(4)=phiA
         dumvfr2(5)=thetaA 
         dumvfr2(6)=psiA

         b_dumvfr2(1)=b_Hext
         b_dumvfr2(2)=b_thetaHe
         b_dumvfr2(3)=b_phiHe
         b_dumvfr2(4)=b_phiA
         b_dumvfr2(5)=b_thetaA
         b_dumvfr2(6)=b_psiA
                                                                       
        b_sites(lay)=.false. 
        isite=0 
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
!        carefull lstruct3 counts the number of sites over all layers ls
         isite=isite+1 
!        isite counts inside this layer                                 
         b_sites(lay)=.true. 
!        at least one nuclear scatterer in the layer (used in g_optic)  
         call mapsub(lstruct1,lstruct2,lstruct3) 
                                                                        
         sftr=vsstrf(2) 
         weight=sftr*uthick_A 
         wi(lay,isite)=weight/vector_k 
!        intensity wi of the site                                       
                                                                        
         if(b_vsstrf(2).and.enwr(6).eq.'nynn') then 
          if(weight.gt.sing/20..or.sing.gt.0.05)                       &
           write(nwr,'(2(a,g8.1),a)')                                  &
           '** f*unit_thickness=',weight,' << sin(th)=',sing,' << 1 ?'   
!           write(nwr,'(a,2g12.5)')'sftr=',sftr,weight/vector_k         
          end if 
                                                                        
                                                                        
         isubthe=0 
         call get_theory(isubthe,info) 
!        get_theory comes back with isubthe<0 if nothing to do          
         b_lay=b_lay.or.(isubthe.gt.0)
 
         iposlay(lay,isite)=l3_get(lstruct3) 
                                                                        
!        pointer on array_fr for the forward scattering amplitude for   
!        each site it has to be multiplied by the weight(f factor) and  
!        the thickness of the layer thicklayer(lay). The weight thicklay
!        will be carried by vkd=vector_k*thicklayer(lay).               
                                                                        
         if(b_isgt1) then 
          isgtp=l3_get(lstruct3) 
          jj=iposlayav(lay) 
          if(isite.eq.1)then 
           h1=wi(lay,isite)*eta(lay) 
          else 
           h1=wi(lay,isite)*(1.-eta(lay)) 
          end if 
          do n=1,8*(nTH+1) 
           array_fr(jj+n)=array_fr(jj+n)+array_fr(isgtp+n)*h1 
          end do 
         else 
          write(nwr,'(a)')' only one site -> no domains !!' 
         end if 
        end do 
        b_absorber=b_absorber.or.b_lay 
       end do 
!      end of loop over all layers                                      
                                                                        
       mlay=lay 
       laystr(2*lay+2)=-1 
       laystr(2*lay+1)=0 
       b_total=b_total.or.b_absorber 
                                                                        
!      write(6,'(a)')'++++++++++++++synrock++++++++++++++++++++++'      
!      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)      
!-----------------------------------------------------------------------
!     here the matrix R for the layers are given :                      
!     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))              
!                         (samplay(n,lay) -sapplay(n,lay))              
!                                                                       
!     calculation of the transmittivity matrix T for all channels n     
!     by   T = exp(iR)*rho*exp(-iR+)                                    
                                                                        
      if(.not.(b_total)) goto 1000 
!     if no change of any layer )and sites of the layer changed b_total=
      do lay=1,mlay 
       vkd(lay)=vector_k*thicklayer(lay) 
      end do 
                                                                        
!       write(6,'(a,20i4)')'laystr=',(laystr(i),i=1,2*mlay)             
!      **************************************************************** 
!      Construction of the layer structure from the laystr variable.    
!      GEOSTR(GRP) is the number of layers in group GRP.                
!      L. Deak, 09.10.2002                                              
       GRP         =0 
       GEOSTR(GRP) =0 
       MAXGRP      =0 
!                                                                       
       b_first     =.true. 
       POINTER=1 
       do lay=2,2*mlay,2 
        if(b_first)then 
         if(GRP.eq.laystr(lay))then 
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1 
         else 
          POINTER         =POINTER+GEOSTR(2*GRP) 
          GRP             =GRP+1 
          MAXGRP          =GRP 
          GEOSTR(2*GRP)   =1 
          GEOSTR(2*GRP-1) =laystr(lay-1) 
         end if 
         if(vkd(lay/2).lt.0.) then 
          b_first         =.false. 
          vkd(lay/2)      =1.d30 
          GEOSTR(2*GRP-1) =1 
         end if  ! VKD < 0  
        end if   ! b_first   
       end do 
!       write(6,'(a,20i4)')  &                                           
!         'MAXGRP,GEOSTR=',MAXGRP,(GEOSTR(i),i=1,2*MAXGRP)             
!      *****************************************************************
        DO i=1,2 
         DO k=1,2 
          A(i,k)=rho(i,k) 
         END DO 
        END DO 
        call ssqrt2(A,A) 
        SQRO(1)=A(1,1) 
        SQRO(2)=A(2,1) 
        SQRO(3)=A(1,2) 
        SQRO(4)=A(2,2) 

!      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega                
       icase=int(real(array_fr(l1_get(0)+1))) 
       n_omega=int(real(array_fr(l1_get(0)+2))) 
       n_theta=int(aimag(array_fr(l1_get(0)+2))) 
       omega_beg=real(array_fr(l1_get(0)+3)) 
       domega=aimag(array_fr(l1_get(0)+3)) 
       theta_beg=real(array_fr(l1_get(0)+4)) 
       dtheta=aimag(array_fr(l1_get(0)+4)) 
       omega_end=real(array_fr(l1_get(0)+5)) 
       theta_end=aimag(array_fr(l1_get(0)+5)) 
       theta_m=aimag(array_fr(l1_get(0)+6)) 
                                                                        
!       write(6,'(a,3i7)') 'th_synoff  nTH1,nstorTH=',nTH1,nstorTH      
!       write(6,'(a,i3)')' icase=',icase                                
       !   nstorTH is 0 by fr_synchrotron() (usage does not interfere       
                                       ! see th_yscanmode()             
       nstorTH=l1_get(0)+6 
       nstorTH2=nstorTH*2 
       nTH1=real(array_fr(l1_get(0)+6)) 
                                                                        
!       write(6,'(a,i4,4x,3f10.4)')'n_theta,theta_beg,dtheta,theta_end=', &
!                                   n_theta,theta_beg,dtheta,theta_end 
!       write(6,'(a,i4,4x,3f10.4)')'n_omega,omega_beg,domega,omega_end=', & 
!                                   n_omega,omega_beg,domega,omega_end                            

       call corfou_dim(mlay,MAXGRP,GEOSTR,b_domain,lay_domain,mal)

       nn_ne0=mal*mal
       if(mal.gt.maxfr2) then
        print'(a)',' number of layers to large'
        return
       end if
       nfourier=8*lay_domain*(iall+1) 
       allocate(aFourier(nfourier))
       allocate(rg1(4,-maxn4:maxn4),g2r(4,-maxn4:maxn4))

       call corfou(mlay,maxfr2,MAXGRP,GEOSTR,b_domain,          &  !(in)
                                  indmu,indll,indly,lmu1,lmu2)     !(out)    
                                                                        
       call window_function(nstrob_order,T_bunch,t1_window,t2_window,Sexpa)
       i=1 
       do while(eta(i).ne.0.) 
        i=i+1 
       end do 
       if(i.le.1)then 
        info=33 
         infotext(1)='<Synchrotron_offspecular>/th_synoffspec/domain' 
         infotext(2)='two eta_domain values have to be defined ' 
         infotext(3)=' ' 
        return 
       end if 
       eta_domain=eta(i-1) 
                                                                        
!       write(6,'(a, 2f12.3)')                                          
!     &  ' eta_domain,lLcor_length=',eta_domain,lLcor_length            
      call cpu_time(start) 
      b_corr=b_corr.and.(.not.b_total) 
      if(b_angpairs.or.n_approx.ge.1.or.b_corr) goto 555 
!      n_approx=0   grazinc<=grazout:diwa  i_approx=1                   
!                   grazinc>grazout :dowa  i_approx=2                   
!      n_approx=1   i_approx=1  diwa                                    
!      n_approx=2   i_approx=2  dowa                                    
!      n_approx=3   i_approx=3  Born approximation                      
!     ---------  begin of loops over specular angles -> ratio: dowa/diwa
      if(icase.le.4)then 
!      icase=1 exchange of theta and omega in routine scanmode          
       do i_theta=1,n_theta 
        theta=theta_beg+dtheta*(i_theta-1) 
                                                                        
        grazinc=0.001*theta/2. 
        SQ=sin(grazinc) 
        K1=-SQ 
        call  offspecular(2,mlay,b_sites,b_domain,MAXGRP,GEOSTR,           &
                    roughlay,vkd,lay_domain,                               &
                    nstorTH1, nfourier,aFourier,rg1,g2r,nstore,nn_ne0,iall,&
                             nstrob_order,nvch,nhyperfine,nomega,          &
                             SQ,K1,Offspec)                             
        ar_ratio(i_theta)=Offspec 
!       write(6,'(a,2g12.4)')' Offspec=',Offspec,theta         
        call  offspecular(1,mlay,b_sites,b_domain,MAXGRP,GEOSTR,           &
                    roughlay,vkd,lay_domain,                               &
                    nstorTH1, nfourier,aFourier,rg1,g2r,nstore,nn_ne0,iall,&
                    nstrob_order,nvch,nhyperfine,nomega,                   &
                    SQ,K1,Offspec)                             
        ar_ratio(i_theta)=Offspec/ar_ratio(i_theta) 
!        write(6,'(a,2g12.4)')' Offspec=',Offspec,theta         
       end do 
      else if(icase.eq.5)then 
       do k_omega=1,n_omega 
        ar_ratio(k_omega)=0.0 
       end do 
       do k_omega=1,n_omega 
        omega=omega_beg+domega*(k_omega-1) 
        grazinc=0.001*omega 
        SQ=sin(grazinc) 
        K1=-SQ 
!        write(6,'(a,6g12.3)')' omega=',omega                           
        call  offspecular(1,mlay,b_sites,b_domain,MAXGRP,GEOSTR,           &
                    roughlay,vkd,lay_domain,                               &
                    nstorTH1, nfourier,aFourier,rg1,g2r,nstore,nn_ne0,iall,&
                    nstrob_order,nvch,nhyperfine,nomega,                   &
                    SQ,K1,Offspec)                             
        ar_ratio(k_omega)=Offspec 
!                write(6,'(i6,6g12.3)')k_omega,Offspec                  
        call  offspecular(2,mlay,b_sites,b_domain,MAXGRP,GEOSTR,           &
                    roughlay,vkd,lay_domain,                               &
                    nstorTH1, nfourier,aFourier,rg1,g2r,nstore,nn_ne0,iall,&
                    nstrob_order,nvch,nhyperfine,nomega,                   &
                    SQ,K1,Offspec)                             
!                 write(6,'(i6,6g12.3)')k_omega,Offspec                  
        if(Offspec.gt.0)then 
         ar_ratio(k_omega)=ar_ratio(k_omega)/Offspec 
        else 
         ar_ratio(k_omega)=0. 
        end if 
       end do 
!       write(6,'(8f10.2)')(ar_ratio(k_omega),k_omega=1,n_omega)        
      end if 
!     ----------- end of loops over specular angles -> ratio: dowa/diwa 
  555 continue 
      kom1=1 
      kom2=n_omega 
      if(.not.(b_angpairs.or.b_corr))then 
       if(n_approx.eq.4) then 
!       symmetrized diwa                                                
        kom2=(n_omega+1)/2 
       else if(n_approx.eq.5) then 
!       symmetrized diwa                                                
        kom1=(n_omega+1)/2 
       end if 
      end if 
                                                                        
      i_angle=0 
      nn=nstorTH*2+nTH1 
      do i_theta=1,n_theta 
       theta=theta_beg+dtheta*(i_theta-1) 
       ibg_angle=i_angle+1 
       do k_omega=kom1,kom2 
        omega=omega_beg+domega*(k_omega-1) 
        if(omega.eq.0.) omega=domega/100. 
                                                                        
        if(icase.eq.1.or.icase.eq.4)then 
!        exchange of theta and omega in routine scanmode                
         grazinc=theta 
         grazout=omega 
         ratio=ar_ratio(i_theta) 
        else if(icase.eq.2.or.icase.eq.3) then 
         grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta 
         grazout=2*omega_beg+domega*(n_omega-1)+                        &
     &       (i_theta-1)*dtheta*2-grazinc                               
         if(grazout.lt.0.) then 
          Offspec=0.0 
          i_angle=i_angle+1 
          goto 776 
         end if 
         ratio=ar_ratio(i_theta) 
        else if(icase.eq.5) then 
!        PHI_s=omega N_s=n_omega                                        
         j=i_theta/2 
         if(2*j.eq.i_theta) then 
!         + dTheta_out                                                  
          grazinc=omega 
          grazout=omega+dtheta*j 
         else 
!         + dTheta_out                                                  
          grazinc=omega+dtheta*j 
          grazout=omega 
         end if 
         if(omega+dtheta*j.gt.omega_end)goto 777 
         ratio=ar_ratio(k_omega) 
        end if 
                                                                        
        i_angle=i_angle+1 
        if(n_approx.eq.0)then 
         i_approx=2 
                                                        ! dowa/diwa     
         if(grazinc.lt.grazout)i_approx=1 
        else if(n_approx.eq.1.or.n_approx.eq.4)then 
         i_approx=1 
        else if(n_approx.eq.2.or.n_approx.eq.5)then 
         i_approx=2 
        else if(n_approx.eq.3)then 
          i_approx=3 
        end if 
                                                                        
        grazinc=(grazinc+0.01)*0.001 
        grazout=(grazout+0.01)*0.001 
        Qz(i_angle)=vector_k*(cos(grazout)-cos(grazinc)) 
                                                                        
        SQ= sin(grazinc) 
        K1=-sin(grazout) 
!       write(6,'(i2,a,6g12.3)')i_angle,'=i_angle,Qz,SQ=',Qz(i_angle),SQ,vector_k
        if(b_angpairs.or.b_corr) goto 777 
        call  offspecular(i_approx,mlay,b_sites,b_domain,MAXGRP,GEOSTR,    &
                    roughlay,vkd,lay_domain,                               &
                    nstorTH1, nfourier,aFourier,rg1,g2r,nstore,nn_ne0,iall,&
                    nstrob_order,nvch,nhyperfine,nomega,                   &
                    SQ,K1,Offspec)                             

        if(n_approx.eq.0.and.i_approx.eq.2)Offspec=Offspec*ratio 
        Offspec=Offspec*srw8*eta_domain*(1.0-eta_domain) 

  776   real_fr(nn+i_angle)=Offspec 
  777   continue 
       end do          ! omega  
       if(b_angpairs.or.b_corr) goto 778 
       if(n_approx.gt.3) then 
        j=i_angle 
        do k=kom1,kom2 
         hoffspec(k)=real_fr(nn+j) 
         j=j-1 
        end do 
!        write(6,'(a,4i4)') 'kom1,kom2,j,i_angle=',kom1,kom2,j,i_angle  
!        write(6,'(6(i3,g12.3))')(k,hoffspec(k),k=kom1,kom2)            
        if(n_approx.eq.4) then 
         do k=2,kom2 
          i_angle=i_angle+1 
          real_fr(nn+i_angle)=hoffspec(k) 
         end do 
!         write(6,'(a,3i4)') 'ibg_angle=',ibg_angle                     
!         write(6,'(6g12.3)')(real_fr(nn+k),k=ibg_angle,i_angle)        
        else if(n_approx.eq.5) then 
         i_angle=j 
         do k=kom1,kom2 
          i_angle=i_angle+1 
          real_fr(nn+i_angle)=hoffspec(k) 
         end do 
!         write(6,'(a,3i4)') 'ibg_angle,i_angle=',ibg_angle,i_angle     
!         write(6,'(6(i3,g12.3))')(k,real_fr(nn+k),k=ibg_angle,i_angle) 
         do k=kom2-1,kom1,-1 
          i_angle=i_angle+1 
          real_fr(nn+i_angle)=hoffspec(k) 
         end do 
        end if 
       end if 
  778  continue 
!      write(6,'(a,3i4)') 'ibg_angle=',ibg_angle                        
!      write(6,'(6g12.3)')(real_fr(nn+k),k=ibg_angle,i_angle)           
                      ! theta                                           
      end do 
      if(b_corr)b_total=.true. 
                                                                        
      thmax=0. 
      if(.not.b_angpairs) then 
       do k=1,i_angle 
        Offspec=real_fr(nn+k)*corroff(Qz(k),lLcor_length*1.0e4) 
         if(Offspec.gt.thmax)thmax=Offspec
        real_fr(nstorTH2+k)=Offspec 
       end do 
       do k=1,i_angle 
        real_fr(nstorTH2+k)=real_fr(nstorTH2+k)/thmax 
       end do 
!       write(6,'(5f12.4)')(real_fr(nstorTH2+k),k=1,i_angle)            
                                                                        
       nTH1=real(array_fr(nstorTH)) 
       do k=i_angle+1,nTH1 
        real_fr(nstorTH2+k)=0.0 
       end do 
      end if 
                                                                        
      h1=real(array_fr(nstorTH)) 
!      write(6,'(5g15.5)')(array_fr(k),k=1,i_angle)                     
      array_fr(nstorTH)=cmplx(h1,float(i_angle)) 
 
      deallocate(aFourier,rg1,g2r)

      call cpu_time(finish) 
      print '(" runtime = ",f15.3," seconds.")',finish-start 
!############### connection to global ###########                       
 2000  continue 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
      subroutine window_function(nStrobo,Tbunch,t1,t2,S) 
      implicit none 
      integer    nStrobo,i 
      real       Tbunch,t1,t2 
      complex    S(0:32) 
      real       T2pT1,T2mT1,t1_window,t2_window,pi,pi_inv 
      complex,parameter:: CI=(0.0,1.0) 
                                                                        
!    maxSn    =                             : 10                        
!    T_bunch : the perod of the synchrotron : 176 ns                    
!    t1      : starting of the time window  :  10 ns                    
!    t2       = T_bunch-t1                  : 166 ns                    
                                                                        
        t1_window    = t1/Tbunch 
        t2_window    = t2/Tbunch 
                                                                       
        pi           = atan(1.0)*4.0 
        pi_inv       = 1.0/pi 
        T2pT1        = (t2_window+t1_window)*pi 
        T2mT1        =  t2_window-t1_window 
!                                                                       
! be careful, we want to use 2*Re[S(n)*Tr..] so                         
! S(0) is the half of the mathematical S(0) !!!!                        
!                                                                       
        S(0)         = cmplx(T2mT1,0.0)/2. 
        T2mT1        = T2mT1*pi 
                                                                        
        do i=1,nStrobo 
         S(i)= pi_inv*cmplx(cos(float(i)*T2pT1),sin(float(i)*T2pT1)) &
                            *sin(float(i)*T2mT1)/float(i)              
        end do 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine th_offspeccorrelation(isubthe,icase,iput,iget,info) 
      use glbconst, only: icstrf,ivstrf
      use comthe, only: array_fr,theoryname
      implicit none 
                                                                        
                                                                        
      integer isubthe,icase,iput,iget,info 
      real          c1,dumc,case 
      common/acmaps/c1,                                                 &
                    dumc(icstrf-1)                                      
      logical       b_c1,b_dumc 
      common/bcmaps/b_c1,                                               &
                    b_dumc(icstrf-1)                                    
      real          v1,va12,vb12,dumv 
      common/avmaps/v1,va12,vb12,dumv(ivstrf-3) 
      logical       b_v1,b_va12,b_vb12,b_dumv 
      common/bvmaps/b_v1,b_va12,b_vb12,b_dumv(ivstrf-3) 
                                                                        
                                                                        
      if(isubthe.lt.0) then 
       c1=1 
!      storage for this routine                                         
       theoryname='offspecular_correlation_matrix     v=001' 
       return 
      end if 
       call get_theory(isubthe,info) 
       case=real(array_fr(iget+1)) 
       array_fr(iput+1)=cmplx(float(icase),case) 
                                                                        
       if(.not.b_c1) then 
        isubthe=-abs(isubthe) 
        return 
       end if 
                                                                        
      return 
      END                                           
                                                                        
      subroutine th_offspeccorrelfunc(isubthe,icase,iput,iget,info) 
      use glbconst, only: icstrf,ivstrf
      use comthe, only: array_fr,theoryname
      implicit none 
                                                                        
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info                                                                 
                                                                       
      real          c1,dumc 
      common/acmaps/c1,                                                 &
     &              dumc(icstrf-1)                                      
      logical       b_c1,b_dumc 
      common/bcmaps/b_c1,                                               &
     &              b_dumc(icstrf-1)                                    
      real          v1,va12,vb12,dumv 
      common/avmaps/v1,va12,vb12,dumv(ivstrf-3) 
      logical       b_v1,b_va12,b_vb12,b_dumv 
      common/bvmaps/b_v1,b_va12,b_vb12,b_dumv(ivstrf-3) 
                                                                        
      info=0                                                                  
      if(isubthe.lt.0) then 
       c1=1 
!      storage for this routine                                         
       theoryname='offspecular_correlation_function     v=001' 
       return 
      end if 
      array_fr(iput+1)=cmplx(float(icase),0.) 
                                                                        
       if(.not.b_c1) then 
        isubthe=-abs(isubthe) 
        return 
       end if 
       if(iget.eq.0) print'(a)','pointer iget not defined for th_offspeccorrelfunc'  
      return 
      END                                           
                                                                        
                                                                        
      subroutine th_scanmode(isubthe,icase,iput,iget,info) 
      use glbconst, only: icstrf
      use comthe, only: array_fr,theoryname
      implicit none 
                                                                        
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info

      real          c1,dumc 
      common/acmaps/c1,dumc(icstrf-1) 
      logical       b_c1,b_dumc 
      common/bcmaps/b_c1, b_dumc(icstrf-1) 
                                                                        
      integer j,n_omega,n_theta,i_angle,i_theta,k_omega 
      real    omega_beg,domega,omega_end,theta_beg,dtheta,theta_end,    &
              theta_m,omega,theta                                       

       theta_m=0.   ! is nowhere calculated
       info=0
!       theoryname='offspecular_scanmode     v=001' 
!      when asking for 'theoryname's  of ysubroutines b_c1=.false.       
!      => calculations avoided                                          
      if(isubthe.lt.0) then 
       theoryname='offspecular_scanmode     v=001' 
       if(isubthe.eq.-16) return 
      end if 

       if(.not.b_c1) then 
        isubthe=-abs(isubthe) 
        return 
       end if  

!       if(iget.eq.0) print'(a)','pointer iget not defined for scanmode'      
!       write(6,'(a,5i8)')' scanmode isubthe,icase,iput,iget=',&         
!                                   isubthe,icase,iput,iget            
!       write(6,'(a)')' th_scanmode, c1,dumc'
!       write(6,'(8f10.3)')c1,(dumc(j),j=1,int(c1))
                                                                        
       if(icase.eq.1) then 
        n_omega=dumc(1) 
        omega_beg=dumc(2) 
        omega_end=dumc(3) 
        if(n_omega.gt.1) then 
         domega=(omega_end-omega_beg)/(n_omega-1) 
        else 
         domega=0. 
        end if 
        n_theta=dumc(4) 
        theta_beg=dumc(5) 
        dtheta=dumc(6) 
        if(n_theta.le.1) then 
         dtheta=0. 
         theta_end=theta_beg 
        else 
         theta_end=theta_beg+(n_theta-1)*dtheta 
        end if 
!       write(6,'(a,f12.2,5i6)')'c1,n_omega,n_theta=',c1,n_omega,n_theta
        goto 10 
       end if 
                                                                        
       if(icase.eq.2.or.icase.eq.3) then 
                                                                        
!       omega scan   (at theta_beg/2 specular reflection)               
        j=dumc(1)/2 
        n_omega=2*j+1 
        omega_beg=dumc(2) 
        n_theta=dumc(4) 
        theta_beg=dumc(5) 
        omega_end=theta_beg 
        domega=(omega_end-omega_beg)/(n_omega-1) 
        dtheta=dumc(6) 
        theta_end=theta_beg+(n_theta-1)*dtheta 
        goto 10 
       end if 
                                                                        
       n_omega=dumc(1) 
       omega_beg=dumc(2) 
       omega_end=dumc(3) 
       if(n_omega.gt.1) then 
        domega=(omega_end-omega_beg)/(n_omega-1) 
       else 
        domega=0. 
       end if 

       if(icase.eq.4) then 
        n_theta=dumc(4) 
        theta_beg=dumc(5) 
        theta_end=dumc(6) 
        if(n_theta.gt.1) then 
         dtheta=(theta_end-theta_beg)/n_theta 
        else 
         dtheta=0. 
        end if 
        goto 10 
       end if 
                                                                        
       n_theta=dumc(4) 
       theta_beg=dumc(5) 
       dtheta=dumc(6) 
       if(n_theta.le.1) then 
        dtheta=0. 
        theta_end=theta_beg 
       else 
        theta_end=theta_beg+(n_theta-1)*dtheta 
       end if 
                                                                        
       if(icase.eq.5) then 
!       scan parallel to  theta_in= theta_out (specular)                
!       PHI_s=omega N_s=n_omega, dtheta parallel shift                  

!       thco(jc+1)='n_omega         i_pos= 1  include=y    10' 
!       thco(jc+2)='omega_begin     i_pos= 2  include=y    0.1' 
!       thco(jc+3)='omega_end       i_pos= 3  include=y    13.0' 
!       thco(jc+4)='ntheta          i_pos= 4  from_data=y  3'
        if(n_theta.eq.1) then 
          dtheta=0. 
        else 
         dtheta=domega*2.0
         theta_beg=omega_beg 
         theta_end=n_theta*dtheta 
         n_theta=n_theta*2-1
        end if 
       end if 
                                                                        
   10  c1=6 
!       write(6,'(a,i4,4x,3f10.4)')                     &                
!      'n_theta,theta_beg,dtheta,theta_end=',          &              
!       n_theta,theta_beg,dtheta,theta_end                            
!      write(6,'(a,i4,4x,3f10.4)')                     &                
!       'n_omega,omega_beg,domega,omega_end=',         &               
!       n_omega,omega_beg,domega,omega_end                            

!      if isubthe<0 iput is not yet defined (iput=0)                    
!      => storage on array_fr not possible                              

!      n_omega=int(real(array_fr(l1_get0+2))) 
!      n_theta=int(aimag(array_fr(l1_get0+2))) 
!      omgtheta= n_omega.ge.n_theta 
!      omega_beg=real(array_fr(l1_get0+3)) 
!      domega=aimag(array_fr(l1_get0+3)) 
!      theta_beg=real(array_fr(l1_get0+4)) 
!      dtheta=aimag(array_fr(l1_get0+4)) 
!      omega_end=real(array_fr(l1_get0+5)) 
!      theta_end=aimag(array_fr(l1_get0+5))

       if(isubthe.gt.0) then 
        array_fr(iput+1)=cmplx(float(icase),float(icase)) 
        array_fr(iput+2)=cmplx(float(n_omega),float(n_theta)) 
        array_fr(iput+3)=cmplx(omega_beg,domega) 
        array_fr(iput+4)=cmplx(theta_beg,dtheta) 
        array_fr(iput+5)=cmplx(omega_end,theta_end) 
       end if 
                                                                        
       if(icase.le.4) then 
        i_angle=(n_theta+1)*(abs(n_omega)+1) 
        goto 20 
       end if 
                                                                        
       i_angle=0 
       do i_theta=1,n_theta 
        theta=theta_beg+dtheta*(i_theta-1) 
        do k_omega=1,n_omega 
         omega=omega_beg+domega*(k_omega-1) 
                                                                        
       if(icase.eq.5) then 
!         PHI_s=omega N_s=n_omega                                       
          j=i_theta/2 
          if(omega+dtheta*j.gt.omega_end+0.01)goto 77 
         end if 
         i_angle=i_angle+1 
   77    continue 
        end do 
       end do 
   20  c1=c1+(i_angle+1) 
!      write(6,'(a,5i6)')' iput,c1,i_angle=',iput,int(c1),i_angle       
       if(isubthe.gt.0)array_fr(iput+6)=cmplx(c1-6.,theta_m) 
      return 
    END subroutine th_scanmode
                                                                        
                                                                        
      subroutine th_oromega(isubthe,icase,iput,iget,info) 
      use glbconst, only: icstrf
      use comthe, only: theoryname
      implicit none 
                                                                        
      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info  
      real          c1,dumc 
      common/acmaps/c1,dumc(icstrf-1) 
      logical       b_c1,b_dumc 
      common/bcmaps/b_c1, b_dumc(icstrf-1) 
 
       info=0 
       theoryname='offspecular_omega     v=001' 
!      when asking for 'theoryname's  of subroutines b_c1=.false.       
!      => calculations avoided                                          
       if(.not.b_c1) then 
        isubthe=-abs(isubthe) 
        return 
       end if 
!      write(6,'(a,5i8)')' ##### oromega iput,iget=',iput,iget         
       c1=dumc(1) 
       if(icase.eq.0) print'(a)','icase not defined in str routine'  
       if(iget.eq.0) print'(a)','pointer iget not defined for th_oromega' 
       if(iput.eq.0) print'(a)','pointer iput not defined'
                                                                         
      return 
      END                                           
                                                                        
                                                                        
      subroutine ssqrt2(A,B) 
! ******************************************************************    
!                     ssqrt matrix (for 2X2)                            
! ******************************************************************    
!                                                                       
      implicit none 
!                                                                       
      complex   A(2,2),B(2,2),DetA,TrA,AA,sqDetA 
      real      imDetA
      real,parameter:: small=1e-8  
!     Khaidukov 05.10.2005                                              
      real      check_value 
!                                                                       
!       B     = sqrt(A) =[A+I*sqrt(DetA)]/sqrt[TrA+2*sqrt(DetA)]        
!                                                                       
      check_value=abs(A(1,2)*A(2,1)/(A(1,1)*A(2,2))) 
      IF (check_value.LT.small) THEN 
      ! Diagonal 
      B(1,1)=sqrt(A(1,1)) 
      B(2,2)=sqrt(A(2,2)) 
      B(1,2)=cmplx(0.,0.) 
      B(2,1)=cmplx(0.,0.) 
                                                                        
      ELSE 
        DetA  = A(1,1)*A(2,2)-A(1,2)*A(2,1) 
        sqDetA= sqrt(DetA) 
        TrA   = A(1,1)+A(2,2) 
                                                                        
      imDetA=aimag(DetA) 
      if(imDetA.gt.0.) sqDetA=-sqDetA 
      AA    = 1./sqrt(TrA+2.*sqDetA) 
      B(1,1)= (A(1,1)+sqDetA)*AA 
      B(2,2)= (A(2,2)+sqDetA)*AA 
      B(1,2)= A(1,2)*AA 
      B(2,1)= A(2,1)*AA 
      END IF 
      return 
      END                                           
                                                                        
                                                                        
     subroutine corfou_dim(mlay,MAXGRP,GEOSTR,b_domain,lay_domain,nn1)
     implicit none
     integer, intent(in) :: mlay,MAXGRP
     integer, intent(in), dimension(0:2*MAXGRP):: GEOSTR
     logical, intent(in), dimension(mlay)      :: b_domain 
     integer, intent(out):: lay_domain,nn1  

     integer classPOINTER,GRP,LMAX,LMAX1,LMIN,LMIN1,n_rep,      &
             n_rep1,n,n1,I1,L1,mu1,mu2,                         &
             i2,l,classPOINTER1,GRP1,nn,nn_ne0,nn2
                                                                        
       nn=0 
       nn1=0 
       DO mu1=1,2 
        I1=0 
        classPOINTER=0 
        do GRP=1,MAXGRP    ! loop for the groups
         LMIN =classPOINTER+1 
         LMAX =classPOINTER+GEOSTR(2*GRP) 
         n_rep=GEOSTR(2*GRP-1) 
         n=1 
         DO WHILE (n.LE.n_rep) 
          n=n+1 
          do L=LMIN,LMAX           ! L   
           if(b_domain(L)) then 
            nn1=nn1+1 
            I1=I1+1 
            !indly(nn1)=L 
            !indmu(nn1)=mu1 
            !indll(nn1)=I1 
            nn2=0 
            DO mu2=1,2 
             I2=0 
             classPOINTER1=0 
             do GRP1=1,MAXGRP      ! loop for the groups  
              LMIN1 =classPOINTER1+1 
              LMAX1 =classPOINTER1+GEOSTR(2*GRP1) 
              n_rep1=GEOSTR(2*GRP1-1) 
              n1=1 
              DO WHILE (n1.LE.n_rep1) 
               n1=n1+1 
               do L1=LMIN1,LMAX1 
                if(b_domain(L1))  then 
                 nn2=nn2+1 
                 I2=I2+1 
!--------------  All the model assumptions are in this IF-block---------
                 nn=nn+1 
!                (-1)**(I1+I2+1-delta(mu1,mu2))                         
                 IF (mod(I1+I2,2).EQ.0)then 
                  !lmu1(nn)=nn1 
                  !lmu2(nn)=nn2 
                  if(mu1.ne.mu2)then 
                  !lmu1(nn)=-nn1 
                  !lmu2(nn)=-nn2 
                  end if 
                 ELSE 
                  !lmu1(nn)=nn1 
                  !lmu2(nn)=nn2 
                  if(mu1.eq.mu2) THEN 
                  !lmu1(nn)=-nn1 
                  ! lmu2(nn)=-nn2 
                  end if 
                 END IF 
!-------------- -------------- end of IF-block ------------------------ 
                end if ! vkd(L1) > 0. and ksi(L1)>0 
               end do ! L1 
              END DO  ! n1<=n1_rep    
              classPOINTER1=classPOINTER1+GEOSTR(2*GRP1) 
             end do ! GRP1
            END DO  ! over mu2  
           endif    ! VKD(L) > 0. and ksi>0  
          end do    ! L 
         END DO       ! n<=n_rep 
         classPOINTER=classPOINTER+GEOSTR(2*GRP) 
        end do      ! GRP  
       END DO       ! over mu1  
      lay_domain=I1 
      nn_ne0=nn 
      return 
      END                                           
                                                                        
     subroutine corfou(mlay,maxl,MAXGRP,GEOSTR,b_domain,                    &
                                       indmu,indll,indly,lmu1,lmu2)         
     implicit none
     integer, intent(in) :: mlay,maxl,MAXGRP
     integer, intent(in), dimension(0:2*MAXGRP):: GEOSTR
     logical, intent(in), dimension(mlay)    :: b_domain 

     integer, intent(out),dimension(maxl)      :: indmu,indll,indly 
     integer, intent(out),dimension(maxl*maxl) :: lmu1,lmu2

     integer classPOINTER,GRP,LMAX,LMAX1,LMIN,LMIN1,n_rep,      &
             n_rep1,n,n1,I1,L1,mu1,mu2,                         &
             i2,l,classPOINTER1,GRP1,nn,nn1,nn2
                                                                        
       nn=0 
       nn1=0 
       DO mu1=1,2 
        I1=0 
        classPOINTER=0 
        do GRP=1,MAXGRP    ! loop for the groups
         LMIN =classPOINTER+1 
         LMAX =classPOINTER+GEOSTR(2*GRP) 
         n_rep=GEOSTR(2*GRP-1) 
         n=1 
         DO WHILE (n.LE.n_rep) 
          n=n+1 
          do L=LMIN,LMAX           ! L   
           if(b_domain(L)) then 
            nn1=nn1+1 
            I1=I1+1 
            indly(nn1)=L 
            indmu(nn1)=mu1 
            indll(nn1)=I1 
                                                                        
            nn2=0 
            DO mu2=1,2 
             I2=0 
             classPOINTER1=0 
             do GRP1=1,MAXGRP      ! loop for the groups  
              LMIN1 =classPOINTER1+1 
              LMAX1 =classPOINTER1+GEOSTR(2*GRP1) 
              n_rep1=GEOSTR(2*GRP1-1) 
              n1=1 
              DO WHILE (n1.LE.n_rep1) 
               n1=n1+1 
               do L1=LMIN1,LMAX1 
                if(b_domain(L1))  then 
                 nn2=nn2+1 
                 I2=I2+1 
!--------------  All the model assumptions are in this IF-block---------
                 nn=nn+1 
!                (-1)**(I1+I2+1-delta(mu1,mu2))                         
                 IF (mod(I1+I2,2).EQ.0)then 
                  lmu1(nn)=nn1 
                  lmu2(nn)=nn2 
                  if(mu1.ne.mu2)then 
                   lmu1(nn)=-nn1 
                   lmu2(nn)=-nn2 
                  end if 
                 ELSE 
                  lmu1(nn)=nn1 
                  lmu2(nn)=nn2 
                  if(mu1.eq.mu2) THEN 
                   lmu1(nn)=-nn1 
                   lmu2(nn)=-nn2 
                  end if 
                 END IF 
!-------------- -------------- end of IF-block ------------------------ 
                end if ! vkd(L1) > 0. and ksi(L1)>0 
               end do ! L1 
              END DO  ! n1<=n1_rep    
              classPOINTER1=classPOINTER1+GEOSTR(2*GRP1) 
             end do ! GRP1
            END DO  ! over mu2  
           endif    ! VKD(L) > 0. and ksi>0  
          end do    ! L 
         END DO       ! n<=n_rep 
         classPOINTER=classPOINTER+GEOSTR(2*GRP) 
        end do      ! GRP  
       END DO       ! over mu1  
      return 
      END                                           
                                                                        
                                                                        
     subroutine Gamma_mju(dowa,nstorTH1,nfourier,aFourier,rg1,g2r,    &
                          nstore,nn_ne0,                              &
                      iall,nstrob_order,nvch,nhyperfine,nomega,Offspec)        
     use glbconst, only: maxfr1,maxfr2,maxn,maxscrd
     use comthe, only: array_fr
     implicit none 
                                                                       
     logical, intent(in):: dowa 
     integer, intent(in):: nstorTH1,nfourier,nstore,nn_ne0,iall,      &
                           nstrob_order,nvch,nhyperfine,nomega 
     complex, intent(in), dimension(nfourier):: aFourier 
     real,   intent(out):: Offspec 
     complex, dimension(4,-maxn*4:maxn*4):: rg1,g2r
                                                                       
     integer   iposlayav,iposlay,ichstr,ichall,indmu,indll,indly,      &
               lmu1,lmu2                                
     real      eta,wi,trace,dumscrd 
     real      ap0,ap1,ap2,bp0,bp1,bp2,cp0,cp1,cp2,dx1,dx2,dx3 
                                                                        
     complex   chilay,SQRO,Sexpa,cmat,sFourier
     integer,parameter::idumscrd=maxscrd-11*maxfr2-3-5*maxn-           &
                         maxfr2*maxfr2*2-66-24-12*96,      &
                         maxn4=4*maxn                                 
     common/scrd/ichall(0:maxn*2),iposlay(maxfr2,2),ichstr(0:maxn),    &
               indmu(maxfr2),indll(maxfr2),indly(maxfr2),              &
               lmu1(maxfr2*maxfr2),lmu2(maxfr2*maxfr2),                &
               eta(maxfr2),wi(maxfr2,2),                               &
               trace(-maxn:maxn),                                      &
               iposlayav(maxfr2),chilay(maxfr2),                       &
               SQRO(4),Sexpa(0:32),cmat(4),sFourier(4),                &
               dumscrd(idumscrd),                                      &
               ap0(0:95),ap1(0:95),ap2(0:95),                          &
               bp0(0:95),bp1(0:95),bp2(0:95),                          &
               cp0(0:95),cp1(0:95),cp2(0:95),                          &
               dx1(0:95),dx2(0:95),dx3(0:95)

     integer   i,icht,ii,ij,j,ka,k0,k1,k2,ll1,lay1,mu1,ll2,lay2,mu2,   &
               mcht,np,nn,neg,nstrob,np1,np2,lmu1nn,lmu1sig,           &
               lmu2nn,lmu2sig,nst,ipos1,ipos2             
     real      ap,bp,cp,hsit,det,x0,x1,x2,hh,h1,h2,pcr,pci 
                                                                       
     complex   hc,B(4) 
!      complex   forout,store                                           
!      dimension forout(4,-maxn:maxn),store(-maxn:maxn),ncht(4)         
!         open(unit=8,file='ch8.dat'                                    
!     &            ,status='unknown'                                    
!     &            ,access='sequential'                                 
!     &            ,form='formatted')                                   
                                                                        
!       call cpu_time(start)                                            
!       write(6,'(10i6)')(ichall(ka),ka=0,iall)                         
!       write(6,'(a,10i6)')'Ga iall,ichall(iall)=',iall,ichall(iall)    
!        nna=796                                                        
        mu1=0 
        lay1=0 
        ll1=0 
!       write(6,'(a,5i6)')'nstorTH1,nstorTH1+nstore=',nstorTH1,nstorTH1+nstore
        do i=nstorTH1+1,nstorTH1+nstore 
         array_fr(i)=(0.,0.) 
        end do 
                                                                        
        do nn=1,nn_ne0 
         lmu1nn=lmu1(nn) 
         lmu1sig=1 
         if(lmu1nn.lt.0)then 
           lmu1sig=-1 
           lmu1nn=-lmu1nn 
         end if 
         lmu2nn=lmu2(nn) 
           lmu2sig=1 
         if(lmu2nn.lt.0)then 
           lmu2sig=-1 
           lmu2nn=-lmu2nn 
         end if 
                                                                        
         mu2=indmu(lmu2nn) 
         lay2=indly(lmu2nn) 
         ll2=indll(lmu2nn) 
         np2=8*(iall+1)*(ll2-1) 
         ipos2=iposlay(lay2,mu2) 
                                                                        
!        -------------lmu1-------------------                           
         if(mu1.eq.indmu(lmu1nn).and.                                   &
     &      lay1.eq.indly(lmu1nn).and.ll1.eq.indll(lmu1nn)) goto 10     
                                                                        
         mu1=indmu(lmu1nn) 
         lay1=indly(lmu1nn) 
         ll1=indll(lmu1nn) 
         np1=8*(iall+1)*(ll1-1) 
         ipos1=iposlay(lay1,mu1) 
                                                                        
         hh=wi(lay1,mu1) 
         DO ka=0,iall 
          ii=ichall(ka) 
          do neg=-1,1,2 
                                                                        
           np=ipos1+8*ii+(neg+1)*2 
!          change from effi- to Fortran convention                      
!          effi (1 3)  to fortran  ( 1 3 )                              
!               (4 2)              ( 2 4 )                              
           if(dowa)then 
            Cmat(1)=conjg(array_fr(np+1)*hh) 
            Cmat(4)=conjg(array_fr(np+2)*hh) 
            Cmat(3)=conjg(array_fr(np+4)*hh) 
            Cmat(2)=conjg(array_fr(np+3)*hh) 
           else 
            Cmat(1)=array_fr(np+1)*hh 
            Cmat(4)=array_fr(np+2)*hh 
            Cmat(3)=array_fr(np+3)*hh 
            Cmat(2)=array_fr(np+4)*hh 
           end if 
           np=np1+8*ka+(neg+1)*2 
           do i=1,4 
            sFourier(i)=aFourier(np+i) 
           end do 
           B(1)=Cmat(1)*sFourier(1)+Cmat(3)*sFourier(2) 
           B(2)=Cmat(2)*sFourier(1)+Cmat(4)*sFourier(2) 
           B(3)=Cmat(1)*sFourier(3)+Cmat(3)*sFourier(4) 
           B(4)=Cmat(2)*sFourier(3)+Cmat(4)*sFourier(4) 
!          g2r=(G_mju)*sqrt(rho)                                        
!          (11 12)  ( 1 3 )      column fortran convention C= A*B       
!          (21 22)  ( 2 4 )                                             
!          g2r(4,-maxn:maxn)    symmetric                               
                                                                        
           if(dowa)then 
            hc=B(2) 
            B(1)=conjg(B(1)) 
            B(2)=conjg(B(3)) 
            B(3)=conjg(hc) 
            B(4)=conjg(B(4)) 
           end if 
           i=-neg*ii 
           g2r(1,i)=B(1)*SQRO(1)+B(3)*SQRO(2) 
           g2r(2,i)=B(2)*SQRO(1)+B(4)*SQRO(2) 
           g2r(3,i)=B(1)*SQRO(3)+B(3)*SQRO(4) 
           g2r(4,i)=B(2)*SQRO(3)+B(4)*SQRO(4) 
          end do  ! neg=-1,1,2 
         END DO   ! ka=0,iall    
   10    continue 
!        -------------lmu2-------------------                           
!        write(6,'(a,5i6)')'nn,mu2,lay2,ll2,np2=',nn,mu2,lay2,ll2,np2   
         hh=wi(lay2,mu2) 
         DO ka=0,iall 
          ii=ichall(ka) 
          do neg=-1,1,2 
                                                                        
           np=ipos2+8*ii+(neg+1)*2 
           if(dowa)then 
            Cmat(1)=conjg(array_fr(np+1)*hh) 
            Cmat(4)=conjg(array_fr(np+2)*hh) 
            Cmat(3)=conjg(array_fr(np+4)*hh) 
            Cmat(2)=conjg(array_fr(np+3)*hh) 
           else 
            Cmat(1)=array_fr(np+1)*hh 
            Cmat(4)=array_fr(np+2)*hh 
            Cmat(3)=array_fr(np+3)*hh 
            Cmat(2)=array_fr(np+4)*hh 
           end if 
           np=np2+8*ka+(neg+1)*2 
           do i=1,4 
            sFourier(i)=aFourier(np+i) 
           end do 
                                                                        
           B(1)=Cmat(1)*sFourier(1)+Cmat(3)*sFourier(2) 
           B(2)=Cmat(2)*sFourier(1)+Cmat(4)*sFourier(2) 
           B(3)=Cmat(1)*sFourier(3)+Cmat(3)*sFourier(4) 
           B(4)=Cmat(2)*sFourier(3)+Cmat(4)*sFourier(4) 
                                                                        
!          rg1=sqrt(rho)*(G_mju)+                                       
           if(.not.dowa)then 
            hc=B(2) 
            B(1)=conjg(B(1)) 
            B(2)=conjg(B(3)) 
            B(3)=conjg(hc) 
            B(4)=conjg(B(4)) 
           end if 
!          C=A*B                                                        
           i=-neg*ii 
           rg1(1,i)=SQRO(1)*B(1)+SQRO(3)*B(2) 
           rg1(2,i)=SQRO(2)*B(1)+SQRO(4)*B(2) 
           rg1(3,i)=SQRO(1)*B(3)+SQRO(3)*B(4) 
           rg1(4,i)=SQRO(2)*B(3)+SQRO(4)*B(4) 
                                                                        
          end do  ! neg=-1,1,2  
         END DO   ! ka=0,iall        
                                                                        
         nst=nstorTH1+1 
         hsit=0. 
         DO nstrob=0,nstrob_order 
          ij=nstrob*nomega/2 
                                                                        
          mcht=ij+nhyperfine 
          do i=0,mcht 
           ichstr(i)=i 
          end do 
          do i=1,nvch 
           ichstr(mcht+i)=mcht+i*(i+1)/2 
          end do 
          icht=mcht+nvch 
                                                                        
          pcr=real(Sexpa(nstrob))*2.0*lmu1sig 
          pci=aimag(Sexpa(nstrob))*2.0*lmu1sig 
          DO ka=0,icht 
           ii=ichstr(ka) 
           i=ii+ij 
           j=ii-ij 
           hc=rg1(1,i)*g2r(1,j)+rg1(3,i)*g2r(2,j)+                      &
             rg1(2,i)*g2r(3,j)+rg1(4,i)*g2r(4,j)                       
           h1=pcr*real(hc)-pci*aimag(hc) 
           i=-ii+ij 
           j=-ii-ij 
           hc=rg1(1,i)*g2r(1,j)+rg1(3,i)*g2r(2,j)+                      &
             rg1(2,i)*g2r(3,j)+rg1(4,i)*g2r(4,j)                       
           h2=pcr*real(hc)-pci*aimag(hc) 
           array_fr(nst+ka)=array_fr(nst+ka)+cmplx(h1,h2) 
          END DO 
          nst=nst+icht+1 
         END DO    ! nstrob=0,nstrob_order   
        end do     ! nn=1,nn_ne0 
        nst=nstorTH1+1 
        offspec=0. 
        DO nstrob=0,nstrob_order 
         ij=nstrob*nomega/2 
!         write(6,'(a,2g15.5)')'  Sexpa=',Sexpa(nstrob)                 
         mcht=ij+nhyperfine 
         do i=0,mcht 
          ichstr(i)=i 
         end do 
         do i=1,nvch 
          ichstr(mcht+i)=mcht+i*(i+1)/2 
         end do 
         icht=mcht+nvch 
                                                                        
         trace(0)=real(array_fr(nst)) 
         DO ka=1,icht 
          trace(ka)=real(array_fr(nst+ka)) 
          trace(-ka)=aimag(array_fr(nst+ka)) 
         END DO 
                                                                        
!         if(nstrob.ge.1.and.nstrob.le.4) then                          
!           ncht(nstrob)=icht                                           
!          DO ka=-icht,icht                                             
!            forout(nstrob,ka+icht+1)=trace(ka)                         
!          end do                                                       
!         end if                                                        
         nst=nst+icht+1 
                                                                        
!        loop over equidistant channels                                 
         hh=0. 
          do i=-mcht+1,mcht-1,2 
          hh=hh+trace(i)*2 
         end do 
         do i=-mcht+2,mcht-2,2 
          hh=hh+trace(i) 
         end do 
         hh=(hh*2.0+trace(-mcht)+trace(mcht))/3.0 
!       if(mcht.ne.iall)then                                            
         do i=1,nvch                   ! -ichstr(icht-i+2)=+ichstr(-icht
          x0 =-ichstr(icht-i+2) 
          x1 =-ichstr(icht-i+1) 
          x2 =-ichstr(icht-i) 
          ap0(i)= (x1-x2) 
          ap1(i)=-(x0-x2) 
          ap2(i)= (x0-x1) 
          bp0(i)=-(x1**2-x2**2) 
          bp1(i)= (x0**2-x2**2) 
          bp2(i)=-(x0**2-x1**2) 
          cp0(i)= (x1-x2)*x1*x2 
          cp1(i)=-(x0-x2)*x0*x2 
          cp2(i)= (x0-x1)*x0*x1 

          det=x0**2*ap0(i)+x0*bp0(i)+cp0(i) 
          dx3(i)=(x2**3-x0**3)/3./det 
          dx2(i)=-bp1(i)/2./det 
          dx1(i)=ap1(i)/det 
         end do 
         dx1(0)=0.0; dx2(0)=0.0; dx3(0)=0.0;                                                               

!         do i=2,nvch,2 
         do i=1,nvch,2 
          k0 =-(icht-i+2) 
          k1 =-(icht-i+1) 
          k2 =-(icht-i) 
          ap= trace(k0)*ap0(i)+trace(k1)*ap1(i)+trace(k2)*ap2(i) 
          bp= trace(k0)*bp0(i)+trace(k1)*bp1(i)+trace(k2)*bp2(i) 
          cp= trace(k0)*cp0(i)+trace(k1)*cp1(i)+trace(k2)*cp2(i) 
          hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i) 
         end do 

!         do i=0,nvch-2                                                                         
         do i=0,nvch-1 
          x0 =ichstr(i+mcht) 
          x1 =ichstr(i+mcht+1) 
          x2 =ichstr(i+mcht+2) 
          ap0(i)= (x1-x2) 
          ap1(i)=-(x0-x2) 
          ap2(i)= (x0-x1) 
          bp0(i)=-(x1**2-x2**2) 
          bp1(i)= (x0**2-x2**2) 
          bp2(i)=-(x0**2-x1**2) 
          cp0(i)= (x1-x2)*x1*x2 
          cp1(i)=-(x0-x2)*x0*x2 
          cp2(i)= (x0-x1)*x0*x1 
                                                                        
          det=x0**2*ap0(i)+x0*bp0(i)+cp0(i) 
          dx3(i)=(x2**3-x0**3)/3./det 
          dx2(i)=-bp1(i)/2./det 
          dx1(i)=ap1(i)/det 
         end do 
                                                                        
!         do i=0,nvch-2,2 
         do i=0,nvch-1,2 
          k0=(mcht+i) 
          k1=(mcht+i+1) 
          k2=(mcht+i+2) 
          ap= trace(k0)*ap0(i)+trace(k1)*ap1(i)+trace(k2)*ap2(i) 
          bp= trace(k0)*bp0(i)+trace(k1)*bp1(i)+trace(k2)*bp2(i) 
          cp= trace(k0)*cp0(i)+trace(k1)*cp1(i)+trace(k2)*cp2(i)
          hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i) 
         end do 
         Offspec=Offspec+hh 
        END DO    ! nstrob=0,nstrob_order  
       return 
      END                                           
                                                                        
!    Correlation function of susceptibilities in  layers                
      real function corroff(Qz,ksi) 
      implicit none 
      real     ksi,Qz
      real,parameter::pi2=6.283185 
      corroff=ksi**2*pi2/(sqrt(1.0+(Qz*ksi)**2))**3 
      return 
      END                                           
                                                                        
     subroutine offspecular(i_approx,mlay,b_sites,b_domain,MAXGRP,&
                            GEOSTR,roughlay,vkd,lay_domain,            &
                            nstorTH1,nfourier,aFourier,rg1,g2r,nstore,nn_ne0,  &
                            iall,nstrob_order,nvch,nhyperfine,nomega,  &
                            SQ,K1,Offspec)                             
     use glbconst, only: maxfr2,maxn,maxscrd
     use comthe, only: array_fr
     implicit none 
                                                                       
     logical, intent(in), dimension(mlay):: b_sites,b_domain 
     integer, intent(in), dimension(0:2*mlay):: GEOSTR
     integer, intent(in):: i_approx,mlay,MAXGRP,lay_domain,nstorTH1,nfourier,&
               nstore,nn_ne0,iall,nstrob_order,nvch,nhyperfine,nomega  
     real(kind=8), intent(in),dimension(mlay):: vkd,roughlay
     real(kind=8), intent(in):: SQ,K1 
     complex, dimension(nfourier):: aFourier 
     real,   intent(out):: Offspec 
     complex, dimension(4,-maxn*4:maxn*4):: rg1,g2r

     integer   iposlayav,iposlay,ichstr,ichall,indmu,indll,indly,      &
               lmu1,lmu2                               
     real      eta,wi,trace,dumscrd 
     complex   chilay,chi_lay,                                 &
               SQRO,Sexpa,cmat,sFourier,                               &
               Fourier,Cmatav,cmat2,hc                                 
     complex(kind=8):: Rmatrix,Kmatrix,Fouphase
     dimension  Rmatrix(2,2),Kmatrix(2,2,maxfr2),Fouphase(maxfr2) 
     integer,parameter::idumscrd=maxscrd-3-5*maxn-11*maxfr2-           &
                        maxfr2*maxfr2*2-16-66-24-8*maxfr2, &
                         maxn4=4*maxn
     complex(kind=8),parameter:: C0=(0.d0,0.d0)                  
     common/scrd/ichall(0:maxn*2),iposlay(maxfr2,2),ichstr(0:maxn),    &
               indmu(maxfr2),indll(maxfr2),indly(maxfr2),              &
               lmu1(maxfr2*maxfr2),lmu2(maxfr2*maxfr2),                &
               eta(maxfr2),wi(maxfr2,2),                               &
               trace(-maxn:maxn),                                      &
               iposlayav(maxfr2),chilay(maxfr2),                       &
               SQRO(4),Sexpa(0:32),cmat(4),sFourier(4),                &
               Fourier(2,2,maxfr2),                                    &
               Cmatav(4),cmat2(4),dumscrd(idumscrd)                    

     integer  i,lay,ll,ka,jj,npos,ni,neg 
     logical   dowa 
!     n_approx=1   i_approx=1  diwa                                    
!     n_approx=2   i_approx=2  dowa                                    
!     n_approx=3   i_approx=3  Born approximation /diwa                
                                                                        
        dowa=.false. 
        if(i_approx.eq.2) dowa=.true. 
        do ka=0,iall 
         jj=ichall(ka) 
         do neg=-1,1,2 
          npos=8*jj+(neg+1)*2 
          do lay=1,mlay 
           if(b_domain(lay))then 
            ni=iposlayav(lay)+npos 
                                                                        
            array_fr(ni+3)=dcmplx(0.0D0,0.0D0) 
            array_fr(ni+4)=dcmplx(0.0D0,0.0D0) 
                                                                        
            do i=1,4 
             Cmatav(i)=array_fr(ni+i) 
!            if(lay.eq.1)forout(i,neg*jj)=array_fr(ni+i)                
            end do 
                                                                        
            chi_lay=chilay(lay) 
            if(dowa) then 
             hc=Cmatav(3) 
             Cmatav(1)=conjg(Cmatav(1)) 
             Cmatav(3)=conjg(Cmatav(4)) 
             Cmatav(4)=conjg(hc) 
             Cmatav(2)=conjg(Cmatav(2)) 
             chi_lay=conjg(chilay(lay)) 
            end if 
!           th_22index storage mode                                     
            Kmatrix(1,1,lay)=Cmatav(1) 
            Kmatrix(1,2,lay)=Cmatav(3) 
            Kmatrix(2,1,lay)=Cmatav(4) 
            Kmatrix(2,2,lay)=Cmatav(2) 
           else 
            Kmatrix(1,1,lay)=chi_lay 
            Kmatrix(1,2,lay)=dcmplx(0.0D0,0.0D0) 
            Kmatrix(2,1,lay)=dcmplx(0.0D0,0.0D0) 
            Kmatrix(2,2,lay)=chi_lay 
           end if 
          end do 
                                                                        
          if(dowa) then 
           call opticN(mlay,b_sites,MAXGRP,GEOSTR,-K1,                  &
                     Kmatrix,roughlay,vkd,Rmatrix)                     

           call inv2(Rmatrix,Rmatrix) 
           call g_field(mlay,b_sites,b_domain,MAXGRP,GEOSTR,            &
                                K1,SQ,Kmatrix,                          &
                  roughlay,vkd,Rmatrix,lay_domain,Fourier)             
          else 
           call opticN(mlay,b_sites,MAXGRP,GEOSTR,SQ,                   &
                     Kmatrix,roughlay,vkd,Rmatrix)                     
                                                                        
           if(i_approx.eq.1)then 
            call g_field(mlay,b_sites,b_domain,MAXGRP,GEOSTR,           &
                                SQ,K1,Kmatrix,                          &
                  roughlay,vkd,Rmatrix,lay_domain,Fourier)             
           else 
            call g_phase(mlay,lay_domain,MAXGRP,GEOSTR,b_domain,        &
                           vkd,K1-SQ,Fouphase)                         
            do ll=1,lay_domain 
             Fourier(1,1,ll)=Fouphase(ll) 
             Fourier(2,2,ll)=Fouphase(ll) 
             Fourier(1,2,ll)=C0 
             Fourier(2,1,ll)=C0 
            end do 
           end if 
          end if 
!         Fourier are only calculated for the point jj and stored       
!         one by one ka=0,iall in groups of 2*4 for +-ka   
          do ll=1,lay_domain 
           ni=8*(iall+1)*(ll-1)+8*ka+(neg+1)*2 
!          stored with fortran convention (later sFourier(1-4))         
           aFourier(ni+1)=Fourier(1,1,ll) 
           aFourier(ni+2)=Fourier(2,1,ll) 
           aFourier(ni+3)=Fourier(1,2,ll) 
           aFourier(ni+4)=Fourier(2,2,ll) 
          end do 
         end do    ! ii=0,4,4 
        end do     ! ka=iall
 
        call Gamma_mju(dowa,nstorTH1,nfourier,AFourier,rg1,g2r,nstore,nn_ne0, &
                       iall,nstrob_order,nvch,nhyperfine,nomega,Offspec)        
        return 
      END                                           
                                                                        
!***********************************************************************
       subroutine g_field(mlay,b_Cm,b_domain,MAXGRP,GEOSTR,             &
     &                                            SQ,K1,Kmatrix,        &
     &                   roughlay,VKD,Rmatrix,lay_domain,Tmatrix)       
                                                                        
!      Subroutine calculates Fourier transformation of the field (expers
!      2.12 in the article). Result is stored in Tmatrix.               
!      Size of the Tmatrix is 2*2*i, where i - Number of the layer with 
!      (pay attention)                                                  
!***********************************************************************
      implicit none 
!     input:                                                            
      integer, intent(in):: mlay,MAXGRP,GEOSTR,lay_domain 
      complex    Tmatrix 
      complex(kind=8):: Rmatrix,Kmatrix 
      real(kind=8)   :: SQ,K1,roughlay,VKD 
      logical    b_Cm,b_domain 
      dimension  b_Cm(mlay),b_domain(mlay),GEOSTR(0:2*MAXGRP),          &
                 Kmatrix(2,2,mlay),roughlay(mlay),                      &
     &           VKD(mlay),Rmatrix(2,2),Tmatrix(2,2,lay_domain)         
!   other variables:                                                    
      integer    I,J,L,n_rep,GRP,LMIN,LMAX,POINTER,I_D,NLOG 
      real       absCmatr 
      complex(kind=8):: M(4,4),ML(4,4),MS(4,4),KL(2,2),               &
                        A(2,2),B(2,2),T(2,2)                                   
      logical    b_odz,b_grp 
!********* Variables added by Khaidukov for neutron case*******         
      integer    Lprev,Lnext,n 
      logical    prev_dgnl,both_dgnl,both_NONdgnl 
      complex(kind=8):: KLprev(2,2) 
      real(kind=8)::    DabsMatr,z1,z2,DL 
!**************************************************************         
      complex(kind=8),parameter::C0=(0.D0,0.D0), C1=(1.D0,0.D0),       &
                                 CI=(0.D0,1.D0) 
!     To set the characteristic matrix to unit matrix                   
    M=C0
    do I=1,4 
     M(I,I) =C1 
    end do 
                                                                      
    I_D=0 
    POINTER=0 
    z1=0.0D0  ! First  
    z2=0.0D0  ! and the second coordinate for each layer 
    do GRP=1,MAXGRP      ! loop for the groups 
     MS=C0
     do I=1,4 
      MS(I,I)=C1 
     end do 
                                                                      
     b_grp=.false. 
     LMIN =POINTER+1 
     LMAX =POINTER+GEOSTR(2*GRP) 
     n_rep=GEOSTR(2*GRP-1) 
!-----------------------------------------------------------------    
     DO n=1,n_rep 
      ML=C0                                                                
      do I=1,4 
       ML(I,I)=C1 
      end do 
                                                                      
      do L=LMIN,LMAX 
       if(VKD(L).gt.0)then 
        b_odz=.not.b_Cm(L) 
        b_grp=.true. 
        DL=VKD(L) 
        if(DL.lt.0.d0)DL=1.0d30 
        z2=z1+DL 
                                                                      
        KL(1,1)=Kmatrix(1,1,L) 
        KL(1,2)=Kmatrix(1,2,L) 
        KL(2,1)=Kmatrix(2,1,L) 
        KL(2,2)=Kmatrix(2,2,L) 
        absCmatr=dreal(KL(1,2)*conjg(KL(1,2))+KL(2,1)*conjg(KL(2,1))) 
                                                                      
        if(absCmatr.lt.1.e-15) then 
         b_odz=.true. 
        end if 
        IF (b_domain(L)) THEN  
        !If there are b_domains in this layer store inform      
         call trans(SQ,KL,Rmatrix,M,A,B) 
         call analytic_fourier(z1,z2,SQ,K1,KL,A,B,T) 
         I_D=I_D+1 
         Tmatrix(1,1,I_D)=T(1,1) 
         Tmatrix(1,2,I_D)=T(1,2) 
         Tmatrix(2,1,I_D)=T(2,1) 
         Tmatrix(2,2,I_D)=T(2,2) 
        END IF    ! b_domain 
        call genM(b_odz,SQ,DL,KL,M) 
!-------------------- Roughness---------------------------------------
        IF (roughlay(L).GT.0.1) THEN 
         if (n_rep.GT.1.and.L.eq.Lmin) then 
          Lprev=Lmax 
         else 
          Lprev=L-1 
         end if 
         if(n_rep.GT.1.and.L.eq.LMAX) then 
          Lnext=LMIN 
         else 
          Lnext=L+1 
          if(Lnext.gt.mlay) Lnext=mlay 
         end if 
         DO I=1,2 
          DO J=1,2 
           IF (Lprev.EQ.0) THEN 
            KLprev(I,J)=C0 
            prev_dgnl=.true. 
           END IF 
           IF (Lprev.GT.0) THEN 
            KLprev(I,J)=Kmatrix(I,J,Lprev) 
            prev_dgnl=.not.b_Cm(Lprev) 
           ENDIF 
          END DO 
         END DO 
         DabsMatr=(KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+&
                (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1)))
         IF (prev_dgnl.and.b_odz) then 
          both_dgnl   =.true. 
          both_NONdgnl=.false. 
         ELSEIF (DabsMatr.lt.1.d-15) then 
          both_dgnl   =.true. 
          both_NONdgnl=.false. 
         ELSEIF (.not.prev_dgnl.and..not.b_odz) then 
          both_dgnl   =.false. 
          both_NONdgnl=.true. 
         ELSE 
          both_dgnl   =.false. 
          both_NONdgnl=.false. 
         ENDIF 
!        --------------------------------------------------------     
!        both_dgnl=.false.             !DONT FORGET TO REMOVE!!!!           
!        both_NONdgnl=.true.              !Deak's roughness           
!        --------------------------------------------------------     
         call roughness(both_dgnl,both_NONdgnl,roughlay(L),           &
                        roughlay(Lnext),SQ,KLprev,KL,M)                
        END IF  !Roughness 
!--------------------end of Roughness-----------------------------    
        call mat4(M,ML,ML)                                            
        call mat4(ML,MS,M)                                            
       end if                                                          
       z1=z2                                                          
      end do                                                          
                                                                        
      if(n_rep.gt.1.and.b_grp)then                                    
       if(n.gt.1)then                                                 
        do I=1,4                                                      
         do J=1,4                                                     
          M(I,J)=ML(I,J)                                              
         end do                                                       
        end do                                                        
       end if                                                         
                                                                        
       NLOG=alog(float(n))/alog(2.0)                                  
       do I=1,NLOG                                                    
        call mat4(ML,ML,ML)                                           
       end do                                                         
                                                                        
       do I=1,n-2**NLOG                                               
        call mat4(M,ML,ML)                                            
       end do                                                         
       MS=ML
       M=ML
      end if                                                          
     END DO                                                           
                                                                        
     POINTER=POINTER+GEOSTR(2*GRP)                                    
    end do                                                            
                                                                        
    return                                                            
    END                                           
                                                                        
                                                                        
      subroutine trans(QD,KL,R,L,A,B) 
! Calculation of the 2x2 A and B matrixes - amplitudes of wave on the   
! upper border                                                          
!                                                                       
! ******************************************************************    
      implicit none 
      real(kind=8)   :: QD 
      complex(kind=8):: KL(2,2),R(2,2),L(4,4) 
      complex(kind=8):: A(2,2),B(2,2) 
      complex(kind=8):: L11(2,2),L12(2,2), L21(2,2),L22(2,2),           &
                        RM(2,2),RP(2,2),A1(2,2),A2(2,2),                &
                        C1(2,2),C2(2,2),C1P(2,2),C2P(2,2),              &
                        C1M(2,2),C2M(2,2)                                      
      real(kind=8):: QD2 
      integer    I,J 
      QD2=QD*QD 
!    Definition of 2x2 block matrices L21, L22 and                      
!    the 2x2 I-R and I+R matrices                                       
                                                                        
      do I=1,2 
       do J=1,2 
        L11(I,J)= 0.5D0*L(I,J) 
        L12(I,J)= 0.5D0*L(I,J+2) 
        L21(I,J)= 0.5D0*L(I+2,J) 
        L22(I,J)= 0.5D0*L(I+2,J+2) 
        RM(I,J) = -R(I,J) 
        RP(I,J) =  R(I,J) 
       end do 
       RM(I,I)  =  1.D0-R(I,I) 
       RP(I,I)  =  1.D0+R(I,I) 
      end do 
!Now Lij are block matrixes already divided by 2, Rm=1-R, Rp=1+R        
                                   !                                    
      A1(1,1)=(KL(1,1)/QD2)+1.D0 
      A1(1,2)= KL(1,2)/QD2 
      A1(2,1)= KL(2,1)/QD2 
      A1(2,2)=(KL(2,2)/QD2)+1.D0 
      call sqrt2(A1,A2) 
      A2(1,1)=-A2(1,1) 
      A2(1,2)=-A2(1,2) 
      A2(2,1)=-A2(2,1) 
      A2(2,2)=-A2(2,2) 
                                                                        
      call inv2(A2,A1) 
      call mat2(A1,L11,C1) 
      call mat2(A1,L12,C2) 
      do I=1,2 
       do J=1,2 
        C1P(I,J)=L21(I,J)+C1(I,J) 
        C1M(I,J)=L21(I,J)-C1(I,J) 
        C2P(I,J)=L22(I,J)+C2(I,J) 
        C2M(I,J)=L22(I,J)-C2(I,J) 
       end do 
      end do 
      call mat2(C1P,RM,C1) 
      call mat2(C2P,RP,C2) 
      call mat2(C1M,RM,A1) 
      call mat2(C2M,RP,A2) 
      do I=1,2 
       do J=1,2 
        B(I,J)=C1(I,J)+C2(I,J) 
        A(I,J)=A1(I,J)+A2(I,J) 
       end do 
      end do 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
! **********************************************************************
      subroutine analytic_fourier(z1,z2,QD,K1,KL,A,B,T) 
! ySubroutines calculate integral (exp(ikz)*A+exp(-ikz)B)*exp(-ik'z)dz   
! in the interval from z1 to z2                                         
! **********************************************************************
      implicit none 
      real(kind=8)   :: z1,z2,QD,K1 
      complex(kind=8):: KL(2,2),A(2,2),B(2,2) 
      complex(kind=8):: T(2,2) 
      complex(kind=8):: bconst,iz1,iz2,DM1(2,2),K(2,2),DMA(2,2),     & 
                        DMB(2,2),DMAA(2,2),DMBB(2,2),iz21            
      complex(kind=8),parameter:: CI=(0.0D0,1.0D0),C1=(1.D0,0.D0) 
      real(kind=8)   :: Kz2 
      integer           I,J 
      complex(kind=8):: phase_of_A(2,2),phase_of_B(2,2) 
                                                                        
      iz1 =CI*z1 
      iz2 =CI*z2 
      iz21=iz2-iz1 
      bconst=-CI/2.50662827D0*exp(-iz1*K1) 
      Kz2=QD*QD 
                                                                        
      DM1(1,1)=KL(1,1)+Kz2 
      DM1(1,2)=KL(1,2) 
      DM1(2,1)=KL(2,1) 
      DM1(2,2)=KL(2,2)+Kz2 
      call sqrt2(DM1,K) 
!-----------REMOVE ADDITIONAL PHASES FROM AMPLITUDES A and B            
!       A->A*exp(-ikz1)  B->B*exp(ikz1)                                 
                                                                        
      DO I=1,2 
       DO J=1,2 
        DMA(I,J)=K(I,J) 
      DMB(I,J)=K(I,J) 
       END DO 
       DMA(I,I)= -K1+K(I,I) 
       DMB(I,I)= -K1-K(I,I) 
      END DO 
                                                                        
      DO I=1,2 
       DO J=1,2 
        phase_of_A(I,J)= iz21*DMA(I,J) 
        phase_of_B(I,J)= iz21*DMB(I,J) 
       END DO 
      END DO 
      call exp2(phase_of_A) 
      call exp2(phase_of_B) 
      DO I=1,2 
       phase_of_A(I,I)=phase_of_A(I,I)-C1 
       phase_of_B(I,I)=phase_of_B(I,I)-C1 
      END DO 
      call mat2(phase_of_A,A,A) 
      call mat2(phase_of_B,B,B) 
      call inv2(DMA,DMAA) 
      call inv2(DMB,DMBB) 
      call mat2(DMAA,A,DMA) 
      call mat2(DMBB,B,DMB) 
                                                                        
      DO I=1,2 
       DO J=1,2 
        T(I,J)=(DMA(I,J)+DMB(I,J))*bconst 
       END DO 
      END DO 
                                                                        
      return 
      END                                           
