      subroutine thstr_hdeq(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     hyperfine parameters of H(j),DEQ(j), equivalent sites             
!     for n_ik(E) refraction index (static)                             
!     level 3 theory                                                    
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth
      character(len=4)  :: cova

      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='22ref.index(stat)-H DEQ' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='H(S_E),DEQ, equivalent sites' 
       namepg(1)='H_DEQ_equivalent_sites  plrs,1 ' 
       nameth(2)='H(S_C),DEQ, equivalent sites' 
       namepg(2)='H_DEQ_equivalent_sites  plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (static,sad)' 
       ntheory(2)='2x2 refraction index (width,static,sad)' 
       ntheory(3)='2x2 refraction index (static)' 
       ntheory(4)='2x2 rho-source selfabsorption (homogeneous distr)'
       ntheory(5)='2x2 rho-source selfabsorption (diffusion profile)'
       ntheory(6)='2x2 rho-source selfabsorption matrix(Delta distr)'
       ntheory(7)='2x2 rho-source selfabsorption matrix(diffusion profile)'
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(7))l_jth=2 
       return 
      end if 
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth 
!      list=5 introduces  8 constants                                 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
      thco(jc+1)='sym_case    i_pos=1    include=y   0' 
               ! equivalent sites by rotation around the z-axis         
      thco(jc+2)='time_invers  i_pos=2   include=y   0' 
               ! equivalent sites by rotation around the y-axis         
      jc=jc+2 
                                                                        
!      common/avsstrf/avss,                                             
!                      sftr,aisom,w_Gauss,w_Lorentz                     
!     &                sx2zz,sx2eta,sx2phi,sx2theta,sx2psi,             
!     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE          
                                                                        
                                                                        
!                    123456789012345678901234567                        
      ntrmt(jm+1)='H_internal  matrix=(3,3)   include=[n] ' 
      ctrmt(jm+1)='internal magnetic field at crystal site' 
       thpa(jp+1)='Hi               , 333.0  0.0 0.0  1.0' 
       thpa(jp+2)='thetaH           , 0.0 0.0 0.0   1.0' 
       thpa(jp+3)='phiH             , 0.0 0.0 0.0   1.0 ' 
       thvr(jv+1)='Hi                      1    1 0 0  ' 
       thvr(jv+2)='thetaH                  2    0 1 0 ' 
       thvr(jv+3)='phiH                    3    0 0 1' 
                                                                        
      ntrmt(jm+2)='EFG   matrix=(2,2)   include=[n] ' 
      ctrmt(jm+2)='electric field gradient tensor at crystal site' 
       thpa(jp+4)='EFG              , 0.0  0.0 0.0  0.1' 
       thpa(jp+5)='eta              , 0.0  0.0 0.0  0.1' 
       thvr(jv+4)='EFG                     4    1 0 ' 
       thvr(jv+5)='eta                     5     0 1 ' 
                                                                        
      ntrmt(jm+3)='orient_EFG   matrix=(3,3)   include=[n] ' 
      ctrmt(jm+3)='Euler angle of the EFG in the crystal system' 
       thpa(jp+6)='phiE            , 0.0  0.0 0.0  1.0' 
       thpa(jp+7)='thetaE          , 0.0 0.0 0.0   1.0' 
       thpa(jp+8)='psiE            , 0.0 0.0 0.0   1.0 ' 
       thvr(jv+6)='phiE                    6   1 0 0' 
       thvr(jv+7)='thetaE                  7   0 1 0' 
       thvr(jv+8)='psiE                    8   0 0 1 ' 
      jm=jm+3 
      jp=jp+8 
      jv=jv+8 
      cova='02_8'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_hdeqf(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     hyperfine parameters of H(j),DEQ(j), equivalent sites             
!     for n_ik(E) refraction index (static),                            
!     powder,texture and external field                                 
!     level 3 theory                                                    
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      character(len=4)  :: cova

      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='22ref.index(stat)-H DEQ f' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='H(S_E),DEQ,f(S_C), equiv. sites'  ! H in S_efg 
       namepg(1)='H_DEQ_f_equivalent_sites  plrs,1 ' 
       nameth(2)='H(S_C),DEQ,f(S_C), equiv. sites'  ! H in S_C
       namepg(2)='H_DEQ_f_equivalent_sites  plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (static,f_anisotrop,sad)' 
       ntheory(2)='2x2 refraction index (Lwidth,f_anisotrop,sad)'
       ntheory(3)='2x2 refraction index (Gwidth,f_anisotrop,sad)'
       ntheory(4)='2x2 refraction index (static,f_anisotrop)' 
       ntheory(5)='2x2 refraction index (Lwidth,f_anisotrop)' 
       ntheory(6)='2x2 rho-source selfabsorption (Delta distr)' 
       ntheory(7)='2x2 rho-source selfabsorption (diffusion profile)' 
       ntheory(8)='2x2 rho-source selfabsorption matrix(diffusion profile)'
                                                                       
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(8)) l_jth=2
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth 
!      8 constants from list=5                                          
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 

      thco(jc+1)='sym_case  i_pos=1    include=y   0' 
               ! equivalent sites by rotation around the z-axis         
       thco(jc+2)='time_invers  i_pos=2 include=y   0' 
               ! equivalent sites by rotation around the y-axis         
       jc=jc+2 
                                                                        
!      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,                
!                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,              
!     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE          
!                     123456789012345678901234567                       
       ntrmt(jm+1)='x2sanisotropy  matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='mean square <x2> at the site' 
        thpa(jp+1)='dsx2                  ,  0.0  0.0 0.0  0.1' 
        thpa(jp+2)='x2seta                ,  0.0  0.0 0.0  0.1' 
        thvr(jv+1)='dsx2                     1    1 0  ' 
        thvr(jv+2)='x2seta                   2    0 1  ' 
                                                                        
       ntrmt(jm+2)='x2sorientation  matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='<x2> orientation with respect to S_C for' 
        thpa(jp+3)='x2sphi                , 0.0  0.0 0.0  1.0' 
        thpa(jp+4)='x2stheta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='x2spsi                , 0.0  0.0 0.0  1.0' 
        thvr(jv+3)='x2sphi                   3    1 0 0 ' 
        thvr(jv+4)='x2stheta                 4    0 1 0 ' 
        thvr(jv+5)='x2spsi                   5    0 0 1 ' 
                                                                        
       ntrmt(jm+3)='H_internal  matrix=(3,3)   include=[n]' 
       ctrmt(jm+3)='internal magnetic field at crystal site' 
        thpa(jp+6)='Hi               , 333.0  0.0 0.0  1.0' 
        thpa(jp+7)='thetaH           , 0.0 0.0 0.0   1.0' 
        thpa(jp+8)='phiH             , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+6)='Hi                       6    1 0 0  ' 
        thvr(jv+7)='thetaH                   7    0 1 0 ' 
        thvr(jv+8)='phiH                     8    0 0 1' 
       jm=jm+3 
       jp=jp+8 
       jv=jv+8 
       ntrmt(jm+1)='EFG    matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='electric field gradient tensor at crystal site' 
        thpa(jp+1)='EFG              , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='eta              , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='EFG                      9     1 0 ' 
        thvr(jv+2)='eta                      10    0 1 ' 
                                                                        
       ntrmt(jm+2)='orient_EFG    matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='Euler angle of the EFG in the crystal system' 
        thpa(jp+3)='phiE            , 0.0  0.0 0.0  1.0' 
        thpa(jp+4)='thetaE          , 0.0 0.0 0.0   1.0' 
        thpa(jp+5)='psiE            , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+3)='phiE                    11   1 0 0' 
        thvr(jv+4)='thetaE                  12   0 1 0' 
        thvr(jv+5)='psiE                    13   0 0 1' 
       jm=jm+2 
       jp=jp+5 
       jv=jv+5 
       cova='_213'
       call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           

                                                     
      subroutine thstr_hdeqfRELAX(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     hyperfine parameters of 2 times H(j),DEQ(j), equivalent sites             
!     for n_ik(E) refraction index,                            
!     powder,texture and external field                                 
!     level 3 theory                                                    
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      character(len=4)  :: cova

      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='22ref-index(RELAX) H-DEQ-f' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='H(S_E),DEQ,f(S_C), 2 state relaxation'  ! H in S_efg 
       namepg(1)='H_DEQ_f_RELAX_equivalent_sites  plrs,1 ' 
       nameth(2)='H(S_E),DEQ, 2 state relaxation (powder)'  ! H in S_efg 
       namepg(2)='H_DEQ_f_RELAX_equivalent_sites  plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 ref_index 2 state relaxation(f,sad)' 

!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1)) l_jth=2
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth 
!      8 constants from list=5                                          
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='sym_case  i_pos=1    include=y   0' 
               ! equivalent sites by rotation around the z-axis         
       thco(jc+2)='time_invers  i_pos=2 include=y   0' 
               ! equivalent sites by rotation around the y-axis         
       jc=jc+2 
                                                                        
!      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,                
!                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,              
!     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE          
!                     123456789012345678901234567                       
       ntrmt(jm+1)='relative_shift  matrix=(1,1)    include=[n]' 
       ctrmt(jm+1)='relative shift of the two states' 
        thpa(jp+1)='shift12              0.00  0.0 0.0  0.1' 
        thvr(jv+1)='shift12                   1    1 0  ' 

       ntrmt(jm+2)='probability  matrix=(2,2)         include=[n]' 
       ctrmt(jm+2)='probabilities of the two fluctuating state ' 
        thpa(jp+2)='pop_state1              0.00  0.0 0.0  0.1' 
        thpa(jp+3)='w12                     0.00  0.0 0.0  0.1' 
        thvr(jv+2)='pop1                       2    1 0  ' 
        thvr(jv+3)='w12                        3    0 1  ' 
       jm=jm+2 
       jp=jp+3 
       jv=jv+3 
       if(l_jth.eq.1)then
       ntrmt(jm+1)='sx_1anisotropy  matrix=(2,2)   include=[n]'
       else
       ntrmt(jm+1)='sx_1anisotropy  matrix=(2,2)   include=n'
       end if 
       ctrmt(jm+1)='mean square <xx> at the site' 
        thpa(jp+1)='dsx_1                   0.00  0.0 0.0  0.1' 
        thpa(jp+2)='sxeta_1                 0.00  0.0 0.0  0.1' 
        thvr(jv+1)='dsx_1                    4    1 0  ' 
        thvr(jv+2)='sxeta_1                  5    0 1  ' 
       if(l_jth.eq.1)then
       ntrmt(jm+2)='s_1orientation  matrix=(3,3)   include=[n]' 
       else
       ntrmt(jm+2)='s_1orientation  matrix=(3,3)   include=n' 
       end if                                                                         
       ntrmt(jm+2)='s_1orientation  matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='<xx> orientation with respect to S_C for' 
        thpa(jp+3)='sxphi_1               0.0  0.0 0.0  1.0' 
        thpa(jp+4)='sxtheta_1             0.0  0.0 0.0  1.0' 
        thpa(jp+5)='sxpsi_1               0.0  0.0 0.0  1.0' 
        thvr(jv+3)='sxphi_1                6    1 0 0 ' 
        thvr(jv+4)='sxtheta_1              7    0 1 0 ' 
        thvr(jv+5)='sxpsi_1                8    0 0 1 ' 
                                                                        
       ntrmt(jm+3)='H_1internal  matrix=(3,3)   include=[n]' 
       ctrmt(jm+3)='internal magnetic field at crystal site' 
        thpa(jp+6)='Hi_1                 333.0  0.0 0.0  1.0' 
        thpa(jp+7)='thetaH_1               0.0  0.0 0.0   1.0' 
        thpa(jp+8)='phiH_1                 0.0  0.0 0.0   1.0 ' 
        thvr(jv+6)='Hi_1                   9     1 0 0  ' 
        thvr(jv+7)='thetaH_1               10    0 1 0 ' 
        thvr(jv+8)='phiH_1                 11    0 0 1' 
       jm=jm+3 
       jp=jp+8 
       jv=jv+8 
       ntrmt(jm+1)='EFG_1    matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='electric field gradient tensor at crystal site' 
        thpa(jp+1)='EFG_1               0.0  0.0 0.0  0.1' 
        thpa(jp+2)='eta_1               0.0  0.0 0.0  0.1' 
        thvr(jv+1)='EFG_1                12     1 0 ' 
        thvr(jv+2)='eta_1                13    0 1 ' 
                                                                        
       ntrmt(jm+2)='orientEFG_1    matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='Euler angle of the EFG in the crystal system' 
        thpa(jp+3)='phiE_1              0.0  0.0 0.0  1.0' 
        thpa(jp+4)='thetaE_1            0.0 0.0 0.0   1.0' 
        thpa(jp+5)='psiE_1              0.0 0.0 0.0   1.0 ' 
        thvr(jv+3)='phiE_1                14   1 0 0' 
        thvr(jv+4)='thetaE_1              15   0 1 0' 
        thvr(jv+5)='psiE_1                16   0 0 1' 
       jm=jm+2 
       jp=jp+5 
       jv=jv+5 
       ntrmt(jm+1)='sx_2anisotropy  matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='mean square <xx> at the site' 
        thpa(jp+1)='dsx_2                   0.00  0.0 0.0  0.1' 
        thpa(jp+2)='sxeta_2                 0.00  0.0 0.0  0.1' 
        thvr(jv+1)='dsx_2                    17    1 0  ' 
        thvr(jv+2)='sxeta_2                  18    0 1  ' 
                                                                        
       ntrmt(jm+2)='sx_2orientation  matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='<xx> orientation with respect to S_C for' 
        thpa(jp+3)='sxphi_2               0.0  0.0 0.0  1.0' 
        thpa(jp+4)='sxtheta_2             0.0  0.0 0.0  1.0' 
        thpa(jp+5)='sxpsi_2               0.0  0.0 0.0  1.0' 
        thvr(jv+3)='sxphi_2                19    1 0 0 ' 
        thvr(jv+4)='sxtheta_2              20    0 1 0 ' 
        thvr(jv+5)='sxpsi_2                21    0 0 1 ' 
                                                                        
       ntrmt(jm+3)='H_2internal  matrix=(3,3)   include=[n]' 
       ctrmt(jm+3)='internal magnetic field at crystal site' 
        thpa(jp+6)='Hi_2                 333.0  0.0 0.0  1.0' 
        thpa(jp+7)='thetaH_2               0.0  0.0 0.0   1.0' 
        thpa(jp+8)='phiH_2                 0.0  0.0 0.0   1.0 ' 
        thvr(jv+6)='Hi_2                    22    1 0 0  ' 
        thvr(jv+7)='thetaH_2                23    0 1 0 ' 
        thvr(jv+8)='phiH_2                  24    0 0 1' 
       jm=jm+3 
       jp=jp+8 
       jv=jv+8 
       ntrmt(jm+1)='EFG_2    matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='electric field gradient tensor at crystal site' 
        thpa(jp+1)='EFG_2               0.0  0.0 0.0  0.1' 
        thpa(jp+2)='eta_2               0.0  0.0 0.0  0.1' 
        thvr(jv+1)='EFG_2                25     1 0 ' 
        thvr(jv+2)='eta_2                26    0 1 ' 
                                                                        
       ntrmt(jm+2)='orientEFG_2    matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='Euler angle of the EFG in the crystal system' 
        thpa(jp+3)='phiE_2              0.0  0.0 0.0  1.0' 
        thpa(jp+4)='thetaE_2            0.0 0.0 0.0   1.0' 
        thpa(jp+5)='psiE_2              0.0 0.0 0.0   1.0 ' 
        thvr(jv+3)='phiE_2                27   1 0 0' 
        thvr(jv+4)='thetaE_2              28   0 1 0' 
        thvr(jv+5)='psiE_2                29   0 0 1' 
       jm=jm+2 
       jp=jp+5 
       jv=jv+5 
       cova='_229'
       call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_hyperfineft(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     hyperfine parameters of H(j),DEQ(j), equivalent sites             
!     for n_ik(E) refraction index (static),                            
!     powder,texture and external field                                 
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth 
      character(len=4) :: cova
 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='2x2_index_f_spinham' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='DEQ spin Hamiltonian'                !  in S_C 
       namepg(1)='DEQ_H_spinham_equiv_sites plrs,1 ' 
       nameth(2)='DEQ spin Hamiltonian, 2 hyp_fields'  !  in S_C  
       namepg(2)='DEQ_H_spinham_equiv_sites plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (f,t,spinham,sad)' 
       ntheory(2)='2x2 refraction index (f,t,spinham)' 
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(2))l_jth=2 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth 
!      8 constants from list=5                                          
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='sym_case  i_pos=1    include=y   0' 
               ! equivalent sites by rotation around the z-axis         
       jc=jc+1 
                                                                        
!      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,                
!                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,              
!     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE          
                                                                        
       ntrmt(jm+1)='x2sanisotropy    matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='mean square <x2> at the site' 
        thpa(jp+1)='dsx2                  ,  0.0  0.0 0.0  0.1' 
        thpa(jp+2)='x2seta                ,  0.0  0.0 0.0  0.1' 
        thvr(jv+1)='dsx2                     1    1 0  ' 
        thvr(jv+2)='x2seta                   2    0 1  ' 
                                                                        
       ntrmt(jm+2)='x2sorientation   matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='<x2> orientation with respect to S_C for' 
        thpa(jp+3)='x2sphi                , 0.0  0.0 0.0  1.0' 
        thpa(jp+4)='x2stheta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='x2spsi                , 0.0  0.0 0.0  1.0' 
        thvr(jv+3)='x2sphi                   3    1 0 0 ' 
        thvr(jv+4)='x2stheta                 4    0 1 0 ' 
        thvr(jv+5)='x2spsi                   5    0 0 1 ' 
       jm=jm+2 
       jp=jp+5 
       jv=jv+5 
       cova='_1_5'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           


      subroutine thstr_rhoSingleLine(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,ntrmt,ctrmt,thpa,thvr
      implicit none 
!     hyperfine parameters of singlet, doublet, and sextet              
!     for scalar n(E) refraction index (static)                         
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth  
      character(len=4) :: cova 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Single_polarized_Line' 
!      names for child theories , mthchild=3 <= max_nth                 
       nameth(1)='single polarized line' 
       namepg(1)='Single_polarized_Line    plrs,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 single polarized line (sad)' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
!      common/avssptrf/ avssp,                                          
!     &                 intensity,shift,                                
!     &                 avss(19),fr_int(8),pos(8)     ! 34              
                                                                        
      ntrmt(jm+1)='Poincare_vector   matrix=(3,3) include=y' 
      ctrmt(jm+1)='(3) Poincare vector of the Synchrotron beam' 
       thpa(jp+1)='P_xsi             , 1.0  0.0 1.0  0.05' 
       thpa(jp+2)='P_eta             , 0.0  0.0 0.0   0.05' 
       thpa(jp+3)='P_zeta            , 0.0  0.0 0.0   0.05' 
       thvr(jv+1)='P_xsi                    1      1 0 0' 
       thvr(jv+2)='P_eta                    2      0 1 0' 
       thvr(jv+3)='P_zeta                   3      0 0 1' 
      jm=jm+1 
      jp=jp+3
      jv=jv+3
       cova='co03'
                                                                        
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                       
      return 
      END                                           
                                                                        
