      subroutine frstr_stroboscopy(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      use comstr, only: ntheory,nstruct,istruct,strcmt,ndev,        &
                        thco,ntrmt,ctrmt,thpa,thvr 
      implicit none
      integer,intent(in):: l_nfrtheo,lstruct1,lstruct2
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      character(len=8) :: chth 
      character(len=4) :: cova 
      integer   jc,jv,jm,jp,number_device 
                                                                        
       if(cmch.eq.'name') then 
!####################################################                   
       nhelpentry  ='Mossbauer stroboscopy' 
       ntheory(1)='Mossbauer synchrotron stroboscopy' 
       ntheory(2)=' '
       
       ndev(1)='reference absorber' 
       ndev(2)='scatterer' 
       ndev(3)=' '
!####################################################                   
       return 
      end if 
                                                                        
      chth='fr'//nhelpentry(1:6) 
      goto(200,300)number_device(lstruct1) 
!-----------------------------------------------------------------------
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb  list=4   chth='//chth 
       !  Fe_wavelength 
      return 
      end if 
      cova='cova'
                                                                  
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
      nhelpentry='theory/'//chth(1:6)//'ex' 
!-----------------------------------------------------------------------
!     variables of frame theory: sample, reference absorber             
!      common block is compatible with subroutine drive                 
!      common/avstrf/avsp,                                              
!     &              amplitude,base,dum2,v_max,channel_v0,v_max1,channel_v01, 
!     &              v_max2,channel_v02,v_max3,channel_v03,geo,     
!     &              ang_shift,P0,Pxsi,Peta,Pzeta,PA0,PAxsi,PAeta,PAzeta
!     dum1=f_factor, dum2=bg_fraction                                   
!     geo is used in subroutine drive. geo=0 for synchrotron radiation  
!     is defined in fr_syncrotron.                                      
                                                                        
!     trans-Matrix   name                  dimension                    
       if(l_nfrtheo.eq.1) then 
        strcmt(1)='absorber_reference      n_set=[fs]  2 0' 
        strcmt(2)='name for the spectrum ' 
        strcmt(3)='not used ' 
        strcmt(4)='theory/'//chth//'/absorber_reference/go' 
        strcmt(5)='theory/'//chth//'/sample/layer/structure' 
       end if 
                                                                        
       if(l_nfrtheo.eq.2) then 
        strcmt(1)='scatterer_reference    n_set=gr 2  0' 
        strcmt(2)='name for the spectrum ' 
        strcmt(3)='not used  ' 
        strcmt(4)='theory/'//chth//'/scatterer_reference/go' 
        strcmt(5)='theory/'//chth//'/scatterer/layer/structure' 
       end if 
                                                                        
      ntrmt(jm+1)='baseline    matrix=(2,2)   include= y' 
      ctrmt(jm+1)='(2) parameter base and amplitude ' 
       thpa(jp+1)='base             100000.0  0.0 0.0 10.0'     ! para b
       thpa(jp+2)='amplitude             1.0  0.0 0.0 10.0'     
       thvr(jv+1)='base                 2    , 1 0 '            ! variab
       thvr(jv+2)='amplitude            1    , 0 1 '              
      jm=jm+1 
      jp=jp+2 
      jv=jv+2 
!                 1        0         012345                             
      ntrmt(jm+1)='calibration    matrix=(2,2)   from_data=[n]' 
      ctrmt(jm+1)='(2) variables for calibration v_max,channel_v0' 
       thpa(jp+1)='v_max             ,  16.0   0.0 0.0 0.05 ' 
       thpa(jp+2)='channel_v0        ,  128.0  0.0 0.0 0.1 '   ! channel 
       thvr(jv+1)='v_max                   4     , 1 0' 
       thvr(jv+2)='channel_v0              5     , 0 1 ' 
                                                                        
      ntrmt(jm+2)='non_linearity     matrix=(6,6) include=[n]' 
      ctrmt(jm+2)='(4) non linearity parameters for calibration' 
       thpa(jp+3)='vmax1            , 0.0   0.0 0.0 0.05 ' 
       thpa(jp+4)='vphase1          , 128.0  0.0 0.0 0.1 ' 
       thpa(jp+5)='vmax2            , 0.0   0.0 0.0 0.05 ' 
       thpa(jp+6)='vphase2          , 128.0  0.0 0.0 0.1 ' 
       thpa(jp+7)='vmax3            , 0.0   0.0 0.0 0.05 ' 
       thpa(jv+8)='vphase3          , 128.0  0.0 0.0 0.1 ' 
       thvr(jv+3)='vmax1                    6    1 0 0 0 0 0 ' 
       thvr(jv+4)='vphase1                  7    0 1 0 0 0 0 ' 
       thvr(jv+5)='vmax2                    8    0 0 1 0 0 0 ' 
       thvr(jv+6)='vphase2                  9    0 0 0 1 0 0 ' 
       thvr(jv+7)='vmax3                   10    0 0 0 0 1 0 ' 
       thvr(jv+8)='vphase3                 11    0 0 0 0 0 1 ' 
      jm=jm+2 
      jp=jp+8 
      jv=jv+8 
      ntrmt(jm+1)='Poincare_vector   matrix=(3,3) from_data=[y]' 
      ctrmt(jm+1)='(3) Poincare vector of the Synchrotron beam' 
       thpa(jp+1)='P_xsi             , 1.0  0.0 1.0  0.05' 
       thpa(jp+2)='P_eta             , 0.0  0.0 0.0   0.05' 
       thpa(jp+3)='P_zeta            , 0.0  0.0 0.0   0.05' 
       thvr(jv+1)='P_xsi                    15      1 0 0' 
       thvr(jv+2)='P_eta                    16      0 1 0' 
       thvr(jv+3)='P_zeta                   17      0 0 1' 
      jm=jm+1 
      jp=jp+3
      jv=jv+3 
      ntrmt(jm+1)='Poincare_an   matrix=(4,4) from_data=[y]' 
      ctrmt(jm+1)='(4) Poincare vector of the analyser' 
       thpa(jp+1)='PA0               , 1.0  0.0 1.0  0.05' 
       thpa(jp+2)='PAxsi             , 0.0  0.0 1.0  0.05' 
       thpa(jp+3)='PAeta             , 0.0  0.0 0.0   0.05' 
       thpa(jp+4)='PAzeta            , 0.0  0.0 0.0   0.05' 
       thvr(jv+1)='PA0                      18     1 0 0 0' 
       thvr(jv+2)='PAxsi                    19     0 1 0 0' 
       thvr(jv+3)='PAeta                    20     0 0 1 0' 
       thvr(jv+4)='PAzeta                   21     0 0 0 1 ' 
      jm=jm+1 
      jp=jp+4 
      jv=jv+4 
      ntrmt(jm+1)='calibration   matrix=(1,1) from_data=[y]' 
      ctrmt(jm+1)='(1) variable ang_shift' 
       thpa(jp+1)='ang_shift         , 0.0 0.0 0.0 0.1' 
       thvr(jv+1)='ang_shift                13     1  ' 
      jm=jm+1 
      jp=jp+1 
      jv=jv+1 
      cova='__21'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
!-----------------------------------------------------------------------
!      sample                                                           
!      common/cfr1trf/pfr1,Hext,thetaHe,phiHe,phi,theta,psi             
  300 continue
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
      if(lstruct2.gt.0) goto 310                                                                   
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
      ntrmt(jm+1)='H_extern      matrix=(3,3)   include=[n]' 
      ctrmt(jm+1)='external magnetic field (lab) at the sample' 
       thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
       thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
       thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
       thvr(jv+1)='Hext                     2    1 0 0  ' 
       thvr(jv+2)='thetaHe                  3    0 1 0 ' 
       thvr(jv+3)='phiHe                    4    0 0 1' 
      jm=jm+1 
      jp=jp+3 
      jv=jv+3 
      cova='__4_'                                                                  
      if(l_nfrtheo.eq.2) then 
                                                                        
       strcmt(1)='scatterer_layer  n_device=[sr] mijk=po;sw;an [1]  1' 
       strcmt(2)='name of layer (cover,sandwich,substrate)' 
       strcmt(3)='number of layers of the scatterer ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/scatterer/layer/structure' 
      else 
       strcmt(1)='sample_layer   n_device=[ab] mij=po;an [1]  1' 
       strcmt(2)='name of layer (polarizer,analyser)' 
       strcmt(3)='number of layers of the sample' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/sample/layer/structure' 
                                                                        
       ntrmt(jm+1)='orientation    matrix=(3,3)   include=[n]' 
       ctrmt(jm+1)='orientation of the sample in the LAB' 
        thpa(jp+1)='phi              , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='theta            , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='psi              , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='phi                     5    1 0 0' 
        thvr(jv+2)='theta                   6    0 1 0' 
        thvr(jv+3)='psi                     7    0 0 1' 
       jm=jm+1 
       jp=jp+3 
       jv=jv+3 
       cova='__7_'                                                                         
      end if 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
!                ---------------------------------------------          
  310 continue 
!     first variable is not counted in the definition                   
!     it containes the number of variable in the common block           
                                                                        
!      common/acfr2trf/acfr2,                                           
!                      rep_grp                                          
!      common/avfr2trf/avfr2,                                           
!                      thicklay,re_chilay,ai_chilay,roughness,          
                                                                        
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       ntrmt(jm+1)='thickn_lay     matrix=(1,1)   include= y' 
       ctrmt(jm+1)='thickness of the layer' 
        thpa(jp+1)='thicklay        , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='thicklay                1    1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
                                                                        
      if(l_nfrtheo.eq.2) then 
       thco(jc+1)='rep.grp         i_pos=1   include= y   1.1 ' 
                ! layer belongs to a group which repeat with period     
       thco(jc+2)='iset_powder     i_pos=2   include= n   0 ' 
                ! iset=1-6 for 4-128 points on 1/48 of the sphere       
       thco(jc+3)='isymmetry       i_pos=3   include= n   10 ' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)          
       thco(jc+4)='n_psi_powder    i_pos=4  include= n  0' 
                ! 3rd Euler angle, rotation around S_lab(z)             
                ! neccessary if Hext not parallel S_lab(z)     
       jc=jc+4
                                                                        
                                                                        
       ntrmt(jm+1)='chi_electronic  matrix=(2,2)   include= y' 
       ctrmt(jm+1)='chi_electronic of the layer  ' 
        thpa(jp+1)='r_chilay        , -14.5 0.0 0.0  0.1' 
        thpa(jp+2)='i_chilay        ,   0.7 0.0 0.0  0.1' 
        thvr(jv+1)='r_chilay                2    1 0' 
        thvr(jv+2)='i_chilay                3    0 1' 
                                                                        
       ntrmt(jm+2)='roughness   matrix=(1,1)   include=[n]' 
       ctrmt(jm+2)='roughness of the layer  ' 
        thpa(jp+3)='roughness        , 0.0  0.0 0.0  0.1' 
        thvr(jv+3)='roughness               4    1 ' 
       jm=jm+2 
       jp=jp+3  
       jv=jv+3 
       cova='_4_4'                                                                 
       strcmt(1)='scatterer_layer    n_cmpt=[s]  [1] 0' 
       strcmt(2)='one letter for name of the site ' 
       strcmt(3)='number of inequivalent sites of the scatterer layer' 
       strcmt(4)='distribution of parameters of site number' 
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites' 
      else if(l_nfrtheo.eq.1) then 
                                                                        
       thco(jc+1)='iset_powder     i_pos=2    include=[n]  0 ' 
                ! iset=1-6 for 4-128 points on 1/48 of the sphere       
       thco(jc+2)='isymmetry       i_pos=3    include=[n] 10 ' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)          
       thco(jc+3)='n_psi_powder    i_pos=4  include= n  0' 
                ! 3rd Euler angle, rotation around S_lab(z)             
                ! neccessary if Hext not parallel S_lab(z)     
       jc=jc+3 
       cova='_4_1'                                                                 
       strcmt(1)='sample_layer       n_cmpt=[s]  [1] 1' 
       strcmt(2)='one letter for name of the site ' 
       strcmt(3)='number of inequivalent sites of the sample layer' 
       strcmt(4)='distribution of parameters of site number' 
       strcmt(5)='theory/'//chth//'/sample/layer/sites' 
      end if 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
!-----------------------------------------------------------------------
!     reference-absorber                                                
!      common/cfr1trf/afr1,                                             
!                     pfr1,Hext,thetaHe,phiHe,phi,theta,psi             
  200 continue
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
      if(lstruct2.gt.0) goto 210 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
      ntrmt(jm+1)='H_extern    matrix=(3,3)   include=[n]' 
      ctrmt(jm+1)='external magnetic field (lab) at the ref-absorber' 
       thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0' 
       thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0' 
       thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 ' 
       thvr(jv+1)='Hext                     2    1 0 0  ' 
       thvr(jv+2)='thetaHe                  3    0 1 0 ' 
       thvr(jv+3)='phiHe                    4    0 0 1' 
                                                                        
      ntrmt(jm+2)='orientation   matrix=(3,3)   include=[n]' 
      ctrmt(jm+2)='orientation of the ref-absorber in the LAB' 
       thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0' 
       thpa(jp+5)='xtheta           , 0.0 0.0 0.0   1.0' 
       thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 ' 
       thvr(jv+4)='phi                      5     1 0 0' 
       thvr(jv+5)='theta                    6     0 1 0' 
       thvr(jv+6)='psi                      7     0 0 1' 
      jm=jm+2 
      jp=jp+6 
      jv=jv+6 
      cova='___7'                                               
      strcmt(1)='reference_layer  n_device=[RF] 1  1' 
      strcmt(2)='name of  reference_layer' 
      strcmt(3)='number of layers of the reference absorber ' 
      strcmt(4)='distribution of parameters at sites of the layer' 
      strcmt(5)='theory/'//chth//'/layer/ref-absorber' 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
                                                                        
  210 continue 
!     first variable is not counted in the definition                   
!     it containes the number of variable in the common block           
                                                                        
!      common/avfr2trf/avfr2,                                           
!                      thicklay                                         
                                                                        
       call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       ntrmt(jm+1)='thickn_lay   matrix=(1,1)   include= y' 
       ctrmt(jm+1)='thickness of the layer' 
        thpa(jp+1)='thicklay        , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='thicklay                1    1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
       cova='___1'                                               
      strcmt(1)='reference_absorber     n_cmpt=[s]  [1] 1' 
      strcmt(2)='one letter for the site of the reference_absorber' 
      strcmt(3)='number of inequivalent sites of the ref-absorber' 
      strcmt(4)='distribution of parameters of site number' 
      strcmt(5)='theory/'//chth//'/reference/layer/sites' 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
      subroutine thstr_synstrob(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory
      implicit none  
!     case time domain spectrum,                                        
!          time integral - rocking curve                                
!          prompt - rocking curve                                       
!     for  Synchrotron reflection                                       
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
                                                                         
      if(cmch.eq.'name')then 
       nhelpentry='Mossbauer synchrotron stroboscopy (distribute)' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='Stroboscopy in transmission' 
       nameth(2)='Stroboscopy in reflection' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Mossbauer synchrotron stroboscopy' 
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=2 

      return 
      end if 
      END                                           
                                                                        
      subroutine thstr_synstrobtrans(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,thco
      implicit none
!     time domain spectrum for synchrotron transmission                 
!     level 0 theory                                                    
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
      character(len=8):: chth 

      integer   jc,jv,jm,jp
                                                                        
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='stroboscopic transmission (distribute)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='stroboscopic transmission spectrum' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Stroboscopy in transmission' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=1   chth='//chth 
       return 
      end if 
                                                                        
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!-----------------------------------------------------------------------
!       common/acstrf/acsp,                                             
!                     wavelength,uthick_w,                           2  
!      &              dum,unitchi,channels,v_range,                     
!      &              th_channels,th_sampling,drive_mode,channels_vmax, 
!      &              Tbunch,flag_basis                                 
!                     nStrobo,t1_window,t2_window                       
                                                                        
!      uthick_A,unitchi are not used                                    
!-------------------------------------------------------                
!                name                    pos  default                   
       thco(jc+1)='th_channels    i_pos=5    include= y   64' 
                   ! theory is calculated at th_channels                 
       thco(jc+2)='n_sampling     i_pos=6    include= y   3 ' 
                   ! density of theoretical points for interpolation
       thco(jc+3)='v_range        i_pos=4    include= y   6.00 ' 
                   ! velocity range of sample spectrum                  
       thco(jc+4)='nu_channels    i_pos=3 from_data= y  512 ' 
                 ! channel number of the spectrum                       
       thco(jc+5)='channels_vmax  i_pos=8 from_data=[y]  128  ' 
                 ! period of the drive unit                             
       thco(jc+6)='drive_mode     i_pos=7 from_data= y  1 ' 
                 ! 1,4 triangular,   2,5 sinus   
                 ! determines channel to velocity function/data structure     
       thco(jc+7)='T_bunch         i_pos=9   from_data=[y]  8 ' 
       thco(jc+8)='flag_basis      i_pos=10  include= y  1 ' 
                 ! switch for circular-linear basis                     
       thco(jc+9)='flag_phase      i_pos=11  include= y  0 ' 
                 ! switch for normal(0), real part(1), imaginary part(-1)
       jc=jc+9 
       call convarmatpar('11__',jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
      subroutine thstr_synstrobrefl(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none

      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
      character(len=8):: chth 
      character(len=4):: cova

      integer   jc,jv,jm,jp
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='stroboscopic reflection (distribute)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='stroboscopic reflection spectrum' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Stroboscopy in reflection' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=1,2   chth='//chth 
       ! Fe_uthick_w, Fe_uthick_A 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!-----------------------------------------------------------------------
!       common/acstrf/acsp,wavelength,uthick_w,uthick_A,               !
!      &              unitchi,channels,v_range,                         
!      &              th_channels,th_sampling,drive_mode,channels_vmax, 
!      &              Tbunch,flag_basis,flag_phase                      
!                     nstrob_order                                      
                                                                        
!-------------------------------------------------------                
!      #    ask [n]                                                     
!      ##   from data file, ask [n]                                     
!      ## y from data file, ask [y]                                     
!      ##n  from data file, no ask                                      
!--------------------------------------------------------               
!                 name                    pos  default                  
       thco(jc+1)='th_channels     i_pos=4   include= y  64' 
                   ! theory is calculated at th_channels   
       thco(jc+2)='n_sampling       i_pos=5   include= y   3 ' 
                   ! density of theoretical points for interpolation
       thco(jc+3)='v_range          i_pos=3   include= y   10.00 ' 
                   ! velocity range of sample spectrum                  
       thco(jc+4)='nu_channels       i_pos=2   from_data= y 512 ' 
                 ! channel number of the spectrum                       
       thco(jc+5)='channels_vmax     i_pos=7   from_data=[y] 128  ' 
                 ! period of the drive unit                             
       thco(jc+6)='drive_mode        i_pos=6   from_data= y 1 ' 
                 ! 1,4 triangular,   2,5 sinus 
                 ! determines channel to velocity function/data structure   
       thco(jc+7)='T_bunch           i_pos=8  from_data=[y] 176 ' 
                                                                        
       thco(jc+8)='unit_chi           i_pos=1  include= y  1.0e-6 ' 
                 ! susceptibility multiplied by                         
       thco(jc+9)='flag_basis         i_pos=9  include= y   1 ' 
                 ! switch for circular-linear basis                     
       thco(jc+10)='flag_phase        i_pos=10 include= y   0 ' 
                 ! switch for normal(0), real part(1), imaginary part(-1
       jc=jc+10 
                                                                        
       ntrmt(jm+1)='orientation    matrix=(1,1) from_data=[y] ' 
       ctrmt(jm+1)='(1) grazing angle of the scatterer' 
        thpa(jp+1)='graz_angle        , 5.0 0.0 0.0   1.0' 
        thvr(jv+1)='graz_angle              1    1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
       cova='1001'  
                                                                
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
      subroutine thstr_strobwindow(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco
      implicit none 
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
      character(len=8):: chth
      character(len=4):: cova 

      integer   jc,jv,jm,jp
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='rectangular time windows' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='one rectangular time window' 
       namepg(1)='rectangular_time_windows  nono,1 ' 
       nameth(2)='m-rectangular time windows' 
       namepg(2)='rectangular_time_windows  nono,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=4 <=max_nth
       ntheory(1)='stroboscopic transmission spectrum_0' 
       ntheory(2)='stroboscopic reflection spectrum_0' 
       ntheory(3)='time integral - rocking curve_0' 
       ntheory(4)='time integral - rocking curve_fi_0' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(4))l_jth=2 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
      if(l_jth.eq.1) then 
!                   standard time window                                
       thco(jc+1)='t1_window     i_pos=3    include= y   0.25' 
       thco(jc+2)='t2_window     i_pos=4    include= y   0.75' 
       thco(jc+3)='n_strob_order i_pos=1    include= y   9' 
       jc=jc+3 
       cova='_4pa'
      end if 
      if(l_jth.eq.2) then 
!             m-window* n_strob_order               
       thco(jc+1)='t1_window       i_pos=3  from_data=[y]  0.0' 
       thco(jc+2)='t2_window       i_pos=4  from_data=[y]   1.0' 
       thco(jc+3)='m-window        i_pos=2  from_data=[y]   24' 
       thco(jc+4)='n_strob_order   i_pos=1  from_data=n    9' 
       jc=jc+4 
       cova='_400'
      end if 
                                                                        
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine thstr_11index(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,ntrmt,ctrmt,thpa,thvr
      implicit none
!     n_ik(E) refraction index (static) for                             
!     Mossbauer transmission , powder, anisotropic f-factor             
!     level 3 theory                                                    
       integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
      character(len=8):: chth 
      character(len=4):: cova 

      integer   jc,jv,jm,jp
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='scalar refraction index' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='scalar refraction index (static)' 
       namepg(1)='1x1_ref_index_static  scal,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='stroboscopic transmission spectrum_31' 
       ntheory(2)='stroboscopic reflection spectrum_31' 
       ntheory(3)='stroboscopic transmission spectrum_32'   
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(3))l_jth=1 
       return 
       end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk'.and.l_jth.eq.1) then 
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
      ntrmt(jm+1)='t_eff  intensity' 
      ctrmt(jm+1)='effective thickness by the f-factor at the site' 
       thpa(jp+1)='mg/cm2xf          , 1.0  0.0 0.0  0.1' 
       thvr(jv+1)='mg/cm2xf                 1     1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
       cova='_0_1'
      if(l_jth.eq.1) then 
       ntrmt(jm+1)='isomer_shift   matrix=(1,1)   include= y' 
       ctrmt(jm+1)='isomer shift of the spectrum' 
        thpa(jp+1)='shift            , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='shift                   2     1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
       cova='_0_2'
      end if 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_22indextrm2(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none                                                                        
!     n_ik(E) refraction index (static)                                 
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      logical   name_eq_ntheo 
      character(len=8):: chth 
      character(len=4):: cova 

      integer   jc,jv,jm,jp
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='2x2 refraction index transmission' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='2x2 refraction index (static)' 
       namepg(1)='2x2_refraction_index_static   plrs,1 ' 
       nameth(2)='2x2 refraction index (f,t,spinham)' 
       namepg(2)='2x2_refraction_index_static   plrs,1 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='stroboscopic transmission spectrum_32' 
       ntheory(2)='stroboscopic transmission spectrum_31' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(2))l_jth=2 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='flag_SAMP   i_pos=1    include= n  0 ' 
                 ! discrete (1) , continuous(0) LG-curves               
       thco(jc+2)='flag_Voigt  i_pos=2    include= n  0 ' 
       jc=jc+2 

       ntrmt(jm+1)='t_eff   intensity' 
       ctrmt(jm+1)='effective thickness by the f-factor at the site' 
        thpa(jp+1)='mg/cm2xf         , 1.0  0.0 0.0  0.1' 
        thvr(jv+1)='mg/cm2xf                1     1  ' 
                                                                        
       ntrmt(jm+2)='position  matrix=(1,1)   include= y' 
       ctrmt(jm+2)='position of the spectrum' 
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1' 
        thvr(jv+2)='is_shift                2    1  ' 
                                                                        
       ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]' 
       ctrmt(jm+3)='broadening of the lines of the spectrum' 
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1' 
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1' 
        thvr(jv+3)='G_width                 3      1 0 ' 
        thvr(jv+4)='L_width                 4      0 1 ' 
       jm=jm+3 
       jp=jp+4 
       jv=jv+4 
       cova='_2_4'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
