     subroutine frstr_synchrotron(l_nfrtheo,lstruct1,lstruct2,cmch,nhelpentry)
      use comstr, only: ntheory,nstruct,istruct,ndev,            &
                        strcmt,thco,ntrmt,ctrmt,thpa,thvr
      implicit none 
      integer,intent(in):: l_nfrtheo,lstruct1,lstruct2
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry

      character(len=8)  :: chth 
      character(len=4)  :: cova 
      integer number_device
      integer jc,jv,jm,jp
                                                                        
      chth='fr'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'name') then 
!####################################################                   
       nhelpentry ='Synchrotron spectrum' 
       ntheory(1)='Synchrotron source' 
       ntheory(2)=' '
       
       ndev(1)='scatterer' 
       ndev(2)=' '
       ndev(3)=' '
!####################################################                   
       return 
      end if 
                                                                        
      chth='fr'//nhelpentry(1:6) 
      nstruct=' ' 
      goto(200)number_device(lstruct1) 
!-----------------------------------------------------------------------
!      common/acstrf/acsp,wavelength,uthick,                            
!     &              unit_chi,aiT_max,v_max,                            
!     &              ak_extension,T_bunch,dastr,channels,               
!     &              ch_angle,graz_beg,graz_end,t0_norm,                
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=4   chth='//chth 
       ! Fe_wavelength
       return  
      end if 
                                                                        
!     variables: source,absorber and detector orientation               
!      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta                
!                      PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z      

      call convarmatpar('coll',jc,jv,jm,jp,chth) 
      nhelpentry='theory/'//chth(1:6)//'ex' 
!                    1        0         012345                          
      ntrmt(jm+1)='counts     matrix=(1,1)   include= y' 
      ctrmt(jm+1)='frame parameter total counts' 
       thpa(jp+1)='counts            , 10000.0  0.0 0.0 10.0' ! sum of co 
       thvr(jv+1)='counts                    1    1   ' 
                                                                        
      ntrmt(jm+2)='background   matrix=(1,1) from_data=[n]' 
      ctrmt(jm+2)='variable background' 
       thpa(jp+2)='background        , 0.0 0.0 0.0 1.0'  ! background/ch
       thvr(jv+2)='background                2    1  ' 
                                                                        
      ntrmt(jm+3)='Poincare_beam  matrix=(3,3) from_data=[y]' 
      ctrmt(jm+3)='Poincare vector of the Synchrotron beam' 
       thpa(jp+3)='P_xsi           , 1.0  0.0 1.0  0.05' 
       thpa(jp+4)='P_eta           , 0.0  0.0 0.0   0.05' 
       thpa(jp+5)='P_zeta          , 0.0  0.0 0.0   0.05' 
       thvr(jv+3)='P_xsi                     4    1 0 0 ' 
       thvr(jv+4)='P_eta                     5    0 1 0 ' 
       thvr(jv+5)='P_zeta                    6    0 0 1 ' 
      jm=jm+3 
      jp=jp+5 
      jv=jv+5 
      if(l_nfrtheo.eq.1) then 
       ntrmt(jm+1)='Poincare_analyser  matrix=(4,4) from_data=[y]' 
       ctrmt(jm+1)='Poincare vector of the analyser ' 
      else 
       ntrmt(jm+1)='Poincare_analyser  matrix=(4,4) from_data=[y]' 
       ctrmt(jm+1)='Poincare vector of the analyser ' 
      end if 
       thpa(jp+1)='PA0             , 1.0  0.0 0.0   0.05' 
       thpa(jp+2)='PAxsi           , 0.0  0.0 0.0   0.05' 
       thpa(jp+3)='PAeta           , 0.0  0.0 0.0   0.05' 
       thpa(jp+4)='PAzeta          , 0.0  0.0 0.0   0.05'
       thvr(jv+1)='PA0                       7    1 0 0 0'  
       thvr(jv+2)='PAxsi                     8    0 1 0 0 ' 
       thvr(jv+3)='PAeta                     9    0 0 1 0 ' 
       thvr(jv+4)='PAzeta                   10    0 0 0 1 ' 
      jm=jm+1 
      jp=jp+4
      jv=jv+4 
                                                                        
      if(l_nfrtheo.eq.1) then 
       strcmt(1)='forward_scatterer    n_set=[sp]   [1]  1' 
       strcmt(2)=' set name of the fs spectrum ' 
       strcmt(3)='number of incoherent parts of the forward scatterer' 
       strcmt(4)='theory/'//chth//'/forward scattering/go' 
       strcmt(5)='theory/'//chth//'/forward_scatterer/layer' 
      end if 
                                                                        
      if(l_nfrtheo.ge.2) then 
       strcmt(1)='grazing_scatterer     n_set=[sc]   [1]   1' 
       strcmt(2)='set name of the grazing incidence scatterer ' 
       strcmt(3)='scatterer consists of incoherent parts ' 
       strcmt(4)='theory/'//chth//'/grazing_scatterer/go' 
       strcmt(5)='theory/'//chth//'/forward_scatterer/layer' 
      end if 
      cova='__10'

      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
!-----------------------------------------------------------------------
!      calling by l_nfrtheo=1,2,3,4                                     
!      nameth(1)='Nuclear forward scattering'                           
!      nameth(2)='Nuclear scattering-specular reflection'               
!      nameth(3)='Nuclear scattering-offspecular reflection'            
!      nameth(4)='X-ray specular reflection'                            

  200 continue 
      if(cmch.eq.'hdbk') then 
        nstruct=' ' 
       return 
      end if 
      if(lstruct2.gt.0) goto 210 
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/cfr1trf/ inc_frac,Hext,thetaHe,phiHe,phi,theta,psi        
                                                                        
     if(l_nfrtheo.eq.1) then 
       strcmt(1)='incoherent_part  n_device=[pj] mijk=co;sw;su [1] 1' 
       strcmt(2)='two letters for incoherent part of the scatterer (fs)' 
       strcmt(3)='number of layers of the scatterer ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/forward_scatterer/layer' 
     end if 
!                                                              def/llimi
     if(l_nfrtheo.ge.2) then 
       strcmt(1)='incoherent_part  n_device=[gs] mijk=co;ly;su [2] 1' 
!                                           cover layer substrate       
       strcmt(2)='two letters for incoherent part of the scatterer' 
       strcmt(3)='number of layers of the scatterer ' 
       strcmt(4)='distribution of parameters at sites of the layer' 
       strcmt(5)='theory/'//chth//'/grazing_scatterer/layer' 
       if(l_nfrtheo.eq.4)strcmt(4)=' ' 
                                                                         
      if(l_nfrtheo.lt.4) then 
!      the external field and orientation for the scatterer are defined 
!      on level fr1: one field and orientation for all layers           
!      !! transfer of fr1 values to all layers(fr2) in the loop lstruct2
!         in the scattering theories                                    
       ntrmt(jm+1)='H_extern   matrix=(3,3)   include=[n]' 
       ctrmt(jm+1)='external magnetic field at the scatterer' 
        thpa(jp+1)='Hext            , 0.0  0.0 0.0  1.0' 
        thpa(jp+2)='thetaHe         , 0.0 0.0 0.0   1.0' 
        thpa(jp+3)='phiHe           , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                    2       1 0 0 ' 
        thvr(jv+2)='thetaHe                 3       0 1 0 ' 
        thvr(jv+3)='phiHe                   4       0 0 1 ' 
                                                                        
                                                                        
       ntrmt(jm+2)='orientation  matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='Euler angle of the absorber in the LAB' 
        thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='theta           , 0.0 0.0 0.0   1.0' 
        thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+4)='phi                     5    1 0 0' 
        thvr(jv+5)='theta                   6    0 1 0' 
        thvr(jv+6)='psi                     7    0 0 1' 
       jm=jm+2 
       jp=jp+6 
       jv=jv+6 
      end if
     end if 
                                                                        
       ntrmt(jm+1)='incoherent_fract  matrix=(1,1)   include=y' 
       ctrmt(jm+1)='area fraction treated incoherently' 
        thpa(jp+1)='inc_frac                 1.0  0.0 0.0  0.01' 
        thvr(jv+1)='inc_frac                 1  1 ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
       cova='co_7'
       call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
!     --------------------------------------------------                
  210 continue 
!     layers of device  common/acfr2trf/    /avfr2trf/                  
!     for common/acfritrf/    /avfritrf/                                
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
!     common/acfr2trf/ repeat_group                                     
!     common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,eta_d
                                                                        
       call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
      if(l_nfrtheo.ge.2) then 
       thco(jc+1)='rep.grp         i_pos=1 include=y   1.1 ' 
           ! layer belongs to a group which repeat with period          
       jc=jc+1 
      end if 
      if(l_nfrtheo.ne.4) then 
       thco(jc+1)='iset_powder     i_pos=2 include=[n]  0 ' 
                ! iset=1-6 for 4-128 points on 1/48 of the sphere       
       thco(jc+2)='isymmetry       i_pos=3 include=[n]  10 ' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)          
       thco(jc+3)='n_psi_powder    i_pos=4 include=[n]  0 ' 
                ! 3rd Euler angle, rotation around S_lab(z)             
                ! neccessary if Hext not parallel S_lab(z)              
       jc=jc+3 
      end if 
      cova='_4pa'                                                                  
      if(l_nfrtheo.eq.1) then 
       ntrmt(jm+1)='x2_anisotropy   matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='mean square <x2> of the scatterer layer' 
        thpa(jp+1)='d_x2                  ,  0.0  0.0 0.0  0.1' 
        thpa(jp+2)='x2_eta                ,  0.0  0.0 0.0  0.1' 
        thvr(jv+1)='d_x2                     12    1 0  ' 
        thvr(jv+2)='x2_eta                   13    0 1  ' 
                                                                        
       ntrmt(jm+2)='x2_orientation    matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='x2_orientation with respect to the scatterer layer'
        thpa(jp+3)='x2_phi                , 0.0  0.0 0.0  1.0' 
        thpa(jp+4)='x2_theta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='x2_psi                , 0.0  0.0 0.0  1.0' 
        thvr(jv+3)='x2_phi                   14    1 0 0 ' 
        thvr(jv+4)='x2_theta                 15    0 1 0 ' 
        thvr(jv+5)='x2_psi                   16    0 0 1 ' 
                                                                        
       jm=jm+2 
       jp=jp+5 
       jv=jv+5                                                                         
       ntrmt(jm+1)='Hextern     matrix=(3,3)   include=[n]' 
       ctrmt(jm+1)='external magnetic field (Lab) at the layer (of the fws)'  
        thpa(jp+1)='Hext             , 0.0  0.0 0.0   1.0' 
        thpa(jp+2)='thetaHe          , 0.0  0.0 0.0   1.0' 
        thpa(jp+3)='phiHe            , 0.0  0.0 0.0   1.0 ' 
        thvr(jv+1)='Hext                     6    1 0 0  ' 
        thvr(jv+2)='thetaHe                  7    0 1 0 ' 
        thvr(jv+3)='phiHe                    8    0 0 1' 
                                                                        
       ntrmt(jm+2)='orientation   matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='Euler angle of the forward scatterer in the LAB' 
        thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='theta           , 0.0 0.0 0.0   1.0' 
        thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+4)='phi                      9    1 0 0' 
        thvr(jv+5)='theta                   10    0 1 0' 
        thvr(jv+6)='psi                     11    0 0 1' 
       jm=jm+2 
       jp=jp+6 
       jv=jv+6 
                                                                        
       ntrmt(jm+1)='thickn_lay    matrix=(1,1)   include=[n]' 
       ctrmt(jm+1)='thickness of the layer' 
        thpa(jp+1)='thicklay        , 10.0  0.0 0.0  0.1' 
        thvr(jv+1)='thicklay                1    , 1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 

       ntrmt(jm+1)='Y1m_texture   matrix=(3,3) include=[n]' 
       ctrmt(jm+1)='Y1m texture - scatterer layer (M1/E1) ' 
        thpa(jp+1)='t100                   , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='t11s                   , 0.0  0.0 0.0  0.1' 
        thpa(jp+3)='t11c                   , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='t100                     17    1 0 0' 
        thvr(jv+2)='t11s                     18    0 1 0' 
        thvr(jv+3)='t11c                     19    0 0 1' 

       ntrmt(jm+2)='Y2m_texture  matrix=(5,5) include=[n] ' 
       ctrmt(jm+2)=' texture - scatterer layer (M1/E1) '
        thpa(jp+4)='t200                   , 0.0  0.0 0.0  0.1' 
        thpa(jp+5)='t21s                   , 0.0  0.0 0.0  0.1' 
        thpa(jp+6)='t21c                   , 0.0  0.0 0.0  0.1' 
        thpa(jp+7)='t22s                   , 0.0  0.0 0.0  0.1' 
        thpa(jp+8)='t22c                   , 0.0  0.0 0.0  0.1' 
        thvr(jv+4)='t200                     20    1 0 0 0 0' 
        thvr(jv+5)='t21s                     21    0 1 0 0 0'
        thvr(jv+6)='t21c                     22    0 0 1 0 0' 
        thvr(jv+7)='t22s                     23    0 0 0 1 0' 
        thvr(jv+8)='t22c                     24    0 0 0 0 1' 

        ntrmt(jm+3)='Y30_texture  matrix=(1,1) include=[n] ' 
        ctrmt(jm+3)='axial texture - scatterer layer (M2/E2) '
         thpa(jp+9)='t300                   , 0.0  0.0 0.0  0.1' 
         thvr(jv+9)='t300                     25    1 ' 
        ntrmt(jm+4)='Y40_texture  matrix=(1,1) include=[n] ' 
        ctrmt(jm+4)='axial texture - scatterer layer (M2/E2) '
         thpa(jp+10)='t400                   , 0.0  0.0 0.0  0.1' 
         thvr(jv+10)='t400                     26    1 ' 
        jm=jm+4 
        jp=jp+10 
        jv=jv+10
       cova(3:4)='26'                                                                 

       strcmt(1)='scatterer_layer  n_cmpt=[s] [1]  1' 
       strcmt(2)=' one letter for name of the site ' 
       strcmt(3)='number of inequivalent sites of the scatterer layer' 
       strcmt(4)='distribution of parameters of site number' 
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites' 
      end if 
                                                                        
      if(l_nfrtheo.ge.2) then 
!                    1        0         01234567                        
       ntrmt(jm+1)='thickn_lay    matrix=(1,1)   include=y' 
       ctrmt(jm+1)='thickness of the layer' 
        thpa(jp+1)='thicklay        , 100.0  0.0 0.0  0.1' 
        thvr(jv+1)='thicklay                1    , 1  ' 
                                                                        
       ntrmt(jm+2)='chi_electronic  matrix=(2,2)   include=y' 
       ctrmt(jm+2)='chi_electronic of the layer  ' 
        thpa(jp+2)='r_chilay        , -14.50  0.0 0.0  0.1'   ! iron   
        thpa(jp+3)='i_chilay        ,   0.70  0.0 0.0  0.1'   ! iron
        thvr(jv+2)='r_chilay                2    1 0' 
        thvr(jv+3)='i_chilay                3    0 1' 
                                                                        
       ntrmt(jm+3)='roughness      matrix=(1,1)   include=[n]' 
       ctrmt(jm+3)='roughness of the layer  ' 
        thpa(jp+4)='roughness        , 0.0  0.0 0.0  0.1' 
        thvr(jv+4)='roughness               4    1 ' 
       jm=jm+3 
       jp=jp+4 
       jv=jv+4 

       cova(3:4)='_4' 
       if(l_nfrtheo.eq.3) then 
!       offspecular theory requires the size of domains                 
        ntrmt(jm+1)='domain_fraction   matrix=(1,1)   include=[n]' 
        ctrmt(jm+1)='fraction of + domain of 1. layer  ' 
         thpa(jp+1)='eta_domain        , 0.50  0.0 0.0  0.02' 
         thvr(jv+1)='eta_domain              5    1 ' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1 
       cova(3:4)='_5'
       end if 
       strcmt(1)='scatterer_layer n_cmpt=[s] [1]  0' 
       strcmt(2)='one letter for name of the site ' 
       strcmt(3)='number of inequivalent sites of the scatterer layer' 
       strcmt(4)='distribution of parameters of site number' 
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites' 
      end if 
      if(l_nfrtheo.eq.4)strcmt(1)='scatterer_layer n_cmpt=s 0  0' 
                                                                        
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine thstr_synsource(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory 
      implicit none                                                            
!     case time domain spectrum,                                        
!          time integral - rocking curve                                
!          prompt - rocking curve                                       
!     for  Synchrotron reflection                                       
                                                                        
      integer   l_jth                                                          
      character nhelpentry*132,cmch*4 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Synchrotron source (distribute)' 
!      names for child theories , mthchild=4 <= max_nth                 
       nameth(1)='Nuclear forward scattering' 
       nameth(2)='Nuclear scattering - specular reflection' 
       nameth(3)='Nuclear scattering - offspecular reflection' 
       nameth(4)='X-ray specular reflection' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Synchrotron source' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=4 
      end if 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_syntransmission(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,                        &
                        thco,thpa,thvr,ntrmt,ctrmt
      implicit none
!     time domain spectrum for synchrotron transmission                 
!     level 0 theory                                                    
                                                                        
                                                                        
      integer   jc,jv,jm,jp,l_jth 
      character nhelpentry*132,chth*8
      character(len=4)  :: cova,cmch 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Nuclear forward scattering (distribute)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='time differential transmission spectrum' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Nuclear forward scattering' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=1   chth='//chth 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/acstrf/ acsp,wavelength,uthick,                           
!     &               unit_chi,                                        1
!     &               aiT_max,v_max,ak_extension,                      4
!     &               T_bunch,dastr,                                   6
!     &               channels,ch_angle,graz_beg,graz_end,            10
!     &               t0_norm,flag_basis                              12
                                                                        
       thco(jc+1)='i_T_max          i_pos=2 include=y   0 ' 
                ! Time window for display                               
       thco(jc+2)='v_max[mm/s]     i_pos=3 include=y   8 ' 
                ! v_max of the nuclear energies                         
       thco(jc+3)='k_extension_2**k i_pos=4 include=y   0 ' 
                ! times v_max                                           
       jc=jc+3 
       thco(jc+1)='T0_NormInt       i_pos=11 include=y  10' 
                 ! integration for normalizing from t0                  
       thco(jc+2)='T_bunch          i_pos=5 from_data=[y] 160' 
                 ! bunch distance in ns                                 
       thco(jc+3)='nu_channels      i_pos=7  from_data=y 256' 
                ! number of channels for for angles                     
       thco(jc+4)='dastr            i_pos=6  from_data=[y] 1' 
                ! determines function for channel to time conversion    
       thco(jc+5)='flag_basis       i_pos=12  include=y   1 ' 
                 ! switch for circular-linear basis                     
       jc=jc+5 
                                                                        
!      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,               
!                      t_shif                                           
                                                                        
        ntrmt(jm+1)='calibration    matrix=(1,1) from_data=[y]' 
        ctrmt(jm+1)='variable t_shift' 
         thpa(jp+1)='t_shift           , 0.0 0.0 0.0 0.1' 
         thvr(jv+1)='t_shift                 1     1  ' 
        jm=jm+1 
        jp=jp+1 
        jv=jv+1 
        cova='1201'                                                             
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_xrayreflection(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,                     &
                        thco,thpa,thvr,ntrmt,ctrmt  
      implicit none
!     time domain spectrum for synchrotron transmission                 
!     level 0 theory                                                    
                                                                        
                                                                        
      integer jc,jv,jm,jp,l_jth 
      character nhelpentry*132,chth*8
      character(len=4)  :: cova,cmch
      logical name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='X-ray specular reflection (distribute)' 
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='prompt - rocking curve' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='X-ray specular reflection' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
      
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
      thco(jc+1)='nu_angle       i_pos=9  include=y     128 ' 
      thco(jc+2)='graz_begin     i_pos=10 from_data=[n] 0.001 ' 
      thco(jc+3)='graz_end       i_pos=11 from_data=[n] 20 ' 
      thco(jc+4)='nu_channels    i_pos=8  from_data=y   128 ' 
               ! number of channels for  angles                         
      thco(jc+5)='dastr          i_pos=7  from_data=[y] 1' 
               ! determines function for channel to time conversion     
      thco(jc+6)='unit_chi       i_pos=2  include=y   1.0e-6 ' 
               ! susceptibility multiplied by                           
      jc=jc+6 
                                                                        
      ntrmt(jm+1)='calibration  matrix=(1,1) from_data=[y]' 
      ctrmt(jm+1)='variable angle shift' 
       thpa(jp+1)='ang_shift           0.0 0.0 0.0 0.1' 
       thvr(jv+1)='ang_shift               1     1  ' 
                                                                        
      ntrmt(jm+2)='orientation   matrix=(2,2) from_data=[n]' 
      ctrmt(jm+2)='(2) variables phi_z, graz_min of the scatterer plane' 
       thpa(jp+2)='graz_min            1.0  0.0 0.0  0.01' 
       thpa(jp+3)='phi_z               0.0  0.0 0.0  1.0' 
       thvr(jv+2)='graz_min                  2    1 0' 
       thvr(jv+3)='phi_z                     3    0 1' 
      jm=jm+2 
      jp=jp+3 
      jv=jv+3 
                                                                        
      ntrmt(jm+1)='deadtime     matrix=(2,2) from_data=[y]' 
      ctrmt(jm+1)='(2) variables detekt_eff,counts_bunch' 
       thpa(jp+1)='detekt_eff             , 0.9 0.0 0.0 0.1' 
       thpa(jp+2)='counts_bunch           , 1.0 0.0 0.0 0.1' 
       thvr(jv+1)='detekt_eff                4     1 0 ' 
       thvr(jv+2)='counts_bunch              5     0 1 ' 
      jm=jm+1 
      jp=jp+2 
      jv=jv+2 
      cova='1405'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_synreflection(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,                        &
                        thco,thpa,thvr,ntrmt,ctrmt  
      implicit none
                                                                        
      integer jc,jv,jm,jp,l_jth 
      character nhelpentry*132,chth*8
      character(len=4)  :: cova,cmch
      logical name_eq_ntheo 
                                                                        
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Nuclear scattering - specular reflection (distribute)'
!      names for child theories , mthchild=4 <= max_nth                 
       nameth(1)='time differential reflection spectrum' 
       nameth(2)='time integral - rocking curve-Fourier' 
       nameth(3)='time integral - rocking curve' 
       nameth(4)='time integral - rocking curve_fi' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Nuclear scattering - specular reflection' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=4 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb  list=2  chth='//chth 
!               list=2 constant uthick 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
!      common/acstrf/acsp,wavelength,uthick,                ! from hdb  
!     &              unit_chi,aiT_max,v_max,                           !
!     &              ak_extension,T_bunch,dastr,channels,              !
!     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,    !
!     &              th_channels,th_sampling,                          !
!     &              strob_order,omega,dumcsp(icstrf-19)                
                                                                        
!      synmos                                                           
!      common/acstrf/acsp,wavelength,uthick,unit_chi,dumcsp(icstrf-4)   
!      synrock                                                          
!      common/acstrf/acsp,wavelength,uthick_A,                          
!     &              unitchi,dum6(6),ch_angle,graz_beg,graz_end,        
!     &              dumcsp(icstrf-8)                                   
                                                                        
!                  1                  012345                            
                                                                        
      cova='14__'                                                              
      if(l_jth.eq.4) then 
       thco(jc+1)='vmax_hypf[mm/s]  i_pos=3 include=y  8 ' 
                ! v_max of the nuclear energies                         
       thco(jc+2)='nch_hypf         i_pos=13 include=y  64' 
                ! v_max/nch_hypf =schrw    stepwidth                    
       thco(jc+3)='nch_TH           i_pos=4  include=y  1024' 
                ! +-channels to be calculated for index of refraction   
       thco(jc+4)='T_bunch          i_pos=5 from_data=[y] 24' 
                 ! bunch distance in ns                                 
       jc=jc+4 
      end if 
                                                                        
      if(l_jth.eq.3) then 
       thco(jc+1)='v_max[mm/s]     i_pos=3 include=y  25 ' 
                ! v_max of the nuclear energies                         
       thco(jc+2)='th_channels      i_pos=13 include=y 126' 
                ! 2**th_sampling <=8 ; 1 means maximal accuracy         
       thco(jc+3)='th_sampling      i_pos=14 include=y  3 ' 
                ! 2**th_sampling <=8 ; 1 means maximal accuracy         
       thco(jc+4)='T_bunch          i_pos=5  from_data=[y] 176' 
                 ! bunch distance in ns                                 
       jc=jc+4 
      end if 
                                                                        
      if(l_jth.le.2) then 
       thco(jc+1)='i_T_max          i_pos=2 include=y   0 ' 
                ! Time window for calculation                           
       thco(jc+2)='v_max[mm/s]     i_pos=3  include=y  8 ' 
                ! v_max of the nuclear energies                         
       thco(jc+3)='k_extension_2**k i_pos=4  include=y  0 ' 
                ! times v_max                                           
       jc=jc+3 
      end if 
                                                                        
      if(l_jth.eq.1) then 
       thco(jc+1)='T0_NormInt       i_pos=11 include=y   10' 
                 ! integration for normalizing from t0                  
       thco(jc+2)='T_bunch          i_pos=5  from_data=[y] 160' 
                 ! bunch distance in ns                                 
       thco(jc+3)='nu_channels      i_pos=7  from_data=y 256' 
                ! number of channels for for angles                     
       jc=jc+3 
      end if 
                                                                        
      if(l_jth.eq.2.or.l_jth.eq.3.or.l_jth.eq.4) then 
       thco(jc+1)='nu_angle         i_pos=8  include=y  128 ' 
       thco(jc+2)='graz_begin       i_pos= 9 from_data=[n] 1.  ' 
       thco(jc+3)='graz_end         i_pos=10 from_data=[n] 20 ' 
       thco(jc+4)='nu_channels      i_pos=7  from_data=y  128 ' 
                ! number of channels for  angles                        
       jc=jc+4 
      end if 
      if(l_jth.eq.2) then 
       thco(jc+1)='T0_Integral      i_pos=11 include=y  10' 
                 ! integration probability of delayed events from t0    
       thco(jc+2)='T_bunch          i_pos=5  from_data=[y] 176' 
                 ! bunch distance in ns                                 
       jc=jc+2 
      end if 
      if(l_jth.le.4) then 
       thco(jc+1)='flag_basis       i_pos=12 include=y   1 ' 
                 ! switch for circular-linear basis                     
       jc=jc+1 
      end if 
                                                                        
      thco(jc+1)='dastr             i_pos=6   from_data=[y] 1' 
               ! determines function for channel to time conversion     
      thco(jc+2)='unit_chi          i_pos=1  include=y  1.0e-6 ' 
               ! susceptibility multiplied by                           
      jc=jc+2 
                                                                        
                                                                        
!      common/avsptrf/counts,background,dum,Pxsi,Peta,Pzeta,PA0,PAxsi,PAeta,PAz
!                     ang_shift(t_shift),graz_angle(graz_min),phi_z,   
!                     detekt_eff,counts_bunch                          
                                                                        
      if(l_jth.eq.1) then 
       ntrmt(jm+1)='calibration   matrix=(1,1) from_data=[y]' 
       ctrmt(jm+1)='variable t_shift' 
        thpa(jp+1)='t_shift           , 0.0 0.0 0.0 0.1' 
        thvr(jv+1)='t_shift                  1     1  ' 
                                                                        
       ntrmt(jm+2)='orientation   matrix=(2,2) from_data=[y]' 
       ctrmt(jm+2)='(2) grazing angles of the scatterer' 
        thpa(jp+2)='graz_angle        , 5.0 0.0 0.0   1.0' 
        thpa(jp+3)='phi_z             , 0.0  0.0 0.0  1.0' 
        thvr(jv+2)='graz_angle                2    1 0 ' 
        thvr(jv+3)='phi_z                     3    0 1 ' 
       jm=jm+2 
       jp=jp+3 
       jv=jv+3 
      else 
       ntrmt(jm+1)='calibration   matrix=(1,1) from_data=[y]' 
       ctrmt(jm+1)='variable angle shift' 
        thpa(jp+1)='ang_shift           0.0 0.0 0.0 0.1' 
        thvr(jv+1)='ang_shift               1     1  ' 

       ntrmt(jm+2)='orientation    matrix=(2,2) from_data=[y]' 
       ctrmt(jm+2)='(2) variables phi_z, graz_min of the scatterer plane' 
        thpa(jp+2)='graz_min            1.0  0.0 0.0  0.01' 
        thpa(jp+3)='phi_z               0.0  0.0 0.0  1.0' 
        thvr(jv+2)='graz_min                  2    1 0' 
        thvr(jv+3)='phi_z                     3    0 1' 
       jm=jm+2 
       jp=jp+3 
       jv=jv+3 
      end if 
      cova='1403'                                                               
      if(l_jth.eq.4)then 
       ntrmt(jm+1)='deadtime      matrix=(2,2) from_data=[y]' 
       ctrmt(jm+2)='(2) variables detekt_eff,counts_bunch' 
        thpa(jp+1)='detekt_eff             , 0.9 0.0 0.0 0.1' 
        thpa(jp+2)='counts_bunch           , 1.0 0.0 0.0 0.1' 
        thvr(jv+1)='detekt_eff                4     1 0 ' 
        thvr(jv+2)='counts_bunch              5     0 1 ' 
       jm=jm+1 
       jp=jp+2 
       jv=jv+2 
       cova='1405'             
      end if 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_synoffspec(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,ntheory,nstruct,                         &
                        thco,thpa,thvr,ntrmt,ctrmt  
      implicit none
                                                                        
      integer jc,jv,jm,jp,l_jth 
      character nhelpentry*132,chth*8,cmch*4,cova*4
      logical name_eq_ntheo 
                                                                        
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='Nuclear scattering - offspecular reflection (distribute)'
!      names for child theories , mthchild=1 <= max_nth                 
       nameth(1)='time integral - offspecular' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Nuclear scattering - offspecular reflection' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=1 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=2   chth='//chth 
       !    constant thickness Angstroem (reflection)
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/acstrf/acsp,wavelength,uthick,              2  from nucleu
!     &              unit_chi,aiT_max,v_max,                            
!     &              nch_TH,T_bunch,dastr,channels,columns,             
!     &              strob_order,t1_window,t2_window,flag_basis,        
!     &              th_channels,DWBA                                   
                                                                        
!                  1                  012345                            
       thco(jc+1)='vmax_hypf[mm/s]    i_pos=3  include=y   8 ' 
                ! v_max of the nuclear energies                         
       thco(jc+2)='nch_hypf           i_pos=14  include=y  64' 
                ! v_max/nch_hypf =schrw    stepwidth                    
       thco(jc+3)='nch_TH             i_pos=4   include=y  1024' 
                ! +-channels to be calculated for index of refraction   
       thco(jc+4)='nu_channels        i_pos=7   from_data=y 1024 ' 
                ! number of angular pairs                               
       jc=jc+4 
       thco(jc+1)='n_strob_order      i_pos=9    include=y  9' 
       thco(jc+2)='t1_window          i_pos=11   from_data=[n] 1.97' 
       thco(jc+3)='t2_window          i_pos=12   from_data=[n] 21.63' 
       jc=jc+3 
       thco(jc+1)='show_angles        i_pos=15   from_data=[n]  0 ' 
       thco(jc+2)='Approximation      i_pos=16   from_data=[n]  0 ' 
       thco(jc+3)='flag_basis         i_pos=13   from_data=[n]  0 ' 
       jc=jc+3 
       thco(jc+1)='T_bunch            i_pos=5     from_data=[y] 23.6' 
                 ! bunch distance in ns                                 
       thco(jc+2)='unit_chi           i_pos=1    include=y 1.0e-6 ' 
                ! susceptibility multiplied by                          
       jc=jc+2 
                                                                        
                                                                        
!      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,               
!                      ang_shift(t_shift)                               
                                                                        
!                    1                  012345                          
       ntrmt(jm+1)='calibration   matrix=(1,1) from_data=[y]' 
       ctrmt(jm+1)='variable angle shift' 
        thpa(jp+1)='ang_shift           0.0 0.0 0.0 0.1' 
        thvr(jv+1)='ang_shift               1     1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1
       cova='1601' 
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine thstr_offspeccorrelation(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,namepg,ntheory
      implicit none
                                                                        
      integer   l_jth                                                          
      character nhelpentry*132,cmch*4 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='offspecular correlation matrix' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='crosscorrelation' 
       namepg(1)='offspecular_correlation_matrix  nono,1  ' 
       nameth(2)='autocorrelation' 
       namepg(2)='offspecular_correlation_matrix  nono,2  ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='time integral - offspecular_1' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(1))l_jth=2 
      end if 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_offspeccorrelfunc(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,namepg,ntheory,nstruct,               &
                        thco,thpa,thvr,ntrmt,ctrmt  
      implicit none
                                                                        
                                                                        
      integer jc,jv,jm,jp,l_jth 
      character nhelpentry*132,chth*8,cmch*4,cova*4
      logical name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='offspecular correlation function' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='exponential' 
       namepg(1)='offspecular_correlation_function nono,1 ' 
       nameth(2)='Lorentzian' 
       namepg(2)='offspecular_correlation_function nono,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='crosscorrelation' 
       ntheory(2)='autocorrelation' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(2))l_jth=2 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
!      common/acfr1trf/acsp,wavelength,uthick_A                         
       thco(jc+1)='um/Angstroem    i_pos=1   include=y  1.0e4' 
       jc=jc+1 
!      common/avfr1trf/avfr1,pvfr1,HextA,thetaHeA,phiHeA,               
!      &                phiA,thetaA,psiA,                               
                                                                        
!                    1                  012345                          
       ntrmt(jm+1)='Lcorrelation   matrix=(1,1)   include=y' 
       ctrmt(jm+1)='correlation length inside layer' 
        thpa(jp+1)='cor_length[um]        4.8 0.0 0.0 0.1' 
        thvr(jv+1)='cor_length                1     1  ' 
       jm=jm+1 
       jp=jp+1 
       jv=jv+1 
      cova='0101'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
      subroutine thstr_scanmode(l_jth,cmch,nhelpentry) 
      use comstr, only: nameth,namepg,ntheory,nstruct,thco  
      implicit none
                                                                        
                                                                        
      integer jc,jv,jm,jp,l_jth 
      character nhelpentry*132,chth*8,cmch*4,cova*4 
      logical name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='offspecular scanmodes' 
!      names for child theories , mthchild=5 <= max_nth                 
       nameth(1)='detector scan' 
       namepg(1)='offspecular_scanmode  nono,1  ' 
       nameth(2)='omega scan' 
       namepg(2)='offspecular_scanmode  nono,2  ' 
       nameth(3)='omega scan-3d' 
       namepg(3)='offspecular_scanmode  nono,3  ' 
       nameth(4)='theta1-theta2 scan-3d' 
       namepg(4)='offspecular_scanmode  nono,4  ' 
       nameth(5)='parallel to specular' 
       namepg(5)='offspecular_scanmode  nono,5  ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='time integral - offspecular_0' 
       ntheory(2)='Neutron offspecular_0' 
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(2))l_jth=5 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
      if(cmch.eq.'hdbk') then 
       nstruct=' ' 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
!      common/acstrf/acsp,wavelength,uthick,                            
!     &              unit_chi,aiT_max,v_max,                            
!     &              ak_extension,T_bunch,dastr,channels,               
!     &              strob_order,t1_window,t2_window,DWBA,flag_basis,   
!     &              th_channels,th_sampling,                           
!      for different set appearing in acmaps of  subroutine  th_scanmode
!     &              omega,n_theta,theta_begin,theta_end,               
!     &              an_omega,omega_begin,omega_end,                    
!     &              omega,n_theta,theta_begin,n2theta,theta2_begin,thet
!     &              n_theta,theta_begin,theta_end,                     
                                                                        
      if(l_jth.eq.1) then 
!                   standard time window                                
       thco(jc+1)='n_omega          i_pos=1  include=y    10' 
       thco(jc+2)='omega_begin      i_pos=2  include=y    0.1' 
       thco(jc+3)='omega_end        i_pos=3  include=y    15.0' 
       thco(jc+4)='n_theta          i_pos=4   from_data=y  5' 
       thco(jc+5)='theta_begin      i_pos=5   from_data=[y]  10.0' 
       thco(jc+6)='delta_theta      i_pos=6   from_data=[y]  1.0' 
       jc=jc+6 
      end if 
      if(l_jth.eq.2) then 
!             omega scan                                                
       thco(jc+1)='n_omega         i_pos= 1  include=y    10' 
       thco(jc+2)='omega_begin     i_pos= 2  include=y    0.1' 
       thco(jc+3)='n2theta         i_pos= 4   from_data=y 2' 
       thco(jc+4)='2theta_begin    i_pos= 5   from_data=[y] 13.75' 
       thco(jc+5)='delta_theta     i_pos= 6   from_data=[y] 1.0' 
       jc=jc+5 
      end if 
      if(l_jth.eq.3) then 
!             omega scan                                                
       thco(jc+1)='n_omega         i_pos= 1  include=y    10' 
       thco(jc+2)='omega_begin     i_pos= 2  include=y    0.1' 
       thco(jc+3)='n2theta         i_pos= 4  include=y   2' 
       thco(jc+4)='2theta_begin    i_pos= 5  include=y   13.75' 
       thco(jc+5)='delta_theta     i_pos= 6  include=y   1.0' 
       jc=jc+5 
      end if 
      if(l_jth.eq.4) then 
!             theta1-2 scan                                             
       thco(jc+1)='ntheta1         i_pos= 1  include=y   5' 
       thco(jc+2)='theta1_begin    i_pos= 2  include=y   10.666' 
       thco(jc+3)='theta1_end      i_pos= 3  include=y   17.109' 
       thco(jc+4)='ntheta2         i_pos= 4  include=y   6' 
       thco(jc+5)='theta2_begin    i_pos= 5  include=y   12.046' 
       thco(jc+6)='theta2_end      i_pos= 6  include=y   19.374' 
       jc=jc+6 
      end if 
      if(l_jth.eq.5) then 
!        parallel to specular scan                                      
       thco(jc+1)='n_omega         i_pos= 1  include=y    10' 
       thco(jc+2)='omega_begin     i_pos= 2  include=y    0.1' 
       thco(jc+3)='omega_end       i_pos= 3  include=y    13.0' 
       thco(jc+4)='ntheta          i_pos= 4   from_data=y  3' 
        jc=jc+4 
      end if 
      cova='0600'                                                              
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
