      subroutine  dddd(theta,phi,d) 
      implicit none
                                                                        
      real(kind=8)   :: al(8,8),alt(8,8),theta,phi 
      complex(kind=8):: qj(3,3),dd(8,8),db(8,8),d(8,8),z1 
      real(kind=8)   :: st,ct,sq2,e1,e2,pp
      real(kind=8),parameter :: zero=0.d0,one=1.d0,two=2.d0,pt5=0.5d0                                                            
      integer    i,i1,i2,j,j1,j2,k,k1,k2,n1,n2      
                                                                  
      st=dsin(theta) 
      ct=dcos(theta) 
      sq2=dsqrt(2.0d0) 
                                                                        
      do i=1,3 
       do j=1,3 
        qj(i,j)=zero 
       end do
      end do                                                                 

      qj(1,1)=(one+ct**2)*pt5 
      qj(3,3)=qj(1,1) 
      qj(2,3)=-st*ct/sq2*dcmplx(dcos(phi),dsin(phi)) 
      qj(1,2)=-qj(2,3) 
      qj(2,2)=st**2 
      qj(1,3)=st**2*pt5*dcmplx(dcos(two*phi),dsin(two*phi)) 
                                                                        
      do i=2,3 
       do j=1,2 
        qj(i,j)= dconjg(qj(j,i)) 
       end do
      end do     
                                                                        
      do i=1,8 
       do j=1,8 
        dd(i,j)=zero 
       end do
      end do     
                                                                        
      do j1=1,4 
       do i1=1,2 
        n1=j1-i1+1 
        if(n1.eq.0.or.n1.eq.4)goto 14
        e1=dfloat(j1)-2.5d0 
        k1=8-4*(i1-1)-(j1-1) 
        do j2=1,4 
         do i2=1,2 
          n2=dfloat(j2)-i2+1 
          if(n2.eq.0.or.n2.eq.4) goto 15
          e2=j2-2.5d0 
          k2=8-4*(i2-1)-(j2-1) 
          dd(k1,k2)=pp(e1,n1)*pp(e2,n2)*qj(n1,n2) 
 15       continue
         end do
        end do
 14     continue
       end do
      end do

      do i=1,8 
       do j=1,8 
        al(i,j)=zero 
        alt(i,j)=zero 
       end do
      end do     
                                                                        
      al(1,1)=one 
      al(2,8)=one 
      al(3,2)=one 
      al(4,7)=one 
      al(5,3)=one 
      al(6,6)=one 
      al(7,4)=one 
      al(8,5)=one 
                                                                        
      do i=1,8 
       do j=1,8 
        alt(i,j)=al(j,i) 
       end do
      end do     
                                                                        
      do i=1,8 
       do j=1,8 
        z1=zero 
        do k=1,8 
         z1=z1+dd(i,k)*alt(k,j) 
        end do
        db(i,j)=z1 
       end do
      end do     
                                                                        
      do i=1,8 
       do j=1,8 
        z1=zero 
        do k=1,8 
         z1=z1+al(i,k)*db(k,j) 
         d(i,j)=z1 
        end do
       end do
      end do                                                                      
      return 
      END                                           
                                                                        
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
! * * * * * * * * * * * * * * * * * * * * * * * * * * * *               
                                                                        
      subroutine hyperr(nr,hyp,rel,gx,gy,gz,ax,ay,az,a_hyp,             &
     &                  qx,qy,qz,qxy,qxz,qyz,tetm,phim)                 
                                                                        
      implicit real(kind=8) (a-h,o-z) 
      integer nr
      real(kind=8),dimension(8,8) :: hyp,rel 
      real(kind=8),parameter:: zero=0.d0, two=2.d0, three=3.d0 
                                                                  
       ag=0.180448d0 
       ae=-0.10307d0 
       h0=a_hyp*0.25d0/ag 
                                                                        
      stm=dsin(tetm) 
      ctm=dcos(tetm) 
      spm=dsin(phim) 
      cpm=dcos(phim) 
                                                                        
      gxx=gx*stm*cpm 
      gyy=gy*stm*spm 
      gzz=gz*ctm 
                                                                        
      g2=gzz**2 + gxx**2 +gyy**2 
      sqr=dsqrt(g2) 
                                                                        
      h0g=h0/sqr 
      if(nr.eq.2) h0g=-h0g 
      hz=h0g*gzz*az 
      hy=h0g*gyy*ay 
      hx=h0g*gxx*ax 
                                                                        
      sq3=dsqrt(three) 
      sq3r=1.d0/sq3 
      sq3r2=two*sq3r 
                                                                        
      do  i=1,8 
       do  j=1,8 
        hyp(i,j)=zero 
        rel(i,j)=zero 
       end do
      end do                                                                        
      ae3=three*ae 
      qz2=two*qz 
                                                                        
      hyp(1,1)=hz*(ae3-ag)+qz 
      hyp(2,2)=-hyp(1,1)+qz2 
      hyp(3,3)=hz*(ae-ag)-qz 
      hyp(4,4)=-hyp(3,3)-qz2 
      hyp(5,5)=hz*(-ae-ag)-qz 
      hyp(6,6)=-hyp(5,5)-qz2 
      hyp(7,7)=hz*(-ae3-ag)+qz 
      hyp(8,8)=-hyp(7,7)+qz2 
                                                                        
      h3x=sq3*ae*hx 
      h2x=two*ae*hx 
      hgx=hx*ag 
                                                                        
      h3y=sq3*ae*hy 
      h2y=two*ae*hy 
      hgy=hy*ag 
      qxz32=qxz*sq3r2 
      qxmy3=sq3r*(qx-qy) 
      qyz32=qyz*sq3r2 
      qxy32=sq3r2*qxy 
                                                                        
      hyp(1,3)= h3x+qxz32 
      hyp(3,1)= hyp(1,3) 
      hyp(1,5)= qxmy3 
      hyp(5,1)= hyp(1,5) 
      hyp(1,8)= -hgx 
      hyp(8,1)= -hgx 
      hyp(2,4)= h3x-qxz32 
      hyp(4,2)= hyp(2,4) 
      hyp(2,6)= qxmy3 
      hyp(6,2)= hyp(2,6) 
      hyp(2,7)= -hgx 
      hyp(7,2)= -hgx 
      hyp(3,5)= h2x 
      hyp(5,3)= h2x 
      hyp(3,7)= qxmy3 
      hyp(7,3)= hyp(3,7) 
      hyp(3,6)= -hgx 
      hyp(6,3)= -hgx 
      hyp(5,4)= -hgx 
      hyp(4,5)= -hgx 
      hyp(4,6)= h2x 
      hyp(6,4)= h2x 
      hyp(4,8)= qxmy3 
      hyp(8,4)= hyp(4,8) 
      hyp(5,7)= h3x-qxz32 
      hyp(7,5)= hyp(5,7) 
      hyp(6,8)= h3x+qxz32 
      hyp(8,6)= hyp(6,8) 
                                                                        
                                                                        
      rel(1,3)=-h3y-qyz32 
      rel(3,1)=-rel(1,3) 
      rel(1,5)=-qxy32 
      rel(5,1)=-rel(1,5) 
      rel(1,8)=-hgy 
      rel(8,1)= hgy 
      rel(2,4)= h3y-qyz32 
      rel(4,2)=-rel(2,4) 
      rel(2,6)= qxy32 
      rel(6,2)=-rel(2,6) 
      rel(2,7)= hgy 
      rel(7,2)=-hgy 
      rel(3,5)=-h2y 
      rel(5,3)= h2y 
      rel(3,7)=-qxy32 
      rel(7,3)=-rel(3,7) 
      rel(3,6)=-hgy 
      rel(6,3)= hgy 
      rel(4,5)= hgy 
      rel(5,4)=-hgy 
      rel(4,6)= h2y 
      rel(6,4)=-h2y 
      rel(4,8)= qxy32 
      rel(8,4)=-rel(4,8) 
      rel(5,7)=-h3y+qyz32 
      rel(7,5)=-rel(5,7) 
      rel(6,8)= h3y+qyz32 
      rel(8,6)=-rel(6,8) 
                                                                        
      return 
      END                                           
                                                                        
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
      function pp(e,n) 
      implicit none
      integer n
      real(kind=8) :: e,fe,fn,pp
      
      fe=2.d0 
      fn=2.d0
      if(dabs(e).gt.0.6d0) fe=6.d0 
      if(n.eq.2) fn=1.d0 
      pp=(-1)**n*dsqrt(fe/fn/12.d0) 
      return 
      END                                           
!********************************************************               
!                                                       *               
      SUBROUTINE tens(QXX,QYY,QZZ,ALPHA,BETA,GAMMA,                     &
     &               VXX,VYY,VZZ,VXY,VXZ,VYZ)                           
!                                                       *               
!********************************************************               
!                                                                       
      IMPLICIT  real(kind=8) (A-H,O-Z)
      real(kind=8),parameter:: pi= 3.14159265358979324, rad=pi/180.d0
!    ***                                                                
!    ***  PURPOSE                                                       
!    ***  SET UP TENSOR COMPONENTS OF A REAL SYMMETRIC TENSOR           
!    ***                                                                
!    ***  INPUT PARAMETERS                                              
!    ***  QXX,QYY,QZZ=MAIN COMPONENTS OF THE TENSOR                     
!    ***  ALPHA,BETA,GAMMA=EULER ANGLES OF THE PRINCIPAL AXES SYSTEM    
!    ***                                                                
!    ***  OUTPUT PARAMETERS                                             
!    ***  VXX,VYY,VZZ,VXY,VXZ,VYZ=TENSOR COMPONENTS                     
!    ***                                                                
                                                                        
                                                                        
      H7=ALPHA*rad 
      H8=BETA*rad
      H9=GAMMA*rad 
      H1=DSIN(H7) 
      H2=DCOS(H7) 
      H3=DSIN(H8) 
      H4=DCOS(H8) 
      H5=DSIN(H9) 
      H6=DCOS(H9) 
      TV33=H4 
      TV31=H3*H2 
      TV32=H3*H1 
      TV13=-H6*H3 
      TV23=H5*H3 
      TV11=H2*H4*H6-H1*H5 
      TV12=H1*H4*H6+H2*H5 
      TV21=-H2*H4*H5-H1*H6 
      TV22=-H1*H4*H5+H2*H6 
!    ***  REMARK  TVIJ IS THE J-TH COMPONENT OF THE I-TH PRINCIPAL AXIS 
      H1=QXX*TV11 
      H2=QYY*TV21 
      H3=QZZ*TV31 
      H4=QXX*TV12 
      H5=QYY*TV22 
      H6=QZZ*TV32 
      VXX=TV11*H1+TV21*H2+TV31*H3 
      VXY=TV12*H1+TV22*H2+TV32*H3 
      VXZ=TV13*H1+TV23*H2+TV33*H3 
      VYY=TV12*H4+TV22*H5+TV32*H6 
      VYZ=TV13*H4+TV23*H5+TV33*H6 
      VZZ=QXX+QYY+QZZ-VXX-VYY 
      RETURN 
      END                                           
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
!**************************************************                     
                                                                        
      subroutine splith(dl,rom,cube,fort,crso) 
      implicit  real(kind=8) (a-h,o-z) 
      real(kind=8),dimension(3,3):: crso
      real(kind=8),parameter :: one=1.d0,two=2.d0,three=3.0d0,pt5=0.5d0                                                            
      sq2=dsqrt(two) 
      sq3=dsqrt(three) 
      sq5=dsqrt(5.d0) 
      sq10=sq2*sq5 
      o3=one/three 
                                                                        
      do  i=1,3 
       do j=1,3 
         crso(i,j)=0.d0 
       end do
      end do                                                                 
      crso(1,1)=10.d0*o3*dl + pt5*cube + o3*fort 
      crso(1,2)=sq10*rom 
      crso(1,3)=pt5*sq5*cube 
      crso(2,1)=crso(1,2) 
      crso(2,2)=-8.d0*o3*dl + cube + two*o3*fort 
      crso(2,3)=three*sq2*rom 
      crso(3,1)=crso(1,3) 
      crso(3,2)=crso(2,3) 
      crso(3,3)=-two*o3*dl -1.5d0*cube - fort 
                                                                        
      return 
      END                                           
                                                                        
!**************************************************                     
      subroutine tenshs(cts,gx,gy,gz,a,b,c) 
      implicit real*8 (a-h,o-z) 
      real(kind=8),dimension(3,3):: cts
      real(kind=8),dimension(3)  :: gx,gy,gz,a,b,c 
      real(kind=8),parameter :: one=1.d0,two=2.d0,three=3.0d0,pt5=0.5d0,four=4.d0                                                           
      sq2=dsqrt(two) 
      sq3=dsqrt(three) 
      sq5=dsqrt(5.d0) 
      sq10=sq2*sq5 
      o3=one/three 
                                                                        
      gj=two 
                                                                        
      sq5t=two*sq5 
      fsq2=four*sq2 
                                                                        
      do i=1,3 
                                                                        
       a(i)=cts(1,i) 
       b(i)=cts(2,i) 
       c(i)=cts(3,i) 
                                                                        
       ai2=a(i)**2 
       bi2=b(i)**2 
       ci2=c(i)**2 
       aici=a(i)*c(i) 
       bici=b(i)*c(i) 
                                                                        
       gx(i)=gj*(three*bi2+sq5t*aici                                     &
             +fsq2*bici)                                                 
       gy(i)=gj*(-1)**(i+1)*(three*bi2+sq5t*aici                         &
             -fsq2*bici)                                                 
       gz(i)=(-1)**(i+1)*gj*(5.d0*ai2+bi2-three*ci2) 
      end do 
                                                                        
      return 
      END                                           
                                                                        
!**************************************************                     
                                                                        
      subroutine relsl(relr,gx,gy,gz,a,b,c,tetm,phim) 
      implicit  real(kind=8) (a-h,o-z) 
      real(kind=8),dimension(3)  :: a,b,c,gx,gy,gz,gzr,gxr,gyr,gr,sq
      real(kind=8),dimension(3,3):: r1,r2,r3,r4                    
      real(kind=8),dimension(6,6):: relr
                                                                        
      complex(kind=8),dimension(6,6) :: relax
      complex(kind=8),dimension(3,3) :: rpp,rpm 
      complex(kind=8),dimension(3)   :: gpl,gmn
      real(kind=8),parameter ::  zero=0.d0,one=1.d0,two=2.d0,three=3.0d0,pt5=0.5d0                                                            
      sq2=dsqrt(two) 
      sq3=dsqrt(three) 
      sq5=dsqrt(5.d0) 
      sq10=sq2*sq5 
      o3=one/three 
                                                                        
      st=dsin(tetm) 
      ct=dcos(tetm) 
      sp=dsin(phim) 
      cp=dcos(phim) 
                                                                        
!      write(6,'(a)')'gx,gy,gz'                                         
!      write(6,'(3g12.4)')(gx(j),j=1,3)                                 
!      write(6,'(6g12.4)')(gy(j),j=1,3)                                 
!      write(6,'(6g12.4)')(gz(j),j=1,3)                                 
!      write(6,'(6g12.4)') st,ct,sp,cp                                  
                                                                        
      do i=1,6 
       do j=1,6 
        relr(i,j)=zero 
        relax(i,j)=zero 
       end do
      end do
                                                                  
     do i=1,3 
                                                                        
      gr(i)=sqrt(gz(i)**2*ct**2 + (gx(i)**2*cp**2                       &
            +gy(i)**2*sp**2)*st**2)                                           
      hh=gr(i)+gz(i)*ct 
      if(hh.le.0.d0) then 
       gzr(i)=0.0d0 
       gxr(i)=0.0d0 
       gyr(i)=0.0d0 
!       write(6,'(a,6g12.4)')'gr(i),sq(i)=',gr(i),sq(i),hh              
      else 
       sq(i)=dsqrt(two*gr(i)*(gr(i)+gz(i)*ct)) 
                                                                        
       gzr(i)=(gr(i)+gz(i)*ct)/sq(i) 
       gxr(i)=gx(i)*st*cp/sq(i) 
       gyr(i)=gy(i)*st*sp/sq(i) 
      end if 
      gpl(i)=dcmplx(gxr(i),gyr(i)) 
      gmn(i)=dcmplx(gxr(i),-gyr(i)) 
     end do 
                                                                       
    do i=1,3 
                                                                        
      ai2=a(i)**2 
      bi2=b(i)**2 
      ci2=c(i)**2 
      aibi=a(i)*b(i) 
      aici=a(i)*c(i) 
      bici=b(i)*c(i) 
                                                                        
     do j=1,3 
                                                                        
      aj2=a(j)**2 
      bj2=b(j)**2 
      cj2=c(j)**2 
      ajbj=a(j)*b(j) 
      ajcj=a(j)*c(j) 
      bjcj=b(j)*c(j) 
                                                                        
      r1(i,j)=40.d0*ai2*aj2 + 48.d0*bi2*bj2+                            &
      184.d0*o3*ci2*cj2 + 160.d0*aibi*ajbj+                             &
      400.d0*o3*aici*ajcj + 352.d0*o3*bici*bjcj-                        &
      40.d0*o3*(ai2*bj2+aj2*bi2)-                                       &
      24.d0*(bi2*cj2+bj2*ci2)-                                          &
      16.d0*sq5*(aibi*bjcj+ ajbj*bici)                                  
                                                                       
      r2(i,j)=40.d0*ai2*aj2 + 48.d0*bi2*bj2+                            &
      184.d0*o3*ci2*cj2 + 400.d0*o3*aibi*ajbj+                          &
      400.d0*o3*aici*ajcj+208.d0*o3*bici*bjcj-                          &
      16.d0*sq5*(bi2*ajcj+bj2*aici)                                     
                                                                       
      r3(i,j)=80.d0*o3*(two*aici*ajcj-ai2*cj2-aj2*ci2) +                &
      32.d0*o3*(two*bici*bjcj-bi2*cj2-bj2*ci2)                          
                                                                       
      r4(i,j)=32.d0*o3*sq10*(ci2*ajbj+cj2*aibi-                         &
      aici*bjcj-ajcj*bici)                                              
                                                                       
      rpp(i,j)=gzr(i)**2*(gzr(j)**2*r1(i,j)+gpl(j)*gmn(j)*r3(i,j))+     &
      gzr(i)*gpl(i)*(gzr(j)*gmn(j)*r2(i,j)+gzr(j)*gpl(j)*r4(i,j))+      &
      gzr(i)*gmn(i)*(gzr(j)*gmn(j)*r4(i,j)+gzr(j)*gpl(j)*r2(i,j))+      &
      gmn(i)*gpl(i)*(gzr(j)**2*r3(i,j)+gmn(j)*gpl(j)*r1(i,j))           
                                                                       
      rpm(i,j)=gzr(i)**2*(gzr(j)**2*r3(i,j)+gpl(j)*gmn(j)*r1(i,j))-     &
      gzr(i)*gpl(i)*(gzr(j)*gmn(j)*r2(i,j)+gzr(j)*gpl(j)*r4(i,j))-      &
      gzr(i)*gmn(i)*(gzr(j)*gmn(j)*r4(i,j)+gzr(j)*gpl(j)*r2(i,j))+      &
      gmn(i)*gpl(i)*(gzr(j)**2*r1(i,j)+gmn(j)*gpl(j)*r3(i,j))           
     end do
    end do                                                                        
 
    do i=1,5,2 
     do j=1,5,2 
      ni=int((i-1)/2)+1 
      nj=int((j-1)/2)+1 
                                                                        
      relax(i,j)=rpp(ni,nj) 
     end do
    end do                                                                    
    do i=2,6,2 
      do j=2,6,2 
      ni=int((i-1)/2)+1 
      nj=int((j-1)/2)+1 
      relax(i,j)=rpp(ni,nj) 
     end do
    end do
                                                                   
    do i=2,6,2 
     do j=1,5,2 
      ni=int((i-1)/2)+1 
      nj=int((j-1)/2)+1 
      relax(i,j)=rpm(ni,nj) 
     end do
    end do 
                                                                      
    do i=1,5,2 
     do j=2,6,2 
      ni=int((i-1)/2)+1 
      nj=int((j-1)/2)+1 
      relax(i,j)=rpm(ni,nj) 
     end do
    end do                                                                        
    relnom=-147.d0/8.d0/767.d0 
                                                                        
    do i=1,6 
     do j=1,6 
      relr(i,j)=relnom*dreal(relax(i,j)) 
     end do
    end do                                                                        
    return 
    END                                           
!*************************************************                      
                                                                        
       subroutine sort(e,es,vor,vsort,delt21,delt31,delt32) 
       implicit real(kind=8) (a-h,o-z) 
                                                                        
      integer index(3) 
      real(kind=8),dimension(3)  :: e,es
      real(kind=8),dimension(3,3):: vor,vsort 

      IF(e(1) .LT. e(2)) THEN 
              IF(e(1) .LT. e(3)) then 
       index(1)=1 
              if(e(2) .lt. e(3)) then 
        index(2)=2 
        index(3)=3 
        else 
        index(2)=3 
        index(3)=2 
        endif 
              else 
              index(1)=3 
              index(2)=1 
       index(3)=2 
             endif 
      ELSE IF (e(2) .LT. e(3) ) THEN 
       index(1)=2 
       if(e(1) .lt. e(3)) then 
       index(2)=1 
       index(3)=3 
       else 
       index(2)=3 
       index(3)=1 
       endif 
      else 
       index(1)=3 
       index(2)=2 
       index(3)=1 
      endif 
                                                                        
      do i=1,3 
       j=index(i) 
       es(i)=e(j) 
       do  k=1,3 
        vsort(k,i)=vor(k,j) 
       end do
      end do 
                                                                       
      delt21=es(2)-es(1) 
      delt31=es(3)-es(1) 
      delt32=es(3)-es(2) 
      return 
      END                                           
                                                                        
                                                                        
       subroutine  relax(dtheta,dphi,gx3,gy3,gz3,h11,h22,h33,a_hyp,     &
                   aw,bw,cw,vxx,vyy,vzz,vxy,vxz,vyz,gml,                &
                   n,hf,r,wr,wi,t,u,tl,ul,                              &
                   epk1,epk2,epk3,epk4,epk55,iepk,                      &
                   vl1,vl2,vl3,vl4,vl5,vl6,                             &
                   vr1,vr2,vr3,vr4,vr5,vr6)                             
      implicit none 
      integer    iepk,n,n2,i,j,k,l,id,ik,nd,nr,                       &
                 iki,ikj,in,ini,inj                                   
      real(kind=8):: dtheta,dphi,h11,h22,h33,    &
                     a_hyp,vxx,vyy,vzz,vxy,vxz,vyz, & 
                     gml,gx,gy,gz,ax,ay,az
      real(kind=8),dimension(3)  :: gx3,gy3,gz3,aw,bw,cw
      real(kind=8),dimension(6,6):: relr
      real(kind=8),dimension(8,8):: rel,hyp
                       
      complex(kind=8),dimension(8,8):: vl1,vl2,vl3,vl4,vl5,vl6,vr1,vr2, &
                                         vr3,vr4,vr5,vr6                  
      real(kind=8),dimension(n,n):: hf,r,t,u,tl,ul
      real(kind=8),dimension(n)  :: wr,wi 
      real(kind=8):: epk1,epk2,epk3,epk4,epk55                            
!                                                                       
                                                                        
                                                                        
!       INITIALIZATION OF THE HYPERFINE MATRIX                          
!        write(6,'(8g12.5)')dtheta,dphi,h11,h22,h33,a_hyp               
!        write(6,'(8g12.5)')gx3,gy3                                     
!        write(6,'(8g12.5)')gz3,aw                                      
!        write(6,'(8g12.5)')bw,cw                                       
!        write(6,'(8g12.5)')vxx,vyy,vzz,vxy,vxz,vyz,gml                 
        nd=n*n 
        call zeroar(nd,hf) 
        call zeroar(nd,r) 
                                                                        
!       CALCULATION OF THE HYPERFINE INTERACTION  MATRIX                
        id=n/8 
        if(id.eq.2) then 
         ax=h11 
         ay=h22 
         az=h33 
         gx=gx3(1) 
         gy=gy3(1) 
         gz=gz3(1) 
!        write(6,'(8g12.5)')gx,gy,gz,ax,ay,az                           
!        write(6,'(8g12.5)')                                            
         do  id=1,2 
          call hyperr(id,hyp,rel,gx,gy,gz,ax,ay,az,a_hyp,               &
                 vxx,vyy,vzz,vxy,vxz,vyz,dtheta,dphi)                  
                                                                        
          ik=8*(id-1) 
          do i=1,8 
           do j=1,8 
            k=i+ik 
            l=j+ik 
            hf(k,l)=hyp(i,j) 
            r(k,l)=rel(i,j) 
           end do 
          end do 
!        write(6,'(/,a)')'hyp'                                          
!        write(6,'(16g8.2)')((hyp(i,k),k=1,8),i=1,8)                    
!        write(6,'(/,a)')'rel'                                          
!        write(6,'(16g8.2)')((rel(i,k),k=1,8),i=1,8)                    
                   ! id=2                                               
         end do 
                                                                        
!        RELAXATION IN ITS MOST PRIMITIVE FORM                          
         do i=1,8 
          j=i+8 
          r(i,j)=gml 
          r(j,i)=gml 
          r(i,i)=-gml 
          r(j,j)=-gml 
         end do 
        else if(id.eq.6) then 
                                                                        
         do id=1,6 
          nd=int((id-1)/2)+1 
          nr=(2+id-2*nd) 
          gx=gx3(nd) 
          gy=gy3(nd) 
          gz=gz3(nd) 
          ax=gx*0.5d0 
          ay=gy*0.5d0 
          az=gz*0.5d0 
                                                                        
          call hyperr(nr,hyp,rel,gx,gy,gz,ax,ay,az,a_hyp,               &
                     vxx,vyy,vzz,vxy,vxz,vyz,dtheta,dphi)              
                                                                        
          ik=8*(id-1) 
          do i=1,8 
           do j=1,8 
            k=i+ik 
            l=j+ik 
            hf(k,l)=hyp(i,j) 
            r(k,l)=rel(i,j) 
           end do 
          end do 
                   ! id=1,6                                             
         end do 
!        RELAXATION between Kramers doublets                            
         call relsl(relr,gx3,gy3,gz3,aw,bw,cw,dtheta,dphi) 
                                                                        
         do  i=1,6 
          iki=8*(i-1) 
          do j=1,6 
           ikj=8*(j-1) 
           do in=1,8 
            ini=in+iki 
            inj=in+ikj 
            r(ini,inj)=relr(i,j)*gml 
           end do 
          end do 
         end do 
                      ! id                                              
        end if 
                                                                        
!       CALCULATION OF THE EIGENVALUES AND EIGENVECTORS                 
!        do i=1,n                                                       
!         do k=1,n                                                      
!          hmat(i,k)=dcmplx(hf(i,k),r(i,k))                             
!         end do                                                        
!        end do                                                         
!        write(6,'(/,a)')'hf'                                           
!        write(6,'(16g8.2)')((hf(i,k),k=1,n),i=1,n)                     
!        write(6,'(/,a)')'r'                                            
!        write(6,'(16g8.2)')((r(i,k),k=1,n),i=1,n)                      
!        write(6,'(/,a)')'t'                                            
!        write(6,'(16g8.2)')((t(i,k),k=1,n),i=1,n)                      
!         write(6,'(/,a)')'wr,wi'                                       
!         write(6,'(8g12.4)')(wr(k),k=1,n)                              
!         write(6,'(8g12.4)')(wi(k),k=1,n)                              
         n2=2*n 
         call allvec (n,hf,r,wr,wi,t,u,tl,ul,                           &
                    epk1,epk2,epk3,n2,epk4,epk55,iepk)                 
                                                                        
!        write(6,'(/,a)')'vr*vl'                                        
!        do i=1,n                                                       
!         do k=1,n                                                      
!           hc=(0.,0.)                                                  
!           do j=1,n                                                    
!            hc=hc+dcmplx(tl(i,j),ul(i,j))*dcmplx(t(j,k),u(j,k))        
!           end do                                                      
!          unit(i,k)=hc                                                 
!         end do                                                        
!        end do                                                         
!        write(6,'(16g9.2)')((unit(i,k),k=1,n),i=1,n)                   
                                                                        
!        write(6,'(/,a)')'diag vl*hmat*vr'                              
!        do i=1,n                                                       
!         do k=1,n                                                      
!          hhc=(0.0,0.0)                                                
!          do l=1,n                                                     
!           hc=(0.,0.)                                                  
!           do j=1,n                                                    
!            hc=hc+hmat(l,j)*dcmplx(t(j,k),u(j,k))                      
!           end do                                                      
!           hhc=hhc+dcmplx(tl(i,l),ul(i,l))*hc                          
!          end do                                                       
!          unit(i,k)=hhc                                                
!         end do                                                        
!        end do                                                         
!        write(6,'(16g8.2)')(real(unit(i,i)),i=1,n)                     
!        write(6,'(/,a)')' tl'                                          
!        write(6,'(8g12.4)')((tl(i,k),k=1,n),i=1,n)                     
!        write(6,'(/,a)')' ul'                                          
!        write(6,'(16g8.2)')((ul(i,k),k=1,n),i=1,n)                     
                                                                        
      id=n/8 
      if(id.eq.2) then 
       do  i=1,8 
        do  j=1,8 
         vl1(i,j)=dcmplx(tl(i,j),ul(i,j))+                             &
                  dcmplx(tl(i,j+8),ul(i,j+8))                          
         vl2(i,j)=dcmplx(tl(i+8,j),ul(i+8,j))+                         &
                  dcmplx(tl(i+8,j+8),ul(i+8,j+8))                      
        end do 
       end do 
       do  i=1,8 
        do  j=1,8 
         vr1(i,j)=dcmplx(t(i,j),u(i,j))+                               &
                  dcmplx(t(i+8,j),u(i+8,j))                            
         vr2(i,j)=dcmplx(t(i,j+8),u(i,j+8))+                           &
                  dcmplx(t(i+8,j+8),u(i+8,j+8))                        
        end do 
       end do 
      else if(id.eq.6) then 
       do  i=1,8 
        do  j=1,8 
         vl1(i,j)=dcmplx(tl(i,j),ul(i,j))+                             &
                  dcmplx(tl(i,j+8),ul(i,j+8))+                         &
                  dcmplx(tl(i,j+16),ul(i,j+16))+                       &
                  dcmplx(tl(i,j+24),ul(i,j+24))+                       &
                  dcmplx(tl(i,j+32),ul(i,j+32))+                       &
                  dcmplx(tl(i,j+40),ul(i,j+40))                        
         vl2(i,j)=dcmplx(tl(i+8,j),ul(i+8,j))+                         &
                  dcmplx(tl(i+8,j+8),ul(i+8,j+8))+                     &
                  dcmplx(tl(i+8,j+16),ul(i+8,j+16))+                   &
                  dcmplx(tl(i+8,j+24),ul(i+8,j+24))+                   &
                  dcmplx(tl(i+8,j+32),ul(i+8,j+32))+                   &
                  dcmplx(tl(i+8,j+40),ul(i+8,j+40))                    
         vl3(i,j)=dcmplx(tl(i+16,j),ul(i+16,j))+                       &
                  dcmplx(tl(i+16,j+8),ul(i+16,j+8))+                   &
                  dcmplx(tl(i+16,j+16),ul(i+16,j+16))+                 &
                  dcmplx(tl(i+16,j+24),ul(i+16,j+24))+                 &
                  dcmplx(tl(i+16,j+32),ul(i+16,j+32))+                 &
                  dcmplx(tl(i+16,j+40),ul(i+16,j+40))                  
         vl4(i,j)=dcmplx(tl(i+24,j),ul(i+24,j))+                       &
                  dcmplx(tl(i+24,j+8),ul(i+24,j+8))+                   &
                  dcmplx(tl(i+24,j+16),ul(i+24,j+16))+                 &
                  dcmplx(tl(i+24,j+24),ul(i+24,j+24))+                 &
                  dcmplx(tl(i+24,j+32),ul(i+24,j+32))+                 &
                  dcmplx(tl(i+24,j+40),ul(i+24,j+40))                  
         vl5(i,j)=dcmplx(tl(i+32,j),ul(i+32,j))+                       &
                  dcmplx(tl(i+32,j+8),ul(i+32,j+8))+                   &
                  dcmplx(tl(i+32,j+16),ul(i+32,j+16))+                 &
                  dcmplx(tl(i+32,j+24),ul(i+32,j+24))+                 &
                  dcmplx(tl(i+32,j+32),ul(i+32,j+32))+                 &
                  dcmplx(tl(i+32,j+40),ul(i+32,j+40))                  
         vl6(i,j)=dcmplx(tl(i+40,j),ul(i+40,j))+                       &
                  dcmplx(tl(i+40,j+8),ul(i+40,j+8))+                   &
                  dcmplx(tl(i+40,j+16),ul(i+40,j+16))+                 &
                  dcmplx(tl(i+40,j+24),ul(i+40,j+24))+                 &
                  dcmplx(tl(i+40,j+32),ul(i+40,j+32))+                 &
                  dcmplx(tl(i+40,j+40),ul(i+40,j+40))                  
        end do 
       end do 
                                                                       
       do  i=1,8 
        do  j=1,8 
        vr1(i,j)=(dcmplx(t(i,j),u(i,j))+                               &
                  dcmplx(t(i+8,j),u(i+8,j)))*h11+                      &
                 (dcmplx(t(i+16,j),u(i+16,j))+                         &
                  dcmplx(t(i+24,j),u(i+24,j)))*h22+                    &
                 (dcmplx(t(i+32,j),u(i+32,j))+                         &
                  dcmplx(t(i+40,j),u(i+40,j)))*h33                     
        vr2(i,j)=(dcmplx(t(i,j+8),u(i,j+8))+                           &
                  dcmplx(t(i+8,j+8),u(i+8,j+8)))*h11+                  &
                 (dcmplx(t(i+16,j+8),u(i+16,j+8))+                     &
                  dcmplx(t(i+24,j+8),u(i+24,j+8)))*h22+                &
                 (dcmplx(t(i+32,j+8),u(i+32,j+8))+                     &
                  dcmplx(t(i+40,j+8),u(i+40,j+8)))*h33                 
        vr3(i,j)=(dcmplx(t(i,j+16),u(i,j+16))+                         &
                  dcmplx(t(i+8,j+16),u(i+8,j+16)))*h11+                &
                 (dcmplx(t(i+16,j+16),u(i+16,j+16))+                   &
                  dcmplx(t(i+24,j+16),u(i+24,j+16)))*h22+              &
                 (dcmplx(t(i+32,j+16),u(i+32,j+16))+                   &
                  dcmplx(t(i+40,j+16),u(i+40,j+16)))*h33               
        vr4(i,j)=(dcmplx(t(i,j+24),u(i,j+24))+                         &
                  dcmplx(t(i+8,j+24),u(i+8,j+24)))*h11+                &
                 (dcmplx(t(i+16,j+24),u(i+16,j+24))+                   &
                  dcmplx(t(i+24,j+24),u(i+24,j+24)))*h22+              &
                 (dcmplx(t(i+32,j+24),u(i+32,j+24))+                   &
                  dcmplx(t(i+40,j+24),u(i+40,j+24)))*h33               
        vr5(i,j)=(dcmplx(t(i,j+32),u(i,j+32))+                         &
                  dcmplx(t(i+8,j+32),u(i+8,j+32)))*h11+                &
                 (dcmplx(t(i+16,j+32),u(i+16,j+32))+                   &
                  dcmplx(t(i+24,j+32),u(i+24,j+32)))*h22+              &
                 (dcmplx(t(i+32,j+32),u(i+32,j+32))+                   &
                  dcmplx(t(i+40,j+32),u(i+40,j+32)))*h22               
        vr6(i,j)=(dcmplx(t(i,j+40),u(i,j+40))+                         &
                  dcmplx(t(i+8,j+40),u(i+8,j+40)))*h11+                &
                 (dcmplx(t(i+16,j+40),u(i+16,j+40))+                   &
                  dcmplx(t(i+24,j+40),u(i+24,j+40)))*h22+              &
                 (dcmplx(t(i+32,j+40),u(i+32,j+40))+                   &
                  dcmplx(t(i+40,j+40),u(i+40,j+40)))*h33               
        end do 
       end do 
                                                                       
                                                                       
      end if 
      return 
      END                                           
                                                                        
      subroutine diag(crys,ct,cti,cl,cli,                               &
                n,hf,r,wr,wi,t,u,tl,ul,                                 &
                epk1,epk2,epk3,epk4,epk55,iepk)                         
                                                                        
      implicit none 
      integer    iepk,n,n2,i,j 
      real(kind=8),dimension(3,3):: crys,ct,cti,cl,cli
      real(kind=8),dimension(n,n):: hf,r,t,u,tl,ul
      real(kind=8),dimension(n)  :: wr,wi
      real(kind=8)::  epk1,epk2,epk3,epk4,epk55                            
                                                                        
      do i=1,3 
       do j=1,3 
        hf(i,j)=crys(i,j) 
         r(i,j)=0.0d0 
       end do 
      end do 
                                                                        
!      CALCULATION OF THE ZERO-FIELD SPLITTING                          
       n2=2*n 
       call allvec (n,hf,r,wr,wi,t,u,tl,ul,                             &
                    epk1,epk2,epk3,n2,epk4,epk55,iepk)                 
                                                                        
      do i=1,3 
       do j=1,3 
        ct(i,j)=t(i,j) 
        cti(i,j)=u(i,j) 
        cl(i,j)=tl(i,j) 
        cli(i,j)=ul(i,j) 
       end do 
      end do 
                                                                        
      return 
      END                                           
                                                                        
      subroutine split(dl,rom,crso) 
      implicit real(kind=8) (a-h,o-z) 
      real(kind=8),dimension(3,3):: crso 
      real(kind=8),parameter :: zero=0.d0,one=1.d0,two=2.d0,pt5=0.5d0                                                            
                                                                        
      sq2=dsqrt(two) 
                                                                        
      do  i=1,3 
      do  j=1,3 
       crso(i,j)=zero 
      end do 
      end do 
                                                                        
      crso(1,1)=-pt5 
      crso(1,2)=-one/sq2 
      crso(1,3)=pt5*rom 
      crso(2,1)=crso(1,2) 
      crso(2,2)=dl 
      crso(3,1)=crso(1,3) 
      crso(3,3)=pt5 
                                                                        
      return 
      END                                           
                                                                        
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
! * * * * * * * * * * * * * * * * * * * * * * * * * * *                 
                                                                        
      subroutine sptensor(cu,orf,gx,gy,gz,ax,ay,az,qx,qy,qz,etq) 
      implicit real(kind=8) (a-h,o-z) 
                                                                        
      real(kind=8),dimension(3,3):: cu
      real(kind=8),dimension(3)  :: gx,gy,gz,ax,ay,az,qx,qy,qz,etq                                          
      real(kind=8),parameter :: one=1.d0,two=2.d0,four=4.d0
                                                                        
      sq2=dsqrt(two) 
                                                                        
      cof=0.35d0 
      s=one/7.d0 
      sk=cof+s 
      s3=3.d0*s 
      s21=two*s 
                                                                        
      do  i=1,3 
      ap=cu(1,i) 
      bp=cu(2,i) 
      cp=cu(3,i) 
                                                                        
      a=bp 
      b=(ap+cp)/sq2 
      c=(ap-cp)/sq2 
                                                                        
      qa=a**2 
      qb=b**2 
      qc=c**2 
                                                                        
      gx(i)= two*(qa-qb+qc+two*a*c*orf) 
      gy(i)= two*(qa+qb-qc+two*a*b*orf) 
      gz(i)= two*(qa-qb-qc-two*b*c*orf) 
                                                                        
      ax(i)= four*a*c-sk*( qa-qb+qc)+s3*(one-two*b*(a+c)) 
      ay(i)= four*a*b-sk*( qa+qb-qc)+s3*(one-two*c*(a+b)) 
      az(i)=-four*b*c+sk*(-qa+qb+qc)-s3*(one-two*a*(b+c)) 
                                                                        
      qx(i)= s21*(qa-two*qb+qc) 
      qy(i)= s21*(qa+qb-two*qc) 
      qz(i)= s21*(-two*qa+qb+qc) 
                                                                        
      etq(i)=(qx(i)-qy(i))/qz(i) 
      end do 
      return 
      END                                           
