      subroutine transmatrix(chc,kwin,ledit,info) 
      use glbconst, only: maxtrf,maxss,maxc,maxp,maxpl,maxvaco,maxco,  &
                          maxprd,infotext,nrd,nwr
      use compar, only: maxsto,maxdimco,maxscr
      use comfrm, only: kco,fpstor,cpstor,kcp,p,up,op,ddp,np,nthpl,    &
                        kp,pst,plast,pold,pmin,mc,mrce,mcs,mrces,kpl,  &
                        ncor,mr,mrs,con,ncon,mconcor,mcl,mp,mco,con,   &
                        mpl,mrcet,mcon
      use comscd, only: npanum,kcpst,nmkcp,nmr,nmc,natcon,scratch,     & 
                        helpar,queryar,ext,scratch,fscratch 
      use comeff, only: ncol
      implicit none              
      integer, intent(in) :: kwin,ledit
      integer, intent(out):: info
      character(len=2), intent(inout) :: chc

      character(len=132):: ch132,cp132,querytype,comline,chcom,chin,nametheory
      character(len=80) :: condition,chdf 
      character(len=24) :: chl,chr,ch24,cp24,fprint,cj24
      character(len=16) :: ch16
      character(len=20) :: prompt
      character(len=10) :: cf10  
      character(len=5)  :: chred,chblue
      character(len=4)  :: chnorm
      character(len=3)  :: ch3
      character(len=2)  :: command,ch2
      character(len=7)  :: form
      character(len=1)  :: ch1,ch0

      character(len=16), dimension(maxco):: ncor_h
      character(len=2), dimension(13):: subcom 
      character(len=4), dimension(32):: chf
      integer,          dimension(maxp):: ind
      real, dimension(32):: out

      real         ht,array_tr,alowlimit,rn,rv,uplimit,value                 

     integer      inf_tr,lf,lb,lc,j,mch(132),i,readaline,n_merge,   &
                  i0,i1,i2,i_,ia,ic,ic2,ica,icase,     &
                  ie,ih,ii,ijco,il,im,in1,in2,i_1,inst,ip,ipl,ipos,    &
                  ipv,ir,ircpv,itr,itrdata,iu,iwin,jA,jc,jco,jcr,      &
                  jh,jj,jm,js,js1,jZ,k,k0,kd,ki1,kk,kk1,kk2,kkn,knc,   &
                  knr,l,l1,l_edit,lk,lpp1,lpp2,lq,ls,mcom,mcsk,mkk,kn, &
                  mkk2,mkki,mkkia,mkkib,mkkn,mp1,mpu,nc,ni,nk,nk1,nk2, &
                  nmc2,nmr2,nn,nni,npa2,npak,nr,numi1,numi2,lch,l_,    &
                  ntrimto0,iv,norder

     common/comtr/array_tr(maxtrf),inf_tr(maxprd) 

     logical b_ch,cpdist 
     character(len=1), dimension(:), allocatable :: chyn
     integer, dimension(:), allocatable :: jname
                                                                             
!     ******************************************************************
!                                                                       
!     n1 = number of columns for display on screen (n2=0)               
                                                                        
                                                                        
!     console input                                                     
!                                                                       
!     the following commands are available                              
!                                                                       
!     ***ch*** change value and names of a transformation matrix        
!     ***mp*** merge two parameters (pi,pk)                         
!     ***ip*** insert the product of two parameters (pi,pk)             
!     ***dp*** de_merge parameter pi -> pi,pi+1                   
!     ***pv*** interchange of variables and parameters                  
!     ***cb*** combine transformation matrix mi,mk                      
!     ***sp*** split a transformation matrix into two smaller ones      
!     ***pm*** interchange transformation matrices                      
!     ***rm*** rm matrices of zero dimension                            
!     ***cc*** correlate constants                                      
!     ***ex*** back to command level                                    
!     ***he*** list of these commands                                   
      if(mco.eq.0) then
       write(nwr,'(a)')' there are no transformation matrices '
       return                                                                 
      end if
!      #call savearsp(12) 
      call store_temp(21) 
!      write(6,'(a,i3)')' transmatrix(kwin,ledit=',ledit                
      iwin=1 
      ch0=char(0) 
      i0=ichar('0') 
      chred=char(27)//'[31m' 
      chblue=char(27)//'[34m' 
      chnorm=char(27)//'[0m'//ch0 
                                                                        
      call clearhist() 
      call addhist('he'//ch0) 
  100 continue 
       
       subcom(1)='ch'    !   change
       subcom(2)='mp'    !   merge two parameters (pi,pk)  
       subcom(3)='ip'    !   insert product of parameters 
       subcom(4)='dp'    !   demerge parameter pi -> pi,pi+1 
       subcom(5)='pv'    !   permute  parameters and variables  
       subcom(6)='cb'    !   combine two matrices i,k  
       subcom(7)='sp'    !   split of matrix 
       subcom(8)='pm'    !   permute matrices
       subcom(9)='rm'    !   remove matrices of zero dimension 
       subcom(10)='cc'   !   correlate two constants (ci,ck) 
       subcom(11)='ex'   !   exit
       subcom(12)='he'   !   list of commands
       subcom(13)='cp'   !   replaced by mp                                                                        
  101 continue 
      do i=1,mco 
        kco(i)=i 
      end do 
      mcon=mco 
      jco=0 
      icase=0 
      call combinerm(icase,jco,kwin,l_edit) 
                                                                        
  102 continue 
      if(chc.ne.' ') then 
       cp132=chc 
       chc=' ' 
       write(nwr,'(a)')'                                ' 
      else 
       prompt=chred//'command>'//chnorm//ch0
       cp132=' ' 
   10  i=readaline(mch,prompt) 
       if(i.gt.0) then 
        do j=1,i 
         cp132(j:j)=char(mch(j)) 
        end do 
        call addhist(cp132(:i)//ch0) 
       else 
        write(nwr,'(1x,a1,a3)') char(27),'[2A' 
        goto 10 
       end if 
      end if
 
      call nextchar(cp132,0,ipos,comline,ih) 
      if(comline(1:1).eq.'*'.or.comline(1:1).eq.'q') comline='ex' 
      command=comline(1:2) 
      prompt=chred//'>'//chnorm//ch0 
      goto 103 
                                                                        
      write(nwr,'(a,i2)') ' *** error*** end of data unit',nrd 
      goto 101 
                                                                        
!     command identification                                            
  103 continue 
      do i=1,13 
       if (command.eq.subcom(i)) then 
        inst=i 
        goto 106 
       end if 
      end do 
      goto 102 
                                                                        
  106 if(inst.gt.1)then 
       l_edit=0 
      else 
       l_edit=ledit 
      end if 
                                                                        
       subcom(1)='ch'    !   change
       subcom(2)='mp'    !   merge two parameters (pi,pk)  
       subcom(3)='ip'    !   insert product of parameters 
       subcom(4)='dp'    !   demerge a parameter pi -> pi,pi+1 
       subcom(5)='pv'    !   permute  parameters and variables  
       subcom(6)='cb'    !   combine two matrices i,k  
       subcom(7)='sp'    !   split of matrix 
       subcom(8)='pm'    !   permute matrices
       subcom(9)='rm'    !   remove matrices of zero dimension 
       subcom(10)='cc'   !   correlate two constants (ci,ck) 
       subcom(11)='ex'   !   exit
       subcom(12)='he'   !   list of commands
       subcom(13)='cp'   !   now mp
!     branch acc. to command                                            
!     change,merge,insert,demerge,interchange,combine,split,pmat
!                                      remove,exit,help                 
!             1   2   3   4   5   6   7   8   9    10    11  12  13       
       goto (200,300,400,500,600,700,800,900,1100,1400,1200,1300,1500),inst 
                                                                        
  200  continue 
       jco=jco+1 
!       if(jco.gt.mco) jco=1                                            
       ch1='g' 
       call selmat(jco,ch1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 101 
  210  call  printcp(jco,kwin,l_edit) 
       if(info.gt.0) then 
        call errormessage(info) 
        info=0 
!        write(nwr,'(/,a)') 'an error has occured '                     
        ch1='y' 
        querytype='restore  matrices ' 
        chcom='effi/transmatrix/restore' 
        call yesno(querytype,ch1,chcom,ncol,nrd,nwr) 
        if(ch1.eq.'y') then 
         call store_temp(12) 
        end if 
        goto 100 
       end if 
  250   continue 
        kk=kco(jco) 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
                                                                        
        prompt=chred//'ch>'//chnorm//ch0 
        ch132=' ' 
        i=readaline(mch,prompt)
 
        if(i.gt.0) then 
         do j=1,i 
          ch132(j:j)=char(mch(j)) 
         end do 
         call addhist(ch132(:i)//ch0) 
        end if 
                                                                        
        call nextchar(ch132,0,ipos,cp132,ip) 
        jA=ichar('A') 
        jZ=ichar('Z') 
        ia=ichar('a') 
        in1=ichar(cp132(1:1)) 
        in2=ichar(cp132(2:2)) 
        if(in1.le.jZ.and.in1.ge.jA) in1=in1-jA+ia 
        if(in2.le.jZ.and.in2.ge.jA) in2=in2-jA+ia 
        command=char(in1)//char(in2) 
        call window(iwin) 
  251   if(command.eq.'he') then 
         chcom='effi/transmatrix/ch' 
         call help(chcom) 
         goto 250 
        end if 
                                                                        
        call nextchar(cp132,0,ipos,ch132,ih) 
        ch1=ch132(1:1) 
        if(ch1.eq.'*'.or.ch1.eq.'q') then 
         goto 100 
        end if 
        ircpv=0 
        if(ih.eq.0) ircpv=1 
        if(ch1.eq.'r'.or.ch1.eq.'R') then 
          ircpv=1 
          call trlch(ih,ch132,nn,out) 
          nr=out(1) 
           j=0 
          do i=1,nmr2 
           if(nr.eq.nmr(2+i)) j=j+1 
          end do 
          if(j.eq.0) then 
           write(nwr,'(a,20i3)') ' rows:',(nmr(i+2),i=1,nmr2) 
           goto 250 
          end if 
          nc=nmc(3) 
  243     call nextchar(ch132,ih,ipos,cp132,ip) 
          if(ip.eq.0) goto 246 
          ch1=cp132(1:1) 
          if(ch1.eq.'c'.or.ch1.eq.'C')then 
           call trlch(ip,cp132,nn,out) 
           nc=out(1) 
             j=0 
            do i=1,nmc2 
             if(nc.eq.nmc(2+i)) j=j+1 
            end do 
            if(j.eq.0) then 
             write(nwr,'(a,20i3)') ' columns:',(nmc(i+2),i=1,nmc2) 
             goto 250 
            end if 
           call nextchar(cp132,ip,ipos,ch132,ih) 
           cp132=ch132 
           call fout_a(cp132,chf,lf) 
           call trlch(ih,ch132,nn,out) 
           rv=out(1) 
           mkk=mrces(kk)+(nr-1)*mc(kk)+nc 
           fpstor(mkk)=chf(1) 
           cpstor(mkk)=rv 
           do i=1,nmc2-1 
            if(nc.eq.nmc(i+2)) goto 241 
           end do 
  241      if(i.lt.nmc2) then 
            nc=nmc(i+3) 
           else 
            goto 246 
           end if 
           goto 243 
          else 
           ch132=cp132 
           call fout_a(ch132,chf,lf) 
           call trlch(ip,cp132,nn,out) 
           rv=out(1) 
           call nextchar(cp132,0,ipos,ch132,ih) 
           mkk=mrces(kk)+(nr-1)*mc(kk)+nc 
           fpstor(mkk)=chf(1) 
           cpstor(mkk)=rv 
           do i=1,nmc2-1 
            if(nc.eq.nmc(i+2)) goto 245 
           end do 
  245      if(i.lt.nmc2) then 
            nc=nmc(i+3) 
           else 
            goto 246 
           end if 
           goto 243 
          end if 
  246      call  printcp(jco,kwin,l_edit) 
           goto 250 
        end if 
                                                                        
                                                                        
        if(ch1.eq.'c'.or.ch1.eq.'C') then 
          ircpv=1 
          call trlch(ih,ch132,nn,out) 
          nc=out(1) 
           j=0 
          do i=1,nmc2 
           if(nc.eq.nmc(2+i)) j=j+1 
          end do 
          if(j.eq.0) then 
           write(nwr,'(a,20i3)') ' columns:',(nmc(i+2),i=1,nmc2) 
           goto 250 
          end if 
          nr=nmr(3) 
  253     call nextchar(ch132,ih,ipos,cp132,ip) 
          if(ip.eq.0) goto 256 
          ch1=cp132(1:1) 
          if(ch1.eq.'r'.or.ch1.eq.'R')then 
           call trlch(ip,cp132,nn,out) 
           nr=out(1) 
             j=0 
            do i=1,nmr2 
             if(nr.eq.nmr(2+i)) j=j+1 
            end do 
            if(j.eq.0) then 
             write(nwr,'(a,20i3)') ' rows:',(nmr(i+2),i=1,nmr2) 
             goto 250 
            end if 
           call nextchar(cp132,ip,ipos,ch132,ih) 
           cp132=ch132 
           call fout_a(cp132,chf,lf) 
           call trlch(ih,ch132,nn,out) 
           rv=out(1) 
           mkk=mrces(kk)+(nr-1)*mc(kk)+nc 
           fpstor(mkk)=chf(1) 
           cpstor(mkk)=rv 
           do i=1,nmr2-1 
            if(nr.eq.nmr(i+2)) goto 252 
           end do 
  252      if(i.lt.nmr2) then 
            nr=nmr(i+3) 
           else 
            goto 256 
           end if 
           goto 253 
          else 
           ch132=cp132 
           call fout_a(ch132,chf,lf) 
           call trlch(ip,cp132,nn,out) 
           rv=out(1) 
           call nextchar(cp132,0,ipos,ch132,ih) 
           mkk=mrces(kk)+(nr-1)*mc(kk)+nc 
           fpstor(mkk)=chf(1) 
           cpstor(mkk)=rv 
           do i=1,nmr2-1 
            if(nr.eq.nmr(i+2)) goto 255 
           end do 
  255      if(i.lt.nmr2) then 
            nr=nmr(i+3) 
           else 
            goto 256 
           end if 
           goto 253 
          end if 
  256      call  printcp(jco,kwin,l_edit) 
           goto 250 
        end if 
                                                                        
                                                                        
        if(ch1.eq.'p'.or.ch1.eq.'P') then 
          ircpv=1 
          call trlch(ih,ch132,nn,out) 
          nc=out(1) 
           j=0 
          do i=1,nmc2 
           if(nc.eq.nmc(2+i)) j=j+1 
          end do 
          if(j.eq.0) then 
           write(nwr,'(a,20i3)') ' columns:',(nmc(i+2),i=1,nmc2) 
           goto 250 
          end if 
          call nextchar(ch132,ih,ipos,cp132,ip) 
                                                  !  15.4.02            
          if(ip.gt.1) then 
           ch132=np(kcp(mcs(kk)+nc))(:24) 
           j=index( ch132,'_') 
           do while(ch132(j:j).eq.'_') 
             j=j+1 
           end do 
            np(kcp(mcs(kk)+nc))(j:24)=cp132(1:ip) 
          end if 
                                                                        
!          if(ip.gt.1) np(kcp(mcs(kk)+nc))(:24)=cp132(1:ip)             
           call coexam(jco,info) 
           call  printcp(jco,kwin,l_edit) 
           goto 250 
        end if 
        if(ch1.eq.'v'.or.ch1.eq.'V') then 
          ircpv=1 
          call trlch(ih,ch132,nn,out) 
          nr=out(1) 
           j=0 
          do i=1,nmr2 
           if(nr.eq.nmr(2+i)) j=j+1 
          end do 
          if(j.eq.0) then 
           write(nwr,'(a,20i3)') ' rows:',(nmr(i+2),i=1,nmr2) 
           goto 250 
          end if 
          call nextchar(ch132,ih,ipos,cp132,ip) 
                                                                        
                                             !  15.4.02                 
          if(ip.gt.1) then 
           ch132=nthpl(kpl(mrs(kk)+nr))(:24) 
           j=index( ch132,'_') 
           do while(ch132(j:j).eq.'_') 
             j=j+1 
           end do 
            nthpl(kpl(mrs(kk)+nr))(j:24)=cp132(1:ip) 
          end if 
!          if(ip.gt.1) nthpl(kpl(mrs(kk)+nr))=cp132(1:ip)               
           call coexam(jco,info) 
           call  printcp(jco,kwin,l_edit) 
           goto 250 
        end if 
        if(ircpv.eq.0) then 
         command='he' 
         goto 251 
        end if 
        goto 200 
                                                                        
!     merge two parameters                                          
  300 continue 
       lq=3 
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       chdf='m' 
       chdf(80:80)='#' 
       chin='merge parameters/ correlate variables' 
       helpar(1)='effi/correlation/manually' 
       helpar(2)='effi/correlation/condition' 
       helpar(3)='effi/correlation/by#name' 
       queryar(1)='manually' 
       queryar(2)='by conditions of a selected matrix' 
       queryar(3)='parameters #..__name in all matrices (no enquiry)' 
       call query(lq,lk,chin,chdf) 
       if(lq.eq.0) lq=1 
                                                                        
       if(lq.eq.1) then 
        jco=jco+1 
        call selmat(jco,ch1) 
        if(ch1.eq.'*'.or.ch1.eq.'q') goto 101 
       else if(lq.eq.3) then 
        n_merge=0 
        lf=0 
        do jco=1,mcon 
         nmr(2)=mr(jco) 
         do i=1,mr(jco) 
          nmr(i+2)=i 
         end do 
         nmc(2)=mc(jco) 
         do i=1,mc(jco) 
          nmc(i+2)=i 
         end do 
         call mergeparameter(jco,2,lf,n_merge,condition,info) 
!        write(6,'(a,6i4)')'jco,2,lf,n_merge=',jco,2,lf,n_merge
        end do 
        write(nwr,'(i3,a,i3,a)')n_merge,                             &
         ' parameters #..__name are merged in ',mcon,' matrices' 
        goto 102 
       else if(lq.eq.2) then
        n_merge=0  
        lc=0 
        jco=0 
  301   jco=jco+1 
        if(lc.gt.0)then 
         write(nwr,'(/,a)')' still the condition: '//TRIM(condition) 
        end if 
        call selmat(jco,ch1) 
        if(ch1.eq.'*'.or.ch1.eq.'q') goto 102 
        call  printcp(jco,kwin,l_edit) 
        call mergeparameter(jco,1,lc,n_merge,condition,info) 
!         write(6,'(a,6i4)')'jco,2,lf,n_merge=',jco,2,lf,n_merge
        call  printcp(jco,kwin,l_edit) 
        if(info.gt.0)then 
         call errormessage(info) 
         info=0 
        end if 
        goto 301 
       end if 
                                                                        
                                                                        
        call  printcp(jco,kwin,l_edit) 
        kk=kco(jco) 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
        cpdist=nmc2.eq.nmr2 
!        cpdist=.false.                                                 
        ijco=jco 
        if(mc(kk).lt.2) then 
           j=0 
          do i=ijco,mcon 
            k=kco(i) 
            if(mc(k).gt.1.and.j.eq.0) then 
            j=j+1 
            jco=i-1 
            end if 
          end do 
         if(j.eq.0) then 
          write(nwr,'(a,/)') ' all matrices have only one column' 
          goto 100 
         else 
          write(nwr,'(2a,i2,a,/)')                                      &
     &            ' transformation matrix has one column',              &
     &            ' (take another one: m',kco(jco),')'                  
         goto 300 
         end if 
        end if 
                                                                        
  350  continue 
       write(nwr,'(a)') ' merging parameter i,k-j ...' 
       prompt=chred//'mp>'//chnorm//ch0 
       cp132=' ' 
       i=readaline(mch,prompt) 
       if(i.gt.0) then 
        do j=1,i 
         cp132(j:j)=char(mch(j)) 
        end do 
        call addhist(cp132(:i)//ch0) 
       end if 
                                                                        
       if(cp132.eq.' ') goto 300 
       if(cp132(1:2).eq.'he') then 
        chcom='effi/parameter/corr/mp/list' 
        call help(chcom) 
       end if 
       call window(iwin) 
         call nextchar(cp132,0,ipos,ch132,ih) 
          if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then 
           goto 100 
          else 
           chin=cp132 
           i=1
           call  panum(chin,maxdimco,npanum,i) 
           if(i.ne.1) then
            print'(2a)','error in the list:',TRIM(chin)
            goto 300
           end if         
           if(npanum(2).gt.nmc2)npanum(2)=nmc2 
          end if 
       nn=npanum(2) 
       if(nn.eq.0) goto 300 
       if(nn.lt.2) then 
         write(nwr,'(a)') ' merging at least two parameters ' 
         goto 350 
       end if 
       if(nn.gt.32) then 
         write(nwr,'(a)') ' only 32 at a single step ' 
         goto 350 
       end if 
       if(cpdist)then 
        if(npanum(2).eq.nmc2)then 
         call cpdistribute(0,ht,jco,kwin) 
        else 
         cpdist=.false. 
        end if 
       end if 
                                                                        
       nni=0 
       do while(nn.gt.1) 
        nni=nni+1 
                                                                        
        i1=npanum(3) 
        i2=npanum(4) 
        do j=2,nn-1 
         npanum(j+2)=npanum(j+3)-1 
        end do 
        nn=nn-1 
        npanum(2)=nn-1 
                                                                        
                                                                        
          j=0 
        do i=1,nmc2 
          if(i1.eq.nmc(i+2)) then 
            j=j+1 
            numi1=i 
          end if 
        end do 
        if(j.eq.0) then 
          write(nwr,'(a)') ' only parameters out of the last listing' 
          call  printcp(jco,kwin,l_edit) 
          goto 350 
        end if 
        j=0 
        do i=1,nmc2 
          if(i2.eq.nmc(i+2)) then 
            j=j+1 
            numi2=i 
          end if 
        end do 
        if(j.eq.0) then 
          write(nwr,'(a)') ' only parameters out of the last listing' 
          call  printcp(jco,kwin,l_edit) 
          goto 350 
        end if 
                                                                        
!       merging of parameter i1-i2                                  
        if(nni.eq.1) then 
         ch24=np(nmkcp(numi1)) 
          i_=index(ch24,'_') 
          do while(ch24(i_:i_).eq.'_') 
           i_=i_+1 
          end do 
         call addhist(ch24(i_:)//ch0) 
         write(nwr,'(a)')'common name of ' 
  380    write(nwr,'(a22,a,a22,a1,a12,a1)')                             &
     &   np(nmkcp(numi1)),'and ',np(nmkcp(numi2)),                      &
     &   '[',ch24(i_:),']'                                              
                                                                        
         cp132=' ' 
         i=readaline(mch,prompt) 
         if(i.gt.0) then 
          do j=1,i 
           cp132(j:j)=char(mch(j)) 
          end do 
          call addhist(cp132(:i)//ch0) 
         end if 
         cp24=cp132 
         call window(iwin) 
         if(index(cp24,'*').gt.0.or.cp24(1:2).eq.'q ') goto 100 
         if(cp24.eq.' ') then 
          np(nmkcp(numi1))(1:24)=ch24 
         else 
          ch24(i_:)=cp24 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         goto 380 
         end if 
        end if 
                                                                        
        do i=1,mr(kk) 
         mkk=mrces(kk)+(i-1)*mc(kk) 
         cpstor(mkk+i1)=cpstor(mkk+i1)+cpstor(mkk+i2) 
         lpp1=10*(ichar(fpstor(mkk+i1)(2:2))-i0)+                       &
     &            ichar(fpstor(mkk+i1)(3:3))-i0                         
         lpp2=10*(ichar(fpstor(mkk+i2)(2:2))-i0)+                       &
     &            ichar(fpstor(mkk+i2)(3:3))-i0                         
         if(lpp1.lt.lpp2) fpstor(mkk+i1)(2:3)=fpstor(mkk+i2)(2:3) 
         lpp1=ichar(fpstor(mkk+i1)(4:4)) 
         lpp2=ichar(fpstor(mkk+i2)(4:4)) 
         if(lpp1.lt.lpp2) fpstor(mkk+i1)(4:4)=fpstor(mkk+i2)(4:4) 
        end do 
         mp1=kcp(mcs(kk)+i1) 
         ic2=mcs(kk)+i2 
         mpu=kcp(ic2) 
!         p(mp1)=p(mp1)+p(mpu)                                          
                                                                        
         do i=mpu+1,mp 
            ii=i-1 
            ie=i 
            np(ii)=np(ie) 
             p(ii)=p(ie) 
            up(ii)=up(ie) 
            op(ii)=op(ie) 
           ddp(ii)=ddp(ie) 
            kp(ii)=kp(ie) 
           pst(ii)=pst(ie) 
         plast(ii)=plast(ie) 
          pold(ii)=pold(ie) 
          pmin(ii)=pmin(ie) 
         end do 
        do i=ic2,mp-1 
         kcp(i)=kcp(i+1) 
        end do 
         do i=1,mp-1 
           if(kcp(i).gt.mpu) kcp(i)=kcp(i)-1 
         end do 
         kcp(mp)=0 
         kp(mp)=0 
                                                                        
         js=mrces(kk) 
         jc=js 
        do i=1,mr(kk) 
         do k=1,mc(kk) 
           jc=jc+1 
           js=js+1 
           fscratch(js)=fpstor(jc) 
           scratch(js)=cpstor(jc) 
           if(k.eq.i2) js=js-1 
         end do 
        end do 
        if(kk.lt.mco) then 
         do i=mrces(kk+1)+1,mrcet 
           js=js+1 
          fscratch(js)=fpstor(i) 
          scratch(js)=cpstor(i) 
          end do 
        end if 
                                                                        
         mp=mp-1 
         mc(kk)=mc(kk)-1 
         mrce(kk)=mr(kk)*mc(kk) 
         do j=2,mco 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
          mrcet=mrcet-mr(kk) 
         do i=mrces(kk)+1,mrcet 
          fpstor(i)=fscratch(i) 
          cpstor(i)=scratch(i) 
         end do 
                                                                        
                                                                        
        nmc2=nmc2-1 
        do j=numi2,nmc2 
         nmc(j+2)=nmc(j+3)-1 
        end do 
        nmc(2)=nmc2 
        call coexam(jco,info) 
        if(info.gt.0) goto 210 
                ! nn                                                    
       end do 
                                                                        
       if(cpdist) then 
        ch1='n' 
        querytype='parameter to the column of the nx1 matrix .. ' 
        chcom='effi/transmatrix/cp/nx1' 
        call yesno(querytype,ch1,chcom,ncol,nrd,nwr) 
        if(ch1.eq.'y')                                                  &
     &   call cpdistribute(1,ht,jco,kwin)                         
       end if 
                                                                        
       call printcp(jco,kwin,l_edit) 
       goto 350 
                                                                        
!     insert the product of two parameters pi,pk                        
  400 continue 
        jco=jco+1 
       call selmat(jco,ch1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 101 
        call  printcp(jco,kwin,l_edit) 
        kk=kco(jco) 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
                                                                        
        if(mp.eq.maxp) then 
         write(nwr,'(a,i3,a)') ' *** maximal number (',maxp,            &
     &                            ') of parameters reached'             
         goto 100 
        end if 
        if(mpl+mr(kk).gt.maxpl) then 
         write(nwr,'(a,i3,a)') ' *** maximal number (',maxpl,           &
     &                            ') of variables reached'              
         goto 100 
        end if 
        if(mrcet+mr(kk).gt.maxsto) then 
          write(nwr,'(2a,/,i6,a,i4,a,i4,a1,/,a)')                       &
     & ' total number of elements of',                                  &
     & ' transformation matrices exceeds :', maxsto,                    &
     & ' = max. parameters(',maxp,')* max. variables(',maxpl,')',       &
     & ' help:  splitting of transformation matrices'                   
         goto 100 
        end if 
                                                                        
                                                                        
  450   write(nwr,'(a)') ' product of two parameters  pi*pk: i k' 
        prompt=chred//'ip>'//chnorm//ch0 
        cp132=' ' 
        i=readaline(mch,prompt) 
        if(i.gt.0) then 
         do j=1,i 
          cp132(j:j)=char(mch(j)) 
         end do 
         call addhist(cp132(:i)//ch0) 
        end if 
                                                                        
        if(cp132(1:2).eq.'he') then 
         chcom='effi/transmatrix/ip/sn' 
         call help(chcom) 
        end if 
        call window(iwin) 
        call nextchar(cp132,0,ipos,ch132,ih) 
        if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then 
         goto 100 
        else 
         call trlch(ncol,ch132,nn,out) 
        end if 
        if(nn.eq.0) goto 400 
        if(nn.ne.2) then 
          write(nwr,'(a)') ' *** specify two parameters ' 
          goto 450 
        end if 
         i1=abs(out(2)) 
         i2=abs(out(1)) 
         b_ch=.false. 
         if(i1.lt.i2) then 
          i2=abs(out(2)) 
          i1=abs(out(1)) 
          b_ch=.true. 
         end if 
          j=0 
          k=0 
        do i=1,nmc2 
          if(i1.eq.nmc(i+2)) then 
            j=j+1 
            numi1=i 
          end if 
          if(i2.eq.nmc(i+2)) then 
            k=k+1 
            numi2=i 
          end if 
        end do 
        if(j.eq.0.or.k.eq.0) then 
         write(nwr,'(a)') ' *** only parameters out of the last listing' 
         call  printcp(jco,kwin,l_edit) 
         goto 450 
        end if 
!     introduction of parameter i2=mc(kk)+1                             
                                                                        
        k=mcs(kk)+i1 
        mpu=kcp(k) 
                                                                        
!        write(6,'(4(i2,2x,a,/))')(nmkcp(i),np(nmkcp(i)),i=1,4)         
!        write(6,'(4(i2,2x,a,/))')mpu,np(mpu)                           
                                                                        
        ch24=np(nmkcp(numi1)) 
        if(b_ch) ch24=np(nmkcp(numi2)) 
        lf=1 
        do while(ch24(lf:lf).ne.'_') 
         lf=lf+1 
        end do 
        do while(ch24(lf:lf).eq.'_') 
         lf=lf+1 
        end do 
        cf10=ch24(lf:) 
                                                                        
        lf=10 
        do while(cf10(lf:lf).eq.' ') 
         lf=lf-1 
        end do 
                                                                        
        ch24=np(nmkcp(numi2)) 
        if(b_ch) ch24=np(nmkcp(numi1)) 
        lb=22 
        do while(ch24(lb:lb).eq.' ') 
         lb=lb-1 
        end do 
        ch24=ch24(1:lb)//'*'//cf10 
        if(lf+lb.gt.22) then 
         info=lf+lb 
         infotext(1)='effi/transmatrix/ip/error/sn' 
         infotext(2)=                                                   &
     &      '**error** the product name is too long'                    
         infotext(3)=                                                   &
     &    ' first shorten the name of the factors of the product'       
         infotext(4)=' ' 
         return 
        end if 
                                                                        
        do i=mp+1,k+2,-1 
         kcp(i)=kcp(i-1) 
        end do 
        do i=1,mp+1 
         if(kcp(i).gt.mpu) kcp(i)=kcp(i)+1 
        end do 
        kcp(k+1)=mpu+1 
                                                                        
         do i=mp+1,mpu+1,-1 
            ii=i-1 
            ie=i 
            np(ie)=np(ii) 
             p(ie)=p(ii) 
            up(ie)=up(ii) 
            op(ie)=op(ii) 
           ddp(ie)=ddp(ii) 
         pst(ie)  =   pst(ii) 
         plast(ie)= plast(ii) 
         pold(ie) =  pold(ii) 
         pmin(ie) =  pmin(ii) 
         end do 
                                                                        
         js=mrces(kk) 
         jc=js 
        do i=1,mr(kk) 
         do k=1,mc(kk) 
          jc=jc+1 
          js=js+1 
          fscratch(js)=fpstor(jc) 
          scratch(js)=cpstor(jc) 
          if(k.eq.i1) then 
           js=js+1 
           fscratch(js)=fpstor(jc) 
           scratch(js)=cpstor(jc) 
          end if 
         end do 
        end do 
                                                                        
        if(kk.lt.mco) then 
         do i=mrces(kk+1)+1,mrcet 
           js=js+1 
          fscratch(js)=fpstor(i) 
          scratch(js)=cpstor(i) 
         end do 
        end if 
                                                                        
         mp=mp+1 
         mc(kk)=mc(kk)+1 
         mrce(kk)=mr(kk)*mc(kk) 
         do j=2,mco 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
          mrcet=mrcet+mr(kk) 
         do i=mrces(kk)+1,mrcet 
          fpstor(i)=fscratch(i) 
          cpstor(i)=scratch(i) 
          end do 
                                                                        
        nmc2=nmc2+1 
        if(nmc2.lt.numi1+2) then 
          nmc(3+numi1)=nmc(2+numi1)+1 
        else 
         do j=nmc2,numi1+2,-1 
          nmc(j+2)=nmc(j+1)+1 
         end do 
        end if 
        nmc(2)=nmc2 
                                                                        
        write(nwr,'(a,a22,a)')                                          &
     &   'product parameter [',ch24,'] is introduced'                   
                                                                        
        mcsk=mcs(kk) 
        do i=1,nmc2 
         nmkcp(i)=kcp(mcsk+nmc(i+2)) 
        end do 
        np(nmkcp(numi1+1))(:22)=ch24(:22) 
!       kp(i(jco))=2 ->kp(i(jco))=1            ! Okt 23 11:56:33 CEST 20
        do i=1,nmc2 
         if(kp(nmkcp(i)).eq.2) kp(nmkcp(i))=1 
        end do 
        call coexam(jco,info) 
        if(info.gt.0) goto 210 
        call  printcp(jco,kwin,l_edit) 
       goto 450 
                                                                        
!     de_merge two parameters                                        
  500 continue 
       jco=jco+1 
       call selmat(jco,ch1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 101 
        call  printcp(jco,kwin,l_edit) 
        kk=kco(jco) 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
        cpdist=nmc2.eq.1 
        if(mp.eq.maxp) then 
         write(nwr,'(a,i3,a)')  ' *** maximal number (',maxp,           &
     &                            ') of parameters reached'             
         goto 100 
        end if 
        if(mpl+mr(kk).gt.maxpl) then 
         write(nwr,'(a,i3,a)') ' *** maximal number (',maxpl,           &
     &                            ') of variables reached'              
         goto 100 
        end if 
        if(mrcet+mr(kk).gt.maxsto) then 
          write(nwr,'(2a,i6,/,a,i6,/,a)')                               &
     & ' total number of elements of',                                  &
     & ' transformation matrices exceeds maxsto=', maxsto,              &
     & ' reason:maxsto is less than maxpl*maxp=',maxp*maxpl,            &
     & ' help:  splitting of transformation matrices'                   
         goto 100 
        end if 
                                                                        
        if(mc(kk).ge.mr(kk)) then 
           j=0 
           ica=mcs(kk) 
          do i=1,mc(kk) 
            k=index(np(kcp(ica+i)),'*') 
            if(k.eq.0) j=j+1 
          end do 
         if(j.ge.mr(kk)) then 
          write(nwr,'(a,/)')                                            &
     & ' *** number of parameters already equals number of variables'   
          goto 100 
         end if 
        end if 
                                                                        
  550   continue 
        if(cpdist) then 
         ch1='n' 
         querytype='generating a unit nxn  matrix .. ' 
         chcom='effi/transmatrix/dp/nxn' 
         call yesno(querytype,ch1,chcom,ncol,nrd,nwr) 
         if(ch1.eq.'y') then 
          info=0 
          call decorunit(jco,info) 
          if(info.gt.0)write(nwr,'(a)') '** error occured**: not freed' 
          info=0 
          cpdist=.false. 
!         goto 550                                                      
          call  printcp(jco,kwin,l_edit) 
          goto 100 
         end if 
        end if 
                                                                        
        write(nwr,'(a)') ' dp: decorrelation of parameter i ' 
        read(nrd,'(a)') cp132 
        call window(iwin) 
          call nextchar(cp132,0,ipos,ch132,ih) 
           if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then 
            goto 100 
           else 
            call trlch(ncol,ch132,nn,out) 
           end if 
        if(nn.eq.0) goto 500 
        if(nn.ne.1) then 
          write(nwr,'(a)') ' *** decorrelation of one parameter ' 
          goto 550 
        end if 
         i1=abs(out(1)) 
          j=0 
        do i=1,nmc2 
          if(i1.eq.nmc(i+2)) then 
            j=j+1 
            numi1=i 
          end if 
        end do 
        if(j.eq.0) then 
         write(nwr,'(a)') ' *** only parameters out of the last listing' 
         call  printcp(jco,kwin,l_edit) 
         goto 550 
        end if 
!     decorrelation of parameter i1, introduction of parameter i2=mpu   
        ipl=ncol(1)/30 
        ch1=char(ipl+i0) 
        fprint='('//ch1//'(i3,1x,a24,2x))' 
        il=mp/ipl 
        ir=mp-ipl*il 
                                                                        
        jj=0 
        if(ir.gt.0) then 
         do j=1,il 
          do k=1,ipl 
           jj=jj+1 
           ind(jj)=(k-1)*il+j 
           if(ir.ge.1.and.k.gt.1 ) ind(jj)=ind(jj)+1 
           if(ir.ge.2.and.k.gt.2 ) ind(jj)=ind(jj)+1 
           if(ir.ge.3.and.k.gt.3 ) ind(jj)=ind(jj)+1 
           if(ir.ge.4.and.k.gt.4 ) ind(jj)=ind(jj)+1 
           if(ir.ge.5.and.k.gt.5 ) ind(jj)=ind(jj)+1 
           if(ir.ge.6.and.k.gt.6 ) ind(jj)=ind(jj)+1 
          end do 
         end do 
         do k=1,ir 
          jj=jj+1 
          ind(jj)=k*il+k 
         end do 
        else 
         do j=1,il 
          do k=1,ipl 
           jj=jj+1 
           ind(jj)=(k-1)*il+j 
          end do 
         end do 
        end if 
        write(nwr,fprint) (ind(i),np(ind(i)),i=1,mp) 
                                                                        
        form='i2' 
        k=mcs(kk)+i1 
        value=kcp(k) 
        alowlimit=1 
        uplimit=mp 
        chcom='effi/transmatrix/decorrelate/parameter' 
        querytype=' number of the new parameter ' 
        call  askvallim(querytype,form,                                 &
     &                  alowlimit,uplimit,value,chcom,ncol,nrd,nwr)     
        mpu=value 
                                                                        
        do i=mp+1,k+2,-1 
         kcp(i)=kcp(i-1) 
        end do 
        do i=1,mp+1 
         if(kcp(i).gt.mpu) kcp(i)=kcp(i)+1 
        end do 
        kcp(k+1)=mpu+1 
                                                                        
         do i=mp+1,mpu+1,-1 
            ii=i-1 
            ie=i 
            np(ie)=np(ii) 
             p(ie)=p(ii) 
            up(ie)=up(ii) 
            op(ie)=op(ii) 
            ddp(ie)=ddp(ii) 
            kp(ie)=kp(ii) 
         pst(ie)  =   pst(ii) 
         plast(ie)= plast(ii) 
         pold(ie) =  pold(ii) 
         pmin(ie) =  pmin(ii) 
         end do 
                                                                        
        jc=mrces(kk) 
        do i=1,mr(kk) 
         do k=1,mc(kk) 
          jc=jc+1 
          if(k.eq.i1) then 
           cpstor(jc)=cpstor(jc) 
           ni=(ichar(fpstor(jc)(2:2))-i0)*10+ichar(fpstor(jc)(3:3))-i0 
           if(ni.le.4)fpstor(jc)(3:3)='5' 
           if(ichar(fpstor(jc)(4:4)).eq.i0)fpstor(jc)(4:4)='1' 
          end if 
         end do 
        end do 
        js=mrces(kk) 
        jc=js 
        do i=1,mr(kk) 
         do k=1,mc(kk) 
          jc=jc+1 
          js=js+1 
          scratch(js)=cpstor(jc) 
          fscratch(js)=fpstor(jc) 
          if(k.eq.i1) then 
           js=js+1 
           scratch(js)=cpstor(jc) 
           fscratch(js)=fpstor(jc) 
          end if 
         end do 
        end do 
                                                                        
        if(kk.lt.mco) then 
         do i=mrces(kk+1)+1,mrcet 
           js=js+1 
          scratch(js)=cpstor(i) 
          fscratch(js)=fpstor(i) 
         end do 
        end if 
                                                                        
         mp=mp+1 
         mc(kk)=mc(kk)+1 
         mcsk=mcs(kk) 
         mrce(kk)=mr(kk)*mc(kk) 
         do j=2,mco 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
          mrcet=mrcet+mr(kk) 
         do i=mrces(kk)+1,mrcet 
          cpstor(i)=scratch(i) 
          fpstor(i)=fscratch(i) 
          end do 
                                                                        
        nmc2=nmc2+1 
        if(nmc2.lt.numi1+2) then 
          nmc(3+numi1)=nmc(2+numi1)+1 
        else 
         do j=nmc2,numi1+2,-1 
          nmc(j+2)=nmc(j+1)+1 
         end do 
        end if 
                                                                        
        do i=1,nmc2 
         nmkcp(i)=kcp(mcsk+nmc(i+2)) 
!         write(6,'(i4,a)') i,np(nmkcp(i))                              
        end do 
!        write(6,'(a,16i4)')'nmkcp(1..)=',(nmkcp(i),i=1,nmc2)           
        ie=nmkcp(numi1+1) 
        ii=nmkcp(numi1) 
        p(ie)=p(ii) 
        up(ie)=up(ii) 
        op(ie)=op(ii) 
        ddp(ie)=ddp(ii) 
        pst(ie)  =   pst(ii) 
        plast(ie)= plast(ii) 
        pold(ie) =  pold(ii) 
        pmin(ie) =  pmin(ii) 
                                                                        
        nmc(2)=nmc2 
        ch24=np(nmkcp(numi1)) 
        i_=index(ch24,'_') 
        i_1=i_ 
        do while(ch24(i_:i_).eq.'_') 
         i_=i_+1 
        end do 
                                                                        
        cp24=ch24(:i_-1)//'dc_' 
        ch24=cp24(:i_+2)//np(nmkcp(numi1))(i_:) 
        ch24(23:24)=' ' 
        cp24=ch24(i_:) 
        ch132=cp24 
        querytype=' name of the new parameter' 
        chcom='effi/transmatrix/decorrrelate/name' 
  590   call askstring(querytype,ch132,chcom,ncol,nwr) 
        if(ch132(1:1).eq.'*'.or.ch1.eq.'q') goto 100 
        l=ntrimto0(ch132) 
        np(nmkcp(numi1+1))(i_:24)=ch132(:l) 
        if(cp24(:l).ne.ch132(:l)) then 
         cp24(:l)=ch132(:l) 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         goto 590 
        end if 
                                                                        
        mcsk=mcs(kk) 
        do i=1,nmc2 
         nmkcp(i)=kcp(mcsk+nmc(i+2)) 
        end do 
        do i=1,mp 
         if(kp(i).eq.2) kp(i)=1 
        end do 
        call coexam(0,info) 
!        call coexam(jco,info)                                          
        if(info.gt.0) goto 210 
        call  printcp(jco,kwin,l_edit) 
       goto 550 
                                                                        
               ! new sequence of parameters or variables                
  600 continue 
        jco=jco+1 
       call selmat(jco,ch1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 101 
       call  printcp(jco,kwin,l_edit) 
        kk=kco(jco) 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
                                                                        
  650   continue 
        write(nwr,'(a)') ' new sequence:p or v   i k-j l- etc. ' 
        prompt=chred//'pv>'//chnorm//ch0 
        cp132=' ' 
        i=readaline(mch,prompt) 
        if(i.gt.0) then 
         do j=1,i 
          cp132(j:j)=char(mch(j)) 
         end do 
         call addhist(cp132(:i)//ch0) 
        end if 
                                                                        
        call window(iwin) 
        call nextchar(cp132,0,ipos,ch132,ih) 
        if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 100 
        ipv=0 
        if(ih.eq.0) ipv=1 
                                                                        
!       new sequence of parameters                                      
        ch1=ch132(1:1) 
        if(ch1.eq.'p'.or.ch1.eq.'P') then 
          ipv=1 
          ch132(1:1)=' ' 
          norder=1
          call panum(ch132,mc(kk),npanum,norder)
          if(norder.eq.10) goto 650 
          norder=0
          call panum(ch132,mc(kk),npanum,norder) 
          j=0 
          npa2=npanum(2) 
!         write(6,'(a,i4)') ' npanum=',npa2                             
!         write(6,'(20i4)') (npanum(j),j=1,npa2+2)                      
          do i=3,npa2+2 
           do k=3,nmc2+2 
            if(npanum(i).eq.nmc(k)) j=j+1 
           end do 
          end do 
         if(npa2.gt.32) then 
          write(nwr,'(a)') ' only 32 at a single step ' 
          goto 650 
         end if 
         if(j.eq.0) then 
          write(nwr,'(20i3)') (npanum(i),i=3,npa2+2) 
          write(nwr,'(a)') ' only parameters out of the last listing :' 
          write(nwr,'(20i3)') (nmc(i),i=3,nmc2+2) 
          goto 650 
         end if 
                                                                        
          jh=2 
          do i=3,nmc2+2 
           j=0 
           do k=3,npa2+2 
            if(npanum(k).eq.nmc(i)) j=j+1 
           end do 
            if(j.eq.0) then 
             jh=jh+1 
             npanum(npa2+jh)=nmc(i) 
            end if 
          end do 
                                                                        
        k=mcs(kk) 
        do i=1,mc(kk) 
         kcpst(i)=kcp(k+i) 
        end do 
        do i=1,nmc2 
         kcp(k+nmc(i+2))=kcpst(npanum(i+2)) 
        end do 
                                                                        
        mkk=mrces(kk) 
        do j=mkk+1,mkk+mrce(kk) 
         fscratch(j)=fpstor(j) 
         scratch(j)=cpstor(j) 
        end do 
                                                                        
        do j=1,nmc2 
        do i=1,mr(kk) 
         mkki=mkk+(i-1)*mc(kk) 
         cpstor(mkki+nmc(j+2))=scratch(mkki+npanum(j+2)) 
         fpstor(mkki+nmc(j+2))=fscratch(mkki+npanum(j+2)) 
        end do 
        end do 
          call  printcp(jco,kwin,l_edit) 
       goto 650 
       end if  ! if p  
!       new sequence of variables                                       
        if(ch1.eq.'v'.or.ch1.eq.'V') then 
          ipv=2 
          ch132(1:1)=' ' 
          norder=1
          call panum(ch132,mr(kk),npanum,norder)
          if(norder.eq.10) goto 650 
          norder=0
          call panum(ch132,mr(kk),npanum,norder) 
!         write(6,'(a,i4)') ' npanum=',npanum(2)                        
!         write(6,'(20i4)') (npanum(j),j=1,npanum(2)+2)                 
          j=0 
          npa2=npanum(2) 
          do i=3,npa2+2 
           do k=3,nmr2+2 
            if(npanum(i).eq.nmr(k)) j=j+1 
           end do 
          end do 
         if(npa2.gt.128) then 
          write(nwr,'(a)') ' only 32 at a single step ' 
          goto 650 
         end if 
         if(j.eq.0) then 
          write(nwr,'(20i3)') (npanum(i),i=3,npa2+2) 
          write(nwr,'(a)') ' only variables out of the last listing :' 
          write(nwr,'(20i3)') (nmr(i),i=3,nmr2+2) 
          goto 650 
         end if 
          jh=2 
          do i=3,nmr2+2 
           j=0 
           do k=3,npa2+2 
            if(npanum(k).eq.nmr(i)) j=j+1 
           end do 
            if(j.eq.0) then 
             jh=jh+1 
             npanum(npa2+jh)=nmr(i) 
            end if 
          end do 
                                                                        
        k=mrs(kk) 
        do i=1,mr(kk) 
         kcpst(i)=kpl(k+i) 
        end do 
        do i=1,nmr2 
         kpl(k+nmr(i+2))=kcpst(npanum(i+2)) 
        end do 
                                                                        
        mkk=mrces(kk) 
        do j=mkk+1,mkk+mrce(kk) 
         fscratch(j)=fpstor(j) 
         scratch(j)=cpstor(j) 
        end do 
                                                                        
        do i=1,nmr2 
         mkkia=mkk+(nmr(i+2)-1)*mc(kk) 
         mkkib=mkk+(npanum(i+2)-1)*mc(kk) 
        do j=1,mc(kk) 
         fpstor(mkkia+j)=fscratch(mkkib+j) 
         cpstor(mkkia+j)=scratch(mkkib+j) 
        end do 
        end do 
          call  printcp(jco,kwin,l_edit) 
       goto 650 
       end if  ! if v     
       if(ipv.eq.0) write(nwr,'(a,/)')                                  &
     &            ' command starts with letter p or v'                  
      goto 600 
                                                                        
                                                                        
!     combine two transformation matrices mi and mk                     
  700 continue 
       if(mcon.eq.1) then 
        write(nwr,'(a)') ' *** no further matrix to combine' 
        goto 100 
       end if 
         do j=1,mcon 
         nmr(2)=mr(j) 
         do i=1,mr(j) 
          nmr(i+2)=i 
         end do 
         nmc(2)=mc(j) 
         do i=1,mc(j) 
          nmc(i+2)=i 
         end do 
        end do                                                                         
!       write(6,'(a,3x,20i4)')' nmc2=',(nmc(i),i=1,20) 

       lq=2 
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       chdf='m' 
       chdf(80:80)='#' 
       chin='combining matrices' 
       helpar(1)='effi/combine/manually' 
       helpar(2)='effi/combine/condition' 
       queryar(1)='manually' 
       queryar(2)='by several conditions ' 
       call query(lq,lk,chin,chdf) 
       if(lq.eq.0) lq=1 
       if(lq.eq.2) then 
        call combinerm(lq,jco,kwin,l_edit) 
        goto 102 
       end if
 
                                                                      
       jco=jco+1 
       form='i2' 
       do k=1,mcon 
        kk=kco(k) 
        rn=mr(kk) 
        call trlnu(form,rn,chr,nn,chl,im) 
        ch3=chl(1:im) 
        jm=im 
        rn=mc(kk) 
        call trlnu(form,rn,chr,nn,chl,im) 
        ext(k)='('//ch3(1:jm)//'x'//chl(1:im)//')' 
        queryar(k)=TRIM(ncor(kk)) 
        helpar(k)='effi/transmatrix/matrix/combine' 
       end do 
       ch16=ncor(kco(jco)) 
       lk=0 
       lq=mcon 
       ch16(16:16)='#' 
!      write(6,'(a,2i4)') ' corr npl,mcon=',npl,mcon                    
       chin=' combine matrices [.1.] and {.2.}' 
       chin(132:132)='l'                    ! 15.4.02  
       call query2(lq,lk,chin,ch16) 
       if(lq.gt.0.and.lk.gt.0) then 
        i2=lk 
        i1=lq 
        jco=lq 
       else 
        goto 101 
       end if 
!       write(6,'(a,3i5)') '  i1,i2=',i1,i2                             
!       combination of matrices i1 and i2                               
                                                                        
        ch132=ncor(kco(i1)) 
        cp132=ncor(kco(i2)) 
        if(index(ch132,'@v')+index(cp132,'@v').gt.0) then 
         chcom='effi/transmatrix/combine/@name' 
         call help(chcom) 
         goto 700 
        end if 
                                                                        
        querytype=TRIM(ch132)//' and '//TRIM(cp132)//' combined; new matrix'
        chcom='effi/transmatrix/combine/name' 
        call askstring(querytype,ch132,chcom,ncol,nwr) 
        if(ch132(1:1).eq.'*'.or.ch132(1:2).eq.'q ') goto 101 
        ncor(kco(i1))=ch132 
                                                                        
        nmr2=nmr(2) 
        nmc2=nmc(2) 
        if (i1.gt.i2) then 
          ncor(kco(i2))=ch132 
          nn=i1 
          i1=i2 
          i2=nn 
          jco=i1 
          kk=kco(i1) 
          kk2=kco(i2) 
          nmc2=nmc2+mc(kk) 
          do j=1,nmc(2)+2 
           kcpst(j)=nmc(j) 
          end do 
          do j=1,mc(kk) 
           nmc(j+2)=j 
          end do 
           i=0 
          do j=mc(kk)+3,nmc2+2 
           i=i+1 
           nmc(j)=mc(kk)+kcpst(i+2) 
          end do 
          nmr2=nmr2+mr(kk) 
          do j=1,nmr(2)+2 
           kcpst(j)=nmr(j) 
          end do 
          do j=1,mr(kk) 
           nmr(j+2)=j 
          end do 
          i=0 
          do j=mr(kk)+3,nmr2+2 
           i=i+1 
           nmr(j)=mr(kk)+kcpst(i+2) 
          end do 
        else 
          kk=kco(i1) 
          kk2=kco(i2) 
          nmc2=nmc2+mc(kk2) 
           i=0 
          do j=nmc(2)+3,nmc2+2 
           i=i+1 
           nmc(j)=mc(kk)+i 
          end do 
          nmr2=nmr2+mr(kk2) 
          i=0 
          do j=nmr(2)+3,nmr2+2 
           i=i+1 
           nmr(j)=mr(kk)+i 
          end do 
        end if 
          nmc(2)=nmc2 
          nmr(2)=nmr2 
                                                                        
          do i=1,mp 
           kcpst(i)=kcp(i) 
          end do 
          nk1=mcs(kk+1) 
          nk2=nk1+mc(kk2) 
          j=mcs(kk2) 
          do i=nk1+1,nk2 
           j=j+1 
           kcp(i)=kcpst(j) 
          end do 
                                                                        
         j=nk2 
         ki1=kco(i1) 
         do k=i1+1,mcon 
            kk1=kco(k) 
          if(k.ne.i2) then 
            do i=1,mc(kk1) 
             j=j+1 
             kcp(j)=kcpst(mcs(kk1)+i) 
            end do 
           end if 
         end do 
                                                                        
          do i=1,mpl 
           kcpst(i)=kpl(i) 
          end do 
          nk1=mrs(kk+1) 
          nk2=nk1+mr(kk2) 
          j=mrs(kk2) 
          do i=nk1+1,nk2 
           j=j+1 
           kpl(i)=kcpst(j) 
          end do 
                                                                        
         j=nk2 
         do k=i1+1,mcon 
            kk1=kco(k) 
          if(k.ne.i2) then 
            do i=1,mr(kk1) 
             j=j+1 
             kpl(j)=kcpst(mrs(kk1)+i) 
            end do 
           end if 
         end do 
                                                                        
        mkk=mrces(kk) 
        js=mkk 
        do ir=1,mr(kk) 
         mkki=mkk+(ir-1)*mc(kk) 
         do ic=1,mc(kk) 
          js=js+1 
          scratch(js)=cpstor(mkki+ic) 
          fscratch(js)=fpstor(mkki+ic) 
         end do 
         do ic=1,mc(kk2) 
          js=js+1 
          scratch(js)=0.0 
          fscratch(js)='f031' 
         end do 
        end do 
                                                                        
        mkk2=mrces(kk2) 
        do ir=1,mr(kk2) 
        do ic=1,mc(kk) 
         js=js+1 
         scratch(js)=0.0 
         fscratch(js)='f031' 
        end do 
        mkki=mkk2+(ir-1)*mc(kk2) 
        do ic=1,mc(kk2) 
         js=js+1 
         scratch(js)=cpstor(mkki+ic) 
         fscratch(js)=fpstor(mkki+ic) 
        end do 
        end do 
                                                                        
        do k=kk+1,mco 
        if(k.ne.kk2) then 
          mkk=mrces(k) 
          do j=mkk+1,mkk+mrce(k) 
           js=js+1 
           scratch(js)=cpstor(j) 
           fscratch(js)=fpstor(j) 
          end do 
        end if 
        end do 
                                                                        
         mc(kk)=mc(kk)+mc(kk2) 
         mc(kk2)=0 
         mr(kk)=mr(kk)+mr(kk2) 
         mr(kk2)=0 
         mrce(kk)=mr(kk)*mc(kk) 
         mrce(kk2)=0 
         do j=2,mco 
          mrs(j)=mrs(j-1)+mr(j-1) 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
         mrcet=mrces(mco)+mrce(mco) 
         do i=mrces(kk)+1,mrcet 
          cpstor(i)=scratch(i) 
          fpstor(i)=fscratch(i) 
         end do 
                                                                        
       do i=1,maxco 
        kco(i)=0 
       end do 
                                                                        
      do i=1,mco 
        kco(i)=i 
      end do 
      mcon=mco 
                                                                        
!      jj=0                                                             
!      do i=1,maxco                                                     
!      if(mc(i).gt.0) then                                              
!        jj=jj+1                                                        
!        kco(jj)=i                                                      
!      end if                                                           
!      end do                                                           
!      mcon=jj                                                          
                                                                        
!      j=mcon                                                           
!      do i=1,maxco                                                     
!      if(mc(i).eq.0) then                                              
!        j=j+1                                                          
!        kco(j)=i                                                       
!      end if                                                           
!      end do                                                           
                                                                        
       call coexam(0,info) 
!      write(6,'(a,i4)')' goto 210 corr jco=',jco                       
       if(info.gt.0) goto 210 
                                                                        
      nmr(2)=mr(kk) 
      do i=1,mr(kk) 
       nmr(i+2)=i 
      end do 
      nmc(2)=mc(kk) 
      do i=1,mc(kk) 
       nmc(i+2)=i 
      end do 
!      write(6,'(a,i4)')' corr jco=',jco                                
      call  printcp(jco,kwin,l_edit) 
      write(nwr,'(a)') 
      goto 700 
                                                                        
!      split a transformation matrix                                    
  800 continue 
        jco=jco+1 
        call selmat(jco,ch1) 
        if(ch1.eq.'*'.or.ch1.eq.'q') goto 101 
        if(index(ncor(kco(jco)),'@v').gt.0) then 
         chcom='effi/transmatrix/split/@name' 
         call help(chcom) 
         goto 800 
        end if 
        call  printcp(jco,kwin,l_edit) 
        kk=kco(jco) 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
        if(nmr2.le.1.or.nmc2.le.1) then 
         write(nwr,'(a,/)')                                             &
     &         ' *** row and column numbers must be greater 1'          
         goto 800 
        end if 
                                                                        
  850   if(mcon.eq.maxco) then 
        write(nwr,'(a)')' *** no empty transformation matrix available' 
        goto 100 
        end if 
        write(nwr,'(a)') ' splitting of the matrix at vi,pk  ' 
                                                                        
        prompt=chred//'sp>'//chnorm//ch0 
        cp132=' ' 
        i=readaline(mch,prompt) 
        if(i.gt.0) then 
         do j=1,i 
          cp132(j:j)=char(mch(j)) 
         end do 
         call addhist(cp132(:i)//ch0) 
        end if 
                                                                        
        call window(iwin) 
          call nextchar(cp132,0,ipos,ch132,ih) 
           if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then 
            goto 100 
           else 
            call trlch(ncol,ch132,nn,out) 
           end if 
        if(nn.eq.0) goto 800 
        if(nn.eq.1) then 
          write(nwr,'(a)') ' *** pk number is missing ' 
          goto 850 
        end if 
         i1=out(1) 
         i2=out(2) 
         kk=kco(jco) 
        if(i1.le.1.or.i2.le.1) then 
         write(nwr,'(a)') ' *** vi,pk numbers must be greater 1' 
         goto 850 
        end if 
        if (i1.gt.mr(kk)) then 
         write(nwr,'(a,i2,a)') ' *** value ',i1,' does not exist' 
         goto 850 
        end if 
        if (i2.gt.mc(kk)) then 
         write(nwr,'(a,i2,a)') ' *** parameter ',i2,' does not exist' 
         goto 850 
        end if 
                                                                        
        ls=0 
        do k=i2,mc(kk) 
         j=kcp(mcs(kk)+k) 
         l=index(np(j),'*') 
         if(l.gt.1) ls=ls+1 
        end do 
        if(mc(kk)-i2-ls.gt.mr(kk)-i1) then 
         write(nwr,'(2a)') ' *** lower matrix: number of parameters >', &
     &    ' number of variables'                                        
         goto 850 
        end if 
        ls=0 
        do k=1,i2-1 
         j=kcp(mcs(kk)+k) 
         l=index(np(j),'*') 
         if(l.gt.1) ls=ls+1 
        end do 
        if(i2-ls.gt.i1) then 
         write(nwr,'(2a)') ' *** upper matrix: number of parameters >', &
     &    ' number of variables'                                        
         goto 850 
        end if 
                                                                        
!       splitting of the matrix                                         
                                                                        
          i=0 
          do j=3,nmc2+2 
           if(nmc(j).ge.i2) goto 852 
           i=i+1 
          end do 
  852     nmc2=i 
                                                                        
                                                                        
          i=0 
          do j=3,nmr2+2 
           if(nmr(j).ge.i1) goto 854 
           i=i+1 
          end do 
  854     nmr2=i 
          nmc(2)=nmc2 
          nmr(2)=nmr2 
                                                                        
        nk=0 
        mkk=mrces(kk) 
        do i=1,i1-1 
         mkki=mkk+(i-1)*mc(kk) 
        do j=i2,mc(kk) 
         if(cpstor(mkk+j).ne.0.0) nk=nk+1 
        end do 
        end do 
        do i=i1,mr(kk) 
         mkki=mkk+(i-1)*mc(kk) 
        do j=1,i2-1 
          if(cpstor(mkki+j).ne.0.0) nk=nk+1 
        end do 
        end do 
        if(nk.gt.0) write(nwr,'(a,/,i2,a,/)') ' **matrix** ',nk,   &
          ' value(s) of the matrix (different from 0.0) will be lost'     
                                                                        
        do k=1,maxco 
          if(mc(k).eq.0) goto 856 
        end do 
  856   k0=k 
        if(k0.lt.kk) then 
          js=mrces(k0) 
          js1=js+1 
          mkk=mrces(kk) 
          do i=i1,mr(kk) 
           mkki=mkk+(i-1)*mc(kk) 
          do j=i2,mc(kk) 
            js=js+1 
           scratch(js)=cpstor(mkki+j) 
           fscratch(js)=fpstor(mkki+j) 
          end do 
          end do 
          do k=k0+1,mco 
           if(k.eq.kk) then 
            do ir=1,i1-1 
             mkki=mrces(kk)+(ir-1)*mc(kk) 
             do ic=1,i2-1 
              js=js+1 
              scratch(js)=cpstor(mkki+ic) 
              fscratch(js)=fpstor(mkki+ic) 
             end do 
            end do 
           else 
            mkk=mrces(k) 
            do j=mkk+1,mkk+mrce(k) 
              js=js+1 
              scratch(js)=cpstor(mkk+j) 
              fscratch(js)=fpstor(mkk+j) 
            end do 
           end if 
          end do 
        else 
          mkk=mrces(kk) 
          js=mkk 
          js1=js+1 
          do ir=1,i1-1 
           mkki=mkk+(ir-1)*mc(kk) 
          do ic=1,i2-1 
            js=js+1 
           scratch(js)=cpstor(mkki+ic) 
           fscratch(js)=fpstor(mkki+ic) 
          end do 
          end do 
          do k=kk+1,mco+1 
           if(k.eq.k0) then 
            do ir=i1,mr(kk) 
             mkki=mrces(kk)+(ir-1)*mc(kk) 
             do ic=i2,mc(kk) 
              js=js+1 
              scratch(js)=cpstor(mkki+ic) 
              fscratch(js)=fpstor(mkki+ic) 
             end do 
            end do 
           else 
            if(k.lt.mco+1) then 
             mkk=mrces(k) 
             do j=mkk+1,mkk+mrce(k) 
              js=js+1 
              scratch(js)=cpstor(j) 
              fscratch(js)=fpstor(j) 
             end do 
            end if 
           end if 
          end do 
        end if
 
        if(k0.eq.mco+1) mco=mco+1 
                                                                        
          do i=1,mp 
           kcpst(i)=kcp(i) 
          end do 
          nk1=mcs(kk)+i2-1 
          if(kco(mcon).gt.kk) then 
            j=mcs(kk+1) 
            do i=nk1+1,mp 
             j=j+1 
             kcp(i)=kcpst(j) 
            end do 
          end if 
                                                                        
          kd=(mc(kk)-i2+1) 
           if(k0.eq.1) then 
            k=0 
           else 
            k=mcs(k0-1)+mc(k0-1) 
            if(k0.gt.kk) k=k-kd 
           end if 
          do i=mp,k+kd+1,-1 
           kcp(i)=kcp(i-kd) 
          end do 
          do i=1,kd 
           kcp(k+i)=kcpst(nk1+i) 
          end do 
                                                                        
          do i=1,mpl 
           kcpst(i)=kpl(i) 
          end do 
          nk1=mrs(kk)+i1-1 
          if(kco(mcon).gt.kk) then 
            j=mrs(kk+1) 
            do i=nk1+1,mpl 
             j=j+1 
             kpl(i)=kcpst(j) 
            end do 
          end if 
                                                                        
          kd=(mr(kk)-i1+1) 
           if(k0.eq.1) then 
            k=0 
           else 
            k=mrs(k0-1)+mr(k0-1) 
            if(k0.gt.kk) k=k-kd 
           end if 
          do i=mpl,k+kd+1,-1 
           kpl(i)=kpl(i-kd) 
          end do 
          do i=1,kd 
           kpl(k+i)=kcpst(nk1+i) 
          end do 
                                                                        
         mr(k0)=mr(kk)-i1+1 
         mc(k0)=mc(kk)-i2+1 
         mr(kk)=i1-1 
         mc(kk)=i2-1 
         mrce(kk)=mr(kk)*mc(kk) 
         mrce(k0)=mr(k0)*mc(k0) 
         do j=2,mco 
          mrs(j)=mrs(j-1)+mr(j-1) 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
         mrcet=mrces(mco)+mrce(mco) 
         do i=js1,mrcet 
          cpstor(i)=scratch(i) 
          fpstor(i)=fscratch(i) 
         end do 
        j=16 
        ch1=' ' 
        ch16=ncor(kk) 
        do while (ch1.eq.' ') 
          ch1=ch16(j:j) 
        j=j-1 
        end do 
        j=j+1 
        if(j.gt.13) j=13 
        ch16=ch16(1:j)//'_1' 
        ch132=ncor(kk) 
        l1=ntrimto0(ch132) 
        querytype=ch132(:l1)//' is split into new matrix 1 ' 
        cp132=ch16 
        chcom='effi/transmatrix/split/name' 
        call askstring(querytype,cp132,chcom,ncol,nwr) 
        if(cp132(1:1).eq.'*'.or.cp132(1:1).eq.'q') goto 101 
        ncor(kk)=cp132 
        querytype=ch132(:l1)//' is split into new matrix 2 ' 
        ch132=ch132(:l1) 
        call askstring(querytype,ch132,chcom,ncol,nwr) 
        if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 101 
        ncor(k0)=ch132 
                                                                        
       do i=1,maxco 
        kco(i)=0 
       end do 
       do i=1,mco 
         kco(i)=i 
       end do 
       mcon=mco 
                                                                        
!      jj=0                                                             
!      do i=1,maxco                                                     
!      if(mc(i).gt.0) then                                              
!        jj=jj+1                                                        
!        kco(jj)=i                                                      
!      end if                                                           
!      end do                                                           
!      mcon=jj                                                          
                                                                        
!      j=mcon                                                           
!      do i=1,maxco                                                     
!      if(mc(i).eq.0) then                                              
!        j=j+1                                                          
!        kco(j)=i                                                       
!      end if                                                           
!      end do                                                           
                                                                        
       call coexam(0,info) 
       if(info.gt.0) goto 210 
       write(nwr,'(/,2a)') ' matrix: ',ncor(kk) 
       call  printcp(kk,kwin,l_edit) 
       nmr(2)=mr(k0) 
       do i=1,mr(k0) 
        nmr(i+2)=i 
       end do 
       nmc(2)=mc(k0) 
       do i=1,mc(k0) 
        nmc(i+2)=i 
       end do 
       write(nwr,'(/,2a)') ' new matrix: ',ncor(k0) 
       call  printcp(k0,kwin,l_edit) 
       write(nwr,'(a)') 
       goto 800 
                                                                        
!      new sequence of transformation matrices                             
  900  continue 
       form='i2' 
       do k=1,mcon 
        kk=kco(k) 
        ch132=ncor(kk) 
        l=ntrimto0(ch132) 
        rn=kk 
        call trlnu(form,rn,chr,nn,chl,im) 
        ext(k)='('//chl(1:im)//')' 
        queryar(k)=ch132(:l) 
        helpar(k)='effi/transmatrix/sequence' 
       end do 
       ch16=' ' 
       lq=mcon 
       lk=lq 
       ch16(16:16)='#' 
       chin=' ' 
       chin(132:132)='l' 
       call query2(lq,lk,chin,ch16) 
       if(lq.eq.0) goto 101 
                                                                        
  950 continue 
      write(nwr,'(a)') ' new sequence of matrices:   i k-j l- etc. ' 
        prompt=chred//'pm>'//chnorm//ch0 
        cp132=' ' 
        i=readaline(mch,prompt) 
        if(i.gt.0) then 
         do j=1,i 
          cp132(j:j)=char(mch(j)) 
         end do 
         call addhist(cp132(:i)//ch0) 
        end if 
                                                                        
        call window(iwin) 
          call nextchar(cp132,0,ipos,ch132,ih) 
           if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 100 
                                                                        
!       new sequence of parameters                                      
         i=1
         call panum(ch132,mcon,npanum,i) 
         if(i.ne.1) then
          print'(2a)','error in the list:',TRIM(ch132)
          goto 950
         end if         
         i=0
         call panum(ch132,mcon,npanum,i) 
         if(i.ne.0) then
          print'(2a)','error in the list:',TRIM(ch132)
          goto 950
         end if         
        npa2=npanum(2) 
        j=0 
        do i=3,npa2+2 
         nn=npanum(i) 
         if(nn.lt.1.or.nn.gt.mcon) j=j+1 
        end do 
        if(npa2.gt.32) then 
         write(nwr,'(a)') ' only 32 at a single step ' 
         goto 950 
        end if 
                                                                        
        if(j.gt.0) then 
         write(nwr,'(20i3)') (npanum(i),i=3,npa2+2) 
         write(nwr,'(a,i2)')                                            &
     &       ' *** only matrices out of the list : 1 -',mcon            
         goto 950 
        end if 
                                                                        
        jh=2 
        do i=1,mcon 
         j=0 
         do k=3,npa2+2 
          if(npanum(k).eq.i) j=j+1 
         end do 
          if(j.eq.0) then 
           jh=jh+1 
           npanum(npa2+jh)=i 
          end if 
        end do 
        npanum(2)=mcon 
                                                                        
        do i=1,mp 
         kcpst(i)=kcp(i) 
        end do 
                                                                        
        jh=0 
        do i=1,mcon 
          kn=kco(npanum(2+i)) 
          knc=mc(kn) 
          do k=1,knc 
           jh=jh+1 
           kcp(jh)=kcpst(mcs(kn)+k) 
          end do 
        end do 
        do i=1,mpl 
         kcpst(i)=kpl(i) 
        end do 
                                                                        
        jh=0 
        do i=1,mcon 
          kn=kco(npanum(2+i)) 
          knr=mr(kn) 
          do k=1,knr 
           jh=jh+1 
           kpl(jh)=kcpst(mrs(kn)+k) 
          end do 
        end do 
                                                                        
        js=0 
        do k=1,mcon 
           npak=npanum(2+k) 
           kk=kco(k) 
           kkn=kco(npak) 
           mkkn=mrces(kkn) 
           do j=mkkn+1,mkkn+mrce(kkn) 
            js=js+1 
            scratch(js)=cpstor(j) 
            fscratch(js)=fpstor(j) 
           end do 
         end do 
                                                                        
        do i=1,mcon 
         kcpst(i)=mc(kco(i)) 
        end do 
        do i=1,mcon 
         mc(kco(i))=kcpst(npanum(i+2)) 
        end do 
        do i=1,mcon 
         kcpst(i)=mr(kco(i)) 
        end do 
        do i=1,mcon 
         mr(kco(i))=kcpst(npanum(i+2)) 
        end do 
        do i=1,mcon 
         ncor_h(i)=ncor(kco(i)) 
        end do 
        do i=1,mcon 
         ncor(kco(i))=ncor_h(npanum(i+2)) 
        end do 
                                                                        
         do j=1,mco 
          mrce(j)=mr(j)*mc(j) 
         end do 
         do j=2,mco 
          mrs(j)=mrs(j-1)+mr(j-1) 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
         mrcet=mrces(mco)+mrce(mco) 
         do i=1,mrcet 
          cpstor(i)=scratch(i) 
          fpstor(i)=fscratch(i) 
         end do
       call coexam(0,info) 
       if(info.gt.0) goto 210 
       goto 900 
                                                                        
 1000  continue 
       if(mcon.eq.1) then 
        write(nwr,'(a)') ' *** no further matrix to assign' 
        goto 100 
       end if 
                                                                        
       i=0 
       do while(i.eq.0.and.jco.lt.mcon) 
        jco=jco+1 
        kk=kco(jco) 
        i=index(ncor(kk),'@') 
       end do 
       if(jco.eq.mcom) then 
        write(nwr,'(a)')' no matrix of type @v found' 
        goto 102 
       end if 
                                                                        
       form='i2' 
       do k=1,mcon 
        kk=kco(k) 
        ch132=ncor(kk) 
        rn=mr(kk) 
        call trlnu(form,rn,chr,nn,chl,im) 
        ch2=chl(1:im) 
        jm=im 
        rn=mc(kk) 
        call trlnu(form,rn,chr,nn,chl,im) 
        ext(k)='('//ch3(1:jm)//'x'//chl(1:im)//')' 
        queryar(k)=TRIM(ch132) 
        helpar(k)='effi/transmatrix/matrix@/assign' 
       end do 
       ch16=ncor(kco(jco)) 
       lk=0 
       lq=mcon 
       ch16(16:16)='#' 
!      write(6,'(a,2i4)') ' corr npl,mcon=',npl,mcon                    
       chin=' assign matrix [.1@.] to be mapped on to matrix {.2.}' 
       call query2(lq,lk,chin,ch16) 
       if(lq.gt.0.and.lk.gt.0) then 
        i2=lk 
        i1=lq 
       else 
        goto 101 
       end if 
!       write(6,'(a,3i5)') '  i1,i2=',i1,i2                             
!       combination of matrices i1 and i2                               
                                                                        
       i=index(ncor(kco(i1)),'@') 
       if(i.eq.0) then 
        chcom='effi/transmatrix/assign/1@' 
        call help(chcom) 
        goto 1000 
       end if 
       i=index(ncor(kco(i2)),'@') 
       if(i.gt.0) then 
        chcom='effi/transmatrix/assign/2@' 
        call help(chcom) 
        goto 1000 
       end if 
       itr=kco(i1) 
!      subroutine infstrth(ico,ithstr,icase,property,nametheory,itrdata)
       call infstrth(itr,chin,nametheory,itrdata) 
       write(nwr,'(3a,/a,//)')' matrix ',ncor(kco(i1)),                 &
     & ' is called by the theory:',nametheory(:80)                      
       if(itrdata.ne.mc(kco(i2))) then 
        write(nwr,'(a,i2,2a,/a,i2,a,//)')' number of parameters (',     &
     &  mc(kco(i2)),') of the matrix ',ncor(kco(i2)),                   &
     &  ' is different from number of variables (',itrdata,             &
     &  ') to be mapped on'                                             
       else 
        inf_tr(itr)=kco(i2) 
       end if 
!       write(6,'(20i3)')(inf_tr(k),k=1,20)                             
       goto 1000 
                                                                        
!      remove matrices of zero dimension                                
 1100  continue 
        icase=0 
        call combinerm(icase,jco,kwin,l_edit) 
        goto 100 
                                                                        
                                                                        
!      exit                                                             
 1200  continue 
!        do i=1,mp                                                      
!         if(kp(i).eq.2) kp(i)=1                                        
!        end do                                                         
        call coexam(0,info) 
        if(info.gt.0) then 
         call errormessage(info) 
         info=0 
         ch1='y' 
        else 
         ch1='n' 
        end if 
        querytype='restore  matrices ' 
        chcom='effi/transmatrix/restore' 
        call yesno(querytype,ch1,chcom,ncol,nrd,nwr) 
        if(ch1.eq.'y') call store_temp(12) 
!        #call savearsp(21) 
       return 
                                                                        
!     correlate two constants                                           
1400   continue
      value=0.0 
      lq=5 
      lk=lq 
      do k=1,lq 
       ext(k)=' ' 
      end do 
      chdf='l' 
      chdf(80:80)='#' 
      chin='correlation of constants' 
      helpar(1)='effi/correlation/constants/list' 
      helpar(2)='effi/correlation/constants/byname' 
      helpar(3)='effi/correlation/byname/valueinquiry'
      helpar(4)='effi/correlation/byix__name'
      helpar(5)='effi/correlation/byname/value'
      queryar(1)='list' 
      queryar(2)='by name (enquiry) of constant'
      queryar(3)='by name (enquiry) of constant and same value' 
      queryar(4)='by ix__name with 0<=i (inqiry) structure characters' 
      queryar(5)='by name/value (no enquiry)' 
      call query(lq,lk,chin,chdf) 
      if(lq.eq.0) lq=1 

       ! correlation of constants from handbook
       do k=1,mcl 
         if(index(ncon(k),'hdb').gt.0)then 
          l=24 
          do while(ncon(k)(l:l).eq.' ') 
           l=l-1 
          end do 
          l=l+1 
          ch24=ncon(k)(1:l)
          l_=index(ch24,'_') 
          do while(ch24(l_:l_).eq.'_') 
           l_=l_+1 
          end do
          chl=ch24(l_:) 
          do j=k+1,mcl 
           if(index(ncon(j),'hdb').gt.0)then
            l=24 
            do while(ncon(j)(l:l).eq.' ') 
             l=l-1 
            end do 
            l=l+1 
            cj24=ncon(j)(1:l)
            l_=index(cj24,'_') 
            do while(cj24(l_:l_).eq.'_') 
             l_=l_+1 
            end do 
            chr=cj24(l_:) 
            if(chl.eq.chr) then 
             ncon(k)(1:1)='0' 
             mconcor(j)=k 
            end if 
           end if
          end do
         end if 
       end do 
      if(lq.eq.2)goto 1420
      if(lq.eq.3)goto 1460
      if(lq.eq.4)goto 1430
      if(lq.eq.5)goto 1440

 1410 continue                                                   
      call printc(jc,jcr) 
 1450  continue
!      queryar(1)='list 
       write(nwr,'(a)') ' correlation of constant i,k-j ...' 
       iv=0
       prompt=chred//'cc>'//chnorm//ch0 
       cp132=' ' 
       i=readaline(mch,prompt) 
       if(i.gt.0) then 
        do j=1,i 
         cp132(j:j)=char(mch(j)) 
        end do 
        call addhist(cp132(:i)//ch0) 
       end if 
                                                                        
       if(cp132.eq.' ') goto 1410 
       if(cp132(1:2).eq.'he') then 
        chcom='effi/correlate/constants' 
        call help(chcom) 
       end if 
       call window(iwin) 
       call nextchar(cp132,0,ipos,ch132,ih) 
       if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') then 
        goto 100 
       else 
        chin=cp132 
        i=1
        call  panum(chin,mcl,npanum,i) 
        if(i.ne.1) then
         print'(2a)','error in the list:',TRIM(chin)
         goto 1450
        end if         
        if(npanum(2).gt.jcr)npanum(2)=jcr 
       end if
 1452  continue 
       nn=npanum(2) 
       if(nn.eq.0.and.iv.eq.0) goto 1410 
       if(nn.lt.2) then 
         write(nwr,'(a)') ' correlation of at least two constants ' 
         goto 1450 
       end if 
       if(nn.gt.jcr) then 
         write(nwr,'(a,i3,a)')' only',jcr,' constants can be correlated' 
         goto 1450 
       end if 
                                                                        
       do nni=1,nn 
        j=npanum(nni+2) 
        i=1 
        do while(j.ne.natcon(i).and.i.le.jcr) 
         i=i+1 
        end do 
        if(i.gt.jcr) then 
          write(nwr,'(a)') ' only constants out of the last listing' 
          goto 1410 
        end if 
       end do 

       iu=npanum(3) 
       do ii=4,nn+2 
        j=npanum(ii) 
        k=mconcor(j) 
        do i=j,mcl 
         if(mconcor(i).eq.k)then 
          nni=index(ncon(i),'_') 
          do while(ncon(i)(nni:nni).eq.'_') 
           nni=nni+1 
          end do 
          ch24=ncon(i)(nni:24) 
          nni=index(ncon(iu),'_') 
          do while(ncon(iu)(nni:nni).eq.'_') 
           nni=nni+1 
          end do 
          cp24=ncon(iu)(nni:24) 
          nni=1 
          do while(ch24(nni:nni).ne.' ') 
           nni=nni+1 
          end do 
          if(ch24(:nni).eq.cp24(:nni))then 
           mconcor(i)=iu 
           ncon(i)='#'//ncon(iu)(2:) 
           ncon(iu)=ncon(i) 
           con(i)=con(iu) 
          else 
           write(nwr,'(4a,/,a)')' the 2 constants:',ch24(:nni),' and ', &
     &      cp24,' are of different type - correlation not done'        
          end if 
         end if 
        end do 
       end do 
       if(iv.eq.0)then
        call  printc(jc,jcr) 
        goto 1450 
       end if
 1420  continue
        call  printc(jc,jcr) 
        chcom='effi/correlation/constants/by#name'
        querytype='only --name of constant' 
        ch132='name' 
        call askstring(querytype,ch132,chcom,ncol,nwr) 
       if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 100
        l1=LEN_TRIM(ch132)
        iv=1

        if(allocated(jname))deallocate(jname)
        allocate(jname(jcr))
        j=0
        do k=1,jcr
         lk=index(ncon(natcon(k)),ch132(:l1))
         if(lk.gt.0)then
          j=j+1
          jname(j)=natcon(k)
         end if
        end do

        if(allocated(chyn))deallocate(chyn)
        allocate(chyn(j))
 
        do k=1,j
         chyn(k)='n' 
         print '(i3,4x,a,a2,a1,a1)',k,ncon(jname(k))(:24)//' [',chyn(k),']'
        end do
        querytype='toggle (y/n) list of selected numbers (leave q/*)'
        write(ch2,'(i2)')j 
        ch132='1-'//ch2 
 1421   call askstring(querytype,ch132,chcom,ncol,nwr) 
        if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 1422
        chin=ch132    
        i=1
        call  panum(chin,j,npanum,i)
        if(i.ne.1) then
         print'(2a)','error in the list:',TRIM(chin)
         goto 1421
        end if         
        do k=1,npanum(2)
          if(chyn(npanum(k+2)).eq.'y')then
           chyn(npanum(k+2))='n'
          else
           chyn(npanum(k+2))='y'
          end if
        end do
        do k=1,j
         print '(i3,4x,a,a2,a1,a1)',k,ncon(jname(k))(:24)//' [',chyn(k),']'
        end do
        goto 1421
 1422   ii=0
        do k=1,j
         if(chyn(k).eq.'y')then
          ii=ii+1; npanum(ii+200)=k
         end if
        end do
        npanum(2)=ii
        do k=1,ii
          npanum(k+2)=jname(npanum(k+200))
        end do  
        goto 1452 

 1430  continue
!       queryar(4)='by ix__name with 0<=i (inqiry) structure characters' 
        form='i1' 
        value=0 
        alowlimit=0 
        uplimit=6
        chcom='effi/correlation/by#xx_name'
        querytype=' number of structure character' 
        call  askvallim(querytype,form,                                 &
                       alowlimit,uplimit,value,chcom,ncol,nrd,nwr)     

     if(allocated(chyn))deallocate(chyn)
      allocate(chyn(mcl))

      do i=1,mcl 
       chyn(i)='y'
      end do     
 
       lch=int(value) 
       do k=1,mcl 
        if(index(ncon(k),'hdb').eq.0)then 
         l=24 
         do while(ncon(k)(l:l).eq.' ') 
          l=l-1 
         end do 
         l=l+1 
         ch24=ncon(k)(1:l)
         l_=index(ch24,'_') 
         l=l_ 
         do while(ch24(l:l).eq.'_') 
          l=l+1 
         end do
         lb=l_-lch
         if(lb.lt.1)lb=1
         chl=ch24(lb:l_)//ch24(l:24) 

         do j=k+1,mcl
          if(index(ncon(j),'hdb').eq.0)then 
           l=24 
           do while(ncon(j)(l:l).eq.' ') 
            l=l-1 
           end do 
           l=l+1 
           cj24=ncon(j)(1:l)
           l_=index(cj24,'_') 
           l=l_ 
           do while(cj24(l:l).eq.'_') 
            l=l+1 
           end do 
           lb=l_-lch
           if(lb.lt.1)lb=1
           chr=cj24(lb:l_)//cj24(l:24) 

           if(chl.eq.chr) then 
!           write(6,'(3a2,2i3,a3,4a24)')chyn(k),chyn(j),' (',k,j,')= ',&
!                                        chl,ncon(k),chr,ncon(j)
            if(chyn(k).eq.'y') then
             ncon(k)(1:1)='0'
             ii=ichar(ncon(k)(2:2))-i0
             if(ii.ge.0.and.ii.le.9)ncon(k)(1:2)=' 0'
            end if 
            chyn(k)='n'; chyn(j)='n'
            mconcor(j)=k 
            con(j)=con(k) 
           end if

           if(chl.eq.chr.and. con(j).eq.con(k)) then 
            if(chyn(k).eq.'y') then
             ncon(k)(1:1)='0'
             ii=ichar(ncon(k)(2:2))-i0
             if(ii.ge.0.and.ii.le.9)ncon(k)(1:2)=' 0'
            end if 
            chyn(k)='n'; chyn(j)='n'
            mconcor(j)=k 
            con(j)=con(k) 
           end if
 
          end if
         end do 
        end if
       end do 
       do k=1,mcl 
        mconcor(k)=mconcor(mconcor(k))  ! 5.5.05 
       end do
!      write(6,'(21i4)')(mconcor(k),k=1,mcl) 
       call  printc(jc,jcr) 
      goto 100 
 
1440 continue
!    queryar(5)='by name/value (no enquiry)' 

     if(allocated(chyn))deallocate(chyn)
      allocate(chyn(mcl))

      do i=1,mcl 
       chyn(i)='y'
      end do     
 
       lch=int(value) 
       do k=1,mcl 
        if(index(ncon(k),'hdb').eq.0)then 
         l=24 
         do while(ncon(k)(l:l).eq.' ') 
          l=l-1 
         end do 
         l=l+1 
         ch24=ncon(k)(1:l)
         l_=index(ch24,'_') 
         l=l_ 
         do while(ch24(l:l).eq.'_') 
          l=l+1 
         end do
         lb=l_-lch
         if(lb.lt.1)lb=1
         chl=ch24(lb:l_)//ch24(l:24) 

         do j=k+1,mcl
          if(index(ncon(j),'hdb').eq.0)then 
           l=24 
           do while(ncon(j)(l:l).eq.' ') 
            l=l-1 
           end do 
           l=l+1 
           cj24=ncon(j)(1:l)
           l_=index(cj24,'_') 
           l=l_ 
           do while(cj24(l:l).eq.'_') 
            l=l+1 
           end do 
           lb=l_-lch
           if(lb.lt.1)lb=1
           chr=cj24(lb:l_)//cj24(l:24) 

           if(chl.eq.chr.and. con(j).eq.con(k)) then 
            if(chyn(k).eq.'y') then
             ncon(k)(1:1)='0'
             ii=ichar(ncon(k)(2:2))-i0
             if(ii.ge.0.and.ii.le.9)ncon(k)(1:2)=' 0'
            end if 
            chyn(k)='n'; chyn(j)='n'
            mconcor(j)=k 
           end if
 
          end if
         end do 
        end if
       end do 
       do k=1,mcl 
        mconcor(k)=mconcor(mconcor(k))  ! 5.5.05 
       end do
!      write(6,'(21i4)')(mconcor(k),k=1,mcl) 
       call  printc(jc,jcr) 
      goto 100
 1460 continue
!     queryar(3)='by name (enquiry) of constant and same value' 
      call  printc(jc,jcr) 
      chcom='effi/correlation/constants/bynamevalue'
      querytype='name/same value of constant name=' 
      ch132='name' 
      call askstring(querytype,ch132,chcom,ncol,nwr) 
      if(ch132(1:1).eq.'*'.or.ch132(1:1).eq.'q') goto 100
      l1=LEN_TRIM(ch132)

      if(allocated(jname))deallocate(jname)
      allocate(jname(mcl))
      j=0
      do k=1,mcl
       lk=index(ncon(k),ch132(:l1))
       if(lk.gt.0)then
        j=j+1
        jname(j)=k
       end if
      end do
      nn=j

      if(allocated(chyn))deallocate(chyn)
      allocate(chyn(mcl))
      do i=1,mcl
       chyn(i)='y'
      end do     
 
       lch=0
       do iu=1,nn
        k=jname(iu)
         l=24 
         do while(ncon(k)(l:l).eq.' ') 
          l=l-1 
         end do 
         l=l+1 
         ch24=ncon(k)(1:l)
         l_=index(ch24,'_') 
         l=l_ 
         do while(ch24(l:l).eq.'_') 
          l=l+1 
         end do
         lb=l_-lch
         if(lb.lt.1)lb=1
         chl=ch24(lb:l_)//ch24(l:24) 

         do iv=iu+1,nn
          j=jname(iv)
           l=24 
           do while(ncon(j)(l:l).eq.' ') 
            l=l-1 
           end do 
           l=l+1 
           cj24=ncon(j)(1:l)
           l_=index(cj24,'_') 
           l=l_ 
           do while(cj24(l:l).eq.'_') 
            l=l+1 
           end do 
           lb=l_-lch
           if(lb.lt.1)lb=1
           chr=cj24(lb:l_)//cj24(l:24) 

           if(chl.eq.chr.and. con(j).eq.con(k)) then 
            if(chyn(k).eq.'y') then
             ncon(k)(1:1)='0'
             ii=ichar(ncon(k)(2:2))-i0
             if(ii.ge.0.and.ii.le.9)ncon(k)(1:2)=' 0'
            end if 
            chyn(k)='n'; chyn(j)='n'
            mconcor(j)=k 
           end if
         end do 
       end do  
       do k=1,nn
         j=jname(k)
        mconcor(j)=mconcor(mconcor(j))  ! 5.5.05 
       end do
       do k=1,mcl 
        mconcor(k)=mconcor(mconcor(k))  ! 5.5.05 
       end do
!      call  printc(jc,jcr) 
      goto 1460                                                                     
 !      listing of commands                                              
 1300  continue 
      if(comline(4:).ne.' ') then 
       call nextchar(comline,2,ipos,cp132,ih) 
       chcom='effi/transmatrix/'//cp132(1:2) 
       call help(chcom) 
       goto 100 
      end if 
      do k=1,12 
       ext(k)=' ' 
       helpar(k)='effi/transmatrix/command' 
      end do 
      queryar(1)=' ch :change of name and values' 
      queryar(2)=' mp :merge two parameters (pi,pk)' 
      queryar(3)=' dp :de_merge parameter pi -> pi,pi+1' 
      queryar(4)=' ip :insert product of two parameters pi*pk' 
      queryar(5)=' pv :permute  parameters and variables' 
      queryar(6)=' cb :combine two matrices i,k' 
      queryar(7)=' sp :split of matrix' 
      queryar(8)=' pm :permute matrices' 
      queryar(9)=' rm :remove matrices of zero dimension' 
      queryar(10)='cc :correlate constants ' 
      queryar(11)='ex :exit' 
      queryar(12)='he :list of commands' 
       ch16=' ' 
       lq=12 
       lk=lq 
       ch16(16:16)='#' 
!      write(6,'(a,2i4)') ' corr npl,mcon=',npl                         
       chin='sub_commands' 
       call query2(lq,lk,chin,ch16) 
       goto 100 
 1500 continue
       chcom='effi/transmatrix/merge' 
       call help(chcom) 
      goto 100
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine printc(jc,jcr) 
      use glbconst, only: maxp,maxc,maxss,maxpl,maxco,nwr
      use compar, only: nwrwin,maxsto,maxscr
      use comfrm, only: con,ncon,mcl,mconcor  
      use comscd, only: npanum,natcon
      implicit none 
      integer, intent(inout):: jc,jcr

      character(len=24) :: chl,chr,fprint
      character(len=5) :: chcol,chnorm 
      character(len=4) :: chbold 

      character(len=16),dimension(4) :: formpr

      integer      i,iconj,ii,iu,ip,iumax,ilmax,j,k,mscr2
                                                                        
      formpr(1)='(a1,i1,4x,a24,a,' 
      formpr(2)='(a1,i2,3x,a24,a,' 
      formpr(3)='(a1,i3,2x,a24,a,' 
      formpr(4)='(a1,i4,1x,a24,a,' 
      chbold=char(27)//'[1m' 
      chcol=char(27)//'[34m' 
      chnorm=char(27)//'[0m' 
                                                                        
      mscr2=maxc+maxp 
      do j=1,mcl 
       npanum(mscr2+2+j)=j 
      end do 
      npanum(mscr2+2)=mcl 
!      call fcadjust(length)                                            
      jc=mcl 
      npanum(2)=jc 
      do j=1,jc 
         ii=npanum(j+mscr2+2) 
         npanum(j+2)=ii 
      end do 
                                                                        
      jcr=0 
      do k=3,jc+2 
       i=npanum(k) 
       if(mconcor(i).eq.i) then 
        jcr=jcr+1 
        natcon(jcr)=npanum(k) 
       end if 
      end do 
                                                                        
       iumax=0 
       ilmax=0 
       do i=1,mcl 
        iu=index(ncon(i),'_') 
        if(iu.gt.ilmax)ilmax=iu 
       end do 
       chl='______________' 
       do i=1,mcl 
        iu=index(ncon(i),'_') 
        j=iu 
        do while(ncon(i)(iu:iu).eq.'_') 
         iu=iu+1 
        end do 
        chr=ncon(i)(iu:) 
        ncon(i)(j:24)=chl 
        ncon(i)(ilmax+2:24)=chr(1:24-iu) 
       end do 
                                                                        
       do j=1,jcr 
        ii=natcon(j) 
        k=ii/1000 
        ip=4 
        if(k.eq.0) then 
         ip=3 
         k=ii/100 
         if(k.eq.0) then 
          ip=2 
          k=ii/10 
          if(k.eq.0) ip=1 
         end if 
        end if 
        fprint=formpr(ip)//ncon(ii)(33:40) 
!       write(6,'(a)')fprint                                            
!       if(mconcor(ii).eq.ii) then                                      
        if(ncon(ii)(33:33).eq.'i') then 
         iconj=con(ii) 
         write(nwrwin,fprint) 'c',ii,ncon(ii),' = ',iconj 
        else 
         write(nwrwin,fprint) 'c',ii,ncon(ii),' = ',con(ii) 
        end if 
       end do 
       if(nwrwin.ne.nwr)write(nwrwin,'(a)') '----------------' 
       return 
      END                                           
