subroutine distribution(n,xi)
  use glbconst,only: maxss,proplow,concent,nrd,nwr
  implicit none
    integer, intent(inout):: n  
    real, dimension(maxss),intent(out)::xi
    character(len=132), dimension(2) :: helpar,distrib
    character(len=132) :: querytype,chcom
    character(len=  7) :: form
    character(len=  1) :: ch1
    integer i,ndim,lcase,npl
    real alowlimit,uplimit,value,sig2,xmin
    
    ndim=maxss
    npl=80

10  lcase=1
     
    helpar(1)='/effi/distribution/gauss'
    helpar(2)='/effi/distribution/binomial'
    distrib(1)='Gauss distribution'
    distrib(2)='Binomial distribution'
    querytype='routines calculating probability distribution'
    call queryS(lcase,2,querytype,distrib,helpar)
    if(lcase.le.0.or.lcase.gt.2) goto 10 
    
    form='f5.2' 
    select case(lcase)
    case(1)
       value=0.1
       alowlimit=0.01
       uplimit=0.99       
       querytype=' lower limit of probability'        
       chcom='effi/distribution/gauss' 
        call askvallim(querytype,form,                                  &
                        alowlimit,uplimit,value,chcom,npl,nrd,nwr)      
        sig2=-1./alog(value)
        call gaussn(n,sig2,ndim,xi)
    case(2)
       querytype=' concentration (:probability)'  
       alowlimit=0.01
       uplimit=0.99 
       value=0.5
       if(concent.gt.0)value=concent
       chcom='effi/distribution/binomial' 
       call askvallim(querytype,form,                                  &
              alowlimit,uplimit,value,chcom,npl,nrd,nwr)
        concent=value
       
13     value=0.01
       if(proplow.gt.0.)value=proplow
       querytype=' lower limit of probability'  
       call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
       if(value.lt.0.0.or. value.gt.0.5)then
        call help(querytype)
        goto 13  
       end if
       xmin=value; proplow=xmin
       call binomial(n,concent,xmin,ndim,xi)
      end select
      print'(a)','  n      probability' 
      do i=1,n
       print'(i3,2x,f10.3)',i, xi(i) 
      end do

      querytype=' number n and lower limit ok?'     
      ch1='y'
      call yesno(querytype,ch1,chcom,npl,nrd,nwr)
      if(ch1.ne.'y') goto 10
      print'(a)'
      return
    end subroutine distribution


 subroutine binomial(n,cn,xmin,ndim,xi)
 implicit none
 integer, intent(inout) :: n
 integer, intent(in) :: ndim
 real,    intent(in) :: cn,xmin
 real, dimension(ndim), intent(out)::xi
 real, dimension(0:ndim)::yi
 integer k,i
 real*8  xnm,com,con,xm,cc
 logical b_reverse
!  (n over k)*con**k*(1-con)**(n-k),    (n over k)=n!/(k!*(n-k)!)
!   =PRODUCT (n-k+i)/i 

 b_reverse=.false.
  if(cn.gt.0.5d0) then
     b_reverse=.true.
     con=1.0d0-cn
  else
     b_reverse=.false.
     con=cn
  end if
 if(n.eq.1) then
     xi(1)=1.
   return
  end if
  com=1.0d0-con;  cc=con/com; xm=xmin
  xnm=com**n
  yi(0)=xnm
   do k=1,n-1
    yi(k)=PRODUCT((/(dfloat(n-k+i)/dfloat(i)*cc,i=1,k)/))*xnm
   end do
  if(b_reverse) then
    do i=1,n
       xi(i)=yi(n-i)
    end do
  else
    do i=1,n
       xi(i)=yi(i-1)
    end do
  end if
  k=0
  do i=1,n
     if(xi(i).gt.abs(xmin)) then
        k=k+1
        yi(k)=xi(i)
     end if
  end do
  n=k
  do i=1,n
   xi(i)=yi(i)				
  end do
  return
 end subroutine binomial


 subroutine gaussn(kr,sig2,ndim,xi)
 implicit none
 integer, intent(in) :: kr,ndim
 real,    intent(in) :: sig2
 real, dimension(ndim), intent(out)::xi

 integer nue,k
 real    x,dx
  if(kr.eq.1) then
     xi(1)=1.
  return
  end if   
  nue=kr/2
     if(2*nue.eq.kr)then
        ! even
        dx=1./(float(nue)-0.5)
        x=-dx/2-nue*dx
        do k=1,kr
         x=x+dx
         xi(k)=exp(-x**2/sig2)
        end do
     else   !      odd
        nue=(kr-1)/2
        dx=1./float(nue)
        x=-nue*dx-dx
        do k=1,kr
         x=x+dx
         xi(k)=exp(-x**2/sig2)
        end do
     end if
       x=0.
       do k=1,kr
         x=x+xi(k)
       end do        
       do k=1,kr
         xi(k)=xi(k)/x
       end do
      return
      end subroutine gaussn

      subroutine dpmatrix(wrb,info) 
      use glbconst,only: maxss
      use comfrm, only: cpstor,ncor,np,kcp,p,op,mco,mc,mr,mrces
      use comeff, only: idistsites,imat,dpmat,idpmat
      implicit none 

      integer i,idp,im,in,k,l,m,j,jco,nr,lkk,mkk,nkk,kr,k1,k2,k3,mski,info,npl 
      real,    dimension(:,:), allocatable:: weight
      real,    dimension(:),   allocatable:: xi,yi,zi

      character(len=24) :: ch24
      character(len=3) :: ch3
      character(len=1) :: wrb
      real x,value

!      write(6,'(a,10i3)')'mco=',mco                                    
!      write(6,'(a,10i3)')'idpmat(0..)=',(idpmat(i),i=0,8)              
!      write(6,'(a,20i3)')'idistsites(0..)=',(idistsites(i),i=1,16) 
      npl=80
!     block not used----------
      i=1
      do while(idistsites(i).ne.0)
       j=1
       do while(idistsites(i+j).eq.idistsites(i))
!       write(6,'(a,5i3)')'i,j=',i,j,idistsites(i),idistsites(i+j)
        j=j+1
       end do
!       write(6,'(a,3i3)')'i,j=',i,j
       i=i+j
      end do
!------------------------------


      allocate(weight(maxss,idpmat(0)))
      allocate(xi(maxss),yi(maxss),zi(maxss))
      weight=0.
      
      ! minGauss (=0.1)  to be defined in modul glbconst
      idp=0
      do i=1,idpmat(0)
       if(idpmat(i).gt.0)idp=idp+1        
       imat=0 
       l=1 
       do j=1,idpmat(i) 
!       write(6,'(a,10i3)')'#i,j=',i,j                                   
!       write(6,'(4a24)')dpmat(i,j)                                     
        do k=1,mco 
         if(ncor(k)(1:16).eq.dpmat(i,j)(1:16)) then 
          imat(l)=k
!         write(6,'(2i4,2x,a)')l,imat(l),ncor(k)(1:16)                 
          l=l+1 
         end if 
        end do 
       end do 
       imat(0)=l-1 

       if(imat(1).eq.0)goto 10 
       if(l.gt.1) call dpcor(wrb,info) 
       if(info.eq.13) return  

       im=imat(1)
       lkk=mrces(im)
       if(imat(0).gt.1) then
        mkk=mrces(imat(2))
        if(imat(0).gt.2) nkk=mrces(imat(3))
       end if
     
        kr=mr(im)
           
       if(imat(0).eq.1) then       
          call distribution(kr,xi)
        do k=1,kr
           weight(k,idp)=xi(k)
        end do 
      else if(imat(0).eq.2) then
         print'(a)','   n         dw_p1       dw_p2'
         do k=1,kr
           print'(i4,2x,3f12.3)',k,cpstor(lkk+k*2),cpstor(mkk+k*2)
         end do
        if(cpstor(lkk+2).eq.cpstor(lkk+4))then
          k1=1
        else 
         value= cpstor(lkk+2)
         k=2
         do while(value.ne.-cpstor(lkk+k*2))
          k=k+1
         end do
         k1=k
        end if
        call distribution(k1,xi)
        k2=kr/k1
        if(k2.eq.1)then
         do k=1,kr
           cpstor(mkk+k*2)=cpstor(lkk+k*2)
         end do
        end if    
        call distribution(k2,yi)
         print'(a)','  n   n1  n2  probability =    p1    *  p2   '
         l=0
         do k=1,k2
            do j=1,k1
              l=l+1
              weight(l,idp)=xi(j)*yi(k)
             print'(i4,2x,2i3,f10.5,2x,3f10.4)',l,k,j, weight(l,idp),xi(j),yi(k)
            end do
         end do
      else if(imat(0).eq.3)then
         
        print'(a)','   n         dw_p1       dw_p2       dw_p3'
        do k=1,kr
         print'(i4,2x,3f12.3)',k,cpstor(lkk+k*2),cpstor(mkk+k*2),cpstor(nkk+k*2)
        end do
        if(cpstor(lkk+2).eq.cpstor(lkk+4))then
          k1=1
        else
          value= cpstor(lkk+2)
          k=2
          do while(value.ne.-cpstor(lkk+k*2))
           k=k+1
          end do
          k1=k
        end if
        if(cpstor(mkk+2).eq.cpstor(mkk+4))then
          k=k1
        else      
         value= cpstor(mkk+2)
         k=0
          do while(value.ne.-cpstor(mkk+k*2))
           k=k+k1
          end do
        end if
        call distribution(k1,xi)
         k2=(k-1+k1)/k1
         call distribution(k2,yi)
          k3=kr/k1/k2
         call distribution(k3,zi)
         print'(a)','  n   n1  n2  n3  probability =    p1    *  p2   *    p3 '
          l=0
          do k=1,k3
           do j=1,k2
             do m=1,k1
              l=l+1
              weight(l,idp)=xi(m)*yi(j)*zi(k)
              print'(i4,2x,3i3,f10.5,2x,3f10.4)', &
                   l,k,j,m, weight(l,idp),xi(m),yi(j),zi(k)
             end do
           end do
          end do
       end if

       if(kr.eq.1) goto 100

       x=0.
       do k=1,kr
          x=x+weight(k,idp)
       end do
       do k=1,kr
        weight(k,idp)=weight(k,idp)/x
       end do
 10    continue
      end do 


!     collecting the transformation matrices with the weight parameters 
      imat=0 
      l=1 
      do i=1,idpmat(0)
       if(idpmat(i).gt.0)then 
        do k=1,mco 
         if(ncor(k)(1:16).eq.dpmat(i,0)(1:16)) then 
          imat(l)=k 
!          write(6,'(a,2i4,2x,a)')'##',l,imat(l),ncor(k)(1:16)            
          l=l+1 
         end if 
        end do
       end if 
      end do 
      imat(0)=l-1   ! number of weight matrices

!                            1234567890123456789012345678901            
!1abs2__mg/cm2           1x,f07.3,1x,f04.1,1x,f04.1,1x,f04.1)           

      do k=1,imat(0)    ! loop over all weight matrices 
       jco=imat(k)
       nr=mc(jco)
       mski=0 
       do i=1,jco-1 
        mski=mski+mc(i) 
       end do 
                                                                        
!      write(6,'(10(2x,2i3))') (i,kcp(i),i=mski+1,mski+mc(jco))        
!      write(6,'(a,a)')'np(kcp(mski+1))=',np(kcp(mski+1))              
       in=index(np(kcp(mski+1))(16:),'x,f')+17 
       ch3='7.3' 
       do l=1,nr 
!        write(6,'(i3,2a,2g12.3,a5)')kcp(mski+l),' mc(jco) even ', &
!             np(kcp(mski+l)), p(kcp(mski+l)),weight(l,k),ch3
        ch24=np(kcp(mski+l)); i=len_trim(ch24)
        do while(ch24(i:i).ne.'_')
         i=i-1
        end do
        ch24(i+1:)='fraction'
        np(kcp(mski+l))(1:24)=ch24
        p(kcp(mski+l))=weight(l,k)
        op(kcp(mski+l))=1.0 
        np(kcp(mski+l))(in+2:in+4)=ch3 
        np(kcp(mski+l))(in+29:in+31)='5.2' 
       end do 
      end do 
 100  deallocate(weight,xi,yi,zi)                                      
      return 
      END                                           
                                                                        
      subroutine dpcor(wrb,info) 
      use glbconst, only: maxp,maxc,maxprd,maxpl,maxtrf,maxco,maxscr,   &
                          infotext,nrd,nwr
      use comfrm, only: maxsto,np,p,up,op,ddp,kp,pst,pold,pmin,plast,   &
                        cpstor,fpstor,mp,mc,mcs,mr,mrce,mrces,mrcet,    &
                        kcp,kco,mcon,mco,mpl,ncor
      use comeff, only: imat,npl,ncol
      use comscd, only: nmr,nmc,scratch,fscratch,nmkcp

      implicit none 
      character(len=1)  , intent(in):: wrb                                   
      integer, intent(out):: info

      integer, dimension(maxp):: ind

      character(len=132):: chcom,querytype,ch132
      character(len=24) :: chp,ch24,cp24
      character(len=20) :: fprint  
      character(len=7)  :: form
      character(len=1)  :: ch1

      real    array_tr
      integer inf_tr                                                            
      common/comtr/array_tr(maxtrf),inf_tr(maxprd) 

      real         value,alowlimit,uplimit      
      integer   npwd,mrco,mrcop,l,k,isn,idwnum,idwma,idwpar,idwpos,     &
     &          i,i1,iv,ica,isnk,i0,ipl,il,ir,ii,ie,i_,i_1,ipm,         &
     &          idw,j,jj,jc,jco,js,kk,lcl,lv,lco,                       &
     &          mprod,mmcl,mpu,mcsk,n,nmr2,nmc2,ni,nc,numi1,ntrimto0

      dimension isn(8),idwnum(8),idwma(8),idwpar(8),idwpos(8) 
                                                                        
                                                                        
!     ***dp*** de_correlate a parameter pi -> pi,pi+1                   
!      write(6,'(a,3i4)') ' ncl, npl=',ncl, npl,ncol(1)                 
                                                                        
   10  do k=1,8 
        idwnum(k)=1 
        idwma(k)=0 
        idwpar(k)=0 
        idwpos(k)=0 
       end do 
                                                                        
      write(nwr,'(/)') 
      idw=0 
      do lco=1,imat(0) 
       jco=imat(lco) 
       j= mc(jco) 
       write(nwr,'(a,i2,2x,a,a1,i2,a1,i1,a1)')                          &
     &  ' transformation matrix ',jco,                                  &
     &  ncor(jco),'(',mr(jco),'x',mc(jco),')'                           
        mrco=mr(jco)/j 
       if(idw+j.gt.8) then 
        info=idw+j 
        infotext(1)='effi/distribute/parameters/select' 
        infotext(2)=                                                    &
     &      '**error** number of preselected parameters larger than 8'  
        infotext(3)=' ' 
        goto 1000 
       end if 
       do l=1,j 
        idw=idw+1 
        idwma(idw)=jco 
        n=kcp(mcs(jco)+l) 
        isn(idw)=n 
!        write(6,'(i4,2x,a24)')n, np(n)                                 
       end do 
      end do 
                                                                        
      if(idw.ge.1) then 
       write(nwr,'(/,i2,a,i3,a)')idw,                                   &
     & ' parameters for distribution over ',mrco,' spectra '            
       if(idw.gt.3) then 
        write(nwr,'(a)')                                                &
     &  ' maximal 3 parameters can be distributed at a time'            
                                                                        
        write(nwr,'(a,a,i3)')                                           &
     &  ' to each parameter i belongs a number of spectra n_i',         &
     &  ' such that n_1*n_2*n_3 =',mrco                                 
                                                                        
                                                                        
       else if(idw.eq.3) then 
        write(nwr,'(a,a,i3)')                                           &
     &  ' to each parameter i belongs a number of spectra n_i',         &
     &  ' such that n_1*n_2*n_3 =',mrco                                 
       else if(idw.eq.2) then 
        write(nwr,'(a,a,i3)')                                           &
     &  ' to each parameter i belongs a number of spectra n_i',         &
     &  ' such that n_1*n_2 =',mrco                                     
       end if 
       if(idw.gt.3) then 
        write(nwr,'(/,2a)') ' selection of i<=3',                       &
     &                                ' parameters for distribution'    
       else 
        write(nwr,'(/,a,i1,a)') ' selection of i<=',idw,                &
     &                                ' parameters for distribution'    
       end if 
         j=2 
         l=0 
         do while(j.le.mrco/2) 
          i=mrco/j 
          if(i*j.eq.mrco)l=j 
          j=j+1 
         end do 
         if(l.eq.0) then 
          write(nwr,'(i2,2a)')mrco,' is a prime number -',              &
     &     ' only one parameter can be distributed'                     
         end if 
                                                                        
        mrcop=mrco 
        chp='......go on...................' 
        npwd=0 
        mprod=1 

       do k=1,idw 
        isnk=isn(k) 
        isn(k)=-isn(k) 
        write(nwr,'(/)') 
        ch1='y' 
        j=24 
        do while(np(isnk)(j:j).eq.' ') 
         j=j-1 
        end do 
        querytype=' distribute parameter '//np(isnk)(:j)//chp(1:30-j)  
        chcom='effi/distribution/parameter/select' 
        querytype(132:132)=wrb 
        call yesno(querytype,ch1,chcom,ncol,nrd,nwr)           ! 20.12.2013
        if(ch1.eq.'y') then 
         if(l.eq.0.or.idw.eq.1) then
          idwnum(k)=mrco 
          isn(k)=-isn(k) 
          goto 50 
         end if 
         querytype=' number of components for '//np(isnk)(:j)//chp(1:20-j)//'n_i'
         form='i2' 
         chcom='effi/distribution/number/select' 
         if(k.eq.idw.and.mrcop.eq.mrco)l=mrco 
40       value=l
         if(l.eq.0)value=1.
         querytype(132:132)=wrb 
         call askvalue(querytype,form,value,chcom,npl,nrd,nwr) 
         iv=value 
         if(iv.eq.1) then 
          write(nwr,'(i2,a)')iv,' is equivalent to no distribution ' 
         end if 
         lv=mrcop/iv 
         if(lv*iv.ne.mrcop) then 
          write(nwr,'(i2,a,i2)')iv,' is not a factor of ',mrcop 
          goto 40 
         end if 
         l=lv 
!         if(l.eq.1)goto 50                                             
         idwnum(k)=iv 
         mrcop=lv 
         mprod=mprod*iv 
         isn(k)=-isn(k) 
         npwd=npwd+1 
        else
         idwnum(k)=1 
         isn(k)=-isn(k) 
         npwd=npwd+1 
        end if 
       end do
       if(mprod.ne.mrco) then 
        write(nwr,'(a,i2,a,i2)')' number of distribution values ',mprod,&
     &  ' is less than number of subspectra ',mrco                      
        write(nwr,'(a)')' .... go on with [y] to leave this loop' 
        goto 10 
       end if 
      end if   ! idw >= 1
   50 continue 
!      ##call savearsp(12) 
!      call store_temp(21)                                              
                                                                        
      do i=1,mco 
        kco(i)=i 
      end do 
      mcon=mco 
      lco=1 
       idw=0 
!      jco has to be defined                                            
  100  jco=imat(lco) 
       mmcl=mc(imat(lco)) 
       lcl=1 
       i1=-1 
  110  continue 
       idw=idw+1 
                                                                        
!      n=kcp(mcs(jco)+lcl)                                              
       if(isn(idw).lt.0) then 
        i1=i1+1 
        goto 900 
       else 
        i1=i1+2 
       end if 
                                                                        
       idwpos(idw)=i1+1 
                                                                        
       kk=kco(jco) 
                                                                        
        nmr(2)=mr(kk) 
        do i=1,mr(kk) 
         nmr(i+2)=i 
        end do 
        nmc(2)=mc(kk) 
        do i=1,mc(kk) 
         nmc(i+2)=i 
        end do 
        nmr2=nmr(2) 
        nmc2=nmc(2) 
                                                                        
        if(mp.eq.maxp) then 
         write(nwr,'(a,i3,a)')  ' *** maximal number (',maxp,           &
     &                            ') of parameters reached'             
         goto 1000 
        end if 
        if(mpl+mr(kk).gt.maxpl) then 
         write(nwr,'(a,i3,a)') ' *** maximal number (',maxpl,           &
     &                            ') of variables reached'              
         goto 1000 
        end if 
        if(mrcet+mr(kk).gt.maxsto) then 
          write(nwr,'(2a,i6,/,a,i6,/,a)')                               &
     & ' total number of elements of',                                  &
     & ' transformation matrices exceeds maxsto=', maxsto,              &
     & ' reason:maxsto is less than maxpl*maxp=',maxp*maxpl,            &
     & ' help:  splitting of transformation matrices'                   
         goto 1000 
        end if 
                                                                        
        if(mc(kk).ge.mr(kk)) then 
           j=0 
           ica=mcs(kk) 
          do i=1,mc(kk) 
            k=index(np(kcp(ica+i)),'*') 
            if(k.eq.0) j=j+1 
          end do 
         infotext(1)='effi/structure/dpcorr' 
         if(j.ge.mc(kk))&
         infotext(2)='number of parameters .ge. number of variables'
         infotext(3)='or in case of no distribution [#] is replaced by [d]'
         infotext(4)='rm and start again or edit the .scr file' 
         infotext(5)=' ' 
         info=13  
         goto 1000 
        end if 
                                                                        
        numi1=0 
        do i=1,nmc2 
          if(i1.eq.nmc(i+2)) then 
            j=j+1 
            numi1=i 
          end if 
        end do 
        if(numi1.eq.0) then 
         info=12
        infotext(1)='effi/structure/dpcorr' 
        infotext(2)='** error occured ** - unexpected'
        infotext(3)='something wrong with d,y,n,# in bracket []' 
        infotext(4)=' ' 
         return 
        end if 
!     decorrelation of parameter i1, introduction of parameter i2=mpu   
        i0=ichar('0') 
        ipl=ncol(1)/28 
        ch1=char(ipl+i0) 
        fprint='('//ch1//'(i3,1x,a23,1x))' 
        il=mp/ipl 
        ir=mp-ipl*il 
                                                                        
        jj=0 
        if(ir.gt.0) then 
         do j=1,il 
          do k=1,ipl 
           jj=jj+1 
           ind(jj)=(k-1)*il+j 
           if(ir.ge.1.and.k.gt.1 ) ind(jj)=ind(jj)+1 
           if(ir.ge.2.and.k.gt.2 ) ind(jj)=ind(jj)+1 
           if(ir.ge.3.and.k.gt.3 ) ind(jj)=ind(jj)+1 
           if(ir.ge.4.and.k.gt.4 ) ind(jj)=ind(jj)+1 
           if(ir.ge.5.and.k.gt.5 ) ind(jj)=ind(jj)+1 
           if(ir.ge.6.and.k.gt.6 ) ind(jj)=ind(jj)+1 
          end do 
         end do 
         do k=1,ir 
          jj=jj+1 
          ind(jj)=k*il+k 
         end do 
        else 
         do j=1,il 
          do k=1,ipl 
           jj=jj+1 
           ind(jj)=(k-1)*il+j 
          end do 
         end do 
        end if 
                                                                        
!        write(6,'(a,i5)')'   mp=', mp                                  
        write(nwr,fprint) (ind(i),np(ind(i)),i=1,mp) 
                                                                        
        form='i2' 
        k=mcs(kk)+i1 
!        write(6,'(a,2i3)') ' mcs(kk),i1=',mcs(kk),i1                   
!        value=kcp(k)+1                                                 
        value=kcp(k) 
        alowlimit=1 
        uplimit=mp 
        chcom='effi/transmatrix/distribution/parameter' 
        querytype=' counter of the parameter for the distribution width' 
        querytype(132:132)=wrb 
        call  askvallim(querytype,form,                                 &
     &                  alowlimit,uplimit,value,chcom,ncol,nrd,nwr)     
        mpu=value 
        do i=1,3 
         if(idwnum(i).gt.1) then 
          if(idwpar(i).gt.mpu)idwpar(i)=idwpar(i)+1 
         end if 
        end do 
        idwpar(idw)=mpu+1 
                                                                        
        do i=mp+1,k+2,-1 
         kcp(i)=kcp(i-1) 
        end do 
        do i=1,mp+1 
         if(kcp(i).gt.mpu) kcp(i)=kcp(i)+1 
        end do 
        kcp(k+1)=mpu+1 
                                                                        
        isn(idw)=mpu+1 
                                                                        
        do i=mp+1,mpu+1,-1 
            ii=i-1 
            ie=i 
            np(ie)=np(ii) 
             p(ie)=p(ii) 
            up(ie)=up(ii) 
            op(ie)=op(ii) 
            ddp(ie)=ddp(ii) 
            kp(ie)=kp(ii) 
         pst(ie)  =   pst(ii) 
         plast(ie)= plast(ii) 
         pold(ie) =  pold(ii) 
         pmin(ie) =  pmin(ii) 
        end do 
        p(mpu+1)=0.0 
                                                                        
        jc=mrces(kk) 
        do i=1,mr(kk) 
         do k=1,mc(kk) 
          jc=jc+1 
          if(k.eq.i1) then 
           cpstor(jc)=cpstor(jc) 
           ni=(ichar(fpstor(jc)(2:2))-i0)*10+ichar(fpstor(jc)(3:3))-i0 
           if(ni.le.4)fpstor(jc)(3:3)='5' 
           if(ichar(fpstor(jc)(4:4)).eq.i0)fpstor(jc)(4:4)='1' 
          end if 
         end do 
        end do 
        js=mrces(kk) 
        jc=js 
        do i=1,mr(kk) 
         do k=1,mc(kk) 
          jc=jc+1 
          js=js+1 
          scratch(js)=cpstor(jc) 
          fscratch(js)=fpstor(jc) 
          if(k.eq.i1) then 
           js=js+1 
           scratch(js)=cpstor(jc) 
           fscratch(js)=fpstor(jc) 
          end if 
         end do 
        end do 
                                                                        
        if(kk.lt.mco) then 
         do i=mrces(kk+1)+1,mrcet 
           js=js+1 
          scratch(js)=cpstor(i) 
          fscratch(js)=fpstor(i) 
         end do 
        end if 
                                                                        
         mp=mp+1 
         mc(kk)=mc(kk)+1 
         mcsk=mcs(kk) 
         mrce(kk)=mr(kk)*mc(kk) 
         do j=2,mco 
          mcs(j)=mcs(j-1)+mc(j-1) 
          mrces(j)=mrces(j-1)+mrce(j-1) 
         end do 
          mrcet=mrcet+mr(kk) 
         do i=mrces(kk)+1,mrcet 
          cpstor(i)=scratch(i) 
          fpstor(i)=fscratch(i) 
         end do 
                                                                        
        nmc2=nmc2+1 
        if(nmc2.lt.numi1+2) then 
          nmc(3+numi1)=nmc(2+numi1)+1 
        else 
         do j=nmc2,numi1+2,-1 
          nmc(j+2)=nmc(j+1)+1 
         end do 
        end if 
                                                                        
        do i=1,nmc2 
         nmkcp(i)=kcp(mcsk+nmc(i+2)) 
!         write(6,'(a,i4,a)') '#######',i,np(nmkcp(i))                  
        end do 
!        write(6,'(a,16i4)')'nmkcp(1..)=',(nmkcp(i),i=1,nmc2)           
        ie=nmkcp(numi1+1) 
        ii=nmkcp(numi1) 
        p(ie)=0.0 
!        p(ie)=p(ii)                                                    
        up(ie)=up(ii) 
        op(ie)=op(ii) 
        ddp(ie)=ddp(ii) 
        pst(ie)  =   pst(ii) 
        plast(ie)= plast(ii) 
        pold(ie) =  pold(ii) 
        pmin(ie) =  pmin(ii) 
                                                                        
        nmc(2)=nmc2 
        ch24=np(nmkcp(numi1)) 
        i_=index(ch24,'_') 
        i_1=i_ 
        do while(ch24(i_:i_).eq.'_') 
         i_=i_+1 
        end do 
                                                                        
        cp24=ch24(:i_-1)//'dw_' 
        ch24=cp24(:i_+2)//np(nmkcp(numi1))(i_:) 
        ch24(23:24)=' ' 
        cp24=ch24(i_:) 
        ch132=cp24 
        querytype=' name of the distribution widths' 
        chcom='effi/transmatrix/distribution/name' 
        querytype(132:132)=wrb 
  590   call askstring(querytype,ch132,chcom,ncol,nwr) 
        if(ch132(1:1).eq.'*'.or.ch1.eq.'q') goto 1000 
        l=ntrimto0(ch132) 
        np(nmkcp(numi1+1))=np(nmkcp(numi1)) 
        np(nmkcp(numi1+1))(i_:24)=ch132(:l) 
        if(cp24(:l).ne.ch132(:l)) then 
         cp24(:l)=ch132(:l) 
         write(nwr,'(1x,a1,a3)') char(27),'[2A' 
         goto 590 
        end if 
                                                                        
!        if(ch24(1:i_-1).eq.ch132(1:i_-1)) then                         
!         np(nmkcp(numi1+1))(1:24)=ch132(1:24)                          
!        else                                                           
!         np(nmkcp(numi1+1))(1:24)=ch24(1:i_-1)//ch132                  
!         ch132=np(nmkcp(numi1+1))(1:24)                                
!         goto 590                                                      
!        end if                                                         
                                                                        
        mcsk=mcs(kk) 
        do i=1,nmc2 
         nmkcp(i)=kcp(mcsk+nmc(i+2)) 
        end do 
        call coexam(jco,info) 
        if(info.gt.0) goto 1000 
                                                                        
        call coexam(0,info) 
        if(info.gt.0) then 
!         call store_temp(12)                                           
         write(nwr,'(a)')'****an error occurred****' 
         goto 1000 
        end if 
!--------------------------------------------------                     
  900   lcl=lcl+1 
       if(lcl.le.mmcl) goto 110 
        lco=lco+1 
       if(lco.le.imat(0)) goto 100 
!--------------------------------------------------                     
!       write(6,'(a,8i3)') ' idw,npwd,mrco=',idw,npwd,mrco              
!       write(6,'(a,8i3)') ' idwnum=',idwnum                            
!       write(6,'(a,8i3)') ' idwma=',idwma                              
!       write(6,'(a,8i3)') ' idwpar=',idwpar                            
!       write(6,'(a,8i3)') ' idwpos=',idwpos                            
                                                                        
        ipm=0 
        do k=1,3 
         if(idwnum(k).ne.1) then 
          jco=idwma(k) 
          nc=idwpos(k) 
          ipm=ipm+1 
         if(nc.gt.0)call chmatrix(jco,nc,idwnum,mrco,ipm) 
         end if 
        end do 
                                                                        
!       ##call savearsp(21) 
 1000  continue 
       return 
      END                                           
                                                                        
      subroutine chmatrix(jco,nc,idwnum,mrco,ipm) 
      use comfrm, only: cpstor,fpstor,mc,mr,mrces
      implicit none
      integer   jco,nc,idwnum,mrco,ipm,idum,k,l,ip0,nr,      &
                ip,j,iq1,iq2,iq3,im1,im2,im3,mjco
      real      h,rv
      dimension idwnum(3),idum(3) 
                                                                        
      k=mrces(jco)-mc(jco)+nc 
      l=0 
      ip0=0 
      do nr=1,mr(jco) 
        mjco=k+nr*mc(jco) 
        if(cpstor(mjco).eq.0.0)then 
         l=l+1 
        else 
         if(ip0.eq.0) ip0=nr 
        end if 
      end do 
      if(l.eq.0) then 
        ip=1 
      else 
       ip=l/mrco+1 
      end if 
      do k=1,3 
       idum(k)=1 
      end do 
      j=1 
      do k=1,3 
       if(idwnum(k).gt.1) then 
        idum(j)=idwnum(k) 
        j=j+1 
       end if 
      end do 
      iq1=idum(1) 
      iq2=idum(2) 
      iq3=idum(3) 
                                                                        
!      write(6,'(a,8i3)')' chmatrix nc,ip,ip0,ipm,mrco,idum=', &         
!                             nc,ip,ip0,ipm,mrco,idum             
                                                                        
       if(ipm.eq.1) then 
        h=(iq1-1.)/2.+1 
        do im3=1,iq3 
         do im2=1,iq2 
          rv=h 
          do im1=1,iq1 
           nr=ip0+(im1-1)*ip+(im2-1)*(iq1*ip)                           &
                +(im3-1)*(iq1*ip+(iq2-1)*(iq1*ip))                     
           rv=rv-1. 
!           write(6,'(a,i3,f6.1)')'1 chmatrix nr,rv=',nr,rv             
           mjco=mrces(jco)+(nr-1)*mc(jco)+nc 
           fpstor(mjco)='f051' 
           cpstor(mjco)=rv 
          end do 
         end do 
        end do 
       else if(ipm.eq.2) then 
        h=(iq2-1.)/2.+1 
        do im3=1,iq3 
         rv=h 
         do im2=1,iq2 
          rv=rv-1. 
          do im1=1,iq1 
           nr=ip0+(im1-1)*ip+(im2-1)*(iq1*ip)                           &
                +(im3-1)*(iq1*ip+(iq2-1)*(iq1*ip))                     
!           write(6,'(a,i3,f6.1)')'2 chmatrix nr,rv=',nr,rv             
           mjco=mrces(jco)+(nr-1)*mc(jco)+nc 
           fpstor(mjco)='f051' 
           cpstor(mjco)=rv 
          end do 
         end do 
        end do 
       else if(ipm.eq.3) then 
        h=(iq3-1.)/2.+1 
        rv=h 
        do im3=1,iq3 
         rv=rv-1. 
         do im2=1,iq2 
          do im1=1,iq1 
           nr=ip0+(im1-1)*ip+(im2-1)*(iq1*ip)                           &
                +(im3-1)*(iq1*ip+(iq2-1)*(iq1*ip))                     
!           write(6,'(a,i3,f6.1)')'3 chmatrix nr,rv=',nr,rv             
           mjco=mrces(jco)+(nr-1)*mc(jco)+nc 
           fpstor(mjco)='f051' 
           cpstor(mjco)=rv 
          end do 
         end do 
        end do 
       end if 
                                                                        
      return 
      END                                           
                                                                        
