    PROGRAM deadtime
!   Driver for routine POWELL
    character(len=132) chin
    PARAMETER(ndim=2,FTOL=1.0e-1)
    real    P(NDIM),XI(NDIM,NDIM)

    real, DIMENSION(ndim)::X
    real, DIMENSION(32)::out
    real, DIMENSION(6)::Omega,Cmk
    real, DIMENSION(6,6)::Cm

    common/dim/ndata
    real counts
    common/xyd/Omega,Cmk,counts
    real YY,h,hi
    integer i
    
      open(unit=4,file='counts_Omega.dat'                            &
                ,status='unknown'                                    &
                ,access='sequential'                                 &
                ,form='formatted')

    read(4,'(a)')chin
    print*,TRIM(chin)
    read(4,'(a)')chin
    print*,TRIM(chin)
    read(4,'(a)')chin
    print*,TRIM(chin)
    call trlch(80,chin,nn,out) 
    ndata=out(1); ncol=out(2)
     
    do k=1,ndata
       read(4,'(a)') chin
       print*,TRIM(chin)       
       call trlch(80,chin,nn,out) 
       Omega(k)=out(1)
       do i=1,ncol
        Cm(k,i)=out(1+i)
       end do
     end do
    close(unit=4)


    open(unit=4,file='dist_count.apl'                              &
                ,status='unknown'                                    &
                ,access='sequential'                                 &
                ,form='formatted')

   do ic=1,4
    
!   estimated counts without deadtime (small Omega)
    do i=1,ndata
     Cmk(i)=Cm(i,ic)
    end do   
    Counts=Cmk(ndata)*Omega(1)/Omega(ndata)
    
    NP=NDIM
    
    XI=0.0
    do i=1,NDIM
     XI(i,i)=1.0
    end do

! variables are n, taup or n,taun or taun,taup (n fixed)   
    P(1)=0.2   !tau*
    P(2)=counts

    CALL POWELL(P,XI,NDIM,NDIM,FTOL,ITER,FRET)
    WRITE(*,'(//1X,A,I3)') 'Iterations:',ITER
    WRITE(*,'(1X,A,3F12.6)') 'Minimum found at (P(I)): ',(P(I),I=1,NDIM)
    WRITE(*,'(1X,A,F12.6)') 'Minimum function value =',FRET
    taun=abs(P(1))
    taup=0.0! abs(P(2))
    counts=P(2)
 print*,' counts=',counts,' counts/(1.0+taun)=', counts*exp(-taup)/(1.0+taun)


    write(4,'(2(a,f6.2))')' paralyzable tauP=',taup,'  non-paralyzable tauN=',taun
     write(4,'(a)') 'Omega/4\gp\r'
     write(4,'(a)') 'counts/s [kHz]'
     do i=1,ndata     
      write(4,'(i5,2f8.2)')10, Omega(i),Cm(i,ic)
     end do

     write(4,'(i5,2f8.2)')34,Omega(1),h
     hcount=P(2)/Omega(1) 
     domega=(Omega(1)-Omega(ndata))/100
     do i=2,100
      om=Omega(1)-(i-1)*domega  
      hi=hcount*om
      h=hi*exp(-hi/counts*taup)/(1.0+hi/counts*taun)
      write(4,'(i5,2f8.2)')0,om,h
     end do
      write(4,'(i5,2f8.2)')34, Omega(1),counts  
      do i=2,100
      om=Omega(1)-(i-1)*domega           
      write(4,'(i5,2f8.2)')2000, om,hcount*om
     END do
   end do
  close(unit=4)
  END PROGRAM deadtime

   FUNCTION FUNC(X)
   real, DIMENSION(2)::X
     integer ndata
     common/dim/ndata
    real hi,counts,hh,countv
    real, DIMENSION(6)::Omega,Cmk

    common/xyd/omega,Cmk,counts
    real h,taup,taun

    taun=abs(X(1))
    taup=0.0  !abs(X(2))
    countv=abs(X(2))
    h1=countv/Omega(1)
    h=0.
    do i=1,ndata
       hi=h1*Omega(i) 
       hh=(Cmk(i) -hi*exp(-hi/countv*taup)/(1.0+hi/countv*taun))**2
      h=h+hh
!    print*,h,hh,Cmk(i),hi*exp(-hi/countv*taup),taup,countv,counts
    END do
    FUNC=h/3
!    read(5,*)

    end


    subroutine trlch(n_ch,chin,iout,out) 
      implicit none
      character chin*132,ch*132 
      real      out(32),pt 
      integer nch,n_ch, &
              i,ic,i0,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given as ch*13
!     to iout real numbers (max.32) stored in the vector out.           
!     nch characters of ch(1:nch) are analysed.                         
      nch=n_ch 
      if(nch.gt.132) nch=132 
      ch=chin 
      i0=ichar('0') 
      nsig=1 
      pt=1. 
      k1=0 
      k2=0 
      nex=0 
      nnum=0 
      iout=0 
      do k=1,32 
       out(k)=0. 
      end do 
                                                                        
      k=0 
   10 k=k+1 
      i=ichar(ch(k:k))-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.nch) goto 50 
       goto 100 
      end if 
                                                                        
      if(ch(k:k).eq.'e'.or.ch(k:k).eq.'E') then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(ch(i:i).eq.'.') then 
         nex=-1 
         goto 50 
        end if 
        ic=ichar(ch(i:i))-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (ch(k:k).eq.'.') then 
        pt =0.1 
        goto 100 
      end if 
      if(ch(k:k).eq.'-') then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.ch(k:k).eq.' ') nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60 
      out(iout)=out(iout)*10.**out(iout+1) 
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.32) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.nch) goto 10 
  110 return 
      END                                           
                                                                        
 
