	PROGRAM D2R1
!	Driver program for subroutine GAUSSJ
!	Reads Matrices from file MATRIX.DAT and feeds them to GAUSSJ
	PARAMETER(NP=20)
	DIMENSION A(NP,NP),B(NP,NP),AI(NP,NP),X(NP,NP)
	DIMENSION U(NP,NP),T(NP,NP)
	CHARACTER DUMMY*3
	OPEN(5,FILE='MATRX1.DAT',STATUS='OLD')
10	READ(5,'(A)') DUMMY
	IF (DUMMY.EQ.'END') GOTO 99
	READ(5,*)
	READ(5,*) N,M
	READ(5,*)
	READ(5,*) ((A(K,L), L=1,N), K=1,N)
	READ(5,*)
	READ(5,*) ((B(K,L), K=1,N), L=1,M)
!	Save Matrices for later testing of results
	DO 13 L=1,N
		DO 11 K=1,N
			AI(K,L)=A(K,L)
11		CONTINUE
		DO 12 K=1,M
			X(L,K)=B(L,K)
12		CONTINUE
13	CONTINUE
      open(unit=4,file= 'result.DAT',status='unknown'        &
           ,access='sequential',form='formatted')

      !	Invert Matrix
	CALL GAUSSJ(AI,N,NP,X,M,NP)
	WRITE(*,*) 'Inverse of Matrix A : '
	WRITE(4,*) 'Inverse of Matrix A : '
	DO 14 K=1,N
		WRITE(*,'(1H,(12g12.5))') (AI(K,L), L=1,N)
		WRITE(4,'(1H,(12g12.5))') (AI(K,L), L=1,N)
14	CONTINUE
!	Test Results
!	Check Inverse
	WRITE(*,*) 'A times A-inverse (compare with unit matrix)'
	DO 17 K=1,N
		DO 16 L=1,N
			U(K,L)=0.0
			DO 15 J=1,N
				U(K,L)=U(K,L)+A(K,J)*AI(J,L)
15			CONTINUE
16		CONTINUE
		WRITE(*,'(1H,(12F12.5))') (U(K,L), L=1,N)
		WRITE(4,'(1H,(12F12.5))') (U(K,L), L=1,N)
17	CONTINUE
!	Check Vector Solutions
	WRITE(*,*) 'Check the following vectors for equality:'
	WRITE(*,'(T12,A8,T23,A12)') 'Original','Matrix*Sol''n'
	DO 21 L=1,M
	        WRITE(*,'(1X,A,I2,A)') 'Vector ',L,':'
		DO 19 K=1,N
			T(K,L)=0.0
			DO 18 J=1,N
				T(K,L)=T(K,L)+A(K,J)*X(J,L)
18			CONTINUE
		WRITE(*,'(8X,2F12.6)') B(K,L),T(K,L)
19		CONTINUE
21	CONTINUE
	WRITE(*,*) '***********************************'
	WRITE(*,*) 'Press RETURN for next problem:'
	READ(*,*)
	GOTO 10
99 CLOSE(5)
        close(4)
     stop
     END	

  subroutine GAUSSJ(A,N,NP,B,M,MP)
      PARAMETER (NMAX=50)
      DIMENSION A(NP,NP),B(NP,MP),IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                print*, 'Singular matrix'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.) print*,'Singular matrix.'
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END
