 program select
 implicit none

 character(len=12), dimension(8)::enel=(/'   57Fe14.41','   Fe122/136', &
        'Rh20.14/22.9','  Fe6.4/7.06','  Cu8.04/8.9',' Zn8.63/9.57',&
        ' Pb10.5/12.6',' Pb72.8/75.0'/)
 !  1    2     3,4   5   6       7     8       9    10    11   12    13    14   15   16
!  Fe   Fe    Fe    Fe  Fe      Rh    Rh     Cu    Cu    Zn   Zn    Pb    Pb    Pb   Pb
! 6.40 7.06  14.4   122 136.5   20.15 22.7   8.05  8.905 8.62 9.57  10.5  12.6  72.8 75 
  real, dimension(16):: el=(/0.834,0.166,1.0,0.0,0.889,0.111,0.828,0.172,&
                             0.880,0.120,0.878,0.122,0.675,0.325,1.0,0.0/)
  real, dimension(16)::Alcoeff=(/26.52,20.13,2.50,2.50,0.041,0.0391,0.914,0.691, &
                                   13.39,10.29,11.25,8.227,6.38,3.939,0.060,0.058/) 
  real, dimension(16)::Plcoeff=(/1.543,1.155,0.148,0.148,0.0183,0.0175,0.067,0.055, &
                                  0.757,0.578,0.631,0.461,0.358,0.226,0.0213,0.0210/) 
  real, dimension(16)::Nicoeff=(/79.06,57.43,72.647,72.647,0.286,0.233,28.24,21.39, &
                                  43.33,25.2,272.6,210.7,169.4,109.9,0.838,0.773/) 
  integer, dimension(8):: ik=(/3,5,7,1,9,11,13,15/)  
  integer, dimension(8):: lk
  integer :: iP,ncol,nrd,nwr
  common/coeff/Alcoeff,Plcoeff,Nicoeff,el,ik,lk,enel,iP,ncol,nrd,nwr

  integer, parameter:: maxco=64
  integer, dimension(maxco):: ld,lw,lpart,laenge
      character(len=132), dimension(maxco):: helpar,queryar,type
      character(len=16), dimension(maxco):: ext     
      common/scrd/ queryar,helpar,ext,type,ld,lw,laenge,lpart
 
  character(len=132):: chin,querytype,chcom
  character(len=80) :: chdf
  real, dimension(32):: out   
  integer :: n_ch,iout,i,j,nd,jk,jq
        ncol=80; nwr=6; nrd=5; n_ch=64

        chcom='background/measurement'
        call help(chcom)

        queryar(1)='Al aluminum' 
        queryar(2)='Plexi ‎(C_5O_2H_8)n' 
        queryar(3)='Ni nickel ' 
        helpar(1)='background/material/Al' 
        helpar(2)='background/material/plexi'
        helpar(3)='background/material/Ni'
        
1       jq=3 
        jk=jq 
        do i=1,jq 
         ext(i)=' ' 
        end do 
        chdf='Al' 
        chdf(80:80)='#'
        chin='select absorption material ' 
        call query2(jq,jk,chin,chdf,ncol,nrd,nwr) 
        if(jq.le.0)then
         print*,' no material selected'  
         goto 1 
        end if 
        if(jq.eq.1)iP=0
        if(jq.eq.2)iP=16
        if(jq.eq.3)iP=32

        
        print'(i3,4x,a12)',(i,enel(i),i=1,8)
        chcom='selection/energies'
11      chin='1 2 3'  
        querytype='select energies contributing to energy window'
        call askstring(querytype,chin,chcom,ncol,nrd,nwr) 
        call trlch(n_ch,chin,iout,out)
        if(iout.lt.2) then
           call help(chcom)
           goto 11
        end if
        lk=0
        do i=1,iout
         lk(i)=out(i)
        end do
        do i=1,iout
           do j=1,iout
              if(lk(i).eq.lk(j).and.i.ne.j)then
                 print*,'each energy only once'
                 goto 11
              end if
           end do
        end do
        print'(i3,4x,a12)',(lk(i),enel(lk(i)),i=1,iout)
        nd=iout-1
      call D10R6(nd)
   stop
   end program select


subroutine rintensities(nd,thick,att)
  integer,  intent(in):: nd
  real,    dimension(nd), intent(in) :: thick
  real, dimension(nd,nd), intent(out):: att
  real, dimension(48):: Mecoeff
  real, dimension(16):: el
  integer, dimension(8):: ik,lk 
  character(len=12), dimension(8)::enel
  integer :: iP,ncol,nrd,nwr
  common/coeff/Mecoeff,el,ik,lk,enel,iP,ncol,nrd,nwr

  do k=1,nd        
     m=lk(k); i=ik(m)  
    do j=1,nd
     att(j,k)=exp(-thick(j)*Mecoeff(i+iP))*el(i)+exp(-thick(j)*Mecoeff(i+iP+1))*el(i+1)
    end do
  end do

  return
  end subroutine rintensities
  
