program solidAngle
  implicit none
  real*8 ASv,alpha,rB,rQ,pQ,rA,A,Al,Bl,omega0,OMA,smax,dvm,sv,  &
       omegaSI_sea, omegaSS_sea,omegaS_ea,omegaII_sc,omegaS_c,omegaSS_sab,&
       omegaS_cp,omegaI_ep
  real, dimension(0:1025) :: chan,yd
  real, parameter :: rad=0.01745329, pi=3.141592654
  integer,parameter :: maxco=64

  integer,dimension(8) :: values
  character(len=132):: chin,ch132,querytype,chcom,queryar,helpar,type,infotext
  character(len=80):: ch80,localhepath
  character(len=16) :: ext,winfile
  character(len=4)  :: enwr
  character(len=1):: ch1
  integer, save:: iout,nQ,nb,nA,nv,nl,nch
 
  real, dimension(32):: out
  real    r,RAND,PHI_inv,dy
  integer nwr,nrd,ncl,lq,lk,i,k
  integer ld,lw,laenge,lpart
  common/infenw/ enwr(16),infotext(8)
  common/localpath/ localhepath   
  common/scrd/queryar(maxco),helpar(maxco),ext(maxco),type(maxco),  &
                   ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)

  integer  id1,npl,ncol,nrows,ixpixel,iypixel,led,kwin,seed
  common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                  winfile,led 

      ncl=80 
      nwr=6 
      nrd=5
      kwin=1 
      call window(kwin) 
      npl=ncol(kwin) 
      localhepath='/solidangle.help'
      print*,'---------------------------------------------------------------'  
   1   querytype='distance A source aperture and source amplitude S_max [mm]' 
       chcom='A-S_max' 
       ch132=' 35.0   0.1' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000 
       call trlch(80,ch132,iout,out) 
       if(iout.ne.2) goto 1
       A=out(1)
       smax=out(2)
       
2      lk=4
       lq=lk
       do k=1,lq 
        ext(k)=' ' 
       end do 
       ch80='elli' 
       ch80(80:80)='#' 
       helpar(1)='circular aperture' 
       helpar(2)='square aperture' 
       helpar(3)='elliptical aperture of a conic section' 
       helpar(3)='circular aperture PQ' 
                                                                        
       queryar(1)='1 circle' 
       queryar(2)='2 square' 
       queryar(3)='3 ellipsis' 
       queryar(4)='4 circlePQ' 
       chin='solid angle and geometry factor calculation' 
       call query(lq,lk,chin,ch80)
       if(lq.eq.0) goto 1
       if(lq.eq.1) goto 10 
       if(lq.eq.2) goto 20   
       if(lq.eq.3) goto 30
       if(lq.eq.4) goto 15       
!      #################################################
10    continue
      ch132='2.0 64  3.0 128' 
11    querytype='source (rS,nS), aperture (rA,nA)' 
      chcom='circle' 
      call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
      ch1=ch132(1:1) 
      if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000
      call trlch(80,ch132,iout,out)        
      rQ=out(1)
      nQ=out(2)
      rB=out(3)
      nb=out(4)

      print'(a,2f12.6)','Omega(0) point source (exact)  :',&
                                2.*pi*(1.-1./sqrt(1+(rB/A)**2))
      omega0=omegaS_c(A,rB,nb)
      print'(a,2f12.6)','Omega(0) point source (circles):',omega0
      omega0=omegaII_sc(A,rQ,nQ,rB,nb)

      OMA=omegaII_sc(A+smax,rQ,nQ,rB,nb)
      
    print'(a,2f12.6)','Omega(0), Omega(Smax)/Omega(0)=',omega0,OMA/omega0
    print'(a,g12.6)','geo    =',smax/A
    print'(a,g12.6)','geo_eff=',1/sqrt( OMA/omega0)-1

      querytype='new (rS,nS), (rA,nA) values (y/n)'
      chcom='new'
      ch1='n'
      call yesno(querytype,ch1,chcom,ncol,nrd,nwr)
      if(ch1.eq.'y')goto 11

      dvm=1.0d0/256.0d0
    chan=0.0
    
    nch=256  
    do nv=-256,255
     sv=smax*(1.0d0-(nv*dvm)**2)     
     ASv=A+sv   !mm
     chan(nch+nv)= chan(nch+nv)+omegaII_sc(A+sv,rQ,nQ,rB,nb)
     end do  ! nv 
    
    nch=256+512  
    do nv=-256,256
     sv=-smax*(1.0d0-(nv*dvm)**2)     
     ASv=A+sv   !mm
     chan(nch+nv)= chan(nch+nv)+omegaII_sc(A+sv,rQ,nQ,rB,nb)
    end do  ! nv

    goto 50
15    continue
      ch132='5.0 3.0 8' 
16    querytype='source (pQ), aperture (rA,nA)' 
      chcom='circle' 
      call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
      ch1=ch132(1:1) 
      if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000
      call trlch(80,ch132,iout,out)        
      pQ=out(1)
      rA=out(2)
      nA=out(3)

      print'(a,2f12.6)','Omega(0) point source (exact)  :',&
                                       omegaI_ep(A,pQ,rA,rA,200)
      omega0=omegaS_cp(A,pQ,rA,nA)
      print'(a,2f12.6)','Omega(0) point source (circles):',omega0
      omega0=omegaS_cp(A,pQ,rA,nA)
      OMA=omegaS_cp(A+smax,pQ,rA,nA)
      
    print'(a,2f12.6)','Omega(0), Omega(Smax)/Omega(0)=',omega0,OMA/omega0
    print'(a,g12.6)','geo    =',smax/A
    print'(a,g12.6)','geo_eff=',1/sqrt( OMA/omega0)-1

      querytype='new (rS,nS), (rA,nA) values (y/n)'
      chcom='new'
      ch1='n'
      call yesno(querytype,ch1,chcom,ncol,nrd,nwr)
      if(ch1.eq.'y')goto 16

      dvm=1.0d0/256.0d0
    chan=0.0
    
    nch=256  
    do nv=-256,255
     sv=smax*(1.0d0-(nv*dvm)**2)     
     ASv=A+sv   !mm
     chan(nch+nv)= chan(nch+nv)+omegaS_cp(A+sv,pQ,rA,nA)
     end do  ! nv 
    
    nch=256+512  
    do nv=-256,256
     sv=-smax*(1.0d0-(nv*dvm)**2)     
     ASv=A+sv   !mm
     chan(nch+nv)= chan(nch+nv)+omegaS_cp(A+sv,pQ,rA,nA)
    end do  ! nv

    goto 50

20  continue
      ch132='0.2 2  5.0 5.0 6' 
21      querytype='source (rS,nS), aperture (Al,Bl,nl)' 
      chcom='circle' 
      call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
      ch1=ch132(1:1) 
      if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000
      call trlch(80,ch132,iout,out)        
      rQ=out(1)
      nQ=out(2)
      Al=out(3)
      Bl=out(4)
      nl=out(5)
      
      omega0=omegaSS_sab(A,rQ,nQ,Al,Bl,nl)
      OMA=omegaSS_sab(A+smax,rQ,nQ,Al,Bl,nl)

    
    print'(a,2f12.6)','Omega(0), Omega(Smax)/Omega(0)=',omega0,OMA/omega0
    print'(a,g12.6)','geo    =',smax/A
    print'(a,g12.6)','geo_eff=',1/sqrt( OMA/omega0)-1

      alpha=(1.0+ (Al/2./A)**2+(Bl/2./A)**2)/(1.0+ (Al/2./A)**2)/(1.0+ (Bl/2./A)**2)
      alpha=4.0*atan(sqrt((1.0-alpha)/alpha))
      print'(a,f12.6,f12.2,a)','point source square (Al*Bl) omega=', &
           alpha, Al*Bl,'mm^2'

      alpha=2.*3.14159*(1.-1./sqrt(1+(Al/A/2.)**2))
      print'(a,f12.6,f12.2,a,/)','point source circle (r=Al)  omega=',&
      alpha,pi*Al**2/4.0,'mm^2'

      querytype='new (rS,nS), (Al,Bl,nl) values (y/n)'
      chcom='new'
      ch1='n'
      call yesno(querytype,ch1,chcom,ncol,nrd,nwr)
      if(ch1.eq.'y')goto 21

      dvm=1.0d0/256.0d0
 chan=0.0

 nch=256  
 do nv=-256,255
  sv=smax*(1.0d0-(nv*dvm)**2)     
  ASv=A+sv   !mm
  chan(nch+nv)= chan(nch+nv)+omegaSS_sab(A+sv,rQ,nQ,Al,Bl,nl)
  end do  ! nv 

 nch=256+512  
 do nv=-256,256
  sv=-smax*(1.0d0-(nv*dvm)**2)     
  ASv=A+sv   !mm
  chan(nch+nv)= chan(nch+nv)+omegaSS_sab(A+sv,rQ,nQ,Al,Bl,nl)
 end do  ! nv
      goto 50
30    continue
       ch132='45.0 2.0 5 3.0 128' 
31     querytype='conic section ALPHA, source (rS,nS), aperture (rA,nA)' 
       chcom='conic_section' 
       call askstring(querytype,ch132,chcom,ncl,nrd,nwr) 
       ch1=ch132(1:1) 
       if(ch1.eq.'*'.or.ch1.eq.'q') goto 1000
       call trlch(80,ch132,iout,out)        
       alpha=out(1)
       rQ=out(2)
       nQ=out(3)
       rB=out(4)
       nb=out(5)

       ! Omega(Smax)/Omega(0)
      print'(a,2f12.6)','Omega(0) point source (exact 90°)       :',&
                                2.*pi*(1.-1./sqrt(1+(rB/A)**2))
      omega0=omegaS_ea(A,alpha,rB,nb)
      print'(a,2f12.6)','Omega(0) point source    (circles-ellipses):',omega0
      omega0=omegaSS_Sea(A,alpha,rQ,nQ,rB,nb)
      print'(a,2f12.6)','Omega(0) extended source (circles-ellipses):',omega0

      omega0=omegaSI_sea(A,alpha,rQ,nQ,rB,nb)
      OMA=omegaSI_sea(A+smax,alpha,rQ,nQ,rB,nb)

  print'(a,2f12.6)','Omega(0), Omega(Smax)/Omega(0)=',omega0,OMA/omega0
  print'(a,g12.6)','geo    =',smax/A
  print'(a,g12.6)','geo_eff=',1/sqrt( OMA/omega0)-1

     querytype='new alpha (rS,nS), (rA,nA) values (y/n)'
      chcom='new'
      ch1='n'
      call yesno(querytype,ch1,chcom,ncol,nrd,nwr)
      if(ch1.eq.'y')goto 31

 dvm=1.0d0/256.0d0
 chan=0.0

 nch=256  
 do nv=-256,255
  sv=smax*(1.0d0-(nv*dvm)**2)     
  ASv=A+sv   !mm
  chan(nch+nv)= chan(nch+nv)+omegaSI_sea(A+sv,alpha,rQ,nQ,rB,nb)
  end do  ! nv 

 nch=256+512  
 do nv=-256,256
  sv=-smax*(1.0d0-(nv*dvm)**2)     
  ASv=A+sv   !mm
  chan(nch+nv)= chan(nch+nv)+omegaSI_sea(A+sv,alpha,rQ,nQ,rB,nb)
end do  ! nv

50 querytype=' file name for simulated baseline'
   ch132='data.dat'
   chcom='simulation' 
   call askstring(querytype,ch132,chcom,npl,nrd,nwr)     

   open(unit=11,file=TRIM(ch132)                                       &
                 ,status='unknown'                                     &
                 ,access='sequential'                                  &
                 ,form='formatted'                                     &
                 ,err= 50)                 
 write(11,'(a)') 'test'
 write(11,'(a)') '(f9.0,f9.1)  y,dy'
 write(11,'(a)') 'nu_channels=1024   drive_mode=1'
 do i=1,1024
   yd(i)= chan(i)/omega0*10000000.
 end do   
 
 call date_and_time(VALUES=values); seed=values(8)
 call srand(seed)   
 do i=1,1024
    r=RAND(0) 
    if(r.lt.0.0001) r=0.0001
      dy=sqrt(yd(i))*PHI_inv(r)
    write(11,'(f9.0,f9.1)') yd(i)+dy, sqrt(yd(i)+dy) 
 end do

 write(6,'(/,a,/)')'simulated spectrum (1024 channels) written to '//trim(ch132)
1000 continue 
 stop
end program solidAngle


real function PHI_inv(u)
!  Inversion for the normal distribution
!  Approximate PHI**-1(u) by AS70 of Odeh and Evans (1974).        
  real, intent(in):: u
  real(kind=8)   :: v,A,B
  real(kind=8), parameter:: a0=-0.322232431088,  b0= 0.099348626060,  &
                            a1=-1.0           ,  b1= 0.588581570495,  &
                            a2=-0.342242088547,  b2= 0.531103462366,  &
                            a3=-0.0204231210245, b3= 0.103537752850,  &
                            a4=-0.0000453642210148, b4= 0.0038560700634

 v =sqrt(-2.0d0*alog(u))
 A = (((a4* v + a3 )* v + a2 ) * v + a1 )*v + a0
 B = (((b4 *v + b3 )* v + b2 ) *v + b1 ) *v + b0

 Phi_inv= v + A/B
 return
end function PHI_inv

!------------------omegaSI_sea----------(ellipse)------------------------

real*8 function omegaSI_sea(Asv,alpha,rQ,nQ,rB,nb)
  implicit none
  real*8, intent(in):: ASv,alpha
  real*8, intent(inout):: rB,rQ
  integer,intent(in):: nb
  integer,intent(inout):: nQ

  real*8 hv,pv,qv,rA,rA2,rB2,phi,dPhi,phimax8,phimax9,sinphi,cosphi,   &
         sinphi2,cosphi2,pv2,hn,hd,psi,dpsi,rho,rhoQ,drho,frQ,dfrQ,  &
        r8phi,r9phi,sinpsi,cospsi,cosalp,cosalp2,sinalp,sinalp2,pv2rA2,omega
  real*8, dimension(0:nb):: t89phi
  real, parameter :: rad=0.01745329
  integer i,jr,kr,jpsi
  real*8, dimension(8) :: psi0=(/0.0,60.0,30.0,19.0,14.0,11.0,9.0,7.0/)
  real*8, dimension(0:8)::rho0=(/0.0,1.0,sqrt(7.0),sqrt(19.0),   &
             sqrt(37.0),sqrt(61.0),sqrt(91.0),sqrt(127.0),sqrt(170.0)/)
  integer,dimension(8)::npsi=(/1,6,12,18,24,30,36,43/)


  rhoQ=rQ/rho0(nQ)
  
  omega=0.0; frq=0.0
  
  sinalp=sin(alpha*rad); sinalp2=sinalp**2;
  cosalp=cos(alpha*rad);  cosalp2=cosalp**2
  rA=rB/sinalp; ra2=rA**2; rB2=rB**2


 do jr=1,nQ
  dpsi=2.0d0*3.141583/dfloat(npsi(jr))

  rho=(rho0(jr)+rho0(jr-1))*rhoQ/2.0d0; drho=(rho0(jr)-rho0(jr-1))*rhoQ
  dfrQ=rho*drho*dpsi  
  frQ=frQ+dfrQ*npsi(jr)

  do jpsi=1,npsi(jr)
   psi= psi0(jr)*rad + dpsi*dfloat(jpsi)
   cospsi=cos(psi); sinpsi=sin(psi)

   hv=(ASv+rho*cospsi)*sinalp
   pv=(ASv-rho*cospsi)*cosalp; pv2=pv**2
   rA=rB/sinalp
   qv=rho*sinpsi 

!  print*,'hv,pv,rA,rB=',hv,pv,rA,rB 
!  hv=5.d0; pv=6.0d0; rA=5.0; rB=1.d0; qv=0.5; ra2=rA**2; rB2=rB**2; pv2=pv**2

   pv2rA2=pv2-rA2
   hn=sqrt(rB2* pv2rA2+(rA*qv)**2)
  
   phimax8=atan((pv*qv-hn)/pv2rA2)
   phimax9=atan((pv*qv+hn)/pv2rA2)

!   print'(a,6f12.4)','phimax=',phimax8/rad,rA,rB,pv,hv
   dphi= (phimax9-phimax8)/dfloat(nb)

   do i=0,nb
    phi=phimax8+float(i)*dphi
    sinphi=sin(phi); cosphi=cos(phi); sinphi2=sinphi**2; cosphi2=cosphi**2
    hd=rA2*sinphi2+rB2*cosphi2

    hn=dabs(rB2*cosphi2- pv2rA2*sinphi2-(qv*cosphi)**2 &
              +2.d0*qv*cosphi*pv*sinphi)
    hn=rA*rB*sqrt(hn)

    r8phi=(rB2*cosphi*pv+rA2*qv*sinphi-hn)/hd
    r9phi=2.0*hn/hd
    t89phi(i)= 1.0d0/sqrt(1.0d0+(r8phi/hv)**2)     &
                      -1.0d0/sqrt(1.0+((r8phi+r9phi)/hv)**2)
   end do

   hn=0
   do i=1,nb-1,2 
    hn=hn+ t89phi(i)*2.0d0 
   end do 
   do i=2,nb-2,2 
    hn=hn+ t89phi(i) 
 end do
   omega=omega+(hn*2.d0+t89phi(0)+t89phi(nb))/3.d0*dphi*dfrQ
  end do
 end do
  omegaSI_sea=omega/frQ
! print*,'omega=',omegaS,frQ
 return
end function omegaSI_sea

!---------------omegaII_sc----------(extended,circle)-------------------------
real*8 function omegaII_sc(Asv,rQ,nQ,rB,nB)
  implicit none
  real*8, intent(in):: ASv,rQ,rB
  integer,intent(in):: nB,nQ

  real*8 hv,pv,phi,dQ,dPhi,phimax,sinphi,cosphi,hn,r2phi,omega,frQ
  real*8, dimension(0:nB):: t2phi
  real*8, parameter :: pi=3.141592654d0
  integer i,je

  omega=0.0d0; frQ=0.0d0
  phimax=2.0*pi
  dphi= phimax/dfloat(nB)

  dQ=rQ/float(nQ)

  do je=0,nQ-1
     pv=dq/2.0d0+float(je)*dQ
     frQ= frQ+pv
     
   do i=0,nB
     phi=float(i)*dphi
     sinphi=sin(phi); cosphi=cos(phi)
     hn=abs((rB*cosphi)**2+(rB**2-pv**2)*sinphi**2)
     hn=sqrt(hn)
     r2phi=pv*cosphi-hn
     t2phi(i)=1.0d0 -1.0d0/sqrt(1.0d0+(r2phi/ASv)**2)
   end do

   hn=0.d0
   do i=1,nB-1,2 
    hn=hn+ t2phi(i)*2.0d0 
   end do 
   do i=2,nB-2,2 
    hn=hn+ t2phi(i) 
 end do
 omega=omega+(hn*2.d0+t2phi(0)+t2phi(nB))/3.d0*dphi*pv
   
  end do
  omegaII_sc=omega/frQ
  return
 end function omegaII_sc

 !---------------omegaSS_sab------------(extended axb)------------------
 
 real*8 function omegaSS_sab(Asv,rQ,nQ,al,bl,nl)
  implicit none
  real*8, intent(in):: ASv
  real*8, intent(inout):: rQ,al,bl
  integer,intent(in):: nl
  integer,intent(inout):: nQ

  real*8 hv,pv,qv,rA,rA2,rB2,phi,dPhi,phimax8,phimax9,sinphi,cosphi,   &
         sinphi2,cosphi2,pv2,hn,hd,psi,dpsi,rho,rhoQ,drho,frQ,dfrQ,  &
        r8phi,r9phi,sinpsi,cospsi,cosalp,cosalp2,sinalp,sinalp2,pv2rA2
  real*8, dimension(0:2*nl,0:2*nl):: ab
  real, parameter :: rad=0.01745329
  integer i,jr,kr,jpsi,j
  real*8, dimension(8) :: psi0=(/0.0,60.0,30.0,19.0,14.0,11.0,9.0,7.0/)
  real*8, dimension(0:8)::rho0=(/0.0,1.0,sqrt(7.0),sqrt(19.0),   &
             sqrt(37.0),sqrt(61.0),sqrt(91.0),sqrt(127.0),sqrt(170.0)/)
  integer,dimension(8)::npsi=(/1,6,12,18,24,30,36,43/)
  real*8 da,db,omega,simpson2d,xA,yA
  integer nb
  
  da=al/dfloat(2*nl)
  nb=int(bl/da)
  db=bl/dfloat(nb)
  nb=nb/2
  rhoQ=rQ/rho0(nQ); da=da/2.d0; db=db/2.d0

  if(nQ.gt.8) then
   nQ=8
   print'(a,f6.1,a)',' parameters set to rQ=',rQ,' n_max=8 rings <=sqrt(170.0) '
  end if 

  
 omega=0.0; frq=0.0
 do jr=1,nQ
  dpsi=2.0d0*3.141583/dfloat(npsi(jr))

  rho=(rho0(jr)+rho0(jr-1))*rhoQ/2.0d0; drho=(rho0(jr)-rho0(jr-1))*rhoQ
  dfrQ=rho*drho*dpsi  
  frQ=frQ+dfrQ*npsi(jr)

  dfrQ=dfrQ*da*db*4.0d0
  do jpsi=1,npsi(jr)
   psi= psi0(jr)*rad + dpsi*dfloat(jpsi)
   cospsi=cos(psi); sinpsi=sin(psi)

   do i=0,2*nl-1
    do j=0,2*nb-1     
     xA=da/2.d0+dfloat(i)*da
     yA=db/2.d0+dfloat(j)*db
     hd=sqrt(xA**2+yA**2+Asv**2+rho**2-2.d0*rho*(xA*cospsi+yA*sinpsi))
     omega=omega+Asv/hd**3*dfrQ
    end do
   end do 
!   print*,simpson2d(nl,nb,ab),da*db/dfloat(9)
!   read(5,*)
  end do
 end do
 omegaSS_sab=omega/frQ
! print*,'omega=',omega,frQ
 return
end function omegaSS_sab


real*8 function simpson2d(m,n,fik)
! int_a^b int_c^d 2m*2n steps  
! factor (b-a)/2m*(d-c)/2n*1/9 is multiplied outside
implicit none
  real*8, dimension(0:2*m,0:2*n), intent(in)::fik
  integer, intent(in):: n,m
  integer i,j  
  real*8 sim,hsim

  sim=fik(0,0)+fik(0,2*n)+fik(2*m,0)+fik(2*m,2*n)
  hsim=0.0d0
  do j=1,n
   hsim=hsim+2.d0*(fik(0,2*j-1)+fik(2*m,2*j-1))
  end do
  do j=1,n-1
   hsim=hsim+fik(0,2*j)+fik(2*m,2*j)
  end do
  sim=sim+2.0d0*hsim

hsim=0.0d0
  do j=1,m
   hsim=hsim+2.d0*(fik(2*j-1,0)+fik(2*j-1,2*n))
  end do
  do j=1,m-1
   hsim=hsim+fik(2*j,0)+fik(2*j,2*n)
  end do
  sim=sim+2.0d0*hsim

  hsim=0.0d0
   do j=1,n
    do i=1,m
       hsim=hsim+2.d0*fik(2*i-1,2*j-1)
    end do
    do i=1,m-1
      hsim=hsim+fik(2*i,2*j-1)
    end do
   end do
   sim=sim+8.0d0*hsim

   hsim=0.0d0
   do j=1,n-1
    do i=1,m
      hsim=hsim+2.0d0*fik(2*i-1,2*j)
    end do
    do i=1,m-1
      hsim=hsim+fik(2*i,2*j)
    end do
   end do
 
   sim=sim+4.0d0*hsim
   simpson2d=sim
   return
 end function simpson2d

 !-------------------------omegaS_c-----(point, circle)-------------------- 
 real*8 function omegaS_c(Asv,rA,nA)
  implicit none
  real*8, intent(in):: ASv
  real*8, intent(inout)::rA
  integer,intent(in):: nA

  real*8 hv,dpsi,rho,rhoA,drho,frA,dfrA
  real*8, parameter :: rad=0.01745329, pi=3.141592654d0
  integer jr,jpsi,n
!  real*8, dimension(8) :: psi0=(/0.0,60.0,30.0,19.0,14.0,11.0,9.0,7.0/)
  real*8, dimension(0:8)::rho0=(/0.0,1.0,sqrt(7.0),sqrt(19.0),   &
             sqrt(37.0),sqrt(61.0),sqrt(91.0),sqrt(127.0),sqrt(170.0)/)
  integer,dimension(8)::npsi=(/1,6,12,18,24,30,36,43/)
  real*8 omega

  n=nA
  if(n.gt.8) then
   n=8
   print'(a,f6.1,a)',' parameters set to r_A=',rA,' n_max=8 rings <=sqrt(170.0) '
  end if 
 rhoA=rA/rho0(n)
 omega=0.0; frA=0.0

  do jr=1,n
   dpsi=2.0d0*pi/dfloat(npsi(jr))

   rho=(rho0(jr)+rho0(jr-1))*rhoA/2.0d0; drho=(rho0(jr)-rho0(jr-1))*rhoA
   dfrA=rho*drho*dpsi  
   frA=frA+dfrA*npsi(jr)

   do jpsi=1,npsi(jr)
    hv=sqrt(ASv**2+rho**2)
    omega=omega+Asv/hv**3*dfrA
   end do
  end do 
 omegaS_c=omega
! print*,'omega=',omega,frA
 return
end function omegaS_c

!---------------------omegaS_ea------(point, ellipse) ------------------- 
 real*8 function omegaS_ea(Asv,alpha,rA,nA)
  implicit none
  real*8, intent(in):: ASv,alpha
  real*8, intent(inout)::rA
  integer,intent(in):: nA

  real*8 hv,hh,psi,dpsi,cospsi,sinpsi,rho,rhoA,drho,frA,dfrA,coa,ta,cost
  real*8, parameter :: rad=0.01745329, pi=3.141592654d0
  integer jr,jpsi,n
  real*8, dimension(8) :: psi0=(/0.0,60.0,30.0,19.0,14.0,11.0,9.0,7.0/)
  real*8, dimension(0:8)::rho0=(/0.0,1.0,sqrt(7.0),sqrt(19.0),   &
             sqrt(37.0),sqrt(61.0),sqrt(91.0),sqrt(127.0),sqrt(170.0)/)
  integer,dimension(8)::npsi=(/1,6,12,18,24,30,36,43/)
  real*8 omega

  n=nA
  if(n.gt.8) then
   n=8
   print'(a,f6.1,a)',' parameters set to r_A=',rA,' n_max=8 rings <=sqrt(170.0) '
  end if 

  rhoA=rA/rho0(n)
 omega=0.0; frA=0.0; coa=cos((90.0-alpha)*rad); ta=tan((90.0-alpha)*rad)

  do jr=1,n
   dpsi=2.0d0*pi/dfloat(npsi(jr))

   rho=(rho0(jr)+rho0(jr-1))*rhoA/2.0d0; drho=(rho0(jr)-rho0(jr-1))*rhoA
   dfrA=rho*drho*dpsi/coa  
   frA=frA+dfrA*npsi(jr)

   do jpsi=1,npsi(jr)
    psi= psi0(jr)*rad + dpsi*dfloat(jpsi)
    cospsi=cos(psi); sinpsi=sin(psi)

    hh=ASv/sqrt(1.d0+ta**2)
    hv=ASv**2+rho**2*(1.d0+(sinpsi*ta)**2)+2.d0*Asv*rho*sinpsi*ta
    cost=hh/sqrt(hv)
    omega=omega+cost/hv*dfrA
   end do
  end do 
 omegaS_ea=omega
 return
end function omegaS_ea

!-----------------------omegaS_cp-------(point-pQ, circle)--------------- 
 real*8 function omegaS_cp(Asv,pQ,rA,nA)
  implicit none
  real*8, intent(in):: ASv,pQ
  real*8, intent(inout)::rA
  integer,intent(in):: nA

  real*8 hv,hh,psi,dpsi,cospsi,sinpsi,rho,rhoA,drho,frA,dfrA,cost
  real*8, parameter :: rad=0.01745329, pi=3.141592654d0
  integer jr,jpsi,n
  real*8, dimension(8) :: psi0=(/0.0,60.0,30.0,19.0,14.0,11.0,9.0,7.0/)
  real*8, dimension(0:8)::rho0=(/0.0,1.0,sqrt(7.0),sqrt(19.0),   &
             sqrt(37.0),sqrt(61.0),sqrt(91.0),sqrt(127.0),sqrt(170.0)/)
  integer,dimension(8)::npsi=(/1,6,12,18,24,30,36,43/)
  real*8 omega

  n=nA
  if(n.gt.8) then
   n=8
   print'(a,f6.1,a)',' parameters set to r_A=',rA,' n_max=8 rings <=sqrt(170.0) '
  end if 

  rhoA=rA/rho0(n)
  omega=0.0; frA=0.0; 

  do jr=1,n
   dpsi=2.0d0*pi/dfloat(npsi(jr))

   rho=(rho0(jr)+rho0(jr-1))*rhoA/2.0d0; drho=(rho0(jr)-rho0(jr-1))*rhoA
   dfrA=rho*drho*dpsi  
   frA=frA+dfrA*npsi(jr)

   do jpsi=1,npsi(jr)
    psi= psi0(jr)*rad + dpsi*dfloat(jpsi)
!    psi= -dpsi/2.d0 + dpsi*dfloat(jpsi)
    cospsi=cos(psi); sinpsi=sin(psi)

    hh=Asv  
    hv=sqrt(Asv**2+pQ**2+rho**2+2.d0*rho*pQ*cospsi) 
    cost=hh/hv
    omega=omega+cost/hv**2*dfrA
   end do
  end do 
 omegaS_cp=omega
!print*,'######omega=',omega,frA
 return
end function omegaS_cp




!-------------------omegaI_ep--------(point-pQ, ellipse)----------------- 

real*8 function omegaI_ep(Asv,pQ,rA,rB,nn)
  implicit none
  real*8, intent(in):: ASv,pQ
  real*8, intent(in):: rA,rB
  integer,intent(in):: nn

  real*8 hv,pv,phi,dPhi,phimax,sinphi,cosphi,hn,hd,r4phi,r5phi
  real*8, dimension(0:nn):: t45phi
  real*8, parameter :: rad=0.01745329
  integer i

  hv=ASv
  pv=pQ
!  hv=1.d0; pv=5.0d0; rA=2.0; rB=1.d0
  phimax=atan(sqrt(rB**2/(pv**2-rA**2)))

!  print'(a,6f12.4)','phimax=',phimax/rad,rA,rB,pv,hv
   dphi= phimax/dfloat(nn)

   do i=0,nn
    phi=float(i)*dphi
    sinphi=sin(phi); cosphi=cos(phi)
    hn=dabs((rB*cosphi)**2+(rA**2-pv**2)*sinphi**2)
    hn=rA*rB*sqrt(hn)
    hd=(rA*sinphi)**2+(rB*cosphi)**2

    r4phi=(rB**2*cosphi*pv-hn)/hd
    r5phi=2.0*hn/hd
    t45phi(i)= 2.0d0/sqrt(1.0d0+(r4phi/hv)**2)     &
                      -2.0/sqrt(1.0+((r4phi+r5phi)/hv)**2)
   end do

   hn=0
   do i=1,nn-1,2 
    hn=hn+ t45phi(i)*2.0d0 
   end do 
   do i=2,nn-2,2 
    hn=hn+ t45phi(i) 
   end do
   omegaI_ep=(hn*2.d0+t45phi(0)+t45phi(nn))/3.d0*dphi
!   print*,'--------omega=',omega
   return
 end function omegaI_ep


 !---------------------omegaSS_sea------(point, ellipse) ------------------- 
 real*8 function omegaSS_sea(Asv,alpha,rQ,nQ,rA,nA)
  implicit none
  real*8, intent(in):: ASv,alpha
  real*8, intent(inout)::rA,rQ
  integer,intent(in):: nA,nQ

  real*8 hv,hh,psi,dpsi,cospsi,sinpsi,phi,dphi,cosphi,sinphi,  &
         rhoQ,rhom,drhom,rhoA,rhon,drhon,frQ,dfrQ,frA,dfrA,    &
         coa,ta,cost,hphps
  real*8, parameter :: rad=0.01745329, pi=3.141592654d0
  integer jQ,jA,jphi,jpsi,n,m
  real*8, dimension(8) :: psi0=(/0.0,60.0,30.0,19.0,14.0,11.0,9.0,7.0/)
  real*8, dimension(0:8)::rho0=(/0.0,1.0,sqrt(7.0),sqrt(19.0),   &
             sqrt(37.0),sqrt(61.0),sqrt(91.0),sqrt(127.0),sqrt(170.0)/)
  integer,dimension(8)::npsi=(/1,6,12,18,24,30,36,43/)
  real*8 omega

  m=nQ
  if(m.gt.8) then
   m=8
   print'(a,f6.1,a)',' parameters set to r_A=',rA,' n_max=8 rings <=sqrt(170.0) '
  end if 
  n=nA
  if(n.gt.8) then
   n=8
   print'(a,f6.1,a)',' parameters set to r_A=',rA,' n_max=8 rings <=sqrt(170.0) '
  end if 

  
  rhoA=rA/rho0(n); rhoQ=rQ/rho0(n)
  omega=0.0; frA=0.0; frQ=0.0;
  coa=cos((90.0-alpha)*rad); ta=tan((90.0-alpha)*rad)

  do jQ=1,m
    dphi=2.0d0*pi/dfloat(npsi(jQ))
    
    rhom=(rho0(jQ)+rho0(jQ-1))*rhoQ/2.0d0; drhom=(rho0(jQ)-rho0(jQ-1))*rhoQ
    dfrQ=rhom*drhom*dphi  
    frQ=frQ+dfrQ*npsi(jQ)

    do jphi=1,npsi(jQ)  
      phi= psi0(jQ)*rad + dphi*dfloat(jphi)
      cosphi=cos(phi); sinphi=sin(phi)
        
      do jA=1,n
       dpsi=2.0d0*pi/dfloat(npsi(jA))
      
       rhon=(rho0(jA)+rho0(jA-1))*rhoA/2.0d0; drhon=(rho0(jA)-rho0(jA-1))*rhoA
       dfrA=rhon*drhon*dpsi/coa  
       frA=frA+dfrA*npsi(jA)
      
       do jpsi=1,npsi(jA)
        psi= psi0(jA)*rad + dpsi*dfloat(jpsi)
        cospsi=cos(psi); sinpsi=sin(psi)

        hphps=1.d0- cosphi*cospsi-sinphi*sinpsi
        hh=(ASv+rhom*sinphi*ta)/sqrt(1.d0+ta**2)
        hv=(ASv+rhon*sinpsi*ta)**2+(rhon-rhom)**2+2.d0*rhon*rhom*hphps
        cost=hh/sqrt(hv)
        omega=omega+cost/hv*dfrA*dfrQ
       end do ! jpsi
      end do  ! jA
    end do ! jphi
   end do  ! jQ
   omegaSS_sea=omega/frQ
   print*,omegaSS_sea,omega,frQ
 return
end function omegaSs_sea
