program solidAngle
  implicit none
  real*8 ASv,alpha,rB,rQ,A,omega0,smax,dvm,sv,omega,OMA
  real, dimension(0:1025) :: chan,yd
  real, parameter :: rad=0.01745329
  integer, save:: i,iout,nn,nv,nch
  character(len=132):: chin,ch132 
  real, dimension(8):: out
  real    r,RAND,PHI_inv,dy
  
  nn=128
  alpha=45 ! grad
  write(6,'(//,a)')' point source: elliptical shape of the  aperture as a cone section'

  smax=0.1  !mm 
  rB=3.0    !mm
  alpha=45  ! grad
  rQ=2.0    !mm
  A=35.0    !mm

  write(6,'(/,a)')' [mm]   smax     rQ       rB        A     alpha'
  write(6,'(a,5f10.3,a)')'  ', smax,rQ,rB,A,alpha,'    print 5 (new) values'
    ch132='      0.100      2.0       3.0      50    45.'
2  read(5,'(a)')chin
   if(chin.eq.' ') then
     chin=ch132
     write(6,'(a)')' use of old values'
   end if   
   call trlch(80,chin,iout,out)
   if(iout.ne.5) goto 2
   smax=out(1)
   rQ=out(2)
   rB=out(3)
   A=out(4)
   alpha=out(5)

   ! Omega(Smax)/Omega(0)
   omega0=omega(A,alpha,rQ,rB,nn)
   OMA=omega(A+smax,alpha,rQ,rB,nn)
print'(a,f10.4)','Omega(Smax)/Omega(0)=', OMA/omega0
print'(a,g10.4)','geo    =',smax/A
print'(a,g10.4)','geo_eff=',1/sqrt( OMA/omega0)-1
   

write(6,'(/,a,/)')'simulated spectrum (1024 channels) written to fort.11'
 stop
end program solidAngle


real function PHI_inv(u)
!  Inversion for the normal distribution
!  Approximate PHI**-1(u) by AS70 of Odeh and Evans (1974).        
  real, intent(in):: u
  real(kind=8)   :: v,A,B
  real(kind=8), parameter:: a0=-0.322232431088,  b0= 0.099348626060,  &
                            a1=-1.0           ,  b1= 0.588581570495,  &
                            a2=-0.342242088547,  b2= 0.531103462366,  &
                            a3=-0.0204231210245, b3= 0.103537752850,  &
                            a4=-0.0000453642210148, b4= 0.0038560700634

 v =sqrt(-2.0d0*alog(u))
 A = (((a4* v + a3 )* v + a2 ) * v + a1 )*v + a0
 B = (((b4 *v + b3 )* v + b2 ) *v + b1 ) *v + b0

 Phi_inv= v + A/B
 return
end function PHI_inv

 real*8 function omega(Asv,alpha,rQ,rB,nn)
  implicit none
  real*8, intent(in):: ASv,alpha
  real*8, intent(inout):: rB,rQ
  integer,intent(in):: nn

  real*8 hv,pv,qv,rA,rA2,rB2,phi,dPhi,phimax8,phimax9,sinphi,cosphi,   &
         sinphi2,cosphi2,pv2,hn,hd,psi,dpsi,rho,drho,frQ,dfrQ,  &
        r8phi,r9phi,sinpsi,cospsi,cosalp2,sinalp,sinalp2,pv2rA2
  real*8, dimension(0:nn):: t89phi
  real, parameter :: rad=0.01745329
  integer i,jr,kr

  omega=0.0; frq=0.0
  sinalp=sin(alpha*rad)**2; sinalp2=sinalp**2;  cosalp2=cos(alpha*rad)**2
  rA=rB/sinalp; ra2=rA**2; rB2=rB**2

  dpsi=3.141583/32.0; drho=rq/8.0

 do jr=0,31
  psi=dpsi*dfloat(jr)
  cospsi=cos(psi); sinpsi=sin(psi)

  do kr=0,7 
   rho=drho/2.0d0+drho*dfloat(kr)
   dfrQ=rho*drho*dpsi  
   frQ=frQ+dfrQ
   
   hv=(ASv+rho*cospsi)*sinalp
   pv=sqrt((ASv-rho*cospsi)**2*cosalp2+rho*sinalp2); pv2=pv**2
   rA=rB/sinalp
   qv=rho*sinpsi 

  
!  hv=1.d0; pv=6.0d0; rA=5.0; rB=1.d0; qv=0.5; ra2=rA**2; rB2=rB**2; pv2=pv**2

   pv2rA2=pv2-rA2
   hn=sqrt(rB2* pv2rA2+(rA*qv)**2)
  
   phimax8=atan((pv*qv-hn)/pv2rA2)
   phimax9=atan((pv*qv+hn)/pv2rA2)

!   print'(a,6f12.4)','phimax=',phimax8/rad,phimax9/rad
   dphi= (phimax9-phimax8)/dfloat(nn)

   do i=0,nn
    phi=phimax8+float(i)*dphi
    sinphi=sin(phi); cosphi=cos(phi); sinphi2=sinphi**2; cosphi2=cosphi**2
    hd=rA2*sinphi2+rB2*cosphi2

    hn=dabs(rB2*cosphi2- pv2rA2*sinphi2-(qv*cosphi)**2 &
              +2.d0*qv*cosphi*pv*sinphi)
    hn=rA*rB*sqrt(hn)

    r8phi=(rB2*cosphi*pv+rA2*qv*sinphi-hn)/hd
    r9phi=2.0*hn/hd
    t89phi(i)= 1.0d0/sqrt(1.0d0+(r8phi/hv)**2)     &
                      -1.0/sqrt(1.0+((r8phi+r9phi)/hv)**2)
   end do

   hn=0
   do i=1,nn-1,2 
    hn=hn+ t89phi(i)*2.0d0 
   end do 
   do i=2,nn-2,2 
    hn=hn+ t89phi(i) 
   end do
   omega=omega+(hn*2.d0+t89phi(0)+t89phi(nn))/3.d0*dphi*dfrQ
  end do
 end do
 omega=omega/frQ
 print*,'omega=',omega,frQ
 return
end function omega


       subroutine trlch(n_ch,chin,iout,out) 
      implicit none
      character chin*132,ch*132 
      real      out(8),pt 
      integer nch,n_ch, &
              i,ic,i0,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given as ch*13
!     to iout real numbers (max.32) stored in the vector out.           
!     nch characters of ch(1:nch) are analysed.                         
      nch=n_ch 
      if(nch.gt.132) nch=132 
      ch=chin 
      i0=ichar('0') 
      nsig=1 
      pt=1. 
      k1=0 
      k2=0 
      nex=0 
      nnum=0 
      iout=0 
      do k=1,32 
       out(k)=0. 
      end do 
                                                                        
      k=0 
   10 k=k+1 
      i=ichar(ch(k:k))-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.nch) goto 50 
       goto 100 
      end if 
                                                                        
      if(ch(k:k).eq.'e'.or.ch(k:k).eq.'E') then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(ch(i:i).eq.'.') then 
         nex=-1 
         goto 50 
        end if 
        ic=ichar(ch(i:i))-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (ch(k:k).eq.'.') then 
        pt =0.1 
        goto 100 
      end if 
      if(ch(k:k).eq.'-') then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.ch(k:k).eq.' ') nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60 
      out(iout)=out(iout)*10.**out(iout+1) 
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.32) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.nch) goto 10 
  110 return 
      END                                           
