 program pafr
   character(len=16) :: filename
   character(len=132):: chin
      
   character(len=16), dimension(11)::name
   real, dimension(16,11):: v
   real, dimension(11):: av
   real, dimension(32):: out
   
   filename='chitest.dat'
   
   open (unit=2,file=filename                   &
                   ,status='unknown'            &
                   ,access='sequential'         &
                   ,form='formatted')                            

   read(2,'(a)')chin
   write(6,'(a)')TRIM(chin)
   read(2,'(a)')chin
   do i=1,11
    read(2,'(a)')chin
    name(i)=chin(1:10)
    write(6,'(a)')name(i)   
   end do
   read(2,'(a)')chin
   read(2,'(a)')chin

   do i=1,11
      read(2,'(a)')chin
    call trlch(80,chin,nn,out)
    do j=1,nn
       v(j,i)=out(j)
    end do
   end do
   read(2,'(a)')chin

   do i=1,11
    read(2,'(a)')chin
    call trlch(80,chin,nn,out)
    do j=1,nn
       v(j+8,i)=out(j)
    end do
   end do

! average
   do i=1,11
    h=0.0
    do j=1,16
       h=h+v(j,i)
    end do
    av(i)=h/16.0
   end do

   do i=1,11
    write(6,'(a16,f12.4)')name(i), av(i)
   end do

   !error
   do i=1,11
    h=0.0
    do j=1,16
       h=h+(v(j,i)-av(i))**2
    end do
    h=sqrt(h/15)
    write(6,'(a16,f12.3,a2,f8.4)')name(i), av(i),'+-',h   
   end do

   stop
 end program pafr

      subroutine trlch(n_ch,chin,iout,out) 
      implicit none
      character chin*132,ch*132 
      real      out(32),pt 
      integer nch,n_ch, &
              i,ic,i0,nsig,k,k1,k2,nex,nnum,iout 
!     program translates numbers (all possible fortran formates,        
!     separated by at least one blank or other character) given as ch*13
!     to iout real numbers (max.32) stored in the vector out.           
!     nch characters of ch(1:nch) are analysed.                         
      nch=n_ch 
      if(nch.gt.132) nch=132 
      ch=chin 
      i0=ichar('0') 
      nsig=1 
      pt=1. 
      k1=0 
      k2=0 
      nex=0 
      nnum=0 
      iout=0 
      do k=1,32 
       out(k)=0. 
      end do 
                                                                        
      k=0 
   10 k=k+1 
      i=ichar(ch(k:k))-i0 
      if(i.ge.0.and.i.lt.10) then 
       nnum=1 
       if (pt.eq.1.) then 
        out(iout+1)=out(iout+1)*10.+float(i) 
       else 
        out(iout+1)=out(iout+1)+float(i)*pt 
        pt=pt/10. 
       end if 
       if(k.eq.nch) goto 50 
       goto 100 
      end if 
                                                                        
      if(ch(k:k).eq.'e'.or.ch(k:k).eq.'E') then 
       if(nex.eq.1) goto 50 
       do i=k-1,1,-1 
        if(ch(i:i).eq.'.') then 
         nex=-1 
         goto 50 
        end if 
        ic=ichar(ch(i:i))-i0 
        if(ic.lt.0.or.ic.gt.9) goto 100 
       end do 
      end if 
                                                                        
      if(pt.lt.1.)then 
       k=k-1 
       goto 50 
      end if 
                                                                        
      if (ch(k:k).eq.'.') then 
        pt =0.1 
        goto 100 
      end if 
      if(ch(k:k).eq.'-') then 
        if(nsig.eq.1) k1=k 
        if(nsig.eq.-1) k2=k 
        nsig=-1 
      end if 
      if(nnum.eq.1) goto 50 
      if(nex.eq.1.and.ch(k:k).eq.' ') nex=0 
      goto 100 
                                                                        
   50 if(k1.lt.k) then 
       out(iout+1)=nsig*out(iout+1) 
       if(k2.lt.k1) then 
        nsig=1 
       else 
        k1=k2 
       end if 
      end if 
      nnum=0 
      pt=1. 
      if (nex.le.0) goto 60 
      out(iout)=out(iout)*10.**out(iout+1) 
      nex=0 
      out(iout+1)=0. 
      iout=iout-1 
   60 if (iout.eq.32) goto 110 
      iout=iout+1 
      k1=0 
      k2=0 
      if(nex.eq.-1) nex=1 
                                                                        
  100 if(k.lt.nch) goto 10 
  110 return 
      END                                           
                                                   
 
