     program main
      implicit none
     integer,parameter :: maxco=64
     character(len=132):: queryar,helpar,type,                        &
                          querytype,chin,chcom,ch132,cp132,ct132
     character(len=16) :: ext,winfile,element
     character(len=80) :: ch80,localhepath
     character(len=3),dimension(1:3):: eai,ebi
     character(len=132):: infotext
     character(len=8)  :: ch8  
     character(len=6)  :: chbold,chnorm                       
     character(len=7)  :: form
     character(len=4)  :: enwr,source      
     character(len=2), dimension(82) :: ES
     character(len=12),dimension(82) :: Ename
     character(len=12) :: name
     character(len=2)  :: ch2
     character(len=1)  :: ch1      

     real,    dimension(82) :: Emolweight
     integer, dimension(12) :: indx, mult
     real,    dimension(12) :: atcoef
 
     common/infenw/ enwr(16),infotext(8)
     common/localpath/ localhepath 
     common/scrd/ queryar(maxco),helpar(maxco),ext(maxco),type(maxco),&
                  ld(maxco),lw(maxco),laenge(maxco),lpart(0:maxco)
     integer     id1,npl,ncol,nrows,ixpixel,iypixel,led,               &
                 ncl,nwr,nrd,kwin,icol
     integer     ld,lw,laenge,lpart      
     common/term/id1,npl,ncol(8),nrows(8),ixpixel(8),iypixel(8),       &
                 winfile,led 
     integer i,l,lq,lk,j,k,nZ,mZ,iout
     real value,energy,atc,atc1,atc2,thick,density,hmol,trm
     real      out(32)
      
     chbold=char(27)//'[1m' 
     chnorm=char(27)//'[0m' 
      ncl=80 
      nwr=6 
      nrd=5 
      kwin=1 
      call window(kwin) 
      npl=ncol(kwin) 
      icol=npl

      write(nwr,'(/,7(a,/),//)')' The program uses the tables:', &
      ' X-Ray Mass Attenuation Coefficients', &
      ' published by National Institute of Standards and Technology (NIST)',&
      ' 1996 copyright by the U.S. Secretary of Commerce',&
      ' and',&
      ' Das Periodensystem der Elemente online:Dichte der Elemente im Festzustand',&
      ' Copyright 2010-2015 by René Rausch'

      
     open (unit=1, file='elements.dat')
     do i=1,82
      read(1,'(a)')ch80
!42      Mo      Molybdenum        95.95      
      ES(i)=ch80(9:10)
      Ename(i)=ch80(17:28)
      ch132=ch80(30:)
      call trlch(20,ch132,iout,out)
      Emolweight(i)=out(1)
     end do
     close(unit=1)
!     do i=1,82
!    write(6,'(i3,2x,a2,2x,a12,4x,f10.2)')i,ES(i),Ename(i),Emolweight(i)
!     end do

      localhepath='/attenuation.help'       

5      lq=11
       lk=lq 
       do k=1,lq 
        ext(k)=' ' 
       end do 
       ch80='Nickel' 
       ch80(80:80)='#' 
       helpar(1)='read/element' 
       helpar(2)='read/element' 
       helpar(3)='read/element' 
       helpar(4)='read/element'
       helpar(5)='read/element' 
       helpar(6)='read/mylar' 
       helpar(7)='read/teflon' 
       helpar(8)='read/sodiumnitrop' 
       helpar(9)='read/fas' 
       helpar(10)='read/compound' 
       helpar(11)='read/bgco57'
                                                                         
       queryar(1)='1 Nickel foil' 
       queryar(2)='2 Iron foil' 
       queryar(3)='3 Lead shielding' 
       queryar(4)='4 Aluminium foil' 
       queryar(5)='5 ES: element symbol' 
       queryar(6)='6 mylar' 
       queryar(7)='7 teflon' 
       queryar(8)='8 Na_2Fe[(CN)_5NO]2H2O' 
       queryar(9)='9 FAS' 
       queryar(10)='10 compound' 
       queryar(11)='11 0.111(136.5keV), 0.889(122.0keV)'
 
       chin='select ' 
       call query(lq,lk,chin,ch80)
       if(lq.eq.0) goto 5
       source='xkeV'
       
       select case(lq)
       case(1)
        name='Nickel'
        value=122.0 ; form='f8.2'; density=8.908 
       case(2)
        name='Iron'
        value=14.4; form='f8.2'; density=7.874 
       case(3)
        name='Lead'
        value=122.0; form='f8.1'; density=11.342 
       case(4)
        name='Aluminum'
        value=14.4; form='f8.2'; density=2.70
       case(5)
        querytype='symbol for the element '
        chin='Cu'
        chcom='read/element' ; density=8.92 
        call askstring(querytype,chin,chcom,ncol,nrd,nwr) 
        ch2=chin
        i=1
        do while(ES(i).ne.ch2)
         i=i+1
        end do
        name=Ename(i); value=14.4; form='f8.2'
       case(6)
!       C10H8O4 1.38g/cm³
        j=3; indx(1)=6; mult(1)=10; indx(2)=1; mult(2)=8; indx(3)=8; mult(3)=4
        density=1.38; value=14.4
        call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc)
       case(7)
        !  C2F4 Teflon   2.20 g/cm³
        j=2; indx(1)=6; mult(1)=2; indx(2)=9; mult(2)=4
        density=2.20; value=14.4
        call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc)
       case(8)
        ! Na_2Fe[(CN)_5NO]2H_2O,   1,72 g/cm3

        j=6; indx(1)=11; mult(1)=2; indx(2)=26; mult(2)=1
             indx(3)=6; mult(3)=5;  indx(4)=7; mult(4)=6
             indx(5)=8; mult(5)=3;  indx(6)=1; mult(6)=2
        density=1.72; value=14.4
        call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc)

       case(9)
        ! (NH_4)_2Fe(SO_4)_2·6H_2O,   1,72 g/cm3

        j=5; indx(1)=7; mult(1)=2; indx(2)=1; mult(2)=20
             indx(3)=26; mult(3)=1;  indx(4)=16; mult(4)=2
             indx(5)=8; mult(5)=14
        density=1.86; value=14.4
        call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc)
 
       case(10)
        querytype='formula of the compound'
        chin='N_2H_8Fe_1S_2O_8H_12O_6'
        chcom='read/compound' 
        call askstring(querytype,chin,chcom,ncol,nrd,nwr) 

        value=0.0; form='f8.2'
        querytype='density of the compound g/cm3'; chcom='read/density'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        density=value; value=14.4

        call contentformula(chin,ES,j,indx,mult)
        call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc)
     
   case(11)
        querytype='formula of the compound'
        chin='N_2H_8Fe_1S_2O_8H_12O_6'
        chcom='read/compound' 
        call askstring(querytype,chin,chcom,ncol,nrd,nwr) 

        density=1.86; form='f8.2'
        querytype='density of the compound g/cm3'; chcom='read/density'
        call askvalue(querytype,form,density,chcom,ncol,nrd,nwr)
        call contentformula(chin,ES,j,indx,mult)
        
        value=122.01
        call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc1)
        value=136.46
        call atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc2)
        source='57Co'
      end select

      nZ=0
      if(lq.le.5) then
        querytype='Photon energy in keV'; chcom='read/energy'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        energy=value
        
        ! interpolated value atc at energy for element <name>
        open (unit=1, file='attenuation.coefficients')
        l=LEN_TRIM(name)+1
        element=' '  
        do while(element(2:l).ne.name)
         read(1,'(a)')element
        end do
        read(1,'(a)')element      
        ch8=element(4:)
        call c8toi(ch8,nZ)
        call attenuation(energy,atc)
        print'(a,f8.3)','        mue/rho=',atc
        close(unit=1)      
      end if
       if(density.gt.0.0) then
        lq=2
        lk=lq 
        do k=1,lq 
         ext(k)=' ' 
        end do 
        ch80='mg/cm2' 
        ch80(80:80)='#' 
        helpar(1)='read/mgcm2' 
        helpar(2)='read/thickness' 
        queryar(1)='thickness mg/cm2' 
        queryar(2)='thickness in mm'
        chin='thickness of the sample' 
        call query(lq,lk,chin,ch80) 
       else
        lq=1
       end if

20     if(lq.eq.1)then
        form='f8.2'
        value=100.0   !   mg/cm2
        querytype='thickness mg/cm2'; chcom='read/mgcm2'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        thick=value/1000.
       else !lq=2
        value=0.125  ! mm
        form='f8.3'
        querytype='thickness in mm'; chcom='read/mgcm2'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)

        if(nZ.gt.0.and.nZ.le.99) then
         ! read dichte.dat for density of an element
         open (unit=2, file='dichte.dat')
         mZ=0
         do while(mZ.ne.nZ)
          read(2,'(a)')ch80
          ch8=ch80
          call c8toi(ch8,mZ)
         end do
         lq=1
         queryar(1)=ch80(9:) 
         do while(mZ.eq.nZ)
          read(2,'(a)')ch80
          ch8=ch80
          call c8toi(ch8,mZ)           
          if(mZ.eq.nZ) then
           lq=lq+1            
           queryar(lq)=ch80(9:) 
          end if
         end do
         lk=lq 
         do k=1,lq 
          ext(k)=' ' 
         end do 
         ch80=queryar(1)(:10) 
         ch80(80:80)='#' 
         helpar(1)='read/modification' 
         helpar(2)='read/modification' 
         chin='density of the modifications' 
         call query(lq,lk,chin,ch80)
         ch132=queryar(lq)(31:) 
         call trlch(60,ch132,iout,out)
         density=out(1)
         close(unit=2)
        end if 
        thick=value*density/10.   ! mm*g/cm3  
       end if

       write(nwr,'(//,a,f10.2)')'       mg/cm2=',thick*1000.0
      select case(source)     
      case('57Co')
          trm=0.889*exp(-thick*atc1)+0.111*exp(-thick*atc2)
       case('xkeV')
          trm=exp(-thick*atc)
      end select
      write(nwr,'(a,f10.4,/)')' transmission=',trm
      ch1='y'
      querytype='new value for the thickness'; chcom='read/repeat'
      call yesno(querytype,ch1,chcom,ncol,nrd,nwr)   
      if(ch1.eq.'y') goto 20      
 end program main


 subroutine attenuation(energy,atc)
!====================================================================
!base on the code of spline interpolation described in
!http://ww2.odu.edu/~agodunov/computing/programs/book2/Ch01/spline.f90
! Spline interpolation
! Comments: values of function f(x) are calculated in n base points
! then: spline coefficients are computed
!       spline interpolation is computed in 2n-1 points, 
!       a difference sum|f(u)-vspline(u)| 
!====================================================================
   implicit none
   real, intent(in):: energy
   real, intent(out):: atc   
integer, parameter :: n=100      ! base points for interpolation
integer, parameter :: nint=21   ! compute interpolation in nint points
double precision xmin, xmax     ! given interval of x()
double precision, dimension (n) :: xi(0:n), yi(n), zi(n)
double precision, dimension (n) :: xs(4), ys(4), zs(4), b(4), c(4), d(4)
double precision x, y, step, error, errav
integer i,ns
double precision f, vspline
character*80 input

do i=1,6
   read(1,'(a)')input
!   print'(a)',input
end do
! step 1: generate xi and yi from f(x), xmin, xmax, n
i=0
xi(0)=0
do while(xi(i).lt.20)
   i=i+1
!   1.00000E-03  5.210E+03  5.197E+03 
   read(1,'(3x,e11.5,2x,e9.3,2x,e9.3)')xi(i),yi(i),zi(i)
!   print*,i,xi(i),yi(i)
end do

x=energy*1.0e-3
 i=1
do while(x.ge.xi(i))
!   print*,i,xi(i),yi(i)
   i=i+1
end do
if(xi(i).eq.x) then
  atc=yi(i)
   write (*,'(3f12.5)') x, atc
   goto 100
end if
i=i-1
if(xi(i-1).lt.xi(i))then
   ns=4
   xs(1)=xi(i-1); xs(2)=xi(i); xs(3)=xi(i+1); xs(4)=xi(i+2) 
   ys(1)=yi(i-1); ys(2)=yi(i); ys(3)=yi(i+1); ys(4)=yi(i+2) 
   if(xi(i+2).eq.xi(i+1))ns=3
else
  ns=3
  xs(1)=xi(i); xs(2)=xi(i+1); xs(3)=xi(i+2)
  ys(1)=yi(i); ys(2)=yi(i+1); ys(3)=yi(i+2)
  if(xi(i+2).eq.xi(i+1))ns=2
end if
!  write(6,'(3x,e11.5,2x,e9.3)')(xs(i),ys(i),i=1,ns)
!  step 2: call spline to calculate spline coeficients
call spline (xs, ys, b, c, d, ns) 

!  step 3: interpolation at nint points
  atc = vspline(x, xs, ys, b, c, d, ns)
!  write (*,'(3f12.5)') x, atc
100 continue

end subroutine attenuation


   subroutine atcoefficient(nrd,nwr,j,indx,mult,Ename,Emolweight,value,atc)
   implicit none
   integer, intent(in):: j,nrd,nwr
   integer, dimension(12), intent(in):: indx,mult
   character(len=12), dimension(82), intent(in):: Ename 
   real,              dimension(82), intent(in):: Emolweight   
   real, intent(in)  :: value
   real, intent(out) :: atc

   character(len=132):: chcom,querytype
   character(len=12):: name,element
   character(len=7) :: form
   real,    dimension(12) :: atcoef
   real energy,hmol
   integer ncol,i,l
        ncol=80
        
        chcom='read/compound' 
        form='f8.2'
        querytype='Photon energy in keV'; chcom='read/energy'
        call askvalue(querytype,form,value,chcom,ncol,nrd,nwr)
        energy=value

        do i=1,j
         name=Ename(indx(i))
         open (unit=1, file='attenuation.coefficients')
         l=LEN_TRIM(name)+1
         element=' '  
         do while(element(2:l).ne.name)
          read(1,'(a)')element
         end do
         read(1,'(a)')element
         call attenuation(energy,atc)
         close(unit=1)       
         atcoef(i)=atc
        end do
        hmol=0.
        do i=1,j
         hmol=hmol+mult(i)*Emolweight(indx(i))
        end do
        atc=0.
        do i=1,j
         atc=atc+mult(i)*Emolweight(indx(i))*atcoef(i)
        end do
        atc=atc/hmol
        print'(a,f8.3)','        mue/rho=',atc
      return
     end

    subroutine contentformula(formula,ES,j,indx,mult)
   implicit none
   
   character(len=132), intent(in):: formula
   character(len=2), dimension(82), intent(in):: ES
   integer, intent(out):: j
   integer, dimension(12), intent(out):: indx,mult

   character(len=132) :: ch132,cp132 
   character(len=2)   :: ch2
   integer i,l,k,m,mu

    j=1
    ch132=ADJUSTL(formula)

100 if(ch132(2:2).eq.'_') then
     ch2=ch132(1:1)
     l=ichar(ch132(3:3))-48; m=ichar(ch132(4:4))-48
     k=4; mu=l
     if(m.le.9.and.m.ge.0)then
      k=5; mu=mu*10+m
     end if
    else
     ch2=ch132(1:2)
     l=ichar(ch132(4:4))-48; m=ichar(ch132(5:5))-48
     k=5; mu=l
     if(m.le.9.and.m.ge.0)then
      k=6; mu=mu*10+m
     end if
    end if
    cp132=ch132(k:)
    ch132=cp132
!print*,TRIM(ch132)
        i=1
        do while(ES(i).ne.ch2)
         i=i+1
        end do
      indx(j)=i; mult(j)=mu
      j=j+1
    if(ch132.ne.' ') goto 100
    j=j-1
!print'(2i5)',(indx(k),mult(k),k=1,j)
    return 
    end

  
